-- phpMyAdmin SQL Dump
-- version 3.5.2.2
-- http://www.phpmyadmin.net
--
-- Host: 127.0.0.1
-- Czas wygenerowania: 25 Lis 2013, 20:16
-- Wersja serwera: 5.5.27
-- Wersja PHP: 5.4.7

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Baza danych: `war`
--

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `accounts`
--

CREATE TABLE IF NOT EXISTS `accounts` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) NOT NULL DEFAULT '',
  `password` varchar(255) NOT NULL,
  `premdays` int(11) NOT NULL DEFAULT '0',
  `lastday` int(10) unsigned NOT NULL DEFAULT '0',
  `email` varchar(255) NOT NULL DEFAULT '',
  `key` varchar(20) NOT NULL DEFAULT '0',
  `blocked` tinyint(1) NOT NULL DEFAULT '0' COMMENT 'internal usage',
  `warnings` int(11) NOT NULL DEFAULT '0',
  `group_id` int(11) NOT NULL DEFAULT '1',
  `recovery_code` varchar(40) NOT NULL DEFAULT '',
  `create_ip` int(11) NOT NULL DEFAULT '0',
  `create_date` int(11) NOT NULL DEFAULT '0',
  `premium_points` int(11) NOT NULL DEFAULT '0',
  `access_flags` int(11) NOT NULL DEFAULT '0',
  `country` varchar(40) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `country` (`country`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=14 ;

--
-- Zrzut danych tabeli `accounts`
--

INSERT INTO `accounts` (`id`, `name`, `password`, `premdays`, `lastday`, `email`, `key`, `blocked`, `warnings`, `group_id`, `recovery_code`, `create_ip`, `create_date`, `premium_points`, `access_flags`, `country`) VALUES
(1, 'ppp', 'b3054ff0797ff0b2bbce03ec897fe63e0b6490e0', 65535, 1373988554, '', '', 0, 0, 1, '', 0, 0, 970, 1, 'pl'),
(3, 'notloggableacc', 'ee895f84cb0c0b58fb2eb0ea4a3f2806357ec55b', 23, 0, '', '', 0, 0, 1, '', 0, 0, 0, 0, '');

--
-- Wyzwalacze `accounts`
--
DROP TRIGGER IF EXISTS `ondelete_accounts`;
DELIMITER //
CREATE TRIGGER `ondelete_accounts` BEFORE DELETE ON `accounts`
 FOR EACH ROW BEGIN
	DELETE FROM `bans` WHERE `type` IN (3, 4) AND `value` = OLD.`id`;
END
//
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `account_viplist`
--

CREATE TABLE IF NOT EXISTS `account_viplist` (
  `account_id` int(11) NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `player_id` int(11) NOT NULL,
  UNIQUE KEY `account_id_2` (`account_id`,`player_id`),
  KEY `account_id` (`account_id`),
  KEY `player_id` (`player_id`),
  KEY `world_id` (`world_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `bans`
--

CREATE TABLE IF NOT EXISTS `bans` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) NOT NULL COMMENT '1 - ip banishment, 2 - namelock, 3 - account banishment, 4 - notation, 5 - deletion',
  `value` int(10) unsigned NOT NULL COMMENT 'ip address (integer), player guid or account number',
  `param` int(10) unsigned NOT NULL DEFAULT '4294967295' COMMENT 'used only for ip banishment mask (integer)',
  `active` tinyint(1) NOT NULL DEFAULT '1',
  `expires` int(11) NOT NULL,
  `added` int(10) unsigned NOT NULL,
  `admin_id` int(10) unsigned NOT NULL DEFAULT '0',
  `comment` text NOT NULL,
  `reason` int(10) unsigned NOT NULL DEFAULT '0',
  `action` int(10) unsigned NOT NULL DEFAULT '0',
  `statement` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `type` (`type`,`value`),
  KEY `active` (`active`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `environment_killers`
--

CREATE TABLE IF NOT EXISTS `environment_killers` (
  `kill_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  KEY `kill_id` (`kill_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `global_storage`
--

CREATE TABLE IF NOT EXISTS `global_storage` (
  `key` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `value` varchar(255) NOT NULL DEFAULT '0',
  UNIQUE KEY `key` (`key`,`world_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `guilds`
--

CREATE TABLE IF NOT EXISTS `guilds` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `ownerid` int(11) NOT NULL,
  `creationdata` int(11) NOT NULL,
  `motd` varchar(255) NOT NULL,
  `balance` bigint(20) unsigned NOT NULL,
  `create_ip` int(11) NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`,`world_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=3 ;

--
-- Wyzwalacze `guilds`
--
DROP TRIGGER IF EXISTS `oncreate_guilds`;
DELIMITER //
CREATE TRIGGER `oncreate_guilds` AFTER INSERT ON `guilds`
 FOR EACH ROW BEGIN
	INSERT INTO `guild_ranks` (`name`, `level`, `guild_id`) VALUES ('Leader', 3, NEW.`id`);
	INSERT INTO `guild_ranks` (`name`, `level`, `guild_id`) VALUES ('Vice-Leader', 2, NEW.`id`);
	INSERT INTO `guild_ranks` (`name`, `level`, `guild_id`) VALUES ('Member', 1, NEW.`id`);
END
//
DELIMITER ;
DROP TRIGGER IF EXISTS `ondelete_guilds`;
DELIMITER //
CREATE TRIGGER `ondelete_guilds` BEFORE DELETE ON `guilds`
 FOR EACH ROW BEGIN
	UPDATE `players` SET `guildnick` = '', `rank_id` = 0 WHERE `rank_id` IN (SELECT `id` FROM `guild_ranks` WHERE `guild_id` = OLD.`id`);
END
//
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `guild_invites`
--

CREATE TABLE IF NOT EXISTS `guild_invites` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `guild_id` int(11) NOT NULL DEFAULT '0',
  UNIQUE KEY `player_id` (`player_id`,`guild_id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `guild_kills`
--

CREATE TABLE IF NOT EXISTS `guild_kills` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `guild_id` int(11) NOT NULL,
  `war_id` int(11) NOT NULL,
  `death_id` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `guild_kills_ibfk_1` (`war_id`),
  KEY `guild_kills_ibfk_2` (`death_id`),
  KEY `guild_kills_ibfk_3` (`guild_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `guild_ranks`
--

CREATE TABLE IF NOT EXISTS `guild_ranks` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `guild_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  `level` int(11) NOT NULL COMMENT '1 - leader, 2 - vice leader, 3 - member',
  PRIMARY KEY (`id`),
  KEY `guild_id` (`guild_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=7 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `guild_wars`
--

CREATE TABLE IF NOT EXISTS `guild_wars` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `guild_id` int(11) NOT NULL,
  `enemy_id` int(11) NOT NULL,
  `begin` bigint(20) NOT NULL DEFAULT '0',
  `end` bigint(20) NOT NULL DEFAULT '0',
  `frags` int(10) unsigned NOT NULL DEFAULT '0',
  `payment` bigint(20) unsigned NOT NULL DEFAULT '0',
  `guild_kills` int(10) unsigned NOT NULL DEFAULT '0',
  `enemy_kills` int(10) unsigned NOT NULL DEFAULT '0',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `status` (`status`),
  KEY `guild_id` (`guild_id`),
  KEY `enemy_id` (`enemy_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `houses`
--

CREATE TABLE IF NOT EXISTS `houses` (
  `id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `owner` int(11) NOT NULL,
  `paid` int(10) unsigned NOT NULL DEFAULT '0',
  `warnings` int(11) NOT NULL DEFAULT '0',
  `lastwarning` int(10) unsigned NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `town` int(10) unsigned NOT NULL DEFAULT '0',
  `size` int(10) unsigned NOT NULL DEFAULT '0',
  `price` int(10) unsigned NOT NULL DEFAULT '0',
  `rent` int(10) unsigned NOT NULL DEFAULT '0',
  `doors` int(10) unsigned NOT NULL DEFAULT '0',
  `beds` int(10) unsigned NOT NULL DEFAULT '0',
  `tiles` int(10) unsigned NOT NULL DEFAULT '0',
  `guild` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `clear` tinyint(1) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `id` (`id`,`world_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `houses`
--

INSERT INTO `houses` (`id`, `world_id`, `owner`, `paid`, `warnings`, `lastwarning`, `name`, `town`, `size`, `price`, `rent`, `doors`, `beds`, `tiles`, `guild`, `clear`) VALUES
(1, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 17, 0, 0),
(2, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 19, 0, 0),
(3, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(4, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(5, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 16, 0, 0),
(6, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 1, 32, 0, 0),
(7, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 13, 0, 0),
(8, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(9, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 4, 42, 0, 0),
(10, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(11, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 26, 0, 0),
(12, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 26, 0, 0),
(13, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 20, 0, 0),
(14, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 34, 0, 0),
(15, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 21, 0, 0),
(16, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 21, 0, 0),
(17, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 37, 0, 0),
(18, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(19, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 19, 0, 0),
(20, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 23, 0, 0),
(23, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(24, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(25, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 39, 0, 0),
(26, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 39, 0, 0),
(27, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 31, 0, 0),
(28, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 36, 0, 0),
(29, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 45, 0, 0),
(30, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 6, 4, 191, 0, 0),
(31, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(32, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(33, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(34, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(35, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(36, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(37, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(38, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(39, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 25, 0, 0),
(40, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 235995192, 0, 0, 0, 2, 15, 0, 0),
(41, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 13, 0, 0),
(42, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 17, 0, 0),
(43, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 14, 0, 0),
(44, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 33, 0, 0),
(45, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 33, 0, 0),
(46, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 29, 0, 0),
(47, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 29, 0, 0),
(48, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 29, 0, 0),
(49, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 34, 0, 0),
(50, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 34, 0, 0),
(51, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 34, 0, 0),
(52, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 33, 0, 0),
(53, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 34, 0, 0),
(54, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 34, 0, 0),
(55, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 34, 0, 0),
(56, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 34, 0, 0),
(57, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 34, 0, 0),
(58, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 6, 8, 203, 0, 0),
(59, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 8, 224, 0, 0),
(60, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 13, 0, 0),
(61, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 17, 0, 0),
(62, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 13, 0, 0),
(63, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 17, 0, 0),
(64, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 3, 13, 0, 0),
(65, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 17, 0, 0),
(66, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 4, 16, 0, 0),
(67, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 21, 0, 0),
(68, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 23, 0, 0),
(69, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 45, 0, 0),
(70, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 18, 0, 0),
(71, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 20, 0, 0),
(72, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 4, 28, 0, 0),
(73, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 26, 0, 0),
(74, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 4, 30, 0, 0),
(75, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 235995192, 0, 0, 1, 2, 26, 0, 0),
(76, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 36, 0, 0),
(77, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 33, 0, 0),
(78, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 33, 0, 0),
(79, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 26, 0, 0),
(80, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 35, 0, 0),
(81, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 23, 0, 0),
(82, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 4, 50, 0, 0),
(83, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 16, 0, 0),
(84, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(85, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 51236296, 0, 0, 1, 4, 25, 0, 0),
(86, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 26, 0, 0),
(87, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 31, 0, 0),
(88, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 4, 37, 0, 0),
(89, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 29, 0, 0),
(90, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 21, 0, 0),
(91, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 4, 30, 0, 0),
(92, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 2, 2, 30, 0, 0),
(93, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 3, 2, 37, 0, 0),
(94, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 26, 0, 0),
(95, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 870, 0, 0, 1, 2, 21, 0, 0),
(96, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 209227351, 0, 0, 1, 2, 21, 0, 0),
(97, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 186195696, 0, 0, 2, 2, 17, 0, 0),
(98, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 214447648, 0, 0, 2, 2, 17, 0, 0),
(99, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 3, 2, 32, 0, 0),
(100, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 1, 2, 13, 0, 0),
(101, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 4, 29, 0, 0),
(102, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 35, 0, 0),
(103, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 25, 0, 0),
(104, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 4, 37, 0, 0),
(105, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 16, 209, 0, 0),
(106, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 21, 0, 0),
(107, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 42, 0, 0),
(108, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 24, 0, 0),
(109, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 26, 0, 0),
(110, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 28, 0, 0),
(111, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 4, 26, 0, 0),
(112, 0, 0, 0, 0, 0, 'Forgotten headquarter (Flat 1, Area 42)', 0, 0, 0, 0, 0, 2, 24, 0, 0);

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `house_auctions`
--

CREATE TABLE IF NOT EXISTS `house_auctions` (
  `house_id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `player_id` int(11) NOT NULL,
  `bid` int(10) unsigned NOT NULL DEFAULT '0',
  `limit` int(10) unsigned NOT NULL DEFAULT '0',
  `endtime` bigint(20) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `house_id` (`house_id`,`world_id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `house_data`
--

CREATE TABLE IF NOT EXISTS `house_data` (
  `house_id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `data` longblob NOT NULL,
  UNIQUE KEY `house_id` (`house_id`,`world_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `house_lists`
--

CREATE TABLE IF NOT EXISTS `house_lists` (
  `house_id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `listid` int(11) NOT NULL,
  `list` text NOT NULL,
  UNIQUE KEY `house_id` (`house_id`,`world_id`,`listid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `killers`
--

CREATE TABLE IF NOT EXISTS `killers` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `death_id` int(11) NOT NULL,
  `final_hit` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `unjustified` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `war` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `death_id` (`death_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `players`
--

CREATE TABLE IF NOT EXISTS `players` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `group_id` int(11) NOT NULL DEFAULT '1',
  `account_id` int(11) NOT NULL DEFAULT '0',
  `level` int(11) NOT NULL DEFAULT '1',
  `vocation` int(11) NOT NULL DEFAULT '0',
  `health` int(11) NOT NULL DEFAULT '150',
  `healthmax` int(11) NOT NULL DEFAULT '150',
  `experience` bigint(20) NOT NULL DEFAULT '0',
  `lookbody` int(11) NOT NULL DEFAULT '0',
  `lookfeet` int(11) NOT NULL DEFAULT '0',
  `lookhead` int(11) NOT NULL DEFAULT '0',
  `looklegs` int(11) NOT NULL DEFAULT '0',
  `looktype` int(11) NOT NULL DEFAULT '136',
  `lookaddons` int(11) NOT NULL DEFAULT '0',
  `maglevel` int(11) NOT NULL DEFAULT '0',
  `mana` int(11) NOT NULL DEFAULT '0',
  `manamax` int(11) NOT NULL DEFAULT '0',
  `manaspent` int(11) NOT NULL DEFAULT '0',
  `soul` int(10) unsigned NOT NULL DEFAULT '0',
  `town_id` int(11) NOT NULL DEFAULT '0',
  `posx` int(11) NOT NULL DEFAULT '0',
  `posy` int(11) NOT NULL DEFAULT '0',
  `posz` int(11) NOT NULL DEFAULT '0',
  `conditions` blob NOT NULL,
  `cap` int(11) NOT NULL DEFAULT '0',
  `sex` int(11) NOT NULL DEFAULT '0',
  `lastlogin` bigint(20) unsigned NOT NULL DEFAULT '0',
  `lastip` int(10) unsigned NOT NULL DEFAULT '0',
  `save` tinyint(1) NOT NULL DEFAULT '1',
  `skull` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `skulltime` int(11) NOT NULL DEFAULT '0',
  `rank_id` int(11) NOT NULL DEFAULT '0',
  `guildnick` varchar(255) NOT NULL DEFAULT '',
  `lastlogout` bigint(20) unsigned NOT NULL DEFAULT '0',
  `blessings` tinyint(2) NOT NULL DEFAULT '0',
  `balance` bigint(20) NOT NULL DEFAULT '0',
  `stamina` bigint(20) NOT NULL DEFAULT '151200000' COMMENT 'stored in miliseconds',
  `direction` int(11) NOT NULL DEFAULT '2',
  `online` tinyint(1) NOT NULL DEFAULT '0',
  `marriage` int(10) unsigned NOT NULL DEFAULT '0',
  `promotion` int(11) NOT NULL DEFAULT '0',
  `deleted` tinyint(1) NOT NULL DEFAULT '0',
  `description` varchar(255) NOT NULL DEFAULT '',
  `kills` int(11) NOT NULL DEFAULT '0',
  `deaths` int(11) NOT NULL DEFAULT '0',
  `assists` int(11) NOT NULL DEFAULT '0',
  `create_ip` int(11) NOT NULL DEFAULT '0',
  `create_date` int(11) NOT NULL DEFAULT '0',
  `hide_char` int(11) NOT NULL DEFAULT '0',
  `comment` text NOT NULL,
  `country` varchar(40) NOT NULL DEFAULT '',
  `tmp_kills` int(11) NOT NULL DEFAULT '0',
  `tmp_assists` int(11) NOT NULL DEFAULT '0',
  `tmp_deaths` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `name` (`name`,`deleted`),
  KEY `account_id` (`account_id`),
  KEY `group_id` (`group_id`),
  KEY `online` (`online`),
  KEY `deleted` (`deleted`),
  KEY `kills` (`kills`,`deaths`,`assists`),
  KEY `country` (`country`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=215 ;

--
-- Zrzut danych tabeli `players`
--

INSERT INTO `players` (`id`, `name`, `world_id`, `group_id`, `account_id`, `level`, `vocation`, `health`, `healthmax`, `experience`, `lookbody`, `lookfeet`, `lookhead`, `looklegs`, `looktype`, `lookaddons`, `maglevel`, `mana`, `manamax`, `manaspent`, `soul`, `town_id`, `posx`, `posy`, `posz`, `conditions`, `cap`, `sex`, `lastlogin`, `lastip`, `save`, `skull`, `skulltime`, `rank_id`, `guildnick`, `lastlogout`, `blessings`, `balance`, `stamina`, `direction`, `online`, `marriage`, `promotion`, `deleted`, `description`, `kills`, `deaths`, `assists`, `create_ip`, `create_date`, `hide_char`, `comment`, `country`, `tmp_kills`, `tmp_assists`, `tmp_deaths`) VALUES
(1, 'Account Manager', 0, 1, 1, 1, 0, 150, 150, 0, 1, 16, 46, 66, 136, 0, 0, 0, 0, 0, 0, 0, 50, 50, 7, '', 400, 0, 1344865351, 16777343, 0, 0, 0, 0, '', 0, 0, 0, 201660000, 0, 0, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, '', 'se', 0, 0, 0),
(2, 'GOD', 0, 6, 1, 1000, 0, 15065, 15065, 16566949800, 2, 17, 47, 67, 302, 3, 0, 50000, 4995, 0, 0, 1, 71, 125, 7, 0x010020000002ffffffff03d86393031a000000001b000000000470170000050100000006701700000701000000fe, 50400, 0, 1373993567, 923018418, 1, 0, 0, 0, '', 1373989131, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 0, 0, 0, 0, 0, 0, 'To ja jestem Bogiem! :)', 'pl', 0, 0, 0),
(3, 'Sorcerer Sample', 0, 1, 1, 121, 1, 750, 750, 28497119, 3, 18, 48, 68, 139, 0, 80, 3425, 3425, 37200, 0, 1, 45, 59, 6, 0x010004000002ffffffff0390e200001a000000001b00000000fe010020000002ffffffff0300e8ff3a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 1373972818, 923018418, 1, 0, 0, 0, '', 1373972820, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1503, 18, 2000, 0, 0, 0, '', 'de', 0, 0, 0),
(8, 'Druid Sample', 0, 1, 1, 116, 2, 725, 725, 25022158, 8, 23, 53, 73, 137, 0, 80, 3275, 3275, 4200, 0, 1, 17, 111, 7, 0x010020000002ffffffff0308c9d86e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0370df00001a000000001b00000000fe, 3000, 0, 1373972710, 923018418, 1, 0, 0, 0, '', 1373972713, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 6, 9, 1, 0, 0, 0, '', 'mx', 0, 0, 0),
(9, 'Paladin Sample', 0, 1, 1, 93, 3, 1035, 1035, 12567200, 9, 24, 60, 74, 136, 1, 16, 1310, 1310, 870, 0, 1, 17, 111, 7, '', 3000, 0, 1373972892, 923018418, 1, 0, 0, 0, '', 1373972916, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 9, 3, 0, 0, 0, '', 'fi', 0, 0, 0),
(10, 'Knight Sample', 0, 1, 1, 82, 4, 1295, 1295, 8641532, 10, 25, 55, 75, 138, 0, 7, 405, 405, 3240, 0, 1, 128, 25, 7, 0x010020000002ffffffff038836c9771a000000001b0000000004e8030000051900000006e8030000070a000000fe010004000002ffffffff0388a900001a000000001b00000000fe, 3000, 0, 1373972714, 923018418, 1, 0, 0, 0, '', 1373972731, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 27, 2, 0, 0, 0, '', '', 0, 0, 0),
(11, 'Kshadowe', 0, 1, 3, 91, 1, 545, 545, 11838305, 11, 26, 56, 76, 131, 0, 80, 1739, 2195, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a8142e5b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805870, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 170, 1093, 1720, 2147483647, 1373357179, 1, '', 'se', 0, 1, 0),
(12, 'Geeme', 0, 1, 3, 89, 1, 520, 520, 10990673, 12, 27, 57, 77, 140, 0, 80, 2045, 2045, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0358632e201a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805870, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 197, 1069, 1752, 2147483647, 1373334319, 1, '', 'pl', 0, 0, 0),
(13, 'Master Kellir', 0, 1, 3, 81, 1, 630, 630, 8240293, 13, 28, 58, 78, 141, 0, 80, 2705, 2705, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0348ce92791a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805870, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 239, 1009, 1800, 2147483647, 1373347975, 1, '', 'es', 0, 0, 0),
(14, 'Home Simpson', 0, 1, 3, 93, 1, 660, 660, 12748090, 14, 29, 59, 79, 142, 0, 80, 2885, 2885, 0, 0, 1, 43, 97, 7, 0x010020000002ffffffff03b0d3830c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805870, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 218, 538, 1640, 2147483647, 1373360007, 1, '', 'no', 0, 0, 0),
(15, 'Tomurka', 0, 1, 3, 117, 1, 625, 625, 25583210, 15, 30, 60, 80, 144, 0, 80, 2437, 2675, 0, 0, 1, 92, 99, 7, 0x010020000002ffffffff03e044aa4e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805870, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 250, 476, 1525, 2147483647, 1373362667, 1, '', 'pl', 1, 2, 1),
(16, 'Rei Leao', 0, 1, 3, 85, 1, 520, 520, 9796267, 16, 31, 61, 81, 137, 0, 80, 1422, 2045, 0, 0, 1, 27, 115, 7, 0x010020000002ffffffff0318be9a571a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 255, 398, 1681, 2147483647, 1373347179, 1, '', 'se', 0, 0, 0),
(17, 'Paola Druidinha', 0, 1, 3, 116, 1, 620, 620, 24718830, 17, 32, 62, 82, 129, 0, 80, 2373, 2645, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d8f473501a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 297, 482, 1793, 2147483647, 1373318874, 1, '', 'pl', 2, 6, 0),
(18, 'Zeck Lester', 0, 1, 3, 112, 1, 530, 530, 22454305, 18, 33, 63, 83, 138, 0, 80, 2105, 2105, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03407e5c7b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 331, 394, 2038, 2147483647, 1373340843, 1, '', 'pl', 0, 5, 0),
(19, 'Cadeirante Vitor', 0, 1, 3, 122, 1, 765, 765, 29183640, 19, 34, 64, 84, 139, 0, 80, 3306, 3515, 0, 0, 1, 93, 36, 7, 0x010020000002ffffffff03288f83471a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 391, 257, 2044, 2147483647, 1373352946, 1, '', 'pl', 0, 4, 0),
(20, 'Bitche', 0, 1, 3, 143, 1, 840, 840, 47443573, 20, 35, 65, 85, 140, 0, 80, 3593, 3965, 0, 0, 1, 154, 36, 7, 0x010020000002ffffffff03884e456b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 426, 182, 1887, 2147483647, 1373332327, 1, '', 'pl', 0, 7, 0),
(21, 'Leaao Niice', 0, 1, 3, 150, 1, 850, 850, 54042300, 21, 36, 66, 86, 141, 0, 80, 3274, 4025, 0, 0, 1, 50, 104, 7, 0x010020000002ffffffff039093aa131a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 408, 145, 2065, 2147483647, 1373331066, 1, '', 'se', 0, 7, 0),
(22, 'Pally Pistao', 0, 1, 3, 134, 1, 815, 815, 38667190, 22, 37, 67, 87, 134, 0, 80, 3042, 3815, 0, 0, 1, 66, 90, 7, 0x010020000002ffffffff0330d31e291a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805871, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 391, 205, 1852, 2147483647, 1373351026, 1, '', 'pl', 3, 5, 0),
(23, 'Fryzon', 0, 1, 3, 132, 1, 770, 770, 37397567, 23, 38, 68, 88, 149, 0, 80, 3545, 3545, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e8c492791a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0318c400001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 478, 220, 2200, 2147483647, 1373359909, 1, '', 'pl', 2, 1, 0),
(24, 'Target Down', 0, 1, 3, 150, 1, 875, 875, 54042300, 24, 39, 69, 89, 128, 0, 80, 3529, 4175, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff038023f0431a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 474, 252, 2414, 2147483647, 1373344759, 1, '', 'es', 0, 1, 0),
(25, 'Vinagrete', 0, 1, 3, 150, 1, 875, 875, 54042300, 25, 40, 70, 90, 136, 0, 80, 4175, 4175, 0, 0, 1, 95, 96, 7, 0x010020000002ffffffff03708383471a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 454, 141, 2092, 2147483647, 1373351268, 1, '', 'de', 1, 4, 0),
(26, 'Rapaz', 0, 1, 3, 150, 1, 850, 850, 54042300, 26, 41, 71, 91, 130, 0, 80, 4025, 4025, 0, 0, 1, 90, 119, 7, 0x010020000002ffffffff03b0d3830c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 525, 190, 2570, 2147483647, 1373340239, 1, '', 'se', 2, 4, 0),
(27, 'Ned Stark', 0, 1, 3, 110, 1, 725, 725, 21271191, 27, 42, 72, 92, 131, 0, 80, 2112, 3275, 0, 0, 1, 25, 115, 7, 0x010020000002ffffffff03106e64591a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 463, 217, 2343, 2147483647, 1373353665, 1, '', 'br', 0, 4, 0),
(28, 'Lemysk Suisem', 0, 1, 3, 137, 1, 840, 840, 41770922, 28, 43, 73, 93, 140, 0, 80, 3394, 3965, 0, 0, 1, 46, 94, 7, 0x010020000002ffffffff0308056c721a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 494, 162, 2295, 2147483647, 1373352998, 1, '', 'pl', 0, 0, 0),
(29, 'Taz Mania', 0, 1, 3, 128, 1, 750, 750, 33407560, 29, 44, 74, 94, 133, 0, 80, 3425, 3425, 0, 0, 1, 40, 101, 7, 0x010020000002ffffffff03a8b3ff3a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805872, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 422, 193, 2120, 2147483647, 1373361903, 1, '', 'pl', 0, 3, 0),
(30, 'Mancha Verde', 0, 1, 3, 149, 1, 895, 895, 53439006, 30, 45, 75, 95, 134, 0, 80, 3567, 4295, 0, 0, 1, 153, 32, 7, 0x010020000002ffffffff0338e5b1671a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805873, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 406, 280, 2126, 2147483647, 1373359230, 1, '', 'fi', 0, 4, 0),
(31, 'Volna Dream', 0, 1, 3, 150, 1, 895, 895, 54042300, 31, 46, 76, 96, 144, 0, 80, 3629, 4295, 0, 0, 1, 53, 89, 7, 0x010020000002ffffffff037053d11a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805873, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 426, 215, 2028, 2147483647, 1373344553, 1, '', 'se', 1, 4, 0),
(32, 'Castiel', 0, 1, 3, 141, 1, 895, 895, 45219685, 32, 47, 77, 97, 128, 0, 80, 4295, 4295, 0, 0, 1, 98, 39, 7, 0x010020000002ffffffff0380841e641a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0350dc00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805873, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 474, 255, 2211, 2147483647, 1373333670, 1, '', 've', 0, 1, 0),
(33, 'Sir Druidizinho', 0, 1, 3, 124, 1, 800, 800, 30967284, 33, 48, 78, 98, 129, 0, 80, 3725, 3725, 0, 0, 1, 65, 95, 7, 0x010020000002ffffffff03b823ba0a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0318dd00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805873, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 380, 114, 1882, 2147483647, 1373336374, 1, '', 'pl', 0, 3, 1),
(34, 'Paladin Of Holy', 0, 1, 3, 141, 1, 895, 895, 45130135, 34, 49, 79, 99, 138, 0, 80, 4295, 4295, 0, 0, 1, 66, 94, 7, 0x010020000002ffffffff0330d31e291a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805873, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 420, 124, 2021, 2147483647, 1373360557, 1, '', 'pl', 0, 1, 0),
(35, 'Devil Oo Barbaro', 0, 1, 3, 150, 1, 895, 895, 54042300, 35, 50, 80, 100, 139, 0, 80, 4295, 4295, 0, 0, 1, 50, 108, 7, 0x010020000002ffffffff0348c3c1231a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0318dd00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805873, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 426, 369, 2475, 2147483647, 1373360367, 1, '', 'es', 0, 0, 0),
(36, 'Matheus De Mage', 0, 1, 3, 141, 1, 870, 870, 45150073, 36, 51, 81, 101, 140, 0, 80, 4145, 4145, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff039092e04c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0350dc00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805874, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 414, 234, 2205, 2147483647, 1373340745, 1, '', 'no', 0, 1, 0),
(37, 'Sir Kolling', 0, 1, 3, 143, 1, 865, 865, 47147390, 37, 52, 82, 102, 141, 0, 80, 4115, 4115, 0, 0, 1, 85, 84, 7, 0x010020000002ffffffff0318a5d86e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff03e0dd00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805874, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 403, 327, 2281, 2147483647, 1373334944, 1, '', 'pl', 1, 3, 0),
(38, 'Matsumi', 0, 1, 3, 134, 1, 895, 895, 39097044, 38, 53, 83, 103, 142, 0, 80, 3937, 4295, 0, 0, 1, 86, 119, 7, 0x010020000002ffffffff039092e04c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805874, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 410, 146, 2249, 2147483647, 1373361991, 1, '', 'pl', 0, 2, 2),
(39, 'Glauber Henrique Xavier', 0, 1, 3, 150, 1, 895, 895, 54042300, 39, 54, 84, 104, 144, 0, 80, 4295, 4295, 0, 0, 1, 64, 93, 7, 0x010020000002ffffffff032033b22c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0320b200001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805874, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 439, 200, 2267, 2147483647, 1373334284, 1, '', 'pl', 0, 0, 0),
(40, 'Druidmaster', 0, 1, 3, 144, 1, 895, 895, 48327098, 40, 55, 85, 105, 137, 0, 80, 4039, 4295, 0, 0, 1, 15, 97, 7, 0x010020000002ffffffff032845456b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805874, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 488, 285, 2633, 2147483647, 1373357170, 1, '', 'mx', 1, 1, 0),
(41, 'Lisa Simpson', 0, 1, 3, 150, 1, 890, 890, 54042300, 41, 56, 86, 106, 136, 0, 80, 4265, 4265, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c8c326071a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 422, 268, 2190, 2147483647, 1373350012, 1, '', 'se', 1, 1, 0),
(42, 'Knight Of Badassdom', 0, 1, 3, 119, 1, 770, 770, 26911892, 42, 57, 87, 107, 138, 0, 80, 3545, 3545, 0, 0, 1, 155, 21, 7, 0x010020000002ffffffff0378a307191a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0370df00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 455, 251, 2543, 2147483647, 1373347490, 1, '', 'nl', 0, 0, 0),
(43, 'El''mago Valdivia', 0, 1, 3, 118, 1, 725, 725, 26355811, 43, 58, 88, 108, 139, 0, 80, 3275, 3275, 0, 0, 1, 91, 96, 7, 0x010020000002ffffffff0390c35c401a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 404, 207, 2186, 2147483647, 1373325457, 1, '', 'pl', 0, 0, 0),
(44, 'Senju Hashirama', 0, 1, 3, 130, 1, 830, 830, 35054708, 44, 59, 89, 109, 140, 0, 80, 3905, 3905, 0, 0, 1, 96, 36, 7, 0x010020000002ffffffff03b8b49a571a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0320b200001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 510, 200, 2582, 2147483647, 1373358806, 1, '', 'pl', 0, 1, 0),
(45, 'Tankador', 0, 1, 3, 138, 1, 790, 790, 42260147, 45, 60, 90, 110, 133, 0, 80, 3665, 3665, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0300b535741a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 376, 206, 2079, 2147483647, 1373322026, 1, '', 'pl', 0, 2, 0),
(46, 'Rany Money', 0, 1, 3, 140, 1, 815, 815, 44699480, 46, 61, 91, 111, 134, 0, 80, 3815, 3815, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff039092e04c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0320b200001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 383, 280, 2231, 2147483647, 1373320465, 1, '', 'es', 0, 1, 1),
(47, 'Refrigerante', 0, 1, 3, 137, 1, 835, 835, 41254756, 47, 62, 92, 112, 149, 0, 80, 3935, 3935, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0368039b1c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0318c400001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805875, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 407, 279, 2500, 2147483647, 1373332980, 1, '', 'de', 0, 0, 0),
(48, 'Lek Metziro', 0, 1, 3, 101, 1, 735, 735, 16221394, 48, 63, 93, 113, 128, 0, 80, 3242, 3335, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b00336391a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 438, 261, 2426, 2147483647, 1373328450, 1, '', 'pl', 0, 0, 0),
(49, 'Mokinho''ek', 0, 1, 3, 100, 1, 660, 660, 15819482, 49, 64, 94, 0, 136, 0, 80, 2885, 2885, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e0745c7b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 430, 293, 2366, 2147483647, 1373327091, 1, '', 'br', 0, 0, 0),
(50, 'Tripowx', 0, 1, 3, 78, 1, 555, 555, 7420025, 50, 65, 95, 1, 138, 0, 80, 1484, 2255, 0, 0, 1, 62, 43, 7, 0x010020000002ffffffff0368c5f75c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 393, 310, 2264, 2147483647, 1373357115, 1, '', 'pl', 0, 0, 0),
(51, 'Archer', 0, 1, 3, 79, 1, 565, 565, 7746825, 51, 66, 96, 2, 139, 0, 80, 2128, 2315, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360e4e0111a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 371, 312, 1967, 2147483647, 1373335378, 1, '', 'fi', 0, 0, 0),
(52, 'Old Impossible', 0, 1, 3, 78, 1, 580, 580, 7561250, 52, 67, 97, 3, 132, 0, 80, 2382, 2405, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a063c93c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 433, 301, 2195, 2147483647, 1373332376, 1, '', 'pl', 0, 0, 0),
(53, 'Olico', 0, 1, 3, 80, 1, 560, 560, 8066939, 53, 68, 98, 4, 141, 0, 80, 1866, 2285, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d89345301a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 395, 298, 2246, 2147483647, 1373343116, 1, '', 'pl', 0, 0, 0),
(54, 'Sooul', 0, 1, 3, 86, 1, 575, 575, 10171640, 54, 69, 99, 5, 134, 0, 80, 233, 2375, 0, 0, 1, 154, 18, 7, 0x010020000002ffffffff0348f43d171a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 197, 194, 1119, 2147483647, 1373363614, 1, '', 'pl', 0, 0, 0),
(55, 'Optimus Primo', 0, 1, 3, 80, 1, 730, 730, 8107154, 55, 70, 100, 6, 144, 0, 80, 2722, 3305, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0370b335741a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805876, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 335, 268, 1943, 2147483647, 1373354600, 1, '', 'pl', 0, 0, 0),
(56, 'Menina Sapeca', 0, 1, 3, 77, 1, 545, 545, 7158981, 56, 71, 101, 7, 137, 0, 80, 969, 2195, 0, 0, 1, 85, 80, 7, 0x010020000002ffffffff0328c0c1231a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 255, 165, 1517, 2147483647, 1373361390, 1, '', 'se', 0, 0, 0),
(57, 'Johnnie Walker', 0, 1, 3, 78, 1, 565, 565, 7409820, 57, 72, 102, 8, 129, 0, 80, 2234, 2315, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a062ff751a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 1, 0, 0, 0, '', 362, 300, 2067, 2147483647, 1373326722, 1, '', 'es', 0, 0, 0),
(58, 'Thiagorib', 0, 1, 3, 91, 1, 615, 615, 12012044, 58, 73, 103, 9, 138, 0, 80, 2178, 2615, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b8fd0e6d1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 340, 281, 1967, 2147483647, 1373361772, 1, '', 'no', 0, 0, 0),
(59, 'Tetinha', 0, 1, 3, 79, 1, 550, 550, 7747540, 59, 74, 104, 10, 131, 0, 80, 1189, 2225, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff033010f8211a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 262, 237, 1718, 2147483647, 1373362849, 1, '', 've', 0, 0, 0),
(60, 'Mandando Bolt', 0, 1, 3, 75, 1, 555, 555, 6489800, 60, 75, 105, 11, 140, 0, 80, 2221, 2255, 0, 0, 1, 12, 139, 5, 0x010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 227, 161, 1276, 2147483647, 1373337976, 1, '', 'pl', 0, 0, 0),
(61, 'Largatixa Treze', 0, 1, 3, 76, 1, 530, 530, 6797055, 61, 76, 106, 12, 141, 0, 80, 869, 2105, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d042456b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 273, 363, 1926, 2147483647, 1373347140, 1, '', 'se', 0, 0, 0),
(62, 'Rush Na Taka', 0, 1, 3, 82, 1, 535, 535, 8544188, 62, 77, 107, 13, 134, 0, 80, 1272, 2135, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03708fe04c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805877, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 237, 351, 1643, 2147483647, 1373349890, 1, '', 'pl', 0, 0, 0),
(63, 'Meninosafadi', 0, 1, 3, 78, 1, 496, 530, 7502586, 63, 78, 108, 14, 144, 0, 80, 468, 2105, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a8f0d8331a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0308e800001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 255, 331, 1572, 2147483647, 1373355967, 1, '', 'pl', 0, 0, 0),
(64, 'Druid Hell', 0, 1, 3, 79, 1, 530, 530, 7701032, 64, 79, 109, 15, 137, 0, 80, 2105, 2105, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03206fc15e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0390e200001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 313, 247, 1867, 2147483647, 1373347908, 1, '', 'be', 0, 0, 0),
(65, 'Canabis', 0, 1, 3, 76, 1, 520, 520, 6781383, 65, 80, 110, 16, 136, 0, 80, 1530, 2045, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03182055271a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 245, 262, 1497, 2147483647, 1373320826, 1, '', 'pl', 0, 0, 0),
(66, 'Parmax', 0, 1, 3, 105, 1, 695, 695, 18433690, 66, 81, 111, 17, 138, 0, 80, 2358, 3095, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff031024267d1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 277, 175, 1540, 2147483647, 1373323995, 1, '', 'se', 0, 0, 0),
(67, 'Bodao', 0, 1, 3, 102, 1, 680, 680, 16814978, 67, 82, 112, 18, 139, 0, 80, 1579, 3005, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d01ef0431a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 289, 281, 1826, 2147483647, 1373356361, 1, '', 'pl', 0, 0, 0),
(68, 'Surfando Na Paralize', 0, 1, 3, 105, 1, 690, 690, 18397491, 68, 83, 113, 19, 140, 0, 80, 2428, 3065, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0310d01e291a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 227, 265, 1407, 2147483647, 1373324958, 1, '', 'es', 0, 0, 0),
(69, 'Que Merda', 0, 1, 3, 112, 1, 730, 730, 22204436, 69, 84, 0, 20, 141, 0, 80, 2633, 3305, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0398ef3d171a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805878, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 226, 201, 1437, 2147483647, 1373349169, 1, '', 'de', 0, 0, 0),
(70, 'Blocker Woe', 0, 1, 3, 123, 1, 735, 735, 29985639, 70, 85, 1, 21, 142, 0, 80, 3333, 3335, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0308b1641e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 300, 264, 1639, 2147483647, 1373330354, 1, '', 'pl', 0, 0, 0),
(71, 'Supino', 0, 1, 3, 81, 1, 560, 560, 8341013, 71, 86, 2, 22, 149, 0, 80, 1157, 2285, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff036013c9771a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 181, 212, 1212, 2147483647, 1373362833, 1, '', 'br', 0, 0, 0),
(72, 'Mage Pokado', 0, 1, 3, 75, 1, 545, 545, 6580589, 72, 87, 3, 23, 137, 0, 80, 2195, 2195, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360bfc1231a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 188, 249, 1211, 2147483647, 1373361856, 1, '', 'fi', 0, 0, 0),
(73, 'Vingador', 0, 1, 3, 89, 1, 590, 590, 11048767, 73, 88, 4, 24, 129, 0, 80, 1244, 2465, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0340d3ef7e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 235, 89, 1284, 2147483647, 1373354098, 1, '', 'pl', 0, 0, 0),
(74, 'Avenger', 0, 1, 3, 93, 1, 625, 625, 12582041, 74, 89, 5, 25, 130, 0, 80, 2188, 2675, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b0dfe0111a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 215, 171, 1332, 2147483647, 1373340164, 1, '', 'pl', 0, 0, 0),
(75, 'Cabrunco Loko', 0, 1, 3, 90, 1, 605, 605, 11615945, 75, 90, 6, 26, 131, 0, 80, 2555, 2555, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c0b0c9011a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 219, 221, 1483, 2147483647, 1373352724, 1, '', 'pl', 0, 0, 0),
(76, 'Rapariga The Walking', 0, 1, 3, 76, 1, 520, 520, 7033693, 76, 91, 7, 27, 140, 0, 80, 1889, 2045, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0358a007191a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 166, 286, 1060, 2147483647, 1373355296, 1, '', 'se', 0, 0, 0),
(77, 'Lucia Do Pagode', 0, 1, 3, 79, 1, 560, 560, 7690081, 77, 92, 8, 28, 133, 0, 80, 2285, 2285, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b033e8651a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805879, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 166, 172, 1178, 2147483647, 1373335009, 1, '', 'pl', 0, 0, 0),
(78, 'Proza Ruim', 0, 1, 3, 78, 1, 565, 565, 7606703, 78, 93, 9, 29, 142, 0, 80, 2315, 2315, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a03f74151a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 217, 316, 1391, 2147483647, 1373333456, 1, '', 'pl', 0, 0, 0),
(79, 'Loucade Acido', 0, 1, 3, 79, 1, 540, 540, 7724936, 79, 94, 10, 30, 144, 0, 80, 1883, 2165, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0320d0ef7e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 219, 217, 1059, 2147483647, 1373336998, 1, '', 'nl', 0, 0, 0),
(80, 'Carnage Of War', 0, 1, 3, 77, 1, 550, 550, 7104600, 80, 95, 11, 31, 137, 0, 80, 2225, 2225, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a03f74151a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 208, 279, 1338, 2147483647, 1373327508, 1, '', 'no', 0, 0, 0),
(81, 'Aline Andrade', 0, 1, 3, 93, 1, 625, 625, 12894236, 81, 96, 12, 32, 136, 0, 80, 2675, 2675, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d073c15e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff03a0d700001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 192, 314, 1232, 2147483647, 1373339858, 1, '', 'se', 0, 0, 0),
(82, 'Dodiin', 0, 1, 3, 88, 1, 585, 585, 10917293, 82, 97, 13, 33, 138, 0, 80, 2435, 2435, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff036863ff751a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff03409c00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 158, 246, 992, 2147483647, 1373357408, 1, '', 'pl', 0, 0, 0),
(83, 'Brietta', 0, 1, 3, 88, 1, 565, 565, 10715204, 83, 98, 14, 34, 131, 0, 80, 1740, 2315, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b0dfe0111a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 220, 228, 1326, 2147483647, 1373351252, 1, '', 'pl', 0, 0, 0),
(84, 'Ethan', 0, 1, 3, 77, 1, 550, 550, 7153789, 84, 99, 15, 35, 140, 0, 80, 570, 2225, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d07f1e641a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805880, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 114, 206, 972, 2147483647, 1373349164, 1, '', 'pl', 0, 0, 0),
(85, 'Queen Of Pain', 0, 1, 3, 92, 1, 605, 605, 12496976, 85, 100, 16, 36, 133, 0, 80, 1926, 2555, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a09fd86e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805881, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 167, 155, 967, 2147483647, 1373324407, 1, '', 'pl', 0, 0, 0),
(86, 'Pure Hemp', 0, 1, 3, 75, 2, 520, 520, 6607503, 86, 101, 17, 37, 142, 0, 80, 1570, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b88f7b691a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805881, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 98, 204, 991, 2147483647, 1373357659, 1, '', 've', 0, 0, 0),
(87, 'Mulambosz', 0, 1, 3, 75, 2, 535, 535, 6548839, 87, 102, 18, 38, 144, 0, 80, 1412, 2135, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03382fb22c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805881, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 116, 213, 852, 2147483647, 1373324729, 1, '', 'pl', 0, 0, 0),
(88, 'Maluko Rastafari', 0, 1, 3, 80, 2, 560, 560, 8018928, 88, 103, 19, 39, 128, 0, 80, 1559, 2285, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c82fe8651a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805881, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 158, 268, 1063, 2147483647, 1373330261, 1, '', 'pl', 0, 0, 0),
(89, 'Druidax', 0, 1, 3, 76, 2, 520, 520, 6886433, 89, 104, 20, 40, 129, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b8e5164b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805881, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 103, 290, 1026, 2147483647, 1373351654, 1, '', 'pl', 0, 0, 0),
(90, 'El Shaarawy', 0, 1, 3, 80, 2, 530, 530, 8143203, 90, 105, 21, 41, 138, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a03f74151a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805881, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 118, 193, 863, 2147483647, 1373349239, 1, '', 'es', 0, 0, 0),
(91, 'Mybrute', 0, 1, 3, 79, 2, 530, 530, 7650306, 91, 106, 22, 42, 139, 0, 80, 1793, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a88faa131a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805882, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 162, 265, 952, 2147483647, 1373346985, 1, '', 'de', 0, 0, 0),
(92, 'Rei Leao Pala', 0, 1, 3, 79, 2, 530, 530, 7674477, 92, 107, 23, 43, 132, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03107ac15e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0310d600001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805882, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 128, 224, 1020, 2147483647, 1373357707, 1, '', 'pl', 0, 0, 0),
(93, 'Fabiinho''pelego', 0, 1, 3, 75, 2, 525, 525, 6670816, 93, 108, 24, 44, 141, 0, 80, 1709, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03286a64591a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805882, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 81, 188, 707, 2147483647, 1373363186, 1, '', 'fi', 0, 0, 0),
(94, 'Cronus Knight', 0, 1, 3, 75, 2, 525, 525, 6666459, 94, 109, 25, 45, 142, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e8e9b1671a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805882, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 90, 161, 669, 2147483647, 1373326434, 1, '', 'pl', 0, 0, 0),
(95, 'Aasdf', 0, 1, 3, 75, 2, 520, 520, 6495985, 95, 110, 26, 46, 149, 0, 80, 1231, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a8b3ff3a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805882, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 73, 210, 590, 2147483647, 1373325990, 1, '', 'pl', 0, 0, 0),
(96, 'Qqwer', 0, 1, 3, 77, 2, 530, 530, 7059490, 96, 111, 27, 47, 128, 0, 80, 1334, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e0be5c401a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805882, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 90, 180, 748, 2147483647, 1373356426, 1, '', 'se', 0, 0, 0),
(97, 'Devilwaree', 0, 1, 3, 75, 2, 520, 520, 6489818, 97, 112, 28, 48, 129, 0, 80, 1475, 2045, 4200, 0, 1, 12, 139, 5, 0x010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805883, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 138, 200, 912, 2147483647, 1373348816, 1, '', 'pl', 0, 0, 0),
(98, 'Druid''walking', 0, 1, 3, 84, 2, 560, 560, 9268366, 98, 113, 29, 49, 138, 0, 80, 1712, 2285, 4200, 0, 1, 12, 139, 5, 0x010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805883, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 155, 196, 858, 2147483647, 1373360482, 1, '', 'pl', 0, 0, 0),
(99, 'Paquita Do Capiroto', 0, 1, 3, 75, 2, 520, 520, 6626495, 99, 0, 30, 50, 131, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0380ff9a1c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805884, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 157, 185, 837, 2147483647, 1373349660, 1, '', 'pl', 0, 0, 0),
(100, 'Diiana', 0, 1, 3, 75, 2, 495, 520, 6540867, 100, 1, 31, 51, 132, 0, 80, 0, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b0dfe0111a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805886, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 131, 190, 791, 2147483647, 1373353950, 1, '', 'pl', 0, 0, 0),
(101, 'Desttruiddor', 0, 1, 3, 76, 2, 520, 520, 6855274, 101, 2, 32, 52, 133, 0, 80, 1268, 2045, 4200, 0, 1, 12, 139, 5, 0x010004000002ffffffff0360ea00001a000000001b00000000fe010020000002ffffffff033010f8211a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805886, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 66, 207, 582, 2147483647, 1373342624, 1, '', 'es', 0, 0, 0),
(102, 'Bruninh', 0, 1, 3, 80, 2, 545, 545, 8019263, 102, 3, 33, 53, 134, 0, 80, 1888, 2195, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e01f8b601a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805886, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 121, 236, 892, 2147483647, 1373359721, 1, '', 'no', 0, 0, 0),
(103, 'Zero', 0, 1, 3, 82, 2, 555, 555, 8702772, 103, 4, 34, 54, 149, 0, 80, 2255, 2255, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c0dfb1671a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805886, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 108, 198, 758, 2147483647, 1373339628, 1, '', 'pl', 0, 0, 0),
(104, 'Fika Rato', 0, 1, 3, 75, 2, 520, 520, 6502334, 104, 5, 35, 55, 137, 0, 80, 1403, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03f8891e641a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 51, 176, 520, 2147483647, 1373344592, 1, '', 'mx', 0, 0, 0),
(105, 'Sorcex', 0, 1, 3, 75, 2, 520, 520, 6495323, 105, 6, 36, 56, 136, 0, 80, 1339, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0378f70e6d1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 76, 176, 641, 2147483647, 1373358819, 1, '', 'pl', 0, 0, 0),
(106, 'Manjador Dos Paranaue', 0, 1, 3, 75, 2, 520, 520, 6637717, 106, 7, 37, 57, 130, 0, 80, 1151, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0348556c371a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 41, 185, 439, 2147483647, 1373349117, 1, '', 'se', 0, 0, 0),
(107, 'Ligerinho''pm', 0, 1, 3, 75, 2, 520, 520, 6501187, 107, 8, 38, 58, 131, 0, 80, 1920, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c07f4d0e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 140, 157, 724, 2147483647, 1373351823, 1, '', 'pl', 0, 0, 0),
(108, 'Dona Benta', 0, 1, 3, 76, 2, 525, 525, 6780552, 108, 9, 39, 59, 132, 0, 80, 1518, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b82f17101a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0398e900001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 102, 173, 650, 2147483647, 1373341254, 1, '', 'pl', 0, 0, 0),
(109, 'Shinigame', 0, 1, 3, 75, 2, 520, 520, 6489800, 109, 10, 40, 60, 133, 0, 80, 0, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0358f5d8331a000000001b0000000004e8030000050a00000006e8030000071e000000fe010004000002ffffffff0360ea00001a000000001b00000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 28, 190, 319, 2147483647, 1373351442, 1, '', 'pl', 0, 0, 0),
(110, 'Diehan', 0, 1, 3, 75, 2, 520, 520, 6579817, 110, 11, 41, 61, 134, 0, 80, 720, 2045, 4200, 0, 1, 12, 139, 5, 0x010004000002ffffffff0360ea00001a000000001b00000000fe010020000002ffffffff03c8ff35391a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805887, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 28, 149, 282, 2147483647, 1373323693, 1, '', 'pl', 0, 0, 0),
(111, 'Edu Darkeness', 0, 1, 3, 85, 2, 570, 570, 9536800, 111, 12, 42, 62, 144, 0, 80, 2345, 2345, 4200, 0, 1, 12, 139, 5, '', 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805888, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 44, 26, 196, 2147483647, 1373320038, 1, '', 'se', 0, 0, 0),
(112, 'Bruh Darkness', 0, 1, 3, 86, 2, 575, 575, 9885500, 112, 13, 43, 63, 128, 0, 80, 2375, 2375, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0308d6830c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805888, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 66, 15, 286, 2147483647, 1373341688, 1, '', 'es', 0, 0, 0),
(113, 'Gordinn Ousado', 0, 1, 3, 97, 2, 630, 630, 14297600, 113, 14, 44, 64, 136, 0, 80, 2705, 2705, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03283ab22c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805888, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 81, 12, 271, 2147483647, 1373347405, 1, '', 've', 0, 0, 0),
(114, 'Bucetinha Rosa', 0, 1, 3, 75, 2, 520, 520, 6489800, 0, 15, 45, 65, 138, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03301bc9771a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805888, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 0, 0, 2147483647, 1373322376, 1, '', 'fi', 0, 0, 0),
(115, 'Mc Costetela', 0, 1, 3, 97, 2, 630, 630, 14297600, 1, 16, 46, 66, 131, 0, 80, 2705, 2705, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0378ebb1671a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805888, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 76, 8, 308, 2147483647, 1373320314, 1, '', 'br', 0, 0, 0),
(116, 'Richard Parker', 0, 1, 3, 77, 2, 530, 530, 7107176, 2, 17, 47, 67, 132, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03207b5c7b1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805889, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 9, 7, 37, 2147483647, 1373324584, 1, '', 'nl', 0, 0, 0),
(117, 'Abcdefghijlmnopqrstuvxz', 0, 1, 3, 86, 2, 575, 575, 9885500, 3, 18, 48, 68, 141, 0, 80, 2375, 2375, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a8cbf75c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805889, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 63, 23, 295, 2147483647, 1373341385, 1, '', 'pl', 0, 0, 0),
(118, 'Victorzin', 0, 1, 3, 86, 2, 575, 575, 9885500, 4, 19, 49, 69, 134, 0, 80, 2375, 2375, 4200, 0, 1, 12, 139, 5, '', 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805889, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 45, 10, 184, 2147483647, 1373328695, 1, '', 'pl', 0, 0, 0),
(119, 'Rastaman', 0, 1, 3, 75, 2, 520, 520, 6507115, 5, 20, 50, 70, 144, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0370d91e291a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805889, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 2, 13, 2147483647, 1373327737, 1, '', 'pl', 0, 0, 0),
(120, 'Following', 0, 1, 3, 77, 2, 530, 530, 7291566, 6, 21, 51, 71, 137, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c0bb9a571a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805889, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 1, 11, 2147483647, 1373325744, 1, '', 'pl', 0, 0, 0),
(121, 'Nerd''ziin', 0, 1, 3, 90, 2, 595, 595, 11663280, 7, 22, 52, 72, 129, 0, 80, 2495, 2495, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff031026ba0a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805889, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 81, 19, 283, 2147483647, 1373320569, 1, '', 'be', 0, 0, 0),
(122, 'Mc Samuka', 0, 1, 3, 101, 2, 650, 650, 16180000, 8, 23, 53, 73, 130, 0, 80, 2825, 2825, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e0fb73501a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805890, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 78, 10, 339, 2147483647, 1373345807, 1, '', 'pl', 0, 0, 0),
(123, 'Pai De Santo', 0, 1, 3, 92, 2, 605, 605, 12271671, 9, 24, 54, 74, 139, 0, 80, 2555, 2555, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d826ba0a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805890, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 93, 20, 310, 2147483647, 1373335132, 1, '', 'es', 0, 0, 0),
(124, 'Cannabis', 0, 1, 3, 98, 2, 635, 635, 14753700, 10, 25, 55, 75, 140, 0, 80, 2735, 2735, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0338b6c9011a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805890, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 83, 22, 277, 2147483647, 1373340848, 1, '', 'no', 0, 0, 0),
(125, 'Mokinho', 0, 1, 3, 90, 2, 595, 595, 11669718, 11, 26, 56, 76, 133, 0, 80, 2495, 2495, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03182cf0431a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805890, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 59, 17, 243, 2147483647, 1373353150, 1, '', 'pl', 0, 0, 0),
(126, 'Miliviix', 0, 1, 3, 96, 2, 625, 625, 13851000, 12, 27, 57, 77, 134, 0, 80, 2675, 2675, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360fb0e6d1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805890, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 63, 10, 231, 2147483647, 1373362407, 1, '', 'se', 0, 0, 0),
(127, 'Oscar Garlic', 0, 1, 3, 85, 2, 570, 570, 9536800, 13, 28, 58, 78, 149, 0, 80, 2345, 2345, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0398fbd8331a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805890, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 66, 24, 256, 2147483647, 1373343060, 1, '', 'pl', 0, 0, 0),
(128, 'Vigilante', 0, 1, 3, 91, 2, 600, 600, 11757000, 14, 29, 59, 79, 137, 0, 80, 2525, 2525, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03f86693031a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805891, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 58, 20, 269, 2147483647, 1373340442, 1, '', 'pl', 0, 0, 0),
(129, 'Metade', 0, 1, 3, 78, 2, 535, 535, 7400390, 15, 30, 60, 80, 129, 0, 80, 2135, 2135, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360fb0e6d1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805891, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 1, 21, 2147483647, 1373359709, 1, '', 'pl', 0, 0, 0),
(130, 'Knight Bolado', 0, 1, 3, 97, 2, 630, 630, 14297600, 16, 31, 61, 81, 130, 0, 80, 2705, 2705, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0338da1e291a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805891, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 62, 14, 227, 2147483647, 1373340975, 1, '', 'pl', 0, 0, 0);
INSERT INTO `players` (`id`, `name`, `world_id`, `group_id`, `account_id`, `level`, `vocation`, `health`, `healthmax`, `experience`, `lookbody`, `lookfeet`, `lookhead`, `looklegs`, `looktype`, `lookaddons`, `maglevel`, `mana`, `manamax`, `manaspent`, `soul`, `town_id`, `posx`, `posy`, `posz`, `conditions`, `cap`, `sex`, `lastlogin`, `lastip`, `save`, `skull`, `skulltime`, `rank_id`, `guildnick`, `lastlogout`, `blessings`, `balance`, `stamina`, `direction`, `online`, `marriage`, `promotion`, `deleted`, `description`, `kills`, `deaths`, `assists`, `create_ip`, `create_date`, `hide_char`, `comment`, `country`, `tmp_kills`, `tmp_assists`, `tmp_deaths`) VALUES
(131, 'Muito Loko Rapaiz', 0, 1, 3, 90, 2, 595, 595, 11365300, 17, 32, 62, 82, 131, 0, 80, 2495, 2495, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0328cc5c401a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805891, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 66, 41, 277, 2147483647, 1373337542, 1, '', 'se', 0, 0, 0),
(132, 'Fell Like Monster', 0, 1, 3, 75, 2, 520, 520, 6747611, 18, 33, 63, 83, 132, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0328165d051a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805891, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 3, 9, 2147483647, 1373341359, 1, '', 'pl', 0, 0, 0),
(133, 'Over Power', 0, 1, 3, 75, 2, 520, 520, 6489800, 19, 34, 64, 84, 133, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03306693031a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805891, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 1, 3, 2147483647, 1373348261, 1, '', 'pl', 0, 0, 0),
(134, 'Slash', 0, 1, 3, 75, 2, 520, 520, 6514923, 20, 35, 65, 85, 134, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff039056d11a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805892, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 1, 2, 2147483647, 1373358336, 1, '', 'es', 0, 0, 0),
(135, 'Cu De Grilo', 0, 1, 3, 81, 2, 550, 550, 8224000, 21, 36, 66, 86, 149, 0, 80, 2225, 2225, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0390aba2351a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805892, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 63, 43, 267, 2147483647, 1373341739, 1, '', 'fi', 0, 0, 0),
(136, 'Danyelzeraah Pally', 0, 1, 3, 75, 2, 520, 520, 6548309, 22, 37, 67, 87, 128, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c0bb9a571a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805892, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 0, 1, 2147483647, 1373360948, 1, '', 'mx', 0, 0, 0),
(137, 'Darkzeraah', 0, 1, 3, 76, 2, 525, 525, 6832655, 23, 38, 68, 88, 129, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0320ea7b2e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805892, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 6, 2, 19, 2147483647, 1373357336, 1, '', 'br', 0, 0, 0),
(138, 'Sir Madruga', 0, 1, 3, 93, 2, 610, 610, 12567200, 24, 39, 69, 89, 138, 0, 80, 2585, 2585, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d826ba0a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805892, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 38, 13, 207, 2147483647, 1373333095, 1, '', 'pl', 0, 0, 0),
(139, 'Chupa', 0, 1, 3, 77, 2, 530, 530, 7037600, 25, 40, 70, 90, 131, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0328cc5c401a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805893, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 51, 69, 263, 2147483647, 1373347254, 1, '', 'pl', 0, 0, 0),
(140, 'Ruxafas', 0, 1, 3, 75, 2, 520, 520, 6576146, 26, 41, 71, 91, 140, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03402a55271a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805893, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 1, 0, 2147483647, 1373332480, 1, '', 've', 0, 0, 0),
(141, 'Amigo Mokinho', 0, 1, 3, 76, 2, 525, 525, 6782477, 27, 42, 72, 92, 141, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0338b6c9011a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805893, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 2, 1, 2147483647, 1373336879, 1, '', 'se', 0, 0, 0),
(142, 'Rafaelzinho Dashow Aboslut', 0, 1, 3, 77, 2, 530, 530, 7037600, 28, 43, 73, 93, 134, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03386bff751a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805893, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 0, 0, 2147483647, 1373327030, 1, '', 'pl', 0, 0, 0),
(143, 'Becker', 0, 1, 3, 80, 2, 545, 545, 7915800, 29, 44, 74, 94, 144, 0, 80, 2195, 2195, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d826ba0a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805893, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 41, 36, 199, 2147483647, 1373352419, 1, '', 'pl', 0, 0, 0),
(144, 'Jarbinha', 0, 1, 3, 81, 2, 550, 550, 8224000, 30, 45, 75, 95, 128, 0, 80, 2225, 2225, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0310dcb9451a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805893, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 50, 50, 252, 2147483647, 1373323840, 1, '', 'pl', 0, 0, 0),
(145, 'Matafacil', 0, 1, 3, 84, 2, 565, 565, 9297035, 31, 46, 76, 96, 129, 0, 80, 2315, 2315, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360cb5c401a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805894, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 65, 15, 249, 2147483647, 1373328681, 1, '', 'es', 0, 0, 0),
(146, 'Thear Fared', 0, 1, 3, 76, 2, 525, 525, 6792602, 32, 47, 77, 97, 130, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360fb0e6d1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805894, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 2, 11, 2147483647, 1373345587, 1, '', 'no', 0, 0, 0),
(147, 'Oloko''meu', 0, 1, 3, 75, 2, 520, 520, 6561714, 33, 48, 78, 98, 139, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b8e6e0111a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805894, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 2, 1, 2147483647, 1373328764, 1, '', 'pl', 0, 0, 0),
(148, 'Adolf Hitler', 0, 1, 3, 79, 2, 540, 540, 7615400, 34, 49, 79, 99, 132, 0, 80, 2165, 2165, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d826ba0a1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805894, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 54, 33, 237, 2147483647, 1373343539, 1, '', 'pl', 0, 0, 0),
(149, 'Depeche Mode', 0, 1, 3, 75, 2, 520, 520, 6491636, 35, 50, 80, 100, 141, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03306693031a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805894, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 48, 48, 231, 2147483647, 1373355390, 1, '', 'pl', 0, 0, 0),
(150, 'Kinho Jah Bless', 0, 1, 3, 77, 2, 530, 530, 7047592, 36, 51, 81, 101, 142, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b86b64591a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805895, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 2, 17, 2147483647, 1373351410, 1, '', 'pl', 0, 0, 0),
(151, 'Lord Paulistinha', 0, 1, 3, 77, 2, 530, 530, 7037600, 37, 52, 82, 102, 144, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e0caf75c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805895, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 0, 0, 2147483647, 1373339387, 1, '', 'se', 0, 0, 0),
(152, 'Turtoise', 0, 1, 3, 75, 2, 520, 520, 6489800, 38, 53, 83, 103, 137, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0360ca92791a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805895, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 1, 0, 2147483647, 1373357825, 1, '', 'pl', 0, 0, 0),
(153, 'Sirius Black', 0, 1, 3, 76, 2, 525, 525, 6929547, 39, 54, 84, 104, 136, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03d0d6830c1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805895, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 2, 20, 2147483647, 1373327590, 1, '', 'nl', 0, 0, 0),
(154, 'Xande', 0, 1, 3, 78, 2, 535, 535, 7322700, 40, 55, 85, 105, 130, 0, 80, 2135, 2135, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03888b1e641a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805895, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 50, 76, 235, 2147483647, 1373342622, 1, '', 'pl', 0, 0, 0),
(155, 'Legalize', 0, 1, 3, 77, 2, 530, 530, 7037600, 41, 56, 86, 106, 131, 0, 80, 2105, 2105, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03301c933e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805895, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 36, 55, 203, 2147483647, 1373363250, 1, '', 'pl', 0, 0, 0),
(156, 'Cadela Loka', 0, 1, 3, 76, 2, 525, 525, 6908755, 42, 57, 87, 107, 140, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03301c933e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805896, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 1, 6, 2147483647, 1373328678, 1, '', 'fi', 0, 0, 0),
(157, 'Terrorista', 0, 1, 3, 75, 2, 520, 520, 6658574, 43, 58, 88, 108, 141, 0, 80, 2045, 2045, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0300b7c9011a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805896, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 50, 73, 195, 2147483647, 1373323419, 1, '', 'de', 0, 0, 0),
(158, 'Rasta', 0, 1, 3, 76, 2, 525, 525, 6760000, 44, 59, 89, 109, 134, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff037016f8211a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805896, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 1, 1, 2147483647, 1373333496, 1, '', 'pl', 0, 0, 0),
(159, 'Thekinaishiri', 0, 1, 3, 76, 2, 525, 525, 6993944, 45, 60, 90, 110, 149, 0, 80, 2075, 2075, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff0320ea7b2e1a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805896, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 2, 22, 2147483647, 1373321564, 1, '', 'br', 0, 0, 0),
(160, 'Piceta Over', 0, 1, 3, 83, 2, 560, 560, 9090633, 46, 61, 91, 111, 137, 0, 80, 2285, 2285, 4200, 0, 1, 12, 139, 5, 0x010020000002ffffffff03301bc9771a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805896, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 12, 11, 28, 2147483647, 1373341395, 1, '', 'pl', 0, 0, 0),
(161, 'Orbital Gomao', 0, 1, 3, 75, 3, 855, 855, 6490311, 47, 62, 92, 112, 136, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03502bf0431a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805896, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 1, 0, 2147483647, 1373320534, 1, '', 'se', 0, 0, 0),
(162, 'Mestre Dos Magos', 0, 1, 3, 75, 3, 855, 855, 6515581, 48, 63, 93, 113, 138, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0380b6641e1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805897, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 7, 62, 165, 2147483647, 1373359805, 1, '', 'pl', 0, 0, 0),
(163, 'Jotape Sdmax', 0, 1, 3, 76, 3, 865, 865, 6760000, 49, 64, 94, 0, 139, 0, 16, 1055, 1055, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0300864d0e1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805897, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 6, 44, 83, 2147483647, 1373327355, 1, '', 'pl', 0, 0, 0),
(164, 'Cadeirante Estrabico', 0, 1, 3, 75, 3, 855, 855, 6500625, 50, 65, 95, 1, 140, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03f8ba9a571a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805897, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 0, 0, 2147483647, 1373324703, 1, '', 'pl', 0, 0, 0),
(165, 'Priscila Pagodeira', 0, 1, 3, 75, 3, 855, 855, 6670372, 51, 66, 96, 2, 133, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03f86693031a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805897, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 0, 10, 2147483647, 1373358644, 1, '', 'pl', 0, 0, 0),
(166, 'Doglas''zin Psiu', 0, 1, 3, 75, 3, 855, 855, 6490290, 52, 67, 97, 3, 142, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0338da1e291a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805897, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 42, 108, 2147483647, 1373333301, 1, '', 'se', 0, 0, 0),
(167, 'Tecomi De Ladinho', 0, 1, 3, 79, 3, 895, 895, 7649353, 53, 68, 98, 4, 149, 0, 16, 1100, 1100, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b01b2e5b1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 31, 55, 2147483647, 1373341895, 1, '', 've', 0, 0, 0),
(168, 'Godky', 0, 1, 3, 75, 3, 855, 855, 6500270, 54, 69, 99, 5, 128, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0378ebb1671a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 45, 81, 2147483647, 1373348179, 1, '', 'mx', 0, 0, 0),
(169, 'Nasci Pra Morrer', 0, 1, 3, 75, 3, 855, 855, 6553925, 55, 70, 100, 6, 136, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0370d91e291a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 51, 74, 2147483647, 1373335470, 1, '', 'pl', 0, 0, 0),
(170, 'Ze Loko', 0, 1, 3, 76, 3, 865, 865, 6760000, 56, 71, 101, 7, 138, 0, 16, 1055, 1055, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03505ba2701a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 76, 169, 2147483647, 1373342706, 1, '', 'pl', 0, 0, 0),
(171, 'Johnny Bravo', 0, 1, 3, 75, 3, 855, 855, 6494827, 57, 72, 102, 8, 131, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e8ea7b2e1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 3, 7, 2147483647, 1373319326, 1, '', 'se', 0, 0, 0),
(172, 'Imperial Jah', 0, 1, 3, 75, 3, 855, 855, 6491829, 58, 73, 103, 9, 140, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03182cf0431a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 6, 56, 105, 2147483647, 1373352271, 1, '', 'pl', 0, 0, 0),
(173, 'Palla Delirious', 0, 1, 3, 75, 3, 855, 855, 6551870, 59, 74, 104, 10, 141, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0348daef7e1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805898, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 6, 8, 2147483647, 1373325468, 1, '', 'pl', 0, 0, 0),
(174, 'Mokin Jr', 0, 1, 3, 75, 3, 855, 855, 6510032, 60, 75, 105, 11, 142, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c855d11a1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805899, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 6, 88, 126, 2147483647, 1373361913, 1, '', 'pl', 0, 0, 0),
(175, 'Shiriahere', 0, 1, 3, 78, 3, 885, 885, 7374449, 61, 76, 106, 12, 149, 0, 16, 1085, 1085, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0358aca2351a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805899, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 15, 32, 2147483647, 1373341479, 1, '', 'pl', 0, 0, 0),
(176, 'Derp Paladin Zuero', 0, 1, 3, 75, 3, 855, 855, 6489800, 62, 77, 107, 13, 128, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03301bc9771a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805899, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 59, 93, 2147483647, 1373340605, 1, '', 'se', 0, 0, 0),
(177, 'Flynawb', 0, 1, 3, 75, 3, 855, 855, 6498291, 63, 78, 108, 14, 136, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c08a1e641a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805899, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 71, 108, 2147483647, 1373343710, 1, '', 'fi', 0, 0, 0),
(178, 'Pistao', 0, 1, 3, 75, 3, 855, 855, 6489800, 64, 79, 109, 15, 130, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e81a2e5b1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805899, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 12, 25, 2147483647, 1373354639, 1, '', 'be', 0, 0, 0),
(179, 'Lulu', 0, 1, 3, 75, 3, 855, 855, 6502073, 65, 80, 110, 16, 131, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0390db54621a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805899, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 6, 63, 144, 2147483647, 1373357172, 1, '', 'de', 0, 0, 0),
(180, 'Pekeno', 0, 1, 3, 75, 3, 855, 855, 6503897, 66, 81, 111, 17, 132, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03681b933e1a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805900, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 4, 6, 2147483647, 1373352184, 1, '', 'pl', 0, 0, 0),
(181, 'Maximilian''mongol', 0, 1, 3, 76, 3, 865, 865, 6760000, 67, 82, 112, 18, 141, 0, 16, 1055, 1055, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a0f63d171a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805900, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 58, 92, 2147483647, 1373353826, 1, '', 'br', 0, 0, 0),
(182, 'Kauane', 0, 1, 3, 75, 3, 855, 855, 6489800, 68, 83, 113, 19, 142, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0338da1e291a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805900, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 67, 103, 2147483647, 1373322309, 1, '', 'pl', 0, 0, 0),
(183, 'Mageziin', 0, 1, 3, 75, 3, 855, 855, 6510466, 69, 84, 0, 20, 144, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03085b07541a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805900, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 57, 124, 2147483647, 1373330027, 1, '', 'pl', 0, 0, 0),
(184, 'Johnata Ekzor', 0, 1, 3, 75, 3, 855, 855, 6489800, 70, 85, 1, 21, 128, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0310dcb9451a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805900, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 51, 100, 2147483647, 1373363577, 1, '', 'pl', 0, 0, 0),
(185, 'Vai Toma No Cucaracha', 0, 1, 3, 75, 3, 855, 855, 6490484, 71, 86, 2, 22, 129, 0, 16, 1040, 1040, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03088c83471a000000001b0000000004e8030000050f00000006e8030000070f000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805901, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 67, 118, 2147483647, 1373359659, 1, '', 'pl', 0, 0, 0),
(186, 'Mercenario', 0, 1, 3, 75, 4, 1190, 1190, 6522373, 72, 87, 3, 23, 130, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03182b267d1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805901, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 9, 49, 98, 2147483647, 1373362586, 1, '', 'se', 0, 0, 0),
(187, 'Arzhak Mululu', 0, 1, 3, 75, 4, 1190, 1190, 6538173, 73, 88, 4, 24, 131, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03f09be04c1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805901, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 6, 9, 2147483647, 1373331080, 1, '', 'pl', 0, 0, 0),
(188, 'Afiliado Do Devilware', 0, 1, 3, 76, 4, 1205, 1205, 6760000, 74, 89, 5, 25, 140, 0, 7, 375, 375, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03a0f63d171a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805901, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 8, 70, 114, 2147483647, 1373320096, 1, '', 'pl', 0, 0, 0),
(189, 'Crystalina', 0, 1, 3, 75, 4, 1190, 1190, 6490636, 75, 90, 6, 26, 133, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c08a1e641a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805901, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 46, 85, 2147483647, 1373354037, 1, '', 'es', 0, 0, 0),
(190, 'Account Managier', 0, 1, 3, 75, 4, 1190, 1190, 6492561, 76, 91, 7, 27, 142, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0320ea7b2e1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805901, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 1, 1, 2147483647, 1373346902, 1, '', 'nl', 0, 0, 0),
(191, 'Deadpoll', 0, 1, 3, 75, 4, 1190, 1190, 6535416, 77, 92, 8, 28, 149, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff037016f8211a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805902, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 2, 2, 2147483647, 1373338730, 1, '', 'se', 0, 0, 0),
(192, 'Pally Infernal', 0, 1, 3, 75, 4, 1190, 1190, 6536403, 78, 93, 9, 29, 128, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0318fb73501a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805902, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 12, 65, 132, 2147483647, 1373355895, 1, '', 'pl', 0, 0, 0),
(193, 'Yosemite Sam', 0, 1, 3, 76, 4, 1205, 1205, 6760000, 79, 94, 10, 30, 129, 0, 7, 375, 375, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03888b1e641a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805902, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 52, 89, 2147483647, 1373341329, 1, '', 'pl', 0, 0, 0),
(194, 'Kaizem', 0, 1, 3, 75, 4, 1190, 1190, 6495272, 80, 95, 11, 31, 138, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c0bb9a571a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805902, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 53, 75, 2147483647, 1373351871, 1, '', 've', 0, 0, 0),
(195, 'Black Kniight', 0, 1, 3, 75, 4, 1190, 1190, 6490747, 81, 96, 12, 32, 139, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03207b5c7b1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805902, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 9, 44, 96, 2147483647, 1373343286, 1, '', 'pl', 0, 0, 0),
(196, 'Toddy Nouxy', 0, 1, 3, 75, 4, 1190, 1190, 6499985, 82, 97, 13, 33, 140, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03681ac9771a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805903, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 5, 60, 113, 2147483647, 1373322772, 1, '', 'se', 0, 0, 0),
(197, 'Matheus Walker', 0, 1, 3, 77, 4, 1220, 1220, 7315136, 83, 98, 14, 34, 141, 0, 7, 380, 380, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03003c4d491a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805903, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 38, 60, 2147483647, 1373342948, 1, '', 'pl', 0, 0, 0),
(198, 'Jhoni Walker', 0, 1, 3, 75, 4, 1190, 1190, 6490068, 84, 99, 15, 35, 134, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03207c26421a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805903, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 3, 3, 1, 2147483647, 1373346242, 1, '', 'fi', 0, 0, 0),
(199, 'Magnus Infernal', 0, 1, 3, 75, 4, 1190, 1190, 6557962, 85, 100, 16, 36, 144, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03306693031a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805903, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 0, 0, 2147483647, 1373358887, 1, '', 'pl', 0, 0, 0),
(200, 'Mc Daleste', 0, 1, 3, 75, 4, 1190, 1190, 6540574, 86, 101, 17, 37, 128, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03c8864d0e1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805903, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 7, 39, 85, 2147483647, 1373336832, 1, '', 'mx', 0, 0, 0),
(201, 'Eternal Sorx', 0, 1, 3, 75, 4, 1190, 1190, 6490004, 87, 102, 18, 38, 136, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0320ea7b2e1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805903, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 4, 7, 2147483647, 1373324552, 1, '', 'de', 0, 0, 0),
(202, 'Thor Paladin', 0, 1, 3, 75, 4, 1190, 1190, 6506119, 88, 103, 19, 39, 138, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03480c36391a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805904, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 3, 5, 2147483647, 1373350935, 1, '', 'pl', 0, 0, 0),
(203, 'Tonha Diaba', 0, 1, 3, 75, 4, 1190, 1190, 6500450, 89, 104, 20, 40, 131, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03b096aa131a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805904, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 2, 12, 2147483647, 1373322726, 1, '', 'br', 0, 0, 0),
(204, 'Eco Cachacero', 0, 1, 3, 75, 4, 1190, 1190, 6509898, 90, 105, 21, 41, 132, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0338da1e291a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805904, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 4, 5, 2147483647, 1373355497, 1, '', 'pl', 0, 0, 0),
(205, 'Demon Holy', 0, 1, 3, 75, 4, 1190, 1190, 6491241, 91, 106, 22, 42, 141, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e84baa4e1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805904, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 3, 8, 2147483647, 1373351402, 1, '', 'pl', 0, 0, 0),
(206, 'Palladina Linda', 0, 1, 3, 75, 4, 1190, 1190, 6533268, 92, 107, 23, 43, 142, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03e09a45301a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805904, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 4, 36, 69, 2147483647, 1373325682, 1, '', 'se', 0, 0, 0),
(207, 'Forever', 0, 1, 3, 75, 4, 1190, 1190, 6498667, 93, 108, 24, 44, 144, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03301bc9771a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805904, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 40, 64, 2147483647, 1373343312, 1, '', 'pl', 0, 0, 0),
(208, 'Favela Owns', 0, 1, 3, 75, 4, 1190, 1190, 6593036, 94, 109, 25, 45, 137, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0328165d051a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805905, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 1, 0, 0, 2147483647, 1373325976, 1, '', 'pl', 0, 0, 0),
(209, 'Bruno Rusha''rp', 0, 1, 3, 75, 4, 1190, 1190, 6622881, 95, 110, 26, 46, 129, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff03f8eb164b1a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 1, 0, 0, 1, 0, 0, 0, '', 1373805905, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 2, 3, 12, 2147483647, 1373345513, 1, '', 'pl', 0, 0, 0),
(210, 'Homer Simpsonp', 0, 1, 3, 75, 4, 1190, 1190, 6505703, 96, 111, 27, 47, 138, 0, 7, 370, 370, 0, 0, 1, 12, 139, 5, 0x010020000002ffffffff0328165d051a000000001b0000000004e8030000051900000006e8030000070a000000fe, 3000, 0, 0, 0, 1, 0, 0, 0, '', 1373805905, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 0, 0, 2147483647, 1373336544, 1, '', 'pl', 0, 0, 0),
(214, 'Klepy Geip', 0, 1, 1, 92, 1, 605, 605, 12262079, 113, 114, 79, 103, 145, 0, 80, 2555, 2555, 33600, 0, 1, 45, 59, 6, 0x010020000002ffffffff036827f0431a000000001b0000000004e8030000050a00000006e8030000071e000000fe, 3000, 1, 1373992602, 923018418, 1, 0, 0, 0, '', 1373993566, 0, 0, 151200000, 0, 0, 0, 0, 0, '', 0, 20, 6, 2147483647, 1373803473, 0, '', 'pl', 0, 0, 0);

--
-- Wyzwalacze `players`
--
DROP TRIGGER IF EXISTS `oncreate_players`;
DELIMITER //
CREATE TRIGGER `oncreate_players` AFTER INSERT ON `players`
 FOR EACH ROW BEGIN
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 0, 10);
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 1, 10);
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 2, 10);
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 3, 10);
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 4, 10);
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 5, 10);
	INSERT INTO `player_skills` (`player_id`, `skillid`, `value`) VALUES (NEW.`id`, 6, 10);
END
//
DELIMITER ;
DROP TRIGGER IF EXISTS `ondelete_players`;
DELIMITER //
CREATE TRIGGER `ondelete_players` BEFORE DELETE ON `players`
 FOR EACH ROW BEGIN
	DELETE FROM `bans` WHERE `type` IN (2, 5) AND `value` = OLD.`id`;
	UPDATE `houses` SET `owner` = 0 WHERE `owner` = OLD.`id`;
END
//
DELIMITER ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_deaths`
--

CREATE TABLE IF NOT EXISTS `player_deaths` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `player_id` int(11) NOT NULL,
  `date` bigint(20) unsigned NOT NULL,
  `level` int(10) unsigned NOT NULL,
  PRIMARY KEY (`id`),
  KEY `date` (`date`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_depotitems`
--

CREATE TABLE IF NOT EXISTS `player_depotitems` (
  `player_id` int(11) NOT NULL,
  `sid` int(11) NOT NULL COMMENT 'any given range, eg. 0-100 is reserved for depot lockers and all above 100 will be normal items inside depots',
  `pid` int(11) NOT NULL DEFAULT '0',
  `itemtype` int(11) NOT NULL,
  `count` int(11) NOT NULL DEFAULT '0',
  `attributes` blob NOT NULL,
  UNIQUE KEY `player_id_2` (`player_id`,`sid`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `player_depotitems`
--

INSERT INTO `player_depotitems` (`player_id`, `sid`, `pid`, `itemtype`, `count`, `attributes`) VALUES
(2, 101, 1, 2589, 1, ''),
(2, 102, 101, 2594, 1, '');

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_items`
--

CREATE TABLE IF NOT EXISTS `player_items` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `pid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `itemtype` int(11) NOT NULL DEFAULT '0',
  `count` int(11) NOT NULL DEFAULT '0',
  `attributes` blob NOT NULL,
  UNIQUE KEY `player_id_2` (`player_id`,`sid`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `player_items`
--

INSERT INTO `player_items` (`player_id`, `pid`, `sid`, `itemtype`, `count`, `attributes`) VALUES
(2, 1, 101, 2491, 1, ''),
(2, 3, 102, 1988, 1, ''),
(2, 4, 103, 2487, 1, ''),
(2, 5, 104, 6108, 1, ''),
(2, 6, 105, 2002, 1, 0x8002000300544944020b00000007006f776e657249440202000000),
(2, 7, 106, 2647, 1, ''),
(2, 8, 107, 2195, 1, ''),
(2, 10, 108, 1988, 1, ''),
(2, 102, 109, 8985, 1, ''),
(2, 102, 110, 5791, 1, ''),
(2, 102, 111, 2263, 99, 0x0f638002000300544944020900000007006f776e657249440202000000),
(2, 102, 112, 2519, 1, ''),
(2, 102, 113, 2263, 3, 0x0f03),
(2, 102, 114, 2268, 100, 0x0f64),
(2, 102, 115, 2263, 95, 0x0f5f),
(2, 102, 116, 2267, 100, 0x0f64),
(2, 105, 117, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 118, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 119, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 120, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 121, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 122, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 123, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 124, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 125, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 126, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 127, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 128, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 129, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 130, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 131, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 132, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 105, 133, 2396, 5, 0x8003000300544944020b000000070063686172676573020500000007006f776e657249440202000000),
(2, 108, 134, 2580, 1, ''),
(2, 108, 135, 2580, 1, ''),
(2, 108, 136, 2580, 1, ''),
(2, 108, 137, 2580, 1, ''),
(2, 108, 138, 2580, 1, ''),
(2, 108, 139, 2580, 1, ''),
(2, 108, 140, 2580, 1, ''),
(2, 108, 141, 2580, 1, ''),
(2, 108, 142, 2580, 1, ''),
(2, 108, 143, 2580, 1, ''),
(2, 108, 144, 2580, 1, ''),
(2, 108, 145, 2580, 1, ''),
(2, 108, 146, 2580, 1, ''),
(3, 1, 101, 2498, 1, ''),
(3, 3, 102, 1988, 1, ''),
(3, 4, 103, 2656, 1, ''),
(3, 5, 104, 2520, 1, ''),
(3, 6, 105, 8920, 1, ''),
(3, 7, 106, 2647, 1, ''),
(3, 8, 107, 2195, 1, ''),
(3, 10, 108, 1987, 1, ''),
(3, 102, 109, 2268, 1, 0x0f01),
(3, 102, 110, 2273, 1, 0x0f01),
(3, 102, 111, 2305, 1, 0x0f01),
(3, 102, 112, 2261, 1, 0x0f01),
(3, 102, 113, 2293, 1, 0x0f01),
(3, 102, 114, 7590, 1, 0x0f01),
(3, 102, 115, 7589, 1, 0x0f01),
(3, 102, 116, 7620, 1, 0x0f01),
(3, 102, 117, 7618, 1, 0x0f01),
(3, 108, 118, 8922, 1, ''),
(3, 108, 119, 2187, 1, ''),
(8, 1, 101, 2498, 1, ''),
(8, 3, 102, 1988, 1, ''),
(8, 4, 103, 2656, 1, ''),
(8, 5, 104, 2520, 1, ''),
(8, 6, 105, 8912, 1, ''),
(8, 7, 106, 2647, 1, ''),
(8, 8, 107, 2195, 1, ''),
(8, 10, 108, 1987, 1, ''),
(8, 102, 109, 2278, 1, 0x0f01),
(8, 102, 110, 2273, 1, 0x0f01),
(8, 102, 111, 2305, 1, 0x0f01),
(8, 102, 112, 2268, 1, 0x0f01),
(8, 102, 113, 2261, 1, 0x0f01),
(8, 102, 114, 2293, 1, 0x0f01),
(8, 102, 115, 7618, 1, 0x0f01),
(8, 102, 116, 7590, 1, 0x0f01),
(8, 102, 117, 7589, 1, 0x0f01),
(8, 108, 118, 8910, 1, ''),
(8, 108, 119, 2183, 1, ''),
(9, 1, 101, 2498, 1, ''),
(9, 3, 102, 1988, 1, ''),
(9, 4, 103, 2492, 1, ''),
(9, 5, 104, 7367, 1, 0x0f01),
(9, 6, 105, 2520, 1, ''),
(9, 7, 106, 2488, 1, ''),
(9, 8, 107, 2195, 1, ''),
(9, 102, 108, 2273, 1, 0x0f01),
(9, 102, 109, 2268, 1, 0x0f01),
(9, 102, 110, 2305, 1, 0x0f01),
(9, 102, 111, 2261, 1, 0x0f01),
(9, 102, 112, 2293, 1, 0x0f01),
(9, 102, 113, 8472, 1, 0x0f01),
(9, 102, 114, 7620, 1, 0x0f01),
(9, 102, 115, 7589, 1, 0x0f01),
(9, 102, 116, 7588, 1, 0x0f01),
(10, 1, 101, 2498, 1, ''),
(10, 3, 102, 1988, 1, ''),
(10, 4, 103, 2492, 1, ''),
(10, 5, 104, 2520, 1, ''),
(10, 6, 105, 7390, 1, ''),
(10, 7, 106, 2488, 1, ''),
(10, 8, 107, 2195, 1, ''),
(10, 10, 108, 1987, 1, ''),
(10, 102, 109, 2261, 1, 0x0f01),
(10, 102, 110, 2305, 1, 0x0f01),
(10, 102, 111, 2293, 1, 0x0f01),
(10, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(10, 102, 113, 7588, 1, 0x0f01),
(10, 102, 114, 8473, 1, 0x0f01),
(10, 102, 115, 7591, 1, 0x0f01),
(10, 102, 116, 7620, 1, 0x0f01),
(10, 108, 117, 7434, 1, ''),
(10, 108, 118, 7431, 1, ''),
(10, 108, 119, 7429, 1, ''),
(11, 1, 101, 2498, 1, ''),
(11, 3, 102, 1988, 1, ''),
(11, 4, 103, 2656, 1, ''),
(11, 5, 104, 2520, 1, ''),
(11, 6, 105, 8920, 1, ''),
(11, 7, 106, 2647, 1, ''),
(11, 8, 107, 2195, 1, ''),
(11, 10, 108, 1987, 1, ''),
(11, 102, 109, 2268, 1, 0x0f01),
(11, 102, 110, 2273, 1, 0x0f01),
(11, 102, 111, 2305, 1, 0x0f01),
(11, 102, 112, 2261, 1, 0x0f01),
(11, 102, 113, 2293, 1, 0x0f01),
(11, 102, 114, 7590, 1, 0x0f01),
(11, 102, 115, 7589, 1, 0x0f01),
(11, 102, 116, 7620, 1, 0x0f01),
(11, 102, 117, 7618, 1, 0x0f01),
(11, 108, 118, 8922, 1, ''),
(11, 108, 119, 2187, 1, ''),
(12, 1, 101, 2498, 1, ''),
(12, 3, 102, 1988, 1, ''),
(12, 4, 103, 2656, 1, ''),
(12, 5, 104, 2520, 1, ''),
(12, 6, 105, 8920, 1, ''),
(12, 7, 106, 2647, 1, ''),
(12, 8, 107, 2195, 1, ''),
(12, 10, 108, 1987, 1, ''),
(12, 102, 109, 2268, 1, 0x0f01),
(12, 102, 110, 2273, 1, 0x0f01),
(12, 102, 111, 2305, 1, 0x0f01),
(12, 102, 112, 2261, 1, 0x0f01),
(12, 102, 113, 2293, 1, 0x0f01),
(12, 102, 114, 7590, 1, 0x0f01),
(12, 102, 115, 7589, 1, 0x0f01),
(12, 102, 116, 7620, 1, 0x0f01),
(12, 102, 117, 7618, 1, 0x0f01),
(12, 108, 118, 8922, 1, ''),
(12, 108, 119, 2187, 1, ''),
(13, 1, 101, 2498, 1, ''),
(13, 3, 102, 1988, 1, ''),
(13, 4, 103, 2656, 1, ''),
(13, 5, 104, 2520, 1, ''),
(13, 6, 105, 8920, 1, ''),
(13, 7, 106, 2647, 1, ''),
(13, 8, 107, 2195, 1, ''),
(13, 10, 108, 1987, 1, ''),
(13, 102, 109, 2268, 1, 0x0f01),
(13, 102, 110, 2273, 1, 0x0f01),
(13, 102, 111, 2305, 1, 0x0f01),
(13, 102, 112, 2261, 1, 0x0f01),
(13, 102, 113, 2293, 1, 0x0f01),
(13, 102, 114, 7590, 1, 0x0f01),
(13, 102, 115, 7589, 1, 0x0f01),
(13, 102, 116, 7620, 1, 0x0f01),
(13, 102, 117, 7618, 1, 0x0f01),
(13, 108, 118, 8922, 1, ''),
(13, 108, 119, 2187, 1, ''),
(14, 1, 101, 2498, 1, ''),
(14, 3, 102, 1988, 1, ''),
(14, 4, 103, 2656, 1, ''),
(14, 5, 104, 2520, 1, ''),
(14, 6, 105, 8920, 1, ''),
(14, 7, 106, 2647, 1, ''),
(14, 8, 107, 2195, 1, ''),
(14, 10, 108, 1987, 1, ''),
(14, 102, 109, 2268, 1, 0x0f01),
(14, 102, 110, 2273, 1, 0x0f01),
(14, 102, 111, 2305, 1, 0x0f01),
(14, 102, 112, 2261, 1, 0x0f01),
(14, 102, 113, 2293, 1, 0x0f01),
(14, 102, 114, 7590, 1, 0x0f01),
(14, 102, 115, 7589, 1, 0x0f01),
(14, 102, 116, 7620, 1, 0x0f01),
(14, 102, 117, 7618, 1, 0x0f01),
(14, 108, 118, 8922, 1, ''),
(14, 108, 119, 2187, 1, ''),
(15, 1, 101, 2498, 1, ''),
(15, 3, 102, 1988, 1, ''),
(15, 4, 103, 2656, 1, ''),
(15, 5, 104, 2520, 1, ''),
(15, 6, 105, 8920, 1, ''),
(15, 7, 106, 2647, 1, ''),
(15, 8, 107, 2195, 1, ''),
(15, 10, 108, 1987, 1, ''),
(15, 102, 109, 2268, 1, 0x0f01),
(15, 102, 110, 2273, 1, 0x0f01),
(15, 102, 111, 2305, 1, 0x0f01),
(15, 102, 112, 2261, 1, 0x0f01),
(15, 102, 113, 2293, 1, 0x0f01),
(15, 102, 114, 7590, 1, 0x0f01),
(15, 102, 115, 7589, 1, 0x0f01),
(15, 102, 116, 7620, 1, 0x0f01),
(15, 102, 117, 7618, 1, 0x0f01),
(15, 108, 118, 8922, 1, ''),
(15, 108, 119, 2187, 1, ''),
(16, 1, 101, 2498, 1, ''),
(16, 3, 102, 1988, 1, ''),
(16, 4, 103, 2656, 1, ''),
(16, 5, 104, 2520, 1, ''),
(16, 6, 105, 8920, 1, ''),
(16, 7, 106, 2647, 1, ''),
(16, 8, 107, 2195, 1, ''),
(16, 10, 108, 1987, 1, ''),
(16, 102, 109, 2268, 1, 0x0f01),
(16, 102, 110, 2273, 1, 0x0f01),
(16, 102, 111, 2305, 1, 0x0f01),
(16, 102, 112, 2261, 1, 0x0f01),
(16, 102, 113, 2293, 1, 0x0f01),
(16, 102, 114, 7590, 1, 0x0f01),
(16, 102, 115, 7589, 1, 0x0f01),
(16, 102, 116, 7620, 1, 0x0f01),
(16, 102, 117, 7618, 1, 0x0f01),
(16, 108, 118, 8922, 1, ''),
(16, 108, 119, 2187, 1, ''),
(17, 1, 101, 2498, 1, ''),
(17, 3, 102, 1988, 1, ''),
(17, 4, 103, 2656, 1, ''),
(17, 5, 104, 2520, 1, ''),
(17, 6, 105, 8920, 1, ''),
(17, 7, 106, 2647, 1, ''),
(17, 8, 107, 2195, 1, ''),
(17, 10, 108, 1987, 1, ''),
(17, 102, 109, 2268, 1, 0x0f01),
(17, 102, 110, 2273, 1, 0x0f01),
(17, 102, 111, 2305, 1, 0x0f01),
(17, 102, 112, 2261, 1, 0x0f01),
(17, 102, 113, 2293, 1, 0x0f01),
(17, 102, 114, 7590, 1, 0x0f01),
(17, 102, 115, 7589, 1, 0x0f01),
(17, 102, 116, 7620, 1, 0x0f01),
(17, 102, 117, 7618, 1, 0x0f01),
(17, 108, 118, 8922, 1, ''),
(17, 108, 119, 2187, 1, ''),
(18, 1, 101, 2498, 1, ''),
(18, 3, 102, 1988, 1, ''),
(18, 4, 103, 2656, 1, ''),
(18, 5, 104, 2520, 1, ''),
(18, 6, 105, 8920, 1, ''),
(18, 7, 106, 2647, 1, ''),
(18, 8, 107, 2195, 1, ''),
(18, 10, 108, 1987, 1, ''),
(18, 102, 109, 2268, 1, 0x0f01),
(18, 102, 110, 2273, 1, 0x0f01),
(18, 102, 111, 2305, 1, 0x0f01),
(18, 102, 112, 2261, 1, 0x0f01),
(18, 102, 113, 2293, 1, 0x0f01),
(18, 102, 114, 7590, 1, 0x0f01),
(18, 102, 115, 7589, 1, 0x0f01),
(18, 102, 116, 7620, 1, 0x0f01),
(18, 102, 117, 7618, 1, 0x0f01),
(18, 108, 118, 8922, 1, ''),
(18, 108, 119, 2187, 1, ''),
(19, 1, 101, 2498, 1, ''),
(19, 3, 102, 1988, 1, ''),
(19, 4, 103, 2656, 1, ''),
(19, 5, 104, 2520, 1, ''),
(19, 6, 105, 8920, 1, ''),
(19, 7, 106, 2647, 1, ''),
(19, 8, 107, 2195, 1, ''),
(19, 10, 108, 1987, 1, ''),
(19, 102, 109, 2268, 1, 0x0f01),
(19, 102, 110, 2273, 1, 0x0f01),
(19, 102, 111, 2305, 1, 0x0f01),
(19, 102, 112, 2261, 1, 0x0f01),
(19, 102, 113, 2293, 1, 0x0f01),
(19, 102, 114, 7590, 1, 0x0f01),
(19, 102, 115, 7589, 1, 0x0f01),
(19, 102, 116, 7620, 1, 0x0f01),
(19, 102, 117, 7618, 1, 0x0f01),
(19, 108, 118, 8922, 1, ''),
(19, 108, 119, 2187, 1, ''),
(20, 1, 101, 2498, 1, ''),
(20, 3, 102, 1988, 1, ''),
(20, 4, 103, 2656, 1, ''),
(20, 5, 104, 2520, 1, ''),
(20, 6, 105, 8920, 1, ''),
(20, 7, 106, 2647, 1, ''),
(20, 8, 107, 2195, 1, ''),
(20, 10, 108, 1987, 1, ''),
(20, 102, 109, 2268, 1, 0x0f01),
(20, 102, 110, 2273, 1, 0x0f01),
(20, 102, 111, 2305, 1, 0x0f01),
(20, 102, 112, 2261, 1, 0x0f01),
(20, 102, 113, 2293, 1, 0x0f01),
(20, 102, 114, 7590, 1, 0x0f01),
(20, 102, 115, 7589, 1, 0x0f01),
(20, 102, 116, 7620, 1, 0x0f01),
(20, 102, 117, 7618, 1, 0x0f01),
(20, 108, 118, 8922, 1, ''),
(20, 108, 119, 2187, 1, ''),
(21, 1, 101, 2498, 1, ''),
(21, 3, 102, 1988, 1, ''),
(21, 4, 103, 2656, 1, ''),
(21, 5, 104, 2520, 1, ''),
(21, 6, 105, 8920, 1, ''),
(21, 7, 106, 2647, 1, ''),
(21, 8, 107, 2195, 1, ''),
(21, 10, 108, 1987, 1, ''),
(21, 102, 109, 2268, 1, 0x0f01),
(21, 102, 110, 2273, 1, 0x0f01),
(21, 102, 111, 2305, 1, 0x0f01),
(21, 102, 112, 2261, 1, 0x0f01),
(21, 102, 113, 2293, 1, 0x0f01),
(21, 102, 114, 7590, 1, 0x0f01),
(21, 102, 115, 7589, 1, 0x0f01),
(21, 102, 116, 7620, 1, 0x0f01),
(21, 102, 117, 7618, 1, 0x0f01),
(21, 108, 118, 8922, 1, ''),
(21, 108, 119, 2187, 1, ''),
(22, 1, 101, 2498, 1, ''),
(22, 3, 102, 1988, 1, ''),
(22, 4, 103, 2656, 1, ''),
(22, 5, 104, 2520, 1, ''),
(22, 6, 105, 8920, 1, ''),
(22, 7, 106, 2647, 1, ''),
(22, 8, 107, 2195, 1, ''),
(22, 10, 108, 1987, 1, ''),
(22, 102, 109, 2268, 1, 0x0f01),
(22, 102, 110, 2273, 1, 0x0f01),
(22, 102, 111, 2305, 1, 0x0f01),
(22, 102, 112, 2261, 1, 0x0f01),
(22, 102, 113, 2293, 1, 0x0f01),
(22, 102, 114, 7590, 1, 0x0f01),
(22, 102, 115, 7589, 1, 0x0f01),
(22, 102, 116, 7620, 1, 0x0f01),
(22, 102, 117, 7618, 1, 0x0f01),
(22, 108, 118, 8922, 1, ''),
(22, 108, 119, 2187, 1, ''),
(23, 1, 101, 2498, 1, ''),
(23, 3, 102, 1988, 1, ''),
(23, 4, 103, 2656, 1, ''),
(23, 5, 104, 2520, 1, ''),
(23, 6, 105, 8920, 1, ''),
(23, 7, 106, 2647, 1, ''),
(23, 8, 107, 2195, 1, ''),
(23, 10, 108, 1987, 1, ''),
(23, 102, 109, 2268, 1, 0x0f01),
(23, 102, 110, 2273, 1, 0x0f01),
(23, 102, 111, 2305, 1, 0x0f01),
(23, 102, 112, 2261, 1, 0x0f01),
(23, 102, 113, 2293, 1, 0x0f01),
(23, 102, 114, 7590, 1, 0x0f01),
(23, 102, 115, 7589, 1, 0x0f01),
(23, 102, 116, 7620, 1, 0x0f01),
(23, 102, 117, 7618, 1, 0x0f01),
(23, 108, 118, 8922, 1, ''),
(23, 108, 119, 2187, 1, ''),
(24, 1, 101, 2498, 1, ''),
(24, 3, 102, 1988, 1, ''),
(24, 4, 103, 2656, 1, ''),
(24, 5, 104, 2520, 1, ''),
(24, 6, 105, 8920, 1, ''),
(24, 7, 106, 2647, 1, ''),
(24, 8, 107, 2195, 1, ''),
(24, 10, 108, 1987, 1, ''),
(24, 102, 109, 2268, 1, 0x0f01),
(24, 102, 110, 2273, 1, 0x0f01),
(24, 102, 111, 2305, 1, 0x0f01),
(24, 102, 112, 2261, 1, 0x0f01),
(24, 102, 113, 2293, 1, 0x0f01),
(24, 102, 114, 7590, 1, 0x0f01),
(24, 102, 115, 7589, 1, 0x0f01),
(24, 102, 116, 7620, 1, 0x0f01),
(24, 102, 117, 7618, 1, 0x0f01),
(24, 108, 118, 8922, 1, ''),
(24, 108, 119, 2187, 1, ''),
(25, 1, 101, 2498, 1, ''),
(25, 3, 102, 1988, 1, ''),
(25, 4, 103, 2656, 1, ''),
(25, 5, 104, 2520, 1, ''),
(25, 6, 105, 8920, 1, ''),
(25, 7, 106, 2647, 1, ''),
(25, 8, 107, 2195, 1, ''),
(25, 10, 108, 1987, 1, ''),
(25, 102, 109, 2268, 1, 0x0f01),
(25, 102, 110, 2273, 1, 0x0f01),
(25, 102, 111, 2305, 1, 0x0f01),
(25, 102, 112, 2261, 1, 0x0f01),
(25, 102, 113, 2293, 1, 0x0f01),
(25, 102, 114, 7590, 1, 0x0f01),
(25, 102, 115, 7589, 1, 0x0f01),
(25, 102, 116, 7620, 1, 0x0f01),
(25, 102, 117, 7618, 1, 0x0f01),
(25, 108, 118, 8922, 1, ''),
(25, 108, 119, 2187, 1, ''),
(26, 1, 101, 2498, 1, ''),
(26, 3, 102, 1988, 1, ''),
(26, 4, 103, 2656, 1, ''),
(26, 5, 104, 2520, 1, ''),
(26, 6, 105, 8920, 1, ''),
(26, 7, 106, 2647, 1, ''),
(26, 8, 107, 2195, 1, ''),
(26, 10, 108, 1987, 1, ''),
(26, 102, 109, 2268, 1, 0x0f01),
(26, 102, 110, 2273, 1, 0x0f01),
(26, 102, 111, 2305, 1, 0x0f01),
(26, 102, 112, 2261, 1, 0x0f01),
(26, 102, 113, 2293, 1, 0x0f01),
(26, 102, 114, 7590, 1, 0x0f01),
(26, 102, 115, 7589, 1, 0x0f01),
(26, 102, 116, 7620, 1, 0x0f01),
(26, 102, 117, 7618, 1, 0x0f01),
(26, 108, 118, 8922, 1, ''),
(26, 108, 119, 2187, 1, ''),
(27, 1, 101, 2498, 1, ''),
(27, 3, 102, 1988, 1, ''),
(27, 4, 103, 2656, 1, ''),
(27, 5, 104, 2520, 1, ''),
(27, 6, 105, 8920, 1, ''),
(27, 7, 106, 2647, 1, ''),
(27, 8, 107, 2195, 1, ''),
(27, 10, 108, 1987, 1, ''),
(27, 102, 109, 2268, 1, 0x0f01),
(27, 102, 110, 2273, 1, 0x0f01),
(27, 102, 111, 2305, 1, 0x0f01),
(27, 102, 112, 2261, 1, 0x0f01),
(27, 102, 113, 2293, 1, 0x0f01),
(27, 102, 114, 7590, 1, 0x0f01),
(27, 102, 115, 7589, 1, 0x0f01),
(27, 102, 116, 7620, 1, 0x0f01),
(27, 102, 117, 7618, 1, 0x0f01),
(27, 108, 118, 8922, 1, ''),
(27, 108, 119, 2187, 1, ''),
(28, 1, 101, 2498, 1, ''),
(28, 3, 102, 1988, 1, ''),
(28, 4, 103, 2656, 1, ''),
(28, 5, 104, 2520, 1, ''),
(28, 6, 105, 8920, 1, ''),
(28, 7, 106, 2647, 1, ''),
(28, 8, 107, 2195, 1, ''),
(28, 10, 108, 1987, 1, ''),
(28, 102, 109, 2268, 1, 0x0f01),
(28, 102, 110, 2273, 1, 0x0f01),
(28, 102, 111, 2305, 1, 0x0f01),
(28, 102, 112, 2261, 1, 0x0f01),
(28, 102, 113, 2293, 1, 0x0f01),
(28, 102, 114, 7590, 1, 0x0f01),
(28, 102, 115, 7589, 1, 0x0f01),
(28, 102, 116, 7620, 1, 0x0f01),
(28, 102, 117, 7618, 1, 0x0f01),
(28, 108, 118, 8922, 1, ''),
(28, 108, 119, 2187, 1, ''),
(29, 1, 101, 2498, 1, ''),
(29, 3, 102, 1988, 1, ''),
(29, 4, 103, 2656, 1, ''),
(29, 5, 104, 2520, 1, ''),
(29, 6, 105, 8920, 1, ''),
(29, 7, 106, 2647, 1, ''),
(29, 8, 107, 2195, 1, ''),
(29, 10, 108, 1987, 1, ''),
(29, 102, 109, 2268, 1, 0x0f01),
(29, 102, 110, 2273, 1, 0x0f01),
(29, 102, 111, 2305, 1, 0x0f01),
(29, 102, 112, 2261, 1, 0x0f01),
(29, 102, 113, 2293, 1, 0x0f01),
(29, 102, 114, 7590, 1, 0x0f01),
(29, 102, 115, 7589, 1, 0x0f01),
(29, 102, 116, 7620, 1, 0x0f01),
(29, 102, 117, 7618, 1, 0x0f01),
(29, 108, 118, 8922, 1, ''),
(29, 108, 119, 2187, 1, ''),
(30, 1, 101, 2498, 1, ''),
(30, 3, 102, 1988, 1, ''),
(30, 4, 103, 2656, 1, ''),
(30, 5, 104, 2520, 1, ''),
(30, 6, 105, 8920, 1, ''),
(30, 7, 106, 2647, 1, ''),
(30, 8, 107, 2195, 1, ''),
(30, 10, 108, 1987, 1, ''),
(30, 102, 109, 2268, 1, 0x0f01),
(30, 102, 110, 2273, 1, 0x0f01),
(30, 102, 111, 2305, 1, 0x0f01),
(30, 102, 112, 2261, 1, 0x0f01),
(30, 102, 113, 2293, 1, 0x0f01),
(30, 102, 114, 7590, 1, 0x0f01),
(30, 102, 115, 7589, 1, 0x0f01),
(30, 102, 116, 7620, 1, 0x0f01),
(30, 102, 117, 7618, 1, 0x0f01),
(30, 108, 118, 8922, 1, ''),
(30, 108, 119, 2187, 1, ''),
(31, 1, 101, 2498, 1, ''),
(31, 3, 102, 1988, 1, ''),
(31, 4, 103, 2656, 1, ''),
(31, 5, 104, 2520, 1, ''),
(31, 6, 105, 8920, 1, ''),
(31, 7, 106, 2647, 1, ''),
(31, 8, 107, 2195, 1, ''),
(31, 10, 108, 1987, 1, ''),
(31, 102, 109, 2268, 1, 0x0f01),
(31, 102, 110, 2273, 1, 0x0f01),
(31, 102, 111, 2305, 1, 0x0f01),
(31, 102, 112, 2261, 1, 0x0f01),
(31, 102, 113, 2293, 1, 0x0f01),
(31, 102, 114, 7590, 1, 0x0f01),
(31, 102, 115, 7589, 1, 0x0f01),
(31, 102, 116, 7620, 1, 0x0f01),
(31, 102, 117, 7618, 1, 0x0f01),
(31, 108, 118, 8922, 1, ''),
(31, 108, 119, 2187, 1, ''),
(32, 1, 101, 2498, 1, ''),
(32, 3, 102, 1988, 1, ''),
(32, 4, 103, 2656, 1, ''),
(32, 5, 104, 2520, 1, ''),
(32, 6, 105, 8920, 1, ''),
(32, 7, 106, 2647, 1, ''),
(32, 8, 107, 2195, 1, ''),
(32, 10, 108, 1987, 1, ''),
(32, 102, 109, 2268, 1, 0x0f01),
(32, 102, 110, 2273, 1, 0x0f01),
(32, 102, 111, 2305, 1, 0x0f01),
(32, 102, 112, 2261, 1, 0x0f01),
(32, 102, 113, 2293, 1, 0x0f01),
(32, 102, 114, 7590, 1, 0x0f01),
(32, 102, 115, 7589, 1, 0x0f01),
(32, 102, 116, 7620, 1, 0x0f01),
(32, 102, 117, 7618, 1, 0x0f01),
(32, 108, 118, 8922, 1, ''),
(32, 108, 119, 2187, 1, ''),
(33, 1, 101, 2498, 1, ''),
(33, 3, 102, 1988, 1, ''),
(33, 4, 103, 2656, 1, ''),
(33, 5, 104, 2520, 1, ''),
(33, 6, 105, 8920, 1, ''),
(33, 7, 106, 2647, 1, ''),
(33, 8, 107, 2195, 1, ''),
(33, 10, 108, 1987, 1, ''),
(33, 102, 109, 2268, 1, 0x0f01),
(33, 102, 110, 2273, 1, 0x0f01),
(33, 102, 111, 2305, 1, 0x0f01),
(33, 102, 112, 2261, 1, 0x0f01),
(33, 102, 113, 2293, 1, 0x0f01),
(33, 102, 114, 7590, 1, 0x0f01),
(33, 102, 115, 7589, 1, 0x0f01),
(33, 102, 116, 7620, 1, 0x0f01),
(33, 102, 117, 7618, 1, 0x0f01),
(33, 108, 118, 8922, 1, ''),
(33, 108, 119, 2187, 1, ''),
(34, 1, 101, 2498, 1, ''),
(34, 3, 102, 1988, 1, ''),
(34, 4, 103, 2656, 1, ''),
(34, 5, 104, 2520, 1, ''),
(34, 6, 105, 8920, 1, ''),
(34, 7, 106, 2647, 1, ''),
(34, 8, 107, 2195, 1, ''),
(34, 10, 108, 1987, 1, ''),
(34, 102, 109, 2268, 1, 0x0f01),
(34, 102, 110, 2273, 1, 0x0f01),
(34, 102, 111, 2305, 1, 0x0f01),
(34, 102, 112, 2261, 1, 0x0f01),
(34, 102, 113, 2293, 1, 0x0f01),
(34, 102, 114, 7590, 1, 0x0f01),
(34, 102, 115, 7589, 1, 0x0f01),
(34, 102, 116, 7620, 1, 0x0f01),
(34, 102, 117, 7618, 1, 0x0f01),
(34, 108, 118, 8922, 1, ''),
(34, 108, 119, 2187, 1, ''),
(35, 1, 101, 2498, 1, ''),
(35, 3, 102, 1988, 1, ''),
(35, 4, 103, 2656, 1, ''),
(35, 5, 104, 2520, 1, ''),
(35, 6, 105, 8920, 1, ''),
(35, 7, 106, 2647, 1, ''),
(35, 8, 107, 2195, 1, ''),
(35, 10, 108, 1987, 1, ''),
(35, 102, 109, 2268, 1, 0x0f01),
(35, 102, 110, 2273, 1, 0x0f01),
(35, 102, 111, 2305, 1, 0x0f01),
(35, 102, 112, 2261, 1, 0x0f01),
(35, 102, 113, 2293, 1, 0x0f01),
(35, 102, 114, 7590, 1, 0x0f01),
(35, 102, 115, 7589, 1, 0x0f01),
(35, 102, 116, 7620, 1, 0x0f01),
(35, 102, 117, 7618, 1, 0x0f01),
(35, 108, 118, 8922, 1, ''),
(35, 108, 119, 2187, 1, ''),
(36, 1, 101, 2498, 1, ''),
(36, 3, 102, 1988, 1, ''),
(36, 4, 103, 2656, 1, ''),
(36, 5, 104, 2520, 1, ''),
(36, 6, 105, 8920, 1, ''),
(36, 7, 106, 2647, 1, ''),
(36, 8, 107, 2195, 1, ''),
(36, 10, 108, 1987, 1, ''),
(36, 102, 109, 2268, 1, 0x0f01),
(36, 102, 110, 2273, 1, 0x0f01),
(36, 102, 111, 2305, 1, 0x0f01),
(36, 102, 112, 2261, 1, 0x0f01),
(36, 102, 113, 2293, 1, 0x0f01),
(36, 102, 114, 7590, 1, 0x0f01),
(36, 102, 115, 7589, 1, 0x0f01),
(36, 102, 116, 7620, 1, 0x0f01),
(36, 102, 117, 7618, 1, 0x0f01),
(36, 108, 118, 8922, 1, ''),
(36, 108, 119, 2187, 1, ''),
(37, 1, 101, 2498, 1, ''),
(37, 3, 102, 1988, 1, ''),
(37, 4, 103, 2656, 1, ''),
(37, 5, 104, 2520, 1, ''),
(37, 6, 105, 8920, 1, ''),
(37, 7, 106, 2647, 1, ''),
(37, 8, 107, 2195, 1, ''),
(37, 10, 108, 1987, 1, ''),
(37, 102, 109, 2268, 1, 0x0f01),
(37, 102, 110, 2273, 1, 0x0f01),
(37, 102, 111, 2305, 1, 0x0f01),
(37, 102, 112, 2261, 1, 0x0f01),
(37, 102, 113, 2293, 1, 0x0f01),
(37, 102, 114, 7590, 1, 0x0f01),
(37, 102, 115, 7589, 1, 0x0f01),
(37, 102, 116, 7620, 1, 0x0f01),
(37, 102, 117, 7618, 1, 0x0f01),
(37, 108, 118, 8922, 1, ''),
(37, 108, 119, 2187, 1, ''),
(38, 1, 101, 2498, 1, ''),
(38, 3, 102, 1988, 1, ''),
(38, 4, 103, 2656, 1, ''),
(38, 5, 104, 2520, 1, ''),
(38, 6, 105, 8920, 1, ''),
(38, 7, 106, 2647, 1, ''),
(38, 8, 107, 2195, 1, ''),
(38, 10, 108, 1987, 1, ''),
(38, 102, 109, 2268, 1, 0x0f01),
(38, 102, 110, 2273, 1, 0x0f01),
(38, 102, 111, 2305, 1, 0x0f01),
(38, 102, 112, 2261, 1, 0x0f01),
(38, 102, 113, 2293, 1, 0x0f01),
(38, 102, 114, 7590, 1, 0x0f01),
(38, 102, 115, 7589, 1, 0x0f01),
(38, 102, 116, 7620, 1, 0x0f01),
(38, 102, 117, 7618, 1, 0x0f01),
(38, 108, 118, 8922, 1, ''),
(38, 108, 119, 2187, 1, ''),
(39, 1, 101, 2498, 1, ''),
(39, 3, 102, 1988, 1, ''),
(39, 4, 103, 2656, 1, ''),
(39, 5, 104, 2520, 1, ''),
(39, 6, 105, 8920, 1, ''),
(39, 7, 106, 2647, 1, ''),
(39, 8, 107, 2195, 1, ''),
(39, 10, 108, 1987, 1, ''),
(39, 102, 109, 2268, 1, 0x0f01),
(39, 102, 110, 2273, 1, 0x0f01),
(39, 102, 111, 2305, 1, 0x0f01),
(39, 102, 112, 2261, 1, 0x0f01),
(39, 102, 113, 2293, 1, 0x0f01),
(39, 102, 114, 7590, 1, 0x0f01),
(39, 102, 115, 7589, 1, 0x0f01),
(39, 102, 116, 7620, 1, 0x0f01),
(39, 102, 117, 7618, 1, 0x0f01),
(39, 108, 118, 8922, 1, ''),
(39, 108, 119, 2187, 1, ''),
(40, 1, 101, 2498, 1, ''),
(40, 3, 102, 1988, 1, ''),
(40, 4, 103, 2656, 1, ''),
(40, 5, 104, 2520, 1, ''),
(40, 6, 105, 8920, 1, ''),
(40, 7, 106, 2647, 1, ''),
(40, 8, 107, 2195, 1, ''),
(40, 10, 108, 1987, 1, ''),
(40, 102, 109, 2268, 1, 0x0f01),
(40, 102, 110, 2273, 1, 0x0f01),
(40, 102, 111, 2305, 1, 0x0f01),
(40, 102, 112, 2261, 1, 0x0f01),
(40, 102, 113, 2293, 1, 0x0f01),
(40, 102, 114, 7590, 1, 0x0f01),
(40, 102, 115, 7589, 1, 0x0f01),
(40, 102, 116, 7620, 1, 0x0f01),
(40, 102, 117, 7618, 1, 0x0f01),
(40, 108, 118, 8922, 1, ''),
(40, 108, 119, 2187, 1, ''),
(41, 1, 101, 2498, 1, ''),
(41, 3, 102, 1988, 1, ''),
(41, 4, 103, 2656, 1, ''),
(41, 5, 104, 2520, 1, ''),
(41, 6, 105, 8920, 1, ''),
(41, 7, 106, 2647, 1, ''),
(41, 8, 107, 2195, 1, ''),
(41, 10, 108, 1987, 1, ''),
(41, 102, 109, 2268, 1, 0x0f01),
(41, 102, 110, 2273, 1, 0x0f01),
(41, 102, 111, 2305, 1, 0x0f01),
(41, 102, 112, 2261, 1, 0x0f01),
(41, 102, 113, 2293, 1, 0x0f01),
(41, 102, 114, 7590, 1, 0x0f01),
(41, 102, 115, 7589, 1, 0x0f01),
(41, 102, 116, 7620, 1, 0x0f01),
(41, 102, 117, 7618, 1, 0x0f01),
(41, 108, 118, 8922, 1, ''),
(41, 108, 119, 2187, 1, ''),
(42, 1, 101, 2498, 1, ''),
(42, 3, 102, 1988, 1, ''),
(42, 4, 103, 2656, 1, ''),
(42, 5, 104, 2520, 1, ''),
(42, 6, 105, 8920, 1, ''),
(42, 7, 106, 2647, 1, ''),
(42, 8, 107, 2195, 1, ''),
(42, 10, 108, 1987, 1, ''),
(42, 102, 109, 2268, 1, 0x0f01),
(42, 102, 110, 2273, 1, 0x0f01),
(42, 102, 111, 2305, 1, 0x0f01),
(42, 102, 112, 2261, 1, 0x0f01),
(42, 102, 113, 2293, 1, 0x0f01),
(42, 102, 114, 7590, 1, 0x0f01),
(42, 102, 115, 7589, 1, 0x0f01),
(42, 102, 116, 7620, 1, 0x0f01),
(42, 102, 117, 7618, 1, 0x0f01),
(42, 108, 118, 8922, 1, ''),
(42, 108, 119, 2187, 1, ''),
(43, 1, 101, 2498, 1, ''),
(43, 3, 102, 1988, 1, ''),
(43, 4, 103, 2656, 1, ''),
(43, 5, 104, 2520, 1, ''),
(43, 6, 105, 8920, 1, ''),
(43, 7, 106, 2647, 1, ''),
(43, 8, 107, 2195, 1, ''),
(43, 10, 108, 1987, 1, ''),
(43, 102, 109, 2268, 1, 0x0f01),
(43, 102, 110, 2273, 1, 0x0f01),
(43, 102, 111, 2305, 1, 0x0f01),
(43, 102, 112, 2261, 1, 0x0f01),
(43, 102, 113, 2293, 1, 0x0f01),
(43, 102, 114, 7590, 1, 0x0f01),
(43, 102, 115, 7589, 1, 0x0f01),
(43, 102, 116, 7620, 1, 0x0f01),
(43, 102, 117, 7618, 1, 0x0f01),
(43, 108, 118, 8922, 1, ''),
(43, 108, 119, 2187, 1, ''),
(44, 1, 101, 2498, 1, ''),
(44, 3, 102, 1988, 1, ''),
(44, 4, 103, 2656, 1, ''),
(44, 5, 104, 2520, 1, ''),
(44, 6, 105, 8920, 1, ''),
(44, 7, 106, 2647, 1, ''),
(44, 8, 107, 2195, 1, ''),
(44, 10, 108, 1987, 1, ''),
(44, 102, 109, 2268, 1, 0x0f01),
(44, 102, 110, 2273, 1, 0x0f01),
(44, 102, 111, 2305, 1, 0x0f01),
(44, 102, 112, 2261, 1, 0x0f01),
(44, 102, 113, 2293, 1, 0x0f01),
(44, 102, 114, 7590, 1, 0x0f01),
(44, 102, 115, 7589, 1, 0x0f01),
(44, 102, 116, 7620, 1, 0x0f01),
(44, 102, 117, 7618, 1, 0x0f01),
(44, 108, 118, 8922, 1, ''),
(44, 108, 119, 2187, 1, ''),
(45, 1, 101, 2498, 1, ''),
(45, 3, 102, 1988, 1, ''),
(45, 4, 103, 2656, 1, ''),
(45, 5, 104, 2520, 1, ''),
(45, 6, 105, 8920, 1, ''),
(45, 7, 106, 2647, 1, ''),
(45, 8, 107, 2195, 1, ''),
(45, 10, 108, 1987, 1, ''),
(45, 102, 109, 2268, 1, 0x0f01),
(45, 102, 110, 2273, 1, 0x0f01),
(45, 102, 111, 2305, 1, 0x0f01),
(45, 102, 112, 2261, 1, 0x0f01),
(45, 102, 113, 2293, 1, 0x0f01),
(45, 102, 114, 7590, 1, 0x0f01),
(45, 102, 115, 7589, 1, 0x0f01),
(45, 102, 116, 7620, 1, 0x0f01),
(45, 102, 117, 7618, 1, 0x0f01),
(45, 108, 118, 8922, 1, ''),
(45, 108, 119, 2187, 1, ''),
(46, 1, 101, 2498, 1, ''),
(46, 3, 102, 1988, 1, ''),
(46, 4, 103, 2656, 1, ''),
(46, 5, 104, 2520, 1, ''),
(46, 6, 105, 8920, 1, ''),
(46, 7, 106, 2647, 1, ''),
(46, 8, 107, 2195, 1, ''),
(46, 10, 108, 1987, 1, ''),
(46, 102, 109, 2268, 1, 0x0f01),
(46, 102, 110, 2273, 1, 0x0f01),
(46, 102, 111, 2305, 1, 0x0f01),
(46, 102, 112, 2261, 1, 0x0f01),
(46, 102, 113, 2293, 1, 0x0f01),
(46, 102, 114, 7590, 1, 0x0f01),
(46, 102, 115, 7589, 1, 0x0f01),
(46, 102, 116, 7620, 1, 0x0f01),
(46, 102, 117, 7618, 1, 0x0f01),
(46, 108, 118, 8922, 1, ''),
(46, 108, 119, 2187, 1, ''),
(47, 1, 101, 2498, 1, ''),
(47, 3, 102, 1988, 1, ''),
(47, 4, 103, 2656, 1, ''),
(47, 5, 104, 2520, 1, ''),
(47, 6, 105, 8920, 1, ''),
(47, 7, 106, 2647, 1, ''),
(47, 8, 107, 2195, 1, ''),
(47, 10, 108, 1987, 1, ''),
(47, 102, 109, 2268, 1, 0x0f01),
(47, 102, 110, 2273, 1, 0x0f01),
(47, 102, 111, 2305, 1, 0x0f01),
(47, 102, 112, 2261, 1, 0x0f01),
(47, 102, 113, 2293, 1, 0x0f01),
(47, 102, 114, 7590, 1, 0x0f01),
(47, 102, 115, 7589, 1, 0x0f01),
(47, 102, 116, 7620, 1, 0x0f01),
(47, 102, 117, 7618, 1, 0x0f01),
(47, 108, 118, 8922, 1, ''),
(47, 108, 119, 2187, 1, ''),
(48, 1, 101, 2498, 1, ''),
(48, 3, 102, 1988, 1, ''),
(48, 4, 103, 2656, 1, ''),
(48, 5, 104, 2520, 1, ''),
(48, 6, 105, 8920, 1, ''),
(48, 7, 106, 2647, 1, ''),
(48, 8, 107, 2195, 1, ''),
(48, 10, 108, 1987, 1, ''),
(48, 102, 109, 2268, 1, 0x0f01),
(48, 102, 110, 2273, 1, 0x0f01),
(48, 102, 111, 2305, 1, 0x0f01),
(48, 102, 112, 2261, 1, 0x0f01),
(48, 102, 113, 2293, 1, 0x0f01),
(48, 102, 114, 7590, 1, 0x0f01),
(48, 102, 115, 7589, 1, 0x0f01),
(48, 102, 116, 7620, 1, 0x0f01),
(48, 102, 117, 7618, 1, 0x0f01),
(48, 108, 118, 8922, 1, ''),
(48, 108, 119, 2187, 1, ''),
(49, 1, 101, 2498, 1, ''),
(49, 3, 102, 1988, 1, ''),
(49, 4, 103, 2656, 1, ''),
(49, 5, 104, 2520, 1, ''),
(49, 6, 105, 8920, 1, ''),
(49, 7, 106, 2647, 1, ''),
(49, 8, 107, 2195, 1, ''),
(49, 10, 108, 1987, 1, ''),
(49, 102, 109, 2268, 1, 0x0f01),
(49, 102, 110, 2273, 1, 0x0f01),
(49, 102, 111, 2305, 1, 0x0f01),
(49, 102, 112, 2261, 1, 0x0f01),
(49, 102, 113, 2293, 1, 0x0f01),
(49, 102, 114, 7590, 1, 0x0f01),
(49, 102, 115, 7589, 1, 0x0f01),
(49, 102, 116, 7620, 1, 0x0f01),
(49, 102, 117, 7618, 1, 0x0f01),
(49, 108, 118, 8922, 1, ''),
(49, 108, 119, 2187, 1, ''),
(50, 1, 101, 2498, 1, ''),
(50, 3, 102, 1988, 1, ''),
(50, 4, 103, 2656, 1, ''),
(50, 5, 104, 2520, 1, ''),
(50, 6, 105, 8920, 1, ''),
(50, 7, 106, 2647, 1, ''),
(50, 8, 107, 2195, 1, ''),
(50, 10, 108, 1987, 1, ''),
(50, 102, 109, 2268, 1, 0x0f01),
(50, 102, 110, 2273, 1, 0x0f01),
(50, 102, 111, 2305, 1, 0x0f01),
(50, 102, 112, 2261, 1, 0x0f01),
(50, 102, 113, 2293, 1, 0x0f01),
(50, 102, 114, 7590, 1, 0x0f01),
(50, 102, 115, 7589, 1, 0x0f01),
(50, 102, 116, 7620, 1, 0x0f01),
(50, 102, 117, 7618, 1, 0x0f01),
(50, 108, 118, 8922, 1, ''),
(50, 108, 119, 2187, 1, ''),
(51, 1, 101, 2498, 1, ''),
(51, 3, 102, 1988, 1, ''),
(51, 4, 103, 2656, 1, ''),
(51, 5, 104, 2520, 1, ''),
(51, 6, 105, 8920, 1, ''),
(51, 7, 106, 2647, 1, ''),
(51, 8, 107, 2195, 1, ''),
(51, 10, 108, 1987, 1, ''),
(51, 102, 109, 2268, 1, 0x0f01),
(51, 102, 110, 2273, 1, 0x0f01),
(51, 102, 111, 2305, 1, 0x0f01),
(51, 102, 112, 2261, 1, 0x0f01),
(51, 102, 113, 2293, 1, 0x0f01),
(51, 102, 114, 7590, 1, 0x0f01),
(51, 102, 115, 7589, 1, 0x0f01),
(51, 102, 116, 7620, 1, 0x0f01),
(51, 102, 117, 7618, 1, 0x0f01),
(51, 108, 118, 8922, 1, ''),
(51, 108, 119, 2187, 1, ''),
(52, 1, 101, 2498, 1, ''),
(52, 3, 102, 1988, 1, ''),
(52, 4, 103, 2656, 1, ''),
(52, 5, 104, 2520, 1, ''),
(52, 6, 105, 8920, 1, ''),
(52, 7, 106, 2647, 1, ''),
(52, 8, 107, 2195, 1, ''),
(52, 10, 108, 1987, 1, ''),
(52, 102, 109, 2268, 1, 0x0f01),
(52, 102, 110, 2273, 1, 0x0f01),
(52, 102, 111, 2305, 1, 0x0f01),
(52, 102, 112, 2261, 1, 0x0f01),
(52, 102, 113, 2293, 1, 0x0f01),
(52, 102, 114, 7590, 1, 0x0f01),
(52, 102, 115, 7589, 1, 0x0f01),
(52, 102, 116, 7620, 1, 0x0f01),
(52, 102, 117, 7618, 1, 0x0f01),
(52, 108, 118, 8922, 1, ''),
(52, 108, 119, 2187, 1, ''),
(53, 1, 101, 2498, 1, ''),
(53, 3, 102, 1988, 1, ''),
(53, 4, 103, 2656, 1, ''),
(53, 5, 104, 2520, 1, ''),
(53, 6, 105, 8920, 1, ''),
(53, 7, 106, 2647, 1, ''),
(53, 8, 107, 2195, 1, ''),
(53, 10, 108, 1987, 1, ''),
(53, 102, 109, 2268, 1, 0x0f01),
(53, 102, 110, 2273, 1, 0x0f01),
(53, 102, 111, 2305, 1, 0x0f01),
(53, 102, 112, 2261, 1, 0x0f01),
(53, 102, 113, 2293, 1, 0x0f01),
(53, 102, 114, 7590, 1, 0x0f01),
(53, 102, 115, 7589, 1, 0x0f01),
(53, 102, 116, 7620, 1, 0x0f01),
(53, 102, 117, 7618, 1, 0x0f01),
(53, 108, 118, 8922, 1, ''),
(53, 108, 119, 2187, 1, ''),
(54, 1, 101, 2498, 1, ''),
(54, 3, 102, 1988, 1, ''),
(54, 4, 103, 2656, 1, ''),
(54, 5, 104, 2520, 1, ''),
(54, 6, 105, 8920, 1, ''),
(54, 7, 106, 2647, 1, ''),
(54, 8, 107, 2195, 1, ''),
(54, 10, 108, 1987, 1, ''),
(54, 102, 109, 2268, 1, 0x0f01),
(54, 102, 110, 2273, 1, 0x0f01),
(54, 102, 111, 2305, 1, 0x0f01),
(54, 102, 112, 2261, 1, 0x0f01),
(54, 102, 113, 2293, 1, 0x0f01),
(54, 102, 114, 7590, 1, 0x0f01),
(54, 102, 115, 7589, 1, 0x0f01),
(54, 102, 116, 7620, 1, 0x0f01),
(54, 102, 117, 7618, 1, 0x0f01),
(54, 108, 118, 8922, 1, ''),
(54, 108, 119, 2187, 1, ''),
(55, 1, 101, 2498, 1, ''),
(55, 3, 102, 1988, 1, ''),
(55, 4, 103, 2656, 1, ''),
(55, 5, 104, 2520, 1, ''),
(55, 6, 105, 8920, 1, ''),
(55, 7, 106, 2647, 1, ''),
(55, 8, 107, 2195, 1, ''),
(55, 10, 108, 1987, 1, ''),
(55, 102, 109, 2268, 1, 0x0f01),
(55, 102, 110, 2273, 1, 0x0f01),
(55, 102, 111, 2305, 1, 0x0f01),
(55, 102, 112, 2261, 1, 0x0f01),
(55, 102, 113, 2293, 1, 0x0f01),
(55, 102, 114, 7590, 1, 0x0f01),
(55, 102, 115, 7589, 1, 0x0f01),
(55, 102, 116, 7620, 1, 0x0f01),
(55, 102, 117, 7618, 1, 0x0f01),
(55, 108, 118, 8922, 1, ''),
(55, 108, 119, 2187, 1, ''),
(56, 1, 101, 2498, 1, ''),
(56, 3, 102, 1988, 1, ''),
(56, 4, 103, 2656, 1, ''),
(56, 5, 104, 2520, 1, ''),
(56, 6, 105, 8920, 1, ''),
(56, 7, 106, 2647, 1, ''),
(56, 8, 107, 2195, 1, ''),
(56, 10, 108, 1987, 1, ''),
(56, 102, 109, 2268, 1, 0x0f01),
(56, 102, 110, 2273, 1, 0x0f01),
(56, 102, 111, 2305, 1, 0x0f01),
(56, 102, 112, 2261, 1, 0x0f01),
(56, 102, 113, 2293, 1, 0x0f01),
(56, 102, 114, 7590, 1, 0x0f01),
(56, 102, 115, 7589, 1, 0x0f01),
(56, 102, 116, 7620, 1, 0x0f01),
(56, 102, 117, 7618, 1, 0x0f01),
(56, 108, 118, 8922, 1, ''),
(56, 108, 119, 2187, 1, ''),
(57, 1, 101, 2498, 1, ''),
(57, 3, 102, 1988, 1, ''),
(57, 4, 103, 2656, 1, ''),
(57, 5, 104, 2520, 1, ''),
(57, 6, 105, 8920, 1, ''),
(57, 7, 106, 2647, 1, ''),
(57, 8, 107, 2195, 1, ''),
(57, 10, 108, 1987, 1, ''),
(57, 102, 109, 2268, 1, 0x0f01),
(57, 102, 110, 2273, 1, 0x0f01),
(57, 102, 111, 2305, 1, 0x0f01),
(57, 102, 112, 2261, 1, 0x0f01),
(57, 102, 113, 2293, 1, 0x0f01),
(57, 102, 114, 7590, 1, 0x0f01),
(57, 102, 115, 7589, 1, 0x0f01),
(57, 102, 116, 7620, 1, 0x0f01),
(57, 102, 117, 7618, 1, 0x0f01),
(57, 108, 118, 8922, 1, ''),
(57, 108, 119, 2187, 1, ''),
(58, 1, 101, 2498, 1, ''),
(58, 3, 102, 1988, 1, ''),
(58, 4, 103, 2656, 1, ''),
(58, 5, 104, 2520, 1, ''),
(58, 6, 105, 8920, 1, ''),
(58, 7, 106, 2647, 1, ''),
(58, 8, 107, 2195, 1, ''),
(58, 10, 108, 1987, 1, ''),
(58, 102, 109, 2268, 1, 0x0f01),
(58, 102, 110, 2273, 1, 0x0f01),
(58, 102, 111, 2305, 1, 0x0f01),
(58, 102, 112, 2261, 1, 0x0f01),
(58, 102, 113, 2293, 1, 0x0f01),
(58, 102, 114, 7590, 1, 0x0f01),
(58, 102, 115, 7589, 1, 0x0f01),
(58, 102, 116, 7620, 1, 0x0f01),
(58, 102, 117, 7618, 1, 0x0f01),
(58, 108, 118, 8922, 1, ''),
(58, 108, 119, 2187, 1, ''),
(59, 1, 101, 2498, 1, ''),
(59, 3, 102, 1988, 1, ''),
(59, 4, 103, 2656, 1, ''),
(59, 5, 104, 2520, 1, ''),
(59, 6, 105, 8920, 1, ''),
(59, 7, 106, 2647, 1, ''),
(59, 8, 107, 2195, 1, ''),
(59, 10, 108, 1987, 1, ''),
(59, 102, 109, 2268, 1, 0x0f01),
(59, 102, 110, 2273, 1, 0x0f01),
(59, 102, 111, 2305, 1, 0x0f01),
(59, 102, 112, 2261, 1, 0x0f01),
(59, 102, 113, 2293, 1, 0x0f01),
(59, 102, 114, 7590, 1, 0x0f01),
(59, 102, 115, 7589, 1, 0x0f01),
(59, 102, 116, 7620, 1, 0x0f01),
(59, 102, 117, 7618, 1, 0x0f01),
(59, 108, 118, 8922, 1, ''),
(59, 108, 119, 2187, 1, ''),
(60, 1, 101, 2498, 1, ''),
(60, 3, 102, 1988, 1, ''),
(60, 4, 103, 2656, 1, ''),
(60, 5, 104, 2520, 1, ''),
(60, 6, 105, 8920, 1, ''),
(60, 7, 106, 2647, 1, ''),
(60, 8, 107, 2195, 1, ''),
(60, 10, 108, 1987, 1, ''),
(60, 102, 109, 2268, 1, 0x0f01),
(60, 102, 110, 2273, 1, 0x0f01),
(60, 102, 111, 2305, 1, 0x0f01),
(60, 102, 112, 2261, 1, 0x0f01),
(60, 102, 113, 2293, 1, 0x0f01),
(60, 102, 114, 7590, 1, 0x0f01),
(60, 102, 115, 7589, 1, 0x0f01),
(60, 102, 116, 7620, 1, 0x0f01),
(60, 102, 117, 7618, 1, 0x0f01),
(60, 108, 118, 8922, 1, ''),
(60, 108, 119, 2187, 1, ''),
(61, 1, 101, 2498, 1, ''),
(61, 3, 102, 1988, 1, ''),
(61, 4, 103, 2656, 1, ''),
(61, 5, 104, 2520, 1, ''),
(61, 6, 105, 8920, 1, ''),
(61, 7, 106, 2647, 1, ''),
(61, 8, 107, 2195, 1, ''),
(61, 10, 108, 1987, 1, ''),
(61, 102, 109, 2268, 1, 0x0f01),
(61, 102, 110, 2273, 1, 0x0f01),
(61, 102, 111, 2305, 1, 0x0f01),
(61, 102, 112, 2261, 1, 0x0f01),
(61, 102, 113, 2293, 1, 0x0f01),
(61, 102, 114, 7590, 1, 0x0f01),
(61, 102, 115, 7589, 1, 0x0f01),
(61, 102, 116, 7620, 1, 0x0f01),
(61, 102, 117, 7618, 1, 0x0f01),
(61, 108, 118, 8922, 1, ''),
(61, 108, 119, 2187, 1, ''),
(62, 1, 101, 2498, 1, ''),
(62, 3, 102, 1988, 1, ''),
(62, 4, 103, 2656, 1, ''),
(62, 5, 104, 2520, 1, ''),
(62, 6, 105, 8920, 1, ''),
(62, 7, 106, 2647, 1, ''),
(62, 8, 107, 2195, 1, ''),
(62, 10, 108, 1987, 1, ''),
(62, 102, 109, 2268, 1, 0x0f01),
(62, 102, 110, 2273, 1, 0x0f01),
(62, 102, 111, 2305, 1, 0x0f01),
(62, 102, 112, 2261, 1, 0x0f01),
(62, 102, 113, 2293, 1, 0x0f01),
(62, 102, 114, 7590, 1, 0x0f01),
(62, 102, 115, 7589, 1, 0x0f01),
(62, 102, 116, 7620, 1, 0x0f01),
(62, 102, 117, 7618, 1, 0x0f01),
(62, 108, 118, 8922, 1, ''),
(62, 108, 119, 2187, 1, ''),
(63, 1, 101, 2498, 1, ''),
(63, 3, 102, 1988, 1, ''),
(63, 4, 103, 2656, 1, ''),
(63, 5, 104, 2520, 1, ''),
(63, 6, 105, 8920, 1, ''),
(63, 7, 106, 2647, 1, ''),
(63, 8, 107, 2195, 1, ''),
(63, 10, 108, 1987, 1, ''),
(63, 102, 109, 2268, 1, 0x0f01),
(63, 102, 110, 2273, 1, 0x0f01),
(63, 102, 111, 2305, 1, 0x0f01),
(63, 102, 112, 2261, 1, 0x0f01),
(63, 102, 113, 2293, 1, 0x0f01),
(63, 102, 114, 7590, 1, 0x0f01),
(63, 102, 115, 7589, 1, 0x0f01),
(63, 102, 116, 7620, 1, 0x0f01),
(63, 102, 117, 7618, 1, 0x0f01),
(63, 108, 118, 8922, 1, ''),
(63, 108, 119, 2187, 1, ''),
(64, 1, 101, 2498, 1, ''),
(64, 3, 102, 1988, 1, ''),
(64, 4, 103, 2656, 1, ''),
(64, 5, 104, 2520, 1, ''),
(64, 6, 105, 8920, 1, ''),
(64, 7, 106, 2647, 1, ''),
(64, 8, 107, 2195, 1, ''),
(64, 10, 108, 1987, 1, ''),
(64, 102, 109, 2268, 1, 0x0f01),
(64, 102, 110, 2273, 1, 0x0f01),
(64, 102, 111, 2305, 1, 0x0f01),
(64, 102, 112, 2261, 1, 0x0f01),
(64, 102, 113, 2293, 1, 0x0f01),
(64, 102, 114, 7590, 1, 0x0f01),
(64, 102, 115, 7589, 1, 0x0f01),
(64, 102, 116, 7620, 1, 0x0f01),
(64, 102, 117, 7618, 1, 0x0f01),
(64, 108, 118, 8922, 1, ''),
(64, 108, 119, 2187, 1, ''),
(65, 1, 101, 2498, 1, ''),
(65, 3, 102, 1988, 1, ''),
(65, 4, 103, 2656, 1, ''),
(65, 5, 104, 2520, 1, ''),
(65, 6, 105, 8920, 1, ''),
(65, 7, 106, 2647, 1, ''),
(65, 8, 107, 2195, 1, ''),
(65, 10, 108, 1987, 1, ''),
(65, 102, 109, 2268, 1, 0x0f01),
(65, 102, 110, 2273, 1, 0x0f01),
(65, 102, 111, 2305, 1, 0x0f01),
(65, 102, 112, 2261, 1, 0x0f01),
(65, 102, 113, 2293, 1, 0x0f01),
(65, 102, 114, 7590, 1, 0x0f01),
(65, 102, 115, 7589, 1, 0x0f01),
(65, 102, 116, 7620, 1, 0x0f01),
(65, 102, 117, 7618, 1, 0x0f01),
(65, 108, 118, 8922, 1, ''),
(65, 108, 119, 2187, 1, ''),
(66, 1, 101, 2498, 1, ''),
(66, 3, 102, 1988, 1, ''),
(66, 4, 103, 2656, 1, ''),
(66, 5, 104, 2520, 1, ''),
(66, 6, 105, 8920, 1, ''),
(66, 7, 106, 2647, 1, ''),
(66, 8, 107, 2195, 1, ''),
(66, 10, 108, 1987, 1, ''),
(66, 102, 109, 2268, 1, 0x0f01),
(66, 102, 110, 2273, 1, 0x0f01),
(66, 102, 111, 2305, 1, 0x0f01),
(66, 102, 112, 2261, 1, 0x0f01),
(66, 102, 113, 2293, 1, 0x0f01),
(66, 102, 114, 7590, 1, 0x0f01),
(66, 102, 115, 7589, 1, 0x0f01),
(66, 102, 116, 7620, 1, 0x0f01),
(66, 102, 117, 7618, 1, 0x0f01),
(66, 108, 118, 8922, 1, ''),
(66, 108, 119, 2187, 1, ''),
(67, 1, 101, 2498, 1, ''),
(67, 3, 102, 1988, 1, ''),
(67, 4, 103, 2656, 1, ''),
(67, 5, 104, 2520, 1, ''),
(67, 6, 105, 8920, 1, ''),
(67, 7, 106, 2647, 1, ''),
(67, 8, 107, 2195, 1, ''),
(67, 10, 108, 1987, 1, ''),
(67, 102, 109, 2268, 1, 0x0f01),
(67, 102, 110, 2273, 1, 0x0f01),
(67, 102, 111, 2305, 1, 0x0f01),
(67, 102, 112, 2261, 1, 0x0f01),
(67, 102, 113, 2293, 1, 0x0f01),
(67, 102, 114, 7590, 1, 0x0f01),
(67, 102, 115, 7589, 1, 0x0f01),
(67, 102, 116, 7620, 1, 0x0f01),
(67, 102, 117, 7618, 1, 0x0f01),
(67, 108, 118, 8922, 1, ''),
(67, 108, 119, 2187, 1, ''),
(68, 1, 101, 2498, 1, ''),
(68, 3, 102, 1988, 1, ''),
(68, 4, 103, 2656, 1, ''),
(68, 5, 104, 2520, 1, ''),
(68, 6, 105, 8920, 1, ''),
(68, 7, 106, 2647, 1, ''),
(68, 8, 107, 2195, 1, ''),
(68, 10, 108, 1987, 1, ''),
(68, 102, 109, 2268, 1, 0x0f01),
(68, 102, 110, 2273, 1, 0x0f01),
(68, 102, 111, 2305, 1, 0x0f01),
(68, 102, 112, 2261, 1, 0x0f01),
(68, 102, 113, 2293, 1, 0x0f01),
(68, 102, 114, 7590, 1, 0x0f01),
(68, 102, 115, 7589, 1, 0x0f01),
(68, 102, 116, 7620, 1, 0x0f01),
(68, 102, 117, 7618, 1, 0x0f01),
(68, 108, 118, 8922, 1, ''),
(68, 108, 119, 2187, 1, ''),
(69, 1, 101, 2498, 1, ''),
(69, 3, 102, 1988, 1, ''),
(69, 4, 103, 2656, 1, ''),
(69, 5, 104, 2520, 1, ''),
(69, 6, 105, 8920, 1, ''),
(69, 7, 106, 2647, 1, ''),
(69, 8, 107, 2195, 1, ''),
(69, 10, 108, 1987, 1, ''),
(69, 102, 109, 2268, 1, 0x0f01),
(69, 102, 110, 2273, 1, 0x0f01),
(69, 102, 111, 2305, 1, 0x0f01),
(69, 102, 112, 2261, 1, 0x0f01),
(69, 102, 113, 2293, 1, 0x0f01),
(69, 102, 114, 7590, 1, 0x0f01),
(69, 102, 115, 7589, 1, 0x0f01),
(69, 102, 116, 7620, 1, 0x0f01),
(69, 102, 117, 7618, 1, 0x0f01),
(69, 108, 118, 8922, 1, ''),
(69, 108, 119, 2187, 1, ''),
(70, 1, 101, 2498, 1, ''),
(70, 3, 102, 1988, 1, ''),
(70, 4, 103, 2656, 1, ''),
(70, 5, 104, 2520, 1, ''),
(70, 6, 105, 8920, 1, ''),
(70, 7, 106, 2647, 1, ''),
(70, 8, 107, 2195, 1, ''),
(70, 10, 108, 1987, 1, ''),
(70, 102, 109, 2268, 1, 0x0f01),
(70, 102, 110, 2273, 1, 0x0f01),
(70, 102, 111, 2305, 1, 0x0f01),
(70, 102, 112, 2261, 1, 0x0f01),
(70, 102, 113, 2293, 1, 0x0f01),
(70, 102, 114, 7590, 1, 0x0f01),
(70, 102, 115, 7589, 1, 0x0f01),
(70, 102, 116, 7620, 1, 0x0f01),
(70, 102, 117, 7618, 1, 0x0f01),
(70, 108, 118, 8922, 1, ''),
(70, 108, 119, 2187, 1, ''),
(71, 1, 101, 2498, 1, ''),
(71, 3, 102, 1988, 1, ''),
(71, 4, 103, 2656, 1, ''),
(71, 5, 104, 2520, 1, ''),
(71, 6, 105, 8920, 1, ''),
(71, 7, 106, 2647, 1, ''),
(71, 8, 107, 2195, 1, ''),
(71, 10, 108, 1987, 1, ''),
(71, 102, 109, 2268, 1, 0x0f01),
(71, 102, 110, 2273, 1, 0x0f01),
(71, 102, 111, 2305, 1, 0x0f01),
(71, 102, 112, 2261, 1, 0x0f01),
(71, 102, 113, 2293, 1, 0x0f01),
(71, 102, 114, 7590, 1, 0x0f01),
(71, 102, 115, 7589, 1, 0x0f01),
(71, 102, 116, 7620, 1, 0x0f01),
(71, 102, 117, 7618, 1, 0x0f01),
(71, 108, 118, 8922, 1, ''),
(71, 108, 119, 2187, 1, ''),
(72, 1, 101, 2498, 1, ''),
(72, 3, 102, 1988, 1, ''),
(72, 4, 103, 2656, 1, ''),
(72, 5, 104, 2520, 1, ''),
(72, 6, 105, 8920, 1, ''),
(72, 7, 106, 2647, 1, ''),
(72, 8, 107, 2195, 1, ''),
(72, 10, 108, 1987, 1, ''),
(72, 102, 109, 2268, 1, 0x0f01),
(72, 102, 110, 2273, 1, 0x0f01),
(72, 102, 111, 2305, 1, 0x0f01),
(72, 102, 112, 2261, 1, 0x0f01),
(72, 102, 113, 2293, 1, 0x0f01),
(72, 102, 114, 7590, 1, 0x0f01),
(72, 102, 115, 7589, 1, 0x0f01),
(72, 102, 116, 7620, 1, 0x0f01),
(72, 102, 117, 7618, 1, 0x0f01),
(72, 108, 118, 8922, 1, ''),
(72, 108, 119, 2187, 1, ''),
(73, 1, 101, 2498, 1, ''),
(73, 3, 102, 1988, 1, ''),
(73, 4, 103, 2656, 1, ''),
(73, 5, 104, 2520, 1, ''),
(73, 6, 105, 8920, 1, ''),
(73, 7, 106, 2647, 1, ''),
(73, 8, 107, 2195, 1, ''),
(73, 10, 108, 1987, 1, ''),
(73, 102, 109, 2268, 1, 0x0f01),
(73, 102, 110, 2273, 1, 0x0f01),
(73, 102, 111, 2305, 1, 0x0f01),
(73, 102, 112, 2261, 1, 0x0f01),
(73, 102, 113, 2293, 1, 0x0f01),
(73, 102, 114, 7590, 1, 0x0f01),
(73, 102, 115, 7589, 1, 0x0f01),
(73, 102, 116, 7620, 1, 0x0f01),
(73, 102, 117, 7618, 1, 0x0f01),
(73, 108, 118, 8922, 1, ''),
(73, 108, 119, 2187, 1, ''),
(74, 1, 101, 2498, 1, ''),
(74, 3, 102, 1988, 1, ''),
(74, 4, 103, 2656, 1, ''),
(74, 5, 104, 2520, 1, ''),
(74, 6, 105, 8920, 1, ''),
(74, 7, 106, 2647, 1, ''),
(74, 8, 107, 2195, 1, ''),
(74, 10, 108, 1987, 1, ''),
(74, 102, 109, 2268, 1, 0x0f01),
(74, 102, 110, 2273, 1, 0x0f01),
(74, 102, 111, 2305, 1, 0x0f01),
(74, 102, 112, 2261, 1, 0x0f01),
(74, 102, 113, 2293, 1, 0x0f01),
(74, 102, 114, 7590, 1, 0x0f01),
(74, 102, 115, 7589, 1, 0x0f01),
(74, 102, 116, 7620, 1, 0x0f01),
(74, 102, 117, 7618, 1, 0x0f01),
(74, 108, 118, 8922, 1, ''),
(74, 108, 119, 2187, 1, ''),
(75, 1, 101, 2498, 1, ''),
(75, 3, 102, 1988, 1, ''),
(75, 4, 103, 2656, 1, ''),
(75, 5, 104, 2520, 1, ''),
(75, 6, 105, 8920, 1, ''),
(75, 7, 106, 2647, 1, ''),
(75, 8, 107, 2195, 1, ''),
(75, 10, 108, 1987, 1, ''),
(75, 102, 109, 2268, 1, 0x0f01),
(75, 102, 110, 2273, 1, 0x0f01),
(75, 102, 111, 2305, 1, 0x0f01),
(75, 102, 112, 2261, 1, 0x0f01),
(75, 102, 113, 2293, 1, 0x0f01),
(75, 102, 114, 7590, 1, 0x0f01),
(75, 102, 115, 7589, 1, 0x0f01),
(75, 102, 116, 7620, 1, 0x0f01),
(75, 102, 117, 7618, 1, 0x0f01),
(75, 108, 118, 8922, 1, ''),
(75, 108, 119, 2187, 1, ''),
(76, 1, 101, 2498, 1, ''),
(76, 3, 102, 1988, 1, ''),
(76, 4, 103, 2656, 1, ''),
(76, 5, 104, 2520, 1, ''),
(76, 6, 105, 8920, 1, ''),
(76, 7, 106, 2647, 1, ''),
(76, 8, 107, 2195, 1, ''),
(76, 10, 108, 1987, 1, ''),
(76, 102, 109, 2268, 1, 0x0f01),
(76, 102, 110, 2273, 1, 0x0f01),
(76, 102, 111, 2305, 1, 0x0f01),
(76, 102, 112, 2261, 1, 0x0f01),
(76, 102, 113, 2293, 1, 0x0f01),
(76, 102, 114, 7590, 1, 0x0f01),
(76, 102, 115, 7589, 1, 0x0f01),
(76, 102, 116, 7620, 1, 0x0f01),
(76, 102, 117, 7618, 1, 0x0f01),
(76, 108, 118, 8922, 1, ''),
(76, 108, 119, 2187, 1, ''),
(77, 1, 101, 2498, 1, ''),
(77, 3, 102, 1988, 1, ''),
(77, 4, 103, 2656, 1, ''),
(77, 5, 104, 2520, 1, ''),
(77, 6, 105, 8920, 1, ''),
(77, 7, 106, 2647, 1, ''),
(77, 8, 107, 2195, 1, ''),
(77, 10, 108, 1987, 1, ''),
(77, 102, 109, 2268, 1, 0x0f01),
(77, 102, 110, 2273, 1, 0x0f01),
(77, 102, 111, 2305, 1, 0x0f01),
(77, 102, 112, 2261, 1, 0x0f01),
(77, 102, 113, 2293, 1, 0x0f01),
(77, 102, 114, 7590, 1, 0x0f01),
(77, 102, 115, 7589, 1, 0x0f01),
(77, 102, 116, 7620, 1, 0x0f01),
(77, 102, 117, 7618, 1, 0x0f01),
(77, 108, 118, 8922, 1, ''),
(77, 108, 119, 2187, 1, ''),
(78, 1, 101, 2498, 1, ''),
(78, 3, 102, 1988, 1, ''),
(78, 4, 103, 2656, 1, ''),
(78, 5, 104, 2520, 1, ''),
(78, 6, 105, 8920, 1, ''),
(78, 7, 106, 2647, 1, ''),
(78, 8, 107, 2195, 1, ''),
(78, 10, 108, 1987, 1, ''),
(78, 102, 109, 2268, 1, 0x0f01),
(78, 102, 110, 2273, 1, 0x0f01),
(78, 102, 111, 2305, 1, 0x0f01),
(78, 102, 112, 2261, 1, 0x0f01),
(78, 102, 113, 2293, 1, 0x0f01),
(78, 102, 114, 7590, 1, 0x0f01),
(78, 102, 115, 7589, 1, 0x0f01),
(78, 102, 116, 7620, 1, 0x0f01),
(78, 102, 117, 7618, 1, 0x0f01),
(78, 108, 118, 8922, 1, ''),
(78, 108, 119, 2187, 1, ''),
(79, 1, 101, 2498, 1, ''),
(79, 3, 102, 1988, 1, ''),
(79, 4, 103, 2656, 1, ''),
(79, 5, 104, 2520, 1, ''),
(79, 6, 105, 8920, 1, ''),
(79, 7, 106, 2647, 1, ''),
(79, 8, 107, 2195, 1, ''),
(79, 10, 108, 1987, 1, ''),
(79, 102, 109, 2268, 1, 0x0f01),
(79, 102, 110, 2273, 1, 0x0f01),
(79, 102, 111, 2305, 1, 0x0f01),
(79, 102, 112, 2261, 1, 0x0f01),
(79, 102, 113, 2293, 1, 0x0f01),
(79, 102, 114, 7590, 1, 0x0f01),
(79, 102, 115, 7589, 1, 0x0f01),
(79, 102, 116, 7620, 1, 0x0f01),
(79, 102, 117, 7618, 1, 0x0f01),
(79, 108, 118, 8922, 1, ''),
(79, 108, 119, 2187, 1, ''),
(80, 1, 101, 2498, 1, ''),
(80, 3, 102, 1988, 1, ''),
(80, 4, 103, 2656, 1, ''),
(80, 5, 104, 2520, 1, ''),
(80, 6, 105, 8920, 1, ''),
(80, 7, 106, 2647, 1, ''),
(80, 8, 107, 2195, 1, ''),
(80, 10, 108, 1987, 1, ''),
(80, 102, 109, 2268, 1, 0x0f01),
(80, 102, 110, 2273, 1, 0x0f01),
(80, 102, 111, 2305, 1, 0x0f01),
(80, 102, 112, 2261, 1, 0x0f01),
(80, 102, 113, 2293, 1, 0x0f01),
(80, 102, 114, 7590, 1, 0x0f01),
(80, 102, 115, 7589, 1, 0x0f01),
(80, 102, 116, 7620, 1, 0x0f01),
(80, 102, 117, 7618, 1, 0x0f01),
(80, 108, 118, 8922, 1, ''),
(80, 108, 119, 2187, 1, ''),
(81, 1, 101, 2498, 1, ''),
(81, 3, 102, 1988, 1, ''),
(81, 4, 103, 2656, 1, ''),
(81, 5, 104, 2520, 1, ''),
(81, 6, 105, 8920, 1, ''),
(81, 7, 106, 2647, 1, ''),
(81, 8, 107, 2195, 1, ''),
(81, 10, 108, 1987, 1, ''),
(81, 102, 109, 2268, 1, 0x0f01),
(81, 102, 110, 2273, 1, 0x0f01),
(81, 102, 111, 2305, 1, 0x0f01),
(81, 102, 112, 2261, 1, 0x0f01),
(81, 102, 113, 2293, 1, 0x0f01),
(81, 102, 114, 7590, 1, 0x0f01),
(81, 102, 115, 7589, 1, 0x0f01),
(81, 102, 116, 7620, 1, 0x0f01),
(81, 102, 117, 7618, 1, 0x0f01),
(81, 108, 118, 8922, 1, ''),
(81, 108, 119, 2187, 1, ''),
(82, 1, 101, 2498, 1, ''),
(82, 3, 102, 1988, 1, ''),
(82, 4, 103, 2656, 1, ''),
(82, 5, 104, 2520, 1, ''),
(82, 6, 105, 8920, 1, ''),
(82, 7, 106, 2647, 1, ''),
(82, 8, 107, 2195, 1, ''),
(82, 10, 108, 1987, 1, ''),
(82, 102, 109, 2268, 1, 0x0f01),
(82, 102, 110, 2273, 1, 0x0f01),
(82, 102, 111, 2305, 1, 0x0f01),
(82, 102, 112, 2261, 1, 0x0f01),
(82, 102, 113, 2293, 1, 0x0f01),
(82, 102, 114, 7590, 1, 0x0f01),
(82, 102, 115, 7589, 1, 0x0f01),
(82, 102, 116, 7620, 1, 0x0f01),
(82, 102, 117, 7618, 1, 0x0f01),
(82, 108, 118, 8922, 1, ''),
(82, 108, 119, 2187, 1, ''),
(83, 1, 101, 2498, 1, ''),
(83, 3, 102, 1988, 1, ''),
(83, 4, 103, 2656, 1, ''),
(83, 5, 104, 2520, 1, ''),
(83, 6, 105, 8920, 1, ''),
(83, 7, 106, 2647, 1, ''),
(83, 8, 107, 2195, 1, ''),
(83, 10, 108, 1987, 1, ''),
(83, 102, 109, 2268, 1, 0x0f01),
(83, 102, 110, 2273, 1, 0x0f01),
(83, 102, 111, 2305, 1, 0x0f01),
(83, 102, 112, 2261, 1, 0x0f01),
(83, 102, 113, 2293, 1, 0x0f01),
(83, 102, 114, 7590, 1, 0x0f01),
(83, 102, 115, 7589, 1, 0x0f01),
(83, 102, 116, 7620, 1, 0x0f01),
(83, 102, 117, 7618, 1, 0x0f01),
(83, 108, 118, 8922, 1, ''),
(83, 108, 119, 2187, 1, ''),
(84, 1, 101, 2498, 1, ''),
(84, 3, 102, 1988, 1, ''),
(84, 4, 103, 2656, 1, ''),
(84, 5, 104, 2520, 1, ''),
(84, 6, 105, 8920, 1, ''),
(84, 7, 106, 2647, 1, ''),
(84, 8, 107, 2195, 1, ''),
(84, 10, 108, 1987, 1, ''),
(84, 102, 109, 2268, 1, 0x0f01),
(84, 102, 110, 2273, 1, 0x0f01),
(84, 102, 111, 2305, 1, 0x0f01),
(84, 102, 112, 2261, 1, 0x0f01),
(84, 102, 113, 2293, 1, 0x0f01),
(84, 102, 114, 7590, 1, 0x0f01),
(84, 102, 115, 7589, 1, 0x0f01),
(84, 102, 116, 7620, 1, 0x0f01),
(84, 102, 117, 7618, 1, 0x0f01),
(84, 108, 118, 8922, 1, ''),
(84, 108, 119, 2187, 1, ''),
(85, 1, 101, 2498, 1, ''),
(85, 3, 102, 1988, 1, ''),
(85, 4, 103, 2656, 1, ''),
(85, 5, 104, 2520, 1, ''),
(85, 6, 105, 8920, 1, ''),
(85, 7, 106, 2647, 1, ''),
(85, 8, 107, 2195, 1, ''),
(85, 10, 108, 1987, 1, ''),
(85, 102, 109, 2268, 1, 0x0f01),
(85, 102, 110, 2273, 1, 0x0f01),
(85, 102, 111, 2305, 1, 0x0f01),
(85, 102, 112, 2261, 1, 0x0f01),
(85, 102, 113, 2293, 1, 0x0f01),
(85, 102, 114, 7590, 1, 0x0f01),
(85, 102, 115, 7589, 1, 0x0f01),
(85, 102, 116, 7620, 1, 0x0f01),
(85, 102, 117, 7618, 1, 0x0f01),
(85, 108, 118, 8922, 1, ''),
(85, 108, 119, 2187, 1, ''),
(86, 1, 101, 2498, 1, ''),
(86, 3, 102, 1988, 1, ''),
(86, 4, 103, 2656, 1, ''),
(86, 5, 104, 2520, 1, ''),
(86, 6, 105, 8912, 1, ''),
(86, 7, 106, 2647, 1, ''),
(86, 8, 107, 2195, 1, ''),
(86, 10, 108, 1987, 1, ''),
(86, 102, 109, 2278, 1, 0x0f01),
(86, 102, 110, 2273, 1, 0x0f01),
(86, 102, 111, 2305, 1, 0x0f01),
(86, 102, 112, 2268, 1, 0x0f01),
(86, 102, 113, 2261, 1, 0x0f01),
(86, 102, 114, 2293, 1, 0x0f01),
(86, 102, 115, 7618, 1, 0x0f01),
(86, 102, 116, 7590, 1, 0x0f01),
(86, 102, 117, 7589, 1, 0x0f01),
(86, 108, 118, 8910, 1, ''),
(86, 108, 119, 2183, 1, ''),
(87, 1, 101, 2498, 1, ''),
(87, 3, 102, 1988, 1, ''),
(87, 4, 103, 2656, 1, ''),
(87, 5, 104, 2520, 1, ''),
(87, 6, 105, 8912, 1, ''),
(87, 7, 106, 2647, 1, ''),
(87, 8, 107, 2195, 1, ''),
(87, 10, 108, 1987, 1, ''),
(87, 102, 109, 2278, 1, 0x0f01),
(87, 102, 110, 2273, 1, 0x0f01),
(87, 102, 111, 2305, 1, 0x0f01),
(87, 102, 112, 2268, 1, 0x0f01),
(87, 102, 113, 2261, 1, 0x0f01),
(87, 102, 114, 2293, 1, 0x0f01),
(87, 102, 115, 7618, 1, 0x0f01),
(87, 102, 116, 7590, 1, 0x0f01),
(87, 102, 117, 7589, 1, 0x0f01),
(87, 108, 118, 8910, 1, ''),
(87, 108, 119, 2183, 1, ''),
(88, 1, 101, 2498, 1, ''),
(88, 3, 102, 1988, 1, ''),
(88, 4, 103, 2656, 1, ''),
(88, 5, 104, 2520, 1, ''),
(88, 6, 105, 8912, 1, ''),
(88, 7, 106, 2647, 1, ''),
(88, 8, 107, 2195, 1, ''),
(88, 10, 108, 1987, 1, ''),
(88, 102, 109, 2278, 1, 0x0f01),
(88, 102, 110, 2273, 1, 0x0f01),
(88, 102, 111, 2305, 1, 0x0f01),
(88, 102, 112, 2268, 1, 0x0f01),
(88, 102, 113, 2261, 1, 0x0f01),
(88, 102, 114, 2293, 1, 0x0f01),
(88, 102, 115, 7618, 1, 0x0f01),
(88, 102, 116, 7590, 1, 0x0f01),
(88, 102, 117, 7589, 1, 0x0f01),
(88, 108, 118, 8910, 1, ''),
(88, 108, 119, 2183, 1, ''),
(89, 1, 101, 2498, 1, ''),
(89, 3, 102, 1988, 1, ''),
(89, 4, 103, 2656, 1, ''),
(89, 5, 104, 2520, 1, ''),
(89, 6, 105, 8912, 1, ''),
(89, 7, 106, 2647, 1, ''),
(89, 8, 107, 2195, 1, ''),
(89, 10, 108, 1987, 1, ''),
(89, 102, 109, 2278, 1, 0x0f01),
(89, 102, 110, 2273, 1, 0x0f01),
(89, 102, 111, 2305, 1, 0x0f01),
(89, 102, 112, 2268, 1, 0x0f01),
(89, 102, 113, 2261, 1, 0x0f01),
(89, 102, 114, 2293, 1, 0x0f01),
(89, 102, 115, 7618, 1, 0x0f01),
(89, 102, 116, 7590, 1, 0x0f01),
(89, 102, 117, 7589, 1, 0x0f01),
(89, 108, 118, 8910, 1, ''),
(89, 108, 119, 2183, 1, ''),
(90, 1, 101, 2498, 1, ''),
(90, 3, 102, 1988, 1, ''),
(90, 4, 103, 2656, 1, ''),
(90, 5, 104, 2520, 1, ''),
(90, 6, 105, 8912, 1, ''),
(90, 7, 106, 2647, 1, ''),
(90, 8, 107, 2195, 1, ''),
(90, 10, 108, 1987, 1, ''),
(90, 102, 109, 2278, 1, 0x0f01),
(90, 102, 110, 2273, 1, 0x0f01),
(90, 102, 111, 2305, 1, 0x0f01),
(90, 102, 112, 2268, 1, 0x0f01),
(90, 102, 113, 2261, 1, 0x0f01),
(90, 102, 114, 2293, 1, 0x0f01),
(90, 102, 115, 7618, 1, 0x0f01),
(90, 102, 116, 7590, 1, 0x0f01),
(90, 102, 117, 7589, 1, 0x0f01),
(90, 108, 118, 8910, 1, ''),
(90, 108, 119, 2183, 1, ''),
(91, 1, 101, 2498, 1, ''),
(91, 3, 102, 1988, 1, ''),
(91, 4, 103, 2656, 1, ''),
(91, 5, 104, 2520, 1, ''),
(91, 6, 105, 8912, 1, ''),
(91, 7, 106, 2647, 1, ''),
(91, 8, 107, 2195, 1, ''),
(91, 10, 108, 1987, 1, ''),
(91, 102, 109, 2278, 1, 0x0f01),
(91, 102, 110, 2273, 1, 0x0f01),
(91, 102, 111, 2305, 1, 0x0f01),
(91, 102, 112, 2268, 1, 0x0f01),
(91, 102, 113, 2261, 1, 0x0f01),
(91, 102, 114, 2293, 1, 0x0f01),
(91, 102, 115, 7618, 1, 0x0f01),
(91, 102, 116, 7590, 1, 0x0f01),
(91, 102, 117, 7589, 1, 0x0f01),
(91, 108, 118, 8910, 1, ''),
(91, 108, 119, 2183, 1, ''),
(92, 1, 101, 2498, 1, ''),
(92, 3, 102, 1988, 1, ''),
(92, 4, 103, 2656, 1, ''),
(92, 5, 104, 2520, 1, ''),
(92, 6, 105, 8912, 1, ''),
(92, 7, 106, 2647, 1, ''),
(92, 8, 107, 2195, 1, ''),
(92, 10, 108, 1987, 1, ''),
(92, 102, 109, 2278, 1, 0x0f01),
(92, 102, 110, 2273, 1, 0x0f01),
(92, 102, 111, 2305, 1, 0x0f01),
(92, 102, 112, 2268, 1, 0x0f01),
(92, 102, 113, 2261, 1, 0x0f01),
(92, 102, 114, 2293, 1, 0x0f01),
(92, 102, 115, 7618, 1, 0x0f01),
(92, 102, 116, 7590, 1, 0x0f01),
(92, 102, 117, 7589, 1, 0x0f01),
(92, 108, 118, 8910, 1, ''),
(92, 108, 119, 2183, 1, ''),
(93, 1, 101, 2498, 1, ''),
(93, 3, 102, 1988, 1, ''),
(93, 4, 103, 2656, 1, ''),
(93, 5, 104, 2520, 1, ''),
(93, 6, 105, 8912, 1, ''),
(93, 7, 106, 2647, 1, ''),
(93, 8, 107, 2195, 1, ''),
(93, 10, 108, 1987, 1, ''),
(93, 102, 109, 2278, 1, 0x0f01),
(93, 102, 110, 2273, 1, 0x0f01),
(93, 102, 111, 2305, 1, 0x0f01),
(93, 102, 112, 2268, 1, 0x0f01),
(93, 102, 113, 2261, 1, 0x0f01),
(93, 102, 114, 2293, 1, 0x0f01),
(93, 102, 115, 7618, 1, 0x0f01),
(93, 102, 116, 7590, 1, 0x0f01),
(93, 102, 117, 7589, 1, 0x0f01),
(93, 108, 118, 8910, 1, ''),
(93, 108, 119, 2183, 1, ''),
(94, 1, 101, 2498, 1, ''),
(94, 3, 102, 1988, 1, ''),
(94, 4, 103, 2656, 1, ''),
(94, 5, 104, 2520, 1, ''),
(94, 6, 105, 8912, 1, ''),
(94, 7, 106, 2647, 1, ''),
(94, 8, 107, 2195, 1, ''),
(94, 10, 108, 1987, 1, ''),
(94, 102, 109, 2278, 1, 0x0f01),
(94, 102, 110, 2273, 1, 0x0f01),
(94, 102, 111, 2305, 1, 0x0f01),
(94, 102, 112, 2268, 1, 0x0f01),
(94, 102, 113, 2261, 1, 0x0f01),
(94, 102, 114, 2293, 1, 0x0f01),
(94, 102, 115, 7618, 1, 0x0f01),
(94, 102, 116, 7590, 1, 0x0f01),
(94, 102, 117, 7589, 1, 0x0f01),
(94, 108, 118, 8910, 1, ''),
(94, 108, 119, 2183, 1, ''),
(95, 1, 101, 2498, 1, ''),
(95, 3, 102, 1988, 1, ''),
(95, 4, 103, 2656, 1, ''),
(95, 5, 104, 2520, 1, ''),
(95, 6, 105, 8912, 1, ''),
(95, 7, 106, 2647, 1, ''),
(95, 8, 107, 2195, 1, ''),
(95, 10, 108, 1987, 1, ''),
(95, 102, 109, 2278, 1, 0x0f01),
(95, 102, 110, 2273, 1, 0x0f01),
(95, 102, 111, 2305, 1, 0x0f01);
INSERT INTO `player_items` (`player_id`, `pid`, `sid`, `itemtype`, `count`, `attributes`) VALUES
(95, 102, 112, 2268, 1, 0x0f01),
(95, 102, 113, 2261, 1, 0x0f01),
(95, 102, 114, 2293, 1, 0x0f01),
(95, 102, 115, 7618, 1, 0x0f01),
(95, 102, 116, 7590, 1, 0x0f01),
(95, 102, 117, 7589, 1, 0x0f01),
(95, 108, 118, 8910, 1, ''),
(95, 108, 119, 2183, 1, ''),
(96, 1, 101, 2498, 1, ''),
(96, 3, 102, 1988, 1, ''),
(96, 4, 103, 2656, 1, ''),
(96, 5, 104, 2520, 1, ''),
(96, 6, 105, 8912, 1, ''),
(96, 7, 106, 2647, 1, ''),
(96, 8, 107, 2195, 1, ''),
(96, 10, 108, 1987, 1, ''),
(96, 102, 109, 2278, 1, 0x0f01),
(96, 102, 110, 2273, 1, 0x0f01),
(96, 102, 111, 2305, 1, 0x0f01),
(96, 102, 112, 2268, 1, 0x0f01),
(96, 102, 113, 2261, 1, 0x0f01),
(96, 102, 114, 2293, 1, 0x0f01),
(96, 102, 115, 7618, 1, 0x0f01),
(96, 102, 116, 7590, 1, 0x0f01),
(96, 102, 117, 7589, 1, 0x0f01),
(96, 108, 118, 8910, 1, ''),
(96, 108, 119, 2183, 1, ''),
(97, 1, 101, 2498, 1, ''),
(97, 3, 102, 1988, 1, ''),
(97, 4, 103, 2656, 1, ''),
(97, 5, 104, 2520, 1, ''),
(97, 6, 105, 8912, 1, ''),
(97, 7, 106, 2647, 1, ''),
(97, 8, 107, 2195, 1, ''),
(97, 10, 108, 1987, 1, ''),
(97, 102, 109, 2278, 1, 0x0f01),
(97, 102, 110, 2273, 1, 0x0f01),
(97, 102, 111, 2305, 1, 0x0f01),
(97, 102, 112, 2268, 1, 0x0f01),
(97, 102, 113, 2261, 1, 0x0f01),
(97, 102, 114, 2293, 1, 0x0f01),
(97, 102, 115, 7618, 1, 0x0f01),
(97, 102, 116, 7590, 1, 0x0f01),
(97, 102, 117, 7589, 1, 0x0f01),
(97, 108, 118, 8910, 1, ''),
(97, 108, 119, 2183, 1, ''),
(98, 1, 101, 2498, 1, ''),
(98, 3, 102, 1988, 1, ''),
(98, 4, 103, 2656, 1, ''),
(98, 5, 104, 2520, 1, ''),
(98, 6, 105, 8912, 1, ''),
(98, 7, 106, 2647, 1, ''),
(98, 8, 107, 2195, 1, ''),
(98, 10, 108, 1987, 1, ''),
(98, 102, 109, 2278, 1, 0x0f01),
(98, 102, 110, 2273, 1, 0x0f01),
(98, 102, 111, 2305, 1, 0x0f01),
(98, 102, 112, 2268, 1, 0x0f01),
(98, 102, 113, 2261, 1, 0x0f01),
(98, 102, 114, 2293, 1, 0x0f01),
(98, 102, 115, 7618, 1, 0x0f01),
(98, 102, 116, 7590, 1, 0x0f01),
(98, 102, 117, 7589, 1, 0x0f01),
(98, 108, 118, 8910, 1, ''),
(98, 108, 119, 2183, 1, ''),
(99, 1, 101, 2498, 1, ''),
(99, 3, 102, 1988, 1, ''),
(99, 4, 103, 2656, 1, ''),
(99, 5, 104, 2520, 1, ''),
(99, 6, 105, 8912, 1, ''),
(99, 7, 106, 2647, 1, ''),
(99, 8, 107, 2195, 1, ''),
(99, 10, 108, 1987, 1, ''),
(99, 102, 109, 2278, 1, 0x0f01),
(99, 102, 110, 2273, 1, 0x0f01),
(99, 102, 111, 2305, 1, 0x0f01),
(99, 102, 112, 2268, 1, 0x0f01),
(99, 102, 113, 2261, 1, 0x0f01),
(99, 102, 114, 2293, 1, 0x0f01),
(99, 102, 115, 7618, 1, 0x0f01),
(99, 102, 116, 7590, 1, 0x0f01),
(99, 102, 117, 7589, 1, 0x0f01),
(99, 108, 118, 8910, 1, ''),
(99, 108, 119, 2183, 1, ''),
(100, 1, 101, 2498, 1, ''),
(100, 3, 102, 1988, 1, ''),
(100, 4, 103, 2656, 1, ''),
(100, 5, 104, 2520, 1, ''),
(100, 6, 105, 8912, 1, ''),
(100, 7, 106, 2647, 1, ''),
(100, 8, 107, 2195, 1, ''),
(100, 10, 108, 1987, 1, ''),
(100, 102, 109, 2278, 1, 0x0f01),
(100, 102, 110, 2273, 1, 0x0f01),
(100, 102, 111, 2305, 1, 0x0f01),
(100, 102, 112, 2268, 1, 0x0f01),
(100, 102, 113, 2261, 1, 0x0f01),
(100, 102, 114, 2293, 1, 0x0f01),
(100, 102, 115, 7618, 1, 0x0f01),
(100, 102, 116, 7590, 1, 0x0f01),
(100, 102, 117, 7589, 1, 0x0f01),
(100, 108, 118, 8910, 1, ''),
(100, 108, 119, 2183, 1, ''),
(101, 1, 101, 2498, 1, ''),
(101, 3, 102, 1988, 1, ''),
(101, 4, 103, 2656, 1, ''),
(101, 5, 104, 2520, 1, ''),
(101, 6, 105, 8912, 1, ''),
(101, 7, 106, 2647, 1, ''),
(101, 8, 107, 2195, 1, ''),
(101, 10, 108, 1987, 1, ''),
(101, 102, 109, 2278, 1, 0x0f01),
(101, 102, 110, 2273, 1, 0x0f01),
(101, 102, 111, 2305, 1, 0x0f01),
(101, 102, 112, 2268, 1, 0x0f01),
(101, 102, 113, 2261, 1, 0x0f01),
(101, 102, 114, 2293, 1, 0x0f01),
(101, 102, 115, 7618, 1, 0x0f01),
(101, 102, 116, 7590, 1, 0x0f01),
(101, 102, 117, 7589, 1, 0x0f01),
(101, 108, 118, 8910, 1, ''),
(101, 108, 119, 2183, 1, ''),
(102, 1, 101, 2498, 1, ''),
(102, 3, 102, 1988, 1, ''),
(102, 4, 103, 2656, 1, ''),
(102, 5, 104, 2520, 1, ''),
(102, 6, 105, 8912, 1, ''),
(102, 7, 106, 2647, 1, ''),
(102, 8, 107, 2195, 1, ''),
(102, 10, 108, 1987, 1, ''),
(102, 102, 109, 2278, 1, 0x0f01),
(102, 102, 110, 2273, 1, 0x0f01),
(102, 102, 111, 2305, 1, 0x0f01),
(102, 102, 112, 2268, 1, 0x0f01),
(102, 102, 113, 2261, 1, 0x0f01),
(102, 102, 114, 2293, 1, 0x0f01),
(102, 102, 115, 7618, 1, 0x0f01),
(102, 102, 116, 7590, 1, 0x0f01),
(102, 102, 117, 7589, 1, 0x0f01),
(102, 108, 118, 8910, 1, ''),
(102, 108, 119, 2183, 1, ''),
(103, 1, 101, 2498, 1, ''),
(103, 3, 102, 1988, 1, ''),
(103, 4, 103, 2656, 1, ''),
(103, 5, 104, 2520, 1, ''),
(103, 6, 105, 8912, 1, ''),
(103, 7, 106, 2647, 1, ''),
(103, 8, 107, 2195, 1, ''),
(103, 10, 108, 1987, 1, ''),
(103, 102, 109, 2278, 1, 0x0f01),
(103, 102, 110, 2273, 1, 0x0f01),
(103, 102, 111, 2305, 1, 0x0f01),
(103, 102, 112, 2268, 1, 0x0f01),
(103, 102, 113, 2261, 1, 0x0f01),
(103, 102, 114, 2293, 1, 0x0f01),
(103, 102, 115, 7618, 1, 0x0f01),
(103, 102, 116, 7590, 1, 0x0f01),
(103, 102, 117, 7589, 1, 0x0f01),
(103, 108, 118, 8910, 1, ''),
(103, 108, 119, 2183, 1, ''),
(104, 1, 101, 2498, 1, ''),
(104, 3, 102, 1988, 1, ''),
(104, 4, 103, 2656, 1, ''),
(104, 5, 104, 2520, 1, ''),
(104, 6, 105, 8912, 1, ''),
(104, 7, 106, 2647, 1, ''),
(104, 8, 107, 2195, 1, ''),
(104, 10, 108, 1987, 1, ''),
(104, 102, 109, 2278, 1, 0x0f01),
(104, 102, 110, 2273, 1, 0x0f01),
(104, 102, 111, 2305, 1, 0x0f01),
(104, 102, 112, 2268, 1, 0x0f01),
(104, 102, 113, 2261, 1, 0x0f01),
(104, 102, 114, 2293, 1, 0x0f01),
(104, 102, 115, 7618, 1, 0x0f01),
(104, 102, 116, 7590, 1, 0x0f01),
(104, 102, 117, 7589, 1, 0x0f01),
(104, 108, 118, 8910, 1, ''),
(104, 108, 119, 2183, 1, ''),
(105, 1, 101, 2498, 1, ''),
(105, 3, 102, 1988, 1, ''),
(105, 4, 103, 2656, 1, ''),
(105, 5, 104, 2520, 1, ''),
(105, 6, 105, 8912, 1, ''),
(105, 7, 106, 2647, 1, ''),
(105, 8, 107, 2195, 1, ''),
(105, 10, 108, 1987, 1, ''),
(105, 102, 109, 2278, 1, 0x0f01),
(105, 102, 110, 2273, 1, 0x0f01),
(105, 102, 111, 2305, 1, 0x0f01),
(105, 102, 112, 2268, 1, 0x0f01),
(105, 102, 113, 2261, 1, 0x0f01),
(105, 102, 114, 2293, 1, 0x0f01),
(105, 102, 115, 7618, 1, 0x0f01),
(105, 102, 116, 7590, 1, 0x0f01),
(105, 102, 117, 7589, 1, 0x0f01),
(105, 108, 118, 8910, 1, ''),
(105, 108, 119, 2183, 1, ''),
(106, 1, 101, 2498, 1, ''),
(106, 3, 102, 1988, 1, ''),
(106, 4, 103, 2656, 1, ''),
(106, 5, 104, 2520, 1, ''),
(106, 6, 105, 8912, 1, ''),
(106, 7, 106, 2647, 1, ''),
(106, 8, 107, 2195, 1, ''),
(106, 10, 108, 1987, 1, ''),
(106, 102, 109, 2278, 1, 0x0f01),
(106, 102, 110, 2273, 1, 0x0f01),
(106, 102, 111, 2305, 1, 0x0f01),
(106, 102, 112, 2268, 1, 0x0f01),
(106, 102, 113, 2261, 1, 0x0f01),
(106, 102, 114, 2293, 1, 0x0f01),
(106, 102, 115, 7618, 1, 0x0f01),
(106, 102, 116, 7590, 1, 0x0f01),
(106, 102, 117, 7589, 1, 0x0f01),
(106, 108, 118, 8910, 1, ''),
(106, 108, 119, 2183, 1, ''),
(107, 1, 101, 2498, 1, ''),
(107, 3, 102, 1988, 1, ''),
(107, 4, 103, 2656, 1, ''),
(107, 5, 104, 2520, 1, ''),
(107, 6, 105, 8912, 1, ''),
(107, 7, 106, 2647, 1, ''),
(107, 8, 107, 2195, 1, ''),
(107, 10, 108, 1987, 1, ''),
(107, 102, 109, 2278, 1, 0x0f01),
(107, 102, 110, 2273, 1, 0x0f01),
(107, 102, 111, 2305, 1, 0x0f01),
(107, 102, 112, 2268, 1, 0x0f01),
(107, 102, 113, 2261, 1, 0x0f01),
(107, 102, 114, 2293, 1, 0x0f01),
(107, 102, 115, 7618, 1, 0x0f01),
(107, 102, 116, 7590, 1, 0x0f01),
(107, 102, 117, 7589, 1, 0x0f01),
(107, 108, 118, 8910, 1, ''),
(107, 108, 119, 2183, 1, ''),
(108, 1, 101, 2498, 1, ''),
(108, 3, 102, 1988, 1, ''),
(108, 4, 103, 2656, 1, ''),
(108, 5, 104, 2520, 1, ''),
(108, 6, 105, 8912, 1, ''),
(108, 7, 106, 2647, 1, ''),
(108, 8, 107, 2195, 1, ''),
(108, 10, 108, 1987, 1, ''),
(108, 102, 109, 2278, 1, 0x0f01),
(108, 102, 110, 2273, 1, 0x0f01),
(108, 102, 111, 2305, 1, 0x0f01),
(108, 102, 112, 2268, 1, 0x0f01),
(108, 102, 113, 2261, 1, 0x0f01),
(108, 102, 114, 2293, 1, 0x0f01),
(108, 102, 115, 7618, 1, 0x0f01),
(108, 102, 116, 7590, 1, 0x0f01),
(108, 102, 117, 7589, 1, 0x0f01),
(108, 108, 118, 8910, 1, ''),
(108, 108, 119, 2183, 1, ''),
(109, 1, 101, 2498, 1, ''),
(109, 3, 102, 1988, 1, ''),
(109, 4, 103, 2656, 1, ''),
(109, 5, 104, 2520, 1, ''),
(109, 6, 105, 8912, 1, ''),
(109, 7, 106, 2647, 1, ''),
(109, 8, 107, 2195, 1, ''),
(109, 10, 108, 1987, 1, ''),
(109, 102, 109, 2278, 1, 0x0f01),
(109, 102, 110, 2273, 1, 0x0f01),
(109, 102, 111, 2305, 1, 0x0f01),
(109, 102, 112, 2268, 1, 0x0f01),
(109, 102, 113, 2261, 1, 0x0f01),
(109, 102, 114, 2293, 1, 0x0f01),
(109, 102, 115, 7618, 1, 0x0f01),
(109, 102, 116, 7590, 1, 0x0f01),
(109, 102, 117, 7589, 1, 0x0f01),
(109, 108, 118, 8910, 1, ''),
(109, 108, 119, 2183, 1, ''),
(110, 1, 101, 2498, 1, ''),
(110, 3, 102, 1988, 1, ''),
(110, 4, 103, 2656, 1, ''),
(110, 5, 104, 2520, 1, ''),
(110, 6, 105, 8912, 1, ''),
(110, 7, 106, 2647, 1, ''),
(110, 8, 107, 2195, 1, ''),
(110, 10, 108, 1987, 1, ''),
(110, 102, 109, 2278, 1, 0x0f01),
(110, 102, 110, 2273, 1, 0x0f01),
(110, 102, 111, 2305, 1, 0x0f01),
(110, 102, 112, 2268, 1, 0x0f01),
(110, 102, 113, 2261, 1, 0x0f01),
(110, 102, 114, 2293, 1, 0x0f01),
(110, 102, 115, 7618, 1, 0x0f01),
(110, 102, 116, 7590, 1, 0x0f01),
(110, 102, 117, 7589, 1, 0x0f01),
(110, 108, 118, 8910, 1, ''),
(110, 108, 119, 2183, 1, ''),
(111, 1, 101, 2498, 1, ''),
(111, 3, 102, 1988, 1, ''),
(111, 4, 103, 2656, 1, ''),
(111, 5, 104, 2520, 1, ''),
(111, 6, 105, 8912, 1, ''),
(111, 7, 106, 2647, 1, ''),
(111, 8, 107, 2195, 1, ''),
(111, 10, 108, 1987, 1, ''),
(111, 102, 109, 2278, 1, 0x0f01),
(111, 102, 110, 2273, 1, 0x0f01),
(111, 102, 111, 2305, 1, 0x0f01),
(111, 102, 112, 2268, 1, 0x0f01),
(111, 102, 113, 2261, 1, 0x0f01),
(111, 102, 114, 2293, 1, 0x0f01),
(111, 102, 115, 7618, 1, 0x0f01),
(111, 102, 116, 7590, 1, 0x0f01),
(111, 102, 117, 7589, 1, 0x0f01),
(111, 108, 118, 8910, 1, ''),
(111, 108, 119, 2183, 1, ''),
(112, 1, 101, 2498, 1, ''),
(112, 3, 102, 1988, 1, ''),
(112, 4, 103, 2656, 1, ''),
(112, 5, 104, 2520, 1, ''),
(112, 6, 105, 8912, 1, ''),
(112, 7, 106, 2647, 1, ''),
(112, 8, 107, 2195, 1, ''),
(112, 10, 108, 1987, 1, ''),
(112, 102, 109, 2278, 1, 0x0f01),
(112, 102, 110, 2273, 1, 0x0f01),
(112, 102, 111, 2305, 1, 0x0f01),
(112, 102, 112, 2268, 1, 0x0f01),
(112, 102, 113, 2261, 1, 0x0f01),
(112, 102, 114, 2293, 1, 0x0f01),
(112, 102, 115, 7618, 1, 0x0f01),
(112, 102, 116, 7590, 1, 0x0f01),
(112, 102, 117, 7589, 1, 0x0f01),
(112, 108, 118, 8910, 1, ''),
(112, 108, 119, 2183, 1, ''),
(113, 1, 101, 2498, 1, ''),
(113, 3, 102, 1988, 1, ''),
(113, 4, 103, 2656, 1, ''),
(113, 5, 104, 2520, 1, ''),
(113, 6, 105, 8912, 1, ''),
(113, 7, 106, 2647, 1, ''),
(113, 8, 107, 2195, 1, ''),
(113, 10, 108, 1987, 1, ''),
(113, 102, 109, 2278, 1, 0x0f01),
(113, 102, 110, 2273, 1, 0x0f01),
(113, 102, 111, 2305, 1, 0x0f01),
(113, 102, 112, 2268, 1, 0x0f01),
(113, 102, 113, 2261, 1, 0x0f01),
(113, 102, 114, 2293, 1, 0x0f01),
(113, 102, 115, 7618, 1, 0x0f01),
(113, 102, 116, 7590, 1, 0x0f01),
(113, 102, 117, 7589, 1, 0x0f01),
(113, 108, 118, 8910, 1, ''),
(113, 108, 119, 2183, 1, ''),
(114, 1, 101, 2498, 1, ''),
(114, 3, 102, 1988, 1, ''),
(114, 4, 103, 2656, 1, ''),
(114, 5, 104, 2520, 1, ''),
(114, 6, 105, 8912, 1, ''),
(114, 7, 106, 2647, 1, ''),
(114, 8, 107, 2195, 1, ''),
(114, 10, 108, 1987, 1, ''),
(114, 102, 109, 2278, 1, 0x0f01),
(114, 102, 110, 2273, 1, 0x0f01),
(114, 102, 111, 2305, 1, 0x0f01),
(114, 102, 112, 2268, 1, 0x0f01),
(114, 102, 113, 2261, 1, 0x0f01),
(114, 102, 114, 2293, 1, 0x0f01),
(114, 102, 115, 7618, 1, 0x0f01),
(114, 102, 116, 7590, 1, 0x0f01),
(114, 102, 117, 7589, 1, 0x0f01),
(114, 108, 118, 8910, 1, ''),
(114, 108, 119, 2183, 1, ''),
(115, 1, 101, 2498, 1, ''),
(115, 3, 102, 1988, 1, ''),
(115, 4, 103, 2656, 1, ''),
(115, 5, 104, 2520, 1, ''),
(115, 6, 105, 8912, 1, ''),
(115, 7, 106, 2647, 1, ''),
(115, 8, 107, 2195, 1, ''),
(115, 10, 108, 1987, 1, ''),
(115, 102, 109, 2278, 1, 0x0f01),
(115, 102, 110, 2273, 1, 0x0f01),
(115, 102, 111, 2305, 1, 0x0f01),
(115, 102, 112, 2268, 1, 0x0f01),
(115, 102, 113, 2261, 1, 0x0f01),
(115, 102, 114, 2293, 1, 0x0f01),
(115, 102, 115, 7618, 1, 0x0f01),
(115, 102, 116, 7590, 1, 0x0f01),
(115, 102, 117, 7589, 1, 0x0f01),
(115, 108, 118, 8910, 1, ''),
(115, 108, 119, 2183, 1, ''),
(116, 1, 101, 2498, 1, ''),
(116, 3, 102, 1988, 1, ''),
(116, 4, 103, 2656, 1, ''),
(116, 5, 104, 2520, 1, ''),
(116, 6, 105, 8912, 1, ''),
(116, 7, 106, 2647, 1, ''),
(116, 8, 107, 2195, 1, ''),
(116, 10, 108, 1987, 1, ''),
(116, 102, 109, 2278, 1, 0x0f01),
(116, 102, 110, 2273, 1, 0x0f01),
(116, 102, 111, 2305, 1, 0x0f01),
(116, 102, 112, 2268, 1, 0x0f01),
(116, 102, 113, 2261, 1, 0x0f01),
(116, 102, 114, 2293, 1, 0x0f01),
(116, 102, 115, 7618, 1, 0x0f01),
(116, 102, 116, 7590, 1, 0x0f01),
(116, 102, 117, 7589, 1, 0x0f01),
(116, 108, 118, 8910, 1, ''),
(116, 108, 119, 2183, 1, ''),
(117, 1, 101, 2498, 1, ''),
(117, 3, 102, 1988, 1, ''),
(117, 4, 103, 2656, 1, ''),
(117, 5, 104, 2520, 1, ''),
(117, 6, 105, 8912, 1, ''),
(117, 7, 106, 2647, 1, ''),
(117, 8, 107, 2195, 1, ''),
(117, 10, 108, 1987, 1, ''),
(117, 102, 109, 2278, 1, 0x0f01),
(117, 102, 110, 2273, 1, 0x0f01),
(117, 102, 111, 2305, 1, 0x0f01),
(117, 102, 112, 2268, 1, 0x0f01),
(117, 102, 113, 2261, 1, 0x0f01),
(117, 102, 114, 2293, 1, 0x0f01),
(117, 102, 115, 7618, 1, 0x0f01),
(117, 102, 116, 7590, 1, 0x0f01),
(117, 102, 117, 7589, 1, 0x0f01),
(117, 108, 118, 8910, 1, ''),
(117, 108, 119, 2183, 1, ''),
(118, 1, 101, 2498, 1, ''),
(118, 3, 102, 1988, 1, ''),
(118, 4, 103, 2656, 1, ''),
(118, 5, 104, 2520, 1, ''),
(118, 6, 105, 8912, 1, ''),
(118, 7, 106, 2647, 1, ''),
(118, 8, 107, 2195, 1, ''),
(118, 10, 108, 1987, 1, ''),
(118, 102, 109, 2278, 1, 0x0f01),
(118, 102, 110, 2273, 1, 0x0f01),
(118, 102, 111, 2305, 1, 0x0f01),
(118, 102, 112, 2268, 1, 0x0f01),
(118, 102, 113, 2261, 1, 0x0f01),
(118, 102, 114, 2293, 1, 0x0f01),
(118, 102, 115, 7618, 1, 0x0f01),
(118, 102, 116, 7590, 1, 0x0f01),
(118, 102, 117, 7589, 1, 0x0f01),
(118, 108, 118, 8910, 1, ''),
(118, 108, 119, 2183, 1, ''),
(119, 1, 101, 2498, 1, ''),
(119, 3, 102, 1988, 1, ''),
(119, 4, 103, 2656, 1, ''),
(119, 5, 104, 2520, 1, ''),
(119, 6, 105, 8912, 1, ''),
(119, 7, 106, 2647, 1, ''),
(119, 8, 107, 2195, 1, ''),
(119, 10, 108, 1987, 1, ''),
(119, 102, 109, 2278, 1, 0x0f01),
(119, 102, 110, 2273, 1, 0x0f01),
(119, 102, 111, 2305, 1, 0x0f01),
(119, 102, 112, 2268, 1, 0x0f01),
(119, 102, 113, 2261, 1, 0x0f01),
(119, 102, 114, 2293, 1, 0x0f01),
(119, 102, 115, 7618, 1, 0x0f01),
(119, 102, 116, 7590, 1, 0x0f01),
(119, 102, 117, 7589, 1, 0x0f01),
(119, 108, 118, 8910, 1, ''),
(119, 108, 119, 2183, 1, ''),
(120, 1, 101, 2498, 1, ''),
(120, 3, 102, 1988, 1, ''),
(120, 4, 103, 2656, 1, ''),
(120, 5, 104, 2520, 1, ''),
(120, 6, 105, 8912, 1, ''),
(120, 7, 106, 2647, 1, ''),
(120, 8, 107, 2195, 1, ''),
(120, 10, 108, 1987, 1, ''),
(120, 102, 109, 2278, 1, 0x0f01),
(120, 102, 110, 2273, 1, 0x0f01),
(120, 102, 111, 2305, 1, 0x0f01),
(120, 102, 112, 2268, 1, 0x0f01),
(120, 102, 113, 2261, 1, 0x0f01),
(120, 102, 114, 2293, 1, 0x0f01),
(120, 102, 115, 7618, 1, 0x0f01),
(120, 102, 116, 7590, 1, 0x0f01),
(120, 102, 117, 7589, 1, 0x0f01),
(120, 108, 118, 8910, 1, ''),
(120, 108, 119, 2183, 1, ''),
(121, 1, 101, 2498, 1, ''),
(121, 3, 102, 1988, 1, ''),
(121, 4, 103, 2656, 1, ''),
(121, 5, 104, 2520, 1, ''),
(121, 6, 105, 8912, 1, ''),
(121, 7, 106, 2647, 1, ''),
(121, 8, 107, 2195, 1, ''),
(121, 10, 108, 1987, 1, ''),
(121, 102, 109, 2278, 1, 0x0f01),
(121, 102, 110, 2273, 1, 0x0f01),
(121, 102, 111, 2305, 1, 0x0f01),
(121, 102, 112, 2268, 1, 0x0f01),
(121, 102, 113, 2261, 1, 0x0f01),
(121, 102, 114, 2293, 1, 0x0f01),
(121, 102, 115, 7618, 1, 0x0f01),
(121, 102, 116, 7590, 1, 0x0f01),
(121, 102, 117, 7589, 1, 0x0f01),
(121, 108, 118, 8910, 1, ''),
(121, 108, 119, 2183, 1, ''),
(122, 1, 101, 2498, 1, ''),
(122, 3, 102, 1988, 1, ''),
(122, 4, 103, 2656, 1, ''),
(122, 5, 104, 2520, 1, ''),
(122, 6, 105, 8912, 1, ''),
(122, 7, 106, 2647, 1, ''),
(122, 8, 107, 2195, 1, ''),
(122, 10, 108, 1987, 1, ''),
(122, 102, 109, 2278, 1, 0x0f01),
(122, 102, 110, 2273, 1, 0x0f01),
(122, 102, 111, 2305, 1, 0x0f01),
(122, 102, 112, 2268, 1, 0x0f01),
(122, 102, 113, 2261, 1, 0x0f01),
(122, 102, 114, 2293, 1, 0x0f01),
(122, 102, 115, 7618, 1, 0x0f01),
(122, 102, 116, 7590, 1, 0x0f01),
(122, 102, 117, 7589, 1, 0x0f01),
(122, 108, 118, 8910, 1, ''),
(122, 108, 119, 2183, 1, ''),
(123, 1, 101, 2498, 1, ''),
(123, 3, 102, 1988, 1, ''),
(123, 4, 103, 2656, 1, ''),
(123, 5, 104, 2520, 1, ''),
(123, 6, 105, 8912, 1, ''),
(123, 7, 106, 2647, 1, ''),
(123, 8, 107, 2195, 1, ''),
(123, 10, 108, 1987, 1, ''),
(123, 102, 109, 2278, 1, 0x0f01),
(123, 102, 110, 2273, 1, 0x0f01),
(123, 102, 111, 2305, 1, 0x0f01),
(123, 102, 112, 2268, 1, 0x0f01),
(123, 102, 113, 2261, 1, 0x0f01),
(123, 102, 114, 2293, 1, 0x0f01),
(123, 102, 115, 7618, 1, 0x0f01),
(123, 102, 116, 7590, 1, 0x0f01),
(123, 102, 117, 7589, 1, 0x0f01),
(123, 108, 118, 8910, 1, ''),
(123, 108, 119, 2183, 1, ''),
(124, 1, 101, 2498, 1, ''),
(124, 3, 102, 1988, 1, ''),
(124, 4, 103, 2656, 1, ''),
(124, 5, 104, 2520, 1, ''),
(124, 6, 105, 8912, 1, ''),
(124, 7, 106, 2647, 1, ''),
(124, 8, 107, 2195, 1, ''),
(124, 10, 108, 1987, 1, ''),
(124, 102, 109, 2278, 1, 0x0f01),
(124, 102, 110, 2273, 1, 0x0f01),
(124, 102, 111, 2305, 1, 0x0f01),
(124, 102, 112, 2268, 1, 0x0f01),
(124, 102, 113, 2261, 1, 0x0f01),
(124, 102, 114, 2293, 1, 0x0f01),
(124, 102, 115, 7618, 1, 0x0f01),
(124, 102, 116, 7590, 1, 0x0f01),
(124, 102, 117, 7589, 1, 0x0f01),
(124, 108, 118, 8910, 1, ''),
(124, 108, 119, 2183, 1, ''),
(125, 1, 101, 2498, 1, ''),
(125, 3, 102, 1988, 1, ''),
(125, 4, 103, 2656, 1, ''),
(125, 5, 104, 2520, 1, ''),
(125, 6, 105, 8912, 1, ''),
(125, 7, 106, 2647, 1, ''),
(125, 8, 107, 2195, 1, ''),
(125, 10, 108, 1987, 1, ''),
(125, 102, 109, 2278, 1, 0x0f01),
(125, 102, 110, 2273, 1, 0x0f01),
(125, 102, 111, 2305, 1, 0x0f01),
(125, 102, 112, 2268, 1, 0x0f01),
(125, 102, 113, 2261, 1, 0x0f01),
(125, 102, 114, 2293, 1, 0x0f01),
(125, 102, 115, 7618, 1, 0x0f01),
(125, 102, 116, 7590, 1, 0x0f01),
(125, 102, 117, 7589, 1, 0x0f01),
(125, 108, 118, 8910, 1, ''),
(125, 108, 119, 2183, 1, ''),
(126, 1, 101, 2498, 1, ''),
(126, 3, 102, 1988, 1, ''),
(126, 4, 103, 2656, 1, ''),
(126, 5, 104, 2520, 1, ''),
(126, 6, 105, 8912, 1, ''),
(126, 7, 106, 2647, 1, ''),
(126, 8, 107, 2195, 1, ''),
(126, 10, 108, 1987, 1, ''),
(126, 102, 109, 2278, 1, 0x0f01),
(126, 102, 110, 2273, 1, 0x0f01),
(126, 102, 111, 2305, 1, 0x0f01),
(126, 102, 112, 2268, 1, 0x0f01),
(126, 102, 113, 2261, 1, 0x0f01),
(126, 102, 114, 2293, 1, 0x0f01),
(126, 102, 115, 7618, 1, 0x0f01),
(126, 102, 116, 7590, 1, 0x0f01),
(126, 102, 117, 7589, 1, 0x0f01),
(126, 108, 118, 8910, 1, ''),
(126, 108, 119, 2183, 1, ''),
(127, 1, 101, 2498, 1, ''),
(127, 3, 102, 1988, 1, ''),
(127, 4, 103, 2656, 1, ''),
(127, 5, 104, 2520, 1, ''),
(127, 6, 105, 8912, 1, ''),
(127, 7, 106, 2647, 1, ''),
(127, 8, 107, 2195, 1, ''),
(127, 10, 108, 1987, 1, ''),
(127, 102, 109, 2278, 1, 0x0f01),
(127, 102, 110, 2273, 1, 0x0f01),
(127, 102, 111, 2305, 1, 0x0f01),
(127, 102, 112, 2268, 1, 0x0f01),
(127, 102, 113, 2261, 1, 0x0f01),
(127, 102, 114, 2293, 1, 0x0f01),
(127, 102, 115, 7618, 1, 0x0f01),
(127, 102, 116, 7590, 1, 0x0f01),
(127, 102, 117, 7589, 1, 0x0f01),
(127, 108, 118, 8910, 1, ''),
(127, 108, 119, 2183, 1, ''),
(128, 1, 101, 2498, 1, ''),
(128, 3, 102, 1988, 1, ''),
(128, 4, 103, 2656, 1, ''),
(128, 5, 104, 2520, 1, ''),
(128, 6, 105, 8912, 1, ''),
(128, 7, 106, 2647, 1, ''),
(128, 8, 107, 2195, 1, ''),
(128, 10, 108, 1987, 1, ''),
(128, 102, 109, 2278, 1, 0x0f01),
(128, 102, 110, 2273, 1, 0x0f01),
(128, 102, 111, 2305, 1, 0x0f01),
(128, 102, 112, 2268, 1, 0x0f01),
(128, 102, 113, 2261, 1, 0x0f01),
(128, 102, 114, 2293, 1, 0x0f01),
(128, 102, 115, 7618, 1, 0x0f01),
(128, 102, 116, 7590, 1, 0x0f01),
(128, 102, 117, 7589, 1, 0x0f01),
(128, 108, 118, 8910, 1, ''),
(128, 108, 119, 2183, 1, ''),
(129, 1, 101, 2498, 1, ''),
(129, 3, 102, 1988, 1, ''),
(129, 4, 103, 2656, 1, ''),
(129, 5, 104, 2520, 1, ''),
(129, 6, 105, 8912, 1, ''),
(129, 7, 106, 2647, 1, ''),
(129, 8, 107, 2195, 1, ''),
(129, 10, 108, 1987, 1, ''),
(129, 102, 109, 2278, 1, 0x0f01),
(129, 102, 110, 2273, 1, 0x0f01),
(129, 102, 111, 2305, 1, 0x0f01),
(129, 102, 112, 2268, 1, 0x0f01),
(129, 102, 113, 2261, 1, 0x0f01),
(129, 102, 114, 2293, 1, 0x0f01),
(129, 102, 115, 7618, 1, 0x0f01),
(129, 102, 116, 7590, 1, 0x0f01),
(129, 102, 117, 7589, 1, 0x0f01),
(129, 108, 118, 8910, 1, ''),
(129, 108, 119, 2183, 1, ''),
(130, 1, 101, 2498, 1, ''),
(130, 3, 102, 1988, 1, ''),
(130, 4, 103, 2656, 1, ''),
(130, 5, 104, 2520, 1, ''),
(130, 6, 105, 8912, 1, ''),
(130, 7, 106, 2647, 1, ''),
(130, 8, 107, 2195, 1, ''),
(130, 10, 108, 1987, 1, ''),
(130, 102, 109, 2278, 1, 0x0f01),
(130, 102, 110, 2273, 1, 0x0f01),
(130, 102, 111, 2305, 1, 0x0f01),
(130, 102, 112, 2268, 1, 0x0f01),
(130, 102, 113, 2261, 1, 0x0f01),
(130, 102, 114, 2293, 1, 0x0f01),
(130, 102, 115, 7618, 1, 0x0f01),
(130, 102, 116, 7590, 1, 0x0f01),
(130, 102, 117, 7589, 1, 0x0f01),
(130, 108, 118, 8910, 1, ''),
(130, 108, 119, 2183, 1, ''),
(131, 1, 101, 2498, 1, ''),
(131, 3, 102, 1988, 1, ''),
(131, 4, 103, 2656, 1, ''),
(131, 5, 104, 2520, 1, ''),
(131, 6, 105, 8912, 1, ''),
(131, 7, 106, 2647, 1, ''),
(131, 8, 107, 2195, 1, ''),
(131, 10, 108, 1987, 1, ''),
(131, 102, 109, 2278, 1, 0x0f01),
(131, 102, 110, 2273, 1, 0x0f01),
(131, 102, 111, 2305, 1, 0x0f01),
(131, 102, 112, 2268, 1, 0x0f01),
(131, 102, 113, 2261, 1, 0x0f01),
(131, 102, 114, 2293, 1, 0x0f01),
(131, 102, 115, 7618, 1, 0x0f01),
(131, 102, 116, 7590, 1, 0x0f01),
(131, 102, 117, 7589, 1, 0x0f01),
(131, 108, 118, 8910, 1, ''),
(131, 108, 119, 2183, 1, ''),
(132, 1, 101, 2498, 1, ''),
(132, 3, 102, 1988, 1, ''),
(132, 4, 103, 2656, 1, ''),
(132, 5, 104, 2520, 1, ''),
(132, 6, 105, 8912, 1, ''),
(132, 7, 106, 2647, 1, ''),
(132, 8, 107, 2195, 1, ''),
(132, 10, 108, 1987, 1, ''),
(132, 102, 109, 2278, 1, 0x0f01),
(132, 102, 110, 2273, 1, 0x0f01),
(132, 102, 111, 2305, 1, 0x0f01),
(132, 102, 112, 2268, 1, 0x0f01),
(132, 102, 113, 2261, 1, 0x0f01),
(132, 102, 114, 2293, 1, 0x0f01),
(132, 102, 115, 7618, 1, 0x0f01),
(132, 102, 116, 7590, 1, 0x0f01),
(132, 102, 117, 7589, 1, 0x0f01),
(132, 108, 118, 8910, 1, ''),
(132, 108, 119, 2183, 1, ''),
(133, 1, 101, 2498, 1, ''),
(133, 3, 102, 1988, 1, ''),
(133, 4, 103, 2656, 1, ''),
(133, 5, 104, 2520, 1, ''),
(133, 6, 105, 8912, 1, ''),
(133, 7, 106, 2647, 1, ''),
(133, 8, 107, 2195, 1, ''),
(133, 10, 108, 1987, 1, ''),
(133, 102, 109, 2278, 1, 0x0f01),
(133, 102, 110, 2273, 1, 0x0f01),
(133, 102, 111, 2305, 1, 0x0f01),
(133, 102, 112, 2268, 1, 0x0f01),
(133, 102, 113, 2261, 1, 0x0f01),
(133, 102, 114, 2293, 1, 0x0f01),
(133, 102, 115, 7618, 1, 0x0f01),
(133, 102, 116, 7590, 1, 0x0f01),
(133, 102, 117, 7589, 1, 0x0f01),
(133, 108, 118, 8910, 1, ''),
(133, 108, 119, 2183, 1, ''),
(134, 1, 101, 2498, 1, ''),
(134, 3, 102, 1988, 1, ''),
(134, 4, 103, 2656, 1, ''),
(134, 5, 104, 2520, 1, ''),
(134, 6, 105, 8912, 1, ''),
(134, 7, 106, 2647, 1, ''),
(134, 8, 107, 2195, 1, ''),
(134, 10, 108, 1987, 1, ''),
(134, 102, 109, 2278, 1, 0x0f01),
(134, 102, 110, 2273, 1, 0x0f01),
(134, 102, 111, 2305, 1, 0x0f01),
(134, 102, 112, 2268, 1, 0x0f01),
(134, 102, 113, 2261, 1, 0x0f01),
(134, 102, 114, 2293, 1, 0x0f01),
(134, 102, 115, 7618, 1, 0x0f01),
(134, 102, 116, 7590, 1, 0x0f01),
(134, 102, 117, 7589, 1, 0x0f01),
(134, 108, 118, 8910, 1, ''),
(134, 108, 119, 2183, 1, ''),
(135, 1, 101, 2498, 1, ''),
(135, 3, 102, 1988, 1, ''),
(135, 4, 103, 2656, 1, ''),
(135, 5, 104, 2520, 1, ''),
(135, 6, 105, 8912, 1, ''),
(135, 7, 106, 2647, 1, ''),
(135, 8, 107, 2195, 1, ''),
(135, 10, 108, 1987, 1, ''),
(135, 102, 109, 2278, 1, 0x0f01),
(135, 102, 110, 2273, 1, 0x0f01),
(135, 102, 111, 2305, 1, 0x0f01),
(135, 102, 112, 2268, 1, 0x0f01),
(135, 102, 113, 2261, 1, 0x0f01),
(135, 102, 114, 2293, 1, 0x0f01),
(135, 102, 115, 7618, 1, 0x0f01),
(135, 102, 116, 7590, 1, 0x0f01),
(135, 102, 117, 7589, 1, 0x0f01),
(135, 108, 118, 8910, 1, ''),
(135, 108, 119, 2183, 1, ''),
(136, 1, 101, 2498, 1, ''),
(136, 3, 102, 1988, 1, ''),
(136, 4, 103, 2656, 1, ''),
(136, 5, 104, 2520, 1, ''),
(136, 6, 105, 8912, 1, ''),
(136, 7, 106, 2647, 1, ''),
(136, 8, 107, 2195, 1, ''),
(136, 10, 108, 1987, 1, ''),
(136, 102, 109, 2278, 1, 0x0f01),
(136, 102, 110, 2273, 1, 0x0f01),
(136, 102, 111, 2305, 1, 0x0f01),
(136, 102, 112, 2268, 1, 0x0f01),
(136, 102, 113, 2261, 1, 0x0f01),
(136, 102, 114, 2293, 1, 0x0f01),
(136, 102, 115, 7618, 1, 0x0f01),
(136, 102, 116, 7590, 1, 0x0f01),
(136, 102, 117, 7589, 1, 0x0f01),
(136, 108, 118, 8910, 1, ''),
(136, 108, 119, 2183, 1, ''),
(137, 1, 101, 2498, 1, ''),
(137, 3, 102, 1988, 1, ''),
(137, 4, 103, 2656, 1, ''),
(137, 5, 104, 2520, 1, ''),
(137, 6, 105, 8912, 1, ''),
(137, 7, 106, 2647, 1, ''),
(137, 8, 107, 2195, 1, ''),
(137, 10, 108, 1987, 1, ''),
(137, 102, 109, 2278, 1, 0x0f01),
(137, 102, 110, 2273, 1, 0x0f01),
(137, 102, 111, 2305, 1, 0x0f01),
(137, 102, 112, 2268, 1, 0x0f01),
(137, 102, 113, 2261, 1, 0x0f01),
(137, 102, 114, 2293, 1, 0x0f01),
(137, 102, 115, 7618, 1, 0x0f01),
(137, 102, 116, 7590, 1, 0x0f01),
(137, 102, 117, 7589, 1, 0x0f01),
(137, 108, 118, 8910, 1, ''),
(137, 108, 119, 2183, 1, ''),
(138, 1, 101, 2498, 1, ''),
(138, 3, 102, 1988, 1, ''),
(138, 4, 103, 2656, 1, ''),
(138, 5, 104, 2520, 1, ''),
(138, 6, 105, 8912, 1, ''),
(138, 7, 106, 2647, 1, ''),
(138, 8, 107, 2195, 1, ''),
(138, 10, 108, 1987, 1, ''),
(138, 102, 109, 2278, 1, 0x0f01),
(138, 102, 110, 2273, 1, 0x0f01),
(138, 102, 111, 2305, 1, 0x0f01),
(138, 102, 112, 2268, 1, 0x0f01),
(138, 102, 113, 2261, 1, 0x0f01),
(138, 102, 114, 2293, 1, 0x0f01),
(138, 102, 115, 7618, 1, 0x0f01),
(138, 102, 116, 7590, 1, 0x0f01),
(138, 102, 117, 7589, 1, 0x0f01),
(138, 108, 118, 8910, 1, ''),
(138, 108, 119, 2183, 1, ''),
(139, 1, 101, 2498, 1, ''),
(139, 3, 102, 1988, 1, ''),
(139, 4, 103, 2656, 1, ''),
(139, 5, 104, 2520, 1, ''),
(139, 6, 105, 8912, 1, ''),
(139, 7, 106, 2647, 1, ''),
(139, 8, 107, 2195, 1, ''),
(139, 10, 108, 1987, 1, ''),
(139, 102, 109, 2278, 1, 0x0f01),
(139, 102, 110, 2273, 1, 0x0f01),
(139, 102, 111, 2305, 1, 0x0f01),
(139, 102, 112, 2268, 1, 0x0f01),
(139, 102, 113, 2261, 1, 0x0f01),
(139, 102, 114, 2293, 1, 0x0f01),
(139, 102, 115, 7618, 1, 0x0f01),
(139, 102, 116, 7590, 1, 0x0f01),
(139, 102, 117, 7589, 1, 0x0f01),
(139, 108, 118, 8910, 1, ''),
(139, 108, 119, 2183, 1, ''),
(140, 1, 101, 2498, 1, ''),
(140, 3, 102, 1988, 1, ''),
(140, 4, 103, 2656, 1, ''),
(140, 5, 104, 2520, 1, ''),
(140, 6, 105, 8912, 1, ''),
(140, 7, 106, 2647, 1, ''),
(140, 8, 107, 2195, 1, ''),
(140, 10, 108, 1987, 1, ''),
(140, 102, 109, 2278, 1, 0x0f01),
(140, 102, 110, 2273, 1, 0x0f01),
(140, 102, 111, 2305, 1, 0x0f01),
(140, 102, 112, 2268, 1, 0x0f01),
(140, 102, 113, 2261, 1, 0x0f01),
(140, 102, 114, 2293, 1, 0x0f01),
(140, 102, 115, 7618, 1, 0x0f01),
(140, 102, 116, 7590, 1, 0x0f01),
(140, 102, 117, 7589, 1, 0x0f01),
(140, 108, 118, 8910, 1, ''),
(140, 108, 119, 2183, 1, ''),
(141, 1, 101, 2498, 1, ''),
(141, 3, 102, 1988, 1, ''),
(141, 4, 103, 2656, 1, ''),
(141, 5, 104, 2520, 1, ''),
(141, 6, 105, 8912, 1, ''),
(141, 7, 106, 2647, 1, ''),
(141, 8, 107, 2195, 1, ''),
(141, 10, 108, 1987, 1, ''),
(141, 102, 109, 2278, 1, 0x0f01),
(141, 102, 110, 2273, 1, 0x0f01),
(141, 102, 111, 2305, 1, 0x0f01),
(141, 102, 112, 2268, 1, 0x0f01),
(141, 102, 113, 2261, 1, 0x0f01),
(141, 102, 114, 2293, 1, 0x0f01),
(141, 102, 115, 7618, 1, 0x0f01),
(141, 102, 116, 7590, 1, 0x0f01),
(141, 102, 117, 7589, 1, 0x0f01),
(141, 108, 118, 8910, 1, ''),
(141, 108, 119, 2183, 1, ''),
(142, 1, 101, 2498, 1, ''),
(142, 3, 102, 1988, 1, ''),
(142, 4, 103, 2656, 1, ''),
(142, 5, 104, 2520, 1, ''),
(142, 6, 105, 8912, 1, ''),
(142, 7, 106, 2647, 1, ''),
(142, 8, 107, 2195, 1, ''),
(142, 10, 108, 1987, 1, ''),
(142, 102, 109, 2278, 1, 0x0f01),
(142, 102, 110, 2273, 1, 0x0f01),
(142, 102, 111, 2305, 1, 0x0f01),
(142, 102, 112, 2268, 1, 0x0f01),
(142, 102, 113, 2261, 1, 0x0f01),
(142, 102, 114, 2293, 1, 0x0f01),
(142, 102, 115, 7618, 1, 0x0f01),
(142, 102, 116, 7590, 1, 0x0f01),
(142, 102, 117, 7589, 1, 0x0f01),
(142, 108, 118, 8910, 1, ''),
(142, 108, 119, 2183, 1, ''),
(143, 1, 101, 2498, 1, ''),
(143, 3, 102, 1988, 1, ''),
(143, 4, 103, 2656, 1, ''),
(143, 5, 104, 2520, 1, ''),
(143, 6, 105, 8912, 1, ''),
(143, 7, 106, 2647, 1, ''),
(143, 8, 107, 2195, 1, ''),
(143, 10, 108, 1987, 1, ''),
(143, 102, 109, 2278, 1, 0x0f01),
(143, 102, 110, 2273, 1, 0x0f01),
(143, 102, 111, 2305, 1, 0x0f01),
(143, 102, 112, 2268, 1, 0x0f01),
(143, 102, 113, 2261, 1, 0x0f01),
(143, 102, 114, 2293, 1, 0x0f01),
(143, 102, 115, 7618, 1, 0x0f01),
(143, 102, 116, 7590, 1, 0x0f01),
(143, 102, 117, 7589, 1, 0x0f01),
(143, 108, 118, 8910, 1, ''),
(143, 108, 119, 2183, 1, ''),
(144, 1, 101, 2498, 1, ''),
(144, 3, 102, 1988, 1, ''),
(144, 4, 103, 2656, 1, ''),
(144, 5, 104, 2520, 1, ''),
(144, 6, 105, 8912, 1, ''),
(144, 7, 106, 2647, 1, ''),
(144, 8, 107, 2195, 1, ''),
(144, 10, 108, 1987, 1, ''),
(144, 102, 109, 2278, 1, 0x0f01),
(144, 102, 110, 2273, 1, 0x0f01),
(144, 102, 111, 2305, 1, 0x0f01),
(144, 102, 112, 2268, 1, 0x0f01),
(144, 102, 113, 2261, 1, 0x0f01),
(144, 102, 114, 2293, 1, 0x0f01),
(144, 102, 115, 7618, 1, 0x0f01),
(144, 102, 116, 7590, 1, 0x0f01),
(144, 102, 117, 7589, 1, 0x0f01),
(144, 108, 118, 8910, 1, ''),
(144, 108, 119, 2183, 1, ''),
(145, 1, 101, 2498, 1, ''),
(145, 3, 102, 1988, 1, ''),
(145, 4, 103, 2656, 1, ''),
(145, 5, 104, 2520, 1, ''),
(145, 6, 105, 8912, 1, ''),
(145, 7, 106, 2647, 1, ''),
(145, 8, 107, 2195, 1, ''),
(145, 10, 108, 1987, 1, ''),
(145, 102, 109, 2278, 1, 0x0f01),
(145, 102, 110, 2273, 1, 0x0f01),
(145, 102, 111, 2305, 1, 0x0f01),
(145, 102, 112, 2268, 1, 0x0f01),
(145, 102, 113, 2261, 1, 0x0f01),
(145, 102, 114, 2293, 1, 0x0f01),
(145, 102, 115, 7618, 1, 0x0f01),
(145, 102, 116, 7590, 1, 0x0f01),
(145, 102, 117, 7589, 1, 0x0f01),
(145, 108, 118, 8910, 1, ''),
(145, 108, 119, 2183, 1, ''),
(146, 1, 101, 2498, 1, ''),
(146, 3, 102, 1988, 1, ''),
(146, 4, 103, 2656, 1, ''),
(146, 5, 104, 2520, 1, ''),
(146, 6, 105, 8912, 1, ''),
(146, 7, 106, 2647, 1, ''),
(146, 8, 107, 2195, 1, ''),
(146, 10, 108, 1987, 1, ''),
(146, 102, 109, 2278, 1, 0x0f01),
(146, 102, 110, 2273, 1, 0x0f01),
(146, 102, 111, 2305, 1, 0x0f01),
(146, 102, 112, 2268, 1, 0x0f01),
(146, 102, 113, 2261, 1, 0x0f01),
(146, 102, 114, 2293, 1, 0x0f01),
(146, 102, 115, 7618, 1, 0x0f01),
(146, 102, 116, 7590, 1, 0x0f01),
(146, 102, 117, 7589, 1, 0x0f01),
(146, 108, 118, 8910, 1, ''),
(146, 108, 119, 2183, 1, ''),
(147, 1, 101, 2498, 1, ''),
(147, 3, 102, 1988, 1, ''),
(147, 4, 103, 2656, 1, ''),
(147, 5, 104, 2520, 1, ''),
(147, 6, 105, 8912, 1, ''),
(147, 7, 106, 2647, 1, ''),
(147, 8, 107, 2195, 1, ''),
(147, 10, 108, 1987, 1, ''),
(147, 102, 109, 2278, 1, 0x0f01),
(147, 102, 110, 2273, 1, 0x0f01),
(147, 102, 111, 2305, 1, 0x0f01),
(147, 102, 112, 2268, 1, 0x0f01),
(147, 102, 113, 2261, 1, 0x0f01),
(147, 102, 114, 2293, 1, 0x0f01),
(147, 102, 115, 7618, 1, 0x0f01),
(147, 102, 116, 7590, 1, 0x0f01),
(147, 102, 117, 7589, 1, 0x0f01),
(147, 108, 118, 8910, 1, ''),
(147, 108, 119, 2183, 1, ''),
(148, 1, 101, 2498, 1, ''),
(148, 3, 102, 1988, 1, ''),
(148, 4, 103, 2656, 1, ''),
(148, 5, 104, 2520, 1, ''),
(148, 6, 105, 8912, 1, ''),
(148, 7, 106, 2647, 1, ''),
(148, 8, 107, 2195, 1, ''),
(148, 10, 108, 1987, 1, ''),
(148, 102, 109, 2278, 1, 0x0f01),
(148, 102, 110, 2273, 1, 0x0f01),
(148, 102, 111, 2305, 1, 0x0f01),
(148, 102, 112, 2268, 1, 0x0f01),
(148, 102, 113, 2261, 1, 0x0f01),
(148, 102, 114, 2293, 1, 0x0f01),
(148, 102, 115, 7618, 1, 0x0f01),
(148, 102, 116, 7590, 1, 0x0f01),
(148, 102, 117, 7589, 1, 0x0f01),
(148, 108, 118, 8910, 1, ''),
(148, 108, 119, 2183, 1, ''),
(149, 1, 101, 2498, 1, ''),
(149, 3, 102, 1988, 1, ''),
(149, 4, 103, 2656, 1, ''),
(149, 5, 104, 2520, 1, ''),
(149, 6, 105, 8912, 1, ''),
(149, 7, 106, 2647, 1, ''),
(149, 8, 107, 2195, 1, ''),
(149, 10, 108, 1987, 1, ''),
(149, 102, 109, 2278, 1, 0x0f01),
(149, 102, 110, 2273, 1, 0x0f01),
(149, 102, 111, 2305, 1, 0x0f01),
(149, 102, 112, 2268, 1, 0x0f01),
(149, 102, 113, 2261, 1, 0x0f01),
(149, 102, 114, 2293, 1, 0x0f01),
(149, 102, 115, 7618, 1, 0x0f01),
(149, 102, 116, 7590, 1, 0x0f01),
(149, 102, 117, 7589, 1, 0x0f01),
(149, 108, 118, 8910, 1, ''),
(149, 108, 119, 2183, 1, ''),
(150, 1, 101, 2498, 1, ''),
(150, 3, 102, 1988, 1, ''),
(150, 4, 103, 2656, 1, ''),
(150, 5, 104, 2520, 1, ''),
(150, 6, 105, 8912, 1, ''),
(150, 7, 106, 2647, 1, ''),
(150, 8, 107, 2195, 1, ''),
(150, 10, 108, 1987, 1, ''),
(150, 102, 109, 2278, 1, 0x0f01),
(150, 102, 110, 2273, 1, 0x0f01),
(150, 102, 111, 2305, 1, 0x0f01),
(150, 102, 112, 2268, 1, 0x0f01),
(150, 102, 113, 2261, 1, 0x0f01),
(150, 102, 114, 2293, 1, 0x0f01),
(150, 102, 115, 7618, 1, 0x0f01),
(150, 102, 116, 7590, 1, 0x0f01),
(150, 102, 117, 7589, 1, 0x0f01),
(150, 108, 118, 8910, 1, ''),
(150, 108, 119, 2183, 1, ''),
(151, 1, 101, 2498, 1, ''),
(151, 3, 102, 1988, 1, ''),
(151, 4, 103, 2656, 1, ''),
(151, 5, 104, 2520, 1, ''),
(151, 6, 105, 8912, 1, ''),
(151, 7, 106, 2647, 1, ''),
(151, 8, 107, 2195, 1, ''),
(151, 10, 108, 1987, 1, ''),
(151, 102, 109, 2278, 1, 0x0f01),
(151, 102, 110, 2273, 1, 0x0f01),
(151, 102, 111, 2305, 1, 0x0f01),
(151, 102, 112, 2268, 1, 0x0f01),
(151, 102, 113, 2261, 1, 0x0f01),
(151, 102, 114, 2293, 1, 0x0f01),
(151, 102, 115, 7618, 1, 0x0f01),
(151, 102, 116, 7590, 1, 0x0f01),
(151, 102, 117, 7589, 1, 0x0f01),
(151, 108, 118, 8910, 1, ''),
(151, 108, 119, 2183, 1, ''),
(152, 1, 101, 2498, 1, ''),
(152, 3, 102, 1988, 1, ''),
(152, 4, 103, 2656, 1, ''),
(152, 5, 104, 2520, 1, ''),
(152, 6, 105, 8912, 1, ''),
(152, 7, 106, 2647, 1, ''),
(152, 8, 107, 2195, 1, ''),
(152, 10, 108, 1987, 1, ''),
(152, 102, 109, 2278, 1, 0x0f01),
(152, 102, 110, 2273, 1, 0x0f01),
(152, 102, 111, 2305, 1, 0x0f01),
(152, 102, 112, 2268, 1, 0x0f01),
(152, 102, 113, 2261, 1, 0x0f01),
(152, 102, 114, 2293, 1, 0x0f01),
(152, 102, 115, 7618, 1, 0x0f01),
(152, 102, 116, 7590, 1, 0x0f01),
(152, 102, 117, 7589, 1, 0x0f01),
(152, 108, 118, 8910, 1, ''),
(152, 108, 119, 2183, 1, ''),
(153, 1, 101, 2498, 1, ''),
(153, 3, 102, 1988, 1, ''),
(153, 4, 103, 2656, 1, ''),
(153, 5, 104, 2520, 1, ''),
(153, 6, 105, 8912, 1, ''),
(153, 7, 106, 2647, 1, ''),
(153, 8, 107, 2195, 1, ''),
(153, 10, 108, 1987, 1, ''),
(153, 102, 109, 2278, 1, 0x0f01),
(153, 102, 110, 2273, 1, 0x0f01),
(153, 102, 111, 2305, 1, 0x0f01),
(153, 102, 112, 2268, 1, 0x0f01),
(153, 102, 113, 2261, 1, 0x0f01),
(153, 102, 114, 2293, 1, 0x0f01),
(153, 102, 115, 7618, 1, 0x0f01),
(153, 102, 116, 7590, 1, 0x0f01),
(153, 102, 117, 7589, 1, 0x0f01),
(153, 108, 118, 8910, 1, ''),
(153, 108, 119, 2183, 1, ''),
(154, 1, 101, 2498, 1, ''),
(154, 3, 102, 1988, 1, ''),
(154, 4, 103, 2656, 1, ''),
(154, 5, 104, 2520, 1, ''),
(154, 6, 105, 8912, 1, ''),
(154, 7, 106, 2647, 1, ''),
(154, 8, 107, 2195, 1, ''),
(154, 10, 108, 1987, 1, ''),
(154, 102, 109, 2278, 1, 0x0f01),
(154, 102, 110, 2273, 1, 0x0f01),
(154, 102, 111, 2305, 1, 0x0f01),
(154, 102, 112, 2268, 1, 0x0f01),
(154, 102, 113, 2261, 1, 0x0f01),
(154, 102, 114, 2293, 1, 0x0f01),
(154, 102, 115, 7618, 1, 0x0f01),
(154, 102, 116, 7590, 1, 0x0f01),
(154, 102, 117, 7589, 1, 0x0f01),
(154, 108, 118, 8910, 1, ''),
(154, 108, 119, 2183, 1, ''),
(155, 1, 101, 2498, 1, ''),
(155, 3, 102, 1988, 1, ''),
(155, 4, 103, 2656, 1, ''),
(155, 5, 104, 2520, 1, ''),
(155, 6, 105, 8912, 1, ''),
(155, 7, 106, 2647, 1, ''),
(155, 8, 107, 2195, 1, ''),
(155, 10, 108, 1987, 1, ''),
(155, 102, 109, 2278, 1, 0x0f01),
(155, 102, 110, 2273, 1, 0x0f01),
(155, 102, 111, 2305, 1, 0x0f01),
(155, 102, 112, 2268, 1, 0x0f01),
(155, 102, 113, 2261, 1, 0x0f01),
(155, 102, 114, 2293, 1, 0x0f01),
(155, 102, 115, 7618, 1, 0x0f01),
(155, 102, 116, 7590, 1, 0x0f01),
(155, 102, 117, 7589, 1, 0x0f01),
(155, 108, 118, 8910, 1, ''),
(155, 108, 119, 2183, 1, ''),
(156, 1, 101, 2498, 1, ''),
(156, 3, 102, 1988, 1, ''),
(156, 4, 103, 2656, 1, ''),
(156, 5, 104, 2520, 1, ''),
(156, 6, 105, 8912, 1, ''),
(156, 7, 106, 2647, 1, ''),
(156, 8, 107, 2195, 1, ''),
(156, 10, 108, 1987, 1, ''),
(156, 102, 109, 2278, 1, 0x0f01),
(156, 102, 110, 2273, 1, 0x0f01),
(156, 102, 111, 2305, 1, 0x0f01),
(156, 102, 112, 2268, 1, 0x0f01),
(156, 102, 113, 2261, 1, 0x0f01),
(156, 102, 114, 2293, 1, 0x0f01),
(156, 102, 115, 7618, 1, 0x0f01),
(156, 102, 116, 7590, 1, 0x0f01),
(156, 102, 117, 7589, 1, 0x0f01),
(156, 108, 118, 8910, 1, ''),
(156, 108, 119, 2183, 1, ''),
(157, 1, 101, 2498, 1, ''),
(157, 3, 102, 1988, 1, ''),
(157, 4, 103, 2656, 1, ''),
(157, 5, 104, 2520, 1, ''),
(157, 6, 105, 8912, 1, ''),
(157, 7, 106, 2647, 1, ''),
(157, 8, 107, 2195, 1, ''),
(157, 10, 108, 1987, 1, ''),
(157, 102, 109, 2278, 1, 0x0f01),
(157, 102, 110, 2273, 1, 0x0f01),
(157, 102, 111, 2305, 1, 0x0f01),
(157, 102, 112, 2268, 1, 0x0f01),
(157, 102, 113, 2261, 1, 0x0f01),
(157, 102, 114, 2293, 1, 0x0f01),
(157, 102, 115, 7618, 1, 0x0f01),
(157, 102, 116, 7590, 1, 0x0f01),
(157, 102, 117, 7589, 1, 0x0f01),
(157, 108, 118, 8910, 1, ''),
(157, 108, 119, 2183, 1, ''),
(158, 1, 101, 2498, 1, ''),
(158, 3, 102, 1988, 1, ''),
(158, 4, 103, 2656, 1, ''),
(158, 5, 104, 2520, 1, ''),
(158, 6, 105, 8912, 1, ''),
(158, 7, 106, 2647, 1, ''),
(158, 8, 107, 2195, 1, ''),
(158, 10, 108, 1987, 1, ''),
(158, 102, 109, 2278, 1, 0x0f01),
(158, 102, 110, 2273, 1, 0x0f01),
(158, 102, 111, 2305, 1, 0x0f01),
(158, 102, 112, 2268, 1, 0x0f01),
(158, 102, 113, 2261, 1, 0x0f01),
(158, 102, 114, 2293, 1, 0x0f01),
(158, 102, 115, 7618, 1, 0x0f01),
(158, 102, 116, 7590, 1, 0x0f01),
(158, 102, 117, 7589, 1, 0x0f01),
(158, 108, 118, 8910, 1, ''),
(158, 108, 119, 2183, 1, ''),
(159, 1, 101, 2498, 1, ''),
(159, 3, 102, 1988, 1, ''),
(159, 4, 103, 2656, 1, ''),
(159, 5, 104, 2520, 1, ''),
(159, 6, 105, 8912, 1, ''),
(159, 7, 106, 2647, 1, ''),
(159, 8, 107, 2195, 1, ''),
(159, 10, 108, 1987, 1, ''),
(159, 102, 109, 2278, 1, 0x0f01),
(159, 102, 110, 2273, 1, 0x0f01),
(159, 102, 111, 2305, 1, 0x0f01),
(159, 102, 112, 2268, 1, 0x0f01),
(159, 102, 113, 2261, 1, 0x0f01),
(159, 102, 114, 2293, 1, 0x0f01),
(159, 102, 115, 7618, 1, 0x0f01),
(159, 102, 116, 7590, 1, 0x0f01),
(159, 102, 117, 7589, 1, 0x0f01),
(159, 108, 118, 8910, 1, ''),
(159, 108, 119, 2183, 1, ''),
(160, 1, 101, 2498, 1, ''),
(160, 3, 102, 1988, 1, ''),
(160, 4, 103, 2656, 1, ''),
(160, 5, 104, 2520, 1, ''),
(160, 6, 105, 8912, 1, ''),
(160, 7, 106, 2647, 1, ''),
(160, 8, 107, 2195, 1, ''),
(160, 10, 108, 1987, 1, ''),
(160, 102, 109, 2278, 1, 0x0f01),
(160, 102, 110, 2273, 1, 0x0f01),
(160, 102, 111, 2305, 1, 0x0f01),
(160, 102, 112, 2268, 1, 0x0f01),
(160, 102, 113, 2261, 1, 0x0f01),
(160, 102, 114, 2293, 1, 0x0f01),
(160, 102, 115, 7618, 1, 0x0f01),
(160, 102, 116, 7590, 1, 0x0f01),
(160, 102, 117, 7589, 1, 0x0f01),
(160, 108, 118, 8910, 1, ''),
(160, 108, 119, 2183, 1, ''),
(161, 1, 101, 2498, 1, ''),
(161, 3, 102, 1988, 1, ''),
(161, 4, 103, 2492, 1, ''),
(161, 5, 104, 7367, 1, 0x0f01),
(161, 6, 105, 2520, 1, ''),
(161, 7, 106, 2488, 1, ''),
(161, 8, 107, 2195, 1, ''),
(161, 102, 108, 2273, 1, 0x0f01),
(161, 102, 109, 2268, 1, 0x0f01),
(161, 102, 110, 2305, 1, 0x0f01),
(161, 102, 111, 2261, 1, 0x0f01),
(161, 102, 112, 2293, 1, 0x0f01),
(161, 102, 113, 8472, 1, 0x0f01),
(161, 102, 114, 7620, 1, 0x0f01),
(161, 102, 115, 7589, 1, 0x0f01),
(161, 102, 116, 7588, 1, 0x0f01),
(162, 1, 101, 2498, 1, ''),
(162, 3, 102, 1988, 1, ''),
(162, 4, 103, 2492, 1, ''),
(162, 5, 104, 7367, 1, 0x0f01),
(162, 6, 105, 2520, 1, ''),
(162, 7, 106, 2488, 1, ''),
(162, 8, 107, 2195, 1, ''),
(162, 102, 108, 2273, 1, 0x0f01),
(162, 102, 109, 2268, 1, 0x0f01),
(162, 102, 110, 2305, 1, 0x0f01),
(162, 102, 111, 2261, 1, 0x0f01),
(162, 102, 112, 2293, 1, 0x0f01),
(162, 102, 113, 8472, 1, 0x0f01),
(162, 102, 114, 7620, 1, 0x0f01),
(162, 102, 115, 7589, 1, 0x0f01),
(162, 102, 116, 7588, 1, 0x0f01),
(163, 1, 101, 2498, 1, ''),
(163, 3, 102, 1988, 1, ''),
(163, 4, 103, 2492, 1, ''),
(163, 5, 104, 7367, 1, 0x0f01),
(163, 6, 105, 2520, 1, ''),
(163, 7, 106, 2488, 1, ''),
(163, 8, 107, 2195, 1, ''),
(163, 102, 108, 2273, 1, 0x0f01),
(163, 102, 109, 2268, 1, 0x0f01),
(163, 102, 110, 2305, 1, 0x0f01),
(163, 102, 111, 2261, 1, 0x0f01),
(163, 102, 112, 2293, 1, 0x0f01),
(163, 102, 113, 8472, 1, 0x0f01),
(163, 102, 114, 7620, 1, 0x0f01),
(163, 102, 115, 7589, 1, 0x0f01),
(163, 102, 116, 7588, 1, 0x0f01),
(164, 1, 101, 2498, 1, ''),
(164, 3, 102, 1988, 1, ''),
(164, 4, 103, 2492, 1, ''),
(164, 5, 104, 7367, 1, 0x0f01),
(164, 6, 105, 2520, 1, ''),
(164, 7, 106, 2488, 1, ''),
(164, 8, 107, 2195, 1, ''),
(164, 102, 108, 2273, 1, 0x0f01),
(164, 102, 109, 2268, 1, 0x0f01),
(164, 102, 110, 2305, 1, 0x0f01),
(164, 102, 111, 2261, 1, 0x0f01),
(164, 102, 112, 2293, 1, 0x0f01),
(164, 102, 113, 8472, 1, 0x0f01),
(164, 102, 114, 7620, 1, 0x0f01),
(164, 102, 115, 7589, 1, 0x0f01),
(164, 102, 116, 7588, 1, 0x0f01),
(165, 1, 101, 2498, 1, ''),
(165, 3, 102, 1988, 1, ''),
(165, 4, 103, 2492, 1, ''),
(165, 5, 104, 7367, 1, 0x0f01),
(165, 6, 105, 2520, 1, ''),
(165, 7, 106, 2488, 1, ''),
(165, 8, 107, 2195, 1, ''),
(165, 102, 108, 2273, 1, 0x0f01),
(165, 102, 109, 2268, 1, 0x0f01),
(165, 102, 110, 2305, 1, 0x0f01),
(165, 102, 111, 2261, 1, 0x0f01),
(165, 102, 112, 2293, 1, 0x0f01),
(165, 102, 113, 8472, 1, 0x0f01),
(165, 102, 114, 7620, 1, 0x0f01),
(165, 102, 115, 7589, 1, 0x0f01),
(165, 102, 116, 7588, 1, 0x0f01),
(166, 1, 101, 2498, 1, ''),
(166, 3, 102, 1988, 1, ''),
(166, 4, 103, 2492, 1, ''),
(166, 5, 104, 7367, 1, 0x0f01),
(166, 6, 105, 2520, 1, ''),
(166, 7, 106, 2488, 1, ''),
(166, 8, 107, 2195, 1, ''),
(166, 102, 108, 2273, 1, 0x0f01),
(166, 102, 109, 2268, 1, 0x0f01),
(166, 102, 110, 2305, 1, 0x0f01),
(166, 102, 111, 2261, 1, 0x0f01),
(166, 102, 112, 2293, 1, 0x0f01),
(166, 102, 113, 8472, 1, 0x0f01),
(166, 102, 114, 7620, 1, 0x0f01),
(166, 102, 115, 7589, 1, 0x0f01),
(166, 102, 116, 7588, 1, 0x0f01),
(167, 1, 101, 2498, 1, ''),
(167, 3, 102, 1988, 1, ''),
(167, 4, 103, 2492, 1, ''),
(167, 5, 104, 7367, 1, 0x0f01),
(167, 6, 105, 2520, 1, ''),
(167, 7, 106, 2488, 1, ''),
(167, 8, 107, 2195, 1, ''),
(167, 102, 108, 2273, 1, 0x0f01),
(167, 102, 109, 2268, 1, 0x0f01),
(167, 102, 110, 2305, 1, 0x0f01),
(167, 102, 111, 2261, 1, 0x0f01),
(167, 102, 112, 2293, 1, 0x0f01),
(167, 102, 113, 8472, 1, 0x0f01),
(167, 102, 114, 7620, 1, 0x0f01),
(167, 102, 115, 7589, 1, 0x0f01),
(167, 102, 116, 7588, 1, 0x0f01),
(168, 1, 101, 2498, 1, ''),
(168, 3, 102, 1988, 1, ''),
(168, 4, 103, 2492, 1, ''),
(168, 5, 104, 7367, 1, 0x0f01),
(168, 6, 105, 2520, 1, ''),
(168, 7, 106, 2488, 1, ''),
(168, 8, 107, 2195, 1, ''),
(168, 102, 108, 2273, 1, 0x0f01),
(168, 102, 109, 2268, 1, 0x0f01),
(168, 102, 110, 2305, 1, 0x0f01),
(168, 102, 111, 2261, 1, 0x0f01),
(168, 102, 112, 2293, 1, 0x0f01),
(168, 102, 113, 8472, 1, 0x0f01),
(168, 102, 114, 7620, 1, 0x0f01),
(168, 102, 115, 7589, 1, 0x0f01),
(168, 102, 116, 7588, 1, 0x0f01),
(169, 1, 101, 2498, 1, ''),
(169, 3, 102, 1988, 1, ''),
(169, 4, 103, 2492, 1, ''),
(169, 5, 104, 7367, 1, 0x0f01),
(169, 6, 105, 2520, 1, ''),
(169, 7, 106, 2488, 1, ''),
(169, 8, 107, 2195, 1, ''),
(169, 102, 108, 2273, 1, 0x0f01),
(169, 102, 109, 2268, 1, 0x0f01),
(169, 102, 110, 2305, 1, 0x0f01),
(169, 102, 111, 2261, 1, 0x0f01),
(169, 102, 112, 2293, 1, 0x0f01),
(169, 102, 113, 8472, 1, 0x0f01),
(169, 102, 114, 7620, 1, 0x0f01),
(169, 102, 115, 7589, 1, 0x0f01),
(169, 102, 116, 7588, 1, 0x0f01),
(170, 1, 101, 2498, 1, ''),
(170, 3, 102, 1988, 1, ''),
(170, 4, 103, 2492, 1, ''),
(170, 5, 104, 7367, 1, 0x0f01),
(170, 6, 105, 2520, 1, ''),
(170, 7, 106, 2488, 1, ''),
(170, 8, 107, 2195, 1, ''),
(170, 102, 108, 2273, 1, 0x0f01),
(170, 102, 109, 2268, 1, 0x0f01),
(170, 102, 110, 2305, 1, 0x0f01),
(170, 102, 111, 2261, 1, 0x0f01),
(170, 102, 112, 2293, 1, 0x0f01),
(170, 102, 113, 8472, 1, 0x0f01),
(170, 102, 114, 7620, 1, 0x0f01),
(170, 102, 115, 7589, 1, 0x0f01),
(170, 102, 116, 7588, 1, 0x0f01),
(171, 1, 101, 2498, 1, ''),
(171, 3, 102, 1988, 1, ''),
(171, 4, 103, 2492, 1, ''),
(171, 5, 104, 7367, 1, 0x0f01),
(171, 6, 105, 2520, 1, ''),
(171, 7, 106, 2488, 1, ''),
(171, 8, 107, 2195, 1, ''),
(171, 102, 108, 2273, 1, 0x0f01),
(171, 102, 109, 2268, 1, 0x0f01),
(171, 102, 110, 2305, 1, 0x0f01),
(171, 102, 111, 2261, 1, 0x0f01),
(171, 102, 112, 2293, 1, 0x0f01),
(171, 102, 113, 8472, 1, 0x0f01),
(171, 102, 114, 7620, 1, 0x0f01),
(171, 102, 115, 7589, 1, 0x0f01),
(171, 102, 116, 7588, 1, 0x0f01),
(172, 1, 101, 2498, 1, ''),
(172, 3, 102, 1988, 1, ''),
(172, 4, 103, 2492, 1, ''),
(172, 5, 104, 7367, 1, 0x0f01),
(172, 6, 105, 2520, 1, ''),
(172, 7, 106, 2488, 1, ''),
(172, 8, 107, 2195, 1, ''),
(172, 102, 108, 2273, 1, 0x0f01),
(172, 102, 109, 2268, 1, 0x0f01),
(172, 102, 110, 2305, 1, 0x0f01),
(172, 102, 111, 2261, 1, 0x0f01),
(172, 102, 112, 2293, 1, 0x0f01),
(172, 102, 113, 8472, 1, 0x0f01),
(172, 102, 114, 7620, 1, 0x0f01),
(172, 102, 115, 7589, 1, 0x0f01),
(172, 102, 116, 7588, 1, 0x0f01),
(173, 1, 101, 2498, 1, ''),
(173, 3, 102, 1988, 1, ''),
(173, 4, 103, 2492, 1, ''),
(173, 5, 104, 7367, 1, 0x0f01),
(173, 6, 105, 2520, 1, ''),
(173, 7, 106, 2488, 1, ''),
(173, 8, 107, 2195, 1, ''),
(173, 102, 108, 2273, 1, 0x0f01),
(173, 102, 109, 2268, 1, 0x0f01),
(173, 102, 110, 2305, 1, 0x0f01),
(173, 102, 111, 2261, 1, 0x0f01),
(173, 102, 112, 2293, 1, 0x0f01),
(173, 102, 113, 8472, 1, 0x0f01),
(173, 102, 114, 7620, 1, 0x0f01),
(173, 102, 115, 7589, 1, 0x0f01),
(173, 102, 116, 7588, 1, 0x0f01),
(174, 1, 101, 2498, 1, ''),
(174, 3, 102, 1988, 1, ''),
(174, 4, 103, 2492, 1, ''),
(174, 5, 104, 7367, 1, 0x0f01),
(174, 6, 105, 2520, 1, ''),
(174, 7, 106, 2488, 1, ''),
(174, 8, 107, 2195, 1, ''),
(174, 102, 108, 2273, 1, 0x0f01),
(174, 102, 109, 2268, 1, 0x0f01),
(174, 102, 110, 2305, 1, 0x0f01),
(174, 102, 111, 2261, 1, 0x0f01),
(174, 102, 112, 2293, 1, 0x0f01),
(174, 102, 113, 8472, 1, 0x0f01),
(174, 102, 114, 7620, 1, 0x0f01),
(174, 102, 115, 7589, 1, 0x0f01),
(174, 102, 116, 7588, 1, 0x0f01),
(175, 1, 101, 2498, 1, ''),
(175, 3, 102, 1988, 1, ''),
(175, 4, 103, 2492, 1, ''),
(175, 5, 104, 7367, 1, 0x0f01),
(175, 6, 105, 2520, 1, ''),
(175, 7, 106, 2488, 1, ''),
(175, 8, 107, 2195, 1, ''),
(175, 102, 108, 2273, 1, 0x0f01),
(175, 102, 109, 2268, 1, 0x0f01),
(175, 102, 110, 2305, 1, 0x0f01),
(175, 102, 111, 2261, 1, 0x0f01),
(175, 102, 112, 2293, 1, 0x0f01),
(175, 102, 113, 8472, 1, 0x0f01),
(175, 102, 114, 7620, 1, 0x0f01),
(175, 102, 115, 7589, 1, 0x0f01),
(175, 102, 116, 7588, 1, 0x0f01),
(176, 1, 101, 2498, 1, ''),
(176, 3, 102, 1988, 1, ''),
(176, 4, 103, 2492, 1, ''),
(176, 5, 104, 7367, 1, 0x0f01),
(176, 6, 105, 2520, 1, ''),
(176, 7, 106, 2488, 1, ''),
(176, 8, 107, 2195, 1, ''),
(176, 102, 108, 2273, 1, 0x0f01),
(176, 102, 109, 2268, 1, 0x0f01),
(176, 102, 110, 2305, 1, 0x0f01),
(176, 102, 111, 2261, 1, 0x0f01),
(176, 102, 112, 2293, 1, 0x0f01),
(176, 102, 113, 8472, 1, 0x0f01),
(176, 102, 114, 7620, 1, 0x0f01),
(176, 102, 115, 7589, 1, 0x0f01),
(176, 102, 116, 7588, 1, 0x0f01),
(177, 1, 101, 2498, 1, ''),
(177, 3, 102, 1988, 1, ''),
(177, 4, 103, 2492, 1, ''),
(177, 5, 104, 7367, 1, 0x0f01),
(177, 6, 105, 2520, 1, ''),
(177, 7, 106, 2488, 1, ''),
(177, 8, 107, 2195, 1, ''),
(177, 102, 108, 2273, 1, 0x0f01),
(177, 102, 109, 2268, 1, 0x0f01),
(177, 102, 110, 2305, 1, 0x0f01),
(177, 102, 111, 2261, 1, 0x0f01),
(177, 102, 112, 2293, 1, 0x0f01),
(177, 102, 113, 8472, 1, 0x0f01),
(177, 102, 114, 7620, 1, 0x0f01),
(177, 102, 115, 7589, 1, 0x0f01),
(177, 102, 116, 7588, 1, 0x0f01),
(178, 1, 101, 2498, 1, ''),
(178, 3, 102, 1988, 1, ''),
(178, 4, 103, 2492, 1, ''),
(178, 5, 104, 7367, 1, 0x0f01),
(178, 6, 105, 2520, 1, ''),
(178, 7, 106, 2488, 1, ''),
(178, 8, 107, 2195, 1, ''),
(178, 102, 108, 2273, 1, 0x0f01),
(178, 102, 109, 2268, 1, 0x0f01),
(178, 102, 110, 2305, 1, 0x0f01),
(178, 102, 111, 2261, 1, 0x0f01),
(178, 102, 112, 2293, 1, 0x0f01),
(178, 102, 113, 8472, 1, 0x0f01),
(178, 102, 114, 7620, 1, 0x0f01),
(178, 102, 115, 7589, 1, 0x0f01),
(178, 102, 116, 7588, 1, 0x0f01),
(179, 1, 101, 2498, 1, ''),
(179, 3, 102, 1988, 1, ''),
(179, 4, 103, 2492, 1, ''),
(179, 5, 104, 7367, 1, 0x0f01),
(179, 6, 105, 2520, 1, ''),
(179, 7, 106, 2488, 1, ''),
(179, 8, 107, 2195, 1, ''),
(179, 102, 108, 2273, 1, 0x0f01),
(179, 102, 109, 2268, 1, 0x0f01),
(179, 102, 110, 2305, 1, 0x0f01),
(179, 102, 111, 2261, 1, 0x0f01),
(179, 102, 112, 2293, 1, 0x0f01),
(179, 102, 113, 8472, 1, 0x0f01),
(179, 102, 114, 7620, 1, 0x0f01),
(179, 102, 115, 7589, 1, 0x0f01),
(179, 102, 116, 7588, 1, 0x0f01),
(180, 1, 101, 2498, 1, ''),
(180, 3, 102, 1988, 1, ''),
(180, 4, 103, 2492, 1, ''),
(180, 5, 104, 7367, 1, 0x0f01),
(180, 6, 105, 2520, 1, ''),
(180, 7, 106, 2488, 1, ''),
(180, 8, 107, 2195, 1, ''),
(180, 102, 108, 2273, 1, 0x0f01),
(180, 102, 109, 2268, 1, 0x0f01),
(180, 102, 110, 2305, 1, 0x0f01),
(180, 102, 111, 2261, 1, 0x0f01),
(180, 102, 112, 2293, 1, 0x0f01),
(180, 102, 113, 8472, 1, 0x0f01),
(180, 102, 114, 7620, 1, 0x0f01),
(180, 102, 115, 7589, 1, 0x0f01),
(180, 102, 116, 7588, 1, 0x0f01),
(181, 1, 101, 2498, 1, ''),
(181, 3, 102, 1988, 1, ''),
(181, 4, 103, 2492, 1, ''),
(181, 5, 104, 7367, 1, 0x0f01),
(181, 6, 105, 2520, 1, ''),
(181, 7, 106, 2488, 1, ''),
(181, 8, 107, 2195, 1, ''),
(181, 102, 108, 2273, 1, 0x0f01),
(181, 102, 109, 2268, 1, 0x0f01),
(181, 102, 110, 2305, 1, 0x0f01),
(181, 102, 111, 2261, 1, 0x0f01),
(181, 102, 112, 2293, 1, 0x0f01),
(181, 102, 113, 8472, 1, 0x0f01),
(181, 102, 114, 7620, 1, 0x0f01),
(181, 102, 115, 7589, 1, 0x0f01),
(181, 102, 116, 7588, 1, 0x0f01),
(182, 1, 101, 2498, 1, ''),
(182, 3, 102, 1988, 1, ''),
(182, 4, 103, 2492, 1, ''),
(182, 5, 104, 7367, 1, 0x0f01),
(182, 6, 105, 2520, 1, ''),
(182, 7, 106, 2488, 1, ''),
(182, 8, 107, 2195, 1, ''),
(182, 102, 108, 2273, 1, 0x0f01),
(182, 102, 109, 2268, 1, 0x0f01),
(182, 102, 110, 2305, 1, 0x0f01),
(182, 102, 111, 2261, 1, 0x0f01),
(182, 102, 112, 2293, 1, 0x0f01),
(182, 102, 113, 8472, 1, 0x0f01),
(182, 102, 114, 7620, 1, 0x0f01),
(182, 102, 115, 7589, 1, 0x0f01),
(182, 102, 116, 7588, 1, 0x0f01),
(183, 1, 101, 2498, 1, ''),
(183, 3, 102, 1988, 1, ''),
(183, 4, 103, 2492, 1, ''),
(183, 5, 104, 7367, 1, 0x0f01),
(183, 6, 105, 2520, 1, ''),
(183, 7, 106, 2488, 1, ''),
(183, 8, 107, 2195, 1, ''),
(183, 102, 108, 2273, 1, 0x0f01),
(183, 102, 109, 2268, 1, 0x0f01),
(183, 102, 110, 2305, 1, 0x0f01),
(183, 102, 111, 2261, 1, 0x0f01),
(183, 102, 112, 2293, 1, 0x0f01),
(183, 102, 113, 8472, 1, 0x0f01),
(183, 102, 114, 7620, 1, 0x0f01),
(183, 102, 115, 7589, 1, 0x0f01),
(183, 102, 116, 7588, 1, 0x0f01),
(184, 1, 101, 2498, 1, ''),
(184, 3, 102, 1988, 1, ''),
(184, 4, 103, 2492, 1, ''),
(184, 5, 104, 7367, 1, 0x0f01),
(184, 6, 105, 2520, 1, ''),
(184, 7, 106, 2488, 1, ''),
(184, 8, 107, 2195, 1, ''),
(184, 102, 108, 2273, 1, 0x0f01),
(184, 102, 109, 2268, 1, 0x0f01),
(184, 102, 110, 2305, 1, 0x0f01),
(184, 102, 111, 2261, 1, 0x0f01),
(184, 102, 112, 2293, 1, 0x0f01),
(184, 102, 113, 8472, 1, 0x0f01),
(184, 102, 114, 7620, 1, 0x0f01),
(184, 102, 115, 7589, 1, 0x0f01),
(184, 102, 116, 7588, 1, 0x0f01),
(185, 1, 101, 2498, 1, ''),
(185, 3, 102, 1988, 1, ''),
(185, 4, 103, 2492, 1, ''),
(185, 5, 104, 7367, 1, 0x0f01),
(185, 6, 105, 2520, 1, ''),
(185, 7, 106, 2488, 1, ''),
(185, 8, 107, 2195, 1, ''),
(185, 102, 108, 2273, 1, 0x0f01),
(185, 102, 109, 2268, 1, 0x0f01),
(185, 102, 110, 2305, 1, 0x0f01),
(185, 102, 111, 2261, 1, 0x0f01),
(185, 102, 112, 2293, 1, 0x0f01),
(185, 102, 113, 8472, 1, 0x0f01),
(185, 102, 114, 7620, 1, 0x0f01),
(185, 102, 115, 7589, 1, 0x0f01),
(185, 102, 116, 7588, 1, 0x0f01),
(186, 1, 101, 2498, 1, ''),
(186, 3, 102, 1988, 1, ''),
(186, 4, 103, 2492, 1, ''),
(186, 5, 104, 2520, 1, ''),
(186, 6, 105, 7390, 1, ''),
(186, 7, 106, 2488, 1, ''),
(186, 8, 107, 2195, 1, ''),
(186, 10, 108, 1987, 1, ''),
(186, 102, 109, 2261, 1, 0x0f01),
(186, 102, 110, 2305, 1, 0x0f01),
(186, 102, 111, 2293, 1, 0x0f01),
(186, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(186, 102, 113, 7588, 1, 0x0f01),
(186, 102, 114, 8473, 1, 0x0f01),
(186, 102, 115, 7591, 1, 0x0f01),
(186, 102, 116, 7620, 1, 0x0f01),
(186, 108, 117, 7434, 1, ''),
(186, 108, 118, 7431, 1, ''),
(186, 108, 119, 7429, 1, ''),
(187, 1, 101, 2498, 1, ''),
(187, 3, 102, 1988, 1, ''),
(187, 4, 103, 2492, 1, ''),
(187, 5, 104, 2520, 1, ''),
(187, 6, 105, 7390, 1, ''),
(187, 7, 106, 2488, 1, ''),
(187, 8, 107, 2195, 1, ''),
(187, 10, 108, 1987, 1, ''),
(187, 102, 109, 2261, 1, 0x0f01),
(187, 102, 110, 2305, 1, 0x0f01),
(187, 102, 111, 2293, 1, 0x0f01),
(187, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(187, 102, 113, 7588, 1, 0x0f01),
(187, 102, 114, 8473, 1, 0x0f01),
(187, 102, 115, 7591, 1, 0x0f01),
(187, 102, 116, 7620, 1, 0x0f01),
(187, 108, 117, 7434, 1, ''),
(187, 108, 118, 7431, 1, ''),
(187, 108, 119, 7429, 1, ''),
(188, 1, 101, 2498, 1, ''),
(188, 3, 102, 1988, 1, ''),
(188, 4, 103, 2492, 1, ''),
(188, 5, 104, 2520, 1, ''),
(188, 6, 105, 7390, 1, ''),
(188, 7, 106, 2488, 1, ''),
(188, 8, 107, 2195, 1, ''),
(188, 10, 108, 1987, 1, ''),
(188, 102, 109, 2261, 1, 0x0f01),
(188, 102, 110, 2305, 1, 0x0f01),
(188, 102, 111, 2293, 1, 0x0f01),
(188, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(188, 102, 113, 7588, 1, 0x0f01),
(188, 102, 114, 8473, 1, 0x0f01),
(188, 102, 115, 7591, 1, 0x0f01),
(188, 102, 116, 7620, 1, 0x0f01),
(188, 108, 117, 7434, 1, ''),
(188, 108, 118, 7431, 1, ''),
(188, 108, 119, 7429, 1, ''),
(189, 1, 101, 2498, 1, ''),
(189, 3, 102, 1988, 1, ''),
(189, 4, 103, 2492, 1, ''),
(189, 5, 104, 2520, 1, ''),
(189, 6, 105, 7390, 1, ''),
(189, 7, 106, 2488, 1, ''),
(189, 8, 107, 2195, 1, '');
INSERT INTO `player_items` (`player_id`, `pid`, `sid`, `itemtype`, `count`, `attributes`) VALUES
(189, 10, 108, 1987, 1, ''),
(189, 102, 109, 2261, 1, 0x0f01),
(189, 102, 110, 2305, 1, 0x0f01),
(189, 102, 111, 2293, 1, 0x0f01),
(189, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(189, 102, 113, 7588, 1, 0x0f01),
(189, 102, 114, 8473, 1, 0x0f01),
(189, 102, 115, 7591, 1, 0x0f01),
(189, 102, 116, 7620, 1, 0x0f01),
(189, 108, 117, 7434, 1, ''),
(189, 108, 118, 7431, 1, ''),
(189, 108, 119, 7429, 1, ''),
(190, 1, 101, 2498, 1, ''),
(190, 3, 102, 1988, 1, ''),
(190, 4, 103, 2492, 1, ''),
(190, 5, 104, 2520, 1, ''),
(190, 6, 105, 7390, 1, ''),
(190, 7, 106, 2488, 1, ''),
(190, 8, 107, 2195, 1, ''),
(190, 10, 108, 1987, 1, ''),
(190, 102, 109, 2261, 1, 0x0f01),
(190, 102, 110, 2305, 1, 0x0f01),
(190, 102, 111, 2293, 1, 0x0f01),
(190, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(190, 102, 113, 7588, 1, 0x0f01),
(190, 102, 114, 8473, 1, 0x0f01),
(190, 102, 115, 7591, 1, 0x0f01),
(190, 102, 116, 7620, 1, 0x0f01),
(190, 108, 117, 7434, 1, ''),
(190, 108, 118, 7431, 1, ''),
(190, 108, 119, 7429, 1, ''),
(191, 1, 101, 2498, 1, ''),
(191, 3, 102, 1988, 1, ''),
(191, 4, 103, 2492, 1, ''),
(191, 5, 104, 2520, 1, ''),
(191, 6, 105, 7390, 1, ''),
(191, 7, 106, 2488, 1, ''),
(191, 8, 107, 2195, 1, ''),
(191, 10, 108, 1987, 1, ''),
(191, 102, 109, 2261, 1, 0x0f01),
(191, 102, 110, 2305, 1, 0x0f01),
(191, 102, 111, 2293, 1, 0x0f01),
(191, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(191, 102, 113, 7588, 1, 0x0f01),
(191, 102, 114, 8473, 1, 0x0f01),
(191, 102, 115, 7591, 1, 0x0f01),
(191, 102, 116, 7620, 1, 0x0f01),
(191, 108, 117, 7434, 1, ''),
(191, 108, 118, 7431, 1, ''),
(191, 108, 119, 7429, 1, ''),
(192, 1, 101, 2498, 1, ''),
(192, 3, 102, 1988, 1, ''),
(192, 4, 103, 2492, 1, ''),
(192, 5, 104, 2520, 1, ''),
(192, 6, 105, 7390, 1, ''),
(192, 7, 106, 2488, 1, ''),
(192, 8, 107, 2195, 1, ''),
(192, 10, 108, 1987, 1, ''),
(192, 102, 109, 2261, 1, 0x0f01),
(192, 102, 110, 2305, 1, 0x0f01),
(192, 102, 111, 2293, 1, 0x0f01),
(192, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(192, 102, 113, 7588, 1, 0x0f01),
(192, 102, 114, 8473, 1, 0x0f01),
(192, 102, 115, 7591, 1, 0x0f01),
(192, 102, 116, 7620, 1, 0x0f01),
(192, 108, 117, 7434, 1, ''),
(192, 108, 118, 7431, 1, ''),
(192, 108, 119, 7429, 1, ''),
(193, 1, 101, 2498, 1, ''),
(193, 3, 102, 1988, 1, ''),
(193, 4, 103, 2492, 1, ''),
(193, 5, 104, 2520, 1, ''),
(193, 6, 105, 7390, 1, ''),
(193, 7, 106, 2488, 1, ''),
(193, 8, 107, 2195, 1, ''),
(193, 10, 108, 1987, 1, ''),
(193, 102, 109, 2261, 1, 0x0f01),
(193, 102, 110, 2305, 1, 0x0f01),
(193, 102, 111, 2293, 1, 0x0f01),
(193, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(193, 102, 113, 7588, 1, 0x0f01),
(193, 102, 114, 8473, 1, 0x0f01),
(193, 102, 115, 7591, 1, 0x0f01),
(193, 102, 116, 7620, 1, 0x0f01),
(193, 108, 117, 7434, 1, ''),
(193, 108, 118, 7431, 1, ''),
(193, 108, 119, 7429, 1, ''),
(194, 1, 101, 2498, 1, ''),
(194, 3, 102, 1988, 1, ''),
(194, 4, 103, 2492, 1, ''),
(194, 5, 104, 2520, 1, ''),
(194, 6, 105, 7390, 1, ''),
(194, 7, 106, 2488, 1, ''),
(194, 8, 107, 2195, 1, ''),
(194, 10, 108, 1987, 1, ''),
(194, 102, 109, 2261, 1, 0x0f01),
(194, 102, 110, 2305, 1, 0x0f01),
(194, 102, 111, 2293, 1, 0x0f01),
(194, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(194, 102, 113, 7588, 1, 0x0f01),
(194, 102, 114, 8473, 1, 0x0f01),
(194, 102, 115, 7591, 1, 0x0f01),
(194, 102, 116, 7620, 1, 0x0f01),
(194, 108, 117, 7434, 1, ''),
(194, 108, 118, 7431, 1, ''),
(194, 108, 119, 7429, 1, ''),
(195, 1, 101, 2498, 1, ''),
(195, 3, 102, 1988, 1, ''),
(195, 4, 103, 2492, 1, ''),
(195, 5, 104, 2520, 1, ''),
(195, 6, 105, 7390, 1, ''),
(195, 7, 106, 2488, 1, ''),
(195, 8, 107, 2195, 1, ''),
(195, 10, 108, 1987, 1, ''),
(195, 102, 109, 2261, 1, 0x0f01),
(195, 102, 110, 2305, 1, 0x0f01),
(195, 102, 111, 2293, 1, 0x0f01),
(195, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(195, 102, 113, 7588, 1, 0x0f01),
(195, 102, 114, 8473, 1, 0x0f01),
(195, 102, 115, 7591, 1, 0x0f01),
(195, 102, 116, 7620, 1, 0x0f01),
(195, 108, 117, 7434, 1, ''),
(195, 108, 118, 7431, 1, ''),
(195, 108, 119, 7429, 1, ''),
(196, 1, 101, 2498, 1, ''),
(196, 3, 102, 1988, 1, ''),
(196, 4, 103, 2492, 1, ''),
(196, 5, 104, 2520, 1, ''),
(196, 6, 105, 7390, 1, ''),
(196, 7, 106, 2488, 1, ''),
(196, 8, 107, 2195, 1, ''),
(196, 10, 108, 1987, 1, ''),
(196, 102, 109, 2261, 1, 0x0f01),
(196, 102, 110, 2305, 1, 0x0f01),
(196, 102, 111, 2293, 1, 0x0f01),
(196, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(196, 102, 113, 7588, 1, 0x0f01),
(196, 102, 114, 8473, 1, 0x0f01),
(196, 102, 115, 7591, 1, 0x0f01),
(196, 102, 116, 7620, 1, 0x0f01),
(196, 108, 117, 7434, 1, ''),
(196, 108, 118, 7431, 1, ''),
(196, 108, 119, 7429, 1, ''),
(197, 1, 101, 2498, 1, ''),
(197, 3, 102, 1988, 1, ''),
(197, 4, 103, 2492, 1, ''),
(197, 5, 104, 2520, 1, ''),
(197, 6, 105, 7390, 1, ''),
(197, 7, 106, 2488, 1, ''),
(197, 8, 107, 2195, 1, ''),
(197, 10, 108, 1987, 1, ''),
(197, 102, 109, 2261, 1, 0x0f01),
(197, 102, 110, 2305, 1, 0x0f01),
(197, 102, 111, 2293, 1, 0x0f01),
(197, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(197, 102, 113, 7588, 1, 0x0f01),
(197, 102, 114, 8473, 1, 0x0f01),
(197, 102, 115, 7591, 1, 0x0f01),
(197, 102, 116, 7620, 1, 0x0f01),
(197, 108, 117, 7434, 1, ''),
(197, 108, 118, 7431, 1, ''),
(197, 108, 119, 7429, 1, ''),
(198, 1, 101, 2498, 1, ''),
(198, 3, 102, 1988, 1, ''),
(198, 4, 103, 2492, 1, ''),
(198, 5, 104, 2520, 1, ''),
(198, 6, 105, 7390, 1, ''),
(198, 7, 106, 2488, 1, ''),
(198, 8, 107, 2195, 1, ''),
(198, 10, 108, 1987, 1, ''),
(198, 102, 109, 2261, 1, 0x0f01),
(198, 102, 110, 2305, 1, 0x0f01),
(198, 102, 111, 2293, 1, 0x0f01),
(198, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(198, 102, 113, 7588, 1, 0x0f01),
(198, 102, 114, 8473, 1, 0x0f01),
(198, 102, 115, 7591, 1, 0x0f01),
(198, 102, 116, 7620, 1, 0x0f01),
(198, 108, 117, 7434, 1, ''),
(198, 108, 118, 7431, 1, ''),
(198, 108, 119, 7429, 1, ''),
(199, 1, 101, 2498, 1, ''),
(199, 3, 102, 1988, 1, ''),
(199, 4, 103, 2492, 1, ''),
(199, 5, 104, 2520, 1, ''),
(199, 6, 105, 7390, 1, ''),
(199, 7, 106, 2488, 1, ''),
(199, 8, 107, 2195, 1, ''),
(199, 10, 108, 1987, 1, ''),
(199, 102, 109, 2261, 1, 0x0f01),
(199, 102, 110, 2305, 1, 0x0f01),
(199, 102, 111, 2293, 1, 0x0f01),
(199, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(199, 102, 113, 7588, 1, 0x0f01),
(199, 102, 114, 8473, 1, 0x0f01),
(199, 102, 115, 7591, 1, 0x0f01),
(199, 102, 116, 7620, 1, 0x0f01),
(199, 108, 117, 7434, 1, ''),
(199, 108, 118, 7431, 1, ''),
(199, 108, 119, 7429, 1, ''),
(200, 1, 101, 2498, 1, ''),
(200, 3, 102, 1988, 1, ''),
(200, 4, 103, 2492, 1, ''),
(200, 5, 104, 2520, 1, ''),
(200, 6, 105, 7390, 1, ''),
(200, 7, 106, 2488, 1, ''),
(200, 8, 107, 2195, 1, ''),
(200, 10, 108, 1987, 1, ''),
(200, 102, 109, 2261, 1, 0x0f01),
(200, 102, 110, 2305, 1, 0x0f01),
(200, 102, 111, 2293, 1, 0x0f01),
(200, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(200, 102, 113, 7588, 1, 0x0f01),
(200, 102, 114, 8473, 1, 0x0f01),
(200, 102, 115, 7591, 1, 0x0f01),
(200, 102, 116, 7620, 1, 0x0f01),
(200, 108, 117, 7434, 1, ''),
(200, 108, 118, 7431, 1, ''),
(200, 108, 119, 7429, 1, ''),
(201, 1, 101, 2498, 1, ''),
(201, 3, 102, 1988, 1, ''),
(201, 4, 103, 2492, 1, ''),
(201, 5, 104, 2520, 1, ''),
(201, 6, 105, 7390, 1, ''),
(201, 7, 106, 2488, 1, ''),
(201, 8, 107, 2195, 1, ''),
(201, 10, 108, 1987, 1, ''),
(201, 102, 109, 2261, 1, 0x0f01),
(201, 102, 110, 2305, 1, 0x0f01),
(201, 102, 111, 2293, 1, 0x0f01),
(201, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(201, 102, 113, 7588, 1, 0x0f01),
(201, 102, 114, 8473, 1, 0x0f01),
(201, 102, 115, 7591, 1, 0x0f01),
(201, 102, 116, 7620, 1, 0x0f01),
(201, 108, 117, 7434, 1, ''),
(201, 108, 118, 7431, 1, ''),
(201, 108, 119, 7429, 1, ''),
(202, 1, 101, 2498, 1, ''),
(202, 3, 102, 1988, 1, ''),
(202, 4, 103, 2492, 1, ''),
(202, 5, 104, 2520, 1, ''),
(202, 6, 105, 7390, 1, ''),
(202, 7, 106, 2488, 1, ''),
(202, 8, 107, 2195, 1, ''),
(202, 10, 108, 1987, 1, ''),
(202, 102, 109, 2261, 1, 0x0f01),
(202, 102, 110, 2305, 1, 0x0f01),
(202, 102, 111, 2293, 1, 0x0f01),
(202, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(202, 102, 113, 7588, 1, 0x0f01),
(202, 102, 114, 8473, 1, 0x0f01),
(202, 102, 115, 7591, 1, 0x0f01),
(202, 102, 116, 7620, 1, 0x0f01),
(202, 108, 117, 7434, 1, ''),
(202, 108, 118, 7431, 1, ''),
(202, 108, 119, 7429, 1, ''),
(203, 1, 101, 2498, 1, ''),
(203, 3, 102, 1988, 1, ''),
(203, 4, 103, 2492, 1, ''),
(203, 5, 104, 2520, 1, ''),
(203, 6, 105, 7390, 1, ''),
(203, 7, 106, 2488, 1, ''),
(203, 8, 107, 2195, 1, ''),
(203, 10, 108, 1987, 1, ''),
(203, 102, 109, 2261, 1, 0x0f01),
(203, 102, 110, 2305, 1, 0x0f01),
(203, 102, 111, 2293, 1, 0x0f01),
(203, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(203, 102, 113, 7588, 1, 0x0f01),
(203, 102, 114, 8473, 1, 0x0f01),
(203, 102, 115, 7591, 1, 0x0f01),
(203, 102, 116, 7620, 1, 0x0f01),
(203, 108, 117, 7434, 1, ''),
(203, 108, 118, 7431, 1, ''),
(203, 108, 119, 7429, 1, ''),
(204, 1, 101, 2498, 1, ''),
(204, 3, 102, 1988, 1, ''),
(204, 4, 103, 2492, 1, ''),
(204, 5, 104, 2520, 1, ''),
(204, 6, 105, 7390, 1, ''),
(204, 7, 106, 2488, 1, ''),
(204, 8, 107, 2195, 1, ''),
(204, 10, 108, 1987, 1, ''),
(204, 102, 109, 2261, 1, 0x0f01),
(204, 102, 110, 2305, 1, 0x0f01),
(204, 102, 111, 2293, 1, 0x0f01),
(204, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(204, 102, 113, 7588, 1, 0x0f01),
(204, 102, 114, 8473, 1, 0x0f01),
(204, 102, 115, 7591, 1, 0x0f01),
(204, 102, 116, 7620, 1, 0x0f01),
(204, 108, 117, 7434, 1, ''),
(204, 108, 118, 7431, 1, ''),
(204, 108, 119, 7429, 1, ''),
(205, 1, 101, 2498, 1, ''),
(205, 3, 102, 1988, 1, ''),
(205, 4, 103, 2492, 1, ''),
(205, 5, 104, 2520, 1, ''),
(205, 6, 105, 7390, 1, ''),
(205, 7, 106, 2488, 1, ''),
(205, 8, 107, 2195, 1, ''),
(205, 10, 108, 1987, 1, ''),
(205, 102, 109, 2261, 1, 0x0f01),
(205, 102, 110, 2305, 1, 0x0f01),
(205, 102, 111, 2293, 1, 0x0f01),
(205, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(205, 102, 113, 7588, 1, 0x0f01),
(205, 102, 114, 8473, 1, 0x0f01),
(205, 102, 115, 7591, 1, 0x0f01),
(205, 102, 116, 7620, 1, 0x0f01),
(205, 108, 117, 7434, 1, ''),
(205, 108, 118, 7431, 1, ''),
(205, 108, 119, 7429, 1, ''),
(206, 1, 101, 2498, 1, ''),
(206, 3, 102, 1988, 1, ''),
(206, 4, 103, 2492, 1, ''),
(206, 5, 104, 2520, 1, ''),
(206, 6, 105, 7390, 1, ''),
(206, 7, 106, 2488, 1, ''),
(206, 8, 107, 2195, 1, ''),
(206, 10, 108, 1987, 1, ''),
(206, 102, 109, 2261, 1, 0x0f01),
(206, 102, 110, 2305, 1, 0x0f01),
(206, 102, 111, 2293, 1, 0x0f01),
(206, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(206, 102, 113, 7588, 1, 0x0f01),
(206, 102, 114, 8473, 1, 0x0f01),
(206, 102, 115, 7591, 1, 0x0f01),
(206, 102, 116, 7620, 1, 0x0f01),
(206, 108, 117, 7434, 1, ''),
(206, 108, 118, 7431, 1, ''),
(206, 108, 119, 7429, 1, ''),
(207, 1, 101, 2498, 1, ''),
(207, 3, 102, 1988, 1, ''),
(207, 4, 103, 2492, 1, ''),
(207, 5, 104, 2520, 1, ''),
(207, 6, 105, 7390, 1, ''),
(207, 7, 106, 2488, 1, ''),
(207, 8, 107, 2195, 1, ''),
(207, 10, 108, 1987, 1, ''),
(207, 102, 109, 2261, 1, 0x0f01),
(207, 102, 110, 2305, 1, 0x0f01),
(207, 102, 111, 2293, 1, 0x0f01),
(207, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(207, 102, 113, 7588, 1, 0x0f01),
(207, 102, 114, 8473, 1, 0x0f01),
(207, 102, 115, 7591, 1, 0x0f01),
(207, 102, 116, 7620, 1, 0x0f01),
(207, 108, 117, 7434, 1, ''),
(207, 108, 118, 7431, 1, ''),
(207, 108, 119, 7429, 1, ''),
(208, 1, 101, 2498, 1, ''),
(208, 3, 102, 1988, 1, ''),
(208, 4, 103, 2492, 1, ''),
(208, 5, 104, 2520, 1, ''),
(208, 6, 105, 7390, 1, ''),
(208, 7, 106, 2488, 1, ''),
(208, 8, 107, 2195, 1, ''),
(208, 10, 108, 1987, 1, ''),
(208, 102, 109, 2261, 1, 0x0f01),
(208, 102, 110, 2305, 1, 0x0f01),
(208, 102, 111, 2293, 1, 0x0f01),
(208, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(208, 102, 113, 7588, 1, 0x0f01),
(208, 102, 114, 8473, 1, 0x0f01),
(208, 102, 115, 7591, 1, 0x0f01),
(208, 102, 116, 7620, 1, 0x0f01),
(208, 108, 117, 7434, 1, ''),
(208, 108, 118, 7431, 1, ''),
(208, 108, 119, 7429, 1, ''),
(209, 1, 101, 2498, 1, ''),
(209, 3, 102, 1988, 1, ''),
(209, 4, 103, 2492, 1, ''),
(209, 5, 104, 2520, 1, ''),
(209, 6, 105, 7390, 1, ''),
(209, 7, 106, 2488, 1, ''),
(209, 8, 107, 2195, 1, ''),
(209, 10, 108, 1987, 1, ''),
(209, 102, 109, 2261, 1, 0x0f01),
(209, 102, 110, 2305, 1, 0x0f01),
(209, 102, 111, 2293, 1, 0x0f01),
(209, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(209, 102, 113, 7588, 1, 0x0f01),
(209, 102, 114, 8473, 1, 0x0f01),
(209, 102, 115, 7591, 1, 0x0f01),
(209, 102, 116, 7620, 1, 0x0f01),
(209, 108, 117, 7434, 1, ''),
(209, 108, 118, 7431, 1, ''),
(209, 108, 119, 7429, 1, ''),
(210, 1, 101, 2498, 1, ''),
(210, 3, 102, 1988, 1, ''),
(210, 4, 103, 2492, 1, ''),
(210, 5, 104, 2520, 1, ''),
(210, 6, 105, 7390, 1, ''),
(210, 7, 106, 2488, 1, ''),
(210, 8, 107, 2195, 1, ''),
(210, 10, 108, 1987, 1, ''),
(210, 102, 109, 2261, 1, 0x0f01),
(210, 102, 110, 2305, 1, 0x0f01),
(210, 102, 111, 2293, 1, 0x0f01),
(210, 102, 112, 2273, 1, 0x0f018001000700636861726765730201000000),
(210, 102, 113, 7588, 1, 0x0f01),
(210, 102, 114, 8473, 1, 0x0f01),
(210, 102, 115, 7591, 1, 0x0f01),
(210, 102, 116, 7620, 1, 0x0f01),
(210, 108, 117, 7434, 1, ''),
(210, 108, 118, 7431, 1, ''),
(210, 108, 119, 7429, 1, ''),
(214, 1, 101, 2498, 1, ''),
(214, 3, 102, 1988, 1, ''),
(214, 4, 103, 2656, 1, ''),
(214, 5, 104, 2520, 1, ''),
(214, 6, 105, 8920, 1, ''),
(214, 7, 106, 2647, 1, ''),
(214, 8, 107, 2195, 1, ''),
(214, 10, 108, 1987, 1, ''),
(214, 102, 109, 2263, 37, 0x0f25),
(214, 102, 110, 2263, 100, 0x0f64),
(214, 102, 111, 2268, 1, 0x0f01),
(214, 102, 112, 2273, 1, 0x0f01),
(214, 102, 113, 2305, 1, 0x0f01),
(214, 102, 114, 2261, 1, 0x0f01),
(214, 102, 115, 2293, 1, 0x0f01),
(214, 102, 116, 7590, 1, 0x0f01),
(214, 102, 117, 7589, 1, 0x0f01),
(214, 102, 118, 7620, 1, 0x0f01),
(214, 102, 119, 7618, 1, 0x0f01),
(214, 108, 120, 2263, 34, 0x0f22),
(214, 108, 121, 2263, 100, 0x0f64),
(214, 108, 122, 8922, 1, ''),
(214, 108, 123, 2187, 1, '');

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_killers`
--

CREATE TABLE IF NOT EXISTS `player_killers` (
  `kill_id` int(11) NOT NULL,
  `player_id` int(11) NOT NULL,
  KEY `kill_id` (`kill_id`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_namelocks`
--

CREATE TABLE IF NOT EXISTS `player_namelocks` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL,
  `new_name` varchar(255) NOT NULL,
  `date` bigint(20) NOT NULL DEFAULT '0',
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_skills`
--

CREATE TABLE IF NOT EXISTS `player_skills` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `skillid` tinyint(2) NOT NULL DEFAULT '0',
  `value` int(10) unsigned NOT NULL DEFAULT '0',
  `count` int(10) unsigned NOT NULL DEFAULT '0',
  UNIQUE KEY `player_id_2` (`player_id`,`skillid`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `player_skills`
--

INSERT INTO `player_skills` (`player_id`, `skillid`, `value`, `count`) VALUES
(2, 0, 10, 0),
(2, 1, 10, 0),
(2, 2, 10, 0),
(2, 3, 10, 0),
(2, 4, 10, 0),
(2, 5, 10, 0),
(2, 6, 10, 0),
(3, 0, 10, 0),
(3, 1, 17, 415),
(3, 2, 10, 0),
(3, 3, 10, 0),
(3, 4, 10, 0),
(3, 5, 10, 0),
(3, 6, 10, 0),
(8, 0, 10, 0),
(8, 1, 10, 0),
(8, 2, 10, 0),
(8, 3, 10, 0),
(8, 4, 10, 0),
(8, 5, 10, 0),
(8, 6, 10, 0),
(9, 0, 10, 0),
(9, 1, 10, 0),
(9, 2, 10, 0),
(9, 3, 10, 0),
(9, 4, 85, 2178),
(9, 5, 65, 24),
(9, 6, 10, 0),
(10, 0, 12, 14),
(10, 1, 70, 12),
(10, 2, 70, 1218),
(10, 3, 70, 0),
(10, 4, 10, 0),
(10, 5, 80, 24),
(10, 6, 10, 0),
(11, 0, 10, 0),
(11, 1, 17, 415),
(11, 2, 10, 0),
(11, 3, 10, 0),
(11, 4, 10, 0),
(11, 5, 12, 68),
(11, 6, 10, 0),
(12, 0, 10, 0),
(12, 1, 17, 415),
(12, 2, 10, 0),
(12, 3, 10, 0),
(12, 4, 10, 0),
(12, 5, 11, 104),
(12, 6, 10, 0),
(13, 0, 10, 0),
(13, 1, 17, 415),
(13, 2, 10, 0),
(13, 3, 10, 0),
(13, 4, 10, 0),
(13, 5, 11, 77),
(13, 6, 10, 0),
(14, 0, 10, 0),
(14, 1, 17, 415),
(14, 2, 10, 0),
(14, 3, 10, 0),
(14, 4, 10, 0),
(14, 5, 10, 87),
(14, 6, 10, 0),
(15, 0, 10, 0),
(15, 1, 17, 415),
(15, 2, 10, 0),
(15, 3, 10, 0),
(15, 4, 10, 0),
(15, 5, 10, 30),
(15, 6, 10, 0),
(16, 0, 10, 0),
(16, 1, 17, 415),
(16, 2, 10, 0),
(16, 3, 10, 0),
(16, 4, 10, 0),
(16, 5, 10, 30),
(16, 6, 10, 0),
(17, 0, 10, 0),
(17, 1, 17, 415),
(17, 2, 10, 0),
(17, 3, 10, 0),
(17, 4, 10, 0),
(17, 5, 10, 66),
(17, 6, 10, 0),
(18, 0, 10, 0),
(18, 1, 17, 415),
(18, 2, 10, 0),
(18, 3, 10, 0),
(18, 4, 10, 0),
(18, 5, 12, 8),
(18, 6, 10, 0),
(19, 0, 10, 0),
(19, 1, 17, 415),
(19, 2, 10, 0),
(19, 3, 10, 0),
(19, 4, 10, 0),
(19, 5, 10, 60),
(19, 6, 10, 0),
(20, 0, 10, 0),
(20, 1, 17, 415),
(20, 2, 10, 0),
(20, 3, 10, 0),
(20, 4, 10, 0),
(20, 5, 10, 48),
(20, 6, 10, 0),
(21, 0, 10, 0),
(21, 1, 17, 415),
(21, 2, 10, 0),
(21, 3, 10, 0),
(21, 4, 10, 0),
(21, 5, 10, 78),
(21, 6, 10, 0),
(22, 0, 10, 0),
(22, 1, 17, 415),
(22, 2, 10, 0),
(22, 3, 10, 0),
(22, 4, 10, 0),
(22, 5, 11, 41),
(22, 6, 10, 0),
(23, 0, 10, 0),
(23, 1, 17, 415),
(23, 2, 10, 0),
(23, 3, 10, 0),
(23, 4, 10, 0),
(23, 5, 11, 32),
(23, 6, 10, 0),
(24, 0, 10, 0),
(24, 1, 17, 415),
(24, 2, 10, 0),
(24, 3, 10, 0),
(24, 4, 10, 0),
(24, 5, 11, 5),
(24, 6, 10, 0),
(25, 0, 10, 0),
(25, 1, 17, 415),
(25, 2, 10, 0),
(25, 3, 10, 0),
(25, 4, 10, 0),
(25, 5, 11, 128),
(25, 6, 10, 0),
(26, 0, 10, 0),
(26, 1, 17, 415),
(26, 2, 10, 0),
(26, 3, 10, 0),
(26, 4, 10, 0),
(26, 5, 13, 236),
(26, 6, 10, 0),
(27, 0, 10, 0),
(27, 1, 17, 415),
(27, 2, 10, 0),
(27, 3, 10, 0),
(27, 4, 10, 0),
(27, 5, 10, 81),
(27, 6, 10, 0),
(28, 0, 10, 0),
(28, 1, 17, 415),
(28, 2, 10, 0),
(28, 3, 10, 0),
(28, 4, 10, 0),
(28, 5, 10, 0),
(28, 6, 10, 0),
(29, 0, 10, 0),
(29, 1, 17, 415),
(29, 2, 10, 0),
(29, 3, 10, 0),
(29, 4, 10, 0),
(29, 5, 11, 53),
(29, 6, 10, 0),
(30, 0, 10, 0),
(30, 1, 17, 415),
(30, 2, 10, 0),
(30, 3, 10, 0),
(30, 4, 10, 0),
(30, 5, 15, 17),
(30, 6, 10, 0),
(31, 0, 10, 0),
(31, 1, 17, 415),
(31, 2, 10, 0),
(31, 3, 10, 0),
(31, 4, 10, 0),
(31, 5, 11, 77),
(31, 6, 10, 0),
(32, 0, 10, 0),
(32, 1, 17, 415),
(32, 2, 10, 0),
(32, 3, 10, 0),
(32, 4, 10, 0),
(32, 5, 10, 69),
(32, 6, 10, 0),
(33, 0, 10, 0),
(33, 1, 17, 415),
(33, 2, 10, 0),
(33, 3, 10, 0),
(33, 4, 10, 0),
(33, 5, 11, 50),
(33, 6, 10, 0),
(34, 0, 10, 0),
(34, 1, 17, 415),
(34, 2, 10, 0),
(34, 3, 10, 0),
(34, 4, 10, 0),
(34, 5, 11, 137),
(34, 6, 10, 0),
(35, 0, 10, 0),
(35, 1, 17, 415),
(35, 2, 10, 0),
(35, 3, 10, 0),
(35, 4, 10, 0),
(35, 5, 13, 320),
(35, 6, 10, 0),
(36, 0, 10, 0),
(36, 1, 17, 415),
(36, 2, 10, 0),
(36, 3, 10, 0),
(36, 4, 10, 0),
(36, 5, 11, 20),
(36, 6, 10, 0),
(37, 0, 10, 0),
(37, 1, 17, 415),
(37, 2, 10, 0),
(37, 3, 10, 0),
(37, 4, 10, 0),
(37, 5, 10, 90),
(37, 6, 10, 0),
(38, 0, 10, 0),
(38, 1, 17, 415),
(38, 2, 10, 0),
(38, 3, 10, 0),
(38, 4, 10, 0),
(38, 5, 10, 87),
(38, 6, 10, 0),
(39, 0, 10, 0),
(39, 1, 17, 415),
(39, 2, 10, 0),
(39, 3, 10, 0),
(39, 4, 10, 0),
(39, 5, 12, 224),
(39, 6, 10, 0),
(40, 0, 10, 0),
(40, 1, 17, 415),
(40, 2, 10, 0),
(40, 3, 10, 0),
(40, 4, 10, 0),
(40, 5, 13, 233),
(40, 6, 10, 0),
(41, 0, 10, 0),
(41, 1, 17, 415),
(41, 2, 10, 0),
(41, 3, 10, 0),
(41, 4, 10, 0),
(41, 5, 10, 30),
(41, 6, 10, 0),
(42, 0, 10, 0),
(42, 1, 17, 415),
(42, 2, 10, 0),
(42, 3, 10, 0),
(42, 4, 10, 0),
(42, 5, 12, 143),
(42, 6, 10, 0),
(43, 0, 10, 0),
(43, 1, 17, 415),
(43, 2, 10, 0),
(43, 3, 10, 0),
(43, 4, 10, 0),
(43, 5, 10, 30),
(43, 6, 10, 0),
(44, 0, 10, 0),
(44, 1, 17, 415),
(44, 2, 10, 0),
(44, 3, 10, 0),
(44, 4, 10, 0),
(44, 5, 13, 311),
(44, 6, 10, 0),
(45, 0, 10, 0),
(45, 1, 17, 415),
(45, 2, 10, 0),
(45, 3, 10, 0),
(45, 4, 10, 0),
(45, 5, 10, 45),
(45, 6, 10, 0),
(46, 0, 10, 0),
(46, 1, 17, 415),
(46, 2, 10, 0),
(46, 3, 10, 0),
(46, 4, 10, 0),
(46, 5, 12, 2),
(46, 6, 10, 0),
(47, 0, 10, 0),
(47, 1, 17, 415),
(47, 2, 10, 0),
(47, 3, 10, 0),
(47, 4, 10, 0),
(47, 5, 13, 266),
(47, 6, 10, 0),
(48, 0, 10, 0),
(48, 1, 17, 415),
(48, 2, 10, 0),
(48, 3, 10, 0),
(48, 4, 10, 0),
(48, 5, 13, 272),
(48, 6, 10, 0),
(49, 0, 10, 0),
(49, 1, 17, 415),
(49, 2, 10, 0),
(49, 3, 10, 0),
(49, 4, 10, 0),
(49, 5, 13, 107),
(49, 6, 10, 0),
(50, 0, 10, 0),
(50, 1, 17, 415),
(50, 2, 10, 0),
(50, 3, 10, 0),
(50, 4, 10, 0),
(50, 5, 13, 92),
(50, 6, 10, 0),
(51, 0, 10, 0),
(51, 1, 17, 415),
(51, 2, 10, 0),
(51, 3, 10, 0),
(51, 4, 10, 0),
(51, 5, 11, 71),
(51, 6, 10, 0),
(52, 0, 10, 0),
(52, 1, 17, 415),
(52, 2, 10, 0),
(52, 3, 10, 0),
(52, 4, 10, 0),
(52, 5, 13, 62),
(52, 6, 10, 0),
(53, 0, 10, 0),
(53, 1, 17, 415),
(53, 2, 10, 0),
(53, 3, 10, 0),
(53, 4, 10, 0),
(53, 5, 14, 7),
(53, 6, 10, 0),
(54, 0, 10, 0),
(54, 1, 17, 415),
(54, 2, 10, 0),
(54, 3, 10, 0),
(54, 4, 10, 0),
(54, 5, 10, 78),
(54, 6, 10, 0),
(55, 0, 10, 0),
(55, 1, 17, 415),
(55, 2, 10, 0),
(55, 3, 10, 0),
(55, 4, 10, 0),
(55, 5, 14, 181),
(55, 6, 10, 0),
(56, 0, 10, 0),
(56, 1, 17, 415),
(56, 2, 10, 0),
(56, 3, 10, 0),
(56, 4, 10, 0),
(56, 5, 11, 80),
(56, 6, 10, 0),
(57, 0, 10, 0),
(57, 1, 17, 415),
(57, 2, 10, 0),
(57, 3, 10, 0),
(57, 4, 10, 0),
(57, 5, 13, 272),
(57, 6, 10, 0),
(58, 0, 10, 0),
(58, 1, 17, 415),
(58, 2, 10, 0),
(58, 3, 10, 0),
(58, 4, 10, 0),
(58, 5, 14, 151),
(58, 6, 10, 0),
(59, 0, 10, 0),
(59, 1, 17, 415),
(59, 2, 10, 0),
(59, 3, 10, 0),
(59, 4, 10, 0),
(59, 5, 12, 92),
(59, 6, 10, 0),
(60, 0, 10, 0),
(60, 1, 17, 415),
(60, 2, 10, 0),
(60, 3, 10, 0),
(60, 4, 10, 0),
(60, 5, 11, 41),
(60, 6, 10, 0),
(61, 0, 10, 0),
(61, 1, 17, 415),
(61, 2, 10, 0),
(61, 3, 10, 0),
(61, 4, 10, 0),
(61, 5, 13, 35),
(61, 6, 10, 0),
(62, 0, 10, 0),
(62, 1, 17, 415),
(62, 2, 10, 0),
(62, 3, 10, 0),
(62, 4, 10, 0),
(62, 5, 13, 266),
(62, 6, 10, 0),
(63, 0, 10, 0),
(63, 1, 17, 415),
(63, 2, 10, 0),
(63, 3, 10, 0),
(63, 4, 10, 0),
(63, 5, 10, 60),
(63, 6, 10, 0),
(64, 0, 10, 0),
(64, 1, 17, 415),
(64, 2, 10, 0),
(64, 3, 10, 0),
(64, 4, 10, 0),
(64, 5, 14, 49),
(64, 6, 10, 0),
(65, 0, 10, 0),
(65, 1, 17, 415),
(65, 2, 10, 0),
(65, 3, 10, 0),
(65, 4, 10, 0),
(65, 5, 12, 47),
(65, 6, 10, 0),
(66, 0, 10, 0),
(66, 1, 17, 415),
(66, 2, 10, 0),
(66, 3, 10, 0),
(66, 4, 10, 0),
(66, 5, 10, 24),
(66, 6, 10, 0),
(67, 0, 10, 0),
(67, 1, 17, 415),
(67, 2, 10, 0),
(67, 3, 10, 0),
(67, 4, 10, 0),
(67, 5, 13, 206),
(67, 6, 10, 0),
(68, 0, 10, 0),
(68, 1, 17, 415),
(68, 2, 10, 0),
(68, 3, 10, 0),
(68, 4, 10, 0),
(68, 5, 12, 179),
(68, 6, 10, 0),
(69, 0, 10, 0),
(69, 1, 17, 415),
(69, 2, 10, 0),
(69, 3, 10, 0),
(69, 4, 10, 0),
(69, 5, 11, 80),
(69, 6, 10, 0),
(70, 0, 10, 0),
(70, 1, 17, 415),
(70, 2, 10, 0),
(70, 3, 10, 0),
(70, 4, 10, 0),
(70, 5, 14, 172),
(70, 6, 10, 0),
(71, 0, 10, 0),
(71, 1, 17, 415),
(71, 2, 10, 0),
(71, 3, 10, 0),
(71, 4, 10, 0),
(71, 5, 11, 110),
(71, 6, 10, 0),
(72, 0, 10, 0),
(72, 1, 17, 415),
(72, 2, 10, 0),
(72, 3, 10, 0),
(72, 4, 10, 0),
(72, 5, 13, 47),
(72, 6, 10, 0),
(73, 0, 10, 0),
(73, 1, 17, 415),
(73, 2, 10, 0),
(73, 3, 10, 0),
(73, 4, 10, 0),
(73, 5, 12, 101),
(73, 6, 10, 0),
(74, 0, 10, 0),
(74, 1, 17, 415),
(74, 2, 10, 0),
(74, 3, 10, 0),
(74, 4, 10, 0),
(74, 5, 12, 161),
(74, 6, 10, 0),
(75, 0, 10, 0),
(75, 1, 17, 415),
(75, 2, 10, 0),
(75, 3, 10, 0),
(75, 4, 10, 0),
(75, 5, 13, 110),
(75, 6, 10, 0),
(76, 0, 10, 0),
(76, 1, 17, 415),
(76, 2, 10, 0),
(76, 3, 10, 0),
(76, 4, 10, 0),
(76, 5, 10, 0),
(76, 6, 10, 0),
(77, 0, 10, 0),
(77, 1, 17, 415),
(77, 2, 10, 0),
(77, 3, 10, 0),
(77, 4, 10, 0),
(77, 5, 12, 182),
(77, 6, 10, 0),
(78, 0, 10, 0),
(78, 1, 17, 415),
(78, 2, 10, 0),
(78, 3, 10, 0),
(78, 4, 10, 0),
(78, 5, 13, 200),
(78, 6, 10, 0),
(79, 0, 10, 0),
(79, 1, 17, 415),
(79, 2, 10, 0),
(79, 3, 10, 0),
(79, 4, 10, 0),
(79, 5, 13, 272),
(79, 6, 10, 0),
(80, 0, 10, 0),
(80, 1, 17, 415),
(80, 2, 10, 0),
(80, 3, 10, 0),
(80, 4, 10, 0),
(80, 5, 14, 103),
(80, 6, 10, 0),
(81, 0, 10, 0),
(81, 1, 17, 415),
(81, 2, 10, 0),
(81, 3, 10, 0),
(81, 4, 10, 0),
(81, 5, 14, 106),
(81, 6, 10, 0),
(82, 0, 10, 0),
(82, 1, 17, 415),
(82, 2, 10, 0),
(82, 3, 10, 0),
(82, 4, 10, 0),
(82, 5, 10, 93),
(82, 6, 10, 0),
(83, 0, 10, 0),
(83, 1, 17, 415),
(83, 2, 10, 0),
(83, 3, 10, 0),
(83, 4, 10, 0),
(83, 5, 13, 209),
(83, 6, 10, 0),
(84, 0, 10, 0),
(84, 1, 17, 415),
(84, 2, 10, 0),
(84, 3, 10, 0),
(84, 4, 10, 0),
(84, 5, 11, 89),
(84, 6, 10, 0),
(85, 0, 10, 0),
(85, 1, 17, 415),
(85, 2, 10, 0),
(85, 3, 10, 0),
(85, 4, 10, 0),
(85, 5, 11, 5),
(85, 6, 10, 0),
(86, 0, 10, 0),
(86, 1, 10, 0),
(86, 2, 10, 0),
(86, 3, 10, 0),
(86, 4, 10, 0),
(86, 5, 11, 23),
(86, 6, 10, 0),
(87, 0, 10, 0),
(87, 1, 10, 0),
(87, 2, 10, 0),
(87, 3, 10, 0),
(87, 4, 10, 0),
(87, 5, 11, 53),
(87, 6, 10, 0),
(88, 0, 10, 0),
(88, 1, 10, 0),
(88, 2, 10, 0),
(88, 3, 10, 0),
(88, 4, 10, 0),
(88, 5, 13, 260),
(88, 6, 10, 0),
(89, 0, 10, 0),
(89, 1, 10, 0),
(89, 2, 10, 0),
(89, 3, 10, 0),
(89, 4, 10, 0),
(89, 5, 12, 191),
(89, 6, 10, 0),
(90, 0, 10, 0),
(90, 1, 10, 0),
(90, 2, 10, 0),
(90, 3, 10, 0),
(90, 4, 10, 0),
(90, 5, 12, 17),
(90, 6, 10, 0),
(91, 0, 10, 0),
(91, 1, 10, 0),
(91, 2, 10, 0),
(91, 3, 10, 0),
(91, 4, 10, 0),
(91, 5, 13, 74),
(91, 6, 10, 0),
(92, 0, 10, 0),
(92, 1, 10, 0),
(92, 2, 10, 0),
(92, 3, 10, 0),
(92, 4, 10, 0),
(92, 5, 13, 182),
(92, 6, 10, 0),
(93, 0, 10, 0),
(93, 1, 10, 0),
(93, 2, 10, 0),
(93, 3, 10, 0),
(93, 4, 10, 0),
(93, 5, 11, 131),
(93, 6, 10, 0),
(94, 0, 10, 0),
(94, 1, 10, 0),
(94, 2, 10, 0),
(94, 3, 10, 0),
(94, 4, 10, 0),
(94, 5, 13, 182),
(94, 6, 10, 0),
(95, 0, 10, 0),
(95, 1, 10, 0),
(95, 2, 10, 0),
(95, 3, 10, 0),
(95, 4, 10, 0),
(95, 5, 10, 90),
(95, 6, 10, 0),
(96, 0, 10, 0),
(96, 1, 10, 0),
(96, 2, 10, 0),
(96, 3, 10, 0),
(96, 4, 10, 0),
(96, 5, 12, 35),
(96, 6, 10, 0),
(97, 0, 10, 0),
(97, 1, 10, 0),
(97, 2, 10, 0),
(97, 3, 10, 0),
(97, 4, 10, 0),
(97, 5, 13, 239),
(97, 6, 10, 0),
(98, 0, 10, 0),
(98, 1, 10, 0),
(98, 2, 10, 0),
(98, 3, 10, 0),
(98, 4, 10, 0),
(98, 5, 15, 629),
(98, 6, 10, 0),
(99, 0, 10, 0),
(99, 1, 10, 0),
(99, 2, 10, 0),
(99, 3, 10, 0),
(99, 4, 10, 0),
(99, 5, 13, 263),
(99, 6, 10, 0),
(100, 0, 10, 0),
(100, 1, 10, 0),
(100, 2, 10, 0),
(100, 3, 10, 0),
(100, 4, 10, 0),
(100, 5, 14, 61),
(100, 6, 10, 0),
(101, 0, 10, 0),
(101, 1, 10, 0),
(101, 2, 10, 0),
(101, 3, 10, 0),
(101, 4, 10, 0),
(101, 5, 10, 72),
(101, 6, 10, 0),
(102, 0, 10, 0),
(102, 1, 10, 0),
(102, 2, 10, 0),
(102, 3, 10, 0),
(102, 4, 10, 0),
(102, 5, 14, 46),
(102, 6, 10, 0),
(103, 0, 10, 0),
(103, 1, 10, 0),
(103, 2, 10, 0),
(103, 3, 10, 0),
(103, 4, 10, 0),
(103, 5, 13, 212),
(103, 6, 10, 0),
(104, 0, 10, 0),
(104, 1, 10, 0),
(104, 2, 10, 0),
(104, 3, 10, 0),
(104, 4, 10, 0),
(104, 5, 10, 96),
(104, 6, 10, 0),
(105, 0, 10, 0),
(105, 1, 10, 0),
(105, 2, 10, 0),
(105, 3, 10, 0),
(105, 4, 10, 0),
(105, 5, 13, 140),
(105, 6, 10, 0),
(106, 0, 10, 0),
(106, 1, 10, 0),
(106, 2, 10, 0),
(106, 3, 10, 0),
(106, 4, 10, 0),
(106, 5, 11, 80),
(106, 6, 10, 0),
(107, 0, 10, 0),
(107, 1, 10, 0),
(107, 2, 10, 0),
(107, 3, 10, 0),
(107, 4, 10, 0),
(107, 5, 13, 152),
(107, 6, 10, 0),
(108, 0, 10, 0),
(108, 1, 10, 0),
(108, 2, 10, 0),
(108, 3, 10, 0),
(108, 4, 10, 0),
(108, 5, 13, 266),
(108, 6, 10, 0),
(109, 0, 10, 0),
(109, 1, 10, 0),
(109, 2, 10, 0),
(109, 3, 10, 0),
(109, 4, 10, 0),
(109, 5, 10, 0),
(109, 6, 10, 0),
(110, 0, 10, 0),
(110, 1, 10, 0),
(110, 2, 10, 0),
(110, 3, 10, 0),
(110, 4, 10, 0),
(110, 5, 12, 116),
(110, 6, 10, 0),
(111, 0, 10, 0),
(111, 1, 10, 0),
(111, 2, 10, 0),
(111, 3, 10, 0),
(111, 4, 10, 0),
(111, 5, 13, 107),
(111, 6, 10, 0),
(112, 0, 10, 0),
(112, 1, 10, 0),
(112, 2, 10, 0),
(112, 3, 10, 0),
(112, 4, 10, 0),
(112, 5, 13, 254),
(112, 6, 10, 0),
(113, 0, 10, 0),
(113, 1, 10, 0),
(113, 2, 10, 0),
(113, 3, 10, 0),
(113, 4, 10, 0),
(113, 5, 13, 209),
(113, 6, 10, 0),
(114, 0, 10, 0),
(114, 1, 10, 0),
(114, 2, 10, 0),
(114, 3, 10, 0),
(114, 4, 10, 0),
(114, 5, 10, 0),
(114, 6, 10, 0),
(115, 0, 10, 0),
(115, 1, 10, 0),
(115, 2, 10, 0),
(115, 3, 10, 0),
(115, 4, 10, 0),
(115, 5, 14, 70),
(115, 6, 10, 0),
(116, 0, 10, 0),
(116, 1, 10, 0),
(116, 2, 10, 0),
(116, 3, 10, 0),
(116, 4, 10, 0),
(116, 5, 13, 125),
(116, 6, 10, 0),
(117, 0, 10, 0),
(117, 1, 10, 0),
(117, 2, 10, 0),
(117, 3, 10, 0),
(117, 4, 10, 0),
(117, 5, 12, 209),
(117, 6, 10, 0),
(118, 0, 10, 0),
(118, 1, 10, 0),
(118, 2, 10, 0),
(118, 3, 10, 0),
(118, 4, 10, 0),
(118, 5, 14, 217),
(118, 6, 10, 0),
(119, 0, 10, 0),
(119, 1, 10, 0),
(119, 2, 10, 0),
(119, 3, 10, 0),
(119, 4, 10, 0),
(119, 5, 11, 20),
(119, 6, 10, 0),
(120, 0, 10, 0),
(120, 1, 10, 0),
(120, 2, 10, 0),
(120, 3, 10, 0),
(120, 4, 10, 0),
(120, 5, 11, 71),
(120, 6, 10, 0),
(121, 0, 10, 0),
(121, 1, 10, 0),
(121, 2, 10, 0),
(121, 3, 10, 0),
(121, 4, 10, 0),
(121, 5, 14, 115),
(121, 6, 10, 0),
(122, 0, 10, 0),
(122, 1, 10, 0),
(122, 2, 10, 0),
(122, 3, 10, 0),
(122, 4, 10, 0),
(122, 5, 14, 187),
(122, 6, 10, 0),
(123, 0, 10, 0),
(123, 1, 10, 0),
(123, 2, 10, 0),
(123, 3, 10, 0),
(123, 4, 10, 0),
(123, 5, 13, 173),
(123, 6, 10, 0),
(124, 0, 10, 0),
(124, 1, 10, 0),
(124, 2, 10, 0),
(124, 3, 10, 0),
(124, 4, 10, 0),
(124, 5, 13, 179),
(124, 6, 10, 0),
(125, 0, 10, 0),
(125, 1, 10, 0),
(125, 2, 10, 0),
(125, 3, 10, 0),
(125, 4, 10, 0),
(125, 5, 13, 68),
(125, 6, 10, 0),
(126, 0, 10, 0),
(126, 1, 10, 0),
(126, 2, 10, 0),
(126, 3, 10, 0),
(126, 4, 10, 0),
(126, 5, 13, 221),
(126, 6, 10, 0),
(127, 0, 10, 0),
(127, 1, 10, 0),
(127, 2, 10, 0),
(127, 3, 10, 0),
(127, 4, 10, 0),
(127, 5, 12, 221),
(127, 6, 10, 0),
(128, 0, 10, 0),
(128, 1, 10, 0),
(128, 2, 10, 0),
(128, 3, 10, 0),
(128, 4, 10, 0),
(128, 5, 13, 206),
(128, 6, 10, 0),
(129, 0, 10, 0),
(129, 1, 10, 0),
(129, 2, 10, 0),
(129, 3, 10, 0),
(129, 4, 10, 0),
(129, 5, 12, 74),
(129, 6, 10, 0),
(130, 0, 10, 0),
(130, 1, 10, 0),
(130, 2, 10, 0),
(130, 3, 10, 0),
(130, 4, 10, 0),
(130, 5, 14, 67),
(130, 6, 10, 0),
(131, 0, 10, 0),
(131, 1, 10, 0),
(131, 2, 10, 0),
(131, 3, 10, 0),
(131, 4, 10, 0),
(131, 5, 13, 284),
(131, 6, 10, 0),
(132, 0, 10, 0),
(132, 1, 10, 0),
(132, 2, 10, 0),
(132, 3, 10, 0),
(132, 4, 10, 0),
(132, 5, 12, 101),
(132, 6, 10, 0),
(133, 0, 10, 0),
(133, 1, 10, 0),
(133, 2, 10, 0),
(133, 3, 10, 0),
(133, 4, 10, 0),
(133, 5, 13, 113),
(133, 6, 10, 0),
(134, 0, 10, 0),
(134, 1, 10, 0),
(134, 2, 10, 0),
(134, 3, 10, 0),
(134, 4, 10, 0),
(134, 5, 10, 99),
(134, 6, 10, 0),
(135, 0, 10, 0),
(135, 1, 10, 0),
(135, 2, 10, 0),
(135, 3, 10, 0),
(135, 4, 10, 0),
(135, 5, 14, 103),
(135, 6, 10, 0),
(136, 0, 10, 0),
(136, 1, 10, 0),
(136, 2, 10, 0),
(136, 3, 10, 0),
(136, 4, 10, 0),
(136, 5, 11, 41),
(136, 6, 10, 0),
(137, 0, 10, 0),
(137, 1, 10, 0),
(137, 2, 10, 0),
(137, 3, 10, 0),
(137, 4, 10, 0),
(137, 5, 10, 84),
(137, 6, 10, 0),
(138, 0, 10, 0),
(138, 1, 10, 0),
(138, 2, 10, 0),
(138, 3, 10, 0),
(138, 4, 10, 0),
(138, 5, 14, 274),
(138, 6, 10, 0),
(139, 0, 10, 0),
(139, 1, 10, 0),
(139, 2, 10, 0),
(139, 3, 10, 0),
(139, 4, 10, 0),
(139, 5, 13, 185),
(139, 6, 10, 0),
(140, 0, 10, 0),
(140, 1, 10, 0),
(140, 2, 10, 0),
(140, 3, 10, 0),
(140, 4, 10, 0),
(140, 5, 10, 39),
(140, 6, 10, 0),
(141, 0, 10, 0),
(141, 1, 10, 0),
(141, 2, 10, 0),
(141, 3, 10, 0),
(141, 4, 10, 0),
(141, 5, 10, 69),
(141, 6, 10, 0),
(142, 0, 10, 0),
(142, 1, 10, 0),
(142, 2, 10, 0),
(142, 3, 10, 0),
(142, 4, 10, 0),
(142, 5, 10, 27),
(142, 6, 10, 0),
(143, 0, 10, 0),
(143, 1, 10, 0),
(143, 2, 10, 0),
(143, 3, 10, 0),
(143, 4, 10, 0),
(143, 5, 14, 61),
(143, 6, 10, 0),
(144, 0, 10, 0),
(144, 1, 10, 0),
(144, 2, 10, 0),
(144, 3, 10, 0),
(144, 4, 10, 0),
(144, 5, 14, 34),
(144, 6, 10, 0),
(145, 0, 10, 0),
(145, 1, 10, 0),
(145, 2, 10, 0),
(145, 3, 10, 0),
(145, 4, 10, 0),
(145, 5, 13, 314),
(145, 6, 10, 0),
(146, 0, 10, 0),
(146, 1, 10, 0),
(146, 2, 10, 0),
(146, 3, 10, 0),
(146, 4, 10, 0),
(146, 5, 11, 83),
(146, 6, 10, 0),
(147, 0, 10, 0),
(147, 1, 10, 0),
(147, 2, 10, 0),
(147, 3, 10, 0),
(147, 4, 10, 0),
(147, 5, 10, 51),
(147, 6, 10, 0),
(148, 0, 10, 0),
(148, 1, 10, 0),
(148, 2, 10, 0),
(148, 3, 10, 0),
(148, 4, 10, 0),
(148, 5, 13, 185),
(148, 6, 10, 0),
(149, 0, 10, 0),
(149, 1, 10, 0),
(149, 2, 10, 0),
(149, 3, 10, 0),
(149, 4, 10, 0),
(149, 5, 13, 329),
(149, 6, 10, 0),
(150, 0, 10, 0),
(150, 1, 10, 0),
(150, 2, 10, 0),
(150, 3, 10, 0),
(150, 4, 10, 0),
(150, 5, 12, 104),
(150, 6, 10, 0),
(151, 0, 10, 0),
(151, 1, 10, 0),
(151, 2, 10, 0),
(151, 3, 10, 0),
(151, 4, 10, 0),
(151, 5, 11, 101),
(151, 6, 10, 0),
(152, 0, 10, 0),
(152, 1, 10, 0),
(152, 2, 10, 0),
(152, 3, 10, 0),
(152, 4, 10, 0),
(152, 5, 10, 0),
(152, 6, 10, 0),
(153, 0, 10, 0),
(153, 1, 10, 0),
(153, 2, 10, 0),
(153, 3, 10, 0),
(153, 4, 10, 0),
(153, 5, 11, 44),
(153, 6, 10, 0),
(154, 0, 10, 0),
(154, 1, 10, 0),
(154, 2, 10, 0),
(154, 3, 10, 0),
(154, 4, 10, 0),
(154, 5, 13, 125),
(154, 6, 10, 0),
(155, 0, 10, 0),
(155, 1, 10, 0),
(155, 2, 10, 0),
(155, 3, 10, 0),
(155, 4, 10, 0),
(155, 5, 13, 68),
(155, 6, 10, 0),
(156, 0, 10, 0),
(156, 1, 10, 0),
(156, 2, 10, 0),
(156, 3, 10, 0),
(156, 4, 10, 0),
(156, 5, 10, 57),
(156, 6, 10, 0),
(157, 0, 10, 0),
(157, 1, 10, 0),
(157, 2, 10, 0),
(157, 3, 10, 0),
(157, 4, 10, 0),
(157, 5, 14, 289),
(157, 6, 10, 0),
(158, 0, 10, 0),
(158, 1, 10, 0),
(158, 2, 10, 0),
(158, 3, 10, 0),
(158, 4, 10, 0),
(158, 5, 10, 57),
(158, 6, 10, 0),
(159, 0, 10, 0),
(159, 1, 10, 0),
(159, 2, 10, 0),
(159, 3, 10, 0),
(159, 4, 10, 0),
(159, 5, 11, 95),
(159, 6, 10, 0),
(160, 0, 10, 0),
(160, 1, 10, 0),
(160, 2, 10, 0),
(160, 3, 10, 0),
(160, 4, 10, 0),
(160, 5, 15, 647),
(160, 6, 10, 0),
(161, 0, 10, 0),
(161, 1, 10, 0),
(161, 2, 10, 0),
(161, 3, 10, 0),
(161, 4, 86, 1858),
(161, 5, 65, 507),
(161, 6, 10, 0),
(162, 0, 10, 0),
(162, 1, 10, 0),
(162, 2, 10, 0),
(162, 3, 10, 0),
(162, 4, 90, 44516),
(162, 5, 65, 1929),
(162, 6, 10, 0),
(163, 0, 10, 0),
(163, 1, 10, 0),
(163, 2, 10, 0),
(163, 3, 10, 0),
(163, 4, 89, 2443),
(163, 5, 65, 1404),
(163, 6, 10, 0),
(164, 0, 10, 0),
(164, 1, 10, 0),
(164, 2, 10, 0),
(164, 3, 10, 0),
(164, 4, 86, 15796),
(164, 5, 65, 723),
(164, 6, 10, 0),
(165, 0, 10, 0),
(165, 1, 10, 0),
(165, 2, 10, 0),
(165, 3, 10, 0),
(165, 4, 87, 3281),
(165, 5, 65, 879),
(165, 6, 10, 0),
(166, 0, 10, 0),
(166, 1, 10, 0),
(166, 2, 10, 0),
(166, 3, 10, 0),
(166, 4, 89, 47341),
(166, 5, 65, 1377),
(166, 6, 10, 0),
(167, 0, 10, 0),
(167, 1, 10, 0),
(167, 2, 10, 0),
(167, 3, 10, 0),
(167, 4, 89, 38068),
(167, 5, 65, 1122),
(167, 6, 10, 0),
(168, 0, 10, 0),
(168, 1, 10, 0),
(168, 2, 10, 0),
(168, 3, 10, 0),
(168, 4, 90, 23378),
(168, 5, 65, 3027),
(168, 6, 10, 0),
(169, 0, 10, 0),
(169, 1, 10, 0),
(169, 2, 10, 0),
(169, 3, 10, 0),
(169, 4, 91, 11840),
(169, 5, 65, 3450),
(169, 6, 10, 0),
(170, 0, 10, 0),
(170, 1, 10, 0),
(170, 2, 10, 0),
(170, 3, 10, 0),
(170, 4, 90, 42686),
(170, 5, 65, 1452),
(170, 6, 10, 0),
(171, 0, 10, 0),
(171, 1, 10, 0),
(171, 2, 10, 0),
(171, 3, 10, 0),
(171, 4, 87, 23360),
(171, 5, 65, 2463),
(171, 6, 10, 0),
(172, 0, 10, 0),
(172, 1, 10, 0),
(172, 2, 10, 0),
(172, 3, 10, 0),
(172, 4, 89, 4120),
(172, 5, 65, 792),
(172, 6, 10, 0),
(173, 0, 10, 0),
(173, 1, 10, 0),
(173, 2, 10, 0),
(173, 3, 10, 0),
(173, 4, 87, 1376),
(173, 5, 65, 1020),
(173, 6, 10, 0),
(174, 0, 10, 0),
(174, 1, 10, 0),
(174, 2, 10, 0),
(174, 3, 10, 0),
(174, 4, 90, 43952),
(174, 5, 65, 1350),
(174, 6, 10, 0),
(175, 0, 10, 0),
(175, 1, 10, 0),
(175, 2, 10, 0),
(175, 3, 10, 0),
(175, 4, 90, 41753),
(175, 5, 65, 831),
(175, 6, 10, 0),
(176, 0, 10, 0),
(176, 1, 10, 0),
(176, 2, 10, 0),
(176, 3, 10, 0),
(176, 4, 89, 12778),
(176, 5, 65, 1128),
(176, 6, 10, 0),
(177, 0, 10, 0),
(177, 1, 10, 0),
(177, 2, 10, 0),
(177, 3, 10, 0),
(177, 4, 90, 794),
(177, 5, 65, 1179),
(177, 6, 10, 0),
(178, 0, 10, 0),
(178, 1, 10, 0),
(178, 2, 10, 0),
(178, 3, 10, 0),
(178, 4, 87, 24083),
(178, 5, 65, 597),
(178, 6, 10, 0),
(179, 0, 10, 0),
(179, 1, 10, 0),
(179, 2, 10, 0),
(179, 3, 10, 0),
(179, 4, 90, 46679),
(179, 5, 65, 2115),
(179, 6, 10, 0),
(180, 0, 10, 0),
(180, 1, 10, 0),
(180, 2, 10, 0),
(180, 3, 10, 0),
(180, 4, 87, 6011),
(180, 5, 65, 636),
(180, 6, 10, 0),
(181, 0, 10, 0),
(181, 1, 10, 0),
(181, 2, 10, 0),
(181, 3, 10, 0),
(181, 4, 90, 44324),
(181, 5, 65, 2088),
(181, 6, 10, 0),
(182, 0, 10, 0),
(182, 1, 10, 0),
(182, 2, 10, 0),
(182, 3, 10, 0),
(182, 4, 89, 22690),
(182, 5, 65, 873),
(182, 6, 10, 0),
(183, 0, 10, 0),
(183, 1, 10, 0),
(183, 2, 10, 0),
(183, 3, 10, 0),
(183, 4, 89, 32206),
(183, 5, 65, 843),
(183, 6, 10, 0),
(184, 0, 10, 0),
(184, 1, 10, 0),
(184, 2, 10, 0),
(184, 3, 10, 0),
(184, 4, 89, 48349),
(184, 5, 65, 876),
(184, 6, 10, 0),
(185, 0, 10, 0),
(185, 1, 10, 0),
(185, 2, 10, 0),
(185, 3, 10, 0),
(185, 4, 90, 34685),
(185, 5, 65, 1455),
(185, 6, 10, 0),
(186, 0, 11, 0),
(186, 1, 70, 12),
(186, 2, 76, 18934),
(186, 3, 70, 0),
(186, 4, 10, 0),
(186, 5, 80, 3663),
(186, 6, 10, 0),
(187, 0, 11, 0),
(187, 1, 70, 12),
(187, 2, 73, 8028),
(187, 3, 70, 0),
(187, 4, 10, 0),
(187, 5, 80, 1020),
(187, 6, 10, 0),
(188, 0, 11, 0),
(188, 1, 70, 12),
(188, 2, 76, 3571),
(188, 3, 70, 0),
(188, 4, 10, 0),
(188, 5, 80, 1461),
(188, 6, 10, 0),
(189, 0, 11, 0),
(189, 1, 70, 12),
(189, 2, 74, 19274),
(189, 3, 70, 0),
(189, 4, 10, 0),
(189, 5, 80, 1281),
(189, 6, 10, 0),
(190, 0, 11, 0),
(190, 1, 70, 12),
(190, 2, 72, 1756),
(190, 3, 70, 0),
(190, 4, 10, 0),
(190, 5, 80, 684),
(190, 6, 10, 0),
(191, 0, 11, 0),
(191, 1, 70, 12),
(191, 2, 73, 738),
(191, 3, 70, 0),
(191, 4, 10, 0),
(191, 5, 80, 894),
(191, 6, 10, 0),
(192, 0, 11, 0),
(192, 1, 70, 12),
(192, 2, 76, 5071),
(192, 3, 70, 0),
(192, 4, 10, 0),
(192, 5, 80, 4794),
(192, 6, 10, 0),
(193, 0, 11, 0),
(193, 1, 70, 12),
(193, 2, 75, 5991),
(193, 3, 70, 0),
(193, 4, 10, 0),
(193, 5, 80, 693),
(193, 6, 10, 0),
(194, 0, 11, 0),
(194, 1, 70, 12),
(194, 2, 75, 22638),
(194, 3, 70, 0),
(194, 4, 10, 0),
(194, 5, 80, 1089),
(194, 6, 10, 0),
(195, 0, 11, 0),
(195, 1, 70, 12),
(195, 2, 76, 11149),
(195, 3, 70, 0),
(195, 4, 10, 0),
(195, 5, 80, 1359),
(195, 6, 10, 0),
(196, 0, 11, 0),
(196, 1, 70, 12),
(196, 2, 76, 1048),
(196, 3, 70, 0),
(196, 4, 10, 0),
(196, 5, 80, 1362),
(196, 6, 10, 0),
(197, 0, 11, 0),
(197, 1, 70, 12),
(197, 2, 76, 1648),
(197, 3, 70, 0),
(197, 4, 10, 0),
(197, 5, 80, 2001),
(197, 6, 10, 0),
(198, 0, 11, 0),
(198, 1, 70, 12),
(198, 2, 73, 5430),
(198, 3, 70, 0),
(198, 4, 10, 0),
(198, 5, 80, 540),
(198, 6, 10, 0),
(199, 0, 11, 0),
(199, 1, 70, 12),
(199, 2, 73, 11187),
(199, 3, 70, 0),
(199, 4, 10, 0),
(199, 5, 80, 471),
(199, 6, 10, 0),
(200, 0, 11, 0),
(200, 1, 70, 12),
(200, 2, 76, 19279),
(200, 3, 70, 0),
(200, 4, 10, 0),
(200, 5, 80, 2259),
(200, 6, 10, 0),
(201, 0, 11, 0),
(201, 1, 70, 12),
(201, 2, 72, 12790),
(201, 3, 70, 0),
(201, 4, 10, 0),
(201, 5, 80, 801),
(201, 6, 10, 0),
(202, 0, 11, 0),
(202, 1, 70, 12),
(202, 2, 72, 7567),
(202, 3, 70, 0),
(202, 4, 10, 0),
(202, 5, 80, 699),
(202, 6, 10, 0),
(203, 0, 11, 0),
(203, 1, 70, 12),
(203, 2, 73, 7011),
(203, 3, 70, 0),
(203, 4, 10, 0),
(203, 5, 80, 480),
(203, 6, 10, 0),
(204, 0, 11, 0),
(204, 1, 70, 12),
(204, 2, 73, 4440),
(204, 3, 70, 0),
(204, 4, 10, 0),
(204, 5, 80, 816),
(204, 6, 10, 0),
(205, 0, 11, 0),
(205, 1, 70, 12),
(205, 2, 70, 5796),
(205, 3, 70, 0),
(205, 4, 10, 0),
(205, 5, 80, 162),
(205, 6, 10, 0),
(206, 0, 11, 0),
(206, 1, 70, 12),
(206, 2, 74, 16724),
(206, 3, 70, 0),
(206, 4, 10, 0),
(206, 5, 80, 1575),
(206, 6, 10, 0),
(207, 0, 11, 0),
(207, 1, 70, 12),
(207, 2, 76, 4726),
(207, 3, 70, 0),
(207, 4, 10, 0),
(207, 5, 80, 2052),
(207, 6, 10, 0),
(208, 0, 11, 0),
(208, 1, 70, 12),
(208, 2, 72, 11764),
(208, 3, 70, 0),
(208, 4, 10, 0),
(208, 5, 80, 2052),
(208, 6, 10, 0),
(209, 0, 11, 0),
(209, 1, 70, 12),
(209, 2, 73, 3261),
(209, 3, 70, 0),
(209, 4, 10, 0),
(209, 5, 80, 1548),
(209, 6, 10, 0),
(210, 0, 11, 0),
(210, 1, 70, 12),
(210, 2, 72, 4369),
(210, 3, 70, 0),
(210, 4, 10, 0),
(210, 5, 80, 1230),
(210, 6, 10, 0),
(214, 0, 10, 0),
(214, 1, 17, 415),
(214, 2, 10, 0),
(214, 3, 10, 0),
(214, 4, 10, 0),
(214, 5, 10, 0),
(214, 6, 10, 0);

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_spells`
--

CREATE TABLE IF NOT EXISTS `player_spells` (
  `player_id` int(11) NOT NULL,
  `name` varchar(255) NOT NULL,
  UNIQUE KEY `player_id_2` (`player_id`,`name`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_storage`
--

CREATE TABLE IF NOT EXISTS `player_storage` (
  `player_id` int(11) NOT NULL DEFAULT '0',
  `key` int(10) unsigned NOT NULL DEFAULT '0',
  `value` varchar(255) NOT NULL DEFAULT '0',
  UNIQUE KEY `player_id_2` (`player_id`,`key`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `player_storage`
--

INSERT INTO `player_storage` (`player_id`, `key`, `value`) VALUES
(2, 30001, '1'),
(2, 59423, '{}'),
(2, 59432, '-1'),
(2, 59433, '-1'),
(2, 59434, '1'),
(2, 10001501, '65539'),
(2, 10001502, '131075'),
(2, 10001503, '2293762'),
(2, 10001504, '2359296'),
(3, 30001, '1'),
(3, 59423, '{}'),
(3, 59425, '1365446254'),
(3, 59427, '0'),
(3, 59430, '1365438039'),
(3, 59431, '0'),
(3, 59432, '-1'),
(3, 59433, '-1'),
(3, 59434, '5'),
(3, 10001501, '65539'),
(3, 10001502, '131073'),
(3, 10001503, '2359296'),
(8, 59432, '-1'),
(8, 59433, '-1'),
(8, 10001501, '2359296'),
(9, 59432, '-1'),
(9, 59433, '-1'),
(9, 10001501, '65537'),
(9, 10001502, '2359296'),
(10, 59432, '-1'),
(10, 59433, '-1'),
(10, 10001501, '2359296'),
(11, 59432, '1'),
(11, 59433, '1'),
(12, 59432, '1'),
(12, 59433, '1'),
(13, 59432, '1'),
(13, 59433, '1'),
(14, 59432, '1'),
(14, 59433, '1'),
(15, 59432, '1'),
(15, 59433, '1'),
(16, 59432, '1'),
(16, 59433, '1'),
(17, 59432, '1'),
(17, 59433, '1'),
(18, 59432, '1'),
(18, 59433, '1'),
(19, 59432, '1'),
(19, 59433, '1'),
(20, 59432, '1'),
(20, 59433, '1'),
(21, 59432, '1'),
(21, 59433, '1'),
(22, 59432, '1'),
(22, 59433, '1'),
(23, 59432, '1'),
(23, 59433, '1'),
(24, 59432, '1'),
(24, 59433, '1'),
(25, 59432, '1'),
(25, 59433, '1'),
(26, 59432, '1'),
(26, 59433, '1'),
(27, 59432, '1'),
(27, 59433, '1'),
(28, 59432, '1'),
(28, 59433, '1'),
(29, 59432, '1'),
(29, 59433, '1'),
(30, 59432, '1'),
(30, 59433, '1'),
(31, 59432, '1'),
(31, 59433, '1'),
(32, 59432, '1'),
(32, 59433, '1'),
(33, 59432, '1'),
(33, 59433, '1'),
(34, 59432, '1'),
(34, 59433, '1'),
(35, 59432, '1'),
(35, 59433, '1'),
(36, 59432, '1'),
(36, 59433, '1'),
(37, 59432, '1'),
(37, 59433, '1'),
(38, 59432, '1'),
(38, 59433, '1'),
(39, 59432, '1'),
(39, 59433, '1'),
(40, 59432, '1'),
(40, 59433, '1'),
(41, 59432, '1'),
(41, 59433, '1'),
(42, 59432, '1'),
(42, 59433, '1'),
(43, 59432, '1'),
(43, 59433, '1'),
(44, 59432, '1'),
(44, 59433, '1'),
(45, 59432, '1'),
(45, 59433, '1'),
(46, 59432, '1'),
(46, 59433, '1'),
(47, 59432, '1'),
(47, 59433, '1'),
(48, 59432, '1'),
(48, 59433, '1'),
(49, 59432, '1'),
(49, 59433, '1'),
(50, 59432, '1'),
(50, 59433, '1'),
(51, 59432, '1'),
(51, 59433, '1'),
(52, 59432, '1'),
(52, 59433, '1'),
(53, 59432, '1'),
(53, 59433, '1'),
(54, 59432, '1'),
(54, 59433, '1'),
(55, 59432, '1'),
(55, 59433, '1'),
(56, 59432, '1'),
(56, 59433, '1'),
(57, 59432, '1'),
(57, 59433, '1'),
(58, 59432, '1'),
(58, 59433, '1'),
(59, 59432, '1'),
(59, 59433, '1'),
(60, 59432, '1'),
(60, 59433, '1'),
(61, 59432, '1'),
(61, 59433, '1'),
(62, 59432, '1'),
(62, 59433, '1'),
(63, 59432, '1'),
(63, 59433, '1'),
(64, 59432, '1'),
(64, 59433, '1'),
(65, 59432, '1'),
(65, 59433, '1'),
(66, 59432, '1'),
(66, 59433, '1'),
(67, 59432, '1'),
(67, 59433, '1'),
(68, 59432, '1'),
(68, 59433, '1'),
(69, 59432, '1'),
(69, 59433, '1'),
(70, 59432, '1'),
(70, 59433, '1'),
(71, 59432, '1'),
(71, 59433, '1'),
(72, 59432, '1'),
(72, 59433, '1'),
(73, 59432, '1'),
(73, 59433, '1'),
(74, 59432, '1'),
(74, 59433, '1'),
(75, 59432, '1'),
(75, 59433, '1'),
(76, 59432, '1'),
(76, 59433, '1'),
(77, 59432, '1'),
(77, 59433, '1'),
(78, 59432, '1'),
(78, 59433, '1'),
(79, 59432, '1'),
(79, 59433, '1'),
(80, 59432, '1'),
(80, 59433, '1'),
(81, 59432, '1'),
(81, 59433, '1'),
(82, 59432, '1'),
(82, 59433, '1'),
(83, 59432, '1'),
(83, 59433, '1'),
(84, 59432, '1'),
(84, 59433, '1'),
(85, 59432, '1'),
(85, 59433, '1'),
(86, 59432, '1'),
(86, 59433, '1'),
(87, 59432, '1'),
(87, 59433, '1'),
(88, 59432, '1'),
(88, 59433, '1'),
(89, 59432, '1'),
(89, 59433, '1'),
(90, 59432, '1'),
(90, 59433, '1'),
(91, 59432, '1'),
(91, 59433, '1'),
(92, 59432, '1'),
(92, 59433, '1'),
(93, 59432, '1'),
(93, 59433, '1'),
(94, 59432, '1'),
(94, 59433, '1'),
(95, 59432, '1'),
(95, 59433, '1'),
(96, 59432, '1'),
(96, 59433, '1'),
(97, 59432, '1'),
(97, 59433, '1'),
(98, 59432, '1'),
(98, 59433, '1'),
(99, 59432, '1'),
(99, 59433, '1'),
(100, 59432, '1'),
(100, 59433, '1'),
(101, 59432, '1'),
(101, 59433, '1'),
(102, 59432, '1'),
(102, 59433, '1'),
(103, 59432, '1'),
(103, 59433, '1'),
(104, 59432, '1'),
(104, 59433, '1'),
(105, 59432, '1'),
(105, 59433, '1'),
(106, 59432, '1'),
(106, 59433, '1'),
(107, 59432, '1'),
(107, 59433, '1'),
(108, 59432, '1'),
(108, 59433, '1'),
(109, 59432, '1'),
(109, 59433, '1'),
(110, 59432, '1'),
(110, 59433, '1'),
(111, 59432, '1'),
(111, 59433, '-1'),
(112, 59432, '1'),
(112, 59433, '-1'),
(113, 59432, '1'),
(113, 59433, '-1'),
(114, 59432, '1'),
(114, 59433, '-1'),
(115, 59432, '1'),
(115, 59433, '-1'),
(116, 59432, '1'),
(116, 59433, '-1'),
(117, 59432, '1'),
(117, 59433, '-1'),
(118, 59432, '1'),
(118, 59433, '-1'),
(119, 59432, '1'),
(119, 59433, '-1'),
(120, 59432, '1'),
(120, 59433, '-1'),
(121, 59432, '1'),
(121, 59433, '-1'),
(122, 59432, '1'),
(122, 59433, '-1'),
(123, 59432, '1'),
(123, 59433, '-1'),
(124, 59432, '1'),
(124, 59433, '-1'),
(125, 59432, '1'),
(125, 59433, '-1'),
(126, 59432, '1'),
(126, 59433, '-1'),
(127, 59432, '1'),
(127, 59433, '-1'),
(128, 59432, '1'),
(128, 59433, '-1'),
(129, 59432, '1'),
(129, 59433, '-1'),
(130, 59432, '1'),
(130, 59433, '-1'),
(131, 59432, '1'),
(131, 59433, '-1'),
(132, 59432, '1'),
(132, 59433, '-1'),
(133, 59432, '1'),
(133, 59433, '-1'),
(134, 59432, '1'),
(134, 59433, '-1'),
(135, 59432, '1'),
(135, 59433, '-1'),
(136, 59432, '1'),
(136, 59433, '-1'),
(137, 59432, '1'),
(137, 59433, '-1'),
(138, 59432, '1'),
(138, 59433, '-1'),
(139, 59432, '1'),
(139, 59433, '-1'),
(140, 59432, '1'),
(140, 59433, '-1'),
(141, 59432, '1'),
(141, 59433, '-1'),
(142, 59432, '1'),
(142, 59433, '-1'),
(143, 59432, '1'),
(143, 59433, '-1'),
(144, 59432, '1'),
(144, 59433, '-1'),
(145, 59432, '1'),
(145, 59433, '-1'),
(146, 59432, '1'),
(146, 59433, '-1'),
(147, 59432, '1'),
(147, 59433, '-1'),
(148, 59432, '1'),
(148, 59433, '-1'),
(149, 59432, '1'),
(149, 59433, '-1'),
(150, 59432, '1'),
(150, 59433, '-1'),
(151, 59432, '1'),
(151, 59433, '-1'),
(152, 59432, '1'),
(152, 59433, '-1'),
(153, 59432, '1'),
(153, 59433, '-1'),
(154, 59432, '1'),
(154, 59433, '-1'),
(155, 59432, '1'),
(155, 59433, '-1'),
(156, 59432, '1'),
(156, 59433, '-1'),
(157, 59432, '1'),
(157, 59433, '-1'),
(158, 59432, '1'),
(158, 59433, '-1'),
(159, 59432, '1'),
(159, 59433, '-1'),
(160, 59432, '1'),
(160, 59433, '-1'),
(161, 59432, '1'),
(161, 59433, '-1'),
(162, 59432, '1'),
(162, 59433, '-1'),
(163, 59432, '1'),
(163, 59433, '-1'),
(164, 59432, '1'),
(164, 59433, '-1'),
(165, 59432, '1'),
(165, 59433, '-1'),
(166, 59432, '1'),
(166, 59433, '-1'),
(167, 59432, '1'),
(167, 59433, '-1'),
(168, 59432, '1'),
(168, 59433, '-1'),
(169, 59432, '1'),
(169, 59433, '-1'),
(170, 59432, '1'),
(170, 59433, '-1'),
(171, 59432, '1'),
(171, 59433, '-1'),
(172, 59432, '1'),
(172, 59433, '-1'),
(173, 59432, '1'),
(173, 59433, '-1'),
(174, 59432, '1'),
(174, 59433, '-1'),
(175, 59432, '1'),
(175, 59433, '-1'),
(176, 59432, '1'),
(176, 59433, '-1'),
(177, 59432, '1'),
(177, 59433, '-1'),
(178, 59432, '1'),
(178, 59433, '-1'),
(179, 59432, '1'),
(179, 59433, '-1'),
(180, 59432, '1'),
(180, 59433, '-1'),
(181, 59432, '1'),
(181, 59433, '-1'),
(182, 59432, '1'),
(182, 59433, '-1'),
(183, 59432, '1'),
(183, 59433, '-1'),
(184, 59432, '1'),
(184, 59433, '-1'),
(185, 59432, '1'),
(185, 59433, '-1'),
(186, 59432, '1'),
(186, 59433, '-1'),
(187, 59432, '1'),
(187, 59433, '-1'),
(188, 59432, '1'),
(188, 59433, '-1'),
(189, 59432, '1'),
(189, 59433, '-1'),
(190, 59432, '1'),
(190, 59433, '-1'),
(191, 59432, '1'),
(191, 59433, '-1'),
(192, 59432, '1'),
(192, 59433, '-1'),
(193, 59432, '1'),
(193, 59433, '-1'),
(194, 59432, '1'),
(194, 59433, '-1'),
(195, 59432, '1'),
(195, 59433, '-1'),
(196, 59432, '1'),
(196, 59433, '-1'),
(197, 59432, '1'),
(197, 59433, '-1'),
(198, 59432, '1'),
(198, 59433, '-1'),
(199, 59432, '1'),
(199, 59433, '-1'),
(200, 59432, '1'),
(200, 59433, '-1'),
(201, 59432, '1'),
(201, 59433, '-1'),
(202, 59432, '1'),
(202, 59433, '-1'),
(203, 59432, '1'),
(203, 59433, '-1'),
(204, 59432, '1'),
(204, 59433, '-1'),
(205, 59432, '1'),
(205, 59433, '-1'),
(206, 59432, '1'),
(206, 59433, '-1'),
(207, 59432, '1'),
(207, 59433, '-1'),
(208, 59432, '1'),
(208, 59433, '-1'),
(209, 59432, '1'),
(209, 59433, '-1'),
(210, 59432, '1'),
(210, 59433, '-1'),
(214, 59432, '-1'),
(214, 59433, '-1'),
(214, 10001501, '655361'),
(214, 10001502, '2359296');

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `player_viplist`
--

CREATE TABLE IF NOT EXISTS `player_viplist` (
  `player_id` int(11) NOT NULL,
  `vip_id` int(11) NOT NULL,
  UNIQUE KEY `player_id_2` (`player_id`,`vip_id`),
  KEY `player_id` (`player_id`),
  KEY `vip_id` (`vip_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `server_config`
--

CREATE TABLE IF NOT EXISTS `server_config` (
  `config` varchar(35) NOT NULL DEFAULT '',
  `value` int(11) NOT NULL,
  UNIQUE KEY `config` (`config`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `server_config`
--

INSERT INTO `server_config` (`config`, `value`) VALUES
('db_version', 23),
('encryption', 0);

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `server_motd`
--

CREATE TABLE IF NOT EXISTS `server_motd` (
  `id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `text` text NOT NULL,
  UNIQUE KEY `id` (`id`,`world_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `server_motd`
--

INSERT INTO `server_motd` (`id`, `world_id`, `text`) VALUES
(3, 0, 'Welcome to the Thais War server!');

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `server_record`
--

CREATE TABLE IF NOT EXISTS `server_record` (
  `record` int(11) NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `timestamp` bigint(20) NOT NULL,
  UNIQUE KEY `record` (`record`,`world_id`,`timestamp`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

--
-- Zrzut danych tabeli `server_record`
--

INSERT INTO `server_record` (`record`, `world_id`, `timestamp`) VALUES
(0, 0, 0);

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `server_reports`
--

CREATE TABLE IF NOT EXISTS `server_reports` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `player_id` int(11) NOT NULL DEFAULT '1',
  `posx` int(11) NOT NULL DEFAULT '0',
  `posy` int(11) NOT NULL DEFAULT '0',
  `posz` int(11) NOT NULL DEFAULT '0',
  `timestamp` bigint(20) NOT NULL DEFAULT '0',
  `report` text NOT NULL,
  `reads` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `world_id` (`world_id`),
  KEY `reads` (`reads`),
  KEY `player_id` (`player_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `tiles`
--

CREATE TABLE IF NOT EXISTS `tiles` (
  `id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `house_id` int(10) unsigned NOT NULL,
  `x` int(5) unsigned NOT NULL,
  `y` int(5) unsigned NOT NULL,
  `z` tinyint(2) unsigned NOT NULL,
  UNIQUE KEY `id` (`id`,`world_id`),
  KEY `x` (`x`,`y`,`z`),
  KEY `house_id` (`house_id`,`world_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `tile_items`
--

CREATE TABLE IF NOT EXISTS `tile_items` (
  `tile_id` int(10) unsigned NOT NULL,
  `world_id` tinyint(2) unsigned NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL,
  `pid` int(11) NOT NULL DEFAULT '0',
  `itemtype` int(11) NOT NULL,
  `count` int(11) NOT NULL DEFAULT '0',
  `attributes` blob NOT NULL,
  UNIQUE KEY `tile_id` (`tile_id`,`world_id`,`sid`),
  KEY `sid` (`sid`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_alive_records`
--

CREATE TABLE IF NOT EXISTS `zotsme_alive_records` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `player_id` int(11) NOT NULL,
  `date` int(11) NOT NULL,
  `alive_time` int(11) NOT NULL,
  `kills` int(11) NOT NULL DEFAULT '0',
  `assists` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`,`date`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=9550 ;

--
-- Zrzut danych tabeli `zotsme_alive_records`
--

INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(1, 90, 1373319965, 604, 1, 0),
(2, 58, 1373320436, 1077, 3, 2),
(3, 122, 1373320969, 1607, 1, 0),
(4, 25, 1373321600, 2243, 2, 3),
(5, 95, 1373321636, 2275, 2, 2),
(6, 62, 1373322086, 2535, 1, 3),
(7, 119, 1373322796, 3434, 1, 2),
(8, 122, 1373323050, 2081, 1, 1),
(9, 23, 1373323429, 4072, 1, 1),
(10, 135, 1373323593, 4230, 3, 7),
(11, 135, 1373324395, 320, 1, 0),
(12, 46, 1373324634, 154, 1, 2),
(13, 100, 1373325092, 404, 1, 1),
(14, 106, 1373325214, 320, 1, 0),
(15, 12, 1373325285, 601, 2, 0),
(16, 102, 1373325500, 812, 1, 2),
(17, 23, 1373325650, 966, 2, 0),
(18, 64, 1373325710, 1024, 2, 3),
(19, 37, 1373325795, 460, 1, 0),
(20, 121, 1373325805, 1116, 3, 2),
(21, 38, 1373325805, 1120, 1, 0),
(22, 143, 1373326206, 1516, 1, 2),
(23, 119, 1373326409, 1720, 1, 2),
(24, 46, 1373326437, 1751, 1, 8),
(25, 125, 1373326466, 1354, 2, 0),
(26, 11, 1373326485, 1801, 1, 7),
(27, 68, 1373326524, 1838, 2, 4),
(28, 48, 1373326576, 1890, 2, 4),
(29, 95, 1373326684, 1996, 2, 8),
(30, 63, 1373326700, 1959, 1, 4),
(31, 17, 1373326913, 2229, 3, 8),
(32, 22, 1373326922, 2238, 3, 9),
(33, 144, 1373326937, 2247, 4, 2),
(34, 12, 1373327215, 1930, 3, 0),
(35, 67, 1373327256, 2570, 3, 1),
(36, 155, 1373327369, 2268, 3, 5),
(37, 103, 1373327520, 2832, 1, 5),
(38, 120, 1373327625, 1444, 3, 0),
(39, 97, 1373327733, 3045, 2, 14),
(40, 19, 1373327741, 2152, 1, 0),
(41, 82, 1373327758, 3071, 1, 2),
(42, 16, 1373327825, 3141, 1, 1),
(43, 35, 1373327857, 3172, 1, 0),
(44, 186, 1373327862, 3170, 1, 0),
(45, 31, 1373327991, 3306, 2, 0),
(46, 104, 1373328173, 3485, 1, 3),
(47, 207, 1373328324, 3631, 1, 1),
(48, 209, 1373328426, 1768, 1, 1),
(49, 92, 1373328433, 3745, 1, 2),
(50, 31, 1373328454, 463, 1, 2),
(51, 151, 1373328518, 3828, 1, 8),
(52, 21, 1373328537, 3853, 1, 0),
(53, 149, 1373328601, 3911, 2, 11),
(54, 78, 1373328720, 4033, 1, 3),
(55, 107, 1373328744, 4056, 1, 5),
(56, 36, 1373328864, 4179, 1, 1),
(57, 20, 1373328915, 4231, 1, 3),
(58, 93, 1373328938, 4250, 2, 5),
(59, 100, 1373329010, 3918, 3, 6),
(60, 72, 1373329121, 4434, 8, 16),
(61, 156, 1373329123, 4432, 3, 3),
(62, 115, 1373329165, 4476, 6, 17),
(63, 77, 1373329176, 4419, 3, 16),
(64, 18, 1373329183, 4499, 2, 5),
(65, 45, 1373329193, 4508, 1, 4),
(66, 123, 1373329231, 4542, 5, 8),
(67, 145, 1373329237, 4547, 1, 4),
(68, 64, 1373329280, 3570, 3, 11),
(69, 136, 1373329403, 4713, 2, 12),
(70, 66, 1373329438, 2669, 2, 7),
(71, 78, 1373329483, 762, 1, 2),
(72, 84, 1373329577, 4890, 1, 1),
(73, 160, 1373330076, 4730, 2, 9),
(74, 108, 1373330097, 4019, 2, 13),
(75, 74, 1373330216, 5529, 2, 16),
(76, 106, 1373330221, 3096, 3, 6),
(77, 135, 1373330223, 4148, 2, 6),
(78, 72, 1373330254, 1133, 2, 0),
(79, 121, 1373330339, 4534, 3, 6),
(80, 75, 1373330526, 5839, 2, 2),
(81, 121, 1373330563, 224, 1, 0),
(82, 44, 1373330567, 5882, 7, 5),
(83, 103, 1373330605, 3085, 2, 8),
(84, 100, 1373330610, 1600, 2, 2),
(85, 99, 1373330732, 6044, 7, 15),
(86, 160, 1373330785, 709, 1, 2),
(87, 44, 1373330813, 246, 1, 2),
(88, 109, 1373330868, 6180, 2, 2),
(89, 13, 1373330881, 6197, 1, 0),
(90, 108, 1373331086, 989, 2, 3),
(91, 160, 1373331221, 436, 1, 1),
(92, 101, 1373331239, 6551, 1, 0),
(93, 44, 1373331297, 483, 1, 0),
(94, 155, 1373331350, 2199, 2, 7),
(95, 64, 1373331390, 2110, 1, 0),
(96, 70, 1373331417, 6730, 5, 12),
(97, 78, 1373331445, 1962, 1, 1),
(98, 88, 1373331510, 6823, 2, 4),
(99, 38, 1373331556, 5750, 1, 6),
(100, 96, 1373331615, 6533, 2, 5),
(101, 122, 1373331617, 6928, 1, 2),
(102, 56, 1373331632, 6946, 5, 8),
(103, 202, 1373331632, 2583, 1, 1),
(104, 159, 1373331669, 6978, 4, 12),
(105, 187, 1373331972, 6912, 1, 2),
(106, 63, 1373331972, 5272, 3, 5),
(107, 113, 1373332117, 6862, 9, 14),
(108, 157, 1373332289, 1744, 2, 5),
(109, 71, 1373332385, 7698, 11, 14),
(110, 79, 1373332436, 3868, 1, 2),
(111, 110, 1373332494, 7806, 8, 18),
(112, 54, 1373332802, 4271, 1, 0),
(113, 60, 1373332862, 8176, 2, 9),
(114, 42, 1373333051, 7870, 1, 0),
(115, 80, 1373333081, 8394, 3, 7),
(116, 85, 1373333159, 7656, 2, 5),
(117, 47, 1373333193, 8507, 5, 7),
(118, 69, 1373333427, 2175, 3, 10),
(119, 70, 1373333507, 2090, 1, 5),
(120, 111, 1373333687, 3814, 1, 2),
(121, 67, 1373333713, 6457, 1, 3),
(122, 90, 1373333779, 9092, 1, 3),
(123, 155, 1373333844, 2493, 2, 2),
(124, 48, 1373333932, 7356, 2, 1),
(125, 59, 1373333960, 9274, 2, 7),
(126, 88, 1373334024, 2514, 1, 8),
(127, 71, 1373334102, 1717, 2, 4),
(128, 30, 1373334127, 9442, 1, 1),
(129, 150, 1373334144, 9454, 4, 11),
(130, 32, 1373334187, 9502, 1, 0),
(131, 68, 1373334291, 5974, 9, 13),
(132, 151, 1373334298, 5780, 2, 13),
(133, 113, 1373334351, 2234, 4, 3),
(134, 188, 1373334454, 6775, 1, 2),
(135, 82, 1373334461, 6703, 2, 5),
(136, 130, 1373334464, 9775, 4, 11),
(137, 72, 1373334641, 4387, 6, 9),
(138, 137, 1373334653, 9963, 1, 0),
(139, 118, 1373334677, 9988, 1, 2),
(140, 74, 1373334690, 4474, 3, 7),
(141, 14, 1373334728, 1765, 2, 1),
(142, 50, 1373334821, 10135, 1, 8),
(143, 53, 1373334878, 6277, 1, 2),
(144, 194, 1373334903, 10211, 1, 5),
(145, 111, 1373334923, 1236, 1, 4),
(146, 94, 1373334941, 2409, 1, 6),
(147, 26, 1373334952, 10267, 2, 16),
(148, 19, 1373335054, 7312, 1, 5),
(149, 24, 1373335055, 2513, 2, 6),
(150, 130, 1373335155, 691, 2, 2),
(151, 159, 1373335185, 3516, 6, 4),
(152, 29, 1373335242, 1971, 3, 6),
(153, 166, 1373335258, 2421, 1, 1),
(154, 131, 1373335549, 6328, 3, 9),
(155, 42, 1373335569, 2518, 4, 4),
(156, 118, 1373335706, 1029, 2, 3),
(157, 47, 1373335741, 2547, 2, 6),
(158, 207, 1373335747, 6269, 1, 6),
(159, 49, 1373335776, 6990, 2, 9),
(160, 84, 1373335820, 4623, 1, 5),
(161, 111, 1373336007, 297, 1, 2),
(162, 57, 1373336153, 4147, 1, 3),
(163, 146, 1373336238, 3061, 3, 4),
(164, 95, 1373336287, 9603, 2, 3),
(165, 199, 1373336368, 2152, 1, 1),
(166, 14, 1373336373, 1645, 1, 0),
(167, 126, 1373336544, 11855, 3, 11),
(168, 131, 1373336838, 1289, 2, 4),
(169, 134, 1373336973, 3408, 1, 6),
(170, 93, 1373337029, 8091, 5, 8),
(171, 80, 1373337128, 4047, 3, 1),
(172, 202, 1373337138, 3674, 1, 2),
(173, 21, 1373337140, 8603, 2, 10),
(174, 115, 1373337207, 6923, 1, 4),
(175, 81, 1373337396, 12709, 5, 12),
(176, 129, 1373337439, 12750, 10, 20),
(177, 72, 1373337570, 2929, 2, 9),
(178, 30, 1373337578, 3451, 1, 2),
(179, 158, 1373337586, 3961, 2, 5),
(180, 126, 1373337637, 1092, 2, 2),
(181, 195, 1373337655, 12963, 1, 9),
(182, 72, 1373337724, 154, 1, 2),
(183, 79, 1373337740, 2034, 1, 6),
(184, 18, 1373337772, 6949, 3, 5),
(185, 59, 1373337778, 3818, 1, 8),
(186, 116, 1373337932, 13243, 7, 24),
(187, 65, 1373338052, 8338, 2, 12),
(188, 143, 1373338088, 554, 2, 2),
(189, 144, 1373338098, 3130, 1, 9),
(190, 159, 1373338120, 2935, 1, 5),
(191, 134, 1373338163, 1190, 1, 3),
(192, 122, 1373338193, 6576, 4, 17),
(193, 27, 1373338222, 4353, 1, 12),
(194, 136, 1373338285, 4380, 3, 7),
(195, 50, 1373338455, 3634, 8, 12),
(196, 200, 1373338460, 7880, 2, 5),
(197, 207, 1373338465, 1771, 1, 2),
(198, 56, 1373338484, 1347, 1, 4),
(199, 35, 1373338517, 10660, 1, 20),
(200, 112, 1373338610, 6155, 1, 4),
(201, 120, 1373338643, 11018, 9, 14),
(202, 18, 1373339124, 1352, 1, 0),
(203, 139, 1373339724, 15034, 2, 8),
(204, 153, 1373340049, 4385, 2, 10),
(205, 72, 1373342083, 4358, 3, 3),
(206, 197, 1373342277, 13598, 2, 5),
(207, 150, 1373342423, 6072, 5, 9),
(208, 59, 1373342425, 4647, 3, 11),
(209, 50, 1373342450, 3995, 3, 3),
(210, 207, 1373342531, 4066, 1, 3),
(211, 156, 1373342567, 13444, 5, 16),
(212, 25, 1373342650, 10301, 2, 6),
(213, 96, 1373342867, 11251, 1, 1),
(214, 46, 1373342944, 16507, 8, 15),
(215, 146, 1373343234, 6996, 2, 8),
(216, 185, 1373343236, 6200, 1, 2),
(217, 122, 1373343285, 5092, 1, 6),
(218, 144, 1373343337, 5239, 1, 2),
(219, 187, 1373343360, 11388, 3, 7),
(220, 11, 1373343474, 16989, 3, 4),
(221, 39, 1373343541, 14401, 1, 1),
(222, 57, 1373343639, 7486, 3, 7),
(223, 210, 1373343650, 6060, 1, 4),
(224, 84, 1373343795, 7975, 2, 12),
(225, 62, 1373343802, 19116, 5, 24),
(226, 169, 1373343970, 11393, 1, 2),
(227, 157, 1373344202, 11913, 1, 2),
(228, 112, 1373344285, 5675, 1, 4),
(229, 149, 1373344428, 11182, 1, 5),
(230, 38, 1373344434, 10903, 1, 2),
(231, 196, 1373344435, 6443, 1, 1),
(232, 209, 1373344441, 2922, 1, 2),
(233, 38, 1373344483, 48, 1, 0),
(234, 94, 1373344494, 9553, 2, 5),
(235, 134, 1373344605, 6442, 1, 5),
(236, 131, 1373344734, 7896, 1, 4),
(237, 116, 1373344776, 6844, 1, 3),
(238, 144, 1373344822, 1485, 1, 7),
(239, 138, 1373345008, 9145, 3, 17),
(240, 151, 1373345013, 10714, 1, 6),
(241, 87, 1373345217, 20530, 1, 6),
(242, 106, 1373345248, 15027, 1, 0),
(243, 32, 1373345354, 11167, 1, 4),
(244, 26, 1373345356, 10403, 2, 5),
(245, 13, 1373345406, 773, 1, 0),
(246, 141, 1373345461, 20771, 1, 3),
(247, 194, 1373345484, 10581, 1, 7),
(248, 83, 1373345487, 8817, 5, 10),
(249, 102, 1373345542, 20042, 1, 8),
(250, 106, 1373345579, 331, 1, 0),
(251, 111, 1373345657, 3076, 1, 3),
(252, 129, 1373345743, 8304, 1, 3),
(253, 132, 1373345744, 21055, 2, 4),
(254, 34, 1373345753, 21068, 4, 17),
(255, 84, 1373345777, 1982, 1, 7),
(256, 195, 1373345835, 2593, 1, 0),
(257, 110, 1373345898, 13404, 2, 7),
(258, 68, 1373346001, 11709, 7, 21),
(259, 51, 1373346089, 12716, 1, 6),
(260, 110, 1373346375, 477, 1, 0),
(261, 104, 1373346394, 10530, 1, 5),
(262, 64, 1373346611, 15221, 4, 15),
(263, 145, 1373346642, 15532, 1, 8),
(264, 81, 1373346736, 9340, 5, 13),
(265, 134, 1373346758, 2153, 2, 3),
(266, 190, 1373346778, 3398, 1, 3),
(267, 35, 1373346832, 8315, 2, 4),
(268, 40, 1373346968, 22283, 1, 0),
(269, 82, 1373346987, 12526, 3, 8),
(270, 144, 1373347034, 2212, 2, 4),
(271, 149, 1373347180, 2752, 1, 8),
(272, 84, 1373347281, 1504, 1, 0),
(273, 53, 1373347337, 12459, 1, 3),
(274, 106, 1373347478, 1899, 2, 1),
(275, 86, 1373348166, 2444, 1, 4),
(276, 56, 1373348226, 9742, 3, 1),
(277, 65, 1373348242, 10190, 9, 21),
(278, 142, 1373348337, 23647, 5, 7),
(279, 74, 1373348426, 13735, 16, 16),
(280, 85, 1373348544, 15385, 3, 2),
(281, 196, 1373348714, 4278, 1, 2),
(282, 138, 1373348806, 3797, 2, 2),
(283, 59, 1373349124, 6699, 1, 10),
(284, 49, 1373349782, 14006, 1, 4),
(285, 71, 1373349886, 14379, 10, 13),
(286, 151, 1373350776, 5763, 2, 10),
(287, 169, 1373351377, 7407, 1, 2),
(288, 189, 1373351602, 5051, 1, 2),
(289, 157, 1373351759, 7557, 2, 5),
(290, 150, 1373352003, 6671, 2, 3),
(291, 12, 1373352379, 8260, 1, 3),
(292, 144, 1373352393, 5359, 2, 2),
(293, 135, 1373353537, 23314, 2, 0),
(294, 97, 1373354120, 8493, 8, 9),
(295, 30, 1373355011, 323, 2, 0),
(296, 43, 1373355208, 519, 2, 1),
(297, 44, 1373355357, 668, 1, 6),
(298, 30, 1373355400, 389, 1, 1),
(299, 38, 1373355480, 791, 1, 0),
(300, 147, 1373355499, 804, 2, 0),
(301, 155, 1373355501, 806, 3, 0),
(302, 56, 1373355598, 908, 2, 7),
(303, 133, 1373355599, 905, 1, 0),
(304, 35, 1373355642, 954, 2, 0),
(305, 198, 1373355755, 1057, 1, 1),
(306, 131, 1373355810, 1116, 1, 3),
(307, 68, 1373355872, 1182, 1, 6),
(308, 89, 1373355908, 1217, 1, 4),
(309, 18, 1373355915, 1227, 1, 4),
(310, 154, 1373356155, 1460, 2, 5),
(311, 92, 1373356158, 1466, 5, 8),
(312, 90, 1373356200, 1337, 1, 6),
(313, 55, 1373356200, 1510, 1, 3),
(314, 145, 1373356275, 1580, 1, 7),
(315, 196, 1373356479, 1781, 1, 4),
(316, 133, 1373356514, 797, 1, 2),
(317, 15, 1373356569, 1882, 2, 0),
(318, 87, 1373356572, 1881, 4, 4),
(319, 49, 1373358254, 225, 1, 1),
(320, 22, 1373358292, 265, 1, 1),
(321, 132, 1373358299, 265, 1, 1),
(322, 160, 1373358388, 353, 1, 2),
(323, 95, 1373358616, 584, 1, 4),
(324, 47, 1373358624, 596, 2, 2),
(325, 153, 1373358649, 614, 2, 2),
(326, 89, 1373358659, 628, 1, 6),
(327, 153, 1373358679, 30, 1, 0),
(328, 19, 1373358775, 748, 1, 5),
(329, 21, 1373358780, 753, 1, 7),
(330, 109, 1373358926, 893, 2, 3),
(331, 125, 1373358943, 366, 1, 2),
(332, 12, 1373358988, 962, 1, 4),
(333, 98, 1373359006, 974, 1, 4),
(334, 18, 1373359074, 1047, 1, 6),
(335, 97, 1373359081, 434, 1, 0),
(336, 11, 1373360405, 665, 1, 3),
(337, 124, 1373360536, 118, 1, 0),
(338, 150, 1373360758, 339, 1, 2),
(339, 93, 1373360889, 473, 1, 0),
(340, 143, 1373361188, 167, 1, 0),
(341, 37, 1373361206, 190, 2, 1),
(342, 146, 1373361606, 584, 1, 1),
(343, 49, 1373361710, 694, 1, 2),
(344, 133, 1373362054, 1033, 1, 1),
(345, 196, 1373362170, 1146, 1, 2),
(346, 120, 1373362195, 1175, 1, 4),
(347, 139, 1373362228, 1207, 1, 0),
(348, 75, 1373362297, 1279, 2, 4),
(349, 207, 1373362416, 1390, 1, 1),
(350, 42, 1373362660, 1287, 2, 2),
(351, 202, 1373362817, 1791, 2, 3),
(352, 158, 1373362874, 1852, 3, 7),
(353, 151, 1373362900, 1878, 1, 0),
(354, 114, 1373362925, 1905, 3, 2),
(355, 101, 1373362967, 1948, 2, 4),
(356, 44, 1373362974, 1958, 4, 4),
(357, 105, 1373363051, 2032, 2, 0),
(358, 71, 1373363115, 2097, 1, 3),
(359, 13, 1373363180, 2166, 2, 7),
(360, 21, 1373363190, 2175, 1, 4),
(361, 193, 1373363236, 1679, 1, 2),
(362, 72, 1373363309, 2291, 1, 3),
(363, 63, 1373363540, 2523, 1, 10),
(364, 14, 1373363600, 2585, 2, 8),
(365, 40, 1373363665, 2649, 3, 10),
(366, 179, 1373364588, 80, 1, 0),
(367, 72, 1373364657, 154, 1, 1),
(368, 123, 1373364715, 209, 1, 1),
(369, 134, 1373364807, 301, 1, 2),
(370, 132, 1373364815, 125, 1, 0),
(371, 98, 1373365050, 546, 1, 0),
(372, 97, 1373365069, 565, 1, 2),
(373, 50, 1373365197, 695, 1, 3),
(374, 68, 1373365233, 730, 1, 4),
(375, 40, 1373365321, 820, 1, 0),
(376, 105, 1373365385, 880, 1, 3),
(377, 91, 1373365458, 521, 1, 4),
(378, 110, 1373365671, 481, 1, 0),
(379, 72, 1373365683, 1026, 1, 5),
(380, 125, 1373365757, 1251, 1, 11),
(381, 138, 1373365768, 1262, 1, 4),
(382, 48, 1373365857, 1355, 3, 5),
(383, 127, 1373365922, 1198, 2, 5),
(384, 35, 1373366089, 1588, 2, 1),
(385, 112, 1373366201, 1696, 1, 5),
(386, 52, 1373366358, 1856, 6, 6),
(387, 66, 1373366804, 2301, 4, 3),
(388, 77, 1373366931, 2428, 4, 6),
(389, 187, 1373366963, 2140, 1, 4),
(390, 155, 1373367699, 2977, 3, 3),
(391, 139, 1373367767, 2959, 3, 4),
(392, 173, 1373368011, 3503, 1, 0),
(393, 64, 1373368135, 3632, 7, 10),
(394, 18, 1373368237, 3737, 1, 4),
(395, 102, 1373368256, 3752, 1, 0),
(396, 54, 1373368298, 3796, 1, 1),
(397, 147, 1373368412, 3905, 1, 0),
(398, 133, 1373368468, 3962, 1, 3),
(399, 20, 1373368979, 1704, 1, 0),
(400, 112, 1373369098, 2897, 1, 3),
(401, 87, 1373369150, 4646, 4, 10),
(402, 59, 1373369209, 4194, 3, 11),
(403, 129, 1373369363, 4857, 3, 18),
(404, 24, 1373369432, 4931, 1, 5),
(405, 159, 1373369435, 4928, 2, 11),
(406, 150, 1373369584, 5077, 2, 11),
(407, 116, 1373369592, 5087, 1, 4),
(408, 157, 1373369630, 5123, 3, 5),
(409, 174, 1373369635, 1409, 1, 1),
(410, 146, 1373369700, 5193, 1, 0),
(411, 82, 1373369812, 5308, 1, 5),
(412, 137, 1373369814, 5308, 2, 11),
(413, 81, 1373369858, 4506, 2, 2),
(414, 86, 1373369894, 5120, 2, 1),
(415, 80, 1373369980, 5477, 1, 1),
(416, 204, 1373369992, 5147, 1, 2),
(417, 116, 1373369999, 406, 1, 1),
(418, 175, 1373370114, 5606, 1, 0),
(419, 82, 1373370124, 312, 1, 0),
(420, 198, 1373370147, 5638, 2, 0),
(421, 160, 1373370167, 5660, 1, 1),
(422, 192, 1373370190, 755, 1, 0),
(423, 54, 1373370194, 1896, 1, 4),
(424, 27, 1373370213, 5479, 2, 5),
(425, 24, 1373370298, 866, 1, 3),
(426, 17, 1373370379, 5879, 2, 3),
(427, 71, 1373370454, 1097, 1, 4),
(428, 97, 1373370495, 5426, 1, 3),
(429, 197, 1373370550, 6041, 1, 1),
(430, 187, 1373370562, 579, 1, 0),
(431, 163, 1373370677, 6170, 2, 0),
(432, 69, 1373370789, 6286, 3, 4),
(433, 56, 1373370811, 1003, 3, 4),
(434, 107, 1373370819, 6314, 2, 3),
(435, 119, 1373370898, 1974, 1, 8),
(436, 121, 1373370954, 946, 1, 2),
(437, 67, 1373371003, 6500, 7, 13),
(438, 172, 1373371004, 4832, 1, 4),
(439, 132, 1373371081, 6266, 1, 9),
(440, 115, 1373371098, 4249, 4, 14),
(441, 88, 1373371135, 1370, 3, 5),
(442, 154, 1373371157, 6650, 2, 3),
(443, 49, 1373371253, 6751, 1, 8),
(444, 166, 1373371284, 4407, 1, 4),
(445, 145, 1373371301, 6794, 4, 7),
(446, 110, 1373371307, 5636, 4, 11),
(447, 40, 1373371321, 3162, 5, 14),
(448, 99, 1373371340, 6836, 2, 10),
(449, 80, 1373371345, 1365, 3, 5),
(450, 82, 1373371356, 1232, 2, 6),
(451, 31, 1373371362, 6744, 2, 3),
(452, 184, 1373371408, 1011, 1, 3),
(453, 55, 1373371410, 6908, 1, 2),
(454, 65, 1373371417, 6914, 4, 24),
(455, 188, 1373371437, 358, 1, 3),
(456, 64, 1373371439, 3304, 2, 9),
(457, 150, 1373371450, 1866, 2, 5),
(458, 197, 1373371456, 232, 1, 2),
(459, 38, 1373371463, 6962, 6, 11),
(460, 104, 1373371574, 7069, 3, 9),
(461, 80, 1373371646, 301, 1, 0),
(462, 170, 1373371674, 385, 1, 2),
(463, 29, 1373371675, 7174, 1, 10),
(464, 98, 1373371681, 2077, 1, 3),
(465, 41, 1373371688, 7187, 7, 14),
(466, 191, 1373371693, 1124, 1, 2),
(467, 193, 1373371756, 2305, 1, 1),
(468, 23, 1373371857, 7166, 5, 6),
(469, 174, 1373371861, 1868, 1, 4),
(470, 77, 1373371882, 4951, 5, 8),
(471, 74, 1373371890, 7387, 4, 13),
(472, 203, 1373371933, 7015, 1, 12),
(473, 194, 1373371944, 266, 1, 0),
(474, 146, 1373371998, 2298, 3, 6),
(475, 186, 1373372008, 542, 1, 3),
(476, 37, 1373372033, 7532, 4, 13),
(477, 198, 1373372037, 182, 1, 0),
(478, 153, 1373372121, 7162, 5, 18),
(479, 137, 1373372242, 2428, 4, 7),
(480, 179, 1373372500, 1067, 1, 5),
(481, 155, 1373372587, 4552, 4, 10),
(482, 175, 1373372933, 1927, 1, 3),
(483, 24, 1373373088, 2790, 2, 6),
(484, 33, 1373373090, 8589, 5, 18),
(485, 36, 1373373091, 5461, 8, 21),
(486, 45, 1373373093, 8591, 5, 12),
(487, 55, 1373373094, 1683, 1, 7),
(488, 70, 1373373097, 8594, 6, 22),
(489, 79, 1373373099, 4867, 11, 12),
(490, 116, 1373373105, 3106, 3, 5),
(491, 120, 1373373106, 8601, 2, 4),
(492, 130, 1373373108, 8602, 1, 6),
(493, 135, 1373373109, 8603, 3, 6),
(494, 136, 1373373109, 8603, 1, 1),
(495, 138, 1373373110, 7342, 1, 1),
(496, 139, 1373373110, 3458, 3, 13),
(497, 162, 1373373115, 3711, 1, 12),
(498, 165, 1373373116, 8608, 1, 9),
(499, 178, 1373373119, 1295, 1, 2),
(500, 187, 1373373121, 2559, 1, 3),
(501, 191, 1373373122, 1427, 1, 0),
(502, 199, 1373373123, 8614, 1, 0),
(503, 200, 1373373123, 3631, 1, 5),
(504, 207, 1373373125, 8615, 1, 1),
(505, 209, 1373373125, 1658, 2, 5),
(506, 42, 1373373781, 124, 1, 0),
(507, 95, 1373373998, 338, 1, 0),
(508, 94, 1373374141, 481, 1, 0),
(509, 138, 1373374205, 542, 1, 5),
(510, 125, 1373374244, 581, 2, 4),
(511, 25, 1373374889, 345, 1, 0),
(512, 155, 1373374931, 380, 1, 2),
(513, 76, 1373375066, 519, 1, 3),
(514, 21, 1373375772, 218, 2, 1),
(515, 20, 1373376513, 534, 2, 2),
(516, 123, 1373376516, 533, 1, 0),
(517, 179, 1373376559, 573, 1, 1),
(518, 26, 1373376560, 330, 2, 1),
(519, 160, 1373376667, 682, 1, 1),
(520, 107, 1373376740, 757, 3, 2),
(521, 121, 1373376794, 750, 1, 3),
(522, 100, 1373376993, 1011, 1, 1),
(523, 135, 1373377026, 1042, 1, 1),
(524, 113, 1373377027, 1044, 1, 4),
(525, 131, 1373377157, 1173, 1, 3),
(526, 40, 1373377332, 1352, 1, 3),
(527, 144, 1373377413, 878, 1, 5),
(528, 160, 1373377536, 869, 1, 2),
(529, 80, 1373377573, 1592, 1, 4),
(530, 18, 1373377685, 1706, 2, 6),
(531, 48, 1373377778, 914, 1, 4),
(532, 91, 1373377839, 570, 1, 1),
(533, 102, 1373377937, 1955, 1, 4),
(534, 107, 1373377955, 1215, 3, 10),
(535, 83, 1373378006, 2025, 3, 6),
(536, 19, 1373378058, 2079, 2, 13),
(537, 123, 1373378173, 1534, 1, 5),
(538, 157, 1373378275, 1540, 1, 8),
(539, 131, 1373378307, 1150, 2, 6),
(540, 121, 1373378392, 1598, 5, 6),
(541, 64, 1373378401, 136, 1, 0),
(542, 44, 1373378402, 319, 1, 2),
(543, 149, 1373378513, 2528, 4, 7),
(544, 100, 1373378577, 1584, 5, 6),
(545, 48, 1373378612, 807, 3, 1),
(546, 83, 1373378701, 695, 1, 5),
(547, 79, 1373378991, 1917, 4, 4),
(548, 107, 1373378991, 1035, 1, 4),
(549, 78, 1373379025, 2791, 4, 6),
(550, 26, 1373379032, 2472, 2, 9),
(551, 145, 1373379039, 3054, 2, 4),
(552, 91, 1373379044, 1205, 2, 0),
(553, 98, 1373379284, 1624, 2, 6),
(554, 122, 1373379424, 3441, 2, 14),
(555, 124, 1373379446, 3463, 4, 7),
(556, 67, 1373379457, 1341, 2, 3),
(557, 154, 1373379503, 714, 1, 2),
(558, 98, 1373379517, 233, 1, 0),
(559, 102, 1373379661, 1724, 1, 8),
(560, 67, 1373379881, 424, 1, 2),
(561, 103, 1373379918, 3936, 3, 10),
(562, 22, 1373379946, 3967, 4, 10),
(563, 107, 1373379964, 973, 1, 5),
(564, 175, 1373379982, 3058, 1, 6),
(565, 78, 1373379983, 958, 1, 7),
(566, 83, 1373380003, 1302, 4, 4),
(567, 91, 1373380054, 1010, 4, 4),
(568, 154, 1373380095, 592, 1, 1),
(569, 80, 1373380121, 2548, 4, 7),
(570, 78, 1373380202, 219, 1, 1),
(571, 160, 1373380260, 2213, 1, 5),
(572, 48, 1373380412, 1800, 4, 0),
(573, 98, 1373380429, 856, 2, 3),
(574, 26, 1373380576, 1466, 1, 3),
(575, 123, 1373380627, 2364, 1, 9),
(576, 81, 1373380642, 4661, 2, 7),
(577, 64, 1373380747, 2034, 1, 1),
(578, 78, 1373380748, 546, 1, 0),
(579, 115, 1373380753, 4770, 5, 21),
(580, 57, 1373380814, 4834, 3, 8),
(581, 67, 1373380868, 720, 1, 3),
(582, 78, 1373380976, 228, 1, 1),
(583, 123, 1373381100, 473, 1, 2),
(584, 121, 1373381209, 1825, 1, 6),
(585, 103, 1373381276, 1358, 5, 10),
(586, 149, 1373381304, 2791, 4, 12),
(587, 40, 1373381500, 4168, 2, 6),
(588, 157, 1373381502, 1129, 3, 8),
(589, 100, 1373381554, 2419, 3, 12),
(590, 103, 1373381705, 429, 1, 3),
(591, 98, 1373381788, 1359, 4, 3),
(592, 131, 1373381847, 3540, 5, 7),
(593, 26, 1373381848, 548, 4, 2),
(594, 154, 1373381946, 1850, 1, 10),
(595, 98, 1373382083, 295, 1, 2),
(596, 44, 1373382103, 1558, 3, 2),
(597, 103, 1373382134, 429, 1, 2),
(598, 57, 1373382262, 973, 1, 3),
(599, 79, 1373382263, 3272, 4, 13),
(600, 100, 1373382359, 805, 1, 2),
(601, 135, 1373382598, 1360, 1, 2),
(602, 122, 1373382604, 3180, 4, 12),
(603, 102, 1373382699, 2784, 2, 10),
(604, 97, 1373382710, 2932, 4, 7),
(605, 81, 1373382740, 831, 1, 6),
(606, 64, 1373382810, 2063, 1, 4),
(607, 160, 1373382848, 519, 1, 3),
(608, 148, 1373382925, 6940, 8, 25),
(609, 44, 1373382941, 838, 1, 4),
(610, 40, 1373383048, 1548, 2, 4),
(611, 108, 1373383110, 7127, 8, 27),
(612, 67, 1373383119, 2251, 1, 3),
(613, 81, 1373383196, 456, 3, 2),
(614, 157, 1373383294, 1792, 1, 4),
(615, 83, 1373383352, 1592, 1, 7),
(616, 124, 1373383379, 3089, 5, 10),
(617, 30, 1373383398, 1583, 1, 3),
(618, 79, 1373383441, 1178, 3, 6),
(619, 121, 1373383455, 2075, 2, 7),
(620, 131, 1373383475, 1628, 3, 2),
(621, 160, 1373383493, 645, 1, 2),
(622, 103, 1373383664, 1530, 2, 6),
(623, 100, 1373383823, 1045, 1, 2),
(624, 174, 1373383884, 2209, 1, 3),
(625, 157, 1373384010, 716, 1, 4),
(626, 40, 1373384028, 225, 1, 1),
(627, 98, 1373384046, 1963, 3, 10),
(628, 81, 1373384089, 791, 4, 1),
(629, 122, 1373384339, 993, 1, 4),
(630, 154, 1373384426, 2301, 3, 2),
(631, 80, 1373384514, 2783, 2, 10),
(632, 48, 1373384580, 1807, 1, 2),
(633, 79, 1373384674, 798, 1, 2),
(634, 123, 1373384819, 3718, 4, 5),
(635, 124, 1373385143, 1764, 1, 5),
(636, 83, 1373385150, 1168, 2, 6),
(637, 79, 1373385311, 637, 1, 3),
(638, 157, 1373385367, 396, 1, 1),
(639, 102, 1373385443, 1850, 1, 5),
(640, 131, 1373385616, 2141, 1, 7),
(641, 103, 1373385844, 2180, 2, 6),
(642, 78, 1373385925, 4949, 2, 16),
(643, 148, 1373385934, 2860, 2, 7),
(644, 145, 1373385973, 6934, 2, 20),
(645, 149, 1373385995, 4691, 1, 11),
(646, 70, 1373386022, 10041, 5, 33),
(647, 79, 1373386051, 218, 1, 0),
(648, 124, 1373386051, 400, 1, 4),
(649, 108, 1373386090, 1354, 2, 3),
(650, 144, 1373386252, 5394, 5, 12),
(651, 131, 1373386324, 195, 1, 0),
(652, 78, 1373386641, 716, 1, 2),
(653, 102, 1373386723, 1280, 1, 3),
(654, 98, 1373386815, 2769, 3, 11),
(655, 40, 1373386831, 2189, 1, 9),
(656, 88, 1373386924, 10942, 1, 4),
(657, 175, 1373386992, 6111, 1, 7),
(658, 78, 1373387037, 396, 1, 2),
(659, 122, 1373387100, 2760, 3, 5),
(660, 88, 1373387114, 190, 1, 0),
(661, 78, 1373387182, 145, 1, 0),
(662, 49, 1373387195, 11215, 1, 2),
(663, 30, 1373387216, 3665, 3, 6),
(664, 139, 1373387313, 11329, 3, 1),
(665, 35, 1373387405, 11426, 1, 0),
(666, 44, 1373387420, 4479, 4, 11),
(667, 149, 1373387435, 1440, 1, 4),
(668, 91, 1373387475, 6076, 10, 15),
(669, 135, 1373387508, 4188, 2, 9),
(670, 124, 1373387509, 1319, 1, 4),
(671, 144, 1373387537, 1285, 1, 1),
(672, 116, 1373387559, 11576, 1, 14),
(673, 22, 1373387565, 5731, 2, 3),
(674, 154, 1373387631, 2712, 3, 4),
(675, 135, 1373387635, 127, 1, 1),
(676, 88, 1373387640, 526, 1, 3),
(677, 48, 1373387641, 2472, 4, 5),
(678, 107, 1373387749, 7785, 6, 26),
(679, 58, 1373387938, 714, 1, 7),
(680, 112, 1373388021, 12038, 1, 7),
(681, 98, 1373388050, 1234, 1, 6),
(682, 196, 1373388087, 5331, 1, 13),
(683, 39, 1373388132, 12153, 1, 1),
(684, 121, 1373388141, 4686, 1, 1),
(685, 48, 1373388172, 296, 1, 0),
(686, 197, 1373388249, 12262, 1, 2),
(687, 102, 1373388251, 1528, 1, 7),
(688, 57, 1373388382, 2478, 1, 7),
(689, 144, 1373388383, 845, 2, 2),
(690, 122, 1373388397, 1297, 1, 5),
(691, 22, 1373388586, 1021, 1, 2),
(692, 79, 1373388654, 2166, 5, 7),
(693, 108, 1373388662, 2572, 1, 9),
(694, 193, 1373388683, 5511, 1, 8),
(695, 149, 1373388744, 1309, 1, 2),
(696, 14, 1373388818, 12840, 2, 3),
(697, 178, 1373388938, 1868, 1, 2),
(698, 80, 1373388967, 3405, 6, 15),
(699, 49, 1373389014, 1744, 1, 10),
(700, 108, 1373389039, 377, 1, 2),
(701, 81, 1373389082, 4993, 8, 18),
(702, 117, 1373389137, 531, 1, 1),
(703, 135, 1373389154, 825, 3, 1),
(704, 108, 1373389156, 117, 1, 0),
(705, 123, 1373389173, 2982, 6, 11),
(706, 88, 1373389214, 1574, 1, 7),
(707, 148, 1373389238, 2230, 1, 6),
(708, 83, 1373389316, 4166, 3, 18),
(709, 67, 1373389461, 5696, 4, 21),
(710, 100, 1373389545, 5722, 6, 19),
(711, 105, 1373389556, 2911, 6, 13),
(712, 112, 1373389610, 1588, 1, 13),
(713, 35, 1373389650, 2245, 3, 8),
(714, 92, 1373389668, 2668, 1, 12),
(715, 124, 1373389715, 2206, 1, 6),
(716, 131, 1373389793, 1272, 2, 7),
(717, 57, 1373389800, 1381, 2, 5),
(718, 78, 1373389849, 551, 4, 0),
(719, 186, 1373389851, 2534, 1, 2),
(720, 23, 1373389896, 13917, 4, 6),
(721, 80, 1373390026, 697, 1, 3),
(722, 40, 1373390126, 3295, 3, 15),
(723, 12, 1373390164, 14186, 1, 16),
(724, 121, 1373390168, 2027, 3, 9),
(725, 167, 1373390228, 923, 1, 2),
(726, 79, 1373390235, 1581, 1, 7),
(727, 103, 1373390271, 4293, 4, 17),
(728, 47, 1373390382, 836, 1, 1),
(729, 135, 1373390384, 1230, 2, 8),
(730, 139, 1373390454, 1831, 2, 8),
(731, 70, 1373390506, 2516, 2, 10),
(732, 113, 1373390508, 13480, 16, 39),
(733, 98, 1373390683, 2632, 4, 9),
(734, 58, 1373390818, 2880, 4, 15),
(735, 157, 1373390857, 1344, 2, 6),
(736, 80, 1373390899, 658, 1, 3),
(737, 35, 1373390950, 358, 1, 2),
(738, 91, 1373390960, 3485, 1, 11),
(739, 52, 1373390991, 867, 2, 4),
(740, 97, 1373391060, 7825, 7, 32),
(741, 144, 1373391076, 1651, 3, 4),
(742, 26, 1373391098, 5751, 2, 18),
(743, 57, 1373391175, 1375, 1, 7),
(744, 157, 1373391201, 343, 2, 1),
(745, 124, 1373391206, 1491, 4, 6),
(746, 30, 1373391252, 2161, 4, 9),
(747, 26, 1373391297, 199, 1, 2),
(748, 48, 1373391325, 3153, 2, 17),
(749, 139, 1373391380, 926, 1, 5),
(750, 92, 1373391471, 1292, 1, 4),
(751, 128, 1373391483, 3409, 2, 10),
(752, 78, 1373391521, 1672, 1, 7),
(753, 117, 1373391639, 2365, 1, 17),
(754, 112, 1373391660, 2050, 2, 7),
(755, 40, 1373391684, 1456, 1, 5),
(756, 91, 1373391711, 751, 1, 4),
(757, 49, 1373391851, 2311, 4, 13),
(758, 100, 1373391973, 1930, 5, 10),
(759, 186, 1373392264, 1423, 1, 1),
(760, 131, 1373392280, 345, 1, 4),
(761, 78, 1373392302, 781, 1, 1),
(762, 149, 1373392422, 3678, 3, 14),
(763, 49, 1373392535, 684, 2, 0),
(764, 99, 1373392588, 16606, 11, 29),
(765, 58, 1373392718, 1620, 2, 7),
(766, 67, 1373392730, 3268, 3, 11),
(767, 53, 1373392780, 16800, 5, 26),
(768, 35, 1373392841, 832, 1, 5),
(769, 64, 1373392867, 7778, 7, 25),
(770, 148, 1373392880, 1119, 2, 5),
(771, 157, 1373392909, 1708, 3, 1),
(772, 44, 1373392959, 5538, 7, 23),
(773, 52, 1373392971, 1980, 2, 11),
(774, 154, 1373392987, 4890, 4, 17),
(775, 117, 1373393143, 1504, 3, 6),
(776, 128, 1373393284, 486, 1, 0),
(777, 194, 1373393324, 2592, 1, 1),
(778, 79, 1373393358, 3060, 1, 13),
(779, 92, 1373393377, 1906, 3, 9),
(780, 102, 1373393494, 2201, 1, 4),
(781, 188, 1373393566, 6019, 1, 14),
(782, 149, 1373393622, 1108, 2, 4),
(783, 105, 1373393646, 3388, 4, 16),
(784, 103, 1373393746, 2964, 1, 10),
(785, 139, 1373393840, 2396, 4, 7),
(786, 123, 1373393970, 4797, 3, 18),
(787, 157, 1373393973, 1064, 2, 3),
(788, 169, 1373393993, 3064, 1, 4),
(789, 91, 1373394060, 2138, 1, 7),
(790, 98, 1373394082, 3398, 2, 15),
(791, 47, 1373394095, 2406, 1, 1),
(792, 92, 1373394252, 875, 1, 8),
(793, 53, 1373394283, 760, 2, 4),
(794, 128, 1373394324, 1039, 1, 7),
(795, 135, 1373394452, 4068, 4, 13),
(796, 88, 1373394467, 3138, 3, 16),
(797, 80, 1373394492, 3593, 4, 10),
(798, 144, 1373394515, 805, 1, 2),
(799, 89, 1373394522, 18540, 2, 9),
(800, 130, 1373394557, 18573, 1, 1),
(801, 52, 1373394585, 1614, 2, 7),
(802, 116, 1373394704, 5821, 1, 0),
(803, 131, 1373394752, 404, 1, 0),
(804, 98, 1373394787, 704, 2, 3),
(805, 154, 1373394804, 1545, 1, 6),
(806, 178, 1373394846, 4333, 1, 5),
(807, 97, 1373394972, 3797, 1, 9),
(808, 126, 1373395027, 19044, 1, 7),
(809, 30, 1373395060, 883, 3, 3),
(810, 103, 1373395111, 1365, 1, 2),
(811, 39, 1373395154, 6245, 5, 22),
(812, 124, 1373395172, 2636, 5, 11),
(813, 52, 1373395274, 689, 2, 2),
(814, 73, 1373395392, 19411, 1, 4),
(815, 57, 1373395400, 2160, 1, 7),
(816, 157, 1373395407, 498, 2, 4),
(817, 92, 1373395414, 1162, 1, 0),
(818, 117, 1373395473, 1722, 6, 8),
(819, 108, 1373395515, 6359, 3, 28),
(820, 116, 1373395526, 822, 1, 4),
(821, 135, 1373395533, 1081, 1, 6),
(822, 67, 1373395539, 1633, 2, 7),
(823, 184, 1373395621, 19634, 1, 3),
(824, 64, 1373395623, 2529, 3, 8),
(825, 127, 1373395635, 1067, 1, 8),
(826, 149, 1373395721, 663, 2, 5),
(827, 145, 1373395723, 9528, 13, 30),
(828, 39, 1373395821, 667, 2, 4),
(829, 154, 1373395837, 1033, 1, 5),
(830, 118, 1373395846, 19863, 5, 6),
(831, 157, 1373395928, 521, 1, 4),
(832, 103, 1373395959, 848, 1, 3),
(833, 174, 1373395966, 2603, 1, 2),
(834, 130, 1373395976, 1419, 1, 4),
(835, 30, 1373395993, 506, 2, 1),
(836, 20, 1373396008, 19495, 2, 3),
(837, 88, 1373396047, 984, 1, 4),
(838, 135, 1373396068, 535, 1, 3),
(839, 154, 1373396073, 236, 1, 2),
(840, 42, 1373396172, 20192, 5, 18),
(841, 53, 1373396173, 610, 2, 1),
(842, 189, 1373396183, 1379, 1, 1),
(843, 183, 1373396191, 777, 1, 4),
(844, 30, 1373396277, 284, 1, 1),
(845, 26, 1373396282, 3107, 3, 11),
(846, 99, 1373396353, 3765, 6, 18),
(847, 52, 1373396447, 1172, 2, 4),
(848, 143, 1373396448, 2005, 1, 1),
(849, 64, 1373396534, 911, 1, 4),
(850, 105, 1373396643, 1503, 2, 7),
(851, 35, 1373396682, 3841, 4, 19),
(852, 124, 1373396719, 1547, 2, 5),
(853, 30, 1373396770, 493, 1, 4),
(854, 157, 1373396777, 849, 3, 1),
(855, 148, 1373396834, 3462, 2, 12),
(856, 102, 1373396893, 3399, 2, 6),
(857, 125, 1373396917, 20934, 1, 3),
(858, 50, 1373396932, 20952, 1, 10),
(859, 70, 1373396942, 6436, 4, 27),
(860, 116, 1373396947, 1421, 1, 7),
(861, 92, 1373396962, 1446, 2, 8),
(862, 157, 1373396966, 189, 1, 2),
(863, 64, 1373396974, 440, 1, 4),
(864, 53, 1373396979, 806, 1, 3),
(865, 111, 1373397019, 21036, 1, 1),
(866, 97, 1373397023, 2051, 3, 17),
(867, 128, 1373397029, 2572, 4, 10),
(868, 73, 1373397145, 1753, 1, 7),
(869, 61, 1373397154, 1068, 1, 2),
(870, 30, 1373397250, 480, 1, 2),
(871, 143, 1373397281, 833, 2, 2),
(872, 103, 1373397299, 1340, 1, 7),
(873, 78, 1373397355, 895, 1, 2),
(874, 75, 1373397460, 1129, 2, 2),
(875, 81, 1373397507, 6641, 2, 26),
(876, 154, 1373397544, 1471, 2, 8),
(877, 88, 1373397546, 1499, 1, 4),
(878, 52, 1373397553, 481, 2, 2),
(879, 155, 1373397554, 1548, 3, 8),
(880, 89, 1373397579, 2901, 4, 8),
(881, 42, 1373397600, 1428, 1, 5),
(882, 49, 1373397600, 2033, 2, 8),
(883, 111, 1373397646, 627, 1, 3),
(884, 75, 1373397652, 192, 1, 0),
(885, 47, 1373397678, 1760, 1, 11),
(886, 192, 1373397711, 2162, 2, 4),
(887, 48, 1373397716, 3710, 5, 21),
(888, 35, 1373397756, 441, 1, 3),
(889, 118, 1373397905, 2059, 4, 5),
(890, 79, 1373397973, 1535, 1, 6),
(891, 39, 1373398018, 2197, 1, 9),
(892, 124, 1373398120, 1401, 4, 7),
(893, 185, 1373398144, 3566, 1, 4),
(894, 83, 1373398152, 5567, 6, 18),
(895, 194, 1373398177, 2420, 1, 5),
(896, 149, 1373398271, 2426, 1, 5),
(897, 108, 1373398292, 2777, 5, 17),
(898, 80, 1373398343, 898, 1, 6),
(899, 127, 1373398368, 1912, 3, 5),
(900, 81, 1373398429, 922, 1, 5),
(901, 44, 1373398465, 5506, 5, 33),
(902, 138, 1373398493, 22509, 1, 12),
(903, 107, 1373398610, 10861, 12, 38),
(904, 26, 1373398625, 2343, 3, 5),
(905, 188, 1373398638, 1115, 1, 4),
(906, 53, 1373398682, 1703, 1, 7),
(907, 50, 1373398713, 1197, 1, 14),
(908, 122, 1373398750, 10071, 15, 49),
(909, 83, 1373398758, 606, 1, 2),
(910, 26, 1373398820, 195, 1, 0),
(911, 126, 1373398838, 2118, 4, 10),
(912, 67, 1373398857, 592, 1, 1),
(913, 70, 1373398881, 1939, 4, 8),
(914, 61, 1373398918, 617, 1, 7),
(915, 49, 1373398948, 1348, 2, 9),
(916, 30, 1373399008, 1319, 1, 9),
(917, 39, 1373399081, 944, 1, 1),
(918, 157, 1373399118, 2152, 2, 5),
(919, 73, 1373399165, 2020, 3, 6),
(920, 130, 1373399166, 3190, 4, 7),
(921, 118, 1373399269, 1364, 1, 6),
(922, 135, 1373399272, 3204, 3, 12),
(923, 30, 1373399366, 358, 1, 1),
(924, 139, 1373399404, 1928, 3, 6),
(925, 102, 1373399413, 530, 2, 1),
(926, 47, 1373399446, 1768, 2, 14),
(927, 39, 1373399447, 366, 1, 0),
(928, 89, 1373399569, 1989, 2, 9),
(929, 92, 1373399569, 1348, 2, 3),
(930, 111, 1373399623, 497, 1, 2),
(931, 40, 1373399719, 7594, 7, 37),
(932, 52, 1373399791, 2238, 5, 11),
(933, 61, 1373399829, 479, 1, 0),
(934, 98, 1373399964, 5177, 6, 13),
(935, 111, 1373400049, 425, 1, 3),
(936, 166, 1373400124, 1531, 1, 4),
(937, 135, 1373400182, 910, 1, 1),
(938, 30, 1373400192, 826, 1, 3),
(939, 97, 1373400234, 3211, 2, 8),
(940, 108, 1373400264, 1972, 2, 8),
(941, 99, 1373400322, 3969, 2, 19),
(942, 91, 1373400359, 6255, 7, 16),
(943, 154, 1373400421, 1513, 4, 4),
(944, 148, 1373400565, 2209, 2, 9),
(945, 144, 1373400569, 3840, 6, 15),
(946, 42, 1373400621, 1034, 1, 0),
(947, 149, 1373400655, 2384, 3, 11),
(948, 80, 1373400661, 1572, 1, 4),
(949, 50, 1373400664, 1951, 3, 8),
(950, 98, 1373400771, 807, 3, 4),
(951, 127, 1373400821, 2453, 3, 14),
(952, 172, 1373400844, 2126, 1, 4),
(953, 75, 1373400845, 1607, 1, 7),
(954, 49, 1373400940, 1992, 2, 7),
(955, 97, 1373400986, 752, 1, 3),
(956, 75, 1373401024, 179, 2, 0),
(957, 78, 1373401075, 268, 1, 0),
(958, 52, 1373401101, 1310, 4, 6),
(959, 117, 1373401111, 5505, 6, 20),
(960, 188, 1373401144, 1274, 1, 3),
(961, 57, 1373401328, 2073, 1, 3),
(962, 88, 1373401357, 3811, 2, 10),
(963, 111, 1373401415, 384, 1, 5),
(964, 154, 1373401456, 918, 1, 5),
(965, 58, 1373401508, 1327, 2, 8),
(966, 127, 1373401546, 725, 1, 4),
(967, 47, 1373401568, 2122, 1, 19),
(968, 42, 1373401632, 1011, 1, 3),
(969, 128, 1373401639, 4610, 1, 6),
(970, 177, 1373401640, 807, 1, 1),
(971, 111, 1373401672, 257, 1, 5),
(972, 99, 1373401726, 1403, 1, 5),
(973, 97, 1373401751, 764, 3, 5),
(974, 80, 1373401811, 1150, 4, 6),
(975, 103, 1373401840, 4541, 2, 25),
(976, 143, 1373401852, 4571, 2, 22),
(977, 124, 1373401937, 3329, 3, 7),
(978, 30, 1373401983, 1791, 1, 1),
(979, 148, 1373401983, 1417, 2, 7),
(980, 155, 1373401992, 4438, 4, 19),
(981, 67, 1373401995, 2725, 1, 10),
(982, 73, 1373402028, 2863, 3, 13),
(983, 105, 1373402100, 5149, 7, 24),
(984, 97, 1373402207, 456, 1, 2),
(985, 70, 1373402213, 3332, 4, 12),
(986, 113, 1373402280, 11772, 14, 34),
(987, 128, 1373402323, 683, 1, 2),
(988, 139, 1373402355, 2375, 2, 12),
(989, 40, 1373402399, 1203, 1, 6),
(990, 30, 1373402412, 429, 1, 1),
(991, 53, 1373402427, 3598, 7, 16),
(992, 126, 1373402450, 3612, 2, 10),
(993, 102, 1373402489, 3076, 1, 13),
(994, 162, 1373402502, 541, 1, 2),
(995, 131, 1373402587, 5444, 3, 33),
(996, 124, 1373402618, 681, 1, 5),
(997, 81, 1373402631, 2681, 2, 7),
(998, 75, 1373402660, 240, 1, 0),
(999, 67, 1373402679, 684, 1, 0),
(1000, 83, 1373402691, 3933, 3, 18),
(1001, 50, 1373402788, 2123, 3, 13),
(1002, 61, 1373402921, 2497, 2, 9),
(1003, 44, 1373402936, 4471, 2, 23),
(1004, 107, 1373402979, 4369, 14, 16),
(1005, 79, 1373403002, 4696, 3, 8),
(1006, 50, 1373403072, 284, 1, 0),
(1007, 48, 1373403187, 5471, 4, 20),
(1008, 126, 1373403217, 767, 1, 3),
(1009, 130, 1373403335, 3450, 3, 16),
(1010, 39, 1373403433, 2361, 1, 13),
(1011, 124, 1373403468, 849, 1, 3),
(1012, 117, 1373403469, 2358, 4, 11),
(1013, 125, 1373403571, 6654, 8, 31),
(1014, 89, 1373403636, 2295, 2, 8),
(1015, 182, 1373403649, 391, 1, 1),
(1016, 154, 1373403770, 1448, 1, 3),
(1017, 52, 1373403797, 2538, 2, 11),
(1018, 92, 1373403836, 1480, 1, 2),
(1019, 127, 1373403847, 2301, 4, 13),
(1020, 88, 1373404048, 2078, 2, 8),
(1021, 196, 1373404073, 286, 1, 0),
(1022, 99, 1373404103, 2183, 1, 9),
(1023, 186, 1373404129, 1796, 1, 1),
(1024, 57, 1373404329, 2643, 3, 7),
(1025, 47, 1373404365, 2797, 1, 6),
(1026, 79, 1373404385, 1383, 3, 6),
(1027, 92, 1373404422, 586, 1, 3),
(1028, 143, 1373404653, 2801, 4, 13),
(1029, 130, 1373404707, 1372, 1, 8),
(1030, 75, 1373404716, 1886, 3, 2),
(1031, 131, 1373404753, 1250, 2, 7),
(1032, 97, 1373404895, 2688, 1, 10),
(1033, 80, 1373404903, 1622, 1, 3),
(1034, 125, 1373404940, 1369, 1, 3),
(1035, 144, 1373404960, 2413, 2, 8),
(1036, 81, 1373404978, 2347, 2, 1),
(1037, 121, 1373405009, 13889, 19, 43),
(1038, 154, 1373405040, 713, 1, 1),
(1039, 61, 1373405044, 1525, 1, 8),
(1040, 131, 1373405091, 338, 1, 0),
(1041, 49, 1373405121, 4181, 11, 17),
(1042, 117, 1373405177, 1708, 2, 5),
(1043, 70, 1373405235, 3022, 5, 13),
(1044, 143, 1373405265, 275, 1, 4),
(1045, 102, 1373405441, 1808, 1, 10),
(1046, 144, 1373405623, 663, 1, 4),
(1047, 192, 1373405650, 4159, 2, 8),
(1048, 52, 1373405730, 455, 1, 1),
(1049, 157, 1373405733, 5209, 2, 13),
(1050, 168, 1373405740, 1457, 1, 2),
(1051, 61, 1373405849, 804, 1, 7),
(1052, 103, 1373405855, 4015, 3, 10),
(1053, 200, 1373405895, 645, 1, 1),
(1054, 53, 1373405895, 3468, 3, 11),
(1055, 30, 1373405900, 3487, 2, 8),
(1056, 145, 1373405906, 10183, 10, 39),
(1057, 67, 1373405916, 3097, 2, 19),
(1058, 186, 1373405916, 1787, 1, 2),
(1059, 183, 1373405923, 3103, 1, 4),
(1060, 91, 1373405938, 5579, 2, 28),
(1061, 97, 1373405975, 1080, 1, 3),
(1062, 52, 1373406021, 290, 1, 1),
(1063, 81, 1373406042, 1064, 1, 3),
(1064, 117, 1373406062, 885, 2, 8),
(1065, 145, 1373406073, 167, 1, 1),
(1066, 79, 1373406116, 911, 1, 3),
(1067, 57, 1373406121, 463, 1, 2),
(1068, 154, 1373406193, 1153, 3, 6),
(1069, 89, 1373406197, 2192, 1, 8),
(1070, 139, 1373406272, 3640, 2, 18),
(1071, 163, 1373406297, 838, 1, 2),
(1072, 81, 1373406335, 151, 1, 1),
(1073, 182, 1373406339, 1023, 1, 1),
(1074, 73, 1373406345, 2165, 4, 8),
(1075, 127, 1373406423, 2433, 4, 11),
(1076, 148, 1373406590, 4607, 5, 22),
(1077, 128, 1373406596, 1833, 2, 18),
(1078, 125, 1373406624, 1684, 2, 10),
(1079, 111, 1373406650, 4978, 8, 9),
(1080, 193, 1373406663, 1229, 1, 0),
(1081, 83, 1373406755, 4064, 4, 16),
(1082, 162, 1373406912, 1423, 1, 4),
(1083, 91, 1373406933, 939, 2, 1),
(1084, 121, 1373406940, 1931, 5, 15),
(1085, 57, 1373406944, 524, 1, 1),
(1086, 126, 1373407030, 3813, 5, 10),
(1087, 131, 1373407097, 1117, 1, 3),
(1088, 89, 1373407107, 909, 1, 6),
(1089, 50, 1373407134, 701, 3, 4),
(1090, 73, 1373407251, 906, 1, 1),
(1091, 139, 1373407272, 1000, 2, 3),
(1092, 143, 1373407328, 2063, 2, 7),
(1093, 42, 1373407599, 5594, 2, 28),
(1094, 157, 1373407609, 1484, 1, 4),
(1095, 75, 1373407616, 1291, 1, 2),
(1096, 155, 1373407644, 4586, 1, 11),
(1097, 123, 1373407709, 13739, 15, 62),
(1098, 39, 1373407742, 4309, 3, 19),
(1099, 99, 1373407806, 2156, 1, 8),
(1100, 130, 1373407809, 2544, 5, 14),
(1101, 52, 1373407812, 1568, 3, 10),
(1102, 79, 1373407828, 1712, 3, 4),
(1103, 67, 1373407958, 1617, 3, 7),
(1104, 197, 1373407976, 462, 1, 0),
(1105, 149, 1373408084, 5057, 4, 16),
(1106, 145, 1373408101, 2028, 3, 11),
(1107, 53, 1373408112, 1878, 3, 14),
(1108, 44, 1373408170, 5234, 8, 18),
(1109, 30, 1373408210, 283, 1, 3),
(1110, 184, 1373408290, 743, 1, 0),
(1111, 61, 1373408294, 2445, 3, 12),
(1112, 40, 1373408299, 2942, 1, 12),
(1113, 49, 1373408316, 3195, 6, 11),
(1114, 92, 1373408325, 3903, 3, 10),
(1115, 42, 1373408327, 370, 1, 2),
(1116, 179, 1373408329, 1723, 1, 6),
(1117, 57, 1373408359, 1414, 4, 4),
(1118, 91, 1373408363, 397, 2, 0),
(1119, 80, 1373408364, 1689, 1, 2),
(1120, 138, 1373408369, 9669, 3, 14),
(1121, 47, 1373408470, 4104, 1, 22),
(1122, 81, 1373408471, 2136, 1, 10),
(1123, 128, 1373408482, 425, 1, 2),
(1124, 70, 1373408494, 3259, 2, 12),
(1125, 89, 1373408495, 210, 1, 0),
(1126, 44, 1373408497, 326, 1, 3),
(1127, 52, 1373408502, 417, 1, 4),
(1128, 55, 1373408504, 32524, 5, 16),
(1129, 102, 1373408506, 3065, 1, 17),
(1130, 48, 1373408508, 5321, 3, 26),
(1131, 127, 1373408510, 2087, 2, 10),
(1132, 144, 1373408513, 2836, 3, 14),
(1133, 58, 1373408520, 7012, 9, 35),
(1134, 155, 1373408525, 880, 2, 12),
(1135, 42, 1373408529, 202, 1, 4),
(1136, 131, 1373408531, 1299, 2, 6),
(1137, 154, 1373408533, 314, 1, 8),
(1138, 30, 1373408536, 326, 1, 7),
(1139, 157, 1373408540, 931, 4, 2),
(1140, 172, 1373408568, 1164, 1, 6),
(1141, 98, 1373408576, 7182, 7, 22),
(1142, 67, 1373408577, 619, 1, 4),
(1143, 193, 1373408583, 197, 1, 4),
(1144, 97, 1373408584, 2609, 2, 16),
(1145, 192, 1373408585, 2029, 1, 4),
(1146, 53, 1373408602, 490, 4, 7),
(1147, 112, 1373408604, 16628, 17, 84),
(1148, 157, 1373408621, 80, 2, 0),
(1149, 118, 1373408639, 9370, 6, 50),
(1150, 127, 1373408659, 148, 1, 5),
(1151, 52, 1373408663, 159, 1, 8),
(1152, 81, 1373408685, 212, 2, 2),
(1153, 195, 1373408691, 111, 1, 1),
(1154, 130, 1373408693, 173, 2, 7),
(1155, 88, 1373408711, 58, 1, 1),
(1156, 80, 1373408721, 193, 1, 5),
(1157, 162, 1373408798, 1075, 1, 11),
(1158, 100, 1373408811, 16838, 20, 72),
(1159, 123, 1373408814, 1104, 4, 16),
(1160, 118, 1373408818, 177, 2, 0),
(1161, 124, 1373408820, 5352, 10, 39),
(1162, 42, 1373408822, 291, 1, 13),
(1163, 206, 1373408824, 195, 1, 3),
(1164, 155, 1373408825, 298, 2, 6),
(1165, 39, 1373408831, 1089, 1, 14),
(1166, 67, 1373408833, 255, 1, 6),
(1167, 115, 1373408834, 27901, 29, 121),
(1168, 143, 1373408837, 1044, 3, 21),
(1169, 81, 1373408842, 157, 2, 1),
(1170, 44, 1373408846, 348, 1, 7),
(1171, 200, 1373408864, 388, 1, 10),
(1172, 102, 1373408874, 366, 1, 11),
(1173, 111, 1373408875, 384, 2, 5),
(1174, 30, 1373408877, 338, 1, 5),
(1175, 35, 1373408879, 388, 1, 7),
(1176, 139, 1373408881, 1609, 3, 13),
(1177, 48, 1373408885, 375, 2, 9),
(1178, 103, 1373408886, 3030, 2, 23),
(1179, 113, 1373408890, 6610, 8, 24),
(1180, 81, 1373408900, 56, 2, 0),
(1181, 89, 1373408901, 357, 1, 8),
(1182, 157, 1373408910, 287, 3, 6),
(1183, 75, 1373408916, 555, 2, 11),
(1184, 111, 1373408929, 53, 1, 2),
(1185, 135, 1373408936, 8754, 8, 36),
(1186, 88, 1373408952, 107, 1, 5),
(1187, 44, 1373408964, 118, 1, 4),
(1188, 89, 1373408968, 65, 1, 0),
(1189, 55, 1373408970, 153, 2, 5),
(1190, 47, 1373408973, 181, 1, 4),
(1191, 138, 1373408984, 431, 3, 17),
(1192, 148, 1373408993, 1848, 1, 9),
(1193, 26, 1373409000, 5280, 5, 32),
(1194, 139, 1373409002, 119, 1, 4),
(1195, 78, 1373409062, 364, 2, 7),
(1196, 125, 1373409065, 1232, 4, 17),
(1197, 107, 1373409074, 4452, 14, 28),
(1198, 67, 1373409076, 242, 2, 7),
(1199, 50, 1373409079, 455, 2, 9),
(1200, 189, 1373409083, 219, 1, 2),
(1201, 83, 1373409089, 523, 1, 12),
(1202, 102, 1373409093, 218, 3, 5),
(1203, 145, 1373409096, 995, 6, 13),
(1204, 181, 1373409101, 12267, 3, 3),
(1205, 89, 1373409111, 142, 1, 4),
(1206, 170, 1373409114, 159, 1, 3),
(1207, 177, 1373409117, 188, 1, 1),
(1208, 48, 1373409155, 269, 1, 7),
(1209, 184, 1373409175, 298, 1, 7),
(1210, 78, 1373409178, 116, 1, 1),
(1211, 80, 1373409189, 274, 1, 7),
(1212, 75, 1373409190, 273, 1, 5),
(1213, 196, 1373409191, 275, 1, 2),
(1214, 57, 1373409192, 567, 4, 11),
(1215, 67, 1373409194, 118, 1, 2),
(1216, 61, 1373409198, 903, 1, 18),
(1217, 130, 1373409213, 206, 1, 4),
(1218, 157, 1373409296, 384, 1, 7),
(1219, 100, 1373409302, 490, 4, 11),
(1220, 79, 1373409306, 595, 1, 8),
(1221, 92, 1373409706, 1380, 1, 6),
(1222, 144, 1373409788, 1194, 3, 17),
(1223, 40, 1373409884, 1193, 2, 7),
(1224, 131, 1373410131, 1468, 3, 16),
(1225, 157, 1373410138, 842, 1, 3),
(1226, 42, 1373410365, 1542, 3, 12),
(1227, 108, 1373410368, 10104, 10, 43),
(1228, 192, 1373410604, 244, 1, 1),
(1229, 155, 1373410604, 1596, 1, 8),
(1230, 78, 1373410664, 1484, 2, 4),
(1231, 50, 1373410703, 1623, 2, 7),
(1232, 39, 1373410782, 390, 1, 2),
(1233, 125, 1373410793, 1727, 2, 4),
(1234, 57, 1373411005, 434, 1, 1),
(1235, 183, 1373411016, 1057, 1, 2),
(1236, 102, 1373411126, 1951, 1, 8),
(1237, 163, 1373411154, 4857, 1, 5),
(1238, 99, 1373411231, 2501, 9, 8),
(1239, 89, 1373411322, 2209, 1, 8),
(1240, 52, 1373411374, 2711, 3, 21),
(1241, 143, 1373411383, 2544, 1, 10),
(1242, 30, 1373411421, 2352, 2, 9),
(1243, 81, 1373411480, 2579, 1, 9),
(1244, 91, 1373411516, 2948, 5, 16),
(1245, 35, 1373411638, 2757, 1, 15),
(1246, 92, 1373411645, 1939, 1, 3),
(1247, 102, 1373411795, 669, 1, 1),
(1248, 79, 1373412044, 2738, 4, 7),
(1249, 26, 1373412077, 3075, 2, 13),
(1250, 188, 1373412131, 1903, 2, 0),
(1251, 52, 1373412302, 851, 1, 4),
(1252, 57, 1373412343, 1338, 2, 4),
(1253, 131, 1373412466, 2335, 1, 6),
(1254, 88, 1373412516, 2459, 1, 7),
(1255, 139, 1373412552, 3396, 5, 11),
(1256, 83, 1373412553, 3463, 3, 7),
(1257, 92, 1373412619, 974, 1, 2),
(1258, 130, 1373412697, 3483, 3, 13),
(1259, 75, 1373412896, 3705, 1, 8),
(1260, 48, 1373412932, 3776, 4, 9),
(1261, 53, 1373412947, 4345, 3, 23),
(1262, 123, 1373412961, 4146, 7, 20),
(1263, 35, 1373412983, 1345, 1, 2),
(1264, 176, 1373413026, 4082, 1, 11),
(1265, 99, 1373413034, 1078, 2, 1),
(1266, 100, 1373413049, 3747, 1, 8),
(1267, 30, 1373413057, 1636, 3, 4),
(1268, 91, 1373413097, 1581, 2, 3),
(1269, 125, 1373413123, 2330, 5, 9),
(1270, 81, 1373413140, 787, 1, 1),
(1271, 40, 1373413169, 814, 1, 2),
(1272, 108, 1373413192, 2824, 3, 11),
(1273, 157, 1373413205, 1488, 2, 5),
(1274, 179, 1373413298, 3485, 1, 3),
(1275, 80, 1373413351, 3764, 2, 11),
(1276, 55, 1373413369, 4292, 1, 7),
(1277, 39, 1373413380, 2598, 1, 13),
(1278, 57, 1373413395, 1052, 3, 1),
(1279, 148, 1373413429, 4256, 2, 16),
(1280, 47, 1373413499, 4102, 4, 13),
(1281, 196, 1373413541, 1443, 1, 2),
(1282, 49, 1373413579, 5261, 7, 27),
(1283, 157, 1373413622, 417, 1, 3),
(1284, 206, 1373413692, 4565, 1, 3),
(1285, 135, 1373413733, 4796, 8, 25),
(1286, 195, 1373413762, 2204, 1, 0),
(1287, 70, 1373413811, 4795, 3, 15),
(1288, 200, 1373413811, 2143, 1, 6),
(1289, 78, 1373413812, 529, 1, 1),
(1290, 92, 1373413889, 1270, 2, 4),
(1291, 172, 1373413945, 1656, 1, 2),
(1292, 30, 1373413992, 935, 1, 2),
(1293, 92, 1373414001, 111, 1, 0),
(1294, 121, 1373414068, 6864, 12, 38),
(1295, 139, 1373414117, 579, 1, 2),
(1296, 128, 1373414141, 5656, 10, 48),
(1297, 144, 1373414218, 637, 1, 3),
(1298, 166, 1373414230, 2426, 1, 5),
(1299, 148, 1373414236, 806, 3, 4),
(1300, 78, 1373414458, 646, 1, 2),
(1301, 57, 1373414462, 1067, 1, 4),
(1302, 88, 1373414666, 1548, 4, 4),
(1303, 55, 1373414675, 1306, 2, 5),
(1304, 89, 1373414714, 3392, 3, 16),
(1305, 58, 1373414753, 6232, 5, 36),
(1306, 26, 1373414904, 2827, 3, 10),
(1307, 44, 1373414974, 6008, 4, 35),
(1308, 52, 1373414978, 2128, 2, 5),
(1309, 39, 1373414998, 1618, 1, 1),
(1310, 107, 1373415038, 5963, 11, 24),
(1311, 111, 1373415170, 6240, 5, 23),
(1312, 186, 1373415252, 251, 2, 0),
(1313, 57, 1373415259, 797, 1, 0),
(1314, 80, 1373415286, 1879, 3, 7),
(1315, 163, 1373415368, 4214, 1, 7),
(1316, 135, 1373415386, 1653, 2, 3),
(1317, 108, 1373415471, 2279, 3, 6),
(1318, 102, 1373415516, 2524, 2, 12),
(1319, 75, 1373415544, 2499, 2, 9),
(1320, 78, 1373415561, 1102, 1, 6),
(1321, 189, 1373415601, 6518, 1, 11),
(1322, 154, 1373415624, 1303, 1, 4),
(1323, 91, 1373415626, 530, 1, 2),
(1324, 88, 1373415628, 962, 1, 5),
(1325, 131, 1373415634, 2284, 3, 9),
(1326, 126, 1373415635, 8605, 13, 46),
(1327, 70, 1373415657, 1231, 1, 7),
(1328, 79, 1373415704, 3660, 2, 10),
(1329, 200, 1373415735, 1874, 1, 4),
(1330, 192, 1373415886, 4949, 3, 9),
(1331, 113, 1373415983, 3978, 6, 12),
(1332, 145, 1373416002, 6905, 4, 31),
(1333, 125, 1373416026, 1607, 1, 7),
(1334, 48, 1373416037, 3105, 4, 12),
(1335, 97, 1373416153, 7568, 7, 35),
(1336, 79, 1373416190, 486, 1, 1),
(1337, 177, 1373416244, 2267, 1, 7),
(1338, 98, 1373416254, 7677, 7, 28),
(1339, 40, 1373416389, 2435, 2, 14),
(1340, 89, 1373416491, 1777, 1, 7),
(1341, 144, 1373416593, 1864, 1, 8),
(1342, 53, 1373416620, 3673, 7, 19),
(1343, 44, 1373416621, 1647, 4, 4),
(1344, 148, 1373416723, 777, 1, 1),
(1345, 154, 1373416828, 1204, 1, 1),
(1346, 83, 1373416858, 4304, 7, 18),
(1347, 81, 1373416863, 3723, 3, 10),
(1348, 80, 1373416906, 1319, 2, 4),
(1349, 112, 1373416928, 8322, 8, 35),
(1350, 102, 1373416999, 1483, 1, 7),
(1351, 149, 1373417109, 9024, 6, 38),
(1352, 61, 1373417109, 1702, 1, 6),
(1353, 155, 1373417149, 1182, 1, 2),
(1354, 40, 1373417298, 821, 1, 3),
(1355, 154, 1373417302, 474, 1, 2),
(1356, 125, 1373417330, 1304, 1, 10),
(1357, 170, 1373417336, 1810, 1, 2),
(1358, 67, 1373417339, 3580, 2, 10),
(1359, 70, 1373417342, 1171, 1, 5),
(1360, 181, 1373417345, 1987, 1, 1),
(1361, 73, 1373417437, 10185, 11, 51),
(1362, 117, 1373417542, 11480, 11, 55),
(1363, 139, 1373417582, 2534, 3, 9),
(1364, 125, 1373417589, 259, 1, 2),
(1365, 123, 1373417605, 4644, 7, 13),
(1366, 143, 1373417653, 3534, 3, 14),
(1367, 113, 1373417751, 1768, 2, 6),
(1368, 64, 1373417773, 20799, 26, 80),
(1369, 57, 1373417787, 2528, 1, 7),
(1370, 154, 1373417803, 345, 1, 2),
(1371, 92, 1373417806, 2319, 1, 9),
(1372, 97, 1373417839, 1686, 3, 3),
(1373, 135, 1373417932, 2546, 2, 17),
(1374, 80, 1373417955, 1049, 3, 5),
(1375, 103, 1373417979, 9091, 8, 53),
(1376, 79, 1373418000, 1249, 3, 4),
(1377, 55, 1373418025, 3350, 1, 10),
(1378, 154, 1373418192, 389, 1, 1),
(1379, 52, 1373418283, 3237, 1, 8),
(1380, 206, 1373418317, 970, 1, 4),
(1381, 102, 1373418520, 963, 1, 4),
(1382, 80, 1373418630, 675, 2, 1),
(1383, 112, 1373418797, 1869, 1, 4),
(1384, 75, 1373418828, 3284, 3, 12),
(1385, 149, 1373418970, 1861, 2, 6),
(1386, 35, 1373418996, 6013, 4, 16),
(1387, 177, 1373419030, 1155, 1, 3),
(1388, 148, 1373419036, 2313, 2, 10),
(1389, 83, 1373419050, 2192, 1, 11),
(1390, 70, 1373419058, 1716, 2, 7),
(1391, 67, 1373419173, 1577, 1, 4),
(1392, 157, 1373419175, 781, 1, 2),
(1393, 79, 1373419194, 1107, 2, 2),
(1394, 61, 1373419280, 1708, 1, 5),
(1395, 127, 1373419356, 10694, 11, 56),
(1396, 40, 1373419366, 2068, 6, 9),
(1397, 148, 1373419375, 339, 1, 2),
(1398, 55, 1373419435, 1410, 4, 7),
(1399, 75, 1373419514, 686, 1, 1),
(1400, 155, 1373419560, 2065, 2, 6),
(1401, 57, 1373419661, 1874, 1, 2),
(1402, 100, 1373419690, 6641, 1, 21),
(1403, 185, 1373419692, 1515, 1, 3),
(1404, 39, 1373419843, 3668, 4, 13),
(1405, 122, 1373419853, 21103, 28, 112),
(1406, 64, 1373419869, 826, 2, 1),
(1407, 39, 1373419914, 71, 1, 1),
(1408, 30, 1373419936, 2457, 4, 6),
(1409, 127, 1373420063, 226, 1, 2),
(1410, 193, 1373420144, 344, 1, 0),
(1411, 78, 1373420179, 1072, 1, 1),
(1412, 174, 1373420233, 2243, 1, 5),
(1413, 189, 1373420266, 687, 1, 2),
(1414, 138, 1373420271, 11287, 4, 57),
(1415, 126, 1373420295, 4628, 9, 13),
(1416, 83, 1373420382, 1331, 1, 7),
(1417, 89, 1373420523, 1340, 2, 3),
(1418, 154, 1373420785, 2565, 2, 2),
(1419, 57, 1373421087, 1426, 2, 3),
(1420, 88, 1373421350, 4989, 2, 12),
(1421, 52, 1373421361, 2465, 1, 8),
(1422, 80, 1373421448, 2437, 1, 8),
(1423, 98, 1373421743, 5489, 1, 17),
(1424, 61, 1373421807, 2527, 2, 4),
(1425, 83, 1373421863, 940, 1, 2),
(1426, 70, 1373421965, 2012, 1, 7),
(1427, 55, 1373422005, 2307, 5, 4),
(1428, 102, 1373422009, 3489, 3, 18),
(1429, 50, 1373422083, 6803, 5, 33),
(1430, 83, 1373422233, 369, 1, 1),
(1431, 40, 1373422343, 2384, 1, 6),
(1432, 83, 1373422447, 214, 1, 0),
(1433, 75, 1373422639, 3125, 1, 4),
(1434, 123, 1373422652, 5047, 7, 26),
(1435, 124, 1373422654, 13833, 19, 55),
(1436, 111, 1373422667, 7496, 6, 28),
(1437, 64, 1373422681, 1796, 1, 4),
(1438, 112, 1373422707, 3910, 4, 18),
(1439, 79, 1373422842, 2538, 1, 7),
(1440, 131, 1373422848, 7213, 6, 26),
(1441, 81, 1373422884, 859, 1, 2),
(1442, 39, 1373423045, 3131, 1, 7),
(1443, 47, 1373423046, 7899, 6, 32),
(1444, 81, 1373423057, 173, 1, 1),
(1445, 143, 1373423089, 5274, 2, 13),
(1446, 88, 1373423122, 1772, 1, 5),
(1447, 67, 1373423162, 1770, 1, 7),
(1448, 157, 1373423224, 1473, 1, 4),
(1449, 107, 1373423237, 8199, 8, 28),
(1450, 154, 1373423251, 643, 1, 1),
(1451, 149, 1373423286, 3386, 2, 9),
(1452, 139, 1373423288, 608, 1, 3),
(1453, 78, 1373423317, 3138, 1, 10),
(1454, 79, 1373423317, 475, 1, 1),
(1455, 100, 1373423333, 2993, 4, 15),
(1456, 102, 1373423664, 1239, 3, 16),
(1457, 123, 1373423788, 1136, 3, 6),
(1458, 121, 1373423812, 9744, 5, 45),
(1459, 113, 1373423850, 6061, 4, 29),
(1460, 53, 1373423905, 7284, 4, 23),
(1461, 70, 1373424007, 834, 1, 7),
(1462, 155, 1373424021, 1567, 1, 6),
(1463, 139, 1373424030, 742, 2, 1),
(1464, 57, 1373424038, 2951, 3, 15),
(1465, 48, 1373424060, 998, 1, 2),
(1466, 144, 1373424142, 7549, 6, 27),
(1467, 73, 1373424244, 6807, 2, 15),
(1468, 35, 1373424348, 2917, 2, 2),
(1469, 53, 1373424365, 460, 1, 1),
(1470, 39, 1373424436, 1185, 1, 5),
(1471, 200, 1373424448, 1437, 1, 0),
(1472, 79, 1373424472, 1155, 1, 1),
(1473, 157, 1373424634, 1410, 1, 4),
(1474, 61, 1373424641, 2731, 4, 10),
(1475, 47, 1373424702, 1655, 1, 4);
INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(1476, 118, 1373424768, 15828, 8, 35),
(1477, 172, 1373424954, 566, 1, 1),
(1478, 89, 1373425114, 239, 1, 0),
(1479, 55, 1373425193, 832, 1, 2),
(1480, 70, 1373425281, 1002, 1, 3),
(1481, 89, 1373425354, 240, 1, 0),
(1482, 148, 1373425477, 5078, 6, 12),
(1483, 144, 1373425484, 586, 1, 3),
(1484, 111, 1373425524, 2857, 1, 18),
(1485, 138, 1373425546, 4388, 2, 18),
(1486, 92, 1373425556, 6300, 4, 30),
(1487, 83, 1373425648, 2188, 1, 2),
(1488, 79, 1373425666, 1194, 1, 8),
(1489, 50, 1373425766, 3683, 1, 12),
(1490, 139, 1373425849, 1819, 1, 9),
(1491, 154, 1373425901, 2350, 1, 8),
(1492, 30, 1373425923, 253, 2, 1),
(1493, 149, 1373425968, 2027, 3, 5),
(1494, 67, 1373426003, 2840, 4, 11),
(1495, 112, 1373426024, 3317, 7, 13),
(1496, 145, 1373426093, 10091, 6, 33),
(1497, 55, 1373426095, 732, 2, 7),
(1498, 52, 1373426344, 4156, 2, 14),
(1499, 135, 1373426377, 8444, 3, 34),
(1500, 58, 1373426382, 11629, 9, 43),
(1501, 127, 1373426469, 6406, 11, 35),
(1502, 35, 1373426501, 2153, 1, 7),
(1503, 40, 1373426590, 928, 1, 6),
(1504, 138, 1373426681, 1135, 2, 3),
(1505, 192, 1373426718, 1429, 1, 3),
(1506, 26, 1373426754, 11001, 4, 25),
(1507, 89, 1373426760, 1406, 1, 5),
(1508, 183, 1373426797, 1274, 1, 3),
(1509, 83, 1373426807, 1159, 1, 3),
(1510, 139, 1373427082, 1233, 1, 6),
(1511, 195, 1373427097, 1153, 1, 3),
(1512, 92, 1373427112, 1530, 1, 9),
(1513, 75, 1373427221, 1785, 1, 6),
(1514, 144, 1373427312, 754, 2, 3),
(1515, 44, 1373427328, 10707, 10, 45),
(1516, 39, 1373427425, 2989, 1, 6),
(1517, 83, 1373427530, 346, 1, 1),
(1518, 81, 1373427547, 3113, 1, 8),
(1519, 154, 1373427595, 1694, 1, 5),
(1520, 57, 1373427657, 3619, 3, 19),
(1521, 49, 1373427658, 14079, 17, 57),
(1522, 186, 1373427663, 1266, 1, 2),
(1523, 73, 1373427696, 3452, 2, 13),
(1524, 42, 1373427723, 12717, 9, 44),
(1525, 78, 1373427799, 2850, 2, 14),
(1526, 98, 1373427837, 5799, 9, 35),
(1527, 61, 1373427862, 2182, 1, 2),
(1528, 117, 1373427866, 10324, 14, 51),
(1529, 67, 1373427897, 1425, 3, 7),
(1530, 80, 1373427912, 471, 1, 2),
(1531, 79, 1373427945, 900, 3, 2),
(1532, 188, 1373427984, 1849, 1, 1),
(1533, 117, 1373428089, 223, 1, 3),
(1534, 155, 1373428117, 2403, 2, 11),
(1535, 40, 1373428125, 1329, 2, 4),
(1536, 144, 1373428192, 880, 1, 2),
(1537, 176, 1373428312, 1472, 1, 5),
(1538, 80, 1373428355, 443, 1, 1),
(1539, 103, 1373428475, 10496, 12, 46),
(1540, 89, 1373428672, 1840, 1, 8),
(1541, 42, 1373428692, 969, 1, 6),
(1542, 39, 1373428712, 1287, 3, 0),
(1543, 112, 1373428942, 2918, 4, 13),
(1544, 163, 1373428982, 2085, 1, 10),
(1545, 58, 1373429043, 2661, 4, 11),
(1546, 88, 1373429074, 3407, 3, 9),
(1547, 80, 1373429119, 521, 2, 2),
(1548, 91, 1373429201, 13538, 14, 65),
(1549, 92, 1373429202, 2090, 2, 8),
(1550, 52, 1373429218, 2874, 4, 13),
(1551, 79, 1373429253, 1308, 2, 3),
(1552, 55, 1373429262, 1038, 2, 2),
(1553, 143, 1373429291, 1907, 3, 8),
(1554, 26, 1373429417, 2663, 1, 9),
(1555, 135, 1373429425, 1449, 2, 2),
(1556, 75, 1373429474, 2253, 3, 14),
(1557, 70, 1373429563, 546, 1, 0),
(1558, 154, 1373429850, 1148, 1, 3),
(1559, 35, 1373430004, 1876, 1, 6),
(1560, 75, 1373430189, 412, 1, 1),
(1561, 52, 1373430199, 981, 4, 3),
(1562, 149, 1373430204, 2606, 1, 8),
(1563, 89, 1373430242, 727, 1, 2),
(1564, 26, 1373430253, 836, 2, 1),
(1565, 155, 1373430259, 1368, 1, 0),
(1566, 131, 1373430259, 7411, 9, 34),
(1567, 67, 1373430276, 1524, 1, 6),
(1568, 91, 1373430281, 1079, 2, 3),
(1569, 103, 1373430299, 1824, 1, 8),
(1570, 130, 1373430394, 17697, 24, 71),
(1571, 39, 1373430481, 818, 1, 3),
(1572, 78, 1373430552, 2466, 3, 8),
(1573, 185, 1373430582, 289, 1, 0),
(1574, 143, 1373430850, 1559, 1, 9),
(1575, 35, 1373430927, 923, 1, 2),
(1576, 55, 1373430963, 907, 4, 3),
(1577, 48, 1373431078, 7017, 2, 33),
(1578, 42, 1373431123, 2431, 3, 12),
(1579, 81, 1373431127, 2477, 2, 8),
(1580, 139, 1373431135, 1276, 1, 3),
(1581, 103, 1373431219, 920, 1, 6),
(1582, 195, 1373431233, 4136, 1, 8),
(1583, 207, 1373431264, 2933, 1, 5),
(1584, 128, 1373431305, 17164, 18, 83),
(1585, 149, 1373431445, 492, 1, 4),
(1586, 39, 1373431538, 982, 1, 4),
(1587, 102, 1373431559, 6762, 8, 28),
(1588, 154, 1373431568, 1718, 2, 7),
(1589, 40, 1373431758, 2668, 2, 13),
(1590, 135, 1373431773, 2348, 3, 4),
(1591, 39, 1373431797, 259, 1, 2),
(1592, 144, 1373431881, 1704, 1, 10),
(1593, 61, 1373432025, 540, 1, 3),
(1594, 79, 1373432082, 2829, 2, 9),
(1595, 80, 1373432244, 1753, 1, 6),
(1596, 111, 1373432251, 6727, 6, 36),
(1597, 131, 1373432251, 1992, 1, 9),
(1598, 89, 1373432263, 1727, 1, 3),
(1599, 177, 1373432380, 4056, 1, 5),
(1600, 169, 1373432496, 25349, 1, 4),
(1601, 88, 1373432552, 3443, 2, 16),
(1602, 89, 1373432588, 325, 1, 0),
(1603, 67, 1373432643, 2303, 3, 16),
(1604, 75, 1373432784, 2594, 1, 10),
(1605, 135, 1373432809, 1036, 2, 2),
(1606, 127, 1373432847, 4897, 3, 18),
(1607, 100, 1373432848, 7767, 11, 30),
(1608, 195, 1373432856, 1623, 1, 5),
(1609, 80, 1373432862, 618, 1, 4),
(1610, 52, 1373433036, 2837, 2, 8),
(1611, 135, 1373433041, 232, 1, 1),
(1612, 145, 1373433146, 7053, 4, 25),
(1613, 112, 1373433175, 4233, 7, 18),
(1614, 64, 1373433239, 1691, 1, 9),
(1615, 157, 1373433246, 743, 2, 2),
(1616, 57, 1373433295, 5638, 4, 30),
(1617, 35, 1373433389, 367, 2, 1),
(1618, 135, 1373433418, 376, 2, 0),
(1619, 149, 1373433422, 322, 2, 1),
(1620, 103, 1373433469, 2250, 2, 9),
(1621, 70, 1373433486, 2952, 2, 8),
(1622, 79, 1373433567, 1085, 1, 9),
(1623, 83, 1373433593, 3268, 4, 8),
(1624, 53, 1373433838, 7677, 5, 25),
(1625, 92, 1373433861, 2541, 1, 10),
(1626, 61, 1373433897, 1872, 1, 10),
(1627, 78, 1373433935, 790, 1, 2),
(1628, 195, 1373433954, 1098, 1, 4),
(1629, 188, 1373433956, 1483, 1, 3),
(1630, 48, 1373433990, 1328, 3, 7),
(1631, 89, 1373433998, 522, 3, 5),
(1632, 192, 1373434038, 6064, 1, 5),
(1633, 108, 1373434046, 18575, 15, 82),
(1634, 138, 1373434062, 7381, 4, 31),
(1635, 123, 1373434203, 10415, 12, 59),
(1636, 79, 1373434224, 657, 1, 2),
(1637, 55, 1373434255, 3082, 2, 19),
(1638, 148, 1373434347, 8870, 10, 21),
(1639, 103, 1373434379, 910, 1, 4),
(1640, 139, 1373434414, 3279, 1, 16),
(1641, 64, 1373434460, 1220, 2, 4),
(1642, 143, 1373434625, 3775, 3, 14),
(1643, 117, 1373434689, 6600, 8, 40),
(1644, 162, 1373434862, 928, 1, 4),
(1645, 35, 1373434939, 1508, 1, 6),
(1646, 47, 1373434995, 10293, 10, 36),
(1647, 73, 1373435010, 7314, 7, 33),
(1648, 169, 1373435057, 2561, 1, 4),
(1649, 52, 1373435129, 478, 1, 0),
(1650, 78, 1373435159, 1224, 1, 6),
(1651, 88, 1373435176, 1906, 7, 7),
(1652, 154, 1373435263, 3443, 1, 12),
(1653, 184, 1373435333, 1338, 1, 2),
(1654, 78, 1373435360, 201, 1, 1),
(1655, 118, 1373435398, 10629, 12, 44),
(1656, 139, 1373435497, 1083, 3, 2),
(1657, 55, 1373435555, 1300, 1, 2),
(1658, 149, 1373435613, 1187, 2, 2),
(1659, 67, 1373435707, 2170, 3, 9),
(1660, 124, 1373435810, 13156, 13, 57),
(1661, 196, 1373435814, 559, 1, 0),
(1662, 143, 1373435875, 922, 2, 4),
(1663, 145, 1373435887, 2741, 1, 6),
(1664, 52, 1373436041, 763, 1, 2),
(1665, 113, 1373436054, 12204, 16, 65),
(1666, 78, 1373436194, 834, 1, 8),
(1667, 39, 1373436198, 4401, 5, 17),
(1668, 26, 1373436337, 6084, 5, 21),
(1669, 149, 1373436413, 419, 1, 0),
(1670, 97, 1373436431, 18592, 19, 74),
(1671, 108, 1373436439, 2393, 2, 14),
(1672, 79, 1373436608, 2384, 4, 2),
(1673, 83, 1373436659, 1627, 2, 7),
(1674, 121, 1373436686, 12873, 17, 61),
(1675, 89, 1373436780, 2042, 1, 3),
(1676, 102, 1373436821, 5262, 8, 31),
(1677, 135, 1373436933, 3468, 2, 17),
(1678, 111, 1373436934, 4683, 2, 16),
(1679, 55, 1373436970, 975, 1, 4),
(1680, 88, 1373437033, 1857, 1, 4),
(1681, 79, 1373437133, 525, 1, 4),
(1682, 64, 1373437140, 2679, 3, 7),
(1683, 35, 1373437144, 2205, 2, 10),
(1684, 70, 1373437198, 1339, 2, 9),
(1685, 154, 1373437322, 2030, 1, 3),
(1686, 131, 1373437340, 5089, 4, 23),
(1687, 92, 1373437553, 2177, 1, 3),
(1688, 155, 1373437588, 2392, 2, 9),
(1689, 57, 1373437665, 4370, 5, 22),
(1690, 81, 1373437792, 4571, 5, 16),
(1691, 79, 1373437939, 806, 2, 2),
(1692, 55, 1373438081, 1111, 1, 1),
(1693, 122, 1373438189, 18336, 17, 81),
(1694, 139, 1373438351, 1577, 1, 4),
(1695, 135, 1373438438, 1505, 2, 5),
(1696, 92, 1373438622, 1069, 2, 3),
(1697, 144, 1373438661, 1702, 1, 5),
(1698, 115, 1373438680, 29843, 33, 116),
(1699, 118, 1373438718, 3320, 3, 13),
(1700, 35, 1373438774, 1630, 1, 4),
(1701, 70, 1373439086, 1888, 1, 7),
(1702, 88, 1373439111, 642, 1, 1),
(1703, 89, 1373439142, 2314, 1, 11),
(1704, 155, 1373439173, 1585, 1, 1),
(1705, 174, 1373439266, 656, 1, 0),
(1706, 39, 1373439423, 1886, 1, 5),
(1707, 143, 1373439426, 3366, 5, 12),
(1708, 149, 1373439471, 2474, 2, 7),
(1709, 144, 1373439522, 860, 1, 1),
(1710, 48, 1373439531, 2341, 1, 7),
(1711, 121, 1373439857, 3171, 7, 16),
(1712, 83, 1373439889, 1281, 1, 5),
(1713, 155, 1373439939, 765, 3, 0),
(1714, 138, 1373440001, 5938, 7, 20),
(1715, 154, 1373440006, 1533, 1, 4),
(1716, 64, 1373440078, 1948, 1, 6),
(1717, 67, 1373440198, 3790, 2, 16),
(1718, 108, 1373440300, 3861, 7, 10),
(1719, 83, 1373440410, 521, 2, 8),
(1720, 73, 1373440519, 5509, 5, 19),
(1721, 78, 1373440542, 1949, 2, 11),
(1722, 144, 1373440656, 1133, 1, 5),
(1723, 143, 1373440823, 1396, 2, 6),
(1724, 52, 1373440911, 2132, 1, 8),
(1725, 127, 1373440996, 8149, 9, 32),
(1726, 89, 1373441262, 1407, 1, 5),
(1727, 64, 1373441274, 113, 1, 0),
(1728, 61, 1373441348, 1299, 2, 6),
(1729, 35, 1373441357, 2583, 1, 6),
(1730, 79, 1373441402, 1895, 1, 7),
(1731, 139, 1373441650, 1563, 1, 4),
(1732, 107, 1373441681, 18444, 13, 72),
(1733, 103, 1373441685, 7306, 7, 45),
(1734, 92, 1373441685, 1132, 2, 3),
(1735, 135, 1373441709, 1752, 2, 6),
(1736, 91, 1373441711, 10129, 4, 43),
(1737, 88, 1373441733, 2621, 3, 10),
(1738, 49, 1373441742, 14084, 21, 56),
(1739, 42, 1373441754, 10631, 9, 48),
(1740, 117, 1373441756, 7067, 2, 35),
(1741, 67, 1373441772, 531, 1, 5),
(1742, 78, 1373441793, 1251, 1, 9),
(1743, 148, 1373441808, 7461, 4, 23),
(1744, 47, 1373441830, 6835, 5, 20),
(1745, 179, 1373441840, 597, 1, 1),
(1746, 39, 1373441842, 1458, 1, 4),
(1747, 170, 1373441849, 164, 1, 0),
(1748, 83, 1373441861, 1451, 2, 9),
(1749, 53, 1373441870, 8032, 6, 26),
(1750, 144, 1373441870, 220, 2, 4),
(1751, 75, 1373441896, 9112, 6, 31),
(1752, 145, 1373441923, 6036, 6, 19),
(1753, 126, 1373441927, 21632, 28, 111),
(1754, 67, 1373441934, 161, 1, 6),
(1755, 112, 1373441946, 8771, 11, 47),
(1756, 98, 1373441948, 14111, 10, 60),
(1757, 73, 1373441951, 1432, 3, 10),
(1758, 89, 1373441956, 694, 1, 12),
(1759, 206, 1373441958, 1566, 1, 2),
(1760, 169, 1373441959, 168, 1, 1),
(1761, 92, 1373441962, 277, 1, 8),
(1762, 155, 1373441963, 1874, 2, 13),
(1763, 70, 1373441968, 283, 3, 9),
(1764, 64, 1373442065, 791, 2, 12),
(1765, 61, 1373442069, 721, 1, 10),
(1766, 172, 1373442090, 136, 1, 2),
(1767, 125, 1373442109, 24520, 27, 116),
(1768, 30, 1373442114, 1944, 3, 8),
(1769, 154, 1373442116, 358, 1, 4),
(1770, 127, 1373442127, 1131, 2, 9),
(1771, 35, 1373442134, 638, 4, 5),
(1772, 145, 1373442136, 211, 2, 1),
(1773, 108, 1373442138, 1838, 7, 7),
(1774, 58, 1373442146, 13102, 8, 35),
(1775, 112, 1373442147, 200, 1, 9),
(1776, 181, 1373442160, 368, 1, 5),
(1777, 102, 1373442176, 336, 2, 13),
(1778, 98, 1373442191, 241, 1, 5),
(1779, 97, 1373442196, 5765, 4, 26),
(1780, 91, 1373442199, 488, 1, 8),
(1781, 64, 1373442205, 138, 1, 5),
(1782, 83, 1373442223, 361, 1, 8),
(1783, 48, 1373442252, 356, 2, 10),
(1784, 128, 1373442309, 11003, 15, 50),
(1785, 81, 1373442319, 4527, 10, 19),
(1786, 55, 1373442320, 4239, 5, 22),
(1787, 30, 1373442369, 254, 1, 4),
(1788, 117, 1373442380, 558, 2, 19),
(1789, 195, 1373442387, 81, 1, 0),
(1790, 53, 1373442389, 259, 1, 5),
(1791, 127, 1373442410, 282, 2, 8),
(1792, 89, 1373442414, 457, 1, 5),
(1793, 67, 1373442433, 498, 1, 12),
(1794, 143, 1373442434, 919, 4, 10),
(1795, 135, 1373442439, 729, 1, 23),
(1796, 75, 1373442446, 549, 1, 9),
(1797, 70, 1373442455, 486, 2, 12),
(1798, 92, 1373442483, 520, 2, 13),
(1799, 183, 1373442489, 123, 1, 1),
(1800, 55, 1373442507, 186, 2, 6),
(1801, 195, 1373442513, 125, 2, 4),
(1802, 61, 1373442600, 246, 1, 4),
(1803, 48, 1373446169, 155, 1, 0),
(1804, 64, 1373446299, 284, 1, 0),
(1805, 52, 1373446317, 302, 2, 3),
(1806, 19, 1373446351, 338, 1, 3),
(1807, 56, 1373446362, 347, 1, 6),
(1808, 27, 1373446414, 401, 1, 3),
(1809, 59, 1373446459, 250, 1, 1),
(1810, 36, 1373446481, 467, 1, 4),
(1811, 23, 1373446489, 476, 4, 7),
(1812, 58, 1373446509, 494, 2, 3),
(1813, 46, 1373446513, 499, 1, 5),
(1814, 11, 1373446519, 66, 1, 1),
(1815, 43, 1373446540, 526, 1, 3),
(1816, 40, 1373446555, 541, 1, 2),
(1817, 24, 1373446562, 549, 3, 7),
(1818, 12, 1373446571, 558, 3, 5),
(1819, 54, 1373446579, 121, 1, 1),
(1820, 51, 1373446581, 566, 4, 6),
(1821, 52, 1373446604, 287, 1, 3),
(1822, 18, 1373446617, 604, 1, 5),
(1823, 41, 1373446617, 289, 2, 6),
(1824, 57, 1373446654, 639, 1, 7),
(1825, 38, 1373446660, 573, 2, 5),
(1826, 47, 1373446680, 666, 4, 7),
(1827, 34, 1373446681, 667, 1, 4),
(1828, 40, 1373446693, 138, 1, 2),
(1829, 37, 1373446708, 617, 2, 5),
(1830, 69, 1373446730, 220, 2, 5),
(1831, 71, 1373446735, 719, 2, 6),
(1832, 35, 1373446739, 344, 1, 2),
(1833, 44, 1373446765, 751, 2, 7),
(1834, 62, 1373446767, 752, 1, 6),
(1835, 63, 1373446787, 331, 4, 4),
(1836, 59, 1373446797, 338, 1, 5),
(1837, 65, 1373446808, 596, 2, 4),
(1838, 54, 1373446817, 238, 2, 3),
(1839, 67, 1373446818, 653, 3, 12),
(1840, 55, 1373446828, 721, 2, 13),
(1841, 34, 1373446844, 163, 1, 1),
(1842, 23, 1373446851, 192, 1, 3),
(1843, 33, 1373446889, 499, 2, 4),
(1844, 62, 1373446905, 138, 1, 0),
(1845, 26, 1373446929, 916, 1, 8),
(1846, 37, 1373446995, 287, 1, 1),
(1847, 11, 1373447004, 485, 2, 11),
(1848, 15, 1373447036, 849, 2, 25),
(1849, 14, 1373447067, 632, 1, 16),
(1850, 41, 1373447124, 507, 5, 4),
(1851, 18, 1373447132, 515, 4, 8),
(1852, 19, 1373447133, 456, 5, 15),
(1853, 26, 1373447134, 205, 1, 4),
(1854, 51, 1373447171, 589, 3, 8),
(1855, 41, 1373447194, 70, 1, 2),
(1856, 39, 1373447199, 327, 1, 2),
(1857, 44, 1373447331, 566, 2, 4),
(1858, 52, 1373447356, 752, 1, 9),
(1859, 22, 1373447364, 526, 4, 10),
(1860, 23, 1373447367, 516, 5, 12),
(1861, 27, 1373447369, 482, 3, 7),
(1862, 29, 1373447372, 307, 2, 2),
(1863, 68, 1373447432, 405, 1, 4),
(1864, 49, 1373447449, 1434, 8, 9),
(1865, 24, 1373447450, 668, 4, 17),
(1866, 31, 1373447475, 1081, 2, 7),
(1867, 45, 1373447478, 701, 3, 7),
(1868, 53, 1373447494, 855, 1, 3),
(1869, 21, 1373447497, 1014, 1, 13),
(1870, 33, 1373447503, 614, 1, 5),
(1871, 17, 1373447510, 1377, 2, 29),
(1872, 46, 1373447511, 998, 5, 11),
(1873, 26, 1373447578, 444, 2, 0),
(1874, 27, 1373447601, 232, 1, 0),
(1875, 48, 1373447603, 1434, 3, 17),
(1876, 19, 1373447649, 516, 3, 6),
(1877, 43, 1373447676, 1054, 1, 3),
(1878, 11, 1373447693, 591, 2, 9),
(1879, 25, 1373447699, 1264, 6, 22),
(1880, 53, 1373447770, 276, 1, 2),
(1881, 41, 1373447771, 576, 1, 4),
(1882, 20, 1373447822, 1224, 4, 13),
(1883, 47, 1373447835, 1155, 1, 4),
(1884, 24, 1373447870, 420, 2, 5),
(1885, 15, 1373447873, 837, 2, 8),
(1886, 13, 1373447878, 867, 2, 3),
(1887, 31, 1373447910, 435, 1, 5),
(1888, 33, 1373447962, 207, 1, 0),
(1889, 25, 1373448002, 303, 2, 5),
(1890, 36, 1373448017, 443, 1, 6),
(1891, 18, 1373448066, 387, 1, 2),
(1892, 20, 1373448082, 86, 1, 0),
(1893, 17, 1373448095, 585, 1, 6),
(1894, 25, 1373448106, 104, 1, 0),
(1895, 21, 1373448149, 461, 2, 0),
(1896, 35, 1373448155, 540, 1, 4),
(1897, 16, 1373448169, 1986, 8, 35),
(1898, 29, 1373448172, 799, 2, 9),
(1899, 67, 1373448197, 1331, 1, 0),
(1900, 48, 1373448208, 375, 2, 0),
(1901, 12, 1373448223, 1652, 5, 32),
(1902, 51, 1373448241, 1070, 1, 8),
(1903, 32, 1373448266, 523, 2, 6),
(1904, 69, 1373448269, 1454, 1, 4),
(1905, 70, 1373448295, 1883, 1, 3),
(1906, 14, 1373448306, 320, 1, 4),
(1907, 56, 1373448328, 304, 2, 5),
(1908, 51, 1373448331, 90, 1, 3),
(1909, 58, 1373448333, 1421, 2, 14),
(1910, 30, 1373448346, 580, 2, 8),
(1911, 26, 1373448360, 503, 1, 3),
(1912, 37, 1373448366, 1073, 1, 6),
(1913, 72, 1373448389, 1530, 1, 2),
(1914, 21, 1373477449, 97, 1, 0),
(1915, 31, 1373477471, 119, 1, 0),
(1916, 13, 1373477478, 126, 1, 1),
(1917, 25, 1373477493, 141, 1, 1),
(1918, 15, 1373477500, 148, 1, 0),
(1919, 45, 1373477539, 186, 2, 2),
(1920, 48, 1373477562, 209, 1, 1),
(1921, 26, 1373477604, 252, 1, 2),
(1922, 52, 1373477626, 273, 3, 4),
(1923, 28, 1373477653, 301, 1, 2),
(1924, 25, 1373477734, 241, 2, 1),
(1925, 33, 1373477760, 408, 1, 3),
(1926, 37, 1373477880, 527, 2, 6),
(1927, 50, 1373477964, 611, 2, 5),
(1928, 39, 1373477987, 634, 2, 5),
(1929, 44, 1373478035, 682, 2, 2),
(1930, 47, 1373478045, 692, 1, 7),
(1931, 35, 1373478086, 733, 1, 6),
(1932, 27, 1373478150, 735, 1, 0),
(1933, 22, 1373478207, 269, 1, 3),
(1934, 15, 1373478234, 734, 2, 7),
(1935, 12, 1373478250, 898, 4, 8),
(1936, 14, 1373478268, 771, 1, 2),
(1937, 21, 1373478362, 913, 2, 5),
(1938, 16, 1373478370, 1018, 1, 9),
(1939, 46, 1373478374, 1021, 2, 11),
(1940, 19, 1373478392, 1040, 2, 10),
(1941, 17, 1373478564, 876, 2, 7),
(1942, 18, 1373478567, 1215, 1, 4),
(1943, 32, 1373478613, 588, 6, 5),
(1944, 35, 1373478646, 560, 1, 10),
(1945, 40, 1373478667, 1314, 1, 7),
(1946, 27, 1373478715, 565, 3, 3),
(1947, 38, 1373478758, 1405, 3, 15),
(1948, 39, 1373478771, 784, 1, 1),
(1949, 24, 1373478783, 750, 1, 7),
(1950, 18, 1373478801, 233, 3, 1),
(1951, 30, 1373478842, 139, 1, 1),
(1952, 41, 1373478855, 191, 1, 0),
(1953, 29, 1373478884, 1532, 3, 12),
(1954, 14, 1373478908, 554, 1, 5),
(1955, 34, 1373478917, 622, 1, 4),
(1956, 15, 1373479027, 268, 1, 2),
(1957, 36, 1373479041, 1624, 3, 11),
(1958, 28, 1373479049, 924, 1, 10),
(1959, 22, 1373479059, 852, 1, 10),
(1960, 39, 1373479082, 311, 2, 2),
(1961, 43, 1373479084, 1053, 5, 6),
(1962, 13, 1373479085, 117, 1, 2),
(1963, 33, 1373479123, 948, 3, 7),
(1964, 42, 1373479168, 180, 1, 0),
(1965, 40, 1373479184, 486, 1, 7),
(1966, 19, 1373479261, 869, 4, 7),
(1967, 14, 1373479269, 167, 1, 4),
(1968, 20, 1373479270, 1708, 2, 22),
(1969, 46, 1373479313, 939, 1, 1),
(1970, 41, 1373479495, 131, 1, 0),
(1971, 28, 1373479557, 194, 1, 1),
(1972, 44, 1373479568, 204, 1, 2),
(1973, 46, 1373479611, 247, 1, 4),
(1974, 38, 1373479635, 271, 1, 1),
(1975, 48, 1373479638, 274, 3, 1),
(1976, 53, 1373479684, 320, 1, 4),
(1977, 33, 1373479704, 247, 1, 3),
(1978, 29, 1373479746, 262, 1, 6),
(1979, 23, 1373479760, 397, 1, 1),
(1980, 31, 1373479783, 420, 3, 4),
(1981, 26, 1373479803, 137, 1, 0),
(1982, 41, 1373479829, 334, 1, 2),
(1983, 12, 1373479838, 476, 1, 3),
(1984, 20, 1373479859, 496, 3, 4),
(1985, 25, 1373479870, 359, 1, 3),
(1986, 16, 1373479876, 410, 1, 3),
(1987, 23, 1373479877, 117, 1, 2),
(1988, 61, 1373479888, 524, 3, 9),
(1989, 65, 1373479902, 341, 1, 4),
(1990, 63, 1373479921, 557, 1, 7),
(1991, 62, 1373479932, 321, 1, 1),
(1992, 66, 1373479933, 225, 1, 1),
(1993, 51, 1373480066, 702, 1, 6),
(1994, 56, 1373480095, 263, 1, 4),
(1995, 32, 1373480103, 325, 1, 3),
(1996, 37, 1373480105, 742, 3, 3),
(1997, 36, 1373480108, 564, 2, 4),
(1998, 31, 1373480122, 339, 1, 2),
(1999, 47, 1373480156, 422, 3, 9),
(2000, 13, 1373480254, 844, 2, 8),
(2001, 40, 1373480279, 509, 1, 4),
(2002, 39, 1373480282, 682, 1, 4),
(2003, 16, 1373480633, 569, 2, 9),
(2004, 54, 1373480645, 1281, 5, 17),
(2005, 32, 1373480705, 431, 1, 2),
(2006, 23, 1373480723, 846, 1, 7),
(2007, 59, 1373480751, 1273, 4, 16),
(2008, 14, 1373480753, 1092, 4, 13),
(2009, 25, 1373480834, 964, 3, 8),
(2010, 38, 1373480842, 251, 1, 0),
(2011, 45, 1373480867, 780, 1, 3),
(2012, 72, 1373480892, 1084, 1, 2),
(2013, 17, 1373480908, 971, 1, 11),
(2014, 57, 1373480986, 1622, 6, 17),
(2015, 52, 1373481005, 1641, 8, 19),
(2016, 48, 1373481017, 122, 1, 0),
(2017, 15, 1373481022, 356, 2, 0),
(2018, 35, 1373481107, 1008, 1, 3),
(2019, 21, 1373481107, 1744, 7, 26),
(2020, 32, 1373481115, 410, 2, 3),
(2021, 28, 1373481150, 1593, 3, 14),
(2022, 47, 1373481151, 116, 1, 1),
(2023, 22, 1373481188, 1574, 3, 16),
(2024, 42, 1373481244, 166, 1, 3),
(2025, 55, 1373481253, 1889, 4, 18),
(2026, 11, 1373481279, 629, 1, 5),
(2027, 23, 1373481300, 577, 2, 6),
(2028, 58, 1373481315, 1951, 5, 15),
(2029, 46, 1373481326, 37, 1, 0),
(2030, 11, 1373481364, 85, 1, 0),
(2031, 20, 1373481369, 1510, 6, 12),
(2032, 14, 1373481373, 132, 1, 2),
(2033, 59, 1373481419, 667, 1, 0),
(2034, 22, 1373481434, 203, 1, 2),
(2035, 13, 1373481450, 680, 2, 5),
(2036, 52, 1373481465, 110, 1, 1),
(2037, 49, 1373481506, 2142, 4, 25),
(2038, 58, 1373481532, 217, 1, 3),
(2039, 31, 1373481575, 1453, 2, 11),
(2040, 36, 1373481619, 424, 2, 3),
(2041, 50, 1373481634, 1638, 2, 8),
(2042, 44, 1373481637, 446, 3, 4),
(2043, 39, 1373481656, 955, 1, 7),
(2044, 57, 1373481704, 718, 1, 3),
(2045, 19, 1373481758, 2395, 5, 31),
(2046, 24, 1373481767, 2404, 8, 29),
(2047, 20, 1373481812, 443, 1, 2),
(2048, 33, 1373481842, 1074, 4, 4),
(2049, 25, 1373481886, 1052, 4, 14),
(2050, 22, 1373481931, 497, 1, 7),
(2051, 36, 1373482059, 440, 1, 0),
(2052, 14, 1373482067, 694, 1, 4),
(2053, 37, 1373482150, 1761, 3, 11),
(2054, 65, 1373482152, 167, 1, 1),
(2055, 20, 1373482152, 340, 1, 2),
(2056, 15, 1373482164, 924, 1, 3),
(2057, 17, 1373482179, 1271, 4, 6),
(2058, 29, 1373482186, 1277, 3, 7),
(2059, 43, 1373482201, 962, 1, 8),
(2060, 54, 1373482216, 816, 1, 6),
(2061, 66, 1373482228, 1439, 2, 5),
(2062, 55, 1373482235, 982, 4, 8),
(2063, 64, 1373482251, 2375, 2, 7),
(2064, 37, 1373482268, 118, 1, 0),
(2065, 31, 1373482283, 708, 2, 5),
(2066, 48, 1373482297, 724, 1, 2),
(2067, 27, 1373482364, 3001, 9, 16),
(2068, 45, 1373482381, 1373, 1, 11),
(2069, 40, 1373482394, 1306, 2, 11),
(2070, 23, 1373482404, 145, 1, 1),
(2071, 69, 1373482412, 2432, 3, 4),
(2072, 68, 1373482459, 605, 1, 2),
(2073, 40, 1373482470, 76, 2, 1),
(2074, 32, 1373482516, 258, 2, 0),
(2075, 42, 1373482531, 930, 1, 8),
(2076, 70, 1373482552, 2473, 3, 6),
(2077, 13, 1373482560, 1110, 2, 7),
(2078, 71, 1373482593, 675, 1, 6),
(2079, 16, 1373482602, 1969, 8, 10),
(2080, 42, 1373482621, 90, 1, 3),
(2081, 63, 1373482627, 683, 1, 7),
(2082, 74, 1373482679, 3314, 2, 5),
(2083, 11, 1373482699, 148, 1, 1),
(2084, 80, 1373482707, 3342, 3, 7),
(2085, 31, 1373482733, 450, 2, 1),
(2086, 41, 1373482757, 1418, 3, 17),
(2087, 17, 1373482786, 607, 2, 1),
(2088, 73, 1373482823, 3458, 1, 5),
(2089, 46, 1373482836, 1392, 2, 14),
(2090, 54, 1373482851, 635, 1, 4),
(2091, 14, 1373482858, 605, 1, 3),
(2092, 82, 1373482881, 3516, 1, 0),
(2093, 38, 1373482901, 2058, 3, 17),
(2094, 65, 1373482908, 264, 1, 1),
(2095, 48, 1373482917, 620, 1, 5),
(2096, 47, 1373482923, 393, 2, 5),
(2097, 34, 1373482929, 3062, 2, 23),
(2098, 75, 1373482949, 3584, 1, 11),
(2099, 20, 1373482987, 835, 2, 6),
(2100, 50, 1373483004, 872, 3, 7),
(2101, 14, 1373483025, 167, 1, 3),
(2102, 60, 1373483055, 1120, 2, 11),
(2103, 55, 1373483056, 821, 2, 9),
(2104, 46, 1373483067, 231, 1, 0),
(2105, 21, 1373483088, 1980, 3, 18),
(2106, 26, 1373483092, 3289, 7, 37),
(2107, 83, 1373483104, 3739, 1, 2),
(2108, 32, 1373483110, 594, 2, 7),
(2109, 36, 1373483124, 1065, 2, 6),
(2110, 57, 1373483125, 1371, 2, 14),
(2111, 28, 1373483133, 1983, 3, 13),
(2112, 35, 1373483160, 335, 2, 2),
(2113, 11, 1373483188, 172, 1, 0),
(2114, 78, 1373483199, 822, 1, 7),
(2115, 50, 1373483206, 202, 1, 0),
(2116, 66, 1373483229, 488, 1, 2),
(2117, 33, 1373483251, 750, 1, 5),
(2118, 43, 1373483262, 968, 1, 7),
(2119, 24, 1373483273, 1506, 3, 9),
(2120, 22, 1373483299, 89, 1, 0),
(2121, 29, 1373483309, 891, 1, 8),
(2122, 92, 1373483330, 3964, 1, 7),
(2123, 61, 1373483415, 536, 2, 7),
(2124, 42, 1373483419, 798, 1, 6),
(2125, 77, 1373483421, 990, 1, 8),
(2126, 86, 1373483422, 4057, 4, 8),
(2127, 65, 1373483467, 559, 1, 3),
(2128, 88, 1373483475, 4109, 1, 6),
(2129, 41, 1373483482, 669, 1, 5),
(2130, 64, 1373483487, 1236, 1, 11),
(2131, 67, 1373483504, 638, 1, 6),
(2132, 11, 1373483508, 320, 1, 3),
(2133, 21, 1373483510, 422, 1, 2),
(2134, 85, 1373483517, 4152, 3, 4),
(2135, 60, 1373483529, 474, 1, 6),
(2136, 83, 1373483608, 91, 1, 1),
(2137, 46, 1373483629, 562, 3, 8),
(2138, 81, 1373483638, 4273, 1, 9),
(2139, 72, 1373483639, 923, 2, 9),
(2140, 51, 1373483647, 567, 1, 3),
(2141, 25, 1373483652, 1766, 4, 15),
(2142, 50, 1373483653, 447, 1, 4),
(2143, 14, 1373483705, 680, 3, 3),
(2144, 69, 1373483770, 1358, 1, 13),
(2145, 21, 1373483853, 342, 1, 5),
(2146, 59, 1373483876, 1658, 4, 17),
(2147, 17, 1373483881, 598, 1, 6),
(2148, 62, 1373483918, 748, 2, 11),
(2149, 68, 1373483949, 273, 1, 1),
(2150, 76, 1373483952, 932, 1, 1),
(2151, 23, 1373483957, 1553, 6, 21),
(2152, 82, 1373484015, 1134, 3, 8),
(2153, 75, 1373484038, 1089, 2, 11),
(2154, 91, 1373484049, 4683, 4, 5),
(2155, 38, 1373484104, 1144, 1, 20),
(2156, 46, 1373484110, 481, 1, 3),
(2157, 66, 1373484184, 449, 2, 1),
(2158, 61, 1373484184, 769, 1, 0),
(2159, 49, 1373484211, 2705, 11, 18),
(2160, 27, 1373484235, 1871, 2, 18),
(2161, 50, 1373484242, 589, 1, 5),
(2162, 58, 1373484250, 2718, 6, 18),
(2163, 52, 1373484294, 2829, 5, 16),
(2164, 40, 1373484319, 1849, 3, 17),
(2165, 51, 1373484358, 356, 3, 6),
(2166, 59, 1373484437, 561, 3, 4),
(2167, 55, 1373484473, 909, 2, 5),
(2168, 54, 1373484474, 844, 3, 12),
(2169, 13, 1373484485, 1522, 4, 13),
(2170, 70, 1373484512, 1960, 4, 16),
(2171, 57, 1373484551, 1426, 3, 10),
(2172, 84, 1373484565, 1721, 1, 4),
(2173, 43, 1373484610, 452, 1, 6),
(2174, 22, 1373484610, 743, 3, 9),
(2175, 67, 1373484645, 452, 1, 4),
(2176, 33, 1373484651, 1400, 4, 21),
(2177, 73, 1373484668, 1845, 3, 15),
(2178, 20, 1373484704, 1717, 4, 24),
(2179, 64, 1373484708, 283, 1, 0),
(2180, 75, 1373484775, 737, 1, 3),
(2181, 32, 1373484815, 787, 1, 10),
(2182, 11, 1373484847, 1072, 1, 5),
(2183, 18, 1373484897, 5397, 9, 49),
(2184, 20, 1373484959, 255, 1, 0),
(2185, 37, 1373485053, 662, 1, 4),
(2186, 38, 1373485064, 960, 2, 9),
(2187, 43, 1373485086, 476, 1, 2),
(2188, 48, 1373485108, 1702, 2, 4),
(2189, 12, 1373485157, 651, 3, 3),
(2190, 28, 1373485186, 2052, 3, 26),
(2191, 44, 1373485195, 3558, 7, 23),
(2192, 52, 1373485208, 914, 2, 5),
(2193, 63, 1373485209, 873, 2, 4),
(2194, 84, 1373485303, 106, 1, 0),
(2195, 29, 1373485326, 2017, 3, 9),
(2196, 57, 1373485329, 778, 1, 3),
(2197, 79, 1373485369, 1504, 2, 2),
(2198, 45, 1373485397, 2592, 6, 30),
(2199, 14, 1373485513, 1492, 1, 12),
(2200, 34, 1373485546, 2616, 4, 13),
(2201, 62, 1373485549, 993, 3, 10),
(2202, 21, 1373485603, 1750, 3, 13),
(2203, 86, 1373485624, 2202, 2, 3),
(2204, 78, 1373485625, 1334, 1, 3),
(2205, 47, 1373485686, 2466, 8, 28),
(2206, 69, 1373485693, 1000, 2, 7),
(2207, 58, 1373485715, 1465, 2, 13),
(2208, 59, 1373485729, 1292, 2, 7),
(2209, 80, 1373485755, 2006, 1, 8),
(2210, 25, 1373485771, 2119, 5, 14),
(2211, 73, 1373485888, 1220, 1, 6),
(2212, 77, 1373485933, 1178, 1, 3),
(2213, 66, 1373485989, 1805, 1, 5),
(2214, 70, 1373486040, 1489, 1, 5),
(2215, 39, 1373486042, 1899, 9, 12),
(2216, 37, 1373486052, 898, 2, 6),
(2217, 64, 1373486152, 1444, 2, 7),
(2218, 65, 1373486218, 1877, 1, 7),
(2219, 16, 1373486316, 3714, 7, 28),
(2220, 70, 1373486324, 284, 1, 0),
(2221, 63, 1373486344, 685, 1, 3),
(2222, 13, 1373486469, 1984, 1, 9),
(2223, 14, 1373486520, 889, 3, 5),
(2224, 37, 1373486632, 580, 1, 1),
(2225, 53, 1373486960, 6393, 6, 39),
(2226, 58, 1373487209, 947, 1, 3),
(2227, 36, 1373487334, 4209, 14, 29),
(2228, 25, 1373487399, 1628, 2, 3),
(2229, 29, 1373487530, 2204, 6, 13),
(2230, 17, 1373487538, 1091, 1, 2),
(2231, 33, 1373487614, 2241, 1, 2),
(2232, 28, 1373487630, 2444, 11, 17),
(2233, 13, 1373487755, 235, 1, 0),
(2234, 35, 1373487776, 2748, 2, 0),
(2235, 12, 1373487803, 289, 1, 1),
(2236, 11, 1373487826, 109, 1, 0),
(2237, 21, 1373487885, 2282, 2, 8),
(2238, 23, 1373488032, 4075, 6, 27),
(2239, 33, 1373488130, 469, 1, 1),
(2240, 15, 1373488204, 388, 1, 0),
(2241, 34, 1373488218, 529, 1, 2),
(2242, 40, 1373488230, 3197, 1, 1),
(2243, 35, 1373488247, 470, 1, 0),
(2244, 18, 1373488268, 568, 1, 3),
(2245, 29, 1373488342, 812, 1, 4),
(2246, 20, 1373488469, 2890, 6, 7),
(2247, 32, 1373488549, 2443, 5, 7),
(2248, 17, 1373488554, 172, 1, 1),
(2249, 13, 1373488560, 151, 1, 0),
(2250, 16, 1373488689, 2373, 5, 10),
(2251, 39, 1373488691, 309, 1, 0),
(2252, 22, 1373488748, 4138, 7, 16),
(2253, 34, 1373488789, 571, 2, 2),
(2254, 15, 1373488796, 592, 1, 0),
(2255, 21, 1373488830, 945, 1, 3),
(2256, 35, 1373488856, 172, 1, 1),
(2257, 17, 1373488883, 231, 1, 1),
(2258, 33, 1373488920, 459, 1, 3),
(2259, 13, 1373488980, 126, 1, 1),
(2260, 28, 1373489009, 1379, 4, 13),
(2261, 22, 1373489011, 262, 1, 2),
(2262, 34, 1373489112, 323, 1, 3),
(2263, 23, 1373489151, 1119, 5, 9),
(2264, 39, 1373489160, 469, 2, 6),
(2265, 32, 1373489184, 635, 2, 10),
(2266, 37, 1373489236, 299, 1, 5),
(2267, 18, 1373489241, 431, 3, 0),
(2268, 22, 1373489380, 247, 1, 4),
(2269, 20, 1373489428, 959, 1, 6),
(2270, 21, 1373489435, 426, 1, 3),
(2271, 38, 1373489439, 1370, 3, 8),
(2272, 33, 1373489442, 522, 1, 7),
(2273, 15, 1373489478, 454, 1, 1),
(2274, 54, 1373489527, 4290, 2, 5),
(2275, 37, 1373489532, 296, 1, 5),
(2276, 60, 1373489549, 3541, 1, 4),
(2277, 24, 1373489574, 6208, 10, 17),
(2278, 11, 1373489606, 84, 1, 3),
(2279, 34, 1373489610, 498, 1, 6),
(2280, 46, 1373489625, 4150, 2, 18),
(2281, 17, 1373489647, 156, 1, 4),
(2282, 59, 1373489649, 3614, 3, 2),
(2283, 43, 1373489650, 879, 5, 9),
(2284, 15, 1373489715, 237, 2, 5),
(2285, 26, 1373489747, 6654, 6, 17),
(2286, 29, 1373489858, 1516, 8, 14),
(2287, 48, 1373489888, 664, 3, 20),
(2288, 20, 1373489910, 480, 1, 5),
(2289, 63, 1373489921, 3577, 2, 0),
(2290, 37, 1373489938, 340, 1, 2),
(2291, 49, 1373489965, 291, 2, 3),
(2292, 38, 1373489998, 559, 1, 9),
(2293, 18, 1373490005, 316, 1, 0),
(2294, 12, 1373490027, 442, 2, 4),
(2295, 43, 1373490034, 231, 1, 0),
(2296, 34, 1373490035, 286, 1, 2),
(2297, 40, 1373490118, 1810, 6, 16),
(2298, 16, 1373490134, 448, 1, 3),
(2299, 14, 1373490168, 467, 2, 3),
(2300, 21, 1373490171, 736, 1, 7),
(2301, 54, 1373490190, 663, 2, 3),
(2302, 24, 1373490205, 162, 1, 1),
(2303, 39, 1373490237, 917, 2, 10),
(2304, 25, 1373490238, 2839, 3, 21),
(2305, 28, 1373490247, 820, 2, 10),
(2306, 55, 1373490254, 4838, 1, 17),
(2307, 13, 1373490275, 593, 2, 3),
(2308, 64, 1373490321, 97, 2, 0),
(2309, 15, 1373490429, 216, 2, 1),
(2310, 53, 1373490450, 1415, 2, 12),
(2311, 76, 1373490461, 5659, 1, 0),
(2312, 52, 1373490537, 547, 2, 4),
(2313, 32, 1373490537, 440, 1, 4),
(2314, 28, 1373490554, 307, 1, 2),
(2315, 23, 1373490611, 843, 2, 5),
(2316, 42, 1373490615, 5541, 9, 25),
(2317, 38, 1373490618, 215, 1, 1),
(2318, 14, 1373490645, 477, 1, 8),
(2319, 12, 1373490667, 433, 1, 7),
(2320, 33, 1373490703, 1194, 1, 17),
(2321, 34, 1373490705, 670, 1, 6),
(2322, 67, 1373490714, 67, 1, 1),
(2323, 31, 1373490724, 6419, 16, 57),
(2324, 35, 1373490736, 1879, 4, 23),
(2325, 60, 1373490739, 428, 1, 11),
(2326, 68, 1373490784, 242, 1, 6),
(2327, 65, 1373490794, 306, 1, 3),
(2328, 23, 1373490809, 198, 2, 1),
(2329, 75, 1373490831, 6056, 1, 3),
(2330, 76, 1373490833, 285, 3, 1),
(2331, 78, 1373490839, 224, 1, 3),
(2332, 70, 1373490847, 591, 1, 8),
(2333, 66, 1373490937, 849, 2, 9),
(2334, 36, 1373490987, 2933, 2, 28),
(2335, 38, 1373491015, 397, 1, 4),
(2336, 64, 1373491033, 712, 1, 9),
(2337, 41, 1373491063, 1752, 7, 24),
(2338, 52, 1373491080, 504, 3, 3),
(2339, 54, 1373491084, 383, 2, 3),
(2340, 17, 1373491164, 537, 1, 4),
(2341, 63, 1373491167, 646, 2, 13),
(2342, 87, 1373491167, 6355, 1, 0),
(2343, 53, 1373491250, 663, 1, 5),
(2344, 14, 1373491271, 626, 1, 4),
(2345, 59, 1373491381, 1179, 3, 11),
(2346, 65, 1373491392, 598, 1, 5),
(2347, 34, 1373491395, 690, 2, 8),
(2348, 23, 1373491408, 599, 1, 2),
(2349, 66, 1373491430, 493, 1, 6),
(2350, 11, 1373491496, 427, 1, 4),
(2351, 13, 1373491500, 811, 2, 5),
(2352, 28, 1373491513, 959, 1, 8),
(2353, 42, 1373491542, 253, 2, 0),
(2354, 12, 1373491546, 689, 2, 2),
(2355, 36, 1373491554, 566, 1, 8),
(2356, 32, 1373491556, 940, 1, 6),
(2357, 18, 1373491563, 749, 1, 6),
(2358, 75, 1373491573, 742, 1, 10),
(2359, 46, 1373491581, 1956, 6, 28),
(2360, 78, 1373491593, 349, 1, 0),
(2361, 68, 1373491593, 809, 2, 4),
(2362, 88, 1373491645, 8170, 2, 2),
(2363, 41, 1373491694, 631, 2, 11),
(2364, 37, 1373491727, 1657, 3, 11),
(2365, 31, 1373491753, 1029, 2, 5),
(2366, 28, 1373491761, 248, 1, 5),
(2367, 45, 1373491776, 6378, 6, 50),
(2368, 15, 1373491777, 1319, 2, 5),
(2369, 70, 1373491787, 182, 1, 0),
(2370, 14, 1373491802, 531, 1, 6),
(2371, 64, 1373491806, 773, 1, 3),
(2372, 49, 1373491855, 1890, 8, 32),
(2373, 33, 1373491886, 481, 1, 6),
(2374, 13, 1373491887, 386, 1, 3),
(2375, 51, 1373491900, 183, 2, 2),
(2376, 44, 1373491907, 6712, 15, 43),
(2377, 90, 1373491927, 948, 1, 1),
(2378, 18, 1373491929, 366, 1, 3),
(2379, 89, 1373491933, 387, 1, 4),
(2380, 58, 1373491941, 1919, 5, 19),
(2381, 54, 1373491941, 857, 2, 3),
(2382, 62, 1373491973, 398, 2, 3),
(2383, 32, 1373491984, 402, 1, 2),
(2384, 16, 1373491989, 1296, 1, 10),
(2385, 47, 1373492110, 2554, 9, 27),
(2386, 86, 1373492133, 1066, 1, 4),
(2387, 84, 1373492139, 1042, 1, 9),
(2388, 81, 1373492176, 213, 2, 3),
(2389, 91, 1373492181, 123, 1, 0),
(2390, 63, 1373492193, 440, 1, 4),
(2391, 24, 1373492229, 2024, 6, 13),
(2392, 52, 1373492259, 1179, 2, 3),
(2393, 62, 1373492268, 295, 1, 3),
(2394, 69, 1373492286, 6311, 3, 14),
(2395, 38, 1373492290, 1275, 3, 9),
(2396, 65, 1373492294, 416, 1, 2),
(2397, 71, 1373492298, 584, 1, 2),
(2398, 82, 1373492333, 1273, 2, 14),
(2399, 29, 1373492358, 2499, 9, 23),
(2400, 68, 1373492394, 759, 1, 1),
(2401, 76, 1373492409, 317, 1, 2),
(2402, 91, 1373492440, 259, 1, 0),
(2403, 73, 1373492463, 1461, 2, 9),
(2404, 51, 1373492477, 577, 1, 3),
(2405, 37, 1373492481, 340, 1, 8),
(2406, 95, 1373492527, 558, 1, 4),
(2407, 79, 1373492542, 1194, 2, 11),
(2408, 31, 1373492553, 651, 2, 9),
(2409, 30, 1373492560, 13197, 2, 5),
(2410, 17, 1373492606, 176, 1, 0),
(2411, 48, 1373492644, 2756, 5, 28),
(2412, 96, 1373492680, 417, 1, 1),
(2413, 54, 1373492704, 763, 1, 5),
(2414, 58, 1373492737, 796, 1, 6),
(2415, 13, 1373492741, 453, 1, 1),
(2416, 89, 1373492747, 814, 1, 4),
(2417, 27, 1373492767, 8532, 24, 81),
(2418, 59, 1373492784, 915, 1, 2),
(2419, 42, 1373492916, 1374, 2, 17),
(2420, 14, 1373492929, 666, 2, 3),
(2421, 85, 1373492950, 1301, 2, 9),
(2422, 90, 1373492976, 592, 2, 3),
(2423, 12, 1373493059, 902, 1, 7),
(2424, 68, 1373493076, 682, 1, 4),
(2425, 35, 1373493109, 2373, 1, 13),
(2426, 106, 1373493210, 13844, 1, 4),
(2427, 11, 1373493213, 1287, 1, 7),
(2428, 109, 1373493450, 802, 2, 3),
(2429, 95, 1373493513, 986, 1, 6),
(2430, 31, 1373493534, 981, 1, 2),
(2431, 63, 1373493535, 520, 1, 2),
(2432, 62, 1373493559, 1291, 2, 5),
(2433, 28, 1373493585, 1823, 5, 16),
(2434, 66, 1373493598, 1621, 1, 5),
(2435, 80, 1373493602, 2072, 4, 14),
(2436, 11, 1373493608, 285, 1, 3),
(2437, 37, 1373493616, 1135, 1, 6),
(2438, 91, 1373493620, 1180, 2, 7),
(2439, 25, 1373493631, 3035, 7, 24),
(2440, 50, 1373493638, 8482, 11, 62),
(2441, 93, 1373493647, 1240, 1, 4),
(2442, 16, 1373493651, 1662, 2, 7),
(2443, 21, 1373493689, 3518, 6, 32),
(2444, 52, 1373493692, 324, 2, 1),
(2445, 74, 1373493696, 2658, 4, 17),
(2446, 70, 1373493698, 1910, 5, 9),
(2447, 71, 1373493729, 1431, 2, 7),
(2448, 47, 1373493761, 1252, 1, 6),
(2449, 57, 1373493824, 8495, 11, 45),
(2450, 42, 1373493852, 936, 1, 5),
(2451, 40, 1373493899, 3781, 9, 31),
(2452, 14, 1373493940, 248, 1, 2),
(2453, 77, 1373493947, 2344, 1, 13),
(2454, 81, 1373493976, 1014, 2, 2),
(2455, 78, 1373494014, 1852, 2, 11),
(2456, 56, 1373494057, 710, 1, 5),
(2457, 95, 1373494058, 545, 1, 3),
(2458, 92, 1373494077, 1240, 1, 3),
(2459, 80, 1373494087, 264, 2, 2),
(2460, 22, 1373494107, 177, 1, 1),
(2461, 32, 1373494121, 425, 1, 4),
(2462, 30, 1373494130, 667, 1, 6),
(2463, 37, 1373494141, 430, 1, 1),
(2464, 67, 1373494167, 2600, 2, 9),
(2465, 83, 1373494180, 3402, 2, 34),
(2466, 50, 1373494213, 575, 2, 5),
(2467, 94, 1373494215, 1972, 1, 14),
(2468, 98, 1373494222, 14856, 3, 9),
(2469, 70, 1373494229, 160, 1, 2),
(2470, 77, 1373494241, 294, 2, 1),
(2471, 18, 1373494248, 488, 1, 4),
(2472, 39, 1373494268, 3623, 9, 28),
(2473, 97, 1373494276, 1875, 2, 10),
(2474, 53, 1373494300, 1792, 4, 12),
(2475, 78, 1373494331, 163, 1, 2),
(2476, 74, 1373494352, 656, 1, 6),
(2477, 51, 1373494379, 1902, 1, 13),
(2478, 106, 1373494383, 306, 1, 0),
(2479, 17, 1373494384, 760, 2, 7),
(2480, 45, 1373494442, 2666, 6, 19),
(2481, 75, 1373494442, 958, 1, 5),
(2482, 15, 1373494467, 283, 1, 4),
(2483, 68, 1373494542, 745, 2, 0),
(2484, 56, 1373494552, 495, 1, 4),
(2485, 59, 1373494562, 611, 1, 0),
(2486, 66, 1373494585, 768, 1, 3),
(2487, 24, 1373494604, 2375, 1, 11),
(2488, 55, 1373494647, 4393, 2, 26),
(2489, 12, 1373494657, 1208, 1, 10),
(2490, 52, 1373494667, 327, 1, 0),
(2491, 86, 1373494670, 2537, 1, 18),
(2492, 44, 1373494685, 2778, 1, 15),
(2493, 29, 1373494687, 2329, 2, 15),
(2494, 101, 1373494707, 1049, 1, 5),
(2495, 100, 1373494790, 15424, 7, 16),
(2496, 110, 1373494793, 663, 1, 3),
(2497, 80, 1373494809, 722, 1, 7),
(2498, 36, 1373494811, 3256, 4, 21),
(2499, 17, 1373494826, 442, 1, 1),
(2500, 106, 1373494832, 449, 1, 2),
(2501, 103, 1373494919, 15553, 3, 16),
(2502, 65, 1373494925, 2039, 5, 16),
(2503, 56, 1373494933, 26, 1, 0),
(2504, 85, 1373494953, 2002, 2, 12),
(2505, 30, 1373494963, 403, 1, 5),
(2506, 84, 1373494971, 1982, 2, 12),
(2507, 79, 1373494973, 1134, 1, 8),
(2508, 26, 1373495043, 4305, 4, 30),
(2509, 60, 1373495049, 2794, 5, 18),
(2510, 11, 1373495057, 677, 1, 7),
(2511, 64, 1373495106, 3300, 2, 24),
(2512, 34, 1373495133, 3738, 5, 34),
(2513, 32, 1373495139, 1018, 1, 5),
(2514, 30, 1373495150, 187, 1, 0),
(2515, 12, 1373495180, 523, 1, 8),
(2516, 49, 1373495227, 2950, 2, 19),
(2517, 69, 1373495227, 2941, 2, 8),
(2518, 63, 1373495246, 1284, 3, 10),
(2519, 72, 1373495252, 3819, 4, 21),
(2520, 68, 1373495259, 717, 1, 5),
(2521, 47, 1373495286, 1525, 4, 16),
(2522, 57, 1373495300, 1475, 2, 12),
(2523, 41, 1373495352, 3658, 8, 28),
(2524, 89, 1373495426, 1070, 2, 6),
(2525, 98, 1373495448, 1226, 2, 7),
(2526, 39, 1373495471, 1203, 2, 7),
(2527, 62, 1373495520, 1961, 1, 8),
(2528, 17, 1373495610, 603, 1, 1),
(2529, 14, 1373495671, 1077, 2, 7),
(2530, 95, 1373495747, 1689, 3, 12),
(2531, 86, 1373495767, 1097, 1, 3),
(2532, 41, 1373495813, 461, 1, 4),
(2533, 30, 1373495860, 710, 2, 2),
(2534, 24, 1373495873, 1269, 1, 6),
(2535, 25, 1373495924, 961, 1, 4),
(2536, 27, 1373495959, 2700, 2, 19),
(2537, 93, 1373495976, 2328, 4, 27),
(2538, 11, 1373495998, 341, 1, 2),
(2539, 13, 1373496015, 220, 1, 1),
(2540, 82, 1373496026, 3381, 3, 19),
(2541, 77, 1373496040, 1395, 1, 7),
(2542, 81, 1373496046, 1051, 1, 1),
(2543, 73, 1373496082, 3619, 2, 26),
(2544, 91, 1373496105, 127, 1, 1),
(2545, 31, 1373496110, 2576, 5, 22),
(2546, 45, 1373496122, 1680, 1, 12),
(2547, 28, 1373496157, 2572, 2, 16),
(2548, 69, 1373496188, 961, 1, 5),
(2549, 101, 1373496212, 1505, 1, 2),
(2550, 104, 1373496220, 3566, 8, 23),
(2551, 56, 1373496227, 813, 1, 6),
(2552, 15, 1373496249, 1144, 1, 4),
(2553, 62, 1373496259, 631, 1, 6),
(2554, 80, 1373496267, 1458, 2, 5),
(2555, 108, 1373496319, 16953, 3, 26),
(2556, 83, 1373496365, 711, 2, 1),
(2557, 80, 1373496389, 122, 1, 0),
(2558, 85, 1373496427, 1474, 1, 7),
(2559, 50, 1373496457, 1140, 1, 11),
(2560, 97, 1373496469, 913, 2, 8),
(2561, 37, 1373496470, 2329, 2, 24),
(2562, 35, 1373498634, 164, 1, 0),
(2563, 55, 1373498671, 200, 2, 2),
(2564, 73, 1373498784, 313, 2, 7),
(2565, 62, 1373498961, 179, 1, 1),
(2566, 49, 1373498964, 494, 1, 8),
(2567, 16, 1373498976, 507, 1, 5),
(2568, 59, 1373498981, 510, 1, 0),
(2569, 29, 1373498985, 342, 1, 4),
(2570, 36, 1373499003, 533, 2, 2),
(2571, 30, 1373499351, 238, 1, 3),
(2572, 101, 1373499375, 264, 1, 5),
(2573, 100, 1373499731, 157, 1, 0),
(2574, 70, 1373499770, 354, 1, 3),
(2575, 46, 1373499783, 492, 1, 8),
(2576, 63, 1373499884, 549, 1, 4),
(2577, 59, 1373499951, 757, 1, 4),
(2578, 15, 1373499954, 263, 1, 2),
(2579, 18, 1373499972, 381, 2, 5),
(2580, 79, 1373500077, 492, 2, 4),
(2581, 26, 1373500080, 597, 1, 5),
(2582, 68, 1373500111, 890, 1, 8),
(2583, 13, 1373500182, 423, 1, 3),
(2584, 82, 1373500194, 503, 1, 1),
(2585, 95, 1373500197, 868, 1, 11),
(2586, 77, 1373500208, 835, 1, 5),
(2587, 100, 1373500219, 488, 1, 6),
(2588, 70, 1373500227, 258, 1, 2),
(2589, 106, 1373500270, 788, 1, 3),
(2590, 51, 1373500274, 1040, 1, 9),
(2591, 78, 1373500303, 619, 2, 10),
(2592, 90, 1373500310, 890, 5, 5),
(2593, 12, 1373500341, 185, 1, 0),
(2594, 62, 1373500352, 503, 1, 7),
(2595, 68, 1373500366, 90, 1, 2),
(2596, 17, 1373500428, 379, 1, 3),
(2597, 81, 1373500439, 1029, 1, 5),
(2598, 52, 1373500440, 393, 1, 8),
(2599, 47, 1373500482, 538, 1, 3),
(2600, 63, 1373500579, 695, 2, 8),
(2601, 22, 1373500680, 700, 1, 5),
(2602, 60, 1373500681, 997, 1, 4),
(2603, 20, 1373500752, 518, 2, 9),
(2604, 14, 1373500775, 1122, 1, 16),
(2605, 16, 1373500831, 1601, 1, 11),
(2606, 75, 1373500839, 167, 1, 0),
(2607, 33, 1373500849, 836, 1, 11),
(2608, 102, 1373500859, 1466, 2, 12),
(2609, 89, 1373500861, 964, 1, 8),
(2610, 17, 1373500872, 444, 1, 3),
(2611, 23, 1373500899, 926, 1, 6),
(2612, 29, 1373500913, 58, 1, 3),
(2613, 74, 1373501067, 766, 1, 7),
(2614, 44, 1373501085, 1142, 2, 8),
(2615, 51, 1373501105, 831, 2, 7),
(2616, 19, 1373501166, 1694, 1, 14),
(2617, 32, 1373501186, 1263, 2, 5),
(2618, 98, 1373501192, 1076, 1, 0),
(2619, 86, 1373501196, 692, 4, 7),
(2620, 19, 1373501218, 52, 1, 0),
(2621, 56, 1373501279, 349, 1, 4),
(2622, 67, 1373501335, 1733, 1, 15),
(2623, 81, 1373501344, 676, 1, 5),
(2624, 26, 1373501399, 1319, 2, 19),
(2625, 33, 1373501429, 579, 1, 2),
(2626, 44, 1373501475, 211, 1, 1),
(2627, 18, 1373501487, 461, 1, 2),
(2628, 37, 1373501502, 677, 3, 11),
(2629, 68, 1373501522, 174, 1, 1),
(2630, 34, 1373501568, 1178, 1, 10),
(2631, 109, 1373501604, 470, 1, 3),
(2632, 65, 1373501626, 627, 1, 5),
(2633, 39, 1373501651, 1181, 2, 9),
(2634, 31, 1373501705, 1561, 2, 14),
(2635, 107, 1373501769, 771, 1, 4),
(2636, 72, 1373501777, 1033, 2, 6),
(2637, 71, 1373501853, 814, 4, 5),
(2638, 106, 1373501865, 1595, 2, 2),
(2639, 74, 1373501998, 931, 2, 2),
(2640, 29, 1373502038, 1125, 1, 8),
(2641, 63, 1373502060, 618, 2, 1),
(2642, 35, 1373502067, 2510, 1, 24),
(2643, 54, 1373502079, 1814, 4, 6),
(2644, 91, 1373502092, 942, 2, 5),
(2645, 89, 1373502095, 294, 1, 1),
(2646, 25, 1373502102, 1858, 3, 16),
(2647, 57, 1373502170, 2007, 1, 13),
(2648, 76, 1373502179, 301, 1, 2),
(2649, 81, 1373502193, 849, 1, 5),
(2650, 13, 1373502198, 1124, 1, 8),
(2651, 84, 1373502200, 1050, 1, 4),
(2652, 110, 1373502209, 465, 1, 4),
(2653, 95, 1373502226, 247, 1, 1),
(2654, 102, 1373502240, 1381, 3, 8),
(2655, 33, 1373502264, 596, 1, 6),
(2656, 27, 1373502267, 3041, 3, 27),
(2657, 51, 1373502277, 428, 2, 7),
(2658, 97, 1373502314, 190, 1, 1),
(2659, 15, 1373502322, 795, 1, 5),
(2660, 104, 1373502329, 524, 1, 3),
(2661, 107, 1373502355, 586, 1, 5),
(2662, 89, 1373502360, 265, 1, 1),
(2663, 47, 1373502373, 1891, 4, 19),
(2664, 72, 1373502375, 598, 1, 4),
(2665, 50, 1373502394, 3177, 6, 33),
(2666, 17, 1373502413, 1541, 3, 7),
(2667, 98, 1373502420, 1228, 4, 10),
(2668, 94, 1373502442, 3082, 7, 32),
(2669, 68, 1373502457, 128, 1, 3),
(2670, 55, 1373502472, 1222, 3, 12),
(2671, 109, 1373502481, 580, 1, 4),
(2672, 104, 1373502482, 153, 1, 5),
(2673, 96, 1373502501, 2408, 2, 14),
(2674, 82, 1373502515, 444, 1, 5),
(2675, 29, 1373502548, 510, 2, 7),
(2676, 110, 1373502553, 271, 1, 0),
(2677, 15, 1373502567, 245, 1, 0),
(2678, 85, 1373502627, 1804, 3, 15),
(2679, 87, 1373502635, 823, 1, 5),
(2680, 30, 1373502644, 3293, 7, 25),
(2681, 52, 1373502658, 1931, 1, 17),
(2682, 46, 1373502659, 2257, 6, 27),
(2683, 68, 1373502667, 185, 1, 3),
(2684, 78, 1373502671, 1288, 1, 13),
(2685, 23, 1373502701, 594, 2, 10),
(2686, 109, 1373502722, 241, 2, 2),
(2687, 32, 1373502798, 1102, 3, 20),
(2688, 26, 1373502812, 1413, 2, 14),
(2689, 74, 1373502812, 814, 1, 12),
(2690, 37, 1373502880, 656, 1, 7),
(2691, 86, 1373502928, 1731, 1, 14),
(2692, 25, 1373502975, 873, 4, 8),
(2693, 56, 1373502987, 504, 1, 16),
(2694, 51, 1373503022, 744, 4, 6),
(2695, 31, 1373503080, 1375, 4, 14),
(2696, 59, 1373503091, 1193, 3, 16),
(2697, 18, 1373503109, 811, 1, 5),
(2698, 34, 1373503114, 1546, 4, 12),
(2699, 61, 1373503127, 2250, 6, 31),
(2700, 35, 1373503183, 395, 1, 2),
(2701, 40, 1373503203, 1525, 4, 15),
(2702, 73, 1373503208, 2764, 3, 28),
(2703, 89, 1373503231, 871, 1, 8),
(2704, 13, 1373503281, 338, 1, 3),
(2705, 71, 1373503330, 167, 1, 3),
(2706, 68, 1373503349, 682, 1, 2),
(2707, 75, 1373503391, 803, 1, 10),
(2708, 49, 1373503446, 3148, 4, 38),
(2709, 16, 1373503450, 2079, 2, 10),
(2710, 19, 1373503510, 1688, 2, 9),
(2711, 106, 1373503632, 967, 1, 2),
(2712, 79, 1373503674, 2143, 2, 19),
(2713, 54, 1373503690, 1276, 1, 8),
(2714, 33, 1373503720, 1456, 1, 7),
(2715, 41, 1373503755, 4552, 4, 31),
(2716, 56, 1373503814, 827, 1, 3),
(2717, 74, 1373503833, 486, 1, 0),
(2718, 13, 1373503836, 555, 2, 1),
(2719, 94, 1373503838, 301, 1, 1),
(2720, 90, 1373503856, 1856, 1, 16),
(2721, 71, 1373503868, 538, 1, 2),
(2722, 22, 1373503902, 945, 1, 7),
(2723, 52, 1373503955, 1004, 2, 3),
(2724, 23, 1373504030, 1198, 2, 5),
(2725, 30, 1373504070, 1425, 2, 6),
(2726, 19, 1373504134, 529, 1, 5),
(2727, 29, 1373504153, 1011, 2, 5),
(2728, 88, 1373504167, 1789, 1, 9),
(2729, 41, 1373504168, 413, 2, 4),
(2730, 14, 1373504180, 977, 1, 6),
(2731, 82, 1373504182, 1540, 3, 5),
(2732, 107, 1373504186, 1831, 2, 14),
(2733, 63, 1373504190, 2130, 1, 27),
(2734, 91, 1373504190, 703, 1, 5),
(2735, 65, 1373504207, 2581, 2, 28),
(2736, 25, 1373504241, 327, 1, 2),
(2737, 77, 1373504271, 544, 1, 8),
(2738, 73, 1373504289, 1081, 1, 6),
(2739, 95, 1373504391, 659, 1, 4),
(2740, 59, 1373504433, 1342, 2, 7),
(2741, 28, 1373504450, 2829, 6, 20),
(2742, 43, 1373504455, 5348, 14, 53),
(2743, 22, 1373504497, 595, 1, 3),
(2744, 78, 1373504522, 1080, 1, 4),
(2745, 39, 1373504527, 2114, 2, 11),
(2746, 54, 1373504563, 415, 2, 2),
(2747, 29, 1373504571, 417, 1, 3),
(2748, 100, 1373504627, 4407, 1, 28),
(2749, 47, 1373504639, 2266, 3, 14),
(2750, 101, 1373504671, 5296, 9, 32),
(2751, 18, 1373504680, 331, 1, 3),
(2752, 80, 1373504698, 3976, 6, 20),
(2753, 97, 1373504709, 2332, 1, 14),
(2754, 35, 1373504719, 853, 1, 14),
(2755, 74, 1373504725, 892, 2, 4),
(2756, 49, 1373504759, 1313, 2, 14),
(2757, 67, 1373504773, 2623, 6, 28),
(2758, 15, 1373504798, 874, 2, 6),
(2759, 37, 1373504827, 285, 1, 4),
(2760, 72, 1373504868, 764, 1, 6),
(2761, 32, 1373504868, 1608, 2, 24),
(2762, 24, 1373504871, 2502, 2, 18),
(2763, 59, 1373504872, 439, 1, 6),
(2764, 52, 1373504882, 198, 1, 1),
(2765, 82, 1373504946, 547, 1, 3),
(2766, 62, 1373505014, 3020, 7, 30),
(2767, 83, 1373505067, 4051, 7, 32),
(2768, 35, 1373505073, 354, 1, 6),
(2769, 109, 1373505148, 1182, 1, 10),
(2770, 30, 1373505151, 1081, 1, 8),
(2771, 74, 1373505161, 436, 1, 5),
(2772, 85, 1373505169, 2542, 2, 16),
(2773, 54, 1373505170, 303, 2, 3),
(2774, 23, 1373505175, 1145, 2, 11),
(2775, 91, 1373505182, 881, 2, 4),
(2776, 17, 1373505219, 833, 2, 10),
(2777, 108, 1373505290, 2893, 3, 16),
(2778, 12, 1373505343, 837, 1, 4),
(2779, 46, 1373505437, 2778, 2, 26),
(2780, 96, 1373505446, 2945, 5, 19),
(2781, 38, 1373505470, 2174, 5, 15),
(2782, 58, 1373505528, 4014, 6, 27),
(2783, 23, 1373505541, 366, 1, 4),
(2784, 67, 1373505546, 773, 1, 8),
(2785, 95, 1373505569, 566, 1, 2),
(2786, 34, 1373505576, 2462, 2, 20),
(2787, 76, 1373505585, 1571, 1, 17),
(2788, 94, 1373505587, 1297, 2, 4),
(2789, 70, 1373505618, 4399, 10, 31),
(2790, 20, 1373505666, 4914, 5, 34),
(2791, 75, 1373505669, 1078, 1, 8),
(2792, 44, 1373505688, 535, 1, 6),
(2793, 17, 1373505703, 484, 1, 2),
(2794, 13, 1373505793, 191, 1, 0),
(2795, 26, 1373505822, 2108, 3, 15),
(2796, 33, 1373505853, 2133, 4, 23),
(2797, 91, 1373505859, 677, 3, 4),
(2798, 42, 1373505877, 1533, 2, 5),
(2799, 84, 1373505924, 2804, 1, 13),
(2800, 51, 1373505944, 922, 2, 5),
(2801, 78, 1373505944, 950, 2, 2),
(2802, 68, 1373505970, 2128, 4, 20),
(2803, 104, 1373506088, 1902, 2, 16),
(2804, 58, 1373506100, 572, 1, 3),
(2805, 11, 1373506104, 283, 1, 1),
(2806, 68, 1373506119, 149, 1, 1),
(2807, 71, 1373506137, 1152, 1, 5),
(2808, 88, 1373506149, 1981, 1, 12),
(2809, 25, 1373506167, 601, 1, 0),
(2810, 54, 1373506258, 800, 3, 12),
(2811, 50, 1373506267, 1043, 1, 18),
(2812, 44, 1373506281, 329, 2, 1),
(2813, 72, 1373506325, 1457, 2, 11),
(2814, 98, 1373506396, 2226, 1, 11),
(2815, 81, 1373506400, 2073, 1, 12),
(2816, 80, 1373506400, 1702, 1, 11),
(2817, 39, 1373506419, 1892, 1, 17),
(2818, 53, 1373506426, 439, 1, 1),
(2819, 17, 1373506428, 724, 2, 6),
(2820, 56, 1373506444, 883, 2, 8),
(2821, 15, 1373506451, 127, 1, 0),
(2822, 75, 1373506453, 784, 1, 5),
(2823, 42, 1373506460, 583, 1, 6),
(2824, 84, 1373506487, 306, 1, 1),
(2825, 78, 1373506501, 343, 3, 1),
(2826, 93, 1373506535, 4139, 2, 29),
(2827, 27, 1373506551, 3646, 7, 23),
(2828, 41, 1373506560, 1715, 3, 16),
(2829, 103, 1373506570, 6636, 5, 38),
(2830, 72, 1373506571, 245, 1, 4),
(2831, 65, 1373506576, 1754, 1, 20),
(2832, 107, 1373506658, 1130, 1, 3),
(2833, 79, 1373506662, 1041, 1, 9),
(2834, 34, 1373506726, 1150, 2, 11),
(2835, 37, 1373506737, 1910, 4, 26),
(2836, 82, 1373506761, 1815, 1, 17),
(2837, 21, 1373506795, 6563, 5, 42),
(2838, 53, 1373506807, 381, 1, 6),
(2839, 104, 1373506809, 699, 1, 4),
(2840, 52, 1373506831, 517, 3, 8),
(2841, 58, 1373506834, 734, 1, 18),
(2842, 96, 1373506845, 1399, 2, 6),
(2843, 88, 1373506854, 705, 1, 3),
(2844, 57, 1373506858, 4688, 8, 45),
(2845, 30, 1373506858, 776, 1, 9),
(2846, 90, 1373506864, 2965, 2, 20),
(2847, 86, 1373506864, 3936, 3, 29),
(2848, 44, 1373506884, 446, 3, 3),
(2849, 47, 1373506895, 2256, 5, 28),
(2850, 43, 1373506915, 1654, 2, 11),
(2851, 46, 1373506931, 1494, 2, 17),
(2852, 11, 1373506949, 351, 2, 8),
(2853, 67, 1373506952, 1406, 2, 8),
(2854, 16, 1373507013, 1038, 1, 9),
(2855, 106, 1373507039, 565, 1, 3),
(2856, 70, 1373507044, 1256, 3, 18),
(2857, 79, 1373507057, 377, 1, 3),
(2858, 75, 1373507116, 663, 1, 4),
(2859, 35, 1373507142, 1755, 1, 17),
(2860, 32, 1373507155, 1189, 4, 5),
(2861, 55, 1373507263, 4791, 6, 39),
(2862, 63, 1373507281, 3091, 6, 34),
(2863, 57, 1373507329, 471, 1, 4),
(2864, 74, 1373507331, 1087, 1, 11),
(2865, 102, 1373507368, 5128, 6, 30),
(2866, 92, 1373507378, 8259, 13, 54),
(2867, 23, 1373507395, 1854, 2, 15),
(2868, 56, 1373507399, 623, 1, 4),
(2869, 13, 1373507404, 1413, 2, 9),
(2870, 15, 1373507408, 956, 2, 17),
(2871, 22, 1373507423, 161, 1, 1),
(2872, 24, 1373507450, 2579, 5, 24),
(2873, 61, 1373507500, 1916, 3, 15),
(2874, 68, 1373507548, 642, 1, 6),
(2875, 50, 1373507582, 581, 1, 2),
(2876, 87, 1373507603, 4818, 7, 28),
(2877, 73, 1373507609, 3320, 6, 21),
(2878, 83, 1373507615, 2548, 3, 20),
(2879, 22, 1373509551, 127, 1, 0),
(2880, 44, 1373509576, 151, 1, 1),
(2881, 13, 1373509582, 158, 1, 1),
(2882, 56, 1373509597, 172, 1, 0),
(2883, 57, 1373509708, 283, 1, 4),
(2884, 41, 1373509823, 298, 2, 2),
(2885, 50, 1373509827, 402, 2, 3),
(2886, 35, 1373509870, 445, 1, 4),
(2887, 53, 1373509882, 457, 1, 1),
(2888, 32, 1373509896, 472, 1, 3),
(2889, 29, 1373509974, 550, 3, 6),
(2890, 34, 1373510016, 591, 3, 3),
(2891, 15, 1373510022, 398, 1, 3),
(2892, 68, 1373510187, 761, 1, 1),
(2893, 25, 1373510221, 703, 1, 5),
(2894, 71, 1373510230, 804, 1, 1),
(2895, 48, 1373510255, 830, 2, 6),
(2896, 63, 1373510282, 856, 2, 6),
(2897, 33, 1373510345, 921, 7, 10),
(2898, 12, 1373510377, 109, 1, 0),
(2899, 66, 1373510377, 951, 3, 2),
(2900, 22, 1373510420, 765, 2, 7),
(2901, 67, 1373510421, 270, 1, 0),
(2902, 17, 1373510426, 101, 1, 0),
(2903, 16, 1373510482, 615, 1, 2),
(2904, 68, 1373510494, 307, 1, 0),
(2905, 33, 1373510557, 212, 1, 2),
(2906, 39, 1373510567, 959, 1, 7),
(2907, 42, 1373510570, 648, 1, 2),
(2908, 31, 1373510610, 1186, 1, 14),
(2909, 19, 1373510646, 931, 1, 7),
(2910, 37, 1373510656, 1231, 2, 12),
(2911, 27, 1373510698, 1214, 1, 2),
(2912, 54, 1373510705, 820, 1, 7),
(2913, 56, 1373510757, 576, 1, 5),
(2914, 59, 1373510950, 1525, 1, 10),
(2915, 54, 1373510998, 293, 1, 0),
(2916, 13, 1373511002, 896, 1, 6),
(2917, 63, 1373511010, 728, 1, 2),
(2918, 55, 1373511050, 1625, 4, 13),
(2919, 77, 1373511056, 495, 1, 2),
(2920, 30, 1373511069, 1482, 4, 14),
(2921, 41, 1373511210, 989, 1, 4),
(2922, 19, 1373511217, 369, 1, 3),
(2923, 14, 1373511240, 1816, 1, 9),
(2924, 49, 1373511339, 1914, 6, 11),
(2925, 78, 1373511346, 523, 1, 5),
(2926, 68, 1373511353, 859, 1, 5),
(2927, 52, 1373511353, 839, 1, 6),
(2928, 84, 1373511406, 1980, 1, 2),
(2929, 74, 1373511420, 881, 1, 5),
(2930, 50, 1373511447, 1620, 3, 10),
(2931, 81, 1373511464, 363, 1, 2),
(2932, 73, 1373511466, 2040, 2, 12),
(2933, 34, 1373511470, 1454, 2, 16),
(2934, 51, 1373511480, 2055, 3, 16),
(2935, 29, 1373511488, 1514, 3, 10),
(2936, 67, 1373511490, 1069, 3, 8),
(2937, 57, 1373511588, 1880, 1, 12),
(2938, 50, 1373511625, 178, 1, 1),
(2939, 70, 1373511636, 748, 1, 6),
(2940, 55, 1373511644, 594, 1, 2),
(2941, 14, 1373511668, 428, 1, 4),
(2942, 64, 1373511684, 1876, 1, 13),
(2943, 72, 1373511728, 2302, 2, 10),
(2944, 110, 1373511860, 2433, 1, 2),
(2945, 26, 1373511890, 2124, 3, 28);
INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(2946, 54, 1373511945, 217, 1, 2),
(2947, 11, 1373511977, 2553, 2, 12),
(2948, 47, 1373512001, 924, 1, 5),
(2949, 43, 1373512001, 2411, 1, 26),
(2950, 60, 1373512027, 1956, 2, 15),
(2951, 30, 1373512036, 967, 1, 12),
(2952, 13, 1373512038, 345, 1, 3),
(2953, 38, 1373512076, 2651, 2, 21),
(2954, 42, 1373512086, 1516, 3, 7),
(2955, 35, 1373512095, 2154, 4, 21),
(2956, 16, 1373512132, 1172, 2, 9),
(2957, 44, 1373512203, 953, 1, 10),
(2958, 93, 1373512207, 748, 1, 8),
(2959, 84, 1373512207, 203, 1, 0),
(2960, 78, 1373512220, 874, 1, 1),
(2961, 62, 1373512224, 1120, 3, 8),
(2962, 27, 1373512294, 914, 1, 10),
(2963, 31, 1373512361, 1751, 2, 11),
(2964, 13, 1373512377, 339, 1, 1),
(2965, 56, 1373512389, 434, 2, 8),
(2966, 100, 1373512432, 3005, 1, 10),
(2967, 36, 1373512437, 2287, 2, 10),
(2968, 49, 1373512463, 1124, 3, 9),
(2969, 85, 1373512498, 3072, 3, 11),
(2970, 88, 1373512503, 3077, 3, 15),
(2971, 55, 1373512526, 882, 2, 12),
(2972, 54, 1373512532, 587, 2, 5),
(2973, 91, 1373512602, 3176, 3, 7),
(2974, 69, 1373512690, 3264, 2, 18),
(2975, 95, 1373512760, 658, 1, 1),
(2976, 28, 1373512764, 3057, 7, 25),
(2977, 101, 1373512775, 3348, 1, 7),
(2978, 22, 1373512777, 288, 1, 1),
(2979, 57, 1373512794, 1086, 2, 4),
(2980, 71, 1373512864, 691, 1, 2),
(2981, 84, 1373512893, 686, 3, 1),
(2982, 60, 1373512920, 893, 1, 10),
(2983, 29, 1373512937, 929, 2, 5),
(2984, 30, 1373513002, 966, 2, 6),
(2985, 70, 1373513068, 705, 1, 3),
(2986, 24, 1373513084, 3660, 3, 21),
(2987, 68, 1373513115, 315, 1, 1),
(2988, 51, 1373513118, 1638, 1, 14),
(2989, 19, 1373513139, 977, 1, 6),
(2990, 66, 1373513145, 2279, 4, 18),
(2991, 17, 1373513149, 2723, 4, 19),
(2992, 87, 1373513154, 1887, 1, 15),
(2993, 81, 1373513164, 1700, 3, 7),
(2994, 64, 1373513172, 1488, 2, 14),
(2995, 63, 1373513230, 2220, 3, 11),
(2996, 28, 1373513236, 471, 2, 1),
(2997, 94, 1373513240, 2039, 1, 6),
(2998, 79, 1373513250, 309, 1, 1),
(2999, 23, 1373513257, 3034, 6, 22),
(3000, 52, 1373513356, 446, 2, 5),
(3001, 69, 1373513387, 697, 1, 2),
(3002, 67, 1373513392, 1902, 1, 18),
(3003, 65, 1373513413, 2512, 3, 23),
(3004, 55, 1373513427, 901, 1, 6),
(3005, 96, 1373513441, 4014, 2, 16),
(3006, 45, 1373513474, 4049, 6, 31),
(3007, 13, 1373513517, 820, 1, 7),
(3008, 76, 1373513521, 712, 1, 1),
(3009, 58, 1373513554, 4129, 10, 22),
(3010, 56, 1373513582, 1001, 1, 7),
(3011, 29, 1373513597, 660, 6, 7),
(3012, 99, 1373513617, 4190, 5, 12),
(3013, 77, 1373513624, 1428, 1, 5),
(3014, 74, 1373513629, 1301, 3, 12),
(3015, 82, 1373513644, 966, 3, 9),
(3016, 41, 1373513680, 2470, 4, 20),
(3017, 70, 1373513707, 554, 1, 6),
(3018, 101, 1373513710, 605, 2, 7),
(3019, 61, 1373513742, 2240, 3, 18),
(3020, 62, 1373513746, 1522, 1, 10),
(3021, 20, 1373513746, 2724, 9, 25),
(3022, 30, 1373513747, 745, 1, 9),
(3023, 43, 1373513757, 1279, 2, 10),
(3024, 98, 1373513772, 187, 1, 0),
(3025, 49, 1373513787, 914, 1, 7),
(3026, 36, 1373513801, 1364, 1, 7),
(3027, 31, 1373513801, 1440, 3, 11),
(3028, 104, 1373513823, 1664, 4, 8),
(3029, 105, 1373513830, 4403, 2, 19),
(3030, 64, 1373513855, 683, 1, 5),
(3031, 57, 1373513863, 1069, 3, 10),
(3032, 38, 1373513875, 1096, 1, 13),
(3033, 90, 1373513897, 2029, 5, 18),
(3034, 40, 1373513916, 3332, 3, 18),
(3035, 68, 1373513956, 841, 1, 5),
(3036, 102, 1373513980, 4553, 1, 17),
(3037, 12, 1373514003, 1841, 3, 13),
(3038, 34, 1373514092, 2140, 3, 22),
(3039, 88, 1373514104, 1499, 5, 16),
(3040, 86, 1373514141, 4715, 4, 27),
(3041, 23, 1373514262, 1005, 1, 7),
(3042, 34, 1373514277, 185, 1, 0),
(3043, 27, 1373514340, 1099, 3, 7),
(3044, 73, 1373514392, 2926, 1, 14),
(3045, 32, 1373514398, 4239, 5, 38),
(3046, 15, 1373514426, 3174, 4, 21),
(3047, 108, 1373514443, 5016, 2, 15),
(3048, 42, 1373514458, 968, 2, 7),
(3049, 46, 1373514498, 3810, 5, 30),
(3050, 67, 1373514524, 1132, 3, 11),
(3051, 26, 1373514613, 2505, 4, 27),
(3052, 29, 1373514626, 1029, 1, 10),
(3053, 16, 1373514631, 654, 1, 1),
(3054, 11, 1373514682, 631, 1, 3),
(3055, 13, 1373514682, 102, 1, 0),
(3056, 80, 1373514724, 1773, 2, 18),
(3057, 47, 1373514728, 2054, 3, 21),
(3058, 30, 1373514814, 709, 1, 4),
(3059, 87, 1373514825, 1645, 2, 21),
(3060, 85, 1373514841, 2343, 1, 15),
(3061, 33, 1373514848, 2014, 1, 14),
(3062, 76, 1373514866, 1101, 1, 3),
(3063, 21, 1373514889, 5465, 12, 32),
(3064, 19, 1373514895, 1756, 1, 9),
(3065, 69, 1373514939, 1118, 2, 12),
(3066, 35, 1373514942, 2057, 3, 16),
(3067, 53, 1373514949, 5067, 7, 41),
(3068, 66, 1373514966, 1679, 5, 20),
(3069, 36, 1373515037, 1236, 2, 11),
(3070, 14, 1373515093, 2826, 2, 23),
(3071, 67, 1373515194, 670, 1, 3),
(3072, 29, 1373515211, 585, 2, 2),
(3073, 77, 1373515215, 1591, 3, 13),
(3074, 13, 1373515219, 537, 1, 1),
(3075, 53, 1373515226, 277, 1, 3),
(3076, 18, 1373515249, 5706, 6, 24),
(3077, 92, 1373515288, 5861, 5, 29),
(3078, 22, 1373515335, 1469, 2, 5),
(3079, 37, 1373515344, 4688, 7, 28),
(3080, 31, 1373515404, 1603, 1, 14),
(3081, 65, 1373515413, 947, 4, 6),
(3082, 56, 1373515532, 1114, 2, 6),
(3083, 81, 1373515545, 2381, 2, 13),
(3084, 72, 1373515573, 3635, 3, 18),
(3085, 83, 1373515578, 6152, 11, 31),
(3086, 59, 1373515589, 3221, 3, 24),
(3087, 57, 1373515647, 1784, 1, 12),
(3088, 61, 1373515698, 1956, 1, 18),
(3089, 87, 1373515763, 938, 1, 3),
(3090, 46, 1373515821, 1323, 3, 11),
(3091, 58, 1373515866, 2312, 3, 11),
(3092, 43, 1373515883, 2126, 5, 13),
(3093, 51, 1373516015, 2897, 3, 36),
(3094, 64, 1373516112, 1435, 2, 9),
(3095, 30, 1373516226, 1048, 1, 0),
(3096, 24, 1373516374, 1313, 1, 0),
(3097, 63, 1373516382, 1835, 3, 9),
(3098, 44, 1373516689, 2936, 5, 18),
(3099, 22, 1373516695, 1108, 1, 4),
(3100, 11, 1373516875, 2148, 1, 3),
(3101, 40, 1373516996, 3080, 5, 18),
(3102, 12, 1373517221, 738, 1, 3),
(3103, 42, 1373517352, 235, 1, 0),
(3104, 41, 1373517353, 3673, 5, 20),
(3105, 31, 1373517436, 2031, 1, 3),
(3106, 21, 1373517535, 2646, 1, 3),
(3107, 14, 1373517567, 426, 1, 1),
(3108, 55, 1373517569, 3593, 1, 11),
(3109, 49, 1373517593, 3805, 5, 28),
(3110, 17, 1373517598, 2303, 4, 5),
(3111, 23, 1373517705, 2384, 1, 2),
(3112, 26, 1373517714, 2759, 3, 10),
(3113, 40, 1373517813, 816, 2, 1),
(3114, 52, 1373517873, 2866, 1, 1),
(3115, 38, 1373517900, 4025, 6, 19),
(3116, 28, 1373517928, 4692, 3, 34),
(3117, 18, 1373517933, 2684, 4, 9),
(3118, 14, 1373517988, 421, 1, 3),
(3119, 73, 1373518027, 3634, 1, 15),
(3120, 20, 1373518060, 4313, 3, 13),
(3121, 34, 1373518126, 727, 3, 5),
(3122, 32, 1373518161, 210, 1, 1),
(3123, 13, 1373518194, 2975, 3, 15),
(3124, 45, 1373518195, 4721, 2, 7),
(3125, 39, 1373518200, 7633, 3, 6),
(3126, 40, 1373518217, 404, 1, 6),
(3127, 41, 1373518253, 489, 1, 3),
(3128, 49, 1373518335, 497, 2, 6),
(3129, 44, 1373518361, 304, 1, 1),
(3130, 16, 1373518421, 449, 1, 2),
(3131, 29, 1373518469, 1600, 1, 7),
(3132, 32, 1373518486, 325, 2, 0),
(3133, 21, 1373518580, 1045, 2, 10),
(3134, 63, 1373518593, 2211, 1, 1),
(3135, 24, 1373518617, 2243, 1, 7),
(3136, 56, 1373518627, 3095, 3, 15),
(3137, 55, 1373518632, 94, 1, 0),
(3138, 43, 1373518684, 2801, 1, 5),
(3139, 62, 1373518730, 3818, 2, 2),
(3140, 36, 1373518759, 3722, 2, 15),
(3141, 16, 1373518772, 189, 1, 1),
(3142, 33, 1373518911, 843, 1, 6),
(3143, 48, 1373518925, 7761, 12, 36),
(3144, 51, 1373518961, 2946, 2, 15),
(3145, 60, 1373518999, 616, 1, 3),
(3146, 22, 1373519005, 1047, 4, 10),
(3147, 68, 1373519045, 559, 2, 5),
(3148, 17, 1373519045, 1064, 2, 9),
(3149, 50, 1373519066, 7217, 13, 54),
(3150, 11, 1373519094, 424, 1, 3),
(3151, 34, 1373519107, 981, 3, 9),
(3152, 56, 1373519116, 489, 1, 5),
(3153, 46, 1373519127, 3306, 5, 14),
(3154, 75, 1373519137, 5406, 1, 5),
(3155, 59, 1373519150, 449, 1, 7),
(3156, 23, 1373519151, 1445, 7, 10),
(3157, 37, 1373519170, 3826, 4, 21),
(3158, 78, 1373519174, 5323, 1, 3),
(3159, 52, 1373519227, 726, 1, 5),
(3160, 69, 1373519241, 349, 1, 4),
(3161, 32, 1373519268, 782, 2, 10),
(3162, 70, 1373519307, 847, 1, 11),
(3163, 36, 1373519384, 625, 4, 2),
(3164, 77, 1373519394, 4179, 1, 3),
(3165, 79, 1373519421, 5863, 1, 5),
(3166, 65, 1373519489, 177, 1, 1),
(3167, 74, 1373519507, 771, 2, 17),
(3168, 62, 1373519599, 458, 2, 4),
(3169, 52, 1373519658, 282, 1, 1),
(3170, 57, 1373519727, 1562, 4, 11),
(3171, 44, 1373519730, 1369, 2, 13),
(3172, 19, 1373519830, 3825, 6, 22),
(3173, 21, 1373519835, 889, 2, 6),
(3174, 18, 1373519861, 1928, 3, 9),
(3175, 50, 1373519900, 834, 1, 5),
(3176, 80, 1373519905, 5181, 1, 8),
(3177, 33, 1373520067, 1156, 2, 6),
(3178, 20, 1373520078, 1920, 1, 12),
(3179, 84, 1373520092, 6577, 1, 5),
(3180, 72, 1373520113, 1471, 1, 19),
(3181, 68, 1373520120, 1075, 2, 11),
(3182, 71, 1373520130, 1831, 6, 22),
(3183, 14, 1373520158, 572, 1, 2),
(3184, 30, 1373520173, 1127, 1, 5),
(3185, 75, 1373520180, 1043, 1, 7),
(3186, 40, 1373520185, 1836, 3, 12),
(3187, 34, 1373520212, 1104, 1, 13),
(3188, 24, 1373520215, 1226, 1, 8),
(3189, 37, 1373520239, 402, 1, 4),
(3190, 41, 1373520288, 2035, 2, 10),
(3191, 63, 1373520294, 1701, 1, 17),
(3192, 27, 1373520376, 4017, 4, 25),
(3193, 11, 1373520410, 1316, 4, 10),
(3194, 66, 1373520422, 1423, 1, 11),
(3195, 54, 1373520583, 6862, 10, 44),
(3196, 31, 1373520614, 1710, 1, 7),
(3197, 44, 1373520640, 910, 2, 5),
(3198, 16, 1373520753, 523, 1, 3),
(3199, 47, 1373520870, 6142, 2, 24),
(3200, 88, 1373520926, 5765, 1, 9),
(3201, 29, 1373521019, 2550, 1, 16),
(3202, 23, 1373521031, 1880, 6, 12),
(3203, 84, 1373521053, 961, 2, 3),
(3204, 51, 1373521063, 1553, 3, 7),
(3205, 17, 1373521072, 729, 2, 4),
(3206, 49, 1373521155, 1882, 3, 8),
(3207, 25, 1373521162, 10941, 2, 8),
(3208, 27, 1373521184, 808, 2, 2),
(3209, 62, 1373521279, 1679, 2, 9),
(3210, 59, 1373521538, 2388, 5, 23),
(3211, 30, 1373521653, 1480, 3, 6),
(3212, 80, 1373521675, 1770, 2, 3),
(3213, 58, 1373521746, 5880, 2, 24),
(3214, 53, 1373521770, 2695, 5, 13),
(3215, 28, 1373521792, 3863, 3, 22),
(3216, 88, 1373521795, 868, 1, 4),
(3217, 31, 1373521807, 1193, 1, 2),
(3218, 67, 1373521814, 6620, 5, 23),
(3219, 46, 1373521935, 2609, 2, 12),
(3220, 32, 1373522028, 2539, 2, 12),
(3221, 39, 1373522036, 3544, 5, 28),
(3222, 72, 1373522065, 1106, 1, 3),
(3223, 65, 1373522085, 2437, 1, 6),
(3224, 36, 1373522124, 2740, 1, 9),
(3225, 19, 1373522185, 2355, 2, 14),
(3226, 75, 1373522243, 1609, 1, 1),
(3227, 61, 1373522260, 2723, 5, 20),
(3228, 14, 1373522355, 1110, 1, 6),
(3229, 83, 1373522424, 2187, 2, 10),
(3230, 69, 1373522456, 1370, 2, 1),
(3231, 79, 1373522466, 1922, 1, 2),
(3232, 33, 1373522577, 2083, 1, 14),
(3233, 87, 1373522600, 6837, 2, 14),
(3234, 21, 1373522742, 2907, 3, 8),
(3235, 43, 1373522745, 4061, 5, 21),
(3236, 30, 1373522787, 1133, 3, 9),
(3237, 73, 1373522805, 4067, 6, 27),
(3238, 61, 1373522856, 596, 1, 2),
(3239, 53, 1373522899, 1129, 2, 5),
(3240, 50, 1373522903, 3003, 3, 15),
(3241, 78, 1373522946, 1049, 1, 4),
(3242, 59, 1373523025, 1487, 1, 3),
(3243, 22, 1373523107, 4101, 10, 32),
(3244, 60, 1373523161, 4162, 6, 16),
(3245, 20, 1373523197, 988, 2, 7),
(3246, 40, 1373523214, 2605, 3, 6),
(3247, 13, 1373523221, 1921, 1, 5),
(3248, 39, 1373523224, 702, 3, 2),
(3249, 30, 1373523315, 528, 1, 4),
(3250, 58, 1373523494, 1748, 1, 6),
(3251, 57, 1373523566, 1517, 1, 5),
(3252, 12, 1373523632, 773, 1, 2),
(3253, 45, 1373523641, 3879, 3, 24),
(3254, 64, 1373523668, 5505, 1, 5),
(3255, 42, 1373523672, 6320, 12, 42),
(3256, 33, 1373523676, 1099, 1, 4),
(3257, 38, 1373523752, 5852, 7, 51),
(3258, 56, 1373523753, 4206, 2, 41),
(3259, 66, 1373523799, 1371, 1, 4),
(3260, 48, 1373523848, 4922, 8, 25),
(3261, 51, 1373523851, 2788, 1, 12),
(3262, 37, 1373523853, 1967, 1, 8),
(3263, 41, 1373523878, 3590, 2, 25),
(3264, 44, 1373523891, 3251, 3, 7),
(3265, 49, 1373523901, 2746, 3, 14),
(3266, 21, 1373523950, 1208, 1, 4),
(3267, 47, 1373523989, 3119, 3, 11),
(3268, 67, 1373524017, 2203, 1, 10),
(3269, 23, 1373524056, 3025, 3, 22),
(3270, 43, 1373524127, 1382, 1, 11),
(3271, 39, 1373524159, 935, 2, 0),
(3272, 23, 1373524281, 225, 1, 0),
(3273, 52, 1373524361, 1802, 3, 8),
(3274, 16, 1373524362, 813, 2, 3),
(3275, 18, 1373524385, 4340, 4, 28),
(3276, 22, 1373524423, 926, 1, 6),
(3277, 17, 1373524431, 1971, 4, 16),
(3278, 48, 1373524447, 599, 2, 1),
(3279, 28, 1373524455, 2663, 3, 9),
(3280, 19, 1373524479, 708, 2, 6),
(3281, 32, 1373524488, 2460, 4, 21),
(3282, 59, 1373524531, 1506, 1, 2),
(3283, 31, 1373524548, 1136, 2, 7),
(3284, 54, 1373524610, 4027, 2, 13),
(3285, 36, 1373524750, 1717, 3, 5),
(3286, 19, 1373524996, 517, 2, 3),
(3287, 27, 1373525012, 3827, 9, 29),
(3288, 17, 1373525050, 619, 1, 4),
(3289, 25, 1373525063, 3901, 8, 24),
(3290, 30, 1373525065, 1750, 1, 14),
(3291, 24, 1373525170, 4954, 5, 23),
(3292, 23, 1373525188, 907, 1, 6),
(3293, 54, 1373525263, 653, 1, 2),
(3294, 43, 1373525270, 743, 2, 4),
(3295, 32, 1373525296, 582, 1, 3),
(3296, 51, 1373525303, 1452, 1, 5),
(3297, 28, 1373525482, 1027, 2, 9),
(3298, 47, 1373525485, 1496, 2, 9),
(3299, 40, 1373525525, 990, 3, 4),
(3300, 34, 1373525547, 5055, 12, 32),
(3301, 31, 1373525565, 983, 1, 6),
(3302, 20, 1373525648, 2108, 3, 11),
(3303, 21, 1373525665, 1247, 2, 7),
(3304, 37, 1373525671, 1755, 3, 9),
(3305, 49, 1373525672, 1771, 1, 4),
(3306, 45, 1373525747, 2106, 3, 9),
(3307, 17, 1373525755, 495, 1, 2),
(3308, 41, 1373525760, 1834, 3, 15),
(3309, 36, 1373525859, 1109, 1, 6),
(3310, 13, 1373525903, 1100, 2, 2),
(3311, 16, 1373526047, 593, 1, 3),
(3312, 45, 1373526053, 306, 1, 1),
(3313, 29, 1373526070, 5051, 2, 31),
(3314, 12, 1373526105, 809, 1, 1),
(3315, 30, 1373526164, 1099, 1, 2),
(3316, 41, 1373526186, 426, 1, 0),
(3317, 38, 1373526225, 1711, 1, 10),
(3318, 19, 1373526357, 1361, 2, 3),
(3319, 48, 1373526385, 1938, 1, 6),
(3320, 52, 1373526409, 731, 1, 5),
(3321, 42, 1373526490, 2818, 6, 16),
(3322, 24, 1373526545, 1375, 2, 6),
(3323, 44, 1373526563, 2672, 3, 14),
(3324, 67, 1373526570, 2552, 1, 8),
(3325, 68, 1373526575, 552, 3, 6),
(3326, 62, 1373526576, 697, 1, 3),
(3327, 51, 1373526587, 718, 1, 6),
(3328, 59, 1373526595, 1165, 2, 7),
(3329, 21, 1373526635, 970, 3, 7),
(3330, 65, 1373526640, 598, 1, 5),
(3331, 41, 1373526709, 523, 1, 0),
(3332, 18, 1373526741, 2356, 1, 15),
(3333, 66, 1373526820, 603, 1, 0),
(3334, 17, 1373526939, 1184, 2, 6),
(3335, 16, 1373526963, 916, 5, 4),
(3336, 47, 1373526997, 1512, 2, 7),
(3337, 57, 1373527011, 3445, 1, 14),
(3338, 29, 1373527054, 839, 1, 5),
(3339, 11, 1373527069, 895, 2, 2),
(3340, 70, 1373527083, 988, 1, 4),
(3341, 23, 1373527169, 1981, 2, 14),
(3342, 38, 1373527174, 846, 1, 5),
(3343, 34, 1373527195, 1648, 4, 13),
(3344, 54, 1373527218, 1082, 2, 8),
(3345, 65, 1373527258, 618, 1, 4),
(3346, 61, 1373527268, 4114, 1, 10),
(3347, 53, 1373527341, 1630, 2, 10),
(3348, 27, 1373527383, 1589, 1, 9),
(3349, 52, 1373527387, 978, 1, 4),
(3350, 41, 1373527405, 265, 1, 3),
(3351, 25, 1373527483, 2420, 2, 12),
(3352, 28, 1373527485, 2003, 3, 19),
(3353, 64, 1373527505, 3837, 3, 14),
(3354, 45, 1373527597, 1543, 1, 9),
(3355, 34, 1373527629, 369, 2, 1),
(3356, 75, 1373527632, 5264, 1, 4),
(3357, 39, 1373527646, 2548, 5, 18),
(3358, 72, 1373527739, 856, 1, 9),
(3359, 66, 1373527766, 946, 3, 9),
(3360, 33, 1373527815, 4139, 8, 29),
(3361, 12, 1373527902, 421, 1, 1),
(3362, 67, 1373527904, 1334, 1, 9),
(3363, 16, 1373527922, 278, 2, 1),
(3364, 60, 1373528034, 4873, 2, 13),
(3365, 59, 1373528082, 1487, 1, 8),
(3366, 17, 1373528191, 1252, 1, 16),
(3367, 36, 1373528211, 1621, 1, 15),
(3368, 31, 1373528231, 2666, 4, 16),
(3369, 19, 1373528241, 1574, 2, 6),
(3370, 25, 1373528269, 786, 4, 3),
(3371, 39, 1373528306, 660, 1, 2),
(3372, 20, 1373528312, 2464, 5, 16),
(3373, 50, 1373528329, 5426, 6, 23),
(3374, 40, 1373528382, 2191, 3, 17),
(3375, 69, 1373528445, 5746, 3, 20),
(3376, 18, 1373528466, 1725, 1, 8),
(3377, 71, 1373528565, 2304, 5, 15),
(3378, 63, 1373528607, 5256, 3, 12),
(3379, 42, 1373528620, 2130, 1, 0),
(3380, 37, 1373528663, 2992, 1, 27),
(3381, 39, 1373528672, 365, 2, 2),
(3382, 13, 1373528787, 220, 2, 1),
(3383, 25, 1373528830, 559, 1, 8),
(3384, 37, 1373528888, 223, 1, 2),
(3385, 62, 1373528893, 1718, 3, 12),
(3386, 22, 1373528895, 1923, 3, 18),
(3387, 50, 1373528918, 252, 1, 1),
(3388, 51, 1373528919, 2251, 2, 16),
(3389, 30, 1373528936, 2772, 4, 17),
(3390, 19, 1373528949, 707, 2, 4),
(3391, 32, 1373528953, 3657, 9, 21),
(3392, 49, 1373528990, 828, 1, 4),
(3393, 55, 1373529004, 1995, 1, 1),
(3394, 23, 1373529008, 424, 2, 4),
(3395, 43, 1373529052, 234, 1, 7),
(3396, 36, 1373529054, 841, 1, 3),
(3397, 56, 1373529094, 1941, 1, 2),
(3398, 54, 1373529100, 1882, 2, 3),
(3399, 49, 1373529108, 118, 1, 1),
(3400, 41, 1373529112, 1707, 2, 6),
(3401, 31, 1373529143, 911, 3, 7),
(3402, 20, 1373529223, 195, 1, 1),
(3403, 21, 1373529354, 1857, 5, 21),
(3404, 51, 1373529491, 571, 1, 2),
(3405, 17, 1373529586, 1394, 1, 12),
(3406, 38, 1373529761, 2586, 3, 27),
(3407, 16, 1373529792, 1151, 2, 10),
(3408, 46, 1373529800, 7103, 14, 39),
(3409, 26, 1373529878, 8142, 18, 74),
(3410, 72, 1373529918, 2179, 1, 1),
(3411, 30, 1373529946, 1009, 1, 7),
(3412, 24, 1373530041, 2622, 4, 21),
(3413, 25, 1373530053, 1222, 3, 7),
(3414, 20, 1373530145, 573, 1, 1),
(3415, 66, 1373530156, 2390, 2, 6),
(3416, 45, 1373530202, 2111, 1, 14),
(3417, 61, 1373530209, 2434, 3, 17),
(3418, 18, 1373530262, 318, 1, 0),
(3419, 58, 1373530389, 1347, 2, 20),
(3420, 55, 1373530421, 968, 1, 0),
(3421, 31, 1373530485, 1342, 2, 5),
(3422, 63, 1373530516, 1909, 7, 18),
(3423, 40, 1373530521, 1873, 2, 14),
(3424, 60, 1373530532, 2246, 3, 19),
(3425, 68, 1373530542, 2431, 1, 18),
(3426, 45, 1373530564, 361, 1, 2),
(3427, 27, 1373530569, 635, 1, 5),
(3428, 31, 1373530597, 112, 1, 1),
(3429, 22, 1373530610, 1546, 2, 7),
(3430, 32, 1373530625, 1671, 2, 8),
(3431, 35, 1373530667, 12534, 16, 46),
(3432, 76, 1373530688, 656, 1, 4),
(3433, 60, 1373530710, 178, 1, 2),
(3434, 23, 1373530720, 1712, 1, 7),
(3435, 13, 1373530737, 571, 1, 4),
(3436, 54, 1373530766, 1666, 2, 13),
(3437, 62, 1373530851, 1957, 6, 29),
(3438, 63, 1373530853, 337, 1, 4),
(3439, 36, 1373530859, 1804, 2, 14),
(3440, 35, 1373530897, 230, 1, 3),
(3441, 85, 1373530910, 9177, 1, 1),
(3442, 17, 1373530931, 864, 1, 3),
(3443, 80, 1373530938, 1120, 1, 16),
(3444, 81, 1373530939, 8606, 1, 7),
(3445, 79, 1373530948, 413, 1, 8),
(3446, 34, 1373530960, 2000, 3, 20),
(3447, 37, 1373530981, 2093, 7, 15),
(3448, 65, 1373531001, 1421, 5, 23),
(3449, 47, 1373531014, 1663, 1, 10),
(3450, 61, 1373531037, 828, 2, 12),
(3451, 50, 1373531059, 1408, 1, 14),
(3452, 44, 1373531282, 4642, 4, 34),
(3453, 30, 1373531283, 338, 1, 1),
(3454, 76, 1373531507, 819, 2, 8),
(3455, 67, 1373531510, 1462, 2, 14),
(3456, 43, 1373531519, 1709, 2, 7),
(3457, 74, 1373531571, 4499, 6, 27),
(3458, 59, 1373531602, 3520, 4, 28),
(3459, 58, 1373531628, 1238, 5, 11),
(3460, 23, 1373531781, 1061, 1, 5),
(3461, 77, 1373531782, 4592, 2, 7),
(3462, 20, 1373531827, 1682, 2, 19),
(3463, 12, 1373531831, 145, 1, 0),
(3464, 56, 1373531844, 1308, 1, 8),
(3465, 49, 1373531874, 1938, 4, 9),
(3466, 88, 1373531894, 8747, 1, 5),
(3467, 53, 1373531916, 4536, 7, 21),
(3468, 83, 1373531938, 8757, 1, 5),
(3469, 19, 1373532020, 1515, 2, 15),
(3470, 20, 1373532082, 255, 1, 1),
(3471, 39, 1373532103, 3140, 4, 25),
(3472, 94, 1373532353, 18879, 1, 0),
(3473, 16, 1373532432, 1463, 2, 10),
(3474, 91, 1373532456, 18912, 1, 2),
(3475, 63, 1373532463, 1502, 1, 5),
(3476, 55, 1373532464, 546, 1, 2),
(3477, 27, 1373532506, 1936, 3, 9),
(3478, 24, 1373532546, 2505, 3, 11),
(3479, 80, 1373532568, 1630, 1, 9),
(3480, 29, 1373532585, 1793, 2, 9),
(3481, 71, 1373532601, 3120, 5, 27),
(3482, 68, 1373532618, 2076, 3, 19),
(3483, 107, 1373532656, 174, 1, 2),
(3484, 86, 1373532679, 10273, 2, 17),
(3485, 90, 1373532690, 8839, 1, 3),
(3486, 39, 1373532694, 591, 3, 2),
(3487, 17, 1373532715, 1784, 2, 13),
(3488, 54, 1373532716, 1950, 1, 10),
(3489, 78, 1373532823, 1919, 2, 3),
(3490, 67, 1373532830, 1320, 2, 5),
(3491, 96, 1373532848, 18350, 1, 5),
(3492, 100, 1373532923, 19474, 1, 5),
(3493, 11, 1373533029, 524, 1, 5),
(3494, 32, 1373533153, 2528, 4, 17),
(3495, 93, 1373533172, 11864, 2, 6),
(3496, 65, 1373533183, 2182, 2, 4),
(3497, 103, 1373533217, 18333, 1, 3),
(3498, 52, 1373533258, 4039, 4, 29),
(3499, 107, 1373533320, 664, 1, 3),
(3500, 106, 1373533331, 19717, 1, 3),
(3501, 88, 1373533337, 1443, 1, 8),
(3502, 102, 1373533477, 19497, 2, 10),
(3503, 55, 1373533564, 1100, 2, 10),
(3504, 47, 1373533617, 2602, 1, 15),
(3505, 76, 1373533674, 219, 2, 0),
(3506, 63, 1373533683, 1220, 1, 9),
(3507, 53, 1373533692, 1776, 5, 14),
(3508, 65, 1373533748, 403, 1, 1),
(3509, 66, 1373533767, 1923, 1, 14),
(3510, 64, 1373533847, 3350, 1, 29),
(3511, 73, 1373533856, 1629, 2, 8),
(3512, 104, 1373533902, 20079, 1, 3),
(3513, 51, 1373533911, 4420, 11, 27),
(3514, 31, 1373533951, 1824, 2, 10),
(3515, 37, 1373533955, 2974, 1, 14),
(3516, 52, 1373533979, 721, 2, 4),
(3517, 89, 1373534040, 9260, 1, 8),
(3518, 40, 1373534068, 1457, 2, 8),
(3519, 12, 1373534143, 1218, 1, 5),
(3520, 34, 1373534148, 3188, 3, 12),
(3521, 11, 1373534255, 700, 1, 3),
(3522, 49, 1373534266, 2392, 5, 18),
(3523, 86, 1373534273, 1594, 1, 6),
(3524, 79, 1373534277, 3329, 1, 14),
(3525, 13, 1373534422, 915, 2, 4),
(3526, 48, 1373534426, 7124, 4, 44),
(3527, 85, 1373534434, 738, 1, 4),
(3528, 52, 1373534440, 461, 1, 5),
(3529, 18, 1373534456, 4194, 1, 18),
(3530, 65, 1373534466, 587, 2, 3),
(3531, 43, 1373534506, 2987, 5, 16),
(3532, 20, 1373534534, 2451, 3, 7),
(3533, 74, 1373534535, 2504, 2, 5),
(3534, 58, 1373534571, 2943, 3, 13),
(3535, 16, 1373534588, 1006, 1, 6),
(3536, 19, 1373534607, 1910, 2, 7),
(3537, 87, 1373534628, 2167, 2, 5),
(3538, 35, 1373534679, 2728, 1, 16),
(3539, 56, 1373534737, 2893, 2, 14),
(3540, 12, 1373534852, 547, 1, 4),
(3541, 60, 1373534856, 4146, 5, 14),
(3542, 41, 1373534980, 4401, 2, 15),
(3543, 54, 1373535010, 2294, 1, 10),
(3544, 62, 1373535096, 4245, 7, 32),
(3545, 77, 1373535105, 3323, 1, 11),
(3546, 29, 1373535163, 2578, 2, 19),
(3547, 74, 1373535174, 639, 1, 2),
(3548, 23, 1373535234, 3453, 2, 18),
(3549, 39, 1373535303, 1579, 1, 2),
(3550, 37, 1373535419, 1464, 3, 9),
(3551, 47, 1373535439, 1822, 2, 4),
(3552, 59, 1373535509, 3907, 2, 24),
(3553, 25, 1373535532, 3223, 3, 11),
(3554, 45, 1373535560, 2508, 1, 17),
(3555, 67, 1373535693, 2863, 4, 23),
(3556, 20, 1373535708, 217, 1, 2),
(3557, 72, 1373535864, 5009, 2, 19),
(3558, 57, 1373535994, 6874, 4, 56),
(3559, 69, 1373536514, 4630, 2, 24),
(3560, 43, 1373536521, 2015, 4, 14),
(3561, 34, 1373536529, 2381, 5, 8),
(3562, 57, 1373536584, 590, 1, 2),
(3563, 70, 1373536619, 9536, 12, 47),
(3564, 36, 1373536686, 5827, 6, 30),
(3565, 68, 1373536749, 4131, 5, 22),
(3566, 46, 1373536811, 5569, 3, 22),
(3567, 99, 1373536819, 23202, 3, 13),
(3568, 21, 1373536857, 6044, 3, 25),
(3569, 26, 1373536888, 6191, 6, 25),
(3570, 61, 1373536910, 5193, 3, 26),
(3571, 32, 1373536937, 3784, 7, 22),
(3572, 11, 1373536938, 187, 1, 2),
(3573, 50, 1373536988, 2590, 1, 2),
(3574, 20, 1373537004, 1295, 3, 7),
(3575, 29, 1373537014, 1851, 1, 0),
(3576, 27, 1373537124, 3538, 1, 20),
(3577, 66, 1373537128, 3361, 6, 16),
(3578, 23, 1373537150, 1600, 6, 5),
(3579, 35, 1373537211, 2532, 1, 4),
(3580, 13, 1373537227, 2466, 1, 1),
(3581, 19, 1373537237, 2568, 3, 9),
(3582, 20, 1373537382, 378, 1, 1),
(3583, 56, 1373537401, 453, 2, 4),
(3584, 13, 1373537458, 231, 1, 1),
(3585, 31, 1373537698, 3747, 2, 23),
(3586, 24, 1373537730, 2890, 2, 13),
(3587, 56, 1373537839, 438, 1, 4),
(3588, 53, 1373537872, 986, 2, 3),
(3589, 71, 1373537886, 4948, 2, 18),
(3590, 20, 1373537959, 577, 2, 1),
(3591, 42, 1373538006, 9386, 11, 59),
(3592, 19, 1373538072, 835, 1, 3),
(3593, 36, 1373538087, 1401, 4, 10),
(3594, 40, 1373538269, 3044, 5, 13),
(3595, 17, 1373538313, 2484, 1, 16),
(3596, 24, 1373538332, 602, 1, 2),
(3597, 34, 1373538339, 1368, 1, 2),
(3598, 69, 1373538413, 1408, 1, 4),
(3599, 57, 1373538469, 1885, 2, 6),
(3600, 31, 1373538528, 830, 3, 9),
(3601, 35, 1373538556, 1033, 2, 8),
(3602, 55, 1373538576, 1817, 2, 7),
(3603, 46, 1373538578, 1767, 2, 13),
(3604, 45, 1373538592, 1537, 3, 15),
(3605, 84, 1373538628, 123, 1, 3),
(3606, 11, 1373538670, 331, 1, 1),
(3607, 52, 1373538674, 4234, 1, 13),
(3608, 78, 1373538724, 4893, 1, 1),
(3609, 48, 1373538731, 2306, 2, 15),
(3610, 38, 1373538740, 8978, 9, 63),
(3611, 89, 1373538774, 3834, 1, 2),
(3612, 54, 1373538785, 1051, 2, 7),
(3613, 63, 1373538866, 5183, 1, 5),
(3614, 32, 1373538901, 1079, 2, 6),
(3615, 31, 1373538917, 389, 1, 0),
(3616, 83, 1373538922, 3955, 1, 2),
(3617, 30, 1373538971, 7688, 7, 54),
(3618, 82, 1373539037, 532, 2, 2),
(3619, 25, 1373539062, 232, 1, 0),
(3620, 27, 1373539141, 1314, 1, 17),
(3621, 72, 1373539176, 3312, 2, 4),
(3622, 80, 1373539184, 4322, 1, 4),
(3623, 54, 1373539256, 471, 1, 2),
(3624, 62, 1373539293, 4197, 3, 16),
(3625, 67, 1373539330, 3107, 2, 14),
(3626, 78, 1373539359, 635, 1, 2),
(3627, 58, 1373539406, 4835, 4, 20),
(3628, 50, 1373539456, 1571, 3, 9),
(3629, 49, 1373539499, 2201, 1, 20),
(3630, 34, 1373539635, 1296, 1, 9),
(3631, 55, 1373539700, 1124, 1, 4),
(3632, 74, 1373539710, 4535, 2, 11),
(3633, 73, 1373539772, 1665, 1, 18),
(3634, 60, 1373539871, 5015, 1, 13),
(3635, 65, 1373539910, 5345, 2, 8),
(3636, 75, 1373539987, 1064, 1, 2),
(3637, 56, 1373540006, 2167, 1, 11),
(3638, 64, 1373540011, 1472, 1, 14),
(3639, 31, 1373540016, 1099, 2, 1),
(3640, 88, 1373540038, 1115, 1, 4),
(3641, 71, 1373540044, 2158, 2, 13),
(3642, 26, 1373540045, 3157, 3, 21),
(3643, 79, 1373540073, 439, 1, 3),
(3644, 17, 1373540116, 1802, 2, 7),
(3645, 12, 1373540123, 494, 1, 1),
(3646, 53, 1373540197, 2325, 1, 14),
(3647, 99, 1373540254, 3435, 1, 4),
(3648, 70, 1373540271, 352, 1, 1),
(3649, 55, 1373540346, 646, 3, 6),
(3650, 48, 1373540360, 1629, 1, 17),
(3651, 87, 1373540368, 1029, 2, 4),
(3652, 91, 1373540376, 7920, 1, 11),
(3653, 69, 1373540420, 2007, 2, 9),
(3654, 82, 1373540597, 1003, 1, 2),
(3655, 63, 1373540618, 1752, 2, 12),
(3656, 32, 1373540642, 1741, 4, 9),
(3657, 50, 1373540664, 1208, 1, 8),
(3658, 105, 1373540734, 6215, 1, 3),
(3659, 75, 1373540755, 768, 1, 1),
(3660, 23, 1373540849, 1916, 1, 9),
(3661, 89, 1373540853, 2079, 2, 11),
(3662, 82, 1373540858, 222, 1, 1),
(3663, 13, 1373540863, 1545, 1, 10),
(3664, 68, 1373540893, 3887, 2, 20),
(3665, 74, 1373540970, 1260, 2, 2),
(3666, 41, 1373540997, 4346, 7, 34),
(3667, 25, 1373540997, 1154, 1, 11),
(3668, 16, 1373541007, 769, 2, 3),
(3669, 58, 1373541018, 490, 1, 3),
(3670, 85, 1373541031, 1933, 1, 7),
(3671, 81, 1373541042, 197, 1, 3),
(3672, 97, 1373541060, 7248, 3, 3),
(3673, 102, 1373541069, 1132, 1, 4),
(3674, 109, 1373541099, 8046, 3, 9),
(3675, 78, 1373541119, 1760, 2, 4),
(3676, 110, 1373541119, 249, 2, 2),
(3677, 31, 1373541235, 1030, 1, 13),
(3678, 64, 1373541255, 1244, 1, 9),
(3679, 35, 1373541258, 2702, 4, 33),
(3680, 103, 1373541268, 8051, 1, 14),
(3681, 34, 1373541326, 1208, 2, 12),
(3682, 82, 1373541336, 478, 2, 2),
(3683, 65, 1373541343, 1433, 1, 11),
(3684, 83, 1373541360, 636, 2, 2),
(3685, 51, 1373541498, 4108, 5, 20),
(3686, 56, 1373541597, 885, 1, 3),
(3687, 96, 1373541658, 8810, 3, 7),
(3688, 47, 1373541671, 4915, 4, 32),
(3689, 30, 1373541689, 2718, 2, 16),
(3690, 93, 1373541702, 1782, 2, 12),
(3691, 27, 1373541713, 2572, 1, 17),
(3692, 69, 1373541793, 1373, 1, 4),
(3693, 50, 1373541794, 1130, 2, 8),
(3694, 70, 1373541825, 1121, 2, 11),
(3695, 81, 1373541827, 785, 1, 4),
(3696, 44, 1373541836, 10554, 16, 58),
(3697, 38, 1373541851, 3111, 5, 28),
(3698, 101, 1373541857, 1234, 3, 13),
(3699, 19, 1373541873, 3357, 2, 14),
(3700, 110, 1373541886, 648, 1, 2),
(3701, 46, 1373541956, 3378, 5, 23),
(3702, 21, 1373541957, 5100, 3, 34),
(3703, 12, 1373541963, 1801, 1, 14),
(3704, 94, 1373542054, 764, 1, 3),
(3705, 79, 1373542075, 1102, 1, 5),
(3706, 105, 1373542079, 1345, 1, 17),
(3707, 75, 1373542134, 676, 1, 3),
(3708, 40, 1373542173, 2743, 3, 20),
(3709, 86, 1373542177, 935, 1, 5),
(3710, 20, 1373542189, 3312, 3, 26),
(3711, 52, 1373542222, 1625, 2, 12),
(3712, 84, 1373542250, 503, 2, 5),
(3713, 100, 1373542343, 9420, 3, 17),
(3714, 98, 1373542352, 922, 1, 3),
(3715, 73, 1373542458, 1489, 3, 20),
(3716, 93, 1373542461, 759, 1, 7),
(3717, 48, 1373542488, 1408, 2, 7),
(3718, 53, 1373542505, 2308, 1, 13),
(3719, 54, 1373542522, 3266, 3, 24),
(3720, 20, 1373542530, 341, 2, 2),
(3721, 87, 1373542540, 2172, 2, 13),
(3722, 74, 1373542581, 1547, 1, 13),
(3723, 17, 1373542611, 833, 1, 6),
(3724, 60, 1373542617, 2746, 6, 20),
(3725, 85, 1373542628, 1597, 1, 8),
(3726, 63, 1373542708, 1729, 4, 17),
(3727, 55, 1373542756, 2258, 1, 5),
(3728, 103, 1373542773, 818, 1, 3),
(3729, 57, 1373542855, 4386, 1, 20),
(3730, 24, 1373542926, 4594, 2, 36),
(3731, 31, 1373542944, 1709, 3, 18),
(3732, 27, 1373542959, 1246, 1, 14),
(3733, 77, 1373542978, 3654, 3, 20),
(3734, 29, 1373543005, 5991, 3, 39),
(3735, 23, 1373543086, 1595, 2, 6),
(3736, 13, 1373543122, 312, 1, 2),
(3737, 30, 1373543300, 1611, 3, 7),
(3738, 41, 1373543318, 1187, 1, 6),
(3739, 32, 1373543331, 2689, 2, 21),
(3740, 34, 1373543341, 2015, 1, 12),
(3741, 36, 1373543374, 5286, 6, 18),
(3742, 70, 1373543560, 1735, 1, 2),
(3743, 62, 1373543566, 4273, 7, 33),
(3744, 64, 1373543601, 2346, 5, 28),
(3745, 26, 1373543658, 3613, 5, 22),
(3746, 51, 1373543691, 777, 2, 7),
(3747, 83, 1373543841, 1496, 1, 10),
(3748, 52, 1373543903, 1681, 2, 14),
(3749, 72, 1373543948, 3696, 4, 24),
(3750, 57, 1373544094, 1239, 2, 12),
(3751, 50, 1373544124, 1576, 4, 10),
(3752, 66, 1373544159, 5755, 6, 40),
(3753, 32, 1373544195, 864, 2, 5),
(3754, 71, 1373544208, 4164, 2, 13),
(3755, 54, 1373544294, 1772, 2, 14),
(3756, 76, 1373544348, 4518, 3, 19),
(3757, 50, 1373544416, 292, 1, 0),
(3758, 24, 1373544426, 1499, 2, 13),
(3759, 49, 1373544434, 4935, 2, 33),
(3760, 18, 1373544444, 718, 1, 5),
(3761, 17, 1373544449, 1761, 1, 3),
(3762, 64, 1373544475, 874, 1, 4),
(3763, 55, 1373544477, 1721, 3, 8),
(3764, 13, 1373544483, 432, 2, 1),
(3765, 27, 1373544544, 1585, 1, 8),
(3766, 37, 1373544556, 1842, 1, 12),
(3767, 35, 1373544586, 1989, 2, 12),
(3768, 80, 1373544725, 2545, 1, 1),
(3769, 69, 1373544797, 3004, 2, 12),
(3770, 73, 1373544862, 1657, 1, 9),
(3771, 68, 1373544873, 3980, 4, 24),
(3772, 30, 1373544941, 1641, 1, 12),
(3773, 48, 1373544958, 992, 1, 2),
(3774, 71, 1373544979, 771, 1, 1),
(3775, 57, 1373544980, 886, 1, 8),
(3776, 59, 1373545009, 6160, 6, 52),
(3777, 70, 1373545021, 1461, 2, 9),
(3778, 88, 1373545098, 1351, 3, 3),
(3779, 63, 1373545256, 2548, 2, 12),
(3780, 31, 1373545406, 1546, 1, 6),
(3781, 19, 1373545407, 845, 1, 8),
(3782, 76, 1373545425, 1077, 1, 8),
(3783, 47, 1373545462, 867, 1, 8),
(3784, 17, 1373545497, 1048, 2, 7),
(3785, 67, 1373545513, 5133, 3, 37),
(3786, 32, 1373545528, 1333, 1, 7),
(3787, 62, 1373545543, 1977, 5, 12),
(3788, 65, 1373545544, 4201, 8, 33),
(3789, 86, 1373545554, 3377, 1, 9),
(3790, 37, 1373545560, 1004, 1, 2),
(3791, 40, 1373545565, 3391, 4, 24),
(3792, 23, 1373545624, 1205, 3, 6),
(3793, 77, 1373545655, 1653, 1, 10),
(3794, 100, 1373545691, 3348, 1, 8),
(3795, 105, 1373545700, 3621, 2, 3),
(3796, 11, 1373545713, 568, 1, 1),
(3797, 21, 1373545761, 3804, 1, 12),
(3798, 64, 1373545769, 1294, 1, 6),
(3799, 80, 1373545781, 949, 2, 7),
(3800, 70, 1373545840, 808, 2, 4),
(3801, 35, 1373545864, 1278, 1, 6),
(3802, 29, 1373545883, 1152, 1, 6),
(3803, 24, 1373545928, 1110, 2, 1),
(3804, 103, 1373546016, 795, 1, 7),
(3805, 57, 1373546027, 1047, 2, 5),
(3806, 95, 1373546030, 3769, 2, 11),
(3807, 88, 1373546081, 982, 1, 7),
(3808, 94, 1373546150, 553, 1, 4),
(3809, 45, 1373546173, 5810, 3, 49),
(3810, 55, 1373546176, 1698, 1, 8),
(3811, 85, 1373546192, 2975, 3, 18),
(3812, 76, 1373546218, 793, 1, 7),
(3813, 20, 1373546295, 2972, 2, 20),
(3814, 98, 1373546581, 894, 1, 4),
(3815, 68, 1373546608, 1735, 1, 6),
(3816, 24, 1373546646, 717, 1, 5),
(3817, 41, 1373546703, 3385, 4, 13),
(3818, 60, 1373546773, 4156, 2, 25),
(3819, 48, 1373546820, 1610, 2, 15),
(3820, 96, 1373546838, 4602, 1, 14),
(3821, 93, 1373546900, 1287, 1, 13),
(3822, 84, 1373547062, 2229, 3, 20),
(3823, 50, 1373547072, 2656, 3, 17),
(3824, 40, 1373547113, 1548, 3, 10),
(3825, 16, 1373547137, 532, 1, 1),
(3826, 29, 1373547151, 1058, 1, 5),
(3827, 71, 1373547181, 2202, 2, 10),
(3828, 46, 1373547282, 1780, 2, 19),
(3829, 69, 1373547305, 2508, 2, 12),
(3830, 81, 1373547310, 2663, 2, 25),
(3831, 51, 1373547329, 3638, 2, 9),
(3832, 98, 1373547419, 838, 1, 7),
(3833, 83, 1373547436, 2725, 2, 20),
(3834, 43, 1373547731, 11210, 13, 82),
(3835, 37, 1373547800, 2240, 1, 9),
(3836, 86, 1373547826, 2272, 3, 16),
(3837, 70, 1373547858, 1628, 1, 7),
(3838, 23, 1373547866, 950, 1, 2),
(3839, 101, 1373547885, 2511, 1, 15),
(3840, 77, 1373547886, 1700, 1, 5),
(3841, 91, 1373547899, 6052, 4, 29),
(3842, 67, 1373547925, 2140, 1, 4),
(3843, 69, 1373547931, 625, 1, 3),
(3844, 51, 1373548135, 806, 2, 10),
(3845, 54, 1373548214, 3920, 3, 26),
(3846, 75, 1373548260, 1493, 1, 1),
(3847, 88, 1373548267, 2186, 1, 0),
(3848, 17, 1373548327, 2830, 1, 14),
(3849, 21, 1373548345, 416, 2, 1),
(3850, 97, 1373548347, 5853, 3, 10),
(3851, 57, 1373548369, 2342, 1, 19),
(3852, 73, 1373548426, 731, 1, 6),
(3853, 31, 1373548452, 455, 1, 1),
(3854, 48, 1373548501, 1681, 3, 17),
(3855, 55, 1373548548, 2372, 1, 11),
(3856, 12, 1373548566, 727, 1, 2),
(3857, 19, 1373548597, 3190, 1, 17),
(3858, 91, 1373548628, 729, 1, 5),
(3859, 82, 1373548630, 3942, 6, 24),
(3860, 13, 1373548669, 178, 1, 0),
(3861, 32, 1373548743, 3215, 2, 20),
(3862, 79, 1373548845, 2985, 1, 7),
(3863, 54, 1373548849, 635, 2, 4),
(3864, 48, 1373548858, 357, 1, 5),
(3865, 71, 1373548864, 1683, 4, 11),
(3866, 81, 1373548960, 708, 2, 4),
(3867, 35, 1373549043, 3179, 1, 14),
(3868, 84, 1373549076, 758, 1, 3),
(3869, 102, 1373549162, 339, 1, 2),
(3870, 68, 1373549163, 2006, 2, 14),
(3871, 61, 1373549173, 11810, 12, 99),
(3872, 95, 1373549196, 3166, 1, 12),
(3873, 98, 1373549203, 1255, 1, 1),
(3874, 105, 1373549223, 3523, 1, 2),
(3875, 97, 1373549259, 912, 1, 5),
(3876, 83, 1373549388, 1272, 1, 8),
(3877, 94, 1373549408, 3257, 1, 12),
(3878, 100, 1373549416, 3458, 1, 3),
(3879, 36, 1373549430, 6055, 4, 42),
(3880, 66, 1373549461, 5302, 6, 30),
(3881, 70, 1373549472, 1614, 4, 15),
(3882, 63, 1373549488, 2101, 2, 15),
(3883, 29, 1373549495, 2344, 1, 19),
(3884, 13, 1373549578, 175, 1, 2),
(3885, 91, 1373549628, 1000, 1, 8),
(3886, 95, 1373549799, 603, 1, 3),
(3887, 77, 1373549831, 1626, 1, 11),
(3888, 74, 1373549863, 4055, 2, 25),
(3889, 48, 1373549869, 841, 1, 3),
(3890, 53, 1373549902, 5842, 5, 12),
(3891, 79, 1373549911, 1066, 3, 6),
(3892, 39, 1373549924, 11357, 20, 85),
(3893, 80, 1373549954, 4173, 2, 13),
(3894, 106, 1373550051, 840, 1, 5),
(3895, 32, 1373550077, 1334, 1, 10),
(3896, 50, 1373550095, 2751, 7, 33),
(3897, 46, 1373550107, 2825, 1, 20),
(3898, 69, 1373550148, 2217, 7, 18),
(3899, 75, 1373550196, 1696, 1, 16),
(3900, 67, 1373550246, 2321, 3, 19),
(3901, 30, 1373550364, 4551, 1, 24),
(3902, 68, 1373550371, 1208, 1, 12),
(3903, 16, 1373550399, 124, 1, 1),
(3904, 98, 1373550480, 1149, 1, 2),
(3905, 65, 1373550481, 4359, 1, 9),
(3906, 80, 1373550599, 645, 3, 6),
(3907, 97, 1373550600, 1341, 1, 10),
(3908, 105, 1373550659, 831, 2, 8),
(3909, 103, 1373550676, 1153, 1, 2),
(3910, 17, 1373550703, 971, 1, 5),
(3911, 70, 1373550779, 1307, 2, 10),
(3912, 63, 1373550792, 1304, 3, 14),
(3913, 78, 1373550840, 8254, 6, 39),
(3914, 45, 1373550843, 3590, 3, 17),
(3915, 24, 1373550944, 3293, 2, 20),
(3916, 77, 1373551029, 1198, 1, 10),
(3917, 49, 1373551050, 5824, 9, 44),
(3918, 39, 1373551126, 1202, 1, 5),
(3919, 88, 1373551147, 2880, 5, 16),
(3920, 43, 1373551190, 3459, 3, 24),
(3921, 50, 1373551224, 1129, 1, 10),
(3922, 40, 1373551282, 4169, 3, 25),
(3923, 100, 1373551291, 1875, 1, 17),
(3924, 82, 1373551339, 921, 1, 4),
(3925, 20, 1373551374, 983, 1, 8),
(3926, 56, 1373551392, 9794, 8, 72),
(3927, 95, 1373551395, 1413, 1, 8),
(3928, 29, 1373551423, 1928, 1, 8),
(3929, 13, 1373551444, 63, 1, 0),
(3930, 79, 1373551454, 1543, 1, 12),
(3931, 26, 1373551473, 7815, 7, 31),
(3932, 87, 1373551547, 4973, 3, 23),
(3933, 99, 1373551554, 11300, 6, 48),
(3934, 90, 1373551564, 5862, 6, 40),
(3935, 23, 1373551565, 1569, 2, 7),
(3936, 103, 1373551626, 89, 1, 0),
(3937, 18, 1373551640, 1124, 1, 5),
(3938, 30, 1373551648, 799, 3, 1),
(3939, 93, 1373551673, 1788, 1, 11),
(3940, 107, 1373551701, 2163, 3, 11),
(3941, 96, 1373551710, 2836, 6, 19),
(3942, 16, 1373551741, 342, 1, 0),
(3943, 74, 1373551754, 1891, 1, 13),
(3944, 43, 1373551805, 615, 5, 3),
(3945, 110, 1373551811, 2131, 3, 11),
(3946, 59, 1373551825, 2484, 1, 19),
(3947, 54, 1373551825, 1411, 1, 11),
(3948, 47, 1373551859, 4157, 6, 40),
(3949, 91, 1373551868, 2240, 3, 22),
(3950, 42, 1373551868, 13207, 16, 74),
(3951, 92, 1373551885, 9556, 9, 44),
(3952, 86, 1373551909, 3160, 1, 28),
(3953, 60, 1373551924, 5150, 7, 35),
(3954, 67, 1373552130, 1884, 5, 11),
(3955, 93, 1373552213, 400, 1, 3),
(3956, 85, 1373552255, 2441, 2, 18),
(3957, 94, 1373552293, 2639, 3, 21),
(3958, 13, 1373552326, 881, 2, 3),
(3959, 24, 1373552334, 1390, 1, 3),
(3960, 25, 1373552345, 8870, 4, 47),
(3961, 12, 1373552374, 483, 2, 0),
(3962, 16, 1373552459, 448, 1, 2),
(3963, 11, 1373552499, 1144, 3, 8),
(3964, 51, 1373552513, 4378, 10, 34),
(3965, 19, 1373552518, 3429, 3, 22),
(3966, 61, 1373552701, 2529, 3, 9),
(3967, 45, 1373552839, 1996, 1, 10),
(3968, 64, 1373552865, 7095, 5, 50),
(3969, 31, 1373552904, 1231, 1, 4),
(3970, 21, 1373552913, 4568, 2, 22),
(3971, 18, 1373552953, 1313, 2, 7),
(3972, 76, 1373553016, 6381, 3, 21),
(3973, 29, 1373553086, 1663, 2, 8),
(3974, 46, 1373553212, 409, 1, 2),
(3975, 66, 1373553242, 3781, 4, 32),
(3976, 69, 1373553343, 3195, 4, 20),
(3977, 53, 1373553369, 3467, 3, 13),
(3978, 73, 1373553496, 4393, 3, 26),
(3979, 65, 1373553511, 3029, 3, 25),
(3980, 71, 1373553547, 4683, 5, 36),
(3981, 62, 1373553635, 5025, 3, 44),
(3982, 68, 1373553683, 3311, 1, 15),
(3983, 75, 1373553759, 3488, 10, 23),
(3984, 38, 1373553833, 11982, 16, 69),
(3985, 16, 1373553918, 1296, 2, 0),
(3986, 32, 1373554028, 2722, 2, 16),
(3987, 72, 1373554177, 6199, 6, 34),
(3988, 23, 1373554197, 2490, 4, 15),
(3989, 83, 1373554340, 3362, 1, 1),
(3990, 45, 1373554417, 1578, 1, 9),
(3991, 57, 1373554417, 6048, 8, 37),
(3992, 36, 1373554443, 4024, 4, 22),
(3993, 19, 1373554480, 864, 1, 6),
(3994, 54, 1373554489, 866, 1, 4),
(3995, 17, 1373554539, 3219, 1, 14),
(3996, 12, 1373554560, 116, 1, 1),
(3997, 18, 1373554629, 1676, 3, 6),
(3998, 82, 1373554632, 3293, 1, 4),
(3999, 30, 1373554764, 3116, 1, 11),
(4000, 90, 1373554842, 358, 1, 3),
(4001, 108, 1373554930, 4475, 1, 0),
(4002, 49, 1373555008, 3958, 3, 31),
(4003, 79, 1373555013, 259, 1, 1),
(4004, 42, 1373555017, 3149, 4, 16),
(4005, 69, 1373555052, 1083, 3, 16),
(4006, 51, 1373555304, 2791, 2, 6),
(4007, 47, 1373555350, 2580, 3, 8),
(4008, 48, 1373555403, 1501, 1, 14),
(4009, 25, 1373555491, 1366, 2, 5),
(4010, 60, 1373555521, 3596, 2, 14),
(4011, 13, 1373555523, 965, 3, 2),
(4012, 35, 1373555551, 1016, 1, 2),
(4013, 24, 1373555684, 536, 1, 1),
(4014, 96, 1373555769, 1319, 1, 6),
(4015, 73, 1373555888, 1366, 2, 4),
(4016, 13, 1373555910, 245, 1, 0),
(4017, 98, 1373556020, 1089, 1, 4),
(4018, 58, 1373556086, 15068, 23, 113),
(4019, 26, 1373556100, 4627, 1, 14),
(4020, 91, 1373556125, 4257, 6, 9),
(4021, 92, 1373556133, 4248, 1, 4),
(4022, 54, 1373556139, 628, 1, 3),
(4023, 53, 1373556174, 2805, 5, 17),
(4024, 63, 1373556223, 4583, 3, 20),
(4025, 102, 1373556270, 853, 1, 3),
(4026, 86, 1373556305, 4395, 2, 13),
(4027, 64, 1373556317, 3452, 1, 18),
(4028, 24, 1373556387, 703, 1, 0),
(4029, 35, 1373556408, 857, 1, 6),
(4030, 85, 1373556424, 4169, 6, 9),
(4031, 90, 1373556444, 1602, 2, 8),
(4032, 55, 1373556463, 7447, 6, 45),
(4033, 94, 1373556485, 1601, 1, 5),
(4034, 60, 1373556525, 680, 2, 3),
(4035, 50, 1373556561, 3457, 1, 16),
(4036, 17, 1373556664, 914, 1, 4),
(4037, 67, 1373556666, 4536, 2, 15),
(4038, 61, 1373556692, 3991, 2, 17),
(4039, 32, 1373556699, 2671, 4, 19),
(4040, 105, 1373556714, 6055, 2, 10),
(4041, 78, 1373556747, 5907, 4, 11),
(4042, 36, 1373556768, 2325, 1, 17),
(4043, 44, 1373556784, 14947, 28, 104),
(4044, 20, 1373556839, 3340, 1, 18),
(4045, 76, 1373556869, 3036, 6, 13),
(4046, 52, 1373556890, 12376, 2, 9),
(4047, 43, 1373556897, 5091, 6, 26),
(4048, 81, 1373556941, 5442, 1, 15),
(4049, 92, 1373556955, 793, 2, 4),
(4050, 95, 1373556991, 5596, 2, 21),
(4051, 99, 1373557104, 995, 2, 6),
(4052, 88, 1373557234, 6087, 3, 27),
(4053, 46, 1373557308, 1324, 2, 5),
(4054, 26, 1373557310, 1210, 1, 3),
(4055, 35, 1373557330, 922, 1, 3),
(4056, 82, 1373557340, 2708, 2, 18),
(4057, 93, 1373557380, 2985, 3, 20),
(4058, 11, 1373557426, 188, 1, 0),
(4059, 36, 1373557460, 692, 1, 7),
(4060, 12, 1373557476, 2341, 4, 8),
(4061, 73, 1373557542, 1654, 3, 13),
(4062, 101, 1373557564, 2965, 4, 20),
(4063, 66, 1373557637, 3604, 4, 23),
(4064, 65, 1373557691, 4180, 3, 21),
(4065, 92, 1373557885, 930, 1, 4),
(4066, 72, 1373557918, 2655, 5, 8),
(4067, 60, 1373557932, 1407, 1, 7),
(4068, 69, 1373558176, 3124, 1, 15),
(4069, 36, 1373558209, 749, 2, 3),
(4070, 56, 1373558218, 3666, 3, 19),
(4071, 79, 1373558233, 2301, 1, 13),
(4072, 57, 1373558247, 1870, 1, 13),
(4073, 30, 1373558257, 3493, 1, 13),
(4074, 49, 1373558267, 2731, 3, 9),
(4075, 45, 1373558275, 3858, 5, 21),
(4076, 25, 1373558276, 1148, 1, 1),
(4077, 70, 1373558290, 2414, 2, 11),
(4078, 37, 1373558305, 2177, 2, 15),
(4079, 61, 1373558306, 1498, 1, 1),
(4080, 44, 1373558331, 1547, 4, 5),
(4081, 71, 1373558434, 4259, 2, 29),
(4082, 32, 1373558459, 1760, 2, 6),
(4083, 47, 1373558465, 2117, 3, 15),
(4084, 82, 1373558502, 1162, 1, 19),
(4085, 18, 1373558581, 885, 1, 6),
(4086, 42, 1373558604, 3587, 1, 22),
(4087, 94, 1373558627, 1260, 1, 3),
(4088, 29, 1373558627, 5541, 4, 27),
(4089, 31, 1373558685, 403, 1, 3),
(4090, 59, 1373558735, 6910, 2, 24),
(4091, 26, 1373558843, 731, 1, 2),
(4092, 94, 1373558958, 331, 1, 0),
(4093, 74, 1373559028, 7274, 10, 42),
(4094, 11, 1373559262, 1269, 1, 4),
(4095, 80, 1373559288, 2841, 1, 19),
(4096, 13, 1373559327, 930, 1, 1),
(4097, 54, 1373559372, 890, 1, 1),
(4098, 67, 1373559443, 2777, 4, 13),
(4099, 100, 1373559502, 4707, 1, 19),
(4100, 90, 1373559592, 2270, 1, 20),
(4101, 56, 1373559673, 1455, 1, 8),
(4102, 86, 1373559843, 3538, 4, 18),
(4103, 82, 1373559920, 1418, 1, 3),
(4104, 89, 1373560036, 5494, 2, 25),
(4105, 30, 1373560120, 1861, 3, 12),
(4106, 47, 1373560270, 1805, 1, 6),
(4107, 19, 1373560312, 3264, 2, 19),
(4108, 48, 1373560335, 3548, 1, 17),
(4109, 50, 1373560351, 870, 1, 2),
(4110, 55, 1373560388, 3164, 1, 10),
(4111, 53, 1373560409, 2741, 1, 14),
(4112, 69, 1373560425, 2249, 4, 9),
(4113, 57, 1373560449, 1852, 1, 6),
(4114, 60, 1373560533, 2601, 1, 5),
(4115, 40, 1373560550, 6671, 7, 47),
(4116, 31, 1373560668, 644, 1, 2),
(4117, 46, 1373560735, 1084, 1, 1),
(4118, 24, 1373560761, 1181, 1, 2),
(4119, 13, 1373560942, 217, 1, 0),
(4120, 21, 1373561052, 751, 1, 3),
(4121, 23, 1373561207, 4714, 2, 17),
(4122, 12, 1373561316, 448, 1, 1),
(4123, 32, 1373561554, 3095, 3, 10),
(4124, 45, 1373561606, 3330, 3, 6),
(4125, 86, 1373561618, 1775, 1, 8),
(4126, 26, 1373561746, 2903, 1, 12),
(4127, 54, 1373561764, 1507, 1, 4),
(4128, 41, 1373561807, 12801, 14, 77),
(4129, 36, 1373561808, 3599, 1, 9),
(4130, 17, 1373561813, 5149, 1, 22),
(4131, 83, 1373561834, 7494, 8, 51),
(4132, 108, 1373561870, 691, 1, 2),
(4133, 65, 1373562073, 4382, 1, 9),
(4134, 29, 1373562078, 3450, 2, 6),
(4135, 82, 1373562086, 2166, 1, 10),
(4136, 67, 1373562090, 2647, 3, 14),
(4137, 11, 1373562091, 2829, 1, 5),
(4138, 76, 1373562167, 4646, 1, 11),
(4139, 56, 1373562179, 1995, 4, 5),
(4140, 35, 1373562187, 1574, 1, 5),
(4141, 44, 1373562192, 3861, 4, 26),
(4142, 61, 1373562196, 3889, 1, 11),
(4143, 51, 1373562292, 5550, 7, 18),
(4144, 84, 1373562305, 13229, 8, 79),
(4145, 97, 1373562376, 6925, 2, 12),
(4146, 60, 1373562380, 1847, 1, 9),
(4147, 103, 1373562408, 6226, 2, 8),
(4148, 31, 1373562488, 1630, 1, 10),
(4149, 70, 1373562501, 4210, 2, 12),
(4150, 43, 1373562642, 5745, 8, 25),
(4151, 48, 1373562646, 160, 1, 1),
(4152, 99, 1373562652, 5184, 1, 17),
(4153, 75, 1373562758, 6574, 6, 36),
(4154, 25, 1373562781, 4129, 2, 15),
(4155, 101, 1373562846, 1545, 1, 6),
(4156, 31, 1373562911, 423, 1, 3),
(4157, 93, 1373562952, 5360, 7, 15),
(4158, 98, 1373562977, 1897, 1, 9),
(4159, 65, 1373562999, 357, 1, 2),
(4160, 68, 1373563099, 9416, 8, 43),
(4161, 45, 1373563126, 1520, 1, 5),
(4162, 105, 1373563143, 6429, 1, 12),
(4163, 19, 1373563186, 2639, 1, 14),
(4164, 23, 1373563195, 989, 1, 3),
(4165, 87, 1373563201, 11654, 3, 48),
(4166, 21, 1373563234, 664, 1, 1),
(4167, 20, 1373563235, 844, 1, 3),
(4168, 63, 1373563277, 7054, 2, 43),
(4169, 54, 1373563315, 1551, 2, 3),
(4170, 73, 1373563324, 5782, 3, 16),
(4171, 97, 1373563346, 970, 2, 7),
(4172, 100, 1373563384, 1946, 2, 10),
(4173, 83, 1373563440, 1337, 1, 10),
(4174, 52, 1373563528, 5149, 2, 24),
(4175, 67, 1373563570, 1480, 2, 7),
(4176, 92, 1373563639, 2308, 2, 17),
(4177, 18, 1373563667, 488, 1, 1),
(4178, 95, 1373563675, 6684, 5, 18),
(4179, 102, 1373563681, 473, 1, 2),
(4180, 108, 1373563693, 1810, 1, 1),
(4181, 35, 1373563716, 227, 1, 2),
(4182, 32, 1373563749, 2195, 1, 8),
(4183, 18, 1373563891, 224, 1, 3),
(4184, 53, 1373563906, 3497, 5, 33),
(4185, 26, 1373563989, 1563, 2, 8),
(4186, 78, 1373563994, 7247, 10, 59),
(4187, 45, 1373564005, 879, 2, 8),
(4188, 37, 1373564070, 5589, 2, 29),
(4189, 84, 1373564125, 1068, 1, 8),
(4190, 71, 1373564138, 3808, 2, 31),
(4191, 40, 1373564196, 3646, 2, 14),
(4192, 25, 1373564347, 1566, 4, 7),
(4193, 91, 1373564355, 2598, 4, 30),
(4194, 26, 1373564402, 413, 1, 2),
(4195, 72, 1373564490, 6572, 12, 41),
(4196, 106, 1373564560, 679, 1, 5),
(4197, 67, 1373564654, 1084, 1, 20),
(4198, 68, 1373564661, 1562, 3, 12),
(4199, 42, 1373564677, 550, 1, 0),
(4200, 96, 1373564688, 8918, 2, 34),
(4201, 35, 1373564706, 728, 1, 5),
(4202, 48, 1373564802, 378, 1, 3),
(4203, 98, 1373564846, 1099, 2, 13),
(4204, 80, 1373564950, 5662, 4, 30),
(4205, 48, 1373564976, 174, 1, 2),
(4206, 91, 1373564978, 623, 2, 3),
(4207, 46, 1373564998, 2212, 4, 17),
(4208, 74, 1373565110, 6082, 9, 28),
(4209, 51, 1373565162, 2870, 3, 16),
(4210, 76, 1373565168, 3001, 8, 22),
(4211, 17, 1373565189, 596, 1, 3),
(4212, 95, 1373565202, 1527, 1, 14),
(4213, 27, 1373565242, 20698, 3, 21),
(4214, 75, 1373565327, 2569, 1, 15),
(4215, 107, 1373565340, 1498, 2, 9),
(4216, 102, 1373565436, 1379, 1, 2),
(4217, 61, 1373565619, 3423, 6, 34),
(4218, 87, 1373565631, 973, 2, 5),
(4219, 92, 1373565717, 2078, 1, 13),
(4220, 109, 1373565750, 1105, 1, 4),
(4221, 60, 1373565779, 3399, 1, 27),
(4222, 53, 1373565923, 2017, 3, 8),
(4223, 93, 1373565975, 3023, 3, 13),
(4224, 35, 1373566052, 670, 2, 2),
(4225, 11, 1373566086, 1370, 2, 4),
(4226, 102, 1373566119, 683, 1, 3),
(4227, 25, 1373566248, 1145, 1, 2),
(4228, 21, 1373566277, 672, 1, 2),
(4229, 55, 1373566313, 4750, 3, 29),
(4230, 38, 1373566338, 12504, 5, 32),
(4231, 47, 1373566356, 6086, 6, 29),
(4232, 57, 1373566367, 5918, 5, 34),
(4233, 36, 1373566391, 1370, 1, 8),
(4234, 65, 1373566478, 1508, 1, 4),
(4235, 79, 1373566504, 624, 2, 4),
(4236, 81, 1373566531, 3758, 6, 22),
(4237, 102, 1373566572, 453, 1, 2),
(4238, 98, 1373566663, 1817, 4, 12),
(4239, 95, 1373566672, 1470, 4, 8),
(4240, 82, 1373566696, 3116, 1, 18),
(4241, 43, 1373566752, 4110, 1, 26),
(4242, 77, 1373566761, 11230, 8, 77),
(4243, 88, 1373566768, 1984, 2, 8),
(4244, 63, 1373566825, 3548, 7, 37),
(4245, 49, 1373566858, 8590, 6, 45),
(4246, 21, 1373566886, 174, 1, 2),
(4247, 103, 1373566898, 2876, 3, 13),
(4248, 76, 1373566936, 1768, 2, 17),
(4249, 67, 1373566989, 2335, 8, 17),
(4250, 87, 1373566997, 1366, 1, 10),
(4251, 44, 1373567032, 4840, 3, 25),
(4252, 31, 1373567111, 196, 1, 2),
(4253, 54, 1373567119, 879, 1, 4),
(4254, 51, 1373567128, 1966, 4, 9),
(4255, 24, 1373567149, 956, 1, 6),
(4256, 41, 1373567237, 5430, 2, 21),
(4257, 45, 1373567256, 2991, 3, 12),
(4258, 43, 1373567261, 509, 1, 3),
(4259, 69, 1373567275, 5999, 6, 46),
(4260, 92, 1373567296, 818, 1, 8),
(4261, 17, 1373567296, 1377, 1, 11),
(4262, 101, 1373567374, 3989, 3, 27),
(4263, 21, 1373567386, 344, 1, 5),
(4264, 110, 1373567414, 141, 1, 1),
(4265, 91, 1373567449, 1012, 3, 6),
(4266, 83, 1373567515, 4075, 7, 23),
(4267, 66, 1373567555, 9918, 7, 60),
(4268, 55, 1373567567, 605, 1, 2),
(4269, 23, 1373567593, 3618, 1, 23),
(4270, 27, 1373567613, 712, 1, 6),
(4271, 89, 1373567621, 5897, 4, 27),
(4272, 54, 1373567626, 186, 1, 2),
(4273, 53, 1373567664, 1741, 3, 14),
(4274, 107, 1373567680, 2340, 5, 11),
(4275, 100, 1373567873, 4488, 1, 32),
(4276, 36, 1373567912, 1244, 2, 11),
(4277, 97, 1373567932, 2261, 3, 10),
(4278, 108, 1373567968, 752, 1, 6),
(4279, 56, 1373568014, 5134, 5, 38),
(4280, 13, 1373568022, 186, 1, 2),
(4281, 73, 1373568082, 4757, 3, 52),
(4282, 84, 1373568101, 3472, 2, 30),
(4283, 26, 1373568133, 195, 1, 1),
(4284, 30, 1373568139, 1363, 1, 10),
(4285, 95, 1373568201, 527, 1, 2),
(4286, 55, 1373568225, 658, 1, 5),
(4287, 80, 1373568290, 3340, 6, 37),
(4288, 26, 1373568328, 194, 1, 0),
(4289, 53, 1373568337, 673, 3, 8),
(4290, 98, 1373568341, 1678, 3, 13),
(4291, 99, 1373568344, 5692, 4, 40),
(4292, 35, 1373568363, 1623, 2, 12),
(4293, 48, 1373568364, 941, 1, 5),
(4294, 63, 1373568367, 1459, 1, 15),
(4295, 42, 1373568371, 3694, 2, 23),
(4296, 106, 1373568387, 1238, 1, 10),
(4297, 31, 1373568395, 70, 1, 3),
(4298, 92, 1373568410, 1114, 2, 5),
(4299, 19, 1373568442, 331, 1, 0),
(4300, 17, 1373568498, 330, 1, 3),
(4301, 13, 1373568526, 348, 1, 5),
(4302, 62, 1373568606, 14810, 13, 78),
(4303, 32, 1373568618, 4869, 4, 19),
(4304, 86, 1373568766, 739, 1, 8),
(4305, 105, 1373568809, 832, 1, 5),
(4306, 78, 1373568836, 4842, 6, 43),
(4307, 59, 1373568964, 7448, 9, 38),
(4308, 17, 1373569016, 472, 1, 6),
(4309, 50, 1373569077, 5942, 5, 37),
(4310, 28, 1373569091, 40157, 2, 7),
(4311, 12, 1373569110, 388, 2, 5),
(4312, 79, 1373569112, 2607, 6, 22),
(4313, 88, 1373569162, 2394, 2, 17),
(4314, 29, 1373569164, 5011, 1, 8),
(4315, 37, 1373569304, 2465, 4, 17),
(4316, 54, 1373569316, 361, 1, 2),
(4317, 103, 1373569328, 1562, 2, 9),
(4318, 101, 1373569397, 1607, 1, 9),
(4319, 102, 1373569401, 730, 1, 6),
(4320, 75, 1373569549, 4222, 8, 34),
(4321, 89, 1373569562, 1941, 1, 16),
(4322, 64, 1373569575, 13258, 15, 61),
(4323, 19, 1373569613, 999, 2, 6),
(4324, 110, 1373569629, 1110, 1, 7),
(4325, 25, 1373569640, 1491, 2, 5),
(4326, 107, 1373569653, 1710, 1, 13),
(4327, 87, 1373569824, 2827, 5, 29),
(4328, 27, 1373569980, 1532, 1, 9),
(4329, 102, 1373570083, 682, 1, 2),
(4330, 81, 1373570180, 2393, 1, 8),
(4331, 104, 1373570252, 7975, 3, 29),
(4332, 52, 1373570298, 5403, 10, 37),
(4333, 35, 1373570369, 320, 1, 2),
(4334, 105, 1373570386, 154, 1, 0),
(4335, 65, 1373570408, 3161, 4, 20),
(4336, 87, 1373570416, 592, 2, 1),
(4337, 60, 1373570451, 1266, 2, 6),
(4338, 46, 1373570453, 671, 1, 1),
(4339, 19, 1373570459, 332, 1, 1),
(4340, 48, 1373570501, 1759, 2, 10),
(4341, 30, 1373570508, 1110, 1, 6),
(4342, 71, 1373570521, 6383, 10, 45),
(4343, 47, 1373570617, 1360, 1, 5),
(4344, 91, 1373570762, 1438, 2, 7),
(4345, 30, 1373570780, 272, 1, 0),
(4346, 44, 1373570897, 3865, 2, 19),
(4347, 86, 1373570971, 2204, 2, 16),
(4348, 56, 1373571011, 2997, 2, 18),
(4349, 65, 1373571074, 666, 1, 1),
(4350, 24, 1373571091, 3338, 2, 14),
(4351, 98, 1373571119, 2778, 1, 15),
(4352, 18, 1373571147, 2040, 2, 6),
(4353, 104, 1373571193, 941, 2, 6),
(4354, 63, 1373571219, 2852, 1, 15),
(4355, 95, 1373571222, 1346, 1, 7),
(4356, 101, 1373571227, 1830, 2, 6),
(4357, 55, 1373571275, 3050, 2, 22),
(4358, 104, 1373571280, 87, 1, 3),
(4359, 46, 1373571282, 206, 1, 6),
(4360, 65, 1373571286, 212, 1, 1),
(4361, 91, 1373571289, 527, 1, 3),
(4362, 54, 1373571290, 632, 1, 2),
(4363, 28, 1373571366, 1815, 3, 8),
(4364, 40, 1373571416, 6059, 4, 26),
(4365, 25, 1373571440, 1800, 1, 5),
(4366, 27, 1373571475, 345, 1, 1),
(4367, 43, 1373571496, 4235, 4, 29),
(4368, 59, 1373571526, 2562, 2, 14),
(4369, 21, 1373571642, 3279, 2, 19),
(4370, 50, 1373571646, 2568, 1, 13),
(4371, 37, 1373571649, 951, 1, 5),
(4372, 26, 1373571652, 3231, 1, 18),
(4373, 101, 1373571661, 375, 1, 5),
(4374, 25, 1373571664, 224, 1, 2),
(4375, 85, 1373571665, 15241, 14, 91),
(4376, 61, 1373571675, 6056, 4, 26),
(4377, 79, 1373571678, 2566, 2, 11),
(4378, 59, 1373571680, 154, 2, 0),
(4379, 84, 1373571685, 3584, 4, 18),
(4380, 47, 1373571694, 734, 1, 7),
(4381, 31, 1373571699, 2712, 3, 14),
(4382, 45, 1373571707, 3897, 9, 13),
(4383, 94, 1373571715, 12757, 11, 66),
(4384, 56, 1373571747, 514, 1, 3),
(4385, 44, 1373571777, 880, 1, 8),
(4386, 85, 1373571783, 116, 1, 1),
(4387, 29, 1373571793, 2628, 4, 14),
(4388, 12, 1373571825, 352, 1, 4),
(4389, 83, 1373571842, 2880, 2, 16),
(4390, 56, 1373571845, 96, 1, 2),
(4391, 71, 1373571866, 1345, 1, 10),
(4392, 49, 1373571874, 5016, 3, 27),
(4393, 86, 1373571880, 909, 1, 8),
(4394, 66, 1373571896, 4341, 5, 34),
(4395, 48, 1373571916, 1415, 3, 4),
(4396, 97, 1373571927, 2921, 6, 17),
(4397, 69, 1373571929, 4654, 7, 32),
(4398, 88, 1373571930, 2370, 5, 18),
(4399, 87, 1373571942, 1526, 3, 13);
INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(4400, 43, 1373571945, 449, 1, 1),
(4401, 81, 1373571951, 1771, 3, 25),
(4402, 28, 1373571957, 180, 1, 7),
(4403, 61, 1373571987, 221, 1, 4),
(4404, 99, 1373571990, 2497, 4, 16),
(4405, 93, 1373572000, 1534, 4, 14),
(4406, 65, 1373572002, 716, 1, 4),
(4407, 21, 1373572006, 363, 2, 6),
(4408, 80, 1373572016, 3726, 6, 35),
(4409, 72, 1373572028, 7538, 10, 64),
(4410, 58, 1373572063, 15977, 19, 82),
(4411, 17, 1373572066, 289, 1, 7),
(4412, 44, 1373572083, 305, 1, 5),
(4413, 54, 1373572110, 650, 2, 11),
(4414, 81, 1373572112, 159, 1, 1),
(4415, 51, 1373572114, 4986, 9, 36),
(4416, 95, 1373572120, 896, 2, 8),
(4417, 29, 1373572146, 351, 2, 8),
(4418, 64, 1373572156, 2581, 3, 13),
(4419, 88, 1373572174, 101, 1, 1),
(4420, 105, 1373572338, 649, 1, 4),
(4421, 25, 1373572519, 854, 2, 11),
(4422, 42, 1373572615, 2981, 4, 22),
(4423, 27, 1373572630, 1000, 1, 0),
(4424, 79, 1373572638, 958, 4, 12),
(4425, 107, 1373572663, 1889, 1, 10),
(4426, 52, 1373572710, 1053, 1, 12),
(4427, 53, 1373572796, 2497, 3, 15),
(4428, 62, 1373572798, 3247, 2, 19),
(4429, 41, 1373572821, 1057, 2, 12),
(4430, 85, 1373572856, 990, 4, 10),
(4431, 12, 1373573016, 916, 1, 4),
(4432, 44, 1373573039, 955, 1, 1),
(4433, 13, 1373573045, 1136, 2, 12),
(4434, 46, 1373573214, 1696, 4, 9),
(4435, 19, 1373573364, 1738, 3, 11),
(4436, 28, 1373573373, 668, 1, 2),
(4437, 12, 1373573435, 419, 1, 1),
(4438, 18, 1373573456, 1553, 2, 13),
(4439, 96, 1373573780, 8256, 9, 61),
(4440, 70, 1373573781, 11280, 12, 87),
(4441, 32, 1373573819, 309, 1, 1),
(4442, 77, 1373573834, 7073, 9, 53),
(4443, 59, 1373573857, 2177, 2, 6),
(4444, 24, 1373573923, 2164, 1, 13),
(4445, 36, 1373574003, 2369, 1, 14),
(4446, 26, 1373574016, 2360, 1, 6),
(4447, 46, 1373574118, 904, 1, 8),
(4448, 53, 1373574122, 1325, 1, 7),
(4449, 27, 1373574141, 1429, 1, 7),
(4450, 107, 1373574309, 1646, 2, 3),
(4451, 23, 1373574332, 2764, 4, 12),
(4452, 72, 1373574381, 2353, 2, 11),
(4453, 80, 1373574392, 2375, 1, 6),
(4454, 76, 1373574532, 7596, 14, 64),
(4455, 92, 1373574544, 4434, 6, 16),
(4456, 82, 1373574750, 8054, 12, 52),
(4457, 30, 1373574755, 2901, 2, 16),
(4458, 19, 1373574831, 870, 1, 3),
(4459, 60, 1373574944, 3674, 8, 31),
(4460, 79, 1373574962, 2324, 1, 7),
(4461, 84, 1373574986, 3300, 2, 23),
(4462, 90, 1373575076, 15484, 17, 93),
(4463, 45, 1373575174, 3466, 3, 13),
(4464, 47, 1373575430, 3734, 2, 13),
(4465, 43, 1373575530, 3508, 5, 11),
(4466, 55, 1373575581, 2764, 1, 8),
(4467, 11, 1373575664, 3802, 3, 17),
(4468, 63, 1373575741, 4009, 3, 24),
(4469, 57, 1373575746, 9379, 10, 63),
(4470, 23, 1373575773, 1239, 1, 1),
(4471, 17, 1373575896, 2166, 2, 7),
(4472, 65, 1373575905, 3467, 5, 25),
(4473, 84, 1373576135, 1149, 1, 2),
(4474, 69, 1373576166, 4236, 6, 26),
(4475, 50, 1373576203, 2676, 1, 11),
(4476, 71, 1373576220, 4353, 6, 27),
(4477, 12, 1373576403, 1172, 1, 0),
(4478, 58, 1373576476, 4309, 4, 13),
(4479, 32, 1373576555, 2736, 1, 3),
(4480, 26, 1373576804, 1313, 1, 6),
(4481, 49, 1373577119, 5125, 3, 11),
(4482, 81, 1373577227, 2437, 1, 9),
(4483, 28, 1373577264, 2908, 2, 11),
(4484, 31, 1373577757, 3253, 2, 5),
(4485, 61, 1373577878, 5890, 3, 30),
(4486, 52, 1373578007, 5296, 3, 16),
(4487, 44, 1373578380, 5341, 2, 23),
(4488, 17, 1373578435, 1199, 1, 1),
(4489, 67, 1373578482, 11493, 19, 90),
(4490, 18, 1373578550, 308, 1, 1),
(4491, 36, 1373578670, 4667, 1, 1),
(4492, 68, 1373578706, 13520, 19, 84),
(4493, 41, 1373579503, 4496, 2, 1),
(4494, 64, 1373579539, 7381, 4, 41),
(4495, 66, 1373579598, 7702, 8, 33),
(4496, 24, 1373579637, 3818, 1, 5),
(4497, 51, 1373579650, 4125, 3, 13),
(4498, 28, 1373579658, 2394, 2, 6),
(4499, 53, 1373579727, 5605, 1, 3),
(4500, 29, 1373579812, 1011, 1, 1),
(4501, 62, 1373579860, 7062, 5, 26),
(4502, 51, 1373580085, 435, 1, 2),
(4503, 12, 1373580163, 3760, 2, 4),
(4504, 31, 1373580222, 591, 1, 1),
(4505, 50, 1373580224, 4021, 2, 5),
(4506, 29, 1373580420, 560, 1, 1),
(4507, 25, 1373580515, 5063, 2, 7),
(4508, 76, 1373580752, 6220, 1, 5),
(4509, 36, 1373580912, 570, 1, 2),
(4510, 49, 1373580962, 3843, 3, 3),
(4511, 99, 1373581001, 9010, 1, 4),
(4512, 107, 1373581176, 194, 1, 0),
(4513, 86, 1373581286, 9282, 1, 9),
(4514, 46, 1373581314, 7196, 1, 6),
(4515, 85, 1373581318, 6899, 1, 6),
(4516, 98, 1373581326, 588, 1, 1),
(4517, 105, 1373581350, 9012, 1, 0),
(4518, 95, 1373581360, 9026, 2, 5),
(4519, 94, 1373581556, 9839, 1, 7),
(4520, 60, 1373581579, 6634, 1, 7),
(4521, 54, 1373581582, 385, 2, 0),
(4522, 35, 1373581618, 435, 3, 3),
(4523, 24, 1373581661, 1444, 2, 9),
(4524, 47, 1373581751, 1177, 1, 7),
(4525, 81, 1373581865, 4638, 3, 18),
(4526, 57, 1373581911, 1376, 1, 6),
(4527, 76, 1373581953, 1201, 1, 11),
(4528, 66, 1373581983, 2385, 2, 19),
(4529, 50, 1373581988, 1764, 1, 8),
(4530, 51, 1373582003, 1918, 2, 9),
(4531, 37, 1373582006, 6925, 1, 15),
(4532, 68, 1373582018, 3312, 6, 22),
(4533, 23, 1373582022, 4251, 1, 19),
(4534, 109, 1373582024, 913, 1, 6),
(4535, 48, 1373582027, 7650, 1, 15),
(4536, 40, 1373582043, 7820, 3, 20),
(4537, 69, 1373582215, 6049, 11, 32),
(4538, 61, 1373582233, 4355, 2, 13),
(4539, 46, 1373582246, 875, 2, 12),
(4540, 87, 1373582268, 1677, 4, 14),
(4541, 106, 1373582305, 10393, 1, 8),
(4542, 88, 1373582324, 8138, 2, 11),
(4543, 52, 1373582333, 4326, 3, 14),
(4544, 67, 1373582390, 3908, 2, 18),
(4545, 64, 1373582484, 2945, 4, 17),
(4546, 62, 1373582523, 2663, 1, 17),
(4547, 71, 1373582531, 6311, 3, 15),
(4548, 85, 1373582591, 1259, 1, 11),
(4549, 26, 1373582639, 5636, 1, 11),
(4550, 73, 1373582644, 14562, 20, 91),
(4551, 55, 1373582717, 7135, 5, 20),
(4552, 79, 1373582788, 3432, 3, 15),
(4553, 89, 1373582789, 10755, 1, 12),
(4554, 11, 1373582857, 4294, 2, 16),
(4555, 80, 1373583063, 2205, 2, 16),
(4556, 48, 1373583138, 1111, 1, 6),
(4557, 100, 1373583192, 1298, 2, 11),
(4558, 91, 1373583282, 8460, 2, 9),
(4559, 29, 1373583327, 2907, 2, 7),
(4560, 47, 1373583671, 1920, 1, 8),
(4561, 98, 1373583739, 2413, 1, 5),
(4562, 45, 1373583783, 8609, 5, 30),
(4563, 63, 1373583898, 2656, 2, 9),
(4564, 53, 1373584131, 4404, 2, 21),
(4565, 93, 1373584218, 11592, 4, 22),
(4566, 101, 1373584287, 3109, 6, 18),
(4567, 99, 1373584310, 3309, 5, 18),
(4568, 41, 1373584312, 2185, 2, 11),
(4569, 32, 1373584381, 7192, 2, 17),
(4570, 102, 1373584965, 3021, 3, 13),
(4571, 42, 1373584974, 6443, 7, 31),
(4572, 105, 1373585119, 3769, 5, 15),
(4573, 97, 1373585302, 12708, 2, 18),
(4574, 44, 1373585370, 6990, 1, 27),
(4575, 86, 1373585406, 2776, 1, 10),
(4576, 107, 1373585431, 4255, 3, 19),
(4577, 49, 1373585524, 4562, 1, 13),
(4578, 79, 1373586100, 3312, 1, 11),
(4579, 76, 1373586363, 4410, 1, 8),
(4580, 83, 1373586691, 5968, 2, 27),
(4581, 17, 1373586921, 4693, 3, 2),
(4582, 41, 1373587056, 2744, 2, 1),
(4583, 31, 1373587076, 273, 1, 1),
(4584, 26, 1373587112, 86, 1, 0),
(4585, 12, 1373587117, 5326, 1, 5),
(4586, 28, 1373587128, 5597, 1, 1),
(4587, 56, 1373587422, 5718, 1, 2),
(4588, 48, 1373587641, 4503, 1, 0),
(4589, 19, 1373587807, 1702, 1, 5),
(4590, 88, 1373587923, 5599, 1, 2),
(4591, 28, 1373587955, 250, 1, 0),
(4592, 13, 1373587972, 206, 1, 0),
(4593, 31, 1373588142, 1066, 1, 1),
(4594, 82, 1373588162, 6593, 2, 7),
(4595, 69, 1373588174, 5959, 1, 4),
(4596, 42, 1373588194, 3220, 1, 2),
(4597, 69, 1373588322, 148, 1, 1),
(4598, 23, 1373588362, 2097, 1, 3),
(4599, 35, 1373588419, 402, 3, 0),
(4600, 49, 1373588424, 2900, 2, 4),
(4601, 76, 1373588426, 2062, 3, 6),
(4602, 63, 1373588441, 4543, 4, 10),
(4603, 68, 1373588496, 6478, 2, 10),
(4604, 90, 1373588525, 13448, 5, 34),
(4605, 51, 1373588533, 6254, 4, 1),
(4606, 36, 1373588567, 6490, 1, 7),
(4607, 75, 1373588627, 19078, 19, 93),
(4608, 19, 1373588705, 898, 1, 12),
(4609, 61, 1373588749, 6516, 1, 18),
(4610, 49, 1373588956, 368, 1, 1),
(4611, 25, 1373588976, 6966, 3, 18),
(4612, 29, 1373589119, 1339, 2, 5),
(4613, 85, 1373589622, 964, 1, 3),
(4614, 50, 1373589695, 1761, 1, 7),
(4615, 18, 1373589714, 1533, 1, 10),
(4616, 43, 1373589782, 7740, 3, 4),
(4617, 53, 1373589797, 2161, 3, 7),
(4618, 62, 1373589842, 6281, 3, 17),
(4619, 11, 1373589962, 391, 1, 1),
(4620, 30, 1373590038, 1656, 1, 10),
(4621, 48, 1373590218, 2577, 2, 11),
(4622, 56, 1373590271, 1821, 1, 7),
(4623, 83, 1373590292, 3601, 2, 12),
(4624, 54, 1373590306, 8724, 3, 16),
(4625, 61, 1373590348, 1599, 3, 8),
(4626, 29, 1373590415, 640, 1, 2),
(4627, 35, 1373590550, 791, 1, 1),
(4628, 23, 1373590566, 1437, 1, 4),
(4629, 32, 1373590783, 3781, 4, 12),
(4630, 95, 1373590906, 9546, 1, 5),
(4631, 59, 1373591033, 9094, 6, 23),
(4632, 60, 1373591252, 9673, 1, 17),
(4633, 82, 1373591297, 3135, 3, 15),
(4634, 87, 1373591399, 9131, 2, 13),
(4635, 45, 1373591431, 7647, 2, 13),
(4636, 26, 1373591464, 2603, 1, 5),
(4637, 99, 1373591509, 7199, 1, 2),
(4638, 88, 1373591555, 1259, 1, 4),
(4639, 62, 1373591647, 1805, 2, 6),
(4640, 92, 1373591688, 1577, 2, 11),
(4641, 17, 1373591752, 4831, 3, 19),
(4642, 65, 1373591781, 9840, 6, 20),
(4643, 70, 1373591871, 18090, 16, 51),
(4644, 46, 1373592070, 9824, 2, 11),
(4645, 24, 1373592128, 3860, 2, 12),
(4646, 68, 1373592153, 3657, 2, 17),
(4647, 19, 1373592304, 2281, 1, 7),
(4648, 88, 1373592322, 767, 1, 4),
(4649, 80, 1373592345, 9141, 3, 19),
(4650, 57, 1373592420, 10509, 4, 22),
(4651, 25, 1373592443, 3467, 1, 6),
(4652, 23, 1373592460, 1894, 1, 8),
(4653, 45, 1373592462, 1031, 2, 2),
(4654, 49, 1373592481, 3525, 4, 10),
(4655, 85, 1373592509, 2887, 7, 11),
(4656, 13, 1373592574, 573, 1, 2),
(4657, 52, 1373592691, 3457, 4, 10),
(4658, 63, 1373592723, 3703, 1, 23),
(4659, 61, 1373592732, 2384, 2, 13),
(4660, 31, 1373592804, 1262, 1, 4),
(4661, 94, 1373592934, 11378, 1, 14),
(4662, 86, 1373592950, 7544, 1, 22),
(4663, 53, 1373593238, 3441, 1, 13),
(4664, 30, 1373593495, 1938, 1, 4),
(4665, 37, 1373593596, 2917, 1, 4),
(4666, 48, 1373593608, 2459, 1, 12),
(4667, 65, 1373593880, 2099, 3, 13),
(4668, 71, 1373593954, 3860, 5, 18),
(4669, 72, 1373593976, 19595, 15, 64),
(4670, 36, 1373593982, 2845, 1, 8),
(4671, 53, 1373593998, 760, 1, 1),
(4672, 59, 1373594122, 3089, 2, 16),
(4673, 70, 1373594132, 2260, 1, 7),
(4674, 12, 1373594166, 3477, 2, 10),
(4675, 110, 1373594183, 11827, 1, 4),
(4676, 47, 1373594224, 9852, 3, 37),
(4677, 99, 1373594273, 2615, 1, 4),
(4678, 85, 1373594333, 1824, 1, 8),
(4679, 98, 1373594446, 4302, 1, 8),
(4680, 103, 1373594558, 1374, 1, 6),
(4681, 109, 1373594693, 12669, 1, 7),
(4682, 55, 1373594750, 10264, 3, 30),
(4683, 100, 1373595015, 1723, 1, 5),
(4684, 51, 1373595043, 2051, 2, 9),
(4685, 75, 1373595108, 6481, 8, 36),
(4686, 49, 1373595205, 2723, 3, 3),
(4687, 11, 1373595229, 299, 1, 1),
(4688, 80, 1373595230, 2884, 4, 21),
(4689, 92, 1373595275, 2827, 1, 9),
(4690, 107, 1373595279, 9848, 2, 9),
(4691, 18, 1373595284, 597, 1, 2),
(4692, 101, 1373595453, 3265, 1, 17),
(4693, 49, 1373595543, 338, 2, 3),
(4694, 27, 1373595615, 367, 2, 3),
(4695, 87, 1373595695, 4295, 5, 16),
(4696, 45, 1373595705, 2836, 2, 8),
(4697, 86, 1373595718, 2768, 3, 13),
(4698, 42, 1373595725, 7531, 2, 25),
(4699, 44, 1373595836, 10466, 3, 27),
(4700, 29, 1373595860, 646, 2, 5),
(4701, 56, 1373596078, 5148, 1, 11),
(4702, 28, 1373596163, 8208, 3, 34),
(4703, 29, 1373596192, 332, 1, 0),
(4704, 88, 1373596264, 3942, 2, 11),
(4705, 55, 1373596568, 1818, 1, 4),
(4706, 68, 1373596579, 4426, 3, 20),
(4707, 58, 1373596628, 14322, 2, 38),
(4708, 97, 1373596632, 5810, 1, 13),
(4709, 88, 1373596669, 405, 1, 2),
(4710, 23, 1373596685, 2316, 2, 15),
(4711, 101, 1373596696, 1242, 1, 5),
(4712, 25, 1373596844, 689, 1, 2),
(4713, 40, 1373596857, 1322, 1, 4),
(4714, 53, 1373596862, 2864, 1, 2),
(4715, 94, 1373596881, 3946, 2, 14),
(4716, 32, 1373596944, 839, 1, 1),
(4717, 102, 1373597097, 5900, 2, 18),
(4718, 52, 1373597224, 4533, 1, 16),
(4719, 98, 1373597254, 2808, 2, 8),
(4720, 96, 1373597402, 15370, 6, 46),
(4721, 48, 1373597425, 1921, 1, 1),
(4722, 53, 1373597468, 606, 2, 2),
(4723, 64, 1373597486, 15002, 9, 47),
(4724, 71, 1373597534, 3580, 1, 0),
(4725, 105, 1373597534, 12415, 3, 23),
(4726, 31, 1373597637, 1124, 2, 9),
(4727, 63, 1373597637, 4399, 4, 9),
(4728, 88, 1373597969, 1300, 1, 5),
(4729, 24, 1373597996, 5868, 4, 30),
(4730, 66, 1373598048, 10401, 10, 55),
(4731, 30, 1373598058, 4563, 4, 29),
(4732, 72, 1373598113, 4137, 1, 8),
(4733, 25, 1373598205, 1361, 1, 9),
(4734, 19, 1373598229, 654, 1, 0),
(4735, 59, 1373598253, 689, 1, 4),
(4736, 54, 1373598387, 4866, 2, 21),
(4737, 106, 1373598434, 13484, 1, 23),
(4738, 46, 1373598436, 2023, 1, 10),
(4739, 23, 1373598495, 1810, 1, 13),
(4740, 51, 1373598641, 1975, 2, 14),
(4741, 28, 1373598674, 2409, 2, 13),
(4742, 83, 1373598796, 8504, 8, 50),
(4743, 49, 1373598797, 3254, 2, 8),
(4744, 37, 1373598863, 5267, 1, 13),
(4745, 47, 1373599203, 4978, 4, 29),
(4746, 28, 1373599660, 801, 1, 0),
(4747, 52, 1373599671, 2447, 5, 10),
(4748, 80, 1373599685, 4455, 2, 15),
(4749, 56, 1373599752, 3674, 1, 8),
(4750, 84, 1373599761, 10796, 6, 45),
(4751, 76, 1373599859, 9287, 9, 45),
(4752, 77, 1373599983, 19343, 16, 83),
(4753, 65, 1373600259, 6379, 1, 11),
(4754, 36, 1373600412, 319, 2, 0),
(4755, 61, 1373600514, 7782, 9, 32),
(4756, 59, 1373600584, 1989, 1, 6),
(4757, 31, 1373600648, 1088, 1, 8),
(4758, 71, 1373600683, 3120, 2, 14),
(4759, 84, 1373600754, 993, 2, 5),
(4760, 30, 1373600853, 2795, 2, 6),
(4761, 58, 1373600874, 1584, 1, 4),
(4762, 74, 1373600888, 35777, 38, 160),
(4763, 28, 1373600931, 1271, 2, 6),
(4764, 23, 1373601204, 1921, 3, 3),
(4765, 27, 1373601217, 624, 1, 2),
(4766, 25, 1373601285, 2072, 2, 11),
(4767, 65, 1373601341, 1082, 1, 2),
(4768, 45, 1373601352, 2988, 2, 4),
(4769, 24, 1373601435, 3438, 2, 6),
(4770, 18, 1373601557, 517, 1, 0),
(4771, 55, 1373601558, 3152, 4, 6),
(4772, 59, 1373601564, 980, 3, 7),
(4773, 60, 1373601578, 2861, 2, 19),
(4774, 75, 1373601686, 6578, 11, 23),
(4775, 37, 1373601961, 1663, 1, 2),
(4776, 79, 1373602308, 13672, 20, 59),
(4777, 68, 1373602369, 5790, 3, 31),
(4778, 80, 1373602518, 2833, 4, 13),
(4779, 90, 1373602547, 14022, 12, 50),
(4780, 26, 1373602556, 3038, 1, 7),
(4781, 54, 1373602682, 4295, 1, 8),
(4782, 30, 1373602918, 2065, 1, 7),
(4783, 67, 1373602972, 20582, 14, 82),
(4784, 35, 1373602987, 2241, 1, 3),
(4785, 73, 1373602997, 20353, 20, 88),
(4786, 82, 1373603008, 10534, 14, 58),
(4787, 40, 1373603353, 5843, 1, 17),
(4788, 19, 1373603539, 270, 1, 0),
(4789, 69, 1373603611, 15289, 12, 80),
(4790, 61, 1373603640, 1391, 1, 5),
(4791, 79, 1373603654, 1345, 1, 6),
(4792, 53, 1373603839, 5355, 5, 22),
(4793, 70, 1373603893, 9761, 7, 33),
(4794, 81, 1373603913, 14272, 18, 62),
(4795, 12, 1373603972, 635, 1, 0),
(4796, 96, 1373603989, 806, 1, 7),
(4797, 74, 1373604049, 3161, 2, 9),
(4798, 24, 1373604173, 1542, 1, 2),
(4799, 26, 1373604190, 1634, 1, 3),
(4800, 47, 1373604300, 5097, 5, 23),
(4801, 28, 1373604565, 1228, 1, 3),
(4802, 49, 1373604585, 3951, 2, 0),
(4803, 24, 1373604598, 425, 1, 0),
(4804, 29, 1373604713, 3180, 1, 7),
(4805, 42, 1373604778, 4069, 1, 4),
(4806, 51, 1373604908, 3886, 1, 1),
(4807, 60, 1373604951, 1200, 1, 2),
(4808, 28, 1373604978, 413, 1, 3),
(4809, 41, 1373604981, 4398, 1, 2),
(4810, 26, 1373605104, 581, 2, 2),
(4811, 40, 1373605145, 619, 1, 4),
(4812, 32, 1373605207, 748, 1, 2),
(4813, 36, 1373605286, 928, 2, 7),
(4814, 62, 1373605313, 7210, 1, 1),
(4815, 18, 1373605318, 906, 1, 4),
(4816, 63, 1373605378, 7398, 1, 2),
(4817, 56, 1373605437, 5685, 5, 27),
(4818, 29, 1373605512, 799, 1, 4),
(4819, 19, 1373605548, 1659, 3, 2),
(4820, 28, 1373605649, 447, 1, 0),
(4821, 49, 1373605772, 1187, 1, 9),
(4822, 18, 1373605887, 569, 1, 1),
(4823, 41, 1373605923, 942, 2, 3),
(4824, 37, 1373605954, 1061, 1, 5),
(4825, 27, 1373605960, 2371, 4, 15),
(4826, 81, 1373606171, 2258, 3, 11),
(4827, 79, 1373606253, 2599, 3, 2),
(4828, 80, 1373606272, 3754, 3, 8),
(4829, 24, 1373606273, 1675, 2, 9),
(4830, 23, 1373606394, 5190, 2, 6),
(4831, 76, 1373606516, 6657, 1, 5),
(4832, 71, 1373606580, 1212, 1, 6),
(4833, 30, 1373606792, 1051, 1, 3),
(4834, 84, 1373606802, 6048, 2, 12),
(4835, 42, 1373606835, 984, 2, 4),
(4836, 88, 1373606847, 8878, 2, 8),
(4837, 87, 1373606855, 11160, 1, 5),
(4838, 66, 1373606943, 1185, 5, 6),
(4839, 29, 1373606947, 871, 1, 3),
(4840, 44, 1373607346, 7254, 5, 28),
(4841, 43, 1373607365, 6354, 3, 19),
(4842, 53, 1373607496, 3657, 3, 28),
(4843, 80, 1373607746, 1474, 1, 3),
(4844, 50, 1373607782, 12385, 15, 70),
(4845, 40, 1373607972, 1771, 1, 5),
(4846, 51, 1373607972, 1463, 1, 2),
(4847, 13, 1373608004, 2681, 1, 6),
(4848, 49, 1373608011, 2239, 2, 8),
(4849, 43, 1373608273, 260, 1, 0),
(4850, 52, 1373608290, 8619, 16, 47),
(4851, 18, 1373608325, 840, 1, 0),
(4852, 47, 1373608395, 4095, 6, 20),
(4853, 46, 1373608473, 10037, 3, 53),
(4854, 54, 1373608531, 2486, 3, 9),
(4855, 85, 1373608690, 14357, 3, 13),
(4856, 19, 1373608705, 1305, 1, 6),
(4857, 27, 1373608727, 498, 1, 1),
(4858, 36, 1373608767, 2126, 1, 1),
(4859, 42, 1373608774, 1939, 1, 3),
(4860, 83, 1373608786, 3327, 2, 16),
(4861, 32, 1373608825, 189, 1, 2),
(4862, 58, 1373608883, 8009, 3, 23),
(4863, 13, 1373608938, 451, 1, 0),
(4864, 29, 1373608946, 930, 2, 2),
(4865, 12, 1373608961, 864, 1, 1),
(4866, 61, 1373609031, 5391, 4, 33),
(4867, 59, 1373609098, 4299, 5, 25),
(4868, 80, 1373609175, 716, 1, 5),
(4869, 93, 1373609287, 15595, 1, 0),
(4870, 88, 1373609340, 2493, 1, 1),
(4871, 13, 1373609360, 331, 1, 3),
(4872, 48, 1373609384, 11959, 12, 50),
(4873, 81, 1373609395, 3224, 1, 4),
(4874, 66, 1373609408, 2465, 2, 15),
(4875, 63, 1373609440, 3201, 2, 19),
(4876, 57, 1373609450, 15298, 18, 47),
(4877, 98, 1373609492, 11715, 1, 0),
(4878, 40, 1373609593, 1206, 1, 8),
(4879, 30, 1373609623, 630, 1, 2),
(4880, 91, 1373609651, 845, 1, 0),
(4881, 95, 1373609656, 886, 1, 2),
(4882, 32, 1373609672, 266, 1, 1),
(4883, 56, 1373609713, 2624, 2, 9),
(4884, 83, 1373609766, 397, 1, 4),
(4885, 35, 1373609796, 1473, 2, 10),
(4886, 14, 1373609809, 87454, 5, 14),
(4887, 27, 1373609817, 1090, 1, 3),
(4888, 62, 1373609828, 4515, 11, 26),
(4889, 15, 1373609852, 95426, 4, 12),
(4890, 76, 1373609863, 1693, 1, 17),
(4891, 72, 1373609867, 11754, 3, 20),
(4892, 23, 1373609875, 3481, 4, 14),
(4893, 53, 1373609890, 2394, 2, 12),
(4894, 75, 1373609908, 8221, 1, 27),
(4895, 68, 1373610000, 3396, 6, 17),
(4896, 66, 1373610039, 630, 1, 6),
(4897, 84, 1373610072, 3191, 2, 8),
(4898, 46, 1373610124, 1651, 3, 16),
(4899, 24, 1373610289, 1144, 1, 7),
(4900, 94, 1373610301, 13420, 2, 14),
(4901, 44, 1373610316, 2305, 4, 16),
(4902, 78, 1373610338, 40678, 29, 177),
(4903, 61, 1373610538, 1507, 1, 7),
(4904, 87, 1373610538, 3683, 2, 13),
(4905, 86, 1373610553, 14835, 1, 30),
(4906, 49, 1373610586, 2574, 1, 20),
(4907, 95, 1373610626, 970, 1, 12),
(4908, 43, 1373610643, 993, 2, 5),
(4909, 53, 1373611020, 1130, 1, 4),
(4910, 19, 1373611049, 794, 1, 0),
(4911, 67, 1373611172, 5864, 6, 48),
(4912, 40, 1373611191, 148, 1, 1),
(4913, 12, 1373611318, 1107, 1, 0),
(4914, 65, 1373611330, 9989, 3, 35),
(4915, 69, 1373611367, 7756, 7, 37),
(4916, 35, 1373611539, 1743, 2, 6),
(4917, 59, 1373611543, 2134, 2, 14),
(4918, 82, 1373611553, 8545, 4, 18),
(4919, 75, 1373611558, 1650, 3, 10),
(4920, 29, 1373611572, 2626, 1, 18),
(4921, 56, 1373611573, 1860, 4, 19),
(4922, 50, 1373611581, 3799, 4, 25),
(4923, 90, 1373611613, 8456, 5, 23),
(4924, 49, 1373611648, 408, 1, 4),
(4925, 94, 1373611697, 1396, 1, 8),
(4926, 27, 1373611858, 2041, 1, 15),
(4927, 71, 1373611897, 5317, 5, 28),
(4928, 69, 1373611906, 343, 1, 2),
(4929, 42, 1373611929, 3155, 3, 16),
(4930, 24, 1373611997, 1708, 2, 3),
(4931, 45, 1373612028, 5867, 4, 33),
(4932, 109, 1373612186, 17493, 1, 0),
(4933, 32, 1373612267, 668, 2, 2),
(4934, 88, 1373612268, 1836, 2, 9),
(4935, 51, 1373612285, 4313, 3, 22),
(4936, 58, 1373612289, 2402, 5, 18),
(4937, 15, 1373612466, 1495, 1, 4),
(4938, 56, 1373612514, 941, 1, 3),
(4939, 93, 1373612529, 3242, 6, 11),
(4940, 59, 1373612570, 723, 1, 2),
(4941, 81, 1373612609, 2878, 2, 6),
(4942, 48, 1373612715, 3331, 4, 20),
(4943, 110, 1373612837, 974, 1, 4),
(4944, 30, 1373612852, 1039, 1, 0),
(4945, 107, 1373612925, 17646, 1, 3),
(4946, 80, 1373612982, 2563, 2, 12),
(4947, 32, 1373613090, 779, 1, 2),
(4948, 19, 1373613105, 1558, 1, 9),
(4949, 100, 1373613110, 1222, 2, 4),
(4950, 92, 1373613196, 3309, 1, 15),
(4951, 91, 1373613200, 771, 3, 3),
(4952, 96, 1373613237, 3664, 1, 8),
(4953, 65, 1373613380, 2050, 3, 19),
(4954, 82, 1373613393, 1840, 1, 10),
(4955, 40, 1373613396, 2205, 2, 10),
(4956, 95, 1373613468, 2842, 1, 12),
(4957, 28, 1373613520, 4978, 1, 16),
(4958, 11, 1373613597, 2319, 2, 8),
(4959, 46, 1373613761, 3636, 4, 20),
(4960, 40, 1373613794, 398, 1, 4),
(4961, 62, 1373613797, 3969, 3, 28),
(4962, 23, 1373613828, 3952, 2, 18),
(4963, 29, 1373613840, 114, 1, 0),
(4964, 87, 1373613871, 3333, 5, 13),
(4965, 42, 1373613952, 2023, 2, 14),
(4966, 72, 1373613979, 4111, 2, 22),
(4967, 98, 1373614007, 2471, 2, 9),
(4968, 79, 1373614324, 6157, 6, 30),
(4969, 77, 1373614352, 14369, 8, 48),
(4970, 69, 1373614404, 2498, 3, 18),
(4971, 43, 1373614406, 3347, 1, 17),
(4972, 94, 1373614437, 2740, 1, 16),
(4973, 36, 1373614441, 3678, 1, 17),
(4974, 50, 1373614483, 2902, 3, 9),
(4975, 56, 1373614526, 2012, 4, 7),
(4976, 51, 1373614537, 2252, 2, 22),
(4977, 66, 1373614578, 4539, 5, 32),
(4978, 88, 1373614665, 1956, 1, 8),
(4979, 57, 1373614763, 4098, 5, 23),
(4980, 52, 1373614773, 6483, 7, 35),
(4981, 90, 1373614781, 3168, 2, 12),
(4982, 84, 1373614788, 3759, 4, 20),
(4983, 47, 1373614845, 6450, 6, 34),
(4984, 49, 1373614919, 3271, 2, 17),
(4985, 71, 1373614989, 2595, 4, 9),
(4986, 89, 1373615041, 21382, 4, 28),
(4987, 26, 1373615199, 1271, 2, 1),
(4988, 58, 1373615337, 3048, 4, 14),
(4989, 29, 1373615592, 688, 1, 2),
(4990, 105, 1373615600, 17479, 1, 17),
(4991, 86, 1373615970, 4510, 1, 30),
(4992, 23, 1373615982, 1808, 2, 2),
(4993, 70, 1373616143, 12250, 19, 87),
(4994, 61, 1373616292, 5754, 3, 32),
(4995, 80, 1373616344, 3362, 2, 10),
(4996, 93, 1373616456, 3927, 3, 15),
(4997, 52, 1373616680, 1907, 1, 9),
(4998, 78, 1373616795, 6457, 5, 27),
(4999, 76, 1373616822, 6958, 5, 29),
(5000, 59, 1373617180, 4610, 5, 21),
(5001, 48, 1373617199, 4483, 2, 5),
(5002, 46, 1373617199, 3438, 1, 7),
(5003, 85, 1373617227, 6751, 6, 25),
(5004, 31, 1373617254, 11867, 5, 42),
(5005, 64, 1373617485, 19999, 12, 63),
(5006, 60, 1373617511, 12560, 15, 62),
(5007, 63, 1373617715, 8275, 10, 52),
(5008, 57, 1373618069, 2726, 1, 5),
(5009, 55, 1373618420, 13816, 12, 68),
(5010, 80, 1373618462, 2118, 3, 13),
(5011, 18, 1373618521, 3637, 2, 1),
(5012, 67, 1373618722, 7113, 4, 31),
(5013, 15, 1373618747, 881, 1, 2),
(5014, 12, 1373618801, 843, 1, 1),
(5015, 30, 1373618876, 339, 1, 2),
(5016, 75, 1373619154, 7595, 13, 41),
(5017, 11, 1373619249, 1599, 1, 2),
(5018, 26, 1373619461, 729, 1, 1),
(5019, 81, 1373619685, 7076, 7, 22),
(5020, 68, 1373619978, 9978, 11, 53),
(5021, 27, 1373620211, 4232, 1, 4),
(5022, 35, 1373620374, 6405, 2, 5),
(5023, 40, 1373621094, 7300, 1, 3),
(5024, 83, 1373621171, 10362, 7, 36),
(5025, 32, 1373621176, 2337, 1, 3),
(5026, 30, 1373621195, 2319, 1, 1),
(5027, 11, 1373621307, 678, 1, 1),
(5028, 71, 1373621320, 6331, 7, 23),
(5029, 46, 1373621374, 4093, 1, 7),
(5030, 32, 1373621463, 287, 1, 0),
(5031, 11, 1373621600, 293, 1, 1),
(5032, 18, 1373621657, 3136, 2, 7),
(5033, 15, 1373621671, 1383, 2, 0),
(5034, 11, 1373621984, 384, 1, 0),
(5035, 27, 1373622089, 1877, 2, 5),
(5036, 29, 1373622299, 1449, 2, 8),
(5037, 42, 1373622577, 1817, 1, 4),
(5038, 32, 1373622637, 1174, 1, 1),
(5039, 42, 1373622670, 93, 1, 0),
(5040, 47, 1373622745, 7900, 3, 18),
(5041, 31, 1373622906, 5651, 4, 16),
(5042, 11, 1373623058, 194, 1, 0),
(5043, 66, 1373623088, 8510, 11, 21),
(5044, 15, 1373623326, 1655, 2, 1),
(5045, 71, 1373623421, 2101, 1, 2),
(5046, 30, 1373623470, 2275, 1, 12),
(5047, 28, 1373623498, 8163, 9, 20),
(5048, 37, 1373623542, 6707, 1, 8),
(5049, 24, 1373623715, 3345, 4, 14),
(5050, 73, 1373623775, 20778, 16, 70),
(5051, 29, 1373623827, 1493, 2, 7),
(5052, 31, 1373623836, 930, 2, 4),
(5053, 19, 1373623850, 3270, 3, 13),
(5054, 44, 1373624222, 2804, 2, 13),
(5055, 14, 1373624302, 81, 1, 0),
(5056, 54, 1373624426, 10188, 1, 11),
(5057, 49, 1373624621, 1310, 1, 20),
(5058, 47, 1373624648, 1902, 5, 7),
(5059, 19, 1373624657, 807, 1, 0),
(5060, 40, 1373624704, 3119, 2, 9),
(5061, 11, 1373624804, 370, 1, 2),
(5062, 23, 1373625102, 1677, 1, 3),
(5063, 26, 1373625142, 1386, 1, 6),
(5064, 24, 1373625193, 371, 1, 0),
(5065, 43, 1373625210, 10804, 2, 19),
(5066, 44, 1373625347, 1125, 1, 9),
(5067, 41, 1373625465, 4079, 1, 8),
(5068, 12, 1373625484, 1059, 1, 4),
(5069, 60, 1373625568, 7532, 1, 7),
(5070, 46, 1373625623, 4249, 9, 23),
(5071, 15, 1373625773, 564, 1, 3),
(5072, 44, 1373625923, 576, 1, 4),
(5073, 45, 1373626494, 12491, 3, 9),
(5074, 44, 1373626574, 651, 1, 3),
(5075, 42, 1373627095, 3526, 2, 13),
(5076, 59, 1373627323, 10142, 2, 13),
(5077, 18, 1373627376, 292, 1, 0),
(5078, 58, 1373627475, 12138, 1, 20),
(5079, 15, 1373627553, 1162, 2, 0),
(5080, 13, 1373627565, 164, 1, 1),
(5081, 60, 1373627817, 2248, 4, 6),
(5082, 56, 1373627860, 13334, 11, 18),
(5083, 31, 1373628089, 3064, 1, 7),
(5084, 12, 1373628119, 1000, 1, 2),
(5085, 24, 1373628224, 1964, 1, 7),
(5086, 60, 1373628353, 536, 1, 2),
(5087, 47, 1373628399, 3751, 2, 17),
(5088, 14, 1373628531, 936, 1, 1),
(5089, 52, 1373628713, 12033, 10, 42),
(5090, 49, 1373628791, 4170, 6, 25),
(5091, 58, 1373628862, 1387, 2, 0),
(5092, 61, 1373628883, 11123, 1, 21),
(5093, 32, 1373628993, 4083, 3, 8),
(5094, 40, 1373629173, 1653, 1, 4),
(5095, 12, 1373629287, 273, 1, 0),
(5096, 51, 1373629344, 5899, 5, 28),
(5097, 55, 1373629359, 10939, 10, 29),
(5098, 14, 1373629376, 28, 1, 0),
(5099, 35, 1373629555, 1873, 1, 0),
(5100, 13, 1373629587, 1646, 2, 3),
(5101, 47, 1373629725, 1326, 1, 2),
(5102, 37, 1373629752, 1909, 1, 8),
(5103, 42, 1373629754, 2659, 2, 10),
(5104, 11, 1373629857, 202, 1, 1),
(5105, 36, 1373629915, 2225, 1, 3),
(5106, 63, 1373629954, 11910, 1, 0),
(5107, 30, 1373630047, 2279, 3, 8),
(5108, 15, 1373630085, 733, 1, 6),
(5109, 32, 1373630158, 1165, 3, 5),
(5110, 28, 1373630185, 2859, 3, 16),
(5111, 13, 1373630212, 437, 1, 2),
(5112, 65, 1373630237, 15007, 1, 3),
(5113, 37, 1373630255, 503, 1, 2),
(5114, 46, 1373630372, 4749, 3, 7),
(5115, 50, 1373630495, 16012, 5, 10),
(5116, 43, 1373630585, 2999, 1, 11),
(5117, 27, 1373630622, 3229, 1, 3),
(5118, 66, 1373630736, 7040, 1, 3),
(5119, 14, 1373630738, 975, 1, 7),
(5120, 68, 1373630803, 10825, 1, 4),
(5121, 31, 1373630881, 2792, 2, 6),
(5122, 29, 1373630950, 6035, 3, 7),
(5123, 49, 1373631013, 2222, 6, 13),
(5124, 26, 1373631067, 4258, 2, 22),
(5125, 27, 1373631124, 502, 1, 1),
(5126, 19, 1373631124, 3883, 4, 15),
(5127, 44, 1373631132, 4558, 4, 8),
(5128, 41, 1373631219, 2470, 3, 6),
(5129, 32, 1373631270, 1112, 1, 3),
(5130, 46, 1373631422, 1050, 1, 4),
(5131, 42, 1373631481, 1727, 1, 4),
(5132, 61, 1373631829, 1095, 2, 10),
(5133, 60, 1373631922, 1970, 1, 3),
(5134, 24, 1373631946, 3722, 4, 14),
(5135, 66, 1373631971, 1234, 1, 2),
(5136, 41, 1373631991, 772, 1, 4),
(5137, 56, 1373632004, 4144, 2, 15),
(5138, 53, 1373632070, 17021, 1, 10),
(5139, 46, 1373632230, 529, 3, 3),
(5140, 24, 1373632244, 298, 1, 3),
(5141, 40, 1373632291, 3118, 2, 14),
(5142, 55, 1373632417, 3058, 4, 16),
(5143, 71, 1373632427, 9006, 2, 10),
(5144, 54, 1373632449, 8023, 3, 8),
(5145, 31, 1373632467, 1415, 1, 2),
(5146, 29, 1373632474, 593, 1, 6),
(5147, 41, 1373632510, 353, 1, 2),
(5148, 19, 1373632548, 1423, 1, 3),
(5149, 13, 1373632596, 315, 1, 4),
(5150, 75, 1373632656, 13502, 1, 5),
(5151, 28, 1373632848, 1274, 1, 7),
(5152, 40, 1373632972, 681, 1, 2),
(5153, 45, 1373632973, 2989, 2, 3),
(5154, 72, 1373633073, 19094, 2, 14),
(5155, 42, 1373633110, 1629, 1, 3),
(5156, 68, 1373633146, 2341, 6, 14),
(5157, 51, 1373633152, 3807, 1, 4),
(5158, 37, 1373633219, 1499, 1, 10),
(5159, 30, 1373633442, 3395, 1, 4),
(5160, 48, 1373633613, 16414, 24, 57),
(5161, 56, 1373634006, 2002, 2, 5),
(5162, 52, 1373634486, 5773, 5, 19),
(5163, 49, 1373634582, 1474, 2, 1),
(5164, 31, 1373634680, 1602, 1, 1),
(5165, 37, 1373634729, 1510, 1, 3),
(5166, 19, 1373634972, 2423, 1, 5),
(5167, 60, 1373635029, 3107, 5, 17),
(5168, 32, 1373635047, 2787, 1, 4),
(5169, 12, 1373635071, 1281, 3, 6),
(5170, 35, 1373635081, 414, 1, 4),
(5171, 69, 1373635184, 3131, 5, 15),
(5172, 61, 1373635326, 3497, 7, 19),
(5173, 29, 1373635469, 2995, 2, 6),
(5174, 52, 1373635520, 1034, 1, 7),
(5175, 28, 1373635574, 2726, 1, 3),
(5176, 24, 1373635742, 1065, 2, 0),
(5177, 14, 1373635788, 533, 1, 2),
(5178, 70, 1373635789, 5828, 9, 27),
(5179, 41, 1373636233, 3723, 2, 6),
(5180, 63, 1373636420, 6466, 2, 3),
(5181, 49, 1373636445, 1863, 1, 10),
(5182, 23, 1373636562, 855, 1, 0),
(5183, 13, 1373636582, 167, 1, 0),
(5184, 36, 1373636588, 4245, 1, 5),
(5185, 37, 1373636599, 1570, 1, 7),
(5186, 19, 1373636639, 1667, 2, 5),
(5187, 71, 1373636657, 4229, 1, 3),
(5188, 15, 1373636752, 2276, 2, 6),
(5189, 73, 1373636802, 13027, 4, 27),
(5190, 61, 1373636876, 1550, 1, 5),
(5191, 37, 1373636966, 367, 1, 0),
(5192, 12, 1373636983, 716, 1, 3),
(5193, 59, 1373637227, 6225, 9, 32),
(5194, 31, 1373637244, 2268, 1, 8),
(5195, 40, 1373637272, 2315, 3, 11),
(5196, 46, 1373637292, 1488, 1, 7),
(5197, 54, 1373637325, 4876, 1, 9),
(5198, 69, 1373637403, 2219, 1, 5),
(5199, 74, 1373637411, 33361, 5, 23),
(5200, 64, 1373637949, 20464, 4, 46),
(5201, 79, 1373637978, 23654, 2, 8),
(5202, 77, 1373638015, 23663, 3, 15),
(5203, 58, 1373638031, 9169, 10, 40),
(5204, 75, 1373638111, 5455, 1, 6),
(5205, 72, 1373638117, 5044, 2, 7),
(5206, 81, 1373638133, 18448, 1, 3),
(5207, 43, 1373638274, 6065, 4, 16),
(5208, 27, 1373638306, 2391, 1, 7),
(5209, 76, 1373638532, 21710, 1, 12),
(5210, 82, 1373638545, 23558, 1, 2),
(5211, 78, 1373638559, 21763, 1, 2),
(5212, 47, 1373638661, 6264, 2, 23),
(5213, 65, 1373638785, 8548, 2, 39),
(5214, 50, 1373638850, 8355, 5, 42),
(5215, 62, 1373638884, 25087, 4, 53),
(5216, 56, 1373639201, 4294, 4, 18),
(5217, 57, 1373639244, 21175, 8, 48),
(5218, 55, 1373639245, 1861, 2, 11),
(5219, 78, 1373639475, 916, 1, 2),
(5220, 67, 1373639535, 20813, 10, 44),
(5221, 18, 1373639559, 895, 1, 2),
(5222, 13, 1373639613, 927, 1, 3),
(5223, 53, 1373639642, 7376, 8, 21),
(5224, 30, 1373639680, 3279, 1, 6),
(5225, 44, 1373639763, 7086, 6, 33),
(5226, 30, 1373639980, 300, 1, 2),
(5227, 11, 1373640000, 3326, 2, 7),
(5228, 45, 1373640407, 7099, 5, 25),
(5229, 42, 1373640507, 5392, 4, 29),
(5230, 28, 1373640583, 3532, 3, 9),
(5231, 26, 1373640696, 4547, 4, 5),
(5232, 12, 1373640712, 1155, 1, 2),
(5233, 37, 1373641043, 1308, 1, 4),
(5234, 35, 1373641074, 4226, 1, 4),
(5235, 15, 1373641176, 1532, 1, 1),
(5236, 19, 1373641291, 4652, 2, 6),
(5237, 41, 1373641325, 5091, 1, 6),
(5238, 40, 1373641603, 4331, 1, 7),
(5239, 31, 1373641646, 2762, 2, 10),
(5240, 36, 1373641986, 2400, 2, 6),
(5241, 43, 1373641992, 3718, 1, 5),
(5242, 32, 1373642080, 5522, 1, 6),
(5243, 30, 1373642088, 2108, 2, 2),
(5244, 27, 1373642189, 1086, 1, 3),
(5245, 47, 1373642796, 4135, 7, 20),
(5246, 11, 1373642818, 1180, 1, 1),
(5247, 56, 1373642886, 3685, 5, 9),
(5248, 40, 1373643057, 465, 1, 0),
(5249, 44, 1373643090, 3327, 4, 17),
(5250, 23, 1373643325, 1060, 1, 3),
(5251, 43, 1373643450, 785, 1, 1),
(5252, 66, 1373643551, 7284, 2, 9),
(5253, 14, 1373643806, 720, 1, 0),
(5254, 31, 1373644039, 2393, 1, 0),
(5255, 41, 1373644138, 532, 2, 0),
(5256, 46, 1373644195, 1183, 1, 5),
(5257, 45, 1373644203, 3796, 7, 11),
(5258, 63, 1373644663, 8243, 3, 8),
(5259, 27, 1373644701, 2512, 1, 7),
(5260, 64, 1373644853, 6904, 2, 12),
(5261, 50, 1373644930, 5096, 7, 27),
(5262, 67, 1373644973, 1956, 2, 3),
(5263, 13, 1373645274, 674, 1, 0),
(5264, 58, 1373645878, 7847, 8, 20),
(5265, 57, 1373645920, 6675, 8, 35),
(5266, 45, 1373646472, 2269, 2, 9),
(5267, 11, 1373646582, 776, 1, 1),
(5268, 15, 1373646778, 1085, 1, 2),
(5269, 29, 1373646920, 3269, 2, 2),
(5270, 15, 1373647238, 460, 1, 2),
(5271, 23, 1373647287, 748, 1, 3),
(5272, 55, 1373647551, 8305, 7, 21),
(5273, 48, 1373647617, 14004, 16, 60),
(5274, 35, 1373648264, 1115, 1, 3),
(5275, 64, 1373648404, 3551, 1, 0),
(5276, 19, 1373648426, 3893, 3, 3),
(5277, 27, 1373648461, 141, 1, 0),
(5278, 60, 1373648556, 11321, 10, 28),
(5279, 65, 1373648716, 9486, 7, 20),
(5280, 24, 1373648849, 2944, 1, 11),
(5281, 42, 1373648905, 5791, 1, 4),
(5282, 51, 1373648975, 13781, 30, 59),
(5283, 11, 1373649597, 824, 1, 2),
(5284, 71, 1373649813, 13156, 1, 4),
(5285, 32, 1373649871, 3676, 3, 8),
(5286, 68, 1373649903, 7230, 2, 4),
(5287, 75, 1373649910, 9048, 1, 9),
(5288, 41, 1373649951, 228, 1, 2),
(5289, 72, 1373650016, 11899, 3, 6),
(5290, 35, 1373650024, 1509, 1, 5),
(5291, 44, 1373650077, 6987, 3, 6),
(5292, 57, 1373650113, 4192, 1, 15),
(5293, 82, 1373650166, 626, 1, 2),
(5294, 67, 1373650543, 1662, 1, 10),
(5295, 102, 1373650570, 37441, 1, 0),
(5296, 42, 1373650735, 1148, 1, 5),
(5297, 68, 1373650805, 299, 1, 2),
(5298, 27, 1373650857, 2396, 1, 11),
(5299, 13, 1373650964, 312, 1, 0),
(5300, 64, 1373651041, 2637, 3, 10),
(5301, 35, 1373651296, 1166, 1, 5),
(5302, 14, 1373651335, 4574, 1, 13),
(5303, 24, 1373651350, 1302, 1, 8),
(5304, 84, 1373651353, 14405, 1, 10),
(5305, 15, 1373651384, 1118, 1, 4),
(5306, 69, 1373651417, 14014, 1, 11),
(5307, 87, 1373651454, 37583, 1, 10),
(5308, 99, 1373651463, 1032, 1, 6),
(5309, 18, 1373651475, 886, 1, 4),
(5310, 46, 1373651487, 1889, 1, 6),
(5311, 41, 1373651710, 1008, 2, 5),
(5312, 90, 1373651782, 36824, 1, 6),
(5313, 46, 1373651795, 308, 1, 1),
(5314, 49, 1373651885, 8662, 11, 26),
(5315, 23, 1373651934, 2005, 2, 7),
(5316, 85, 1373652016, 34789, 2, 10),
(5317, 68, 1373652067, 1262, 1, 3),
(5318, 36, 1373652151, 3698, 4, 12),
(5319, 90, 1373652163, 381, 1, 0),
(5320, 66, 1373652209, 8658, 3, 16),
(5321, 65, 1373652384, 3668, 3, 10),
(5322, 98, 1373652400, 38393, 1, 6),
(5323, 62, 1373652605, 13687, 7, 45),
(5324, 69, 1373652628, 1211, 1, 12),
(5325, 86, 1373652726, 3007, 1, 11),
(5326, 40, 1373652930, 2524, 3, 8),
(5327, 100, 1373653063, 888, 1, 2),
(5328, 108, 1373653295, 40548, 1, 5),
(5329, 66, 1373653355, 1146, 2, 2),
(5330, 96, 1373653418, 2092, 2, 5),
(5331, 31, 1373653440, 926, 1, 2),
(5332, 50, 1373653480, 8550, 4, 23),
(5333, 32, 1373653572, 3701, 2, 13),
(5334, 19, 1373653645, 5219, 1, 19),
(5335, 76, 1373653777, 15245, 6, 20),
(5336, 28, 1373653785, 3633, 2, 15),
(5337, 85, 1373653800, 1784, 1, 5),
(5338, 107, 1373653806, 40881, 1, 4),
(5339, 68, 1373653836, 1146, 1, 1),
(5340, 26, 1373653872, 10317, 1, 14),
(5341, 103, 1373653902, 520, 1, 4),
(5342, 96, 1373653926, 232, 1, 5),
(5343, 94, 1373654043, 38823, 1, 15),
(5344, 71, 1373654072, 2099, 1, 5),
(5345, 88, 1373654130, 3160, 3, 9),
(5346, 86, 1373654341, 468, 1, 3),
(5347, 60, 1373654386, 5830, 2, 20),
(5348, 75, 1373654497, 4587, 2, 19),
(5349, 36, 1373654516, 1656, 3, 8),
(5350, 73, 1373654579, 17777, 5, 30),
(5351, 16, 1373654593, 98430, 2, 10),
(5352, 20, 1373654593, 91358, 1, 13),
(5353, 21, 1373654593, 82586, 1, 22),
(5354, 22, 1373654594, 123733, 4, 17),
(5355, 25, 1373654594, 53178, 5, 33),
(5356, 31, 1373654595, 1154, 1, 6),
(5357, 33, 1373654595, 126098, 7, 16),
(5358, 34, 1373654596, 111255, 5, 13),
(5359, 38, 1373654596, 87731, 1, 27),
(5360, 39, 1373654597, 103471, 7, 36),
(5361, 41, 1373654597, 2887, 2, 7),
(5362, 42, 1373654597, 3105, 2, 19),
(5363, 43, 1373654597, 5285, 7, 31),
(5364, 44, 1373654597, 4471, 1, 23),
(5365, 45, 1373654598, 8126, 7, 32),
(5366, 47, 1373654598, 11802, 8, 30),
(5367, 48, 1373654598, 6981, 9, 30),
(5368, 49, 1373654598, 2713, 1, 11),
(5369, 51, 1373654599, 5624, 1, 24),
(5370, 52, 1373654599, 19079, 12, 62),
(5371, 53, 1373654599, 14957, 20, 65),
(5372, 54, 1373654599, 17274, 2, 11),
(5373, 55, 1373654600, 7049, 7, 32),
(5374, 56, 1373654600, 11714, 9, 32),
(5375, 57, 1373654600, 3223, 3, 17),
(5376, 58, 1373654600, 8722, 6, 28),
(5377, 59, 1373654600, 17373, 17, 65),
(5378, 61, 1373654601, 5748, 1, 28),
(5379, 62, 1373654601, 1996, 1, 5),
(5380, 63, 1373654601, 9938, 8, 29),
(5381, 64, 1373654601, 3560, 3, 6),
(5382, 67, 1373654602, 1196, 2, 9),
(5383, 72, 1373654603, 4587, 5, 16),
(5384, 74, 1373654603, 17192, 3, 26),
(5385, 77, 1373654604, 16589, 2, 21),
(5386, 78, 1373654604, 15129, 7, 24),
(5387, 79, 1373654604, 4715, 3, 17),
(5388, 80, 1373654604, 16160, 3, 25),
(5389, 81, 1373654604, 16374, 4, 24),
(5390, 82, 1373654605, 1868, 2, 10),
(5391, 83, 1373654605, 16459, 3, 17),
(5392, 84, 1373654605, 3252, 1, 9),
(5393, 87, 1373654605, 2857, 4, 11),
(5394, 89, 1373654606, 2514, 2, 10),
(5395, 92, 1373654606, 41410, 4, 11),
(5396, 97, 1373654607, 41588, 4, 14),
(5397, 98, 1373654607, 2207, 1, 9),
(5398, 99, 1373654608, 3145, 3, 5),
(5399, 100, 1373654608, 942, 1, 5),
(5400, 101, 1373654608, 41620, 1, 15),
(5401, 106, 1373654609, 1634, 1, 6),
(5402, 107, 1373654609, 803, 1, 1),
(5403, 109, 1373654610, 2362, 1, 3),
(5404, 36, 1373655009, 337, 2, 2),
(5405, 46, 1373655033, 360, 1, 0),
(5406, 34, 1373655077, 405, 1, 5),
(5407, 51, 1373655140, 467, 2, 4),
(5408, 53, 1373655326, 653, 1, 2),
(5409, 14, 1373655391, 551, 1, 4),
(5410, 28, 1373655439, 767, 1, 4),
(5411, 15, 1373655504, 833, 1, 3),
(5412, 19, 1373655614, 942, 1, 4),
(5413, 26, 1373655799, 1127, 1, 4),
(5414, 41, 1373655876, 1203, 3, 5),
(5415, 42, 1373655896, 1223, 4, 8),
(5416, 47, 1373655978, 1305, 4, 7),
(5417, 41, 1373656059, 183, 1, 2),
(5418, 55, 1373656129, 1456, 3, 11),
(5419, 46, 1373656232, 1199, 2, 5),
(5420, 43, 1373656299, 1626, 2, 7),
(5421, 32, 1373656484, 1596, 1, 1),
(5422, 18, 1373656507, 1344, 1, 2),
(5423, 61, 1373656555, 1881, 2, 0),
(5424, 60, 1373656666, 1992, 1, 2),
(5425, 29, 1373656705, 1913, 1, 3),
(5426, 23, 1373656730, 1002, 1, 3),
(5427, 28, 1373656790, 1351, 1, 2),
(5428, 56, 1373656872, 2199, 1, 14),
(5429, 46, 1373656905, 673, 2, 4),
(5430, 22, 1373657013, 1578, 2, 4),
(5431, 15, 1373657030, 757, 1, 5),
(5432, 58, 1373657256, 2583, 1, 6),
(5433, 28, 1373657401, 377, 1, 1),
(5434, 44, 1373657554, 2881, 3, 14),
(5435, 49, 1373657609, 2936, 6, 17),
(5436, 13, 1373657698, 85, 1, 0),
(5437, 70, 1373657713, 3039, 1, 1),
(5438, 60, 1373657737, 1071, 2, 0),
(5439, 12, 1373657758, 700, 1, 2),
(5440, 24, 1373657816, 2892, 1, 3),
(5441, 52, 1373657831, 3158, 2, 12),
(5442, 32, 1373657854, 1370, 2, 4),
(5443, 11, 1373657943, 179, 1, 0),
(5444, 34, 1373657970, 2893, 2, 5),
(5445, 40, 1373658022, 888, 1, 3),
(5446, 11, 1373658056, 113, 1, 0),
(5447, 19, 1373658215, 2079, 3, 9),
(5448, 36, 1373658220, 1398, 2, 5),
(5449, 34, 1373658381, 411, 1, 1),
(5450, 20, 1373658406, 3734, 1, 12),
(5451, 32, 1373658525, 670, 1, 2),
(5452, 43, 1373658591, 2292, 1, 14),
(5453, 33, 1373658688, 3162, 2, 6),
(5454, 16, 1373658796, 2060, 2, 5),
(5455, 13, 1373658979, 964, 1, 1),
(5456, 29, 1373659078, 2373, 4, 13),
(5457, 25, 1373659229, 4557, 8, 18),
(5458, 11, 1373659321, 1128, 1, 0),
(5459, 14, 1373659407, 3664, 2, 6),
(5460, 70, 1373659480, 1504, 1, 3),
(5461, 60, 1373659530, 1746, 1, 7),
(5462, 55, 1373659655, 3526, 6, 16),
(5463, 71, 1373659690, 5016, 4, 10),
(5464, 41, 1373659978, 3919, 1, 16),
(5465, 72, 1373659979, 5305, 1, 12),
(5466, 75, 1373660058, 5384, 2, 14),
(5467, 19, 1373660059, 1844, 1, 1),
(5468, 69, 1373660294, 5620, 2, 12),
(5469, 22, 1373660294, 3280, 2, 12),
(5470, 74, 1373660301, 5627, 1, 10),
(5471, 62, 1373660519, 5845, 5, 15),
(5472, 31, 1373660561, 1234, 2, 7),
(5473, 66, 1373660641, 5967, 1, 16),
(5474, 64, 1373660748, 6074, 5, 21),
(5475, 26, 1373660754, 4954, 7, 15),
(5476, 78, 1373660774, 6100, 2, 7),
(5477, 39, 1373660775, 3929, 2, 15),
(5478, 58, 1373660836, 3580, 2, 9),
(5479, 14, 1373660851, 378, 1, 0),
(5480, 77, 1373661021, 6347, 1, 10),
(5481, 41, 1373661094, 1116, 2, 5),
(5482, 15, 1373661251, 2343, 1, 0),
(5483, 46, 1373661325, 2508, 1, 1),
(5484, 12, 1373661378, 409, 1, 0),
(5485, 60, 1373661589, 2058, 1, 3),
(5486, 50, 1373661598, 6925, 12, 53),
(5487, 12, 1373661721, 168, 1, 0),
(5488, 46, 1373661723, 398, 1, 0),
(5489, 91, 1373661792, 7117, 1, 0),
(5490, 37, 1373661895, 3340, 2, 4),
(5491, 40, 1373661900, 3272, 4, 19),
(5492, 42, 1373662047, 3793, 1, 2),
(5493, 13, 1373662070, 922, 2, 2),
(5494, 20, 1373662165, 960, 1, 1),
(5495, 11, 1373662301, 2781, 1, 7),
(5496, 73, 1373662442, 7768, 6, 13),
(5497, 28, 1373662659, 826, 1, 2),
(5498, 14, 1373662669, 1509, 2, 3),
(5499, 67, 1373662770, 8096, 1, 23),
(5500, 99, 1373662782, 8107, 3, 3),
(5501, 12, 1373662855, 330, 1, 1),
(5502, 22, 1373662878, 2583, 2, 4),
(5503, 61, 1373662909, 1216, 1, 5),
(5504, 69, 1373663033, 1491, 1, 5),
(5505, 19, 1373663119, 2925, 2, 4),
(5506, 41, 1373663250, 2156, 1, 9),
(5507, 80, 1373663267, 8593, 1, 7),
(5508, 106, 1373663380, 8705, 1, 2),
(5509, 18, 1373663384, 638, 1, 1),
(5510, 101, 1373663546, 8871, 2, 9),
(5511, 14, 1373663610, 941, 1, 3),
(5512, 15, 1373663618, 1221, 1, 8),
(5513, 36, 1373663729, 1120, 2, 5),
(5514, 82, 1373663834, 9160, 1, 14),
(5515, 70, 1373663851, 4371, 4, 15),
(5516, 34, 1373663906, 2732, 1, 7),
(5517, 76, 1373663986, 4430, 2, 14),
(5518, 44, 1373664016, 6462, 2, 25),
(5519, 95, 1373664097, 9422, 1, 4),
(5520, 105, 1373664133, 9458, 2, 12),
(5521, 89, 1373664148, 1898, 1, 10),
(5522, 58, 1373664207, 3371, 4, 21),
(5523, 65, 1373664245, 2607, 1, 6),
(5524, 84, 1373664433, 2299, 3, 8),
(5525, 29, 1373664488, 5410, 1, 15),
(5526, 16, 1373664504, 5490, 2, 13),
(5527, 19, 1373664522, 866, 1, 1),
(5528, 34, 1373664550, 644, 1, 4),
(5529, 36, 1373664581, 851, 3, 6),
(5530, 80, 1373664618, 1351, 1, 3),
(5531, 15, 1373664624, 178, 1, 2),
(5532, 39, 1373664708, 3933, 3, 18),
(5533, 88, 1373664724, 10049, 1, 6),
(5534, 22, 1373664837, 1958, 1, 5),
(5535, 46, 1373665073, 2210, 1, 10),
(5536, 102, 1373665098, 10423, 4, 13),
(5537, 51, 1373665200, 10060, 15, 51),
(5538, 41, 1373665306, 1962, 1, 5),
(5539, 68, 1373665318, 1909, 1, 9),
(5540, 92, 1373665324, 10649, 1, 15),
(5541, 27, 1373665341, 924, 1, 3),
(5542, 62, 1373665351, 4832, 3, 17),
(5543, 15, 1373665411, 787, 1, 2),
(5544, 13, 1373665560, 1544, 1, 8),
(5545, 79, 1373665623, 10949, 1, 19),
(5546, 37, 1373665665, 1709, 1, 8),
(5547, 28, 1373665668, 2545, 2, 12),
(5548, 88, 1373665678, 954, 2, 0),
(5549, 41, 1373665777, 183, 1, 0),
(5550, 94, 1373665844, 11169, 3, 12),
(5551, 13, 1373666152, 460, 2, 0),
(5552, 86, 1373666359, 295, 1, 2),
(5553, 37, 1373666438, 353, 1, 1),
(5554, 93, 1373666599, 3716, 1, 3),
(5555, 105, 1373666638, 2505, 2, 11),
(5556, 32, 1373666659, 470, 1, 5),
(5557, 16, 1373666734, 1552, 1, 8),
(5558, 24, 1373666841, 987, 1, 2),
(5559, 31, 1373666934, 4530, 3, 15),
(5560, 34, 1373666940, 2390, 1, 5),
(5561, 68, 1373667004, 1325, 2, 9),
(5562, 97, 1373667060, 1197, 1, 4),
(5563, 12, 1373667173, 2596, 3, 9),
(5564, 40, 1373667226, 5326, 2, 19),
(5565, 72, 1373667286, 3398, 1, 8),
(5566, 13, 1373667522, 372, 1, 0),
(5567, 14, 1373667539, 3929, 1, 8),
(5568, 61, 1373667573, 4664, 1, 21),
(5569, 46, 1373667617, 2544, 2, 9),
(5570, 35, 1373667689, 1448, 1, 9),
(5571, 85, 1373667782, 13107, 4, 30),
(5572, 84, 1373667791, 3358, 2, 7),
(5573, 102, 1373667915, 2286, 1, 6),
(5574, 26, 1373667987, 7233, 4, 24),
(5575, 29, 1373668038, 3550, 1, 12),
(5576, 15, 1373668126, 2454, 3, 9),
(5577, 104, 1373668215, 4782, 2, 2),
(5578, 90, 1373668246, 1907, 1, 7),
(5579, 70, 1373668247, 4396, 6, 14),
(5580, 98, 1373668256, 13581, 3, 20),
(5581, 33, 1373668261, 9573, 7, 24),
(5582, 25, 1373668469, 9240, 4, 40),
(5583, 82, 1373668685, 3991, 3, 18),
(5584, 75, 1373668799, 7848, 4, 27),
(5585, 23, 1373668837, 8848, 1, 27),
(5586, 97, 1373668846, 1786, 1, 6),
(5587, 71, 1373668858, 9167, 5, 35),
(5588, 30, 1373669014, 4734, 3, 16),
(5589, 34, 1373669031, 2091, 1, 5),
(5590, 106, 1373669147, 5766, 1, 8),
(5591, 42, 1373669184, 6623, 2, 16),
(5592, 44, 1373669279, 5263, 6, 14),
(5593, 16, 1373669355, 1529, 1, 3),
(5594, 38, 1373669455, 14782, 7, 32),
(5595, 22, 1373669493, 3938, 3, 15),
(5596, 68, 1373669569, 2565, 1, 6),
(5597, 85, 1373669593, 668, 1, 0),
(5598, 86, 1373669660, 1832, 2, 3),
(5599, 37, 1373669763, 874, 1, 0),
(5600, 89, 1373669832, 2444, 1, 2),
(5601, 26, 1373669866, 1878, 1, 11),
(5602, 24, 1373670065, 2216, 1, 4),
(5603, 39, 1373670363, 4593, 3, 22),
(5604, 81, 1373670408, 4235, 2, 12),
(5605, 23, 1373670409, 859, 1, 3),
(5606, 96, 1373670448, 4030, 1, 12),
(5607, 37, 1373670906, 445, 1, 0),
(5608, 51, 1373671042, 5683, 2, 23),
(5609, 18, 1373671082, 2431, 1, 7),
(5610, 61, 1373671085, 3512, 3, 10),
(5611, 36, 1373671095, 974, 1, 1),
(5612, 35, 1373671136, 3447, 3, 11),
(5613, 91, 1373671157, 3706, 1, 0),
(5614, 46, 1373671185, 2174, 3, 6),
(5615, 100, 1373671478, 667, 1, 0),
(5616, 28, 1373671524, 5856, 5, 18),
(5617, 42, 1373671708, 2489, 1, 6),
(5618, 88, 1373671817, 1169, 1, 2),
(5619, 27, 1373671829, 6137, 5, 27),
(5620, 90, 1373671899, 629, 1, 1),
(5621, 87, 1373672242, 17567, 8, 32),
(5622, 68, 1373672333, 2764, 1, 4),
(5623, 95, 1373672505, 8408, 4, 11),
(5624, 22, 1373672532, 3039, 1, 3),
(5625, 72, 1373672551, 5265, 2, 17),
(5626, 104, 1373672573, 3849, 1, 5),
(5627, 76, 1373672594, 3802, 1, 8),
(5628, 67, 1373672757, 3304, 2, 13),
(5629, 100, 1373672799, 1321, 1, 1),
(5630, 108, 1373672829, 5023, 1, 0),
(5631, 96, 1373672876, 1805, 1, 2),
(5632, 104, 1373672935, 362, 1, 1),
(5633, 17, 1373673024, 4517, 1, 1),
(5634, 30, 1373673080, 4066, 2, 12),
(5635, 62, 1373673160, 4910, 2, 13),
(5636, 36, 1373673254, 2068, 3, 3),
(5637, 98, 1373673274, 3080, 3, 3),
(5638, 70, 1373673400, 3199, 2, 13),
(5639, 88, 1373673423, 611, 1, 5),
(5640, 91, 1373673430, 547, 1, 8),
(5641, 86, 1373673479, 3819, 1, 9),
(5642, 35, 1373673501, 457, 1, 2),
(5643, 103, 1373673540, 1064, 1, 3),
(5644, 109, 1373673714, 7391, 1, 7),
(5645, 37, 1373673719, 682, 1, 2),
(5646, 106, 1373673780, 4633, 2, 6),
(5647, 85, 1373673811, 3305, 2, 6),
(5648, 90, 1373673890, 1991, 2, 5),
(5649, 33, 1373673920, 5658, 2, 21),
(5650, 58, 1373674203, 9996, 4, 37),
(5651, 55, 1373674382, 14727, 4, 50),
(5652, 85, 1373674423, 611, 1, 2),
(5653, 66, 1373674592, 7545, 4, 30),
(5654, 101, 1373674597, 1975, 3, 9),
(5655, 46, 1373674685, 3500, 3, 6),
(5656, 92, 1373674688, 7975, 4, 19),
(5657, 29, 1373674753, 6715, 3, 21),
(5658, 105, 1373674754, 1658, 1, 4),
(5659, 94, 1373674784, 8940, 5, 29),
(5660, 43, 1373674825, 16097, 5, 48),
(5661, 20, 1373674896, 5459, 3, 23),
(5662, 77, 1373674911, 13890, 10, 63),
(5663, 84, 1373674917, 3638, 4, 11),
(5664, 80, 1373675068, 6680, 4, 23),
(5665, 23, 1373675284, 4875, 3, 25),
(5666, 25, 1373675667, 7198, 3, 25),
(5667, 42, 1373675744, 3736, 1, 13),
(5668, 76, 1373675777, 3183, 2, 13),
(5669, 51, 1373675787, 4745, 4, 8),
(5670, 16, 1373675828, 3792, 1, 9),
(5671, 68, 1373675861, 3527, 2, 15),
(5672, 32, 1373676176, 4357, 3, 8),
(5673, 17, 1373676353, 496, 1, 0),
(5674, 50, 1373676691, 15092, 9, 69),
(5675, 69, 1373676752, 8437, 2, 44),
(5676, 24, 1373677170, 828, 1, 1),
(5677, 62, 1373677194, 3812, 1, 12),
(5678, 83, 1373677288, 11967, 4, 32),
(5679, 18, 1373677360, 2084, 2, 5),
(5680, 34, 1373677695, 5723, 3, 16),
(5681, 65, 1373677813, 12409, 9, 46),
(5682, 15, 1373677910, 4134, 1, 8),
(5683, 23, 1373678171, 2887, 1, 1),
(5684, 22, 1373678248, 5716, 2, 18),
(5685, 106, 1373678300, 4520, 1, 8),
(5686, 30, 1373678363, 5134, 1, 8),
(5687, 33, 1373678529, 4608, 3, 3),
(5688, 71, 1373678548, 9690, 4, 32),
(5689, 31, 1373678567, 10733, 3, 21),
(5690, 82, 1373678877, 10191, 4, 22),
(5691, 74, 1373678978, 18677, 10, 63),
(5692, 40, 1373679103, 5871, 3, 11),
(5693, 39, 1373679114, 8751, 6, 31),
(5694, 81, 1373679123, 7527, 3, 20),
(5695, 15, 1373679142, 1232, 1, 4),
(5696, 26, 1373679488, 9622, 5, 21),
(5697, 28, 1373679549, 8025, 3, 21),
(5698, 19, 1373680009, 6153, 2, 8),
(5699, 21, 1373680072, 24621, 17, 85),
(5700, 61, 1373680303, 9218, 5, 33),
(5701, 59, 1373680336, 25663, 12, 106),
(5702, 24, 1373680407, 3237, 1, 2),
(5703, 63, 1373680436, 25762, 15, 89),
(5704, 40, 1373680462, 1359, 1, 2),
(5705, 64, 1373680489, 18916, 8, 74),
(5706, 28, 1373680497, 473, 1, 5),
(5707, 38, 1373680542, 11087, 4, 32),
(5708, 30, 1373680598, 2235, 1, 3),
(5709, 20, 1373680809, 2404, 1, 3),
(5710, 56, 1373681106, 24234, 29, 101),
(5711, 32, 1373681127, 4610, 1, 7),
(5712, 18, 1373681135, 716, 1, 3),
(5713, 44, 1373681317, 12038, 3, 31),
(5714, 51, 1373681371, 5584, 3, 19),
(5715, 53, 1373681590, 26264, 20, 109),
(5716, 78, 1373681602, 20828, 9, 75),
(5717, 29, 1373681669, 4499, 1, 7),
(5718, 36, 1373681676, 434, 3, 1),
(5719, 49, 1373681712, 24103, 14, 92),
(5720, 58, 1373681741, 7538, 5, 26),
(5721, 52, 1373681749, 23918, 21, 99),
(5722, 57, 1373681775, 27102, 23, 93),
(5723, 11, 1373681854, 380, 1, 3),
(5724, 47, 1373681940, 25962, 18, 119),
(5725, 23, 1373682307, 4136, 1, 10),
(5726, 34, 1373682542, 4846, 2, 7),
(5727, 36, 1373682553, 877, 1, 0),
(5728, 36, 1373682783, 229, 1, 0),
(5729, 26, 1373682982, 3494, 1, 2),
(5730, 48, 1373683173, 28500, 18, 122),
(5731, 16, 1373683195, 1644, 1, 8),
(5732, 20, 1373683409, 2600, 2, 10),
(5733, 31, 1373683442, 4875, 3, 14),
(5734, 33, 1373683656, 4080, 9, 10),
(5735, 40, 1373683676, 430, 1, 0),
(5736, 38, 1373683816, 1313, 1, 2),
(5737, 23, 1373684200, 1893, 1, 9),
(5738, 36, 1373684260, 1112, 1, 1),
(5739, 47, 1373684304, 2364, 2, 4),
(5740, 35, 1373684678, 1813, 1, 1),
(5741, 16, 1373684817, 1622, 4, 5),
(5742, 17, 1373685073, 3468, 2, 5),
(5743, 17, 1373685333, 260, 1, 1),
(5744, 47, 1373685372, 1068, 1, 0),
(5745, 11, 1373685386, 151, 1, 0),
(5746, 31, 1373685469, 738, 1, 3),
(5747, 15, 1373685610, 1105, 2, 7),
(5748, 29, 1373685654, 3985, 3, 14),
(5749, 39, 1373685857, 868, 2, 3),
(5750, 26, 1373685905, 2923, 6, 11),
(5751, 17, 1373685925, 592, 1, 0),
(5752, 30, 1373686077, 335, 1, 1),
(5753, 30, 1373686253, 176, 1, 0),
(5754, 65, 1373686320, 8507, 2, 0),
(5755, 28, 1373686425, 2962, 1, 13),
(5756, 44, 1373686494, 5177, 3, 9),
(5757, 37, 1373686529, 751, 1, 3),
(5758, 55, 1373687028, 12646, 4, 5),
(5759, 77, 1373687048, 638, 1, 0),
(5760, 61, 1373687358, 7055, 2, 14),
(5761, 51, 1373687379, 6008, 1, 7),
(5762, 68, 1373687425, 972, 1, 4),
(5763, 53, 1373687431, 5841, 2, 9),
(5764, 62, 1373687435, 10240, 1, 3),
(5765, 50, 1373687451, 10760, 1, 14),
(5766, 43, 1373687507, 12682, 4, 10),
(5767, 16, 1373687538, 1726, 1, 14),
(5768, 12, 1373687566, 883, 3, 3),
(5769, 46, 1373687609, 2138, 1, 11),
(5770, 63, 1373687623, 7187, 1, 7),
(5771, 77, 1373687628, 580, 1, 4),
(5772, 41, 1373687687, 1322, 1, 11),
(5773, 34, 1373687745, 5203, 2, 24),
(5774, 28, 1373687908, 1483, 4, 14),
(5775, 32, 1373688000, 3094, 4, 20),
(5776, 17, 1373688059, 2134, 6, 16),
(5777, 72, 1373688067, 702, 1, 6),
(5778, 25, 1373688077, 7696, 7, 39),
(5779, 55, 1373688112, 1084, 1, 10),
(5780, 13, 1373688159, 201, 1, 2),
(5781, 26, 1373688203, 2298, 2, 16),
(5782, 21, 1373688244, 8172, 11, 37),
(5783, 75, 1373688272, 14438, 2, 7),
(5784, 35, 1373688286, 1868, 4, 18),
(5785, 61, 1373688296, 938, 2, 11),
(5786, 17, 1373688299, 239, 2, 1),
(5787, 23, 1373688301, 4101, 2, 15),
(5788, 85, 1373688305, 11708, 2, 6),
(5789, 95, 1373688305, 13763, 1, 5),
(5790, 19, 1373688331, 8321, 11, 40),
(5791, 12, 1373688422, 200, 1, 2),
(5792, 13, 1373688481, 322, 4, 1),
(5793, 76, 1373688526, 1195, 2, 10),
(5794, 65, 1373688764, 1017, 1, 1),
(5795, 41, 1373688849, 1162, 2, 6),
(5796, 96, 1373688881, 1537, 1, 10),
(5797, 49, 1373689134, 817, 1, 3),
(5798, 95, 1373689180, 874, 1, 1),
(5799, 37, 1373689208, 2169, 3, 27),
(5800, 32, 1373689619, 1619, 2, 6),
(5801, 15, 1373689756, 1626, 1, 7),
(5802, 24, 1373689877, 9469, 12, 39),
(5803, 108, 1373689886, 137, 1, 2),
(5804, 88, 1373689970, 575, 1, 2),
(5805, 16, 1373690125, 2073, 1, 3),
(5806, 92, 1373690347, 2348, 2, 10),
(5807, 14, 1373690401, 13112, 13, 46),
(5808, 80, 1373690420, 146, 1, 0),
(5809, 109, 1373690432, 203, 1, 0),
(5810, 50, 1373690465, 3014, 1, 13),
(5811, 77, 1373690500, 2872, 1, 2),
(5812, 104, 1373690527, 16937, 1, 5),
(5813, 20, 1373690541, 7132, 4, 6),
(5814, 109, 1373690745, 157, 1, 0),
(5815, 65, 1373690848, 2084, 1, 6),
(5816, 106, 1373690850, 12025, 1, 6),
(5817, 57, 1373690875, 9100, 4, 23),
(5818, 22, 1373690934, 9565, 11, 51),
(5819, 58, 1373690939, 9198, 3, 24),
(5820, 98, 1373690967, 17191, 3, 19),
(5821, 110, 1373690988, 1351, 1, 1),
(5822, 89, 1373690991, 3072, 4, 12),
(5823, 103, 1373691051, 1737, 1, 6),
(5824, 101, 1373691203, 16606, 1, 7),
(5825, 56, 1373691247, 10141, 2, 27),
(5826, 37, 1373691272, 2063, 1, 11),
(5827, 71, 1373691280, 4904, 1, 19),
(5828, 32, 1373691294, 1675, 2, 7),
(5829, 87, 1373691314, 3659, 3, 14),
(5830, 95, 1373691325, 273, 1, 1),
(5831, 82, 1373691558, 2061, 1, 5),
(5832, 78, 1373691572, 5945, 3, 27),
(5833, 53, 1373691675, 4244, 1, 7),
(5834, 93, 1373691701, 16441, 3, 23),
(5835, 72, 1373691705, 2389, 1, 12),
(5836, 70, 1373691806, 2203, 3, 3),
(5837, 98, 1373691847, 879, 1, 4),
(5838, 50, 1373691847, 1382, 1, 3),
(5839, 85, 1373691909, 2542, 3, 16),
(5840, 68, 1373691950, 3302, 2, 13),
(5841, 37, 1373691956, 623, 1, 2),
(5842, 105, 1373691979, 2194, 2, 9),
(5843, 80, 1373692086, 1666, 1, 2),
(5844, 63, 1373692313, 4690, 1, 16),
(5845, 34, 1373692441, 4136, 3, 13),
(5846, 67, 1373692482, 1365, 1, 2);
INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(5847, 31, 1373692504, 7034, 3, 44),
(5848, 16, 1373692584, 1527, 2, 11),
(5849, 61, 1373692664, 4367, 1, 19),
(5850, 94, 1373692697, 15350, 1, 17),
(5851, 29, 1373692731, 4801, 6, 19),
(5852, 83, 1373692928, 5014, 2, 18),
(5853, 37, 1373693088, 1132, 1, 2),
(5854, 65, 1373693158, 2310, 2, 2),
(5855, 49, 1373693436, 3821, 1, 16),
(5856, 16, 1373693442, 858, 1, 2),
(5857, 81, 1373693502, 4692, 2, 11),
(5858, 97, 1373693511, 5584, 4, 15),
(5859, 15, 1373693768, 2261, 1, 7),
(5860, 13, 1373693840, 1005, 1, 2),
(5861, 70, 1373693885, 649, 2, 1),
(5862, 46, 1373693945, 4165, 3, 7),
(5863, 45, 1373694017, 38994, 21, 103),
(5864, 89, 1373694025, 1041, 2, 0),
(5865, 77, 1373694069, 3569, 1, 10),
(5866, 44, 1373694078, 6693, 2, 32),
(5867, 71, 1373694096, 1392, 2, 3),
(5868, 66, 1373694140, 19548, 5, 36),
(5869, 43, 1373694173, 6666, 8, 38),
(5870, 92, 1373694188, 3841, 1, 12),
(5871, 78, 1373694248, 1014, 1, 1),
(5872, 96, 1373694313, 2363, 1, 5),
(5873, 69, 1373694409, 2641, 1, 3),
(5874, 76, 1373694510, 5852, 2, 11),
(5875, 86, 1373694576, 6268, 4, 18),
(5876, 41, 1373694581, 5046, 3, 21),
(5877, 67, 1373694606, 185, 1, 1),
(5878, 40, 1373694682, 11006, 9, 40),
(5879, 35, 1373694708, 6420, 4, 25),
(5880, 91, 1373694827, 2914, 1, 4),
(5881, 48, 1373694884, 11682, 10, 36),
(5882, 98, 1373694930, 2218, 1, 4),
(5883, 81, 1373695057, 1555, 1, 2),
(5884, 62, 1373695080, 4191, 2, 19),
(5885, 17, 1373695264, 6963, 1, 27),
(5886, 28, 1373695281, 7372, 5, 45),
(5887, 57, 1373695296, 4421, 5, 17),
(5888, 65, 1373695405, 2247, 1, 6),
(5889, 53, 1373695407, 3732, 4, 16),
(5890, 64, 1373695408, 9743, 4, 35),
(5891, 90, 1373695457, 6238, 4, 24),
(5892, 34, 1373695483, 3042, 1, 19),
(5893, 67, 1373695553, 947, 1, 2),
(5894, 72, 1373695749, 3438, 1, 5),
(5895, 68, 1373695761, 2185, 1, 13),
(5896, 42, 1373695807, 19439, 5, 61),
(5897, 32, 1373695812, 2457, 3, 18),
(5898, 45, 1373695998, 1981, 3, 10),
(5899, 63, 1373696109, 3796, 2, 18),
(5900, 13, 1373696148, 306, 2, 0),
(5901, 13, 1373696775, 310, 1, 0),
(5902, 39, 1373696935, 6825, 4, 29),
(5903, 72, 1373697021, 1101, 1, 3),
(5904, 69, 1373697037, 2051, 1, 3),
(5905, 65, 1373697074, 1669, 1, 9),
(5906, 81, 1373697185, 440, 1, 1),
(5907, 71, 1373697273, 3041, 1, 11),
(5908, 47, 1373697298, 6667, 3, 35),
(5909, 103, 1373697314, 5397, 1, 2),
(5910, 95, 1373697405, 3168, 1, 0),
(5911, 46, 1373697429, 256, 1, 0),
(5912, 89, 1373697508, 282, 1, 4),
(5913, 67, 1373697608, 2055, 1, 6),
(5914, 15, 1373697730, 764, 2, 5),
(5915, 87, 1373697800, 6486, 4, 13),
(5916, 30, 1373697930, 8354, 11, 38),
(5917, 84, 1373697969, 1916, 3, 6),
(5918, 12, 1373698009, 1164, 1, 3),
(5919, 61, 1373698093, 4586, 3, 15),
(5920, 13, 1373698111, 764, 1, 0),
(5921, 45, 1373698158, 2160, 1, 6),
(5922, 64, 1373698236, 2828, 3, 11),
(5923, 102, 1373698245, 822, 1, 3),
(5924, 58, 1373698251, 7312, 2, 19),
(5925, 68, 1373698370, 2609, 1, 9),
(5926, 52, 1373698419, 8134, 7, 37),
(5927, 71, 1373698435, 1161, 2, 3),
(5928, 81, 1373698550, 1365, 1, 7),
(5929, 44, 1373698635, 4557, 6, 17),
(5930, 66, 1373698826, 4686, 4, 15),
(5931, 15, 1373698996, 1266, 1, 1),
(5932, 55, 1373699020, 10908, 8, 45),
(5933, 69, 1373699069, 962, 1, 0),
(5934, 37, 1373699094, 6005, 1, 21),
(5935, 38, 1373699190, 14677, 9, 69),
(5936, 18, 1373699201, 18066, 26, 96),
(5937, 77, 1373699433, 2235, 1, 17),
(5938, 28, 1373699494, 4213, 1, 27),
(5939, 32, 1373699550, 2062, 2, 9),
(5940, 88, 1373699608, 3103, 1, 19),
(5941, 13, 1373699674, 1563, 1, 5),
(5942, 12, 1373699680, 465, 1, 4),
(5943, 90, 1373699719, 4262, 2, 20),
(5944, 16, 1373699733, 1904, 1, 4),
(5945, 37, 1373699820, 726, 1, 3),
(5946, 75, 1373699912, 4221, 1, 20),
(5947, 15, 1373699921, 925, 1, 8),
(5948, 82, 1373699931, 1390, 2, 1),
(5949, 87, 1373699943, 2143, 1, 1),
(5950, 49, 1373700206, 6770, 3, 26),
(5951, 70, 1373700221, 6108, 3, 26),
(5952, 86, 1373700356, 780, 1, 2),
(5953, 95, 1373700575, 2705, 1, 0),
(5954, 66, 1373700584, 1758, 1, 9),
(5955, 47, 1373700878, 3580, 1, 5),
(5956, 80, 1373700898, 5601, 4, 16),
(5957, 62, 1373700914, 5834, 1, 21),
(5958, 67, 1373700939, 1319, 1, 2),
(5959, 88, 1373700957, 1349, 1, 7),
(5960, 81, 1373701056, 1814, 1, 3),
(5961, 65, 1373701282, 2261, 1, 6),
(5962, 69, 1373701287, 2218, 3, 9),
(5963, 82, 1373701308, 152, 1, 0),
(5964, 11, 1373701392, 2943, 1, 20),
(5965, 28, 1373701425, 1931, 1, 8),
(5966, 68, 1373701440, 3070, 2, 11),
(5967, 95, 1373701523, 230, 1, 0),
(5968, 76, 1373701548, 2518, 1, 6),
(5969, 55, 1373701578, 2558, 2, 10),
(5970, 77, 1373701629, 2196, 1, 8),
(5971, 15, 1373701642, 1306, 1, 5),
(5972, 51, 1373701696, 14317, 7, 82),
(5973, 40, 1373701764, 5009, 3, 14),
(5974, 32, 1373701918, 1589, 3, 9),
(5975, 74, 1373701946, 9802, 1, 15),
(5976, 17, 1373701989, 6725, 5, 25),
(5977, 107, 1373701995, 10251, 1, 18),
(5978, 49, 1373702254, 2048, 1, 7),
(5979, 53, 1373702263, 6856, 4, 23),
(5980, 50, 1373702301, 10454, 6, 42),
(5981, 34, 1373702528, 7045, 2, 27),
(5982, 98, 1373702536, 5718, 2, 15),
(5983, 46, 1373702593, 1549, 1, 8),
(5984, 56, 1373702654, 11407, 5, 47),
(5985, 96, 1373702655, 4168, 1, 15),
(5986, 90, 1373702663, 2506, 1, 5),
(5987, 35, 1373702716, 5971, 2, 22),
(5988, 39, 1373702809, 5874, 4, 16),
(5989, 16, 1373703006, 3273, 1, 11),
(5990, 48, 1373703058, 8174, 3, 26),
(5991, 43, 1373703125, 8952, 5, 23),
(5992, 41, 1373703191, 3163, 3, 6),
(5993, 71, 1373703225, 4756, 2, 15),
(5994, 45, 1373703297, 5139, 1, 23),
(5995, 39, 1373703393, 584, 1, 1),
(5996, 61, 1373703479, 1971, 1, 12),
(5997, 69, 1373703582, 1191, 2, 2),
(5998, 57, 1373703628, 7634, 5, 32),
(5999, 77, 1373703670, 377, 1, 0),
(6000, 29, 1373703866, 10581, 6, 61),
(6001, 24, 1373703882, 14005, 13, 70),
(6002, 26, 1373703934, 15731, 9, 72),
(6003, 72, 1373704061, 1281, 1, 0),
(6004, 39, 1373704126, 733, 1, 2),
(6005, 40, 1373704180, 1625, 3, 6),
(6006, 16, 1373704236, 904, 1, 4),
(6007, 76, 1373704665, 713, 1, 3),
(6008, 104, 1373704890, 7246, 1, 0),
(6009, 65, 1373705054, 1067, 2, 3),
(6010, 20, 1373705219, 14678, 13, 57),
(6011, 11, 1373705282, 354, 1, 1),
(6012, 83, 1373705359, 4046, 1, 5),
(6013, 66, 1373705393, 4809, 1, 20),
(6014, 69, 1373705447, 1769, 1, 7),
(6015, 77, 1373705499, 1829, 1, 6),
(6016, 28, 1373705554, 4129, 2, 10),
(6017, 95, 1373705558, 684, 1, 0),
(6018, 58, 1373705578, 7327, 2, 35),
(6019, 76, 1373705672, 1007, 1, 3),
(6020, 81, 1373705764, 3269, 1, 5),
(6021, 104, 1373705834, 473, 1, 2),
(6022, 100, 1373705839, 206, 2, 1),
(6023, 78, 1373705873, 4864, 2, 3),
(6024, 41, 1373705891, 2700, 4, 8),
(6025, 89, 1373705975, 465, 2, 4),
(6026, 49, 1373706200, 1980, 1, 6),
(6027, 98, 1373706205, 3626, 1, 7),
(6028, 87, 1373706323, 1732, 2, 4),
(6029, 102, 1373706533, 1634, 1, 6),
(6030, 39, 1373706585, 2459, 2, 5),
(6031, 86, 1373706717, 1214, 2, 5),
(6032, 88, 1373706799, 5842, 1, 7),
(6033, 37, 1373706890, 2602, 1, 9),
(6034, 36, 1373706950, 22689, 15, 95),
(6035, 42, 1373706977, 11118, 4, 44),
(6036, 89, 1373706999, 1023, 1, 1),
(6037, 64, 1373707071, 8835, 4, 29),
(6038, 61, 1373707088, 3609, 2, 12),
(6039, 99, 1373707123, 2149, 2, 2),
(6040, 63, 1373707126, 2444, 1, 4),
(6041, 12, 1373707190, 1987, 1, 5),
(6042, 58, 1373707307, 1729, 1, 3),
(6043, 45, 1373707433, 4136, 1, 19),
(6044, 65, 1373707454, 1774, 1, 5),
(6045, 91, 1373707459, 3248, 3, 12),
(6046, 51, 1373707472, 5776, 2, 19),
(6047, 46, 1373707531, 4337, 4, 12),
(6048, 85, 1373707562, 2548, 1, 13),
(6049, 35, 1373707628, 3652, 1, 21),
(6050, 72, 1373707682, 1993, 1, 3),
(6051, 22, 1373707897, 16963, 12, 79),
(6052, 16, 1373708048, 3812, 2, 12),
(6053, 32, 1373708292, 4101, 4, 22),
(6054, 58, 1373708385, 880, 2, 4),
(6055, 57, 1373708404, 4776, 1, 22),
(6056, 13, 1373708745, 955, 1, 1),
(6057, 81, 1373708756, 522, 1, 1),
(6058, 17, 1373708834, 6844, 3, 31),
(6059, 95, 1373709047, 1065, 1, 4),
(6060, 68, 1373709058, 6706, 2, 12),
(6061, 75, 1373709069, 2410, 4, 4),
(6062, 34, 1373709086, 6558, 5, 29),
(6063, 12, 1373709225, 1750, 1, 6),
(6064, 101, 1373709242, 737, 1, 3),
(6065, 11, 1373709276, 3993, 2, 12),
(6066, 64, 1373709323, 2252, 2, 15),
(6067, 16, 1373709446, 1106, 2, 6),
(6068, 23, 1373709577, 21274, 18, 86),
(6069, 90, 1373709587, 4420, 3, 11),
(6070, 62, 1373709592, 5643, 3, 13),
(6071, 102, 1373709735, 3202, 1, 7),
(6072, 100, 1373709797, 631, 1, 2),
(6073, 47, 1373709892, 4165, 1, 14),
(6074, 58, 1373709954, 1569, 1, 5),
(6075, 94, 1373710039, 1336, 1, 5),
(6076, 46, 1373710085, 2554, 1, 11),
(6077, 86, 1373710201, 201, 1, 0),
(6078, 42, 1373710361, 1248, 1, 6),
(6079, 40, 1373710442, 6262, 3, 30),
(6080, 78, 1373710757, 641, 2, 2),
(6081, 76, 1373710781, 1029, 1, 1),
(6082, 86, 1373710807, 606, 1, 1),
(6083, 40, 1373710859, 417, 2, 1),
(6084, 32, 1373710860, 2211, 4, 7),
(6085, 72, 1373710941, 1693, 4, 9),
(6086, 98, 1373711114, 2627, 1, 7),
(6087, 83, 1373711218, 5859, 3, 11),
(6088, 85, 1373711234, 3672, 3, 10),
(6089, 12, 1373711245, 1515, 2, 10),
(6090, 110, 1373711304, 1695, 2, 5),
(6091, 11, 1373711380, 2104, 1, 10),
(6092, 71, 1373711382, 8157, 1, 19),
(6093, 97, 1373711608, 2627, 1, 7),
(6094, 66, 1373711621, 4359, 3, 17),
(6095, 50, 1373711650, 9349, 5, 30),
(6096, 12, 1373711855, 610, 1, 2),
(6097, 77, 1373712010, 6187, 1, 16),
(6098, 87, 1373712046, 1370, 1, 3),
(6099, 95, 1373712072, 1125, 1, 2),
(6100, 37, 1373712107, 4720, 1, 19),
(6101, 66, 1373712121, 500, 1, 2),
(6102, 78, 1373712124, 1367, 1, 4),
(6103, 87, 1373712179, 133, 1, 0),
(6104, 83, 1373712182, 964, 2, 2),
(6105, 82, 1373712256, 1702, 1, 3),
(6106, 15, 1373712259, 9718, 7, 31),
(6107, 89, 1373712259, 1756, 1, 8),
(6108, 67, 1373712283, 3272, 3, 5),
(6109, 82, 1373712442, 186, 1, 0),
(6110, 103, 1373712510, 1829, 1, 4),
(6111, 69, 1373712532, 6125, 3, 24),
(6112, 94, 1373712589, 1620, 1, 4),
(6113, 100, 1373712673, 1008, 1, 2),
(6114, 110, 1373712744, 1440, 1, 4),
(6115, 70, 1373712785, 4918, 6, 13),
(6116, 99, 1373712818, 2417, 1, 7),
(6117, 63, 1373712852, 5726, 2, 20),
(6118, 68, 1373713003, 3390, 1, 15),
(6119, 37, 1373713086, 979, 1, 4),
(6120, 65, 1373713280, 5148, 1, 15),
(6121, 25, 1373713286, 25208, 18, 102),
(6122, 61, 1373713398, 6310, 4, 22),
(6123, 64, 1373713409, 4086, 6, 16),
(6124, 97, 1373713421, 1177, 1, 0),
(6125, 102, 1373713453, 3207, 1, 13),
(6126, 35, 1373713554, 5926, 8, 29),
(6127, 89, 1373713655, 1396, 1, 1),
(6128, 32, 1373713666, 2666, 5, 9),
(6129, 85, 1373713742, 2508, 3, 3),
(6130, 98, 1373713781, 2667, 1, 5),
(6131, 12, 1373713785, 1930, 2, 8),
(6132, 11, 1373713792, 2412, 2, 12),
(6133, 68, 1373713804, 515, 1, 5),
(6134, 96, 1373714078, 7474, 3, 12),
(6135, 77, 1373714089, 2079, 2, 9),
(6136, 49, 1373714169, 6144, 2, 15),
(6137, 62, 1373714379, 2164, 1, 6),
(6138, 99, 1373714502, 774, 1, 3),
(6139, 67, 1373714656, 727, 1, 2),
(6140, 65, 1373714677, 996, 1, 1),
(6141, 57, 1373714833, 6429, 1, 24),
(6142, 80, 1373714842, 9389, 4, 30),
(6143, 61, 1373714874, 1177, 1, 5),
(6144, 88, 1373714902, 3168, 1, 4),
(6145, 62, 1373714982, 603, 1, 0),
(6146, 18, 1373715002, 15801, 10, 49),
(6147, 83, 1373715128, 2418, 1, 8),
(6148, 91, 1373715162, 1729, 1, 8),
(6149, 81, 1373715205, 1560, 3, 4),
(6150, 74, 1373715221, 13275, 6, 34),
(6151, 30, 1373715256, 17326, 10, 81),
(6152, 89, 1373715300, 1478, 1, 4),
(6153, 17, 1373715414, 6494, 3, 36),
(6154, 72, 1373715420, 1075, 1, 7),
(6155, 29, 1373715442, 11346, 8, 55),
(6156, 94, 1373715503, 2062, 4, 6),
(6157, 16, 1373715612, 3398, 3, 12),
(6158, 75, 1373715635, 4535, 4, 13),
(6159, 90, 1373715676, 409, 1, 1),
(6160, 46, 1373715686, 1499, 4, 5),
(6161, 76, 1373715731, 488, 1, 2),
(6162, 101, 1373715987, 990, 2, 2),
(6163, 65, 1373715987, 1310, 1, 6),
(6164, 104, 1373715997, 3581, 1, 4),
(6165, 37, 1373716086, 2010, 2, 7),
(6166, 12, 1373716112, 1865, 1, 4),
(6167, 15, 1373716224, 2508, 2, 17),
(6168, 65, 1373716342, 355, 1, 4),
(6169, 50, 1373716449, 4121, 7, 15),
(6170, 64, 1373716455, 3046, 2, 10),
(6171, 41, 1373716571, 9515, 8, 39),
(6172, 97, 1373716631, 1649, 1, 6),
(6173, 67, 1373716899, 110, 1, 1),
(6174, 16, 1373717037, 1425, 2, 0),
(6175, 92, 1373717088, 11106, 1, 28),
(6176, 49, 1373717135, 2903, 3, 13),
(6177, 72, 1373717135, 1715, 1, 4),
(6178, 71, 1373717167, 5425, 2, 17),
(6179, 63, 1373717173, 3739, 1, 13),
(6180, 70, 1373717208, 1950, 1, 10),
(6181, 76, 1373717312, 1553, 1, 0),
(6182, 39, 1373717338, 10753, 4, 55),
(6183, 68, 1373717436, 1587, 1, 1),
(6184, 40, 1373717633, 4188, 3, 27),
(6185, 101, 1373717644, 1486, 1, 2),
(6186, 65, 1373717697, 1355, 1, 3),
(6187, 37, 1373717752, 1665, 2, 5),
(6188, 44, 1373717808, 19173, 13, 73),
(6189, 69, 1373717832, 2565, 2, 10),
(6190, 95, 1373718153, 3096, 2, 8),
(6191, 28, 1373718252, 10538, 8, 47),
(6192, 46, 1373718332, 2646, 3, 9),
(6193, 107, 1373718466, 5087, 2, 9),
(6194, 67, 1373718539, 1640, 1, 0),
(6195, 66, 1373718665, 3705, 1, 15),
(6196, 47, 1373718826, 8934, 5, 32),
(6197, 40, 1373718953, 1320, 1, 2),
(6198, 26, 1373718983, 15049, 13, 67),
(6199, 68, 1373719225, 1789, 1, 2),
(6200, 28, 1373719387, 1045, 1, 2),
(6201, 49, 1373719491, 2356, 2, 2),
(6202, 35, 1373719531, 5977, 2, 28),
(6203, 61, 1373719546, 4672, 2, 6),
(6204, 45, 1373719774, 12340, 6, 46),
(6205, 59, 1373719899, 39563, 12, 110),
(6206, 11, 1373719924, 6132, 1, 23),
(6207, 36, 1373720053, 13103, 11, 48),
(6208, 63, 1373720062, 2735, 2, 1),
(6209, 37, 1373720168, 986, 1, 5),
(6210, 42, 1373720292, 9931, 9, 41),
(6211, 96, 1373720364, 5021, 4, 9),
(6212, 44, 1373720815, 3007, 1, 9),
(6213, 14, 1373721071, 30669, 15, 119),
(6214, 71, 1373721143, 3976, 1, 7),
(6215, 51, 1373721898, 14426, 3, 48),
(6216, 57, 1373722041, 7208, 3, 21),
(6217, 55, 1373722105, 19783, 5, 65),
(6218, 39, 1373722393, 5055, 6, 17),
(6219, 32, 1373722406, 5881, 3, 18),
(6220, 49, 1373722539, 3048, 3, 10),
(6221, 53, 1373722580, 20316, 7, 58),
(6222, 34, 1373722646, 12677, 11, 60),
(6223, 52, 1373722673, 24254, 9, 81),
(6224, 50, 1373722692, 1705, 4, 5),
(6225, 15, 1373722748, 327, 1, 0),
(6226, 29, 1373722942, 770, 1, 8),
(6227, 64, 1373723105, 6650, 3, 12),
(6228, 42, 1373723124, 1646, 1, 3),
(6229, 36, 1373723246, 3193, 2, 8),
(6230, 69, 1373723283, 742, 1, 1),
(6231, 58, 1373723287, 5018, 2, 14),
(6232, 45, 1373723384, 1754, 1, 11),
(6233, 43, 1373723437, 20311, 15, 89),
(6234, 14, 1373723710, 2639, 1, 9),
(6235, 31, 1373724070, 31566, 33, 147),
(6236, 34, 1373724251, 1605, 1, 2),
(6237, 38, 1373724264, 24996, 15, 101),
(6238, 40, 1373724334, 5381, 2, 12),
(6239, 47, 1373724349, 1743, 2, 7),
(6240, 51, 1373724489, 2591, 1, 6),
(6241, 57, 1373724582, 1796, 2, 6),
(6242, 39, 1373724601, 2208, 1, 6),
(6243, 43, 1373724861, 1424, 1, 4),
(6244, 55, 1373724924, 2629, 1, 4),
(6245, 17, 1373725038, 2830, 1, 9),
(6246, 15, 1373725397, 810, 1, 0),
(6247, 12, 1373725526, 3305, 2, 15),
(6248, 45, 1373725750, 2366, 2, 2),
(6249, 32, 1373725795, 516, 1, 2),
(6250, 30, 1373725907, 10650, 8, 35),
(6251, 33, 1373726019, 42363, 36, 184),
(6252, 34, 1373726048, 1797, 1, 3),
(6253, 16, 1373726105, 1418, 2, 3),
(6254, 12, 1373726629, 492, 1, 3),
(6255, 63, 1373726675, 3036, 1, 1),
(6256, 19, 1373726687, 38356, 19, 146),
(6257, 29, 1373726724, 3782, 2, 19),
(6258, 50, 1373726785, 3313, 1, 1),
(6259, 52, 1373726824, 4151, 2, 11),
(6260, 25, 1373726846, 13560, 12, 68),
(6261, 57, 1373727167, 1660, 1, 3),
(6262, 35, 1373727250, 1504, 2, 7),
(6263, 51, 1373727253, 2764, 1, 1),
(6264, 11, 1373727534, 1336, 1, 6),
(6265, 17, 1373727540, 2501, 1, 10),
(6266, 55, 1373727588, 2664, 1, 4),
(6267, 20, 1373727657, 22438, 17, 93),
(6268, 47, 1373727849, 3500, 1, 6),
(6269, 40, 1373727957, 3623, 1, 5),
(6270, 15, 1373727974, 2109, 2, 13),
(6271, 43, 1373728016, 3155, 1, 2),
(6272, 42, 1373728335, 4443, 2, 7),
(6273, 58, 1373728352, 4195, 1, 6),
(6274, 48, 1373728491, 25433, 11, 89),
(6275, 18, 1373728622, 13620, 6, 58),
(6276, 35, 1373728666, 1415, 1, 6),
(6277, 39, 1373728866, 2524, 2, 7),
(6278, 21, 1373728933, 40689, 30, 180),
(6279, 37, 1373729333, 2926, 1, 2),
(6280, 30, 1373729574, 3667, 7, 18),
(6281, 36, 1373729614, 4229, 2, 15),
(6282, 19, 1373729622, 2935, 2, 2),
(6283, 34, 1373729647, 3468, 6, 17),
(6284, 35, 1373729869, 1203, 1, 1),
(6285, 27, 1373729991, 53520, 50, 240),
(6286, 45, 1373730100, 615, 1, 1),
(6287, 14, 1373730277, 1722, 4, 4),
(6288, 23, 1373730334, 20757, 21, 92),
(6289, 18, 1373730373, 1751, 1, 5),
(6290, 16, 1373730379, 1062, 1, 4),
(6291, 47, 1373730661, 2465, 1, 2),
(6292, 22, 1373730785, 22888, 23, 92),
(6293, 38, 1373730841, 1836, 1, 5),
(6294, 17, 1373731248, 3708, 2, 10),
(6295, 19, 1373731560, 1938, 2, 7),
(6296, 43, 1373731566, 3550, 1, 3),
(6297, 32, 1373732084, 5337, 7, 20),
(6298, 43, 1373732216, 556, 1, 1),
(6299, 34, 1373732303, 451, 1, 3),
(6300, 15, 1373732476, 421, 1, 0),
(6301, 41, 1373732549, 665, 1, 1),
(6302, 35, 1373732562, 2618, 1, 2),
(6303, 46, 1373732857, 205, 1, 0),
(6304, 33, 1373733127, 7107, 13, 33),
(6305, 12, 1373733316, 816, 3, 8),
(6306, 11, 1373733327, 159, 1, 0),
(6307, 57, 1373733356, 279, 1, 3),
(6308, 78, 1373733416, 16127, 1, 0),
(6309, 85, 1373733547, 15865, 1, 1),
(6310, 68, 1373733681, 9104, 1, 1),
(6311, 50, 1373733783, 1180, 2, 5),
(6312, 45, 1373733815, 1131, 3, 15),
(6313, 14, 1373733914, 1715, 2, 16),
(6314, 38, 1373734037, 3196, 2, 4),
(6315, 59, 1373734095, 1277, 1, 6),
(6316, 36, 1373734182, 4180, 1, 7),
(6317, 87, 1373734208, 13705, 1, 6),
(6318, 67, 1373734251, 717, 1, 5),
(6319, 62, 1373734308, 261, 1, 2),
(6320, 83, 1373734312, 1036, 1, 3),
(6321, 92, 1373734338, 17250, 1, 4),
(6322, 41, 1373734362, 538, 1, 3),
(6323, 80, 1373734410, 1193, 1, 5),
(6324, 84, 1373734427, 741, 1, 2),
(6325, 45, 1373734442, 395, 1, 1),
(6326, 19, 1373734614, 1788, 4, 11),
(6327, 89, 1373734641, 814, 2, 5),
(6328, 86, 1373734673, 17942, 1, 7),
(6329, 16, 1373734681, 2126, 4, 8),
(6330, 44, 1373734796, 2259, 7, 11),
(6331, 63, 1373734846, 332, 1, 0),
(6332, 49, 1373734859, 783, 2, 5),
(6333, 75, 1373734859, 1400, 3, 7),
(6334, 66, 1373734891, 11030, 1, 11),
(6335, 18, 1373734938, 4565, 2, 17),
(6336, 50, 1373734947, 455, 1, 2),
(6337, 94, 1373734953, 19310, 1, 7),
(6338, 97, 1373734983, 18352, 2, 5),
(6339, 95, 1373735027, 16874, 1, 5),
(6340, 55, 1373735051, 933, 1, 9),
(6341, 80, 1373735063, 653, 1, 7),
(6342, 88, 1373735104, 18255, 3, 7),
(6343, 53, 1373735176, 1609, 2, 14),
(6344, 84, 1373735296, 744, 1, 4),
(6345, 63, 1373735383, 537, 1, 2),
(6346, 12, 1373735434, 885, 1, 4),
(6347, 39, 1373735468, 2776, 4, 22),
(6348, 47, 1373735501, 2182, 2, 15),
(6349, 36, 1373735530, 1348, 2, 19),
(6350, 37, 1373735602, 1079, 1, 2),
(6351, 63, 1373735638, 254, 1, 1),
(6352, 40, 1373735659, 1685, 3, 17),
(6353, 45, 1373735707, 298, 1, 0),
(6354, 89, 1373735723, 595, 2, 3),
(6355, 46, 1373735770, 2913, 4, 27),
(6356, 44, 1373735797, 1001, 1, 4),
(6357, 48, 1373735814, 4197, 1, 28),
(6358, 55, 1373735845, 794, 1, 4),
(6359, 15, 1373735854, 2693, 3, 21),
(6360, 64, 1373735932, 1663, 1, 3),
(6361, 18, 1373735964, 1026, 2, 8),
(6362, 35, 1373736125, 3563, 2, 18),
(6363, 50, 1373736170, 1223, 1, 4),
(6364, 63, 1373736566, 49, 1, 0),
(6365, 42, 1373736586, 4179, 2, 29),
(6366, 16, 1373736602, 1920, 2, 12),
(6367, 13, 1373736649, 734, 2, 7),
(6368, 40, 1373736660, 1001, 1, 1),
(6369, 17, 1373736668, 4701, 12, 26),
(6370, 20, 1373736709, 9052, 9, 51),
(6371, 58, 1373736725, 8373, 4, 19),
(6372, 19, 1373736886, 1576, 2, 12),
(6373, 57, 1373736898, 406, 2, 2),
(6374, 61, 1373736901, 209, 1, 0),
(6375, 45, 1373736934, 1227, 2, 5),
(6376, 62, 1373736935, 65, 1, 1),
(6377, 47, 1373737121, 1620, 1, 9),
(6378, 38, 1373737124, 3087, 4, 22),
(6379, 35, 1373737153, 1028, 1, 6),
(6380, 57, 1373737181, 283, 1, 3),
(6381, 66, 1373737218, 1664, 1, 4),
(6382, 50, 1373737248, 279, 1, 2),
(6383, 43, 1373737258, 972, 2, 10),
(6384, 72, 1373737290, 2967, 1, 5),
(6385, 37, 1373737322, 1557, 4, 16),
(6386, 52, 1373737336, 10512, 2, 20),
(6387, 50, 1373737377, 129, 2, 1),
(6388, 76, 1373737387, 3004, 1, 2),
(6389, 41, 1373737490, 2889, 1, 18),
(6390, 31, 1373737503, 13433, 28, 73),
(6391, 46, 1373737556, 669, 2, 7),
(6392, 50, 1373737585, 208, 1, 4),
(6393, 36, 1373737622, 2092, 4, 18),
(6394, 58, 1373737631, 906, 1, 8),
(6395, 32, 1373737648, 5563, 9, 47),
(6396, 29, 1373737714, 10990, 14, 81),
(6397, 70, 1373737717, 3415, 3, 4),
(6398, 86, 1373737723, 3050, 1, 1),
(6399, 16, 1373737734, 1132, 1, 16),
(6400, 59, 1373737737, 2192, 1, 9),
(6401, 51, 1373737739, 9846, 3, 30),
(6402, 13, 1373737763, 87, 1, 2),
(6403, 69, 1373737790, 117, 1, 2),
(6404, 44, 1373737794, 983, 2, 13),
(6405, 14, 1373737831, 3917, 2, 29),
(6406, 71, 1373737852, 698, 1, 11),
(6407, 19, 1373737856, 970, 2, 16),
(6408, 64, 1373737867, 704, 1, 10),
(6409, 63, 1373737897, 892, 1, 6),
(6410, 37, 1373738079, 757, 2, 3),
(6411, 44, 1373738081, 287, 1, 3),
(6412, 39, 1373738089, 1606, 4, 22),
(6413, 53, 1373738091, 928, 1, 6),
(6414, 12, 1373738168, 196, 1, 3),
(6415, 43, 1373738187, 929, 1, 8),
(6416, 24, 1373738267, 34385, 46, 180),
(6417, 42, 1373738430, 1843, 5, 17),
(6418, 51, 1373738464, 724, 1, 4),
(6419, 49, 1373738478, 732, 3, 9),
(6420, 74, 1373738528, 1135, 1, 13),
(6421, 46, 1373738558, 1002, 2, 2),
(6422, 11, 1373738576, 854, 1, 11),
(6423, 41, 1373738586, 1096, 1, 13),
(6424, 45, 1373738599, 851, 2, 4),
(6425, 18, 1373738622, 2658, 4, 25),
(6426, 53, 1373738746, 654, 2, 3),
(6427, 15, 1373738851, 2140, 1, 6),
(6428, 40, 1373738887, 2227, 9, 28),
(6429, 50, 1373738903, 928, 1, 4),
(6430, 47, 1373739029, 1908, 2, 14),
(6431, 57, 1373739103, 1386, 1, 9),
(6432, 42, 1373739180, 750, 1, 2),
(6433, 86, 1373739220, 1496, 2, 7),
(6434, 64, 1373739258, 602, 1, 3),
(6435, 52, 1373739347, 2011, 2, 13),
(6436, 48, 1373739445, 3137, 2, 23),
(6437, 39, 1373739454, 1363, 3, 6),
(6438, 36, 1373739465, 1842, 2, 19),
(6439, 35, 1373739537, 2384, 2, 22),
(6440, 22, 1373739577, 7554, 15, 49),
(6441, 17, 1373739688, 2903, 4, 27),
(6442, 37, 1373739903, 1823, 1, 3),
(6443, 38, 1373739966, 2842, 5, 25),
(6444, 32, 1373740027, 2378, 5, 13),
(6445, 34, 1373740073, 6482, 15, 36),
(6446, 25, 1373740594, 13748, 18, 65),
(6447, 33, 1373740807, 7680, 13, 63),
(6448, 11, 1373740923, 421, 1, 2),
(6449, 34, 1373741145, 274, 1, 2),
(6450, 36, 1373741150, 1685, 1, 2),
(6451, 30, 1373741536, 11962, 20, 97),
(6452, 35, 1373741560, 626, 1, 0),
(6453, 18, 1373741974, 3352, 2, 6),
(6454, 14, 1373742226, 551, 1, 0),
(6455, 19, 1373742387, 4530, 4, 8),
(6456, 13, 1373742441, 221, 1, 1),
(6457, 39, 1373742512, 1274, 1, 0),
(6458, 33, 1373742556, 1749, 1, 6),
(6459, 11, 1373742563, 366, 1, 1),
(6460, 13, 1373742696, 205, 1, 0),
(6461, 27, 1373742748, 12757, 29, 103),
(6462, 18, 1373742809, 835, 1, 7),
(6463, 16, 1373742812, 1883, 3, 8),
(6464, 47, 1373742894, 1072, 1, 3),
(6465, 29, 1373742917, 5203, 5, 13),
(6466, 39, 1373743109, 596, 1, 5),
(6467, 26, 1373743114, 24131, 4, 11),
(6468, 12, 1373743164, 488, 1, 1),
(6469, 34, 1373743311, 2166, 3, 9),
(6470, 27, 1373743342, 572, 1, 2),
(6471, 18, 1373743915, 1106, 2, 1),
(6472, 19, 1373743988, 1601, 2, 8),
(6473, 41, 1373743991, 1720, 3, 11),
(6474, 61, 1373744112, 1010, 1, 1),
(6475, 32, 1373744130, 4103, 8, 28),
(6476, 34, 1373744138, 827, 2, 0),
(6477, 36, 1373744157, 1413, 1, 9),
(6478, 50, 1373744202, 875, 1, 3),
(6479, 39, 1373744296, 1187, 2, 2),
(6480, 35, 1373744337, 2777, 4, 14),
(6481, 52, 1373744374, 1013, 2, 2),
(6482, 21, 1373744380, 15447, 23, 101),
(6483, 37, 1373744408, 1632, 3, 7),
(6484, 49, 1373744447, 5969, 5, 20),
(6485, 33, 1373744453, 1897, 2, 16),
(6486, 51, 1373744456, 1373, 4, 10),
(6487, 50, 1373744508, 306, 1, 1),
(6488, 30, 1373744618, 2814, 3, 15),
(6489, 11, 1373744644, 880, 2, 7),
(6490, 48, 1373744675, 2842, 4, 20),
(6491, 42, 1373744738, 2199, 7, 20),
(6492, 38, 1373744801, 2320, 3, 24),
(6493, 51, 1373744812, 356, 1, 0),
(6494, 13, 1373744830, 866, 1, 3),
(6495, 40, 1373745139, 6252, 5, 15),
(6496, 19, 1373745560, 1572, 1, 13),
(6497, 17, 1373745595, 4725, 1, 24),
(6498, 45, 1373745603, 3095, 2, 19),
(6499, 12, 1373745661, 568, 1, 1),
(6500, 22, 1373745727, 6150, 3, 33),
(6501, 25, 1373745742, 5148, 9, 32),
(6502, 13, 1373745746, 301, 1, 0),
(6503, 58, 1373745862, 6817, 2, 8),
(6504, 43, 1373745942, 3496, 2, 21),
(6505, 55, 1373746377, 978, 1, 0),
(6506, 20, 1373746394, 9685, 15, 54),
(6507, 46, 1373746591, 3916, 1, 18),
(6508, 39, 1373746636, 2340, 1, 3),
(6509, 55, 1373746671, 294, 1, 1),
(6510, 45, 1373746710, 1027, 2, 3),
(6511, 35, 1373746740, 1382, 2, 10),
(6512, 15, 1373746807, 1037, 2, 2),
(6513, 36, 1373746905, 2246, 1, 12),
(6514, 43, 1373746926, 984, 2, 2),
(6515, 38, 1373746976, 2175, 2, 15),
(6516, 44, 1373747005, 2168, 2, 5),
(6517, 34, 1373747011, 2873, 3, 13),
(6518, 33, 1373747032, 2579, 6, 18),
(6519, 14, 1373747099, 4771, 3, 27),
(6520, 16, 1373747106, 4293, 5, 21),
(6521, 42, 1373747182, 2443, 2, 9),
(6522, 30, 1373747395, 2777, 2, 12),
(6523, 11, 1373747514, 523, 2, 4),
(6524, 12, 1373747591, 607, 1, 3),
(6525, 12, 1373747796, 113, 1, 0),
(6526, 75, 1373748200, 10222, 1, 2),
(6527, 12, 1373748216, 371, 1, 0),
(6528, 63, 1373748266, 4412, 1, 3),
(6529, 62, 1373748372, 2275, 1, 0),
(6530, 13, 1373748426, 705, 1, 1),
(6531, 67, 1373748454, 463, 1, 4),
(6532, 57, 1373748481, 277, 1, 1),
(6533, 70, 1373748511, 10077, 1, 0),
(6534, 36, 1373748535, 331, 1, 2),
(6535, 18, 1373748581, 4666, 6, 29),
(6536, 52, 1373748594, 1526, 1, 4),
(6537, 17, 1373748643, 3048, 5, 14),
(6538, 51, 1373748711, 2430, 1, 3),
(6539, 50, 1373748724, 693, 2, 1),
(6540, 74, 1373748850, 10001, 2, 0),
(6541, 65, 1373748860, 4813, 1, 3),
(6542, 38, 1373748953, 1977, 1, 10),
(6543, 45, 1373749152, 2183, 4, 6),
(6544, 58, 1373749236, 2125, 1, 3),
(6545, 41, 1373749264, 2306, 3, 6),
(6546, 15, 1373749373, 1573, 2, 10),
(6547, 35, 1373749380, 2160, 3, 13),
(6548, 43, 1373749381, 2455, 2, 9),
(6549, 42, 1373749541, 2056, 1, 6),
(6550, 52, 1373749673, 1079, 1, 4),
(6551, 34, 1373749685, 2674, 2, 15),
(6552, 12, 1373749860, 1644, 1, 10),
(6553, 40, 1373749894, 2501, 5, 10),
(6554, 29, 1373749981, 7064, 16, 47),
(6555, 15, 1373750536, 1163, 1, 0),
(6556, 36, 1373750560, 165, 1, 1),
(6557, 51, 1373750776, 227, 2, 1),
(6558, 43, 1373750830, 1449, 1, 2),
(6559, 52, 1373750863, 1190, 1, 2),
(6560, 40, 1373750883, 415, 1, 4),
(6561, 38, 1373750899, 455, 1, 3),
(6562, 50, 1373750934, 319, 1, 3),
(6563, 57, 1373750942, 2461, 1, 3),
(6564, 41, 1373751061, 638, 3, 2),
(6565, 39, 1373751097, 2175, 2, 7),
(6566, 24, 1373751141, 12874, 17, 42),
(6567, 17, 1373751177, 2534, 3, 11),
(6568, 21, 1373751180, 6799, 3, 29),
(6569, 38, 1373751239, 340, 1, 0),
(6570, 47, 1373751513, 544, 1, 3),
(6571, 34, 1373751594, 1307, 1, 11),
(6572, 57, 1373751669, 727, 1, 1),
(6573, 67, 1373751698, 179, 1, 2),
(6574, 15, 1373751730, 1194, 1, 7),
(6575, 37, 1373751740, 1408, 1, 11),
(6576, 18, 1373751742, 3161, 3, 17),
(6577, 36, 1373751811, 801, 2, 4),
(6578, 63, 1373751869, 297, 1, 0),
(6579, 42, 1373751971, 825, 2, 6),
(6580, 71, 1373752003, 271, 1, 2),
(6581, 13, 1373752138, 1607, 5, 23),
(6582, 23, 1373752182, 21848, 20, 87),
(6583, 41, 1373752203, 901, 1, 4),
(6584, 81, 1373752240, 14773, 1, 0),
(6585, 14, 1373752241, 934, 1, 6),
(6586, 18, 1373752355, 613, 3, 3),
(6587, 37, 1373752377, 196, 1, 1),
(6588, 59, 1373752380, 411, 2, 1),
(6589, 55, 1373752405, 228, 1, 1),
(6590, 78, 1373752437, 4056, 1, 4),
(6591, 39, 1373752472, 1324, 4, 11),
(6592, 15, 1373752558, 828, 1, 8),
(6593, 87, 1373752578, 15267, 1, 1),
(6594, 76, 1373752649, 230, 1, 1),
(6595, 91, 1373752681, 14496, 1, 3),
(6596, 44, 1373752703, 763, 1, 4),
(6597, 90, 1373752746, 14452, 1, 1),
(6598, 17, 1373752763, 1094, 1, 8),
(6599, 70, 1373752777, 446, 2, 1),
(6600, 77, 1373752926, 683, 1, 4),
(6601, 57, 1373752930, 460, 1, 3),
(6602, 55, 1373752950, 544, 1, 5),
(6603, 84, 1373752972, 15478, 1, 3),
(6604, 68, 1373753007, 573, 1, 4),
(6605, 63, 1373753049, 790, 2, 4),
(6606, 55, 1373753144, 194, 1, 1),
(6607, 59, 1373753153, 126, 2, 0),
(6608, 80, 1373753183, 906, 1, 5),
(6609, 88, 1373753269, 15561, 1, 5),
(6610, 71, 1373753307, 248, 1, 4),
(6611, 65, 1373753327, 930, 2, 6),
(6612, 74, 1373753375, 4525, 4, 8),
(6613, 50, 1373753426, 146, 1, 0),
(6614, 48, 1373753471, 2218, 2, 22),
(6615, 58, 1373753474, 958, 1, 6),
(6616, 38, 1373753507, 1078, 2, 8),
(6617, 44, 1373753527, 192, 1, 0),
(6618, 30, 1373753573, 6178, 6, 48),
(6619, 36, 1373753614, 1803, 1, 17),
(6620, 69, 1373753642, 464, 2, 3),
(6621, 37, 1373753656, 1164, 2, 9),
(6622, 62, 1373753770, 387, 1, 3),
(6623, 59, 1373753858, 705, 2, 7),
(6624, 41, 1373753867, 1664, 2, 11),
(6625, 15, 1373753964, 647, 1, 7),
(6626, 50, 1373754012, 406, 1, 2),
(6627, 76, 1373754031, 544, 1, 4),
(6628, 97, 1373754061, 19078, 1, 3),
(6629, 44, 1373754123, 295, 1, 2),
(6630, 70, 1373754132, 671, 1, 4),
(6631, 72, 1373754173, 178, 1, 1),
(6632, 45, 1373754230, 3618, 3, 16),
(6633, 37, 1373754255, 599, 2, 5),
(6634, 89, 1373754290, 1737, 1, 3),
(6635, 87, 1373754331, 1753, 1, 2),
(6636, 14, 1373754455, 1142, 2, 11),
(6637, 16, 1373754488, 7382, 3, 58),
(6638, 85, 1373754507, 612, 1, 4),
(6639, 45, 1373754539, 309, 1, 0),
(6640, 76, 1373754591, 349, 1, 0),
(6641, 59, 1373754620, 518, 1, 2),
(6642, 93, 1373754669, 20492, 1, 8),
(6643, 35, 1373754672, 3601, 5, 27),
(6644, 98, 1373754682, 19484, 1, 4),
(6645, 78, 1373754696, 701, 1, 3),
(6646, 72, 1373754760, 587, 1, 3),
(6647, 86, 1373754777, 1842, 3, 9),
(6648, 65, 1373754839, 1512, 2, 9),
(6649, 64, 1373756097, 830, 1, 4),
(6650, 13, 1373756288, 1032, 2, 3),
(6651, 17, 1373756344, 1184, 1, 4),
(6652, 50, 1373756750, 1352, 1, 0),
(6653, 17, 1373756966, 622, 1, 3),
(6654, 43, 1373757137, 738, 1, 4),
(6655, 14, 1373757148, 604, 1, 1),
(6656, 13, 1373757215, 927, 1, 3),
(6657, 42, 1373757256, 1710, 2, 5),
(6658, 44, 1373757335, 1513, 3, 4),
(6659, 37, 1373757338, 662, 1, 7),
(6660, 19, 1373757410, 1030, 4, 4),
(6661, 36, 1373757578, 1815, 1, 9),
(6662, 41, 1373757678, 1378, 1, 10),
(6663, 38, 1373758203, 2118, 2, 14),
(6664, 16, 1373758493, 675, 1, 1),
(6665, 33, 1373758882, 2854, 4, 14),
(6666, 31, 1373759633, 720, 2, 5),
(6667, 17, 1373760117, 625, 1, 3),
(6668, 36, 1373760172, 246, 2, 2),
(6669, 37, 1373760197, 2277, 1, 2),
(6670, 38, 1373760221, 2018, 1, 0),
(6671, 11, 1373760272, 210, 1, 1),
(6672, 14, 1373760324, 452, 2, 0),
(6673, 42, 1373760572, 3316, 1, 1),
(6674, 39, 1373760575, 2407, 1, 1),
(6675, 35, 1373761328, 1227, 1, 1),
(6676, 18, 1373761709, 3981, 1, 10),
(6677, 19, 1373761777, 4366, 2, 6),
(6678, 32, 1373761874, 5175, 4, 16),
(6679, 48, 1373762133, 5465, 1, 0),
(6680, 13, 1373762303, 1304, 1, 3),
(6681, 36, 1373762475, 463, 1, 4),
(6682, 12, 1373762527, 256, 1, 0),
(6683, 32, 1373762531, 657, 1, 2),
(6684, 46, 1373762591, 5946, 1, 0),
(6685, 46, 1373762718, 127, 1, 0),
(6686, 41, 1373762861, 708, 2, 3),
(6687, 35, 1373762961, 1052, 2, 7),
(6688, 14, 1373763042, 146, 1, 2),
(6689, 37, 1373763087, 785, 1, 6),
(6690, 13, 1373763146, 843, 1, 3),
(6691, 41, 1373763285, 424, 1, 3),
(6692, 63, 1373763309, 7326, 2, 1),
(6693, 55, 1373763328, 218, 1, 2),
(6694, 43, 1373763349, 3263, 1, 5),
(6695, 40, 1373763353, 2980, 2, 3),
(6696, 15, 1373763364, 225, 1, 4),
(6697, 12, 1373763422, 595, 1, 6),
(6698, 47, 1373763449, 491, 3, 4),
(6699, 38, 1373763479, 1600, 2, 7),
(6700, 51, 1373763534, 194, 1, 0),
(6701, 39, 1373763568, 2420, 1, 13),
(6702, 58, 1373763610, 408, 1, 3),
(6703, 66, 1373763666, 8349, 1, 2),
(6704, 13, 1373763763, 449, 1, 3),
(6705, 57, 1373763771, 716, 1, 8),
(6706, 48, 1373763775, 455, 1, 6),
(6707, 14, 1373763814, 89, 1, 0),
(6708, 82, 1373763832, 121, 1, 0),
(6709, 69, 1373763902, 563, 3, 1),
(6710, 45, 1373763923, 751, 1, 5),
(6711, 41, 1373763934, 649, 2, 7),
(6712, 83, 1373764097, 299, 1, 2),
(6713, 99, 1373764141, 8780, 1, 0),
(6714, 77, 1373764178, 77, 1, 0),
(6715, 89, 1373764212, 8945, 1, 4),
(6716, 11, 1373764216, 543, 3, 5),
(6717, 78, 1373764240, 168, 1, 1),
(6718, 69, 1373764285, 382, 2, 0),
(6719, 12, 1373764307, 885, 1, 7),
(6720, 53, 1373764321, 190, 1, 1),
(6721, 88, 1373764325, 7739, 1, 8),
(6722, 13, 1373764475, 711, 1, 3),
(6723, 59, 1373764501, 854, 2, 5),
(6724, 100, 1373764509, 9456, 1, 6),
(6725, 48, 1373764529, 754, 1, 4),
(6726, 81, 1373764554, 567, 1, 3),
(6727, 17, 1373764571, 3449, 5, 26),
(6728, 62, 1373764595, 9399, 2, 15),
(6729, 74, 1373764626, 8906, 1, 6),
(6730, 55, 1373764651, 1011, 1, 9),
(6731, 57, 1373764676, 905, 1, 5),
(6732, 42, 1373764699, 1771, 2, 15),
(6733, 67, 1373764722, 594, 1, 1),
(6734, 104, 1373764729, 9594, 1, 6),
(6735, 68, 1373764749, 640, 1, 1),
(6736, 70, 1373764757, 485, 1, 1),
(6737, 45, 1373764800, 685, 1, 3),
(6738, 63, 1373764800, 1491, 1, 7),
(6739, 11, 1373764922, 283, 1, 1),
(6740, 66, 1373764928, 632, 1, 5),
(6741, 86, 1373764955, 656, 4, 3),
(6742, 85, 1373764980, 693, 3, 3),
(6743, 80, 1373764982, 1159, 1, 11),
(6744, 43, 1373765005, 1655, 1, 14),
(6745, 102, 1373765011, 210, 2, 1),
(6746, 36, 1373765020, 2545, 6, 21),
(6747, 77, 1373765044, 452, 1, 3),
(6748, 16, 1373765044, 1641, 5, 12),
(6749, 89, 1373765120, 528, 3, 5),
(6750, 83, 1373765121, 1024, 1, 12),
(6751, 11, 1373765151, 229, 1, 3),
(6752, 53, 1373765165, 137, 1, 1),
(6753, 64, 1373765242, 1693, 1, 5),
(6754, 46, 1373765319, 1170, 2, 12),
(6755, 90, 1373765469, 1290, 1, 8),
(6756, 11, 1373765469, 318, 1, 0),
(6757, 12, 1373765475, 700, 1, 3),
(6758, 52, 1373765506, 1248, 1, 5),
(6759, 106, 1373765517, 738, 1, 5),
(6760, 72, 1373765520, 148, 1, 1),
(6761, 75, 1373765544, 961, 1, 4),
(6762, 13, 1373765572, 757, 1, 3),
(6763, 76, 1373765579, 999, 2, 5),
(6764, 108, 1373765616, 1195, 2, 3),
(6765, 41, 1373765640, 1706, 2, 19),
(6766, 88, 1373765643, 1317, 1, 10),
(6767, 67, 1373765659, 112, 1, 1),
(6768, 104, 1373765680, 951, 1, 6),
(6769, 109, 1373765692, 164, 1, 0),
(6770, 85, 1373765740, 760, 4, 5),
(6771, 18, 1373765749, 4040, 2, 29),
(6772, 108, 1373765766, 150, 1, 0),
(6773, 107, 1373765775, 9474, 1, 9),
(6774, 87, 1373765782, 10657, 2, 24),
(6775, 77, 1373765784, 740, 1, 4),
(6776, 11, 1373765794, 325, 1, 0),
(6777, 50, 1373765807, 279, 1, 4),
(6778, 80, 1373765848, 134, 1, 1),
(6779, 78, 1373765851, 1243, 2, 5),
(6780, 68, 1373765864, 787, 1, 5),
(6781, 57, 1373765902, 282, 1, 1),
(6782, 106, 1373765920, 403, 1, 2),
(6783, 63, 1373765922, 1122, 1, 5),
(6784, 99, 1373765953, 1465, 1, 20),
(6785, 51, 1373765983, 505, 1, 7),
(6786, 14, 1373765988, 210, 1, 2),
(6787, 46, 1373765997, 678, 1, 6),
(6788, 95, 1373766040, 2209, 1, 13),
(6789, 72, 1373766055, 535, 1, 2),
(6790, 85, 1373766070, 278, 1, 2),
(6791, 88, 1373766084, 441, 1, 0),
(6792, 13, 1373766098, 310, 1, 2),
(6793, 69, 1373766246, 1201, 1, 11),
(6794, 40, 1373766255, 2902, 5, 25),
(6795, 45, 1373766324, 728, 1, 5),
(6796, 81, 1373766338, 360, 1, 0),
(6797, 47, 1373766339, 1561, 4, 12),
(6798, 44, 1373766341, 3249, 5, 22),
(6799, 57, 1373766344, 442, 2, 2),
(6800, 39, 1373766354, 2786, 6, 27),
(6801, 17, 1373766365, 1653, 2, 9),
(6802, 91, 1373766391, 11357, 6, 16),
(6803, 75, 1373766400, 856, 1, 7),
(6804, 40, 1373766421, 166, 1, 3),
(6805, 65, 1373766442, 1361, 1, 13),
(6806, 52, 1373766454, 765, 2, 8),
(6807, 36, 1373766466, 314, 1, 5),
(6808, 62, 1373766487, 1082, 3, 11),
(6809, 98, 1373766518, 1477, 4, 10),
(6810, 90, 1373766583, 1114, 2, 5),
(6811, 57, 1373766599, 255, 2, 3),
(6812, 12, 1373766599, 211, 1, 2),
(6813, 55, 1373766642, 741, 1, 7),
(6814, 74, 1373766692, 2065, 1, 15),
(6815, 15, 1373766725, 1168, 2, 6),
(6816, 83, 1373766749, 444, 1, 0),
(6817, 13, 1373766796, 335, 1, 1),
(6818, 39, 1373766839, 485, 1, 1),
(6819, 78, 1373766869, 1018, 1, 4),
(6820, 49, 1373766882, 888, 2, 4),
(6821, 72, 1373766889, 834, 1, 5),
(6822, 95, 1373766891, 851, 1, 5),
(6823, 70, 1373766896, 920, 1, 9),
(6824, 109, 1373766931, 959, 1, 8),
(6825, 58, 1373766969, 1438, 1, 10),
(6826, 43, 1373766984, 1909, 3, 20),
(6827, 99, 1373767014, 467, 3, 0),
(6828, 61, 1373767020, 11925, 7, 18),
(6829, 101, 1373767028, 771, 1, 6),
(6830, 50, 1373767038, 490, 1, 3),
(6831, 41, 1373767040, 701, 3, 10),
(6832, 65, 1373767058, 615, 1, 3),
(6833, 45, 1373767059, 174, 1, 1),
(6834, 69, 1373767069, 195, 1, 2),
(6835, 92, 1373767089, 12208, 1, 36),
(6836, 63, 1373767222, 1300, 3, 8),
(6837, 107, 1373767243, 413, 1, 4),
(6838, 13, 1373767255, 459, 1, 6),
(6839, 66, 1373767287, 2359, 3, 13),
(6840, 71, 1373767296, 3063, 2, 24),
(6841, 40, 1373767310, 889, 1, 5),
(6842, 46, 1373767322, 658, 1, 8),
(6843, 14, 1373767332, 1106, 1, 17),
(6844, 62, 1373767337, 425, 1, 1),
(6845, 72, 1373767352, 463, 1, 2),
(6846, 37, 1373767366, 4159, 5, 49),
(6847, 103, 1373767382, 1593, 1, 15),
(6848, 77, 1373767482, 1698, 1, 5),
(6849, 42, 1373767506, 2462, 5, 19),
(6850, 64, 1373767545, 2303, 2, 15),
(6851, 70, 1373767608, 712, 1, 1),
(6852, 71, 1373767615, 253, 1, 1),
(6853, 51, 1373767640, 515, 3, 2),
(6854, 18, 1373767787, 2037, 7, 21),
(6855, 17, 1373767884, 1519, 4, 18),
(6856, 97, 1373767892, 3682, 6, 30),
(6857, 50, 1373767927, 889, 1, 3),
(6858, 49, 1373767966, 510, 1, 0),
(6859, 14, 1373768007, 675, 1, 8),
(6860, 76, 1373768011, 571, 1, 3),
(6861, 102, 1373768036, 2193, 3, 15),
(6862, 11, 1373768046, 1434, 4, 15),
(6863, 78, 1373768075, 1024, 1, 6),
(6864, 43, 1373768149, 1165, 2, 5),
(6865, 38, 1373768154, 4675, 15, 47),
(6866, 47, 1373768160, 249, 1, 2),
(6867, 94, 1373768216, 4406, 7, 14),
(6868, 15, 1373768234, 370, 1, 3),
(6869, 77, 1373768284, 802, 1, 6),
(6870, 52, 1373768304, 822, 1, 3),
(6871, 46, 1373768361, 293, 1, 0),
(6872, 35, 1373768361, 5399, 12, 50),
(6873, 24, 1373768384, 12448, 36, 117),
(6874, 96, 1373768406, 12667, 6, 24),
(6875, 32, 1373768458, 5927, 14, 67),
(6876, 53, 1373768492, 570, 1, 4),
(6877, 51, 1373768497, 375, 1, 1),
(6878, 16, 1373768500, 3456, 4, 38),
(6879, 59, 1373768630, 728, 1, 4),
(6880, 49, 1373768631, 511, 1, 3),
(6881, 11, 1373768675, 405, 1, 0),
(6882, 14, 1373768742, 735, 1, 6),
(6883, 43, 1373768807, 535, 3, 5),
(6884, 58, 1373768818, 867, 2, 3),
(6885, 74, 1373768825, 1964, 2, 6),
(6886, 98, 1373768857, 2339, 1, 13),
(6887, 63, 1373768925, 788, 1, 1),
(6888, 42, 1373769045, 1539, 2, 8),
(6889, 66, 1373769194, 1906, 1, 7),
(6890, 48, 1373769249, 3369, 5, 18),
(6891, 44, 1373769363, 3022, 4, 16),
(6892, 88, 1373769378, 2420, 1, 13),
(6893, 37, 1373770085, 2719, 2, 15),
(6894, 18, 1373770096, 2309, 2, 13),
(6895, 40, 1373770267, 1210, 1, 1),
(6896, 33, 1373770316, 9106, 11, 77),
(6897, 34, 1373770414, 7361, 8, 66),
(6898, 34, 1373770543, 129, 1, 1),
(6899, 16, 1373770615, 2115, 1, 3),
(6900, 36, 1373770919, 1036, 2, 3),
(6901, 19, 1373771013, 9236, 24, 83),
(6902, 39, 1373771433, 922, 1, 0),
(6903, 34, 1373771436, 893, 1, 6),
(6904, 13, 1373771548, 142, 1, 0),
(6905, 11, 1373771616, 53, 1, 0),
(6906, 38, 1373771958, 634, 1, 1),
(6907, 37, 1373772060, 462, 2, 0),
(6908, 33, 1373772139, 1465, 3, 8),
(6909, 40, 1373772153, 697, 1, 0),
(6910, 16, 1373772225, 1269, 1, 3),
(6911, 32, 1373772230, 3772, 1, 5),
(6912, 18, 1373772365, 360, 1, 1),
(6913, 17, 1373772418, 243, 1, 1),
(6914, 34, 1373772420, 984, 1, 0),
(6915, 15, 1373772537, 449, 1, 3),
(6916, 27, 1373772583, 17058, 31, 106),
(6917, 13, 1373773073, 627, 2, 0),
(6918, 24, 1373773325, 4941, 13, 25),
(6919, 12, 1373773341, 310, 1, 0),
(6920, 42, 1373773387, 1620, 1, 0),
(6921, 34, 1373773423, 326, 1, 2),
(6922, 39, 1373773538, 178, 1, 0),
(6923, 17, 1373773551, 101, 1, 1),
(6924, 41, 1373773679, 113, 1, 0),
(6925, 13, 1373773680, 607, 1, 6),
(6926, 16, 1373773777, 663, 1, 3),
(6927, 12, 1373773799, 327, 1, 5),
(6928, 33, 1373773850, 917, 1, 4),
(6929, 15, 1373773978, 1016, 2, 2),
(6930, 14, 1373773997, 1917, 1, 9),
(6931, 36, 1373774061, 543, 1, 7),
(6932, 39, 1373774083, 389, 1, 0),
(6933, 45, 1373774099, 361, 1, 1),
(6934, 47, 1373774131, 40, 1, 0),
(6935, 51, 1373774141, 4721, 1, 0),
(6936, 58, 1373774238, 4831, 1, 0),
(6937, 40, 1373774334, 241, 1, 0),
(6938, 23, 1373774376, 7770, 26, 49),
(6939, 53, 1373774401, 5909, 1, 3),
(6940, 13, 1373774436, 756, 2, 4),
(6941, 42, 1373774471, 349, 1, 5),
(6942, 45, 1373774541, 401, 2, 2),
(6943, 58, 1373774551, 313, 1, 0),
(6944, 47, 1373774659, 528, 1, 4),
(6945, 35, 1373774668, 377, 1, 0),
(6946, 44, 1373774715, 666, 1, 5),
(6947, 18, 1373774810, 702, 2, 5),
(6948, 52, 1373774831, 245, 1, 1),
(6949, 37, 1373774868, 820, 1, 9),
(6950, 19, 1373774891, 2954, 3, 19),
(6951, 42, 1373774949, 478, 1, 6),
(6952, 17, 1373774995, 1444, 3, 12),
(6953, 12, 1373775047, 819, 1, 5),
(6954, 41, 1373775086, 1032, 4, 14),
(6955, 16, 1373775088, 1311, 2, 11),
(6956, 35, 1373775110, 442, 1, 8),
(6957, 49, 1373775128, 898, 1, 2),
(6958, 14, 1373775267, 764, 2, 4),
(6959, 15, 1373775308, 954, 2, 8),
(6960, 45, 1373775449, 633, 1, 5),
(6961, 39, 1373775496, 677, 2, 6),
(6962, 46, 1373775583, 1004, 3, 5),
(6963, 35, 1373775590, 480, 1, 4),
(6964, 42, 1373775664, 715, 1, 1),
(6965, 13, 1373775666, 332, 1, 3),
(6966, 38, 1373775688, 3730, 8, 20),
(6967, 40, 1373775706, 1100, 4, 12),
(6968, 33, 1373775892, 2042, 3, 20),
(6969, 17, 1373775950, 955, 2, 1),
(6970, 30, 1373776060, 6378, 20, 41),
(6971, 16, 1373776091, 748, 1, 1),
(6972, 17, 1373776342, 392, 1, 2),
(6973, 37, 1373776423, 371, 1, 2),
(6974, 29, 1373776681, 4499, 10, 30),
(6975, 12, 1373776789, 136, 1, 0),
(6976, 38, 1373776812, 727, 1, 0),
(6977, 14, 1373776826, 1210, 1, 0),
(6978, 31, 1373776882, 17249, 27, 107),
(6979, 33, 1373776906, 944, 1, 2),
(6980, 32, 1373776981, 4751, 3, 29),
(6981, 15, 1373777100, 1792, 3, 9),
(6982, 16, 1373777338, 1247, 2, 3),
(6983, 13, 1373777368, 869, 1, 3),
(6984, 14, 1373777481, 655, 1, 0),
(6985, 34, 1373777577, 4154, 5, 22),
(6986, 35, 1373777632, 952, 1, 0),
(6987, 17, 1373777654, 1311, 2, 6),
(6988, 38, 1373777828, 1016, 1, 2),
(6989, 45, 1373777832, 1947, 1, 0),
(6990, 15, 1373777895, 513, 1, 1),
(6991, 33, 1373777981, 1075, 2, 4),
(6992, 36, 1373778048, 1103, 1, 6),
(6993, 48, 1373778198, 3203, 1, 2),
(6994, 11, 1373778225, 432, 1, 2),
(6995, 38, 1373778389, 561, 1, 2),
(6996, 50, 1373778437, 245, 1, 2),
(6997, 41, 1373778510, 523, 1, 4),
(6998, 13, 1373778765, 949, 3, 9),
(6999, 16, 1373778778, 847, 1, 9),
(7000, 48, 1373778823, 625, 1, 4),
(7001, 12, 1373779069, 495, 2, 4),
(7002, 38, 1373779154, 234, 1, 0),
(7003, 11, 1373779228, 1003, 1, 5),
(7004, 39, 1373779288, 342, 1, 3),
(7005, 40, 1373779374, 2572, 1, 6),
(7006, 53, 1373779385, 368, 1, 1),
(7007, 34, 1373779386, 1809, 4, 16),
(7008, 40, 1373779610, 145, 1, 1),
(7009, 45, 1373779619, 88, 1, 0),
(7010, 43, 1373779626, 1431, 2, 7),
(7011, 33, 1373779646, 1665, 3, 10),
(7012, 58, 1373779647, 331, 1, 4),
(7013, 51, 1373779695, 475, 1, 3),
(7014, 70, 1373779818, 12210, 2, 3),
(7015, 36, 1373779822, 276, 1, 2),
(7016, 49, 1373779868, 555, 1, 5),
(7017, 57, 1373779883, 720, 1, 7),
(7018, 69, 1373779888, 323, 1, 5),
(7019, 13, 1373779899, 598, 2, 7),
(7020, 14, 1373779953, 731, 2, 6),
(7021, 38, 1373780024, 431, 1, 2),
(7022, 53, 1373780051, 335, 1, 0),
(7023, 70, 1373780083, 265, 1, 1),
(7024, 71, 1373780109, 652, 1, 2),
(7025, 34, 1373780169, 783, 2, 5),
(7026, 43, 1373780189, 394, 2, 0),
(7027, 52, 1373780260, 1249, 1, 8),
(7028, 63, 1373780274, 5344, 1, 4),
(7029, 41, 1373780298, 1280, 1, 8),
(7030, 61, 1373780361, 123, 2, 1),
(7031, 55, 1373780397, 5717, 5, 7),
(7032, 14, 1373780415, 462, 1, 4),
(7033, 13, 1373780434, 535, 1, 5),
(7034, 57, 1373780465, 446, 1, 5),
(7035, 59, 1373780493, 1113, 2, 8),
(7036, 18, 1373780500, 5628, 8, 39),
(7037, 67, 1373780571, 600, 1, 5),
(7038, 42, 1373780573, 401, 1, 4),
(7039, 51, 1373780581, 613, 1, 5),
(7040, 15, 1373780585, 2690, 8, 22),
(7041, 76, 1373780593, 107, 1, 0),
(7042, 20, 1373780598, 9663, 10, 28),
(7043, 24, 1373780616, 7291, 18, 57),
(7044, 51, 1373780619, 38, 1, 1),
(7045, 31, 1373780635, 3753, 3, 24),
(7046, 33, 1373780642, 996, 2, 8),
(7047, 38, 1373780669, 387, 3, 4),
(7048, 45, 1373780691, 641, 2, 3),
(7049, 35, 1373780695, 3063, 5, 23),
(7050, 49, 1373780705, 310, 1, 8),
(7051, 71, 1373780731, 622, 1, 12),
(7052, 53, 1373780755, 704, 1, 7),
(7053, 11, 1373780791, 1009, 1, 8),
(7054, 57, 1373780816, 351, 2, 2),
(7055, 50, 1373780873, 483, 2, 8),
(7056, 20, 1373780878, 279, 3, 5),
(7057, 43, 1373780910, 279, 1, 0),
(7058, 80, 1373780920, 13576, 1, 2),
(7059, 41, 1373780965, 468, 3, 6),
(7060, 68, 1373780987, 1118, 3, 7),
(7061, 52, 1373781009, 629, 1, 7),
(7062, 66, 1373781018, 601, 2, 3),
(7063, 27, 1373781103, 8520, 20, 55),
(7064, 13, 1373781119, 538, 4, 5),
(7065, 63, 1373781147, 873, 4, 9),
(7066, 55, 1373781154, 757, 1, 7),
(7067, 42, 1373781194, 620, 1, 3),
(7068, 51, 1373781239, 619, 1, 7),
(7069, 46, 1373781267, 2374, 3, 15),
(7070, 15, 1373781269, 682, 2, 8),
(7071, 33, 1373781281, 563, 1, 7),
(7072, 36, 1373781283, 839, 1, 11),
(7073, 53, 1373781311, 359, 1, 3),
(7074, 76, 1373781357, 654, 1, 5),
(7075, 17, 1373781433, 2969, 7, 22),
(7076, 68, 1373781448, 461, 1, 1),
(7077, 55, 1373781527, 373, 2, 0),
(7078, 45, 1373781632, 941, 1, 7),
(7079, 62, 1373781704, 1155, 1, 8),
(7080, 34, 1373781706, 1537, 1, 14),
(7081, 47, 1373781723, 269, 1, 4),
(7082, 22, 1373781728, 24597, 36, 87),
(7083, 42, 1373781728, 534, 1, 4),
(7084, 28, 1373781803, 6900, 12, 50),
(7085, 37, 1373781898, 649, 1, 2),
(7086, 30, 1373781947, 5887, 9, 46),
(7087, 52, 1373781982, 366, 2, 3),
(7088, 29, 1373781988, 5307, 9, 50),
(7089, 44, 1373781999, 3640, 3, 20),
(7090, 37, 1373782006, 108, 1, 0),
(7091, 61, 1373782056, 510, 1, 3),
(7092, 13, 1373782060, 941, 3, 15),
(7093, 50, 1373782201, 1328, 1, 14),
(7094, 58, 1373782244, 317, 2, 1),
(7095, 72, 1373782247, 463, 1, 0),
(7096, 45, 1373782311, 111, 1, 1),
(7097, 75, 1373782398, 1786, 2, 15),
(7098, 63, 1373782425, 1278, 2, 8),
(7099, 47, 1373782440, 157, 1, 0),
(7100, 67, 1373782441, 495, 1, 4),
(7101, 38, 1373782449, 1269, 2, 4),
(7102, 14, 1373782505, 1947, 1, 13),
(7103, 86, 1373782510, 16126, 1, 0),
(7104, 81, 1373782522, 441, 1, 3),
(7105, 76, 1373782523, 1166, 1, 6),
(7106, 43, 1373782530, 1183, 2, 8),
(7107, 83, 1373782533, 15784, 1, 2),
(7108, 35, 1373782542, 1707, 2, 9),
(7109, 41, 1373782563, 1598, 1, 18),
(7110, 84, 1373782577, 443, 1, 1),
(7111, 68, 1373782619, 729, 1, 5),
(7112, 82, 1373782623, 260, 1, 3),
(7113, 80, 1373782683, 973, 1, 4),
(7114, 87, 1373782738, 15198, 1, 2),
(7115, 72, 1373782797, 549, 1, 1),
(7116, 67, 1373782815, 374, 1, 2),
(7117, 19, 1373782864, 7973, 12, 57),
(7118, 70, 1373782869, 919, 2, 5),
(7119, 74, 1373782928, 725, 1, 3),
(7120, 57, 1373782928, 1442, 2, 12),
(7121, 35, 1373782992, 450, 1, 2),
(7122, 40, 1373783019, 2060, 6, 7),
(7123, 11, 1373783035, 39, 1, 0),
(7124, 74, 1373783072, 144, 1, 3),
(7125, 42, 1373783102, 1374, 2, 6),
(7126, 53, 1373783124, 1153, 1, 5),
(7127, 48, 1373783147, 1663, 5, 12),
(7128, 85, 1373783154, 16217, 2, 11),
(7129, 77, 1373783169, 807, 1, 2),
(7130, 80, 1373783174, 491, 2, 1),
(7131, 72, 1373783227, 430, 1, 3),
(7132, 18, 1373783270, 2770, 4, 17),
(7133, 44, 1373783281, 515, 2, 6),
(7134, 41, 1373783334, 771, 2, 2),
(7135, 55, 1373783363, 1836, 2, 22),
(7136, 61, 1373783448, 1392, 1, 11),
(7137, 84, 1373783572, 995, 3, 3),
(7138, 17, 1373783581, 591, 2, 5),
(7139, 24, 1373783688, 3072, 9, 28),
(7140, 11, 1373783691, 509, 1, 4),
(7141, 39, 1373783826, 4538, 7, 44),
(7142, 52, 1373783834, 1037, 2, 4),
(7143, 83, 1373783944, 530, 3, 0),
(7144, 62, 1373783982, 2278, 3, 11),
(7145, 97, 1373783992, 16100, 1, 7),
(7146, 75, 1373784004, 1168, 1, 6),
(7147, 48, 1373784146, 998, 1, 8),
(7148, 57, 1373784203, 1274, 2, 10),
(7149, 94, 1373784204, 15473, 2, 9),
(7150, 41, 1373784229, 291, 1, 5),
(7151, 91, 1373784251, 937, 1, 8),
(7152, 85, 1373784264, 1110, 4, 6),
(7153, 27, 1373784292, 3189, 3, 35),
(7154, 16, 1373784311, 4776, 13, 44),
(7155, 106, 1373784313, 745, 1, 4),
(7156, 71, 1373784334, 916, 1, 5),
(7157, 82, 1373784343, 1719, 1, 12),
(7158, 101, 1373784387, 603, 1, 7),
(7159, 61, 1373784475, 454, 2, 0),
(7160, 66, 1373784493, 2812, 2, 18),
(7161, 90, 1373784584, 819, 2, 7),
(7162, 71, 1373784645, 311, 2, 3),
(7163, 11, 1373784658, 196, 1, 0),
(7164, 55, 1373784658, 1295, 1, 11),
(7165, 37, 1373784713, 389, 4, 3),
(7166, 57, 1373784719, 515, 1, 3),
(7167, 108, 1373784740, 833, 1, 2),
(7168, 83, 1373784810, 866, 3, 3),
(7169, 82, 1373784821, 478, 1, 0),
(7170, 78, 1373784863, 561, 2, 4),
(7171, 93, 1373784995, 18134, 3, 9),
(7172, 12, 1373785038, 1849, 1, 13),
(7173, 63, 1373785100, 2675, 1, 14),
(7174, 65, 1373785106, 3762, 3, 24),
(7175, 25, 1373785113, 27668, 44, 110),
(7176, 103, 1373785129, 17747, 1, 11),
(7177, 70, 1373785144, 814, 1, 8),
(7178, 69, 1373785151, 446, 1, 0),
(7179, 75, 1373785175, 1102, 1, 7),
(7180, 15, 1373785182, 3913, 5, 20),
(7181, 92, 1373785185, 2336, 3, 18),
(7182, 17, 1373785223, 1310, 2, 9),
(7183, 24, 1373785250, 1562, 3, 11),
(7184, 80, 1373785263, 2089, 3, 11),
(7185, 102, 1373785264, 17089, 4, 9),
(7186, 67, 1373785435, 942, 1, 7),
(7187, 96, 1373785445, 16422, 2, 16),
(7188, 76, 1373785495, 1849, 1, 11),
(7189, 59, 1373785576, 4216, 6, 24),
(7190, 47, 1373785646, 3206, 5, 21),
(7191, 99, 1373785667, 2099, 6, 15),
(7192, 46, 1373785712, 4445, 4, 33),
(7193, 92, 1373785718, 533, 1, 1),
(7194, 42, 1373785737, 2635, 7, 21),
(7195, 61, 1373785776, 1301, 3, 3),
(7196, 21, 1373785969, 29026, 51, 184),
(7197, 74, 1373785998, 1114, 1, 0),
(7198, 55, 1373786022, 1364, 2, 14),
(7199, 70, 1373786042, 238, 1, 0),
(7200, 14, 1373786051, 1826, 3, 12),
(7201, 52, 1373786119, 2285, 3, 9),
(7202, 38, 1373786120, 1828, 2, 11),
(7203, 97, 1373786128, 1955, 1, 6),
(7204, 76, 1373786151, 402, 1, 0),
(7205, 44, 1373786204, 2923, 5, 31),
(7206, 47, 1373786326, 597, 1, 2),
(7207, 51, 1373786433, 2517, 4, 17),
(7208, 98, 1373786440, 1624, 1, 2),
(7209, 82, 1373786442, 1621, 3, 5),
(7210, 83, 1373786472, 1217, 2, 8),
(7211, 63, 1373786478, 1378, 1, 2),
(7212, 94, 1373786479, 986, 1, 2),
(7213, 99, 1373786504, 493, 1, 5),
(7214, 65, 1373786519, 1022, 1, 5),
(7215, 88, 1373786567, 17189, 3, 29),
(7216, 67, 1373786603, 388, 1, 3),
(7217, 51, 1373786630, 197, 2, 0),
(7218, 85, 1373786676, 2412, 3, 13),
(7219, 35, 1373786770, 3778, 7, 26),
(7220, 53, 1373786778, 3603, 2, 30),
(7221, 48, 1373786808, 2662, 2, 23),
(7222, 41, 1373786838, 2609, 1, 20),
(7223, 50, 1373786852, 4651, 4, 39),
(7224, 94, 1373786861, 382, 1, 3),
(7225, 86, 1373786881, 1737, 2, 7),
(7226, 76, 1373786888, 737, 2, 1),
(7227, 49, 1373786927, 2688, 3, 13),
(7228, 61, 1373786978, 890, 1, 2),
(7229, 35, 1373787010, 239, 1, 4),
(7230, 32, 1373787023, 10042, 23, 83),
(7231, 17, 1373787079, 1856, 2, 9),
(7232, 57, 1373787149, 439, 2, 0),
(7233, 16, 1373787201, 2890, 1, 18),
(7234, 53, 1373787234, 456, 1, 4),
(7235, 63, 1373787295, 420, 1, 1),
(7236, 109, 1373787317, 2745, 1, 3),
(7237, 43, 1373787363, 4833, 7, 43),
(7238, 50, 1373787488, 635, 1, 7),
(7239, 104, 1373787492, 803, 1, 3),
(7240, 101, 1373787506, 2806, 3, 4),
(7241, 84, 1373787534, 3962, 1, 20),
(7242, 107, 1373787559, 1958, 1, 5),
(7243, 31, 1373787570, 6934, 8, 50),
(7244, 63, 1373787601, 306, 1, 2),
(7245, 40, 1373787603, 3283, 3, 13),
(7246, 13, 1373787619, 683, 1, 5),
(7247, 61, 1373787655, 677, 1, 5),
(7248, 62, 1373787672, 3690, 3, 22),
(7249, 28, 1373787756, 5953, 8, 40),
(7250, 77, 1373787829, 2059, 2, 12),
(7251, 91, 1373787845, 2934, 4, 10),
(7252, 49, 1373787887, 960, 1, 3),
(7253, 103, 1373787971, 2842, 3, 18),
(7254, 43, 1373788004, 641, 1, 4),
(7255, 108, 1373788113, 827, 1, 5),
(7256, 17, 1373788162, 478, 1, 4),
(7257, 106, 1373788180, 1894, 1, 7),
(7258, 34, 1373788205, 6499, 9, 55),
(7259, 53, 1373788318, 1083, 2, 8),
(7260, 88, 1373788532, 1965, 1, 8),
(7261, 67, 1373788536, 1504, 1, 11),
(7262, 57, 1373788545, 1396, 1, 9),
(7263, 72, 1373788679, 1902, 3, 7),
(7264, 68, 1373788690, 1552, 2, 7),
(7265, 43, 1373788711, 707, 2, 4),
(7266, 63, 1373788714, 283, 1, 1),
(7267, 45, 1373788776, 5876, 7, 49),
(7268, 74, 1373788808, 2810, 2, 17),
(7269, 37, 1373788854, 3163, 6, 29),
(7270, 69, 1373788876, 1637, 1, 9),
(7271, 52, 1373789042, 2923, 2, 21),
(7272, 21, 1373789087, 3118, 3, 12),
(7273, 32, 1373789093, 2070, 1, 11),
(7274, 71, 1373789101, 2642, 6, 22),
(7275, 40, 1373789140, 1537, 2, 6),
(7276, 91, 1373789190, 742, 1, 3),
(7277, 105, 1373789223, 566, 1, 2),
(7278, 18, 1373789280, 6009, 12, 38),
(7279, 95, 1373789335, 885, 1, 6),
(7280, 12, 1373789355, 611, 1, 3),
(7281, 85, 1373789377, 2701, 1, 13),
(7282, 71, 1373789433, 332, 1, 2),
(7283, 48, 1373789440, 2632, 2, 5),
(7284, 98, 1373789481, 3041, 4, 27),
(7285, 76, 1373789498, 344, 2, 3),
(7286, 100, 1373789621, 3659, 4, 22),
(7287, 15, 1373789684, 1961, 1, 12),
(7288, 47, 1373789692, 1575, 3, 9),
(7289, 72, 1373789795, 470, 1, 4),
(7290, 14, 1373789805, 492, 1, 1),
(7291, 16, 1373789811, 2610, 3, 8),
(7292, 109, 1373789816, 1649, 1, 0),
(7293, 63, 1373789837, 944, 1, 4),
(7294, 11, 1373789878, 290, 1, 0),
(7295, 64, 1373789878, 1149, 2, 5),
(7296, 93, 1373789930, 4935, 3, 30),
(7297, 97, 1373789931, 2052, 1, 5),
(7298, 76, 1373789974, 476, 1, 3),
(7299, 51, 1373789990, 2702, 1, 11),
(7300, 53, 1373790074, 1756, 4, 12),
(7301, 94, 1373790103, 693, 1, 0),
(7302, 83, 1373790114, 3642, 8, 18),
(7303, 80, 1373790116, 1450, 1, 11),
(7304, 49, 1373790116, 2229, 3, 13),
(7305, 65, 1373790135, 3269, 1, 16),
(7306, 12, 1373790165, 270, 1, 1),
(7307, 85, 1373790224, 847, 2, 4),
(7308, 78, 1373790392, 1034, 1, 4);
INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(7309, 37, 1373790482, 1628, 1, 4),
(7310, 101, 1373790553, 1507, 1, 12),
(7311, 72, 1373790664, 761, 1, 5),
(7312, 41, 1373790675, 3837, 3, 31),
(7313, 40, 1373790676, 1536, 1, 5),
(7314, 49, 1373790681, 565, 1, 2),
(7315, 62, 1373790705, 3032, 4, 16),
(7316, 69, 1373790724, 1764, 1, 5),
(7317, 74, 1373790738, 1930, 2, 12),
(7318, 44, 1373790804, 4292, 4, 34),
(7319, 38, 1373790900, 1090, 2, 3),
(7320, 14, 1373790923, 843, 1, 4),
(7321, 43, 1373790964, 1340, 1, 7),
(7322, 31, 1373790980, 3410, 6, 20),
(7323, 68, 1373791001, 2311, 3, 19),
(7324, 70, 1373791140, 448, 1, 1),
(7325, 15, 1373791166, 1482, 1, 8),
(7326, 90, 1373791210, 1144, 1, 9),
(7327, 81, 1373791220, 600, 1, 5),
(7328, 88, 1373791269, 2737, 1, 9),
(7329, 104, 1373791300, 1930, 3, 7),
(7330, 29, 1373791310, 9322, 14, 55),
(7331, 11, 1373791320, 1070, 1, 3),
(7332, 102, 1373791362, 2153, 2, 9),
(7333, 55, 1373791391, 4888, 3, 36),
(7334, 96, 1373791442, 5997, 3, 25),
(7335, 107, 1373791522, 1705, 1, 10),
(7336, 21, 1373791629, 2542, 2, 21),
(7337, 84, 1373791655, 2576, 3, 20),
(7338, 92, 1373791729, 1893, 4, 13),
(7339, 51, 1373791779, 1789, 3, 7),
(7340, 77, 1373791811, 2812, 1, 8),
(7341, 106, 1373791864, 3684, 2, 10),
(7342, 47, 1373791928, 1818, 3, 3),
(7343, 99, 1373791982, 4923, 3, 22),
(7344, 47, 1373792031, 103, 1, 1),
(7345, 87, 1373792041, 8812, 1, 1),
(7346, 48, 1373792054, 2614, 1, 12),
(7347, 46, 1373792070, 6358, 9, 33),
(7348, 85, 1373792187, 1963, 4, 8),
(7349, 101, 1373792191, 1638, 2, 7),
(7350, 35, 1373792196, 4553, 2, 17),
(7351, 61, 1373792205, 1474, 1, 7),
(7352, 82, 1373792273, 1423, 1, 4),
(7353, 38, 1373792465, 1565, 1, 1),
(7354, 71, 1373792602, 3169, 2, 10),
(7355, 65, 1373792646, 2511, 1, 2),
(7356, 15, 1373792731, 1565, 1, 12),
(7357, 91, 1373792786, 2306, 3, 8),
(7358, 75, 1373792802, 6242, 1, 35),
(7359, 52, 1373792835, 3010, 3, 10),
(7360, 47, 1373792923, 457, 1, 2),
(7361, 97, 1373792942, 3011, 3, 15),
(7362, 68, 1373792947, 1946, 1, 2),
(7363, 58, 1373792985, 8447, 3, 40),
(7364, 95, 1373792994, 3659, 2, 18),
(7365, 106, 1373793062, 957, 1, 7),
(7366, 35, 1373793073, 877, 1, 7),
(7367, 15, 1373793085, 354, 1, 0),
(7368, 63, 1373793128, 343, 1, 0),
(7369, 61, 1373793152, 947, 1, 4),
(7370, 99, 1373793189, 1207, 1, 5),
(7371, 41, 1373793192, 2517, 2, 15),
(7372, 11, 1373793212, 293, 1, 2),
(7373, 70, 1373793285, 2145, 1, 0),
(7374, 51, 1373793294, 1515, 2, 6),
(7375, 38, 1373793384, 919, 2, 4),
(7376, 43, 1373793529, 1147, 2, 9),
(7377, 62, 1373793563, 2461, 3, 5),
(7378, 40, 1373793584, 2125, 1, 5),
(7379, 69, 1373793900, 120, 1, 0),
(7380, 12, 1373793997, 1420, 1, 5),
(7381, 75, 1373794045, 1243, 1, 3),
(7382, 98, 1373794144, 4663, 3, 18),
(7383, 66, 1373794202, 8104, 11, 42),
(7384, 64, 1373794227, 3327, 1, 2),
(7385, 37, 1373794239, 338, 1, 7),
(7386, 33, 1373794243, 12962, 18, 82),
(7387, 71, 1373794263, 1661, 1, 1),
(7388, 105, 1373794354, 5131, 3, 30),
(7389, 22, 1373794398, 12670, 18, 83),
(7390, 36, 1373794511, 12733, 19, 92),
(7391, 68, 1373794527, 1206, 1, 8),
(7392, 42, 1373794546, 7944, 6, 44),
(7393, 47, 1373794550, 1003, 1, 5),
(7394, 41, 1373794595, 1403, 4, 6),
(7395, 49, 1373794631, 3226, 1, 10),
(7396, 46, 1373794684, 770, 1, 4),
(7397, 62, 1373794696, 1133, 1, 5),
(7398, 68, 1373794728, 201, 1, 1),
(7399, 31, 1373794733, 3753, 3, 22),
(7400, 39, 1373794775, 10346, 9, 72),
(7401, 74, 1373794781, 4043, 3, 8),
(7402, 51, 1373794814, 1520, 6, 6),
(7403, 53, 1373794896, 4822, 4, 22),
(7404, 45, 1373794980, 2166, 2, 16),
(7405, 49, 1373795020, 389, 1, 1),
(7406, 13, 1373795031, 1695, 4, 9),
(7407, 46, 1373795082, 398, 1, 3),
(7408, 24, 1373795097, 9847, 10, 80),
(7409, 67, 1373795258, 1136, 1, 0),
(7410, 66, 1373795293, 164, 1, 0),
(7411, 71, 1373795302, 1039, 1, 2),
(7412, 19, 1373795306, 12442, 10, 85),
(7413, 25, 1373795320, 10207, 17, 58),
(7414, 58, 1373795322, 1042, 1, 2),
(7415, 35, 1373795324, 586, 1, 9),
(7416, 98, 1373795325, 1181, 1, 10),
(7417, 55, 1373795331, 584, 2, 7),
(7418, 61, 1373795348, 2196, 2, 9),
(7419, 43, 1373795382, 230, 1, 1),
(7420, 38, 1373795384, 2000, 3, 23),
(7421, 40, 1373795386, 590, 1, 8),
(7422, 53, 1373795429, 533, 1, 4),
(7423, 31, 1373795432, 699, 1, 7),
(7424, 30, 1373795444, 13497, 13, 96),
(7425, 18, 1373795467, 6124, 9, 48),
(7426, 24, 1373795479, 382, 2, 8),
(7427, 64, 1373795504, 1277, 1, 7),
(7428, 20, 1373795573, 14695, 17, 112),
(7429, 48, 1373795608, 3554, 2, 15),
(7430, 52, 1373795673, 1860, 5, 8),
(7431, 28, 1373795686, 7930, 12, 48),
(7432, 14, 1373795694, 1666, 6, 31),
(7433, 13, 1373795801, 662, 1, 10),
(7434, 22, 1373795987, 1589, 6, 15),
(7435, 47, 1373796042, 701, 1, 11),
(7436, 12, 1373796076, 814, 3, 8),
(7437, 27, 1373796104, 11812, 19, 86),
(7438, 17, 1373796210, 2297, 7, 27),
(7439, 91, 1373796220, 889, 2, 4),
(7440, 21, 1373796374, 4745, 5, 46),
(7441, 45, 1373796575, 1595, 1, 23),
(7442, 42, 1373796616, 1041, 2, 5),
(7443, 65, 1373796761, 1451, 1, 7),
(7444, 14, 1373796801, 854, 1, 3),
(7445, 59, 1373796894, 1383, 1, 3),
(7446, 16, 1373797051, 7204, 10, 49),
(7447, 19, 1373797129, 1822, 1, 9),
(7448, 41, 1373797138, 2543, 2, 24),
(7449, 64, 1373797209, 1705, 1, 6),
(7450, 25, 1373797295, 1974, 1, 11),
(7451, 51, 1373797435, 2220, 1, 7),
(7452, 20, 1373797449, 1876, 2, 11),
(7453, 12, 1373797693, 1285, 1, 2),
(7454, 24, 1373797791, 2312, 1, 11),
(7455, 43, 1373797827, 2445, 5, 17),
(7456, 25, 1373798407, 590, 1, 0),
(7457, 15, 1373798450, 4236, 12, 33),
(7458, 23, 1373798804, 24427, 36, 170),
(7459, 44, 1373798987, 4258, 5, 30),
(7460, 33, 1373799064, 3610, 8, 14),
(7461, 51, 1373799164, 1729, 1, 1),
(7462, 61, 1373799337, 2965, 1, 0),
(7463, 11, 1373799361, 164, 1, 0),
(7464, 49, 1373799558, 2554, 1, 6),
(7465, 46, 1373799568, 983, 1, 2),
(7466, 42, 1373799600, 1190, 2, 3),
(7467, 57, 1373799666, 3694, 1, 1),
(7468, 55, 1373799772, 689, 2, 1),
(7469, 20, 1373799905, 2455, 3, 8),
(7470, 64, 1373799913, 616, 1, 0),
(7471, 82, 1373799983, 7710, 1, 1),
(7472, 40, 1373800072, 4686, 4, 35),
(7473, 57, 1373800148, 482, 1, 2),
(7474, 39, 1373800211, 5436, 12, 39),
(7475, 49, 1373800281, 291, 1, 4),
(7476, 78, 1373800320, 9534, 1, 4),
(7477, 31, 1373800329, 4631, 2, 5),
(7478, 68, 1373800386, 550, 2, 7),
(7479, 76, 1373800437, 443, 1, 2),
(7480, 42, 1373800456, 437, 1, 6),
(7481, 18, 1373800474, 4380, 1, 8),
(7482, 71, 1373800603, 636, 1, 8),
(7483, 31, 1373800620, 291, 1, 4),
(7484, 87, 1373800667, 8626, 1, 2),
(7485, 99, 1373800672, 237, 1, 0),
(7486, 68, 1373800676, 290, 1, 1),
(7487, 85, 1373800681, 8493, 1, 4),
(7488, 27, 1373800722, 4618, 3, 17),
(7489, 90, 1373800911, 683, 1, 1),
(7490, 11, 1373800914, 282, 1, 0),
(7491, 64, 1373800921, 1008, 2, 9),
(7492, 104, 1373801070, 9770, 1, 2),
(7493, 53, 1373801124, 1752, 2, 5),
(7494, 82, 1373801142, 773, 1, 0),
(7495, 72, 1373801182, 1316, 1, 13),
(7496, 11, 1373801312, 398, 1, 4),
(7497, 98, 1373801380, 619, 1, 1),
(7498, 25, 1373801416, 3009, 4, 19),
(7499, 94, 1373801432, 259, 1, 1),
(7500, 12, 1373801599, 654, 1, 3),
(7501, 18, 1373801611, 1137, 3, 8),
(7502, 77, 1373801662, 610, 1, 3),
(7503, 45, 1373801678, 5103, 7, 23),
(7504, 51, 1373801766, 2239, 3, 17),
(7505, 69, 1373801906, 5825, 1, 17),
(7506, 88, 1373802046, 10561, 2, 9),
(7507, 23, 1373802074, 3270, 4, 23),
(7508, 65, 1373802095, 5334, 1, 14),
(7509, 15, 1373802112, 2858, 2, 11),
(7510, 44, 1373802157, 3169, 4, 32),
(7511, 35, 1373802188, 5881, 8, 46),
(7512, 96, 1373802203, 8155, 1, 6),
(7513, 93, 1373802204, 1751, 1, 5),
(7514, 52, 1373802254, 5597, 2, 24),
(7515, 84, 1373802268, 1477, 1, 4),
(7516, 74, 1373802302, 1837, 1, 6),
(7517, 86, 1373802310, 622, 1, 4),
(7518, 50, 1373802370, 2927, 3, 21),
(7519, 92, 1373802442, 2164, 1, 9),
(7520, 42, 1373802529, 2073, 1, 18),
(7521, 16, 1373802672, 4803, 3, 19),
(7522, 26, 1373802871, 7413, 12, 46),
(7523, 14, 1373802948, 2886, 1, 14),
(7524, 47, 1373803072, 3774, 4, 33),
(7525, 100, 1373803129, 12429, 2, 4),
(7526, 66, 1373803185, 3997, 3, 19),
(7527, 19, 1373803237, 6108, 4, 14),
(7528, 40, 1373803244, 3097, 6, 22),
(7529, 43, 1373803331, 5504, 1, 21),
(7530, 48, 1373803438, 3114, 5, 18),
(7531, 38, 1373803608, 8223, 13, 56),
(7532, 48, 1373803986, 337, 1, 0),
(7533, 15, 1373804471, 823, 1, 1),
(7534, 45, 1373804526, 877, 1, 5),
(7535, 49, 1373804717, 1067, 1, 2),
(7536, 43, 1373804800, 1151, 1, 5),
(7537, 16, 1373804890, 564, 1, 1),
(7538, 23, 1373805215, 1566, 1, 4),
(7539, 12, 1373805279, 1463, 1, 0),
(7540, 36, 1373805355, 1706, 2, 7),
(7541, 41, 1373805564, 481, 1, 2),
(7542, 17, 1373805864, 931, 1, 0),
(7543, 19, 1373805871, 2223, 3, 2),
(7544, 20, 1373805871, 1376, 1, 5),
(7545, 22, 1373805871, 1563, 1, 5),
(7546, 25, 1373805872, 2223, 2, 2),
(7547, 26, 1373805872, 2223, 1, 7),
(7548, 27, 1373805872, 2223, 1, 7),
(7549, 28, 1373805872, 2223, 1, 7),
(7550, 29, 1373805872, 2223, 3, 5),
(7551, 30, 1373805873, 2224, 2, 9),
(7552, 31, 1373805873, 2224, 2, 10),
(7553, 32, 1373805873, 2224, 2, 10),
(7554, 33, 1373805873, 2224, 2, 12),
(7555, 34, 1373805873, 2224, 3, 11),
(7556, 35, 1373805873, 2224, 3, 8),
(7557, 37, 1373805874, 1269, 1, 5),
(7558, 38, 1373805874, 2225, 2, 10),
(7559, 40, 1373805874, 2225, 2, 6),
(7560, 42, 1373805875, 964, 1, 2),
(7561, 44, 1373805875, 2226, 1, 4),
(7562, 50, 1373805876, 2226, 1, 5),
(7563, 10, 1373806615, 277, 1, 0),
(7564, 42, 1373806723, 610, 1, 2),
(7565, 46, 1373807025, 912, 1, 7),
(7566, 16, 1373807055, 943, 1, 0),
(7567, 63, 1373807102, 143, 1, 1),
(7568, 66, 1373807181, 1067, 3, 1),
(7569, 48, 1373807207, 1094, 1, 7),
(7570, 13, 1373807263, 124, 1, 0),
(7571, 50, 1373807334, 1220, 1, 2),
(7572, 65, 1373807368, 1254, 1, 4),
(7573, 62, 1373807414, 1300, 1, 4),
(7574, 41, 1373807418, 1305, 2, 2),
(7575, 36, 1373807434, 1321, 1, 8),
(7576, 40, 1373807484, 729, 2, 5),
(7577, 11, 1373807590, 598, 1, 3),
(7578, 47, 1373807635, 1522, 3, 9),
(7579, 13, 1373807646, 383, 2, 1),
(7580, 71, 1373807694, 611, 1, 2),
(7581, 40, 1373807816, 332, 1, 1),
(7582, 19, 1373807976, 1864, 1, 8),
(7583, 67, 1373808131, 1311, 1, 5),
(7584, 70, 1373808166, 2052, 3, 7),
(7585, 71, 1373808189, 495, 1, 1),
(7586, 60, 1373808220, 2106, 1, 5),
(7587, 57, 1373808227, 1258, 1, 4),
(7588, 42, 1373808246, 1461, 1, 5),
(7589, 18, 1373808330, 2218, 1, 9),
(7590, 49, 1373808360, 2247, 3, 9),
(7591, 52, 1373808421, 1069, 3, 3),
(7592, 61, 1373808638, 1339, 1, 9),
(7593, 39, 1373808718, 2605, 2, 16),
(7594, 51, 1373808757, 768, 2, 1),
(7595, 40, 1373808851, 1035, 2, 7),
(7596, 81, 1373808945, 2830, 2, 0),
(7597, 46, 1373809023, 1998, 1, 12),
(7598, 72, 1373809056, 716, 1, 0),
(7599, 17, 1373809066, 2274, 1, 9),
(7600, 12, 1373809177, 1600, 1, 5),
(7601, 57, 1373809245, 570, 1, 2),
(7602, 61, 1373809410, 772, 1, 5),
(7603, 11, 1373809600, 483, 1, 3),
(7604, 85, 1373809681, 238, 1, 0),
(7605, 74, 1373809688, 404, 1, 0),
(7606, 13, 1373809718, 608, 1, 3),
(7607, 55, 1373809762, 2000, 1, 9),
(7608, 68, 1373809781, 524, 2, 2),
(7609, 14, 1373809869, 2717, 1, 11),
(7610, 50, 1373809924, 1879, 3, 10),
(7611, 85, 1373810044, 363, 1, 1),
(7612, 82, 1373810057, 946, 1, 1),
(7613, 20, 1373810069, 3957, 6, 18),
(7614, 76, 1373810147, 1986, 1, 7),
(7615, 66, 1373810172, 2991, 2, 10),
(7616, 72, 1373810179, 892, 2, 2),
(7617, 60, 1373810279, 2059, 1, 4),
(7618, 17, 1373810287, 250, 1, 3),
(7619, 78, 1373810300, 1412, 1, 2),
(7620, 70, 1373810356, 2190, 2, 6),
(7621, 67, 1373810443, 1619, 1, 14),
(7622, 64, 1373810456, 2506, 4, 8),
(7623, 40, 1373810466, 1615, 2, 14),
(7624, 75, 1373810499, 2658, 1, 4),
(7625, 87, 1373810556, 1039, 1, 6),
(7626, 83, 1373810559, 818, 1, 8),
(7627, 45, 1373810590, 2345, 2, 13),
(7628, 52, 1373810636, 2214, 2, 16),
(7629, 61, 1373810742, 459, 1, 5),
(7630, 55, 1373810746, 520, 2, 2),
(7631, 104, 1373810755, 4640, 1, 6),
(7632, 18, 1373810796, 2466, 5, 17),
(7633, 86, 1373810832, 779, 1, 2),
(7634, 61, 1373810907, 165, 1, 1),
(7635, 50, 1373811590, 598, 1, 2),
(7636, 48, 1373811732, 740, 1, 2),
(7637, 15, 1373811739, 748, 1, 0),
(7638, 62, 1373811912, 919, 1, 1),
(7639, 14, 1373811972, 981, 2, 3),
(7640, 27, 1373811990, 999, 3, 6),
(7641, 25, 1373812459, 1468, 2, 9),
(7642, 56, 1373812588, 1595, 2, 1),
(7643, 11, 1373812592, 152, 1, 0),
(7644, 51, 1373812689, 894, 1, 3),
(7645, 42, 1373812755, 698, 1, 2),
(7646, 52, 1373812765, 989, 1, 4),
(7647, 29, 1373812865, 1874, 3, 5),
(7648, 67, 1373812959, 1966, 1, 3),
(7649, 54, 1373813180, 1330, 2, 7),
(7650, 40, 1373813292, 2300, 1, 17),
(7651, 72, 1373813297, 2303, 1, 0),
(7652, 55, 1373813311, 1474, 1, 11),
(7653, 87, 1373813332, 2338, 1, 1),
(7654, 44, 1373813353, 1524, 3, 7),
(7655, 80, 1373813374, 2380, 2, 1),
(7656, 11, 1373813381, 19, 1, 1),
(7657, 20, 1373813392, 2140, 1, 8),
(7658, 97, 1373813529, 2534, 1, 0),
(7659, 89, 1373813566, 2572, 1, 1),
(7660, 13, 1373813604, 219, 1, 2),
(7661, 78, 1373813756, 2762, 1, 3),
(7662, 61, 1373813844, 2588, 1, 14),
(7663, 21, 1373813972, 2981, 2, 12),
(7664, 77, 1373814244, 842, 1, 1),
(7665, 16, 1373814283, 1795, 1, 7),
(7666, 57, 1373814302, 2546, 1, 15),
(7667, 75, 1373814406, 1136, 1, 3),
(7668, 34, 1373814415, 3423, 4, 13),
(7669, 12, 1373814691, 1382, 2, 4),
(7670, 81, 1373814712, 1687, 1, 6),
(7671, 15, 1373814767, 1261, 2, 7),
(7672, 54, 1373814786, 963, 1, 3),
(7673, 62, 1373814931, 156, 1, 0),
(7674, 81, 1373815009, 297, 2, 0),
(7675, 69, 1373815041, 4048, 2, 12),
(7676, 58, 1373815153, 614, 1, 1),
(7677, 76, 1373815204, 937, 1, 3),
(7678, 71, 1373815207, 1233, 3, 3),
(7679, 63, 1373815213, 4220, 3, 22),
(7680, 109, 1373815287, 1011, 1, 1),
(7681, 14, 1373815365, 3393, 1, 17),
(7682, 40, 1373815442, 2150, 2, 7),
(7683, 59, 1373815497, 2032, 3, 7),
(7684, 84, 1373815532, 1264, 1, 4),
(7685, 16, 1373815739, 1172, 1, 4),
(7686, 82, 1373815767, 627, 1, 4),
(7687, 89, 1373815964, 805, 1, 6),
(7688, 21, 1373815968, 1996, 1, 12),
(7689, 83, 1373815979, 4985, 2, 8),
(7690, 24, 1373816046, 2517, 2, 16),
(7691, 49, 1373816131, 5139, 2, 30),
(7692, 50, 1373816175, 3610, 3, 25),
(7693, 69, 1373816201, 1160, 1, 4),
(7694, 52, 1373816242, 1663, 4, 7),
(7695, 47, 1373816256, 3165, 8, 20),
(7696, 17, 1373816285, 940, 2, 3),
(7697, 74, 1373816314, 1133, 1, 15),
(7698, 49, 1373816330, 199, 1, 3),
(7699, 68, 1373816357, 1542, 1, 10),
(7700, 45, 1373816402, 5250, 7, 31),
(7701, 48, 1373816473, 3992, 3, 16),
(7702, 109, 1373816490, 147, 1, 1),
(7703, 95, 1373816537, 3026, 1, 13),
(7704, 71, 1373816602, 767, 2, 6),
(7705, 72, 1373816652, 1260, 1, 12),
(7706, 103, 1373816795, 5800, 2, 6),
(7707, 25, 1373816807, 4234, 4, 30),
(7708, 78, 1373816852, 656, 1, 10),
(7709, 70, 1373816854, 1048, 1, 6),
(7710, 66, 1373816885, 5443, 2, 23),
(7711, 110, 1373816952, 1503, 1, 7),
(7712, 89, 1373816961, 264, 1, 1),
(7713, 53, 1373816979, 5986, 5, 20),
(7714, 57, 1373816999, 2697, 2, 18),
(7715, 42, 1373817044, 4289, 4, 26),
(7716, 19, 1373817127, 5648, 4, 36),
(7717, 47, 1373817223, 967, 2, 2),
(7718, 83, 1373817302, 1323, 1, 6),
(7719, 85, 1373817329, 1162, 4, 10),
(7720, 28, 1373817338, 6347, 8, 29),
(7721, 46, 1373817386, 6394, 5, 37),
(7722, 76, 1373817456, 1639, 4, 12),
(7723, 16, 1373817585, 1846, 2, 10),
(7724, 78, 1373817689, 837, 3, 1),
(7725, 38, 1373817835, 6843, 8, 54),
(7726, 52, 1373817852, 405, 1, 3),
(7727, 71, 1373817868, 887, 1, 4),
(7728, 14, 1373817945, 2580, 1, 12),
(7729, 95, 1373817954, 1416, 1, 5),
(7730, 65, 1373817989, 5461, 6, 15),
(7731, 25, 1373818170, 1363, 1, 8),
(7732, 76, 1373818215, 759, 2, 3),
(7733, 51, 1373818225, 5536, 1, 25),
(7734, 53, 1373818247, 1012, 1, 5),
(7735, 80, 1373818294, 2390, 2, 24),
(7736, 31, 1373818320, 7328, 15, 41),
(7737, 70, 1373818393, 1109, 1, 8),
(7738, 82, 1373818456, 509, 1, 1),
(7739, 58, 1373818489, 932, 2, 2),
(7740, 15, 1373818605, 3838, 1, 21),
(7741, 83, 1373818680, 1378, 1, 5),
(7742, 81, 1373818739, 3161, 3, 18),
(7743, 78, 1373818753, 1064, 2, 4),
(7744, 53, 1373818815, 568, 1, 1),
(7745, 107, 1373818832, 45, 1, 0),
(7746, 103, 1373818835, 1399, 1, 1),
(7747, 49, 1373818930, 1348, 1, 5),
(7748, 50, 1373818966, 1866, 2, 16),
(7749, 75, 1373819026, 4620, 6, 38),
(7750, 35, 1373819062, 8070, 12, 59),
(7751, 91, 1373819176, 8182, 2, 16),
(7752, 51, 1373819261, 314, 1, 1),
(7753, 68, 1373819367, 2060, 1, 11),
(7754, 106, 1373819438, 724, 1, 2),
(7755, 92, 1373819453, 211, 1, 1),
(7756, 69, 1373819497, 3296, 3, 14),
(7757, 64, 1373819530, 7047, 7, 36),
(7758, 14, 1373819536, 908, 1, 5),
(7759, 77, 1373819541, 5297, 6, 34),
(7760, 46, 1373819544, 2158, 3, 11),
(7761, 43, 1373819567, 8575, 6, 46),
(7762, 56, 1373819587, 6999, 5, 34),
(7763, 70, 1373819588, 1195, 3, 8),
(7764, 90, 1373819591, 532, 1, 0),
(7765, 12, 1373819603, 488, 1, 3),
(7766, 108, 1373819657, 275, 1, 5),
(7767, 16, 1373819687, 1890, 2, 10),
(7768, 47, 1373819810, 2587, 3, 24),
(7769, 76, 1373820020, 1022, 1, 10),
(7770, 102, 1373820118, 677, 1, 4),
(7771, 90, 1373820119, 527, 1, 2),
(7772, 101, 1373820136, 1153, 1, 6),
(7773, 82, 1373820188, 1094, 1, 2),
(7774, 47, 1373820498, 231, 1, 0),
(7775, 91, 1373820508, 899, 1, 1),
(7776, 71, 1373820603, 640, 1, 2),
(7777, 103, 1373820735, 1293, 1, 2),
(7778, 48, 1373820822, 2806, 3, 16),
(7779, 88, 1373820860, 567, 1, 0),
(7780, 85, 1373820907, 3578, 2, 11),
(7781, 51, 1373820923, 1662, 1, 4),
(7782, 78, 1373820948, 1797, 3, 6),
(7783, 64, 1373821044, 1514, 3, 5),
(7784, 83, 1373821337, 2657, 3, 4),
(7785, 62, 1373821341, 3572, 4, 17),
(7786, 82, 1373821368, 966, 2, 1),
(7787, 55, 1373821436, 8125, 6, 53),
(7788, 11, 1373821505, 3457, 3, 6),
(7789, 16, 1373821522, 1835, 1, 8),
(7790, 42, 1373821541, 1770, 1, 6),
(7791, 92, 1373821747, 2294, 1, 4),
(7792, 98, 1373821771, 5060, 2, 14),
(7793, 75, 1373821915, 2889, 1, 13),
(7794, 63, 1373822084, 5094, 5, 28),
(7795, 17, 1373822126, 4397, 6, 22),
(7796, 13, 1373822163, 3825, 2, 16),
(7797, 76, 1373822239, 507, 1, 0),
(7798, 66, 1373822242, 5357, 5, 15),
(7799, 100, 1373822261, 11266, 2, 25),
(7800, 50, 1373822266, 2626, 1, 2),
(7801, 76, 1373822303, 64, 1, 0),
(7802, 80, 1373822347, 993, 1, 2),
(7803, 54, 1373822382, 7596, 8, 38),
(7804, 40, 1373822507, 7064, 6, 38),
(7805, 74, 1373822587, 6273, 1, 26),
(7806, 53, 1373822623, 740, 1, 2),
(7807, 62, 1373822744, 1403, 1, 12),
(7808, 80, 1373822831, 484, 1, 2),
(7809, 42, 1373822837, 1296, 1, 4),
(7810, 69, 1373822910, 743, 1, 7),
(7811, 28, 1373822929, 5591, 4, 42),
(7812, 39, 1373822931, 11939, 12, 51),
(7813, 46, 1373822940, 1977, 2, 10),
(7814, 55, 1373822946, 1510, 2, 11),
(7815, 68, 1373822998, 1151, 4, 6),
(7816, 85, 1373823086, 1055, 2, 4),
(7817, 49, 1373823088, 1079, 1, 8),
(7818, 61, 1373823105, 9261, 7, 48),
(7819, 77, 1373823119, 3577, 1, 21),
(7820, 66, 1373823219, 783, 4, 9),
(7821, 90, 1373823321, 432, 1, 2),
(7822, 81, 1373823325, 3781, 2, 16),
(7823, 93, 1373823358, 667, 1, 3),
(7824, 42, 1373823464, 627, 4, 3),
(7825, 17, 1373823509, 816, 3, 6),
(7826, 66, 1373823549, 330, 1, 0),
(7827, 79, 1373823561, 12567, 2, 22),
(7828, 58, 1373823598, 5109, 5, 31),
(7829, 76, 1373823729, 516, 1, 2),
(7830, 70, 1373824004, 1704, 5, 7),
(7831, 100, 1373824005, 1744, 2, 3),
(7832, 53, 1373824006, 1202, 1, 11),
(7833, 64, 1373824074, 1793, 1, 17),
(7834, 88, 1373824121, 456, 1, 1),
(7835, 110, 1373824143, 4492, 1, 1),
(7836, 52, 1373824238, 5415, 5, 32),
(7837, 80, 1373824355, 1079, 1, 2),
(7838, 12, 1373824370, 960, 2, 5),
(7839, 47, 1373824377, 2446, 3, 11),
(7840, 87, 1373824423, 1418, 1, 7),
(7841, 14, 1373824473, 2159, 1, 10),
(7842, 99, 1373824527, 609, 1, 1),
(7843, 17, 1373824653, 1144, 3, 6),
(7844, 55, 1373824671, 1725, 1, 11),
(7845, 75, 1373824672, 1097, 1, 5),
(7846, 95, 1373824672, 1087, 1, 4),
(7847, 34, 1373824691, 10276, 10, 55),
(7848, 23, 1373824756, 13765, 23, 74),
(7849, 40, 1373824818, 2311, 1, 18),
(7850, 17, 1373824891, 238, 1, 3),
(7851, 45, 1373825008, 8606, 10, 34),
(7852, 49, 1373825055, 1158, 1, 4),
(7853, 54, 1373825078, 2696, 5, 18),
(7854, 58, 1373825079, 1481, 2, 7),
(7855, 81, 1373825149, 338, 1, 1),
(7856, 71, 1373825268, 2161, 2, 13),
(7857, 47, 1373825321, 944, 1, 5),
(7858, 12, 1373825465, 1095, 5, 5),
(7859, 50, 1373825534, 2812, 1, 12),
(7860, 63, 1373825546, 3462, 6, 29),
(7861, 83, 1373825606, 2819, 1, 11),
(7862, 80, 1373825621, 492, 1, 1),
(7863, 32, 1373825626, 14634, 18, 70),
(7864, 87, 1373825655, 210, 1, 0),
(7865, 106, 1373825987, 952, 1, 1),
(7866, 78, 1373826044, 4148, 5, 25),
(7867, 81, 1373826102, 773, 1, 2),
(7868, 86, 1373826156, 811, 1, 3),
(7869, 50, 1373826200, 178, 1, 3),
(7870, 28, 1373826221, 3292, 2, 19),
(7871, 16, 1373826317, 3846, 5, 31),
(7872, 74, 1373826329, 2350, 1, 11),
(7873, 66, 1373826346, 2797, 2, 22),
(7874, 91, 1373826362, 2316, 1, 8),
(7875, 82, 1373826389, 3508, 3, 19),
(7876, 99, 1373826506, 1072, 1, 3),
(7877, 49, 1373826570, 183, 1, 0),
(7878, 68, 1373826570, 2539, 2, 20),
(7879, 50, 1373826631, 431, 1, 3),
(7880, 93, 1373826665, 3024, 1, 8),
(7881, 59, 1373826824, 11327, 7, 66),
(7882, 77, 1373826853, 3734, 3, 21),
(7883, 94, 1373826939, 2093, 1, 4),
(7884, 90, 1373826946, 848, 1, 3),
(7885, 71, 1373827015, 1747, 1, 12),
(7886, 58, 1373827149, 1783, 1, 5),
(7887, 48, 1373827170, 5308, 4, 23),
(7888, 109, 1373827196, 730, 1, 2),
(7889, 84, 1373827223, 879, 3, 2),
(7890, 76, 1373827238, 607, 1, 5),
(7891, 70, 1373827332, 3327, 5, 26),
(7892, 41, 1373827432, 16440, 21, 83),
(7893, 69, 1373827465, 4211, 2, 27),
(7894, 45, 1373827513, 1135, 1, 5),
(7895, 85, 1373827604, 3078, 2, 10),
(7896, 11, 1373827735, 4615, 1, 22),
(7897, 63, 1373827742, 2196, 2, 9),
(7898, 40, 1373827918, 3100, 3, 13),
(7899, 96, 1373827930, 2038, 1, 4),
(7900, 47, 1373827976, 2485, 3, 18),
(7901, 61, 1373828004, 4514, 8, 18),
(7902, 103, 1373828029, 500, 1, 0),
(7903, 63, 1373828037, 295, 1, 2),
(7904, 46, 1373828072, 3180, 1, 16),
(7905, 42, 1373828073, 3395, 4, 17),
(7906, 47, 1373828091, 115, 1, 1),
(7907, 62, 1373828109, 5365, 6, 32),
(7908, 105, 1373828264, 503, 1, 1),
(7909, 108, 1373828281, 3908, 1, 7),
(7910, 80, 1373828435, 1831, 1, 3),
(7911, 71, 1373828537, 917, 3, 8),
(7912, 51, 1373828553, 3877, 6, 22),
(7913, 87, 1373828667, 1625, 1, 6),
(7914, 68, 1373828732, 2162, 3, 6),
(7915, 14, 1373828734, 4261, 4, 21),
(7916, 95, 1373828735, 1297, 1, 5),
(7917, 106, 1373828756, 804, 1, 4),
(7918, 13, 1373828765, 6517, 4, 23),
(7919, 101, 1373828839, 804, 1, 4),
(7920, 104, 1373828844, 1833, 1, 5),
(7921, 85, 1373828848, 1244, 1, 5),
(7922, 17, 1373828870, 1628, 5, 7),
(7923, 16, 1373828910, 2593, 4, 13),
(7924, 50, 1373828986, 1285, 1, 5),
(7925, 58, 1373828999, 989, 1, 5),
(7926, 98, 1373829095, 2900, 1, 8),
(7927, 11, 1373829116, 1381, 1, 4),
(7928, 92, 1373829180, 1677, 1, 4),
(7929, 76, 1373829201, 1916, 3, 8),
(7930, 55, 1373829214, 3119, 5, 15),
(7931, 110, 1373829247, 600, 1, 2),
(7932, 96, 1373829257, 1327, 1, 5),
(7933, 68, 1373829362, 630, 1, 5),
(7934, 91, 1373829397, 904, 2, 1),
(7935, 107, 1373829432, 1051, 1, 0),
(7936, 72, 1373829437, 4665, 7, 34),
(7937, 58, 1373829443, 90, 1, 0),
(7938, 86, 1373829465, 1741, 1, 7),
(7939, 13, 1373829491, 725, 1, 2),
(7940, 96, 1373829791, 534, 1, 1),
(7941, 55, 1373829810, 596, 1, 1),
(7942, 84, 1373829824, 1350, 1, 8),
(7943, 40, 1373829845, 1927, 2, 15),
(7944, 85, 1373829893, 1045, 1, 4),
(7945, 23, 1373829904, 5148, 3, 30),
(7946, 59, 1373829908, 3084, 4, 17),
(7947, 77, 1373829914, 3061, 1, 21),
(7948, 83, 1373829916, 4310, 3, 18),
(7949, 33, 1373829920, 18928, 26, 108),
(7950, 38, 1373829955, 12120, 10, 55),
(7951, 105, 1373830077, 362, 1, 0),
(7952, 51, 1373830155, 1602, 3, 6),
(7953, 39, 1373830284, 7352, 6, 38),
(7954, 64, 1373830314, 6240, 4, 39),
(7955, 88, 1373830336, 697, 1, 3),
(7956, 66, 1373830337, 3991, 3, 23),
(7957, 47, 1373830344, 2253, 3, 8),
(7958, 32, 1373830386, 4760, 3, 24),
(7959, 49, 1373830400, 1419, 4, 10),
(7960, 96, 1373830404, 612, 1, 1),
(7961, 45, 1373830449, 2936, 5, 22),
(7962, 100, 1373830560, 6555, 1, 25),
(7963, 75, 1373830609, 4453, 5, 22),
(7964, 78, 1373830711, 2109, 1, 12),
(7965, 57, 1373830751, 9422, 9, 46),
(7966, 58, 1373830759, 1316, 2, 5),
(7967, 71, 1373830778, 866, 1, 7),
(7968, 13, 1373830818, 1327, 1, 10),
(7969, 82, 1373830937, 4548, 3, 13),
(7970, 25, 1373830950, 12780, 13, 93),
(7971, 80, 1373831014, 1232, 1, 3),
(7972, 108, 1373831211, 2930, 1, 12),
(7973, 17, 1373831257, 2386, 2, 16),
(7974, 107, 1373831350, 872, 1, 3),
(7975, 47, 1373831431, 1087, 1, 9),
(7976, 42, 1373831465, 3307, 2, 28),
(7977, 94, 1373831485, 2094, 1, 1),
(7978, 81, 1373831613, 519, 1, 1),
(7979, 63, 1373831631, 3594, 1, 28),
(7980, 51, 1373831764, 1050, 2, 7),
(7981, 49, 1373831974, 1574, 1, 12),
(7982, 50, 1373831975, 2988, 4, 21),
(7983, 48, 1373831984, 3497, 4, 22),
(7984, 58, 1373831988, 1229, 1, 5),
(7985, 22, 1373831994, 19486, 35, 103),
(7986, 74, 1373832114, 1688, 2, 9),
(7987, 93, 1373832301, 3286, 1, 10),
(7988, 62, 1373832313, 1559, 2, 7),
(7989, 69, 1373832319, 4854, 8, 23),
(7990, 94, 1373832467, 500, 1, 3),
(7991, 53, 1373832510, 1478, 2, 10),
(7992, 66, 1373832530, 1740, 3, 9),
(7993, 38, 1373832560, 2605, 2, 10),
(7994, 75, 1373832603, 1994, 1, 14),
(7995, 41, 1373832666, 5234, 5, 27),
(7996, 77, 1373832703, 2789, 2, 15),
(7997, 65, 1373832781, 14054, 17, 103),
(7998, 54, 1373832793, 7572, 6, 48),
(7999, 40, 1373832811, 2966, 3, 22),
(8000, 46, 1373833001, 4929, 7, 22),
(8001, 72, 1373833105, 3668, 5, 20),
(8002, 57, 1373833185, 2434, 4, 8),
(8003, 45, 1373833323, 2734, 2, 9),
(8004, 52, 1373833363, 6602, 12, 35),
(8005, 60, 1373833591, 22598, 21, 108),
(8006, 38, 1373833637, 1077, 1, 1),
(8007, 68, 1373833671, 4309, 4, 14),
(8008, 33, 1373833699, 3779, 4, 16),
(8009, 49, 1373833778, 1804, 1, 4),
(8010, 75, 1373834048, 1445, 1, 4),
(8011, 71, 1373834082, 3304, 2, 13),
(8012, 50, 1373834291, 2316, 1, 5),
(8013, 25, 1373834348, 1998, 1, 2),
(8014, 70, 1373834438, 7106, 9, 32),
(8015, 11, 1373834726, 5610, 4, 10),
(8016, 27, 1373834765, 22654, 26, 131),
(8017, 76, 1373834837, 5636, 7, 20),
(8018, 41, 1373834917, 2251, 1, 8),
(8019, 24, 1373835047, 19000, 18, 106),
(8020, 73, 1373835106, 24112, 20, 106),
(8021, 67, 1373835199, 22240, 20, 120),
(8022, 48, 1373835422, 3438, 1, 7),
(8023, 16, 1373835542, 6632, 5, 26),
(8024, 52, 1373835581, 2218, 2, 10),
(8025, 55, 1373835714, 5742, 10, 17),
(8026, 40, 1373835768, 2957, 2, 7),
(8027, 25, 1373836537, 1961, 2, 11),
(8028, 79, 1373836603, 13042, 10, 42),
(8029, 47, 1373836872, 444, 1, 1),
(8030, 22, 1373836907, 1340, 1, 4),
(8031, 50, 1373837099, 1438, 1, 1),
(8032, 19, 1373837175, 20048, 22, 95),
(8033, 11, 1373837191, 833, 1, 4),
(8034, 24, 1373837201, 2154, 2, 4),
(8035, 74, 1373837211, 346, 1, 1),
(8036, 63, 1373837253, 5622, 1, 2),
(8037, 59, 1373837285, 640, 1, 4),
(8038, 14, 1373837359, 2814, 2, 8),
(8039, 47, 1373837491, 619, 1, 4),
(8040, 56, 1373837520, 17933, 14, 63),
(8041, 99, 1373837588, 6074, 1, 0),
(8042, 38, 1373837690, 4053, 3, 8),
(8043, 71, 1373837853, 3031, 1, 3),
(8044, 53, 1373837878, 1417, 2, 4),
(8045, 37, 1373837973, 26981, 32, 127),
(8046, 44, 1373837983, 24630, 17, 117),
(8047, 64, 1373838007, 7693, 3, 22),
(8048, 50, 1373838028, 928, 1, 3),
(8049, 73, 1373838057, 1005, 1, 4),
(8050, 46, 1373838061, 1475, 2, 9),
(8051, 14, 1373838091, 732, 1, 7),
(8052, 62, 1373838096, 5783, 3, 10),
(8053, 23, 1373838142, 8237, 2, 18),
(8054, 17, 1373838202, 1664, 1, 11),
(8055, 49, 1373838233, 2683, 1, 9),
(8056, 68, 1373838522, 4851, 1, 14),
(8057, 18, 1373838782, 27791, 27, 144),
(8058, 42, 1373838876, 3576, 2, 12),
(8059, 55, 1373839232, 3518, 5, 6),
(8060, 11, 1373839264, 2073, 1, 2),
(8061, 72, 1373839286, 6181, 4, 10),
(8062, 70, 1373839373, 4935, 1, 15),
(8063, 12, 1373839482, 4427, 1, 16),
(8064, 45, 1373839490, 6167, 2, 17),
(8065, 82, 1373839653, 1120, 1, 0),
(8066, 25, 1373839656, 3119, 1, 20),
(8067, 42, 1373839662, 786, 1, 1),
(8068, 53, 1373839665, 539, 1, 5),
(8069, 46, 1373839775, 1694, 1, 6),
(8070, 71, 1373839842, 526, 1, 1),
(8071, 39, 1373839910, 9626, 6, 43),
(8072, 76, 1373839953, 388, 1, 1),
(8073, 69, 1373839963, 7644, 4, 18),
(8074, 16, 1373840010, 2113, 1, 8),
(8075, 66, 1373840041, 7511, 5, 11),
(8076, 77, 1373840086, 7383, 3, 14),
(8077, 12, 1373840101, 618, 1, 3),
(8078, 94, 1373840146, 2843, 1, 4),
(8079, 18, 1373840149, 1367, 1, 9),
(8080, 51, 1373840159, 698, 2, 5),
(8081, 86, 1373840430, 195, 1, 0),
(8082, 19, 1373840440, 3265, 6, 14),
(8083, 13, 1373840449, 6379, 1, 27),
(8084, 96, 1373840548, 3583, 1, 2),
(8085, 94, 1373840806, 660, 1, 1),
(8086, 14, 1373840984, 1392, 1, 12),
(8087, 51, 1373840986, 745, 1, 4),
(8088, 60, 1373841100, 7509, 7, 21),
(8089, 84, 1373841106, 164, 1, 0),
(8090, 40, 1373841124, 5356, 5, 25),
(8091, 79, 1373841195, 2966, 2, 3),
(8092, 66, 1373841227, 436, 1, 3),
(8093, 75, 1373841229, 2907, 2, 15),
(8094, 17, 1373841231, 1644, 2, 13),
(8095, 53, 1373841262, 1597, 2, 20),
(8096, 51, 1373841265, 279, 1, 4),
(8097, 52, 1373841277, 2122, 2, 19),
(8098, 39, 1373841293, 1383, 1, 13),
(8099, 79, 1373841384, 189, 1, 1),
(8100, 59, 1373841415, 2516, 3, 9),
(8101, 46, 1373841444, 1483, 4, 14),
(8102, 106, 1373841504, 540, 1, 5),
(8103, 83, 1373841605, 923, 1, 6),
(8104, 63, 1373841638, 630, 3, 3),
(8105, 62, 1373841721, 1670, 2, 13),
(8106, 108, 1373841730, 10519, 2, 3),
(8107, 102, 1373841822, 334, 1, 0),
(8108, 84, 1373841832, 726, 1, 1),
(8109, 66, 1373841836, 609, 3, 3),
(8110, 12, 1373841888, 737, 1, 6),
(8111, 88, 1373841890, 944, 2, 7),
(8112, 93, 1373841900, 75, 1, 0),
(8113, 80, 1373842045, 891, 2, 5),
(8114, 74, 1373842064, 2139, 4, 13),
(8115, 77, 1373842102, 855, 1, 5),
(8116, 76, 1373842128, 272, 1, 2),
(8117, 78, 1373842133, 254, 1, 2),
(8118, 23, 1373842169, 4027, 5, 33),
(8119, 53, 1373842258, 996, 1, 16),
(8120, 65, 1373842268, 9487, 5, 19),
(8121, 23, 1373842275, 105, 1, 1),
(8122, 61, 1373842286, 8786, 9, 42),
(8123, 16, 1373842318, 2072, 4, 13),
(8124, 81, 1373842382, 918, 3, 5),
(8125, 48, 1373842421, 6999, 7, 47),
(8126, 102, 1373842435, 612, 2, 4),
(8127, 72, 1373842444, 2505, 6, 12),
(8128, 85, 1373842460, 1244, 2, 4),
(8129, 58, 1373842504, 6639, 2, 24),
(8130, 108, 1373842510, 780, 1, 2),
(8131, 92, 1373842512, 620, 1, 2),
(8132, 38, 1373842517, 3159, 3, 29),
(8133, 24, 1373842541, 5340, 3, 42),
(8134, 91, 1373842547, 1373, 2, 11),
(8135, 99, 1373842554, 697, 1, 7),
(8136, 14, 1373842565, 1581, 1, 12),
(8137, 15, 1373842624, 24018, 21, 110),
(8138, 45, 1373842634, 1350, 2, 25),
(8139, 84, 1373842740, 908, 1, 6),
(8140, 97, 1373842815, 1708, 5, 15),
(8141, 68, 1373842826, 1488, 2, 5),
(8142, 50, 1373843066, 4819, 8, 35),
(8143, 17, 1373843107, 1149, 2, 8),
(8144, 13, 1373843114, 2665, 2, 11),
(8145, 51, 1373843153, 1536, 3, 19),
(8146, 35, 1373843285, 24223, 26, 126),
(8147, 46, 1373843362, 1918, 5, 30),
(8148, 70, 1373843362, 1942, 1, 8),
(8149, 47, 1373843489, 5563, 3, 32),
(8150, 39, 1373843501, 2208, 1, 8),
(8151, 73, 1373843674, 5617, 2, 17),
(8152, 12, 1373843692, 1300, 1, 5),
(8153, 11, 1373843908, 1505, 1, 3),
(8154, 36, 1373844006, 33014, 24, 177),
(8155, 78, 1373844122, 954, 1, 2),
(8156, 11, 1373844214, 306, 1, 0),
(8157, 56, 1373844372, 6852, 3, 35),
(8158, 80, 1373844716, 871, 1, 1),
(8159, 41, 1373844798, 9881, 7, 59),
(8160, 49, 1373844856, 6502, 5, 35),
(8161, 67, 1373844870, 5702, 1, 3),
(8162, 63, 1373844889, 708, 1, 5),
(8163, 53, 1373845018, 2759, 5, 14),
(8164, 48, 1373845040, 1631, 2, 6),
(8165, 82, 1373845144, 1328, 1, 2),
(8166, 55, 1373845172, 5940, 6, 41),
(8167, 19, 1373845262, 4822, 9, 26),
(8168, 64, 1373845269, 7262, 1, 37),
(8169, 13, 1373845316, 2202, 3, 12),
(8170, 95, 1373845399, 651, 3, 4),
(8171, 63, 1373845451, 302, 1, 3),
(8172, 50, 1373845652, 2586, 1, 11),
(8173, 62, 1373845667, 3424, 2, 19),
(8174, 32, 1373845677, 15291, 20, 74),
(8175, 100, 1373845721, 3823, 1, 3),
(8176, 72, 1373845801, 1617, 2, 4),
(8177, 74, 1373846052, 1078, 1, 3),
(8178, 15, 1373846097, 3472, 2, 17),
(8179, 22, 1373846168, 9261, 5, 10),
(8180, 40, 1373846196, 3575, 5, 14),
(8181, 68, 1373846263, 3437, 1, 18),
(8182, 58, 1373846282, 3777, 3, 18),
(8183, 12, 1373846394, 1790, 1, 6),
(8184, 20, 1373846405, 33013, 42, 146),
(8185, 94, 1373846490, 1850, 1, 7),
(8186, 99, 1373846494, 1636, 1, 9),
(8187, 82, 1373846518, 1374, 3, 15),
(8188, 24, 1373846634, 4093, 2, 17),
(8189, 90, 1373846641, 1879, 1, 13),
(8190, 59, 1373846771, 4738, 6, 33),
(8191, 28, 1373846882, 20661, 19, 127),
(8192, 97, 1373847236, 3282, 1, 8),
(8193, 16, 1373847317, 4997, 4, 22),
(8194, 42, 1373847333, 7671, 9, 40),
(8195, 22, 1373847459, 1291, 1, 1),
(8196, 48, 1373847471, 2431, 2, 12),
(8197, 66, 1373847494, 5656, 4, 35),
(8198, 72, 1373847623, 1822, 1, 4),
(8199, 43, 1373847629, 28062, 18, 144),
(8200, 57, 1373847659, 12745, 11, 62),
(8201, 14, 1373848135, 5570, 4, 22),
(8202, 81, 1373848177, 3273, 4, 11),
(8203, 84, 1373848201, 2392, 2, 12),
(8204, 53, 1373848299, 3281, 2, 12),
(8205, 79, 1373848304, 4648, 7, 18),
(8206, 89, 1373848372, 901, 1, 0),
(8207, 53, 1373848517, 218, 1, 1),
(8208, 63, 1373848673, 1560, 3, 3),
(8209, 17, 1373848697, 4602, 7, 15),
(8210, 67, 1373848763, 3893, 1, 17),
(8211, 12, 1373848840, 1020, 1, 3),
(8212, 24, 1373848960, 1493, 1, 2),
(8213, 74, 1373848990, 1822, 2, 12),
(8214, 91, 1373849100, 1029, 1, 5),
(8215, 22, 1373849177, 1718, 2, 9),
(8216, 12, 1373849187, 347, 1, 0),
(8217, 48, 1373849199, 1728, 2, 5),
(8218, 76, 1373849201, 2052, 1, 12),
(8219, 81, 1373849213, 682, 1, 2),
(8220, 87, 1373849219, 852, 1, 6),
(8221, 79, 1373849222, 918, 2, 3),
(8222, 80, 1373849244, 4004, 4, 28),
(8223, 102, 1373849273, 3569, 1, 0),
(8224, 92, 1373849346, 787, 1, 0),
(8225, 17, 1373849378, 681, 1, 4),
(8226, 68, 1373849441, 3178, 3, 9),
(8227, 42, 1373849522, 2188, 4, 14),
(8228, 98, 1373849588, 551, 1, 0),
(8229, 62, 1373849632, 223, 1, 1),
(8230, 45, 1373849653, 7017, 4, 29),
(8231, 82, 1373849655, 1984, 1, 7),
(8232, 17, 1373849923, 545, 2, 3),
(8233, 53, 1373849942, 1424, 1, 5),
(8234, 58, 1373850059, 3776, 2, 6),
(8235, 100, 1373850545, 1529, 1, 5),
(8236, 40, 1373850602, 2785, 2, 24),
(8237, 87, 1373850666, 42, 1, 0),
(8238, 79, 1373850702, 815, 1, 4),
(8239, 11, 1373850797, 279, 1, 0),
(8240, 58, 1373850900, 841, 1, 5),
(8241, 55, 1373850965, 5793, 2, 17),
(8242, 53, 1373850967, 1024, 2, 5),
(8243, 62, 1373851007, 1375, 1, 5),
(8244, 90, 1373851069, 4428, 4, 8),
(8245, 83, 1373851080, 5160, 4, 31),
(8246, 49, 1373851149, 6293, 3, 28),
(8247, 67, 1373851186, 454, 1, 1),
(8248, 21, 1373851417, 35449, 29, 175),
(8249, 84, 1373851467, 3266, 2, 7),
(8250, 13, 1373851474, 3511, 1, 8),
(8251, 66, 1373851535, 4041, 4, 9),
(8252, 97, 1373851546, 1304, 1, 3),
(8253, 75, 1373851561, 5746, 2, 26),
(8254, 24, 1373852156, 1718, 1, 6),
(8255, 12, 1373852592, 3405, 3, 10),
(8256, 95, 1373852623, 911, 1, 0),
(8257, 72, 1373852668, 3282, 3, 9),
(8258, 69, 1373852746, 12783, 8, 59),
(8259, 49, 1373852751, 1602, 1, 4),
(8260, 53, 1373852760, 637, 1, 3),
(8261, 66, 1373852770, 1235, 2, 2),
(8262, 82, 1373852813, 2491, 3, 8),
(8263, 58, 1373852876, 1975, 1, 4),
(8264, 76, 1373852971, 3770, 2, 14),
(8265, 68, 1373852987, 3546, 1, 8),
(8266, 50, 1373853173, 6389, 1, 13),
(8267, 89, 1373853270, 2814, 3, 10),
(8268, 22, 1373853341, 3277, 2, 21),
(8269, 64, 1373853362, 8092, 6, 30),
(8270, 88, 1373853600, 3361, 1, 11),
(8271, 59, 1373853613, 6841, 2, 27),
(8272, 96, 1373853773, 3321, 1, 7),
(8273, 17, 1373853851, 1956, 4, 9),
(8274, 101, 1373853877, 616, 1, 3),
(8275, 109, 1373854043, 746, 1, 1),
(8276, 63, 1373854331, 760, 1, 2),
(8277, 82, 1373854383, 1570, 1, 3),
(8278, 15, 1373854435, 8338, 4, 25),
(8279, 97, 1373854532, 2986, 1, 6),
(8280, 88, 1373854586, 986, 1, 2),
(8281, 62, 1373854588, 3326, 2, 13),
(8282, 56, 1373854595, 10222, 4, 32),
(8283, 22, 1373854624, 1283, 2, 6),
(8284, 17, 1373854636, 785, 1, 2),
(8285, 73, 1373854670, 10996, 6, 29),
(8286, 98, 1373854678, 271, 1, 1),
(8287, 24, 1373854729, 2573, 2, 18),
(8288, 78, 1373854738, 303, 1, 2),
(8289, 97, 1373854743, 210, 1, 1),
(8290, 60, 1373854810, 13710, 12, 54),
(8291, 12, 1373854832, 1924, 2, 5),
(8292, 66, 1373855011, 2241, 2, 4),
(8293, 13, 1373855072, 1924, 3, 6),
(8294, 68, 1373855285, 2298, 3, 8),
(8295, 104, 1373855337, 645, 1, 0),
(8296, 104, 1373855429, 92, 1, 0),
(8297, 53, 1373855813, 2928, 5, 14),
(8298, 63, 1373855886, 933, 1, 4),
(8299, 62, 1373855984, 1396, 1, 7),
(8300, 55, 1373856001, 5036, 1, 23),
(8301, 58, 1373856017, 3141, 3, 8),
(8302, 100, 1373856067, 891, 1, 2),
(8303, 82, 1373856117, 1734, 2, 4),
(8304, 85, 1373856262, 10826, 8, 41),
(8305, 74, 1373856287, 7297, 4, 36),
(8306, 78, 1373856369, 1160, 1, 7),
(8307, 72, 1373856422, 2368, 2, 9),
(8308, 97, 1373856671, 898, 1, 2),
(8309, 17, 1373856684, 2048, 1, 6),
(8310, 107, 1373856708, 1341, 1, 4),
(8311, 14, 1373856724, 6038, 5, 28),
(8312, 47, 1373856781, 11733, 14, 60),
(8313, 76, 1373857073, 3923, 4, 20),
(8314, 13, 1373857135, 1105, 2, 6),
(8315, 48, 1373857140, 3041, 7, 13),
(8316, 17, 1373857173, 489, 2, 1),
(8317, 83, 1373857242, 6162, 5, 23),
(8318, 22, 1373857255, 1619, 2, 7),
(8319, 72, 1373857289, 553, 1, 1),
(8320, 61, 1373857317, 15030, 10, 65),
(8321, 40, 1373857364, 6762, 6, 37),
(8322, 78, 1373857368, 935, 1, 4),
(8323, 81, 1373857378, 581, 1, 2),
(8324, 12, 1373857576, 2744, 3, 13),
(8325, 80, 1373857606, 8362, 5, 35),
(8326, 77, 1373857634, 14147, 7, 58),
(8327, 48, 1373857651, 511, 1, 2),
(8328, 16, 1373858017, 10700, 4, 39),
(8329, 78, 1373858220, 724, 1, 2),
(8330, 53, 1373858340, 2527, 2, 10),
(8331, 22, 1373858349, 1094, 2, 2),
(8332, 66, 1373858383, 2371, 2, 9),
(8333, 104, 1373858395, 1244, 1, 1),
(8334, 101, 1373858433, 1429, 1, 1),
(8335, 100, 1373858470, 955, 1, 1),
(8336, 95, 1373858507, 454, 2, 0),
(8337, 38, 1373858514, 15995, 14, 82),
(8338, 106, 1373858767, 394, 1, 0),
(8339, 56, 1373858780, 4120, 2, 18),
(8340, 63, 1373858793, 2508, 1, 17),
(8341, 12, 1373858803, 777, 1, 3),
(8342, 24, 1373858811, 3582, 4, 18),
(8343, 74, 1373858894, 2607, 2, 8),
(8344, 94, 1373858957, 2091, 1, 3),
(8345, 66, 1373858963, 580, 1, 4),
(8346, 69, 1373859025, 6279, 5, 30),
(8347, 64, 1373859088, 5726, 6, 17),
(8348, 99, 1373859150, 689, 1, 2),
(8349, 82, 1373859194, 3077, 5, 12),
(8350, 88, 1373859206, 1469, 2, 6),
(8351, 51, 1373859213, 16060, 9, 66),
(8352, 49, 1373859306, 3369, 1, 16),
(8353, 89, 1373859333, 1057, 1, 5),
(8354, 59, 1373859395, 4150, 1, 18),
(8355, 58, 1373859465, 3448, 4, 22),
(8356, 72, 1373859600, 2311, 2, 12),
(8357, 62, 1373859657, 3673, 5, 16),
(8358, 26, 1373859720, 48290, 46, 227),
(8359, 68, 1373859739, 4454, 4, 21),
(8360, 17, 1373859799, 2001, 1, 9),
(8361, 93, 1373859844, 508, 1, 1),
(8362, 55, 1373859923, 3922, 6, 25),
(8363, 106, 1373859948, 489, 1, 1),
(8364, 51, 1373860025, 812, 1, 7),
(8365, 84, 1373860196, 8729, 2, 28),
(8366, 99, 1373860266, 959, 1, 5),
(8367, 76, 1373860277, 3204, 2, 9),
(8368, 94, 1373860289, 1115, 1, 2),
(8369, 18, 1373860308, 20159, 8, 86),
(8370, 79, 1373860566, 9864, 10, 37),
(8371, 11, 1373860617, 856, 1, 1),
(8372, 36, 1373860665, 16659, 27, 74),
(8373, 97, 1373860695, 56, 1, 0),
(8374, 48, 1373860698, 1004, 1, 6),
(8375, 57, 1373860724, 13065, 10, 51),
(8376, 58, 1373860767, 1302, 1, 9),
(8377, 50, 1373860768, 7595, 8, 31),
(8378, 37, 1373860791, 22818, 18, 48),
(8379, 12, 1373860795, 1992, 2, 9),
(8380, 85, 1373861053, 4790, 3, 20),
(8381, 20, 1373861076, 14346, 11, 55),
(8382, 86, 1373861157, 13051, 5, 61),
(8383, 62, 1373861302, 1645, 4, 5),
(8384, 70, 1373861387, 15341, 6, 55),
(8385, 96, 1373861614, 1843, 2, 4),
(8386, 34, 1373861649, 36958, 25, 190),
(8387, 82, 1373861678, 2484, 3, 17),
(8388, 14, 1373861938, 724, 1, 4),
(8389, 108, 1373861994, 581, 1, 1),
(8390, 91, 1373862030, 1189, 1, 3),
(8391, 53, 1373862095, 2870, 3, 15),
(8392, 78, 1373862182, 2614, 1, 15),
(8393, 89, 1373862228, 410, 1, 1),
(8394, 105, 1373862265, 270, 1, 1),
(8395, 102, 1373862281, 530, 1, 0),
(8396, 17, 1373862323, 1141, 1, 6),
(8397, 84, 1373862340, 2144, 1, 11),
(8398, 106, 1373862391, 2443, 1, 5),
(8399, 74, 1373862590, 3462, 8, 20),
(8400, 22, 1373862592, 571, 1, 1),
(8401, 48, 1373862688, 540, 1, 4),
(8402, 11, 1373862744, 358, 1, 0),
(8403, 79, 1373862792, 2226, 4, 8),
(8404, 110, 1373862828, 81, 1, 0),
(8405, 68, 1373862891, 3152, 5, 9),
(8406, 53, 1373863008, 913, 2, 7),
(8407, 83, 1373863030, 5788, 4, 24),
(8408, 97, 1373863095, 1318, 1, 2),
(8409, 59, 1373863151, 3756, 2, 24),
(8410, 21, 1373863177, 11760, 14, 69),
(8411, 85, 1373863323, 2270, 1, 7),
(8412, 92, 1373863401, 358, 1, 0),
(8413, 57, 1373863610, 2886, 2, 16),
(8414, 58, 1373863660, 2893, 2, 16),
(8415, 46, 1373863815, 20453, 20, 97),
(8416, 100, 1373863856, 1887, 1, 6),
(8417, 107, 1373863882, 2325, 2, 5),
(8418, 12, 1373864167, 1093, 1, 1),
(8419, 75, 1373864173, 12611, 12, 57),
(8420, 80, 1373864329, 5959, 6, 24),
(8421, 50, 1373864380, 3612, 3, 20),
(8422, 52, 1373864390, 22998, 18, 111),
(8423, 42, 1373864422, 14900, 21, 83),
(8424, 44, 1373864469, 26486, 34, 125),
(8425, 50, 1373864587, 207, 1, 0),
(8426, 11, 1373864592, 512, 1, 1),
(8427, 103, 1373864805, 1912, 1, 4),
(8428, 107, 1373864864, 739, 1, 3),
(8429, 75, 1373864909, 736, 1, 4),
(8430, 35, 1373864988, 21703, 14, 107),
(8431, 14, 1373865026, 996, 1, 3),
(8432, 15, 1373865055, 10278, 8, 41),
(8433, 21, 1373865120, 1943, 1, 10),
(8434, 19, 1373865195, 19933, 13, 40),
(8435, 106, 1373865201, 1042, 1, 7),
(8436, 77, 1373865240, 7606, 5, 45),
(8437, 76, 1373865279, 5002, 2, 18),
(8438, 79, 1373865544, 2310, 3, 13),
(8439, 105, 1373865677, 300, 1, 0),
(8440, 96, 1373865724, 509, 1, 1),
(8441, 67, 1373865819, 14633, 14, 76),
(8442, 98, 1373865831, 1648, 2, 7),
(8443, 15, 1373865893, 838, 2, 2),
(8444, 92, 1373865902, 1822, 1, 6),
(8445, 72, 1373865907, 483, 1, 3),
(8446, 24, 1373865944, 3036, 3, 4),
(8447, 74, 1373865946, 3356, 1, 18),
(8448, 12, 1373866024, 1857, 1, 12),
(8449, 106, 1373866121, 920, 1, 3),
(8450, 53, 1373866147, 3139, 2, 24),
(8451, 62, 1373866157, 4133, 2, 26),
(8452, 101, 1373866231, 679, 1, 2),
(8453, 93, 1373866258, 291, 1, 3),
(8454, 13, 1373866352, 977, 1, 4),
(8455, 63, 1373866442, 2940, 7, 20),
(8456, 16, 1373866602, 2956, 1, 10),
(8457, 78, 1373866690, 1559, 1, 7),
(8458, 58, 1373866724, 3064, 4, 15),
(8459, 20, 1373866734, 5658, 4, 27),
(8460, 61, 1373866822, 9505, 8, 55),
(8461, 57, 1373866833, 3222, 3, 24),
(8462, 90, 1373866958, 1457, 1, 14),
(8463, 14, 1373866968, 1187, 1, 3),
(8464, 42, 1373866978, 2556, 2, 16),
(8465, 50, 1373867035, 2447, 1, 8),
(8466, 86, 1373867104, 4177, 1, 11),
(8467, 88, 1373867118, 1746, 2, 9),
(8468, 22, 1373867351, 798, 1, 5),
(8469, 82, 1373867391, 5094, 5, 18),
(8470, 17, 1373867397, 623, 1, 4),
(8471, 55, 1373867402, 7479, 4, 21),
(8472, 66, 1373867447, 8484, 16, 52),
(8473, 106, 1373867590, 238, 1, 1),
(8474, 76, 1373867607, 1174, 1, 7),
(8475, 91, 1373867853, 2524, 4, 10),
(8476, 16, 1373867882, 1280, 1, 5),
(8477, 13, 1373868068, 1568, 2, 11),
(8478, 53, 1373868164, 2016, 2, 13),
(8479, 77, 1373868209, 2969, 4, 11),
(8480, 87, 1373868414, 3204, 2, 14),
(8481, 84, 1373868484, 2845, 3, 19),
(8482, 11, 1373868494, 1498, 1, 5),
(8483, 62, 1373868494, 2337, 5, 7),
(8484, 64, 1373868555, 9467, 10, 34),
(8485, 89, 1373868604, 4089, 2, 18),
(8486, 99, 1373868656, 1862, 1, 1),
(8487, 93, 1373868683, 1495, 1, 1),
(8488, 13, 1373868772, 703, 1, 0),
(8489, 86, 1373868790, 1685, 1, 6),
(8490, 81, 1373868833, 5519, 3, 19),
(8491, 14, 1373868841, 1028, 1, 2),
(8492, 22, 1373868884, 1110, 1, 1),
(8493, 85, 1373868993, 5670, 3, 22),
(8494, 14, 1373869099, 206, 1, 1),
(8495, 12, 1373869177, 1385, 1, 4),
(8496, 55, 1373869211, 1809, 1, 9),
(8497, 47, 1373869267, 12486, 9, 62),
(8498, 78, 1373869340, 1235, 1, 3),
(8499, 77, 1373869420, 1210, 1, 1),
(8500, 82, 1373869502, 2111, 3, 9),
(8501, 80, 1373869723, 5394, 2, 23),
(8502, 18, 1373869913, 9605, 7, 38),
(8503, 40, 1373869915, 12551, 8, 55),
(8504, 17, 1373869923, 599, 2, 4),
(8505, 53, 1373869929, 1212, 1, 1),
(8506, 60, 1373869937, 15127, 17, 76),
(8507, 75, 1373870097, 4109, 2, 22),
(8508, 15, 1373870103, 4210, 2, 19),
(8509, 45, 1373870126, 20473, 22, 103),
(8510, 20, 1373870149, 3415, 4, 18),
(8511, 34, 1373870520, 8871, 14, 54),
(8512, 50, 1373870767, 2805, 2, 12),
(8513, 53, 1373870779, 639, 1, 3),
(8514, 48, 1373870786, 8098, 4, 52),
(8515, 89, 1373870960, 1528, 1, 3),
(8516, 62, 1373871207, 2141, 3, 10),
(8517, 66, 1373871240, 3138, 1, 8),
(8518, 58, 1373871530, 4806, 6, 24),
(8519, 74, 1373871538, 5592, 2, 16),
(8520, 35, 1373871818, 6830, 8, 26),
(8521, 47, 1373871885, 2618, 1, 8),
(8522, 82, 1373872046, 2544, 1, 7),
(8523, 84, 1373872057, 2140, 1, 4),
(8524, 15, 1373872077, 1974, 1, 1),
(8525, 85, 1373872103, 2157, 1, 4),
(8526, 83, 1373872109, 9079, 5, 29),
(8527, 59, 1373872232, 9081, 7, 32),
(8528, 19, 1373872612, 7417, 4, 28),
(8529, 53, 1373872689, 1910, 1, 4),
(8530, 11, 1373872711, 2351, 2, 7),
(8531, 68, 1373872797, 8155, 3, 29),
(8532, 69, 1373872930, 13905, 8, 49),
(8533, 46, 1373873130, 9315, 10, 38),
(8534, 90, 1373873132, 6173, 2, 9),
(8535, 57, 1373873347, 6514, 6, 29),
(8536, 79, 1373873446, 7350, 4, 19),
(8537, 63, 1373873511, 7069, 2, 24),
(8538, 80, 1373873565, 3842, 1, 7),
(8539, 17, 1373873783, 1126, 1, 4),
(8540, 76, 1373873873, 236, 1, 0),
(8541, 13, 1373873947, 784, 1, 3),
(8542, 100, 1373873963, 4914, 2, 0),
(8543, 98, 1373874147, 6333, 1, 0),
(8544, 92, 1373874370, 457, 1, 2),
(8545, 51, 1373874389, 14364, 9, 61),
(8546, 103, 1373874453, 6050, 1, 0),
(8547, 81, 1373874466, 930, 1, 2),
(8548, 88, 1373874482, 3978, 1, 1),
(8549, 22, 1373874509, 248, 1, 0),
(8550, 58, 1373874609, 1415, 3, 3),
(8551, 14, 1373874610, 535, 1, 2),
(8552, 80, 1373874640, 1074, 1, 5),
(8553, 101, 1373874704, 665, 1, 5),
(8554, 78, 1373874748, 419, 1, 1),
(8555, 107, 1373874753, 6989, 1, 10),
(8556, 66, 1373874798, 1780, 1, 10),
(8557, 87, 1373874891, 656, 1, 0),
(8558, 79, 1373874914, 1076, 1, 2),
(8559, 62, 1373874988, 955, 1, 9),
(8560, 68, 1373875037, 2240, 1, 5),
(8561, 92, 1373875044, 312, 2, 0),
(8562, 78, 1373875137, 389, 1, 0),
(8563, 102, 1373875148, 6584, 2, 5),
(8564, 84, 1373875166, 3109, 4, 11),
(8565, 76, 1373875173, 1300, 1, 7),
(8566, 67, 1373875191, 9372, 6, 30),
(8567, 18, 1373875320, 5407, 4, 18),
(8568, 85, 1373875366, 3263, 1, 4),
(8569, 15, 1373875390, 939, 1, 1),
(8570, 17, 1373875473, 1399, 1, 4),
(8571, 16, 1373875619, 7736, 3, 18),
(8572, 73, 1373875684, 21014, 16, 67),
(8573, 77, 1373875726, 1105, 1, 5),
(8574, 106, 1373875778, 447, 1, 3),
(8575, 14, 1373875820, 1210, 1, 4),
(8576, 80, 1373875844, 1204, 1, 3),
(8577, 20, 1373875976, 5827, 2, 18),
(8578, 74, 1373876076, 2721, 1, 7),
(8579, 45, 1373876224, 6098, 6, 23),
(8580, 17, 1373876500, 1027, 1, 2),
(8581, 11, 1373876587, 1855, 2, 5),
(8582, 104, 1373876644, 8840, 3, 9),
(8583, 48, 1373876727, 5941, 8, 38),
(8584, 22, 1373876750, 240, 1, 0),
(8585, 39, 1373876754, 33253, 37, 157),
(8586, 83, 1373876803, 770, 1, 5),
(8587, 32, 1373876857, 31180, 38, 154),
(8588, 16, 1373876953, 1334, 1, 3),
(8589, 102, 1373876955, 820, 1, 3),
(8590, 82, 1373877005, 4959, 1, 15),
(8591, 62, 1373877059, 2071, 3, 10),
(8592, 86, 1373877076, 881, 2, 6),
(8593, 70, 1373877104, 1866, 1, 4),
(8594, 13, 1373877115, 428, 1, 3),
(8595, 99, 1373877122, 2266, 2, 4),
(8596, 90, 1373877131, 219, 1, 1),
(8597, 18, 1373877254, 1934, 1, 8),
(8598, 3, 1373877278, 149, 500, 500),
(8599, 75, 1373877325, 2197, 3, 11),
(8600, 94, 1373877346, 2656, 2, 5),
(8601, 20, 1373877379, 1403, 4, 3),
(8602, 81, 1373877404, 2155, 3, 12),
(8603, 3, 1373877659, 47, 1, 0),
(8604, 8, 1373877679, 51, 1, 0),
(8605, 3, 1373877717, 58, 1, 0),
(8606, 8, 1373877754, 75, 1, 0),
(8607, 3, 1373877856, 139, 1, 0),
(8608, 81, 1373878561, 729, 1, 0),
(8609, 71, 1373878909, 841, 1, 6),
(8610, 100, 1373878945, 1397, 1, 4),
(8611, 22, 1373879293, 1614, 2, 5),
(8612, 14, 1373879497, 192, 1, 1),
(8613, 80, 1373879540, 419, 1, 8),
(8614, 24, 1373879591, 1837, 2, 9),
(8615, 79, 1373879599, 1254, 3, 7),
(8616, 100, 1373879745, 800, 1, 1),
(8617, 76, 1373879754, 660, 2, 6),
(8618, 87, 1373879907, 2135, 2, 5),
(8619, 85, 1373880218, 1107, 1, 2),
(8620, 74, 1373880364, 2246, 3, 18),
(8621, 22, 1373880402, 1109, 1, 6),
(8622, 13, 1373880420, 244, 1, 0),
(8623, 93, 1373880520, 289, 1, 0),
(8624, 68, 1373880677, 2394, 3, 7),
(8625, 12, 1373880709, 1188, 1, 6),
(8626, 99, 1373880768, 1601, 1, 4),
(8627, 78, 1373880864, 3088, 3, 13),
(8628, 11, 1373881016, 1689, 1, 6),
(8629, 61, 1373881232, 2600, 3, 12),
(8630, 103, 1373881268, 1561, 2, 1),
(8631, 15, 1373881343, 1612, 4, 4),
(8632, 13, 1373881344, 924, 1, 2),
(8633, 81, 1373881483, 1878, 1, 4),
(8634, 83, 1373881669, 1197, 1, 7),
(8635, 77, 1373881676, 1638, 2, 6),
(8636, 68, 1373881850, 1173, 1, 7),
(8637, 22, 1373882114, 1712, 2, 10),
(8638, 102, 1373882227, 2726, 1, 7),
(8639, 12, 1373882231, 1522, 1, 4),
(8640, 23, 1373882331, 3601, 3, 13),
(8641, 87, 1373882367, 1996, 1, 5),
(8642, 84, 1373882436, 1884, 2, 12),
(8643, 78, 1373882447, 1583, 4, 7),
(8644, 53, 1373882550, 3873, 6, 19),
(8645, 13, 1373882607, 1263, 2, 1),
(8646, 73, 1373882883, 1746, 1, 7),
(8647, 91, 1373882974, 2129, 1, 6),
(8648, 79, 1373883078, 3478, 1, 18),
(8649, 67, 1373883269, 3317, 2, 11),
(8650, 72, 1373883273, 2819, 4, 13),
(8651, 58, 1373883542, 4402, 3, 20),
(8652, 75, 1373883582, 2175, 1, 6),
(8653, 17, 1373883617, 734, 1, 2),
(8654, 85, 1373883869, 3651, 1, 12),
(8655, 71, 1373884007, 5097, 3, 31),
(8656, 77, 1373884017, 1500, 1, 2),
(8657, 66, 1373884065, 4923, 3, 19),
(8658, 15, 1373884096, 411, 1, 1),
(8659, 14, 1373884570, 440, 1, 1),
(8660, 61, 1373884654, 3422, 2, 19),
(8661, 68, 1373884715, 2865, 2, 16),
(8662, 15, 1373885038, 299, 1, 0),
(8663, 20, 1373885093, 1138, 2, 1),
(8664, 17, 1373885497, 1440, 1, 3),
(8665, 71, 1373885811, 703, 1, 1),
(8666, 66, 1373885834, 1769, 1, 4),
(8667, 43, 1373886001, 6582, 9, 27),
(8668, 78, 1373886327, 2221, 2, 3),
(8669, 51, 1373886601, 8651, 4, 32),
(8670, 62, 1373886709, 2584, 1, 4),
(8671, 76, 1373886825, 2377, 1, 2),
(8672, 22, 1373886972, 3075, 1, 7),
(8673, 35, 1373887071, 3005, 2, 7),
(8674, 16, 1373887294, 2559, 1, 3),
(8675, 79, 1373887335, 3811, 1, 4),
(8676, 49, 1373887409, 7190, 4, 22),
(8677, 23, 1373888038, 5707, 2, 10),
(8678, 42, 1373888439, 6798, 9, 20),
(8679, 14, 1373888813, 807, 1, 2),
(8680, 75, 1373888887, 1323, 1, 1),
(8681, 60, 1373888909, 839, 1, 4),
(8682, 49, 1373889207, 1798, 2, 5),
(8683, 24, 1373889377, 2457, 1, 6),
(8684, 68, 1373889431, 4716, 2, 8),
(8685, 61, 1373889605, 3285, 1, 9),
(8686, 14, 1373890087, 607, 1, 1),
(8687, 73, 1373890209, 7326, 4, 13),
(8688, 72, 1373890278, 4579, 2, 7),
(8689, 22, 1373890292, 2129, 1, 4),
(8690, 66, 1373890308, 4474, 2, 6),
(8691, 71, 1373890737, 4926, 2, 9),
(8692, 57, 1373890784, 10148, 8, 31),
(8693, 67, 1373890871, 7602, 3, 24),
(8694, 18, 1373890882, 5649, 2, 13),
(8695, 63, 1373890952, 3627, 1, 10),
(8696, 33, 1373890998, 6848, 2, 18),
(8697, 13, 1373891016, 1015, 1, 2),
(8698, 62, 1373891120, 4411, 1, 13),
(8699, 43, 1373891217, 5216, 2, 23),
(8700, 26, 1373891256, 8754, 4, 30),
(8701, 23, 1373891421, 3383, 4, 9),
(8702, 46, 1373891800, 3849, 2, 18),
(8703, 14, 1373892012, 1771, 1, 7),
(8704, 47, 1373892129, 3457, 4, 19),
(8705, 60, 1373892241, 3332, 1, 8),
(8706, 22, 1373892450, 568, 1, 0),
(8707, 18, 1373892456, 1435, 2, 5),
(8708, 66, 1373893026, 2718, 1, 6),
(8709, 69, 1373893058, 12904, 3, 30),
(8710, 26, 1373893635, 1635, 1, 2),
(8711, 35, 1373893825, 4580, 3, 10),
(8712, 38, 1373893849, 14729, 7, 44),
(8713, 48, 1373894038, 9421, 5, 33),
(8714, 70, 1373894107, 13194, 8, 33),
(8715, 22, 1373894158, 1708, 1, 2),
(8716, 56, 1373894332, 9603, 3, 33),
(8717, 27, 1373894361, 2188, 1, 5),
(8718, 49, 1373894414, 5207, 3, 13),
(8719, 26, 1373894825, 1190, 1, 4),
(8720, 65, 1373895201, 4399, 1, 11),
(8721, 42, 1373895249, 6810, 3, 19),
(8722, 41, 1373895402, 12916, 11, 45),
(8723, 24, 1373895512, 1654, 1, 2),
(8724, 17, 1373895601, 5985, 3, 15),
(8725, 35, 1373895621, 1796, 1, 10),
(8726, 43, 1373895702, 4484, 1, 3),
(8727, 72, 1373895826, 4413, 1, 2),
(8728, 44, 1373895845, 2961, 2, 11),
(8729, 69, 1373895896, 1354, 2, 1),
(8730, 45, 1373895991, 5171, 4, 20),
(8731, 47, 1373896004, 3875, 2, 5),
(8732, 62, 1373896007, 4886, 1, 4),
(8733, 58, 1373896176, 732, 1, 3),
(8734, 32, 1373896216, 4975, 2, 15),
(8735, 43, 1373896415, 713, 2, 1),
(8736, 51, 1373896884, 1174, 1, 2),
(8737, 15, 1373897178, 4198, 2, 11),
(8738, 24, 1373897240, 1728, 1, 13),
(8739, 96, 1373897259, 15222, 1, 0),
(8740, 80, 1373897267, 402, 2, 1),
(8741, 77, 1373897338, 8120, 1, 2),
(8742, 97, 1373897348, 15888, 1, 0),
(8743, 78, 1373897388, 638, 1, 2),
(8744, 19, 1373897560, 7262, 2, 22),
(8745, 11, 1373897626, 773, 1, 3),
(8746, 79, 1373897694, 114, 1, 0),
(8747, 61, 1373897743, 2098, 2, 10),
(8748, 65, 1373897858, 2657, 1, 8),
(8749, 58, 1373897877, 1701, 1, 9),
(8750, 67, 1373897884, 7013, 4, 8),
(8751, 38, 1373897919, 4070, 1, 15),
(8752, 62, 1373897946, 804, 1, 7),
(8753, 102, 1373897948, 929, 1, 1),
(8754, 83, 1373897990, 256, 1, 2),
(8755, 81, 1373897992, 468, 1, 3),
(8756, 96, 1373897997, 738, 1, 2),
(8757, 76, 1373898036, 1252, 1, 6),
(8758, 62, 1373898046, 100, 1, 3),
(8759, 99, 1373898161, 497, 1, 3),
(8760, 104, 1373898351, 15611, 1, 4),
(8761, 76, 1373898745, 540, 1, 1);
INSERT INTO `zotsme_alive_records` (`id`, `player_id`, `date`, `alive_time`, `kills`, `assists`) VALUES
(8762, 98, 1373899043, 17615, 2, 4),
(8763, 50, 1373899055, 5484, 3, 16),
(8764, 22, 1373899087, 4929, 4, 18),
(8765, 43, 1373899120, 2705, 2, 18),
(8766, 12, 1373899203, 1742, 2, 5),
(8767, 78, 1373899263, 914, 2, 3),
(8768, 38, 1373899336, 1417, 1, 5),
(8769, 69, 1373899405, 3509, 2, 22),
(8770, 75, 1373899422, 8112, 1, 15),
(8771, 59, 1373899503, 8853, 5, 18),
(8772, 70, 1373899518, 5410, 7, 12),
(8773, 103, 1373899543, 1871, 1, 7),
(8774, 20, 1373899588, 14494, 7, 36),
(8775, 77, 1373899695, 2357, 2, 13),
(8776, 83, 1373899846, 1270, 1, 8),
(8777, 108, 1373899875, 1953, 1, 5),
(8778, 47, 1373899907, 3903, 2, 14),
(8779, 110, 1373899943, 2202, 1, 6),
(8780, 99, 1373899977, 657, 1, 0),
(8781, 74, 1373900114, 4087, 3, 9),
(8782, 26, 1373900121, 5296, 7, 19),
(8783, 32, 1373900268, 4052, 4, 28),
(8784, 79, 1373900294, 1490, 1, 7),
(8785, 16, 1373900361, 1009, 1, 10),
(8786, 90, 1373900389, 1285, 3, 2),
(8787, 81, 1373900420, 1950, 1, 9),
(8788, 66, 1373900433, 4811, 11, 19),
(8789, 93, 1373900473, 864, 2, 4),
(8790, 70, 1373900689, 1171, 2, 3),
(8791, 12, 1373900702, 1265, 1, 5),
(8792, 82, 1373901003, 2418, 4, 11),
(8793, 11, 1373901150, 755, 1, 3),
(8794, 88, 1373901171, 1999, 2, 6),
(8795, 50, 1373901240, 1992, 4, 10),
(8796, 63, 1373901488, 10131, 6, 35),
(8797, 80, 1373901492, 3098, 1, 10),
(8798, 67, 1373901553, 3669, 1, 18),
(8799, 17, 1373901589, 5988, 2, 16),
(8800, 13, 1373901624, 6288, 8, 18),
(8801, 82, 1373901764, 761, 1, 2),
(8802, 83, 1373901980, 2134, 1, 9),
(8803, 98, 1373902030, 2455, 1, 7),
(8804, 75, 1373902038, 2616, 1, 9),
(8805, 73, 1373902068, 5066, 6, 18),
(8806, 59, 1373902099, 2596, 3, 6),
(8807, 65, 1373902303, 4445, 2, 22),
(8808, 81, 1373902329, 1909, 1, 3),
(8809, 78, 1373902352, 3089, 2, 10),
(8810, 58, 1373902410, 4533, 1, 16),
(8811, 85, 1373902459, 18590, 2, 19),
(8812, 53, 1373902643, 20092, 12, 77),
(8813, 60, 1373902787, 10545, 4, 31),
(8814, 38, 1373902788, 2700, 3, 10),
(8815, 14, 1373903033, 7737, 6, 24),
(8816, 35, 1373903080, 7458, 3, 26),
(8817, 40, 1373903117, 13214, 10, 50),
(8818, 46, 1373903147, 11347, 9, 35),
(8819, 16, 1373903230, 2868, 1, 7),
(8820, 56, 1373903644, 9312, 7, 36),
(8821, 37, 1373903716, 11909, 13, 40),
(8822, 49, 1373903753, 5019, 6, 24),
(8823, 68, 1373903855, 14424, 3, 26),
(8824, 72, 1373903970, 481, 1, 0),
(8825, 51, 1373903989, 7105, 7, 42),
(8826, 14, 1373904193, 1160, 1, 6),
(8827, 52, 1373904322, 9428, 10, 37),
(8828, 18, 1373904335, 11879, 8, 34),
(8829, 12, 1373904418, 1968, 1, 9),
(8830, 61, 1373904481, 6738, 7, 20),
(8831, 77, 1373904601, 2782, 1, 2),
(8832, 13, 1373904698, 3074, 1, 11),
(8833, 75, 1373904776, 1022, 1, 2),
(8834, 22, 1373904783, 5696, 4, 20),
(8835, 19, 1373904801, 7241, 4, 29),
(8836, 66, 1373905087, 1698, 1, 8),
(8837, 48, 1373905118, 9087, 13, 38),
(8838, 24, 1373905151, 7910, 9, 29),
(8839, 27, 1373905832, 11471, 9, 29),
(8840, 15, 1373905851, 5786, 3, 16),
(8841, 33, 1373906089, 15091, 9, 50),
(8842, 64, 1373906256, 15522, 8, 34),
(8843, 46, 1373906527, 3379, 6, 7),
(8844, 74, 1373907142, 2165, 1, 1),
(8845, 34, 1373907318, 6796, 5, 19),
(8846, 59, 1373907328, 2226, 1, 6),
(8847, 60, 1373907467, 3021, 1, 2),
(8848, 70, 1373907534, 6845, 3, 21),
(8849, 61, 1373907632, 3151, 1, 5),
(8850, 82, 1373907662, 3059, 1, 6),
(8851, 32, 1373907668, 7400, 7, 25),
(8852, 41, 1373907833, 10643, 12, 38),
(8853, 63, 1373907893, 6404, 1, 9),
(8854, 17, 1373907992, 1701, 2, 3),
(8855, 48, 1373908027, 2909, 2, 16),
(8856, 32, 1373908188, 520, 1, 3),
(8857, 58, 1373908723, 159, 1, 1),
(8858, 81, 1373908736, 4084, 1, 12),
(8859, 25, 1373908794, 13619, 11, 62),
(8860, 27, 1373908870, 3038, 1, 7),
(8861, 18, 1373908895, 4560, 3, 7),
(8862, 21, 1373908926, 15736, 19, 47),
(8863, 16, 1373909521, 6291, 1, 18),
(8864, 51, 1373909643, 5654, 4, 11),
(8865, 40, 1373909721, 6604, 8, 31),
(8866, 56, 1373909747, 3741, 2, 12),
(8867, 66, 1373909832, 2763, 2, 3),
(8868, 35, 1373909842, 6762, 2, 15),
(8869, 52, 1373909950, 5628, 4, 21),
(8870, 62, 1373909960, 2654, 1, 5),
(8871, 33, 1373909965, 3876, 3, 22),
(8872, 49, 1373910328, 5885, 1, 12),
(8873, 22, 1373910338, 2738, 1, 4),
(8874, 27, 1373912026, 481, 1, 2),
(8875, 31, 1373913182, 990, 2, 6),
(8876, 44, 1373913316, 1123, 1, 3),
(8877, 27, 1373913399, 339, 2, 2),
(8878, 29, 1373913569, 1377, 2, 7),
(8879, 42, 1373913770, 1577, 2, 7),
(8880, 34, 1373914287, 2095, 1, 6),
(8881, 17, 1373914732, 2253, 1, 11),
(8882, 23, 1373914815, 2624, 3, 8),
(8883, 63, 1373915281, 3087, 1, 3),
(8884, 65, 1373915393, 3198, 1, 5),
(8885, 28, 1373915453, 3261, 4, 14),
(8886, 25, 1373915465, 3273, 3, 13),
(8887, 36, 1373915518, 3326, 4, 11),
(8888, 27, 1373915551, 2152, 1, 5),
(8889, 21, 1373916063, 3872, 2, 9),
(8890, 13, 1373916132, 522, 1, 0),
(8891, 57, 1373916317, 4123, 1, 9),
(8892, 22, 1373916570, 1339, 1, 5),
(8893, 27, 1373916627, 1076, 1, 1),
(8894, 56, 1373916685, 4491, 1, 7),
(8895, 48, 1373916884, 3567, 4, 20),
(8896, 61, 1373917500, 532, 1, 1),
(8897, 63, 1373917702, 1698, 1, 1),
(8898, 31, 1373917791, 4608, 4, 11),
(8899, 15, 1373917799, 791, 1, 2),
(8900, 24, 1373917825, 5634, 4, 22),
(8901, 23, 1373917973, 3158, 4, 12),
(8902, 44, 1373918115, 4799, 7, 33),
(8903, 29, 1373918143, 2680, 1, 7),
(8904, 46, 1373918147, 5954, 7, 33),
(8905, 21, 1373918323, 2259, 1, 8),
(8906, 49, 1373918333, 6140, 6, 24),
(8907, 65, 1373918529, 1155, 1, 4),
(8908, 33, 1373918536, 6344, 4, 20),
(8909, 27, 1373918605, 1736, 1, 11),
(8910, 13, 1373918724, 718, 1, 0),
(8911, 51, 1373918949, 6755, 4, 19),
(8912, 41, 1373918962, 6769, 3, 37),
(8913, 37, 1373919001, 6809, 6, 29),
(8914, 15, 1373919016, 333, 1, 1),
(8915, 46, 1373919273, 1029, 2, 4),
(8916, 17, 1373919421, 2483, 2, 7),
(8917, 57, 1373919428, 3111, 1, 10),
(8918, 55, 1373919528, 2165, 2, 11),
(8919, 17, 1373919540, 117, 1, 0),
(8920, 16, 1373919817, 2370, 2, 6),
(8921, 20, 1373919841, 1721, 2, 6),
(8922, 35, 1373919866, 6425, 8, 29),
(8923, 18, 1373919917, 7726, 1, 20),
(8924, 38, 1373919975, 7782, 9, 45),
(8925, 37, 1373920004, 1003, 2, 10),
(8926, 28, 1373920223, 3425, 3, 21),
(8927, 42, 1373920301, 6531, 3, 15),
(8928, 45, 1373920495, 6674, 4, 35),
(8929, 30, 1373920622, 8430, 15, 32),
(8930, 64, 1373920632, 6210, 1, 8),
(8931, 21, 1373920796, 2473, 1, 10),
(8932, 14, 1373920834, 620, 1, 3),
(8933, 51, 1373920871, 1922, 6, 9),
(8934, 59, 1373920982, 3297, 1, 13),
(8935, 22, 1373920985, 3994, 2, 21),
(8936, 26, 1373921018, 2107, 1, 14),
(8937, 25, 1373921158, 5693, 5, 25),
(8938, 47, 1373921420, 9227, 3, 48),
(8939, 28, 1373921461, 1238, 1, 3),
(8940, 49, 1373921488, 3155, 3, 11),
(8941, 40, 1373922019, 9826, 12, 47),
(8942, 31, 1373922362, 3840, 4, 17),
(8943, 27, 1373922476, 3871, 4, 15),
(8944, 62, 1373922505, 2783, 3, 7),
(8945, 13, 1373922658, 323, 1, 0),
(8946, 55, 1373922910, 3382, 2, 6),
(8947, 12, 1373923056, 661, 1, 0),
(8948, 43, 1373923105, 10912, 13, 50),
(8949, 19, 1373923212, 11021, 6, 19),
(8950, 63, 1373923236, 541, 1, 4),
(8951, 35, 1373923391, 3525, 1, 12),
(8952, 31, 1373923484, 1122, 1, 5),
(8953, 14, 1373923765, 438, 1, 0),
(8954, 54, 1373923817, 6376, 2, 18),
(8955, 39, 1373923871, 11678, 10, 49),
(8956, 18, 1373924062, 4145, 2, 11),
(8957, 37, 1373924140, 4136, 4, 21),
(8958, 49, 1373924304, 2815, 3, 13),
(8959, 47, 1373924322, 2902, 1, 7),
(8960, 23, 1373924511, 6538, 3, 20),
(8961, 27, 1373924599, 2123, 1, 5),
(8962, 29, 1373924637, 6494, 4, 24),
(8963, 60, 1373924643, 3880, 5, 13),
(8964, 65, 1373924653, 428, 1, 2),
(8965, 61, 1373924732, 1300, 1, 8),
(8966, 55, 1373924812, 1902, 2, 11),
(8967, 59, 1373925025, 4043, 1, 10),
(8968, 29, 1373925066, 429, 2, 2),
(8969, 20, 1373925090, 5248, 2, 11),
(8970, 26, 1373925096, 1554, 1, 4),
(8971, 49, 1373925140, 836, 4, 2),
(8972, 24, 1373925520, 7172, 6, 16),
(8973, 25, 1373925643, 4485, 3, 11),
(8974, 34, 1373925740, 11453, 14, 55),
(8975, 21, 1373925752, 2226, 2, 3),
(8976, 54, 1373925868, 1812, 4, 13),
(8977, 28, 1373925883, 4422, 5, 16),
(8978, 15, 1373926860, 666, 1, 1),
(8979, 14, 1373926952, 543, 1, 1),
(8980, 12, 1373927263, 1093, 1, 0),
(8981, 55, 1373927652, 1438, 1, 1),
(8982, 13, 1373927800, 1646, 1, 8),
(8983, 36, 1373928681, 2352, 4, 10),
(8984, 13, 1373928933, 1133, 1, 1),
(8985, 65, 1373928994, 172, 1, 1),
(8986, 44, 1373929031, 1967, 1, 13),
(8987, 61, 1373929286, 1356, 1, 3),
(8988, 38, 1373929461, 2871, 1, 6),
(8989, 13, 1373929649, 716, 3, 5),
(8990, 58, 1373929651, 1966, 1, 3),
(8991, 56, 1373930108, 3453, 1, 6),
(8992, 14, 1373930252, 1391, 1, 8),
(8993, 35, 1373930690, 3146, 2, 12),
(8994, 16, 1373931104, 3713, 6, 14),
(8995, 41, 1373931193, 1356, 1, 0),
(8996, 13, 1373931395, 511, 1, 1),
(8997, 55, 1373931505, 3853, 1, 12),
(8998, 17, 1373931527, 1613, 2, 6),
(8999, 25, 1373931628, 5276, 1, 13),
(9000, 27, 1373931704, 3336, 2, 14),
(9001, 49, 1373931972, 952, 1, 9),
(9002, 54, 1373932124, 1275, 1, 5),
(9003, 43, 1373932209, 2616, 2, 15),
(9004, 11, 1373932230, 84, 1, 0),
(9005, 27, 1373932468, 763, 2, 5),
(9006, 17, 1373933130, 1603, 1, 6),
(9007, 18, 1373933273, 2872, 1, 5),
(9008, 31, 1373933288, 2447, 1, 5),
(9009, 24, 1373933404, 2648, 4, 11),
(9010, 13, 1373933503, 1018, 1, 2),
(9011, 27, 1373933689, 1220, 1, 1),
(9012, 26, 1373933803, 2139, 1, 4),
(9013, 29, 1373933825, 4080, 1, 18),
(9014, 44, 1373934104, 5073, 8, 17),
(9015, 11, 1373934154, 925, 1, 1),
(9016, 39, 1373934160, 2616, 2, 12),
(9017, 21, 1373934538, 5681, 5, 26),
(9018, 18, 1373934711, 1438, 2, 2),
(9019, 41, 1373934900, 3707, 1, 10),
(9020, 49, 1373935114, 3142, 2, 3),
(9021, 20, 1373935621, 5588, 2, 7),
(9022, 15, 1373935894, 8000, 4, 15),
(9023, 35, 1373935987, 5297, 2, 11),
(9024, 14, 1373936058, 1235, 1, 1),
(9025, 55, 1373936146, 4641, 2, 9),
(9026, 50, 1373936222, 6727, 4, 16),
(9027, 41, 1373936305, 1405, 2, 3),
(9028, 48, 1373936470, 6069, 2, 13),
(9029, 19, 1373936677, 4315, 1, 6),
(9030, 33, 1373936820, 9939, 3, 35),
(9031, 38, 1373937084, 7623, 2, 23),
(9032, 24, 1373937468, 4064, 2, 5),
(9033, 27, 1373937483, 3794, 1, 4),
(9034, 31, 1373937948, 4660, 3, 15),
(9035, 51, 1373938060, 3387, 1, 5),
(9036, 25, 1373938295, 6667, 2, 21),
(9037, 31, 1373938322, 374, 1, 1),
(9038, 48, 1373938389, 1918, 1, 9),
(9039, 34, 1373938603, 9405, 3, 11),
(9040, 37, 1373938758, 5751, 8, 15),
(9041, 29, 1373939177, 1136, 1, 1),
(9042, 25, 1373939225, 930, 2, 4),
(9043, 15, 1373939286, 878, 1, 1),
(9044, 28, 1373939500, 2833, 1, 6),
(9045, 24, 1373939574, 2106, 1, 2),
(9046, 22, 1373939877, 2984, 1, 3),
(9047, 30, 1373939935, 4503, 1, 6),
(9048, 20, 1373940328, 1173, 1, 0),
(9049, 27, 1373940432, 1784, 2, 6),
(9050, 44, 1373940511, 6407, 3, 33),
(9051, 13, 1373940603, 979, 1, 0),
(9052, 29, 1373941020, 1843, 1, 3),
(9053, 50, 1373941083, 4861, 3, 17),
(9054, 15, 1373941139, 277, 1, 1),
(9055, 49, 1373941942, 5014, 3, 12),
(9056, 13, 1373942226, 311, 1, 0),
(9057, 23, 1373942367, 1186, 2, 4),
(9058, 58, 1373942377, 9778, 1, 5),
(9059, 50, 1373942652, 1569, 2, 2),
(9060, 57, 1373942699, 789, 1, 3),
(9061, 28, 1373942843, 3343, 3, 13),
(9062, 29, 1373942955, 1935, 1, 8),
(9063, 19, 1373942999, 2539, 1, 4),
(9064, 35, 1373943041, 7054, 10, 28),
(9065, 27, 1373943060, 1483, 2, 6),
(9066, 20, 1373943065, 1662, 2, 2),
(9067, 16, 1373943072, 1712, 1, 3),
(9068, 22, 1373943097, 2731, 1, 7),
(9069, 31, 1373943107, 3623, 2, 17),
(9070, 24, 1373943179, 3445, 1, 9),
(9071, 54, 1373943257, 6063, 2, 2),
(9072, 55, 1373943365, 7219, 1, 7),
(9073, 48, 1373943384, 4995, 2, 13),
(9074, 49, 1373943579, 1636, 1, 4),
(9075, 15, 1373943605, 881, 1, 1),
(9076, 51, 1373943756, 5599, 1, 11),
(9077, 57, 1373944077, 1224, 1, 4),
(9078, 25, 1373944179, 3236, 1, 6),
(9079, 12, 1373944227, 309, 1, 0),
(9080, 24, 1373944339, 1160, 1, 0),
(9081, 59, 1373944429, 985, 1, 0),
(9082, 24, 1373944522, 183, 2, 0),
(9083, 55, 1373944746, 181, 1, 0),
(9084, 28, 1373945217, 2374, 1, 2),
(9085, 42, 1373945394, 14726, 25, 80),
(9086, 23, 1373945744, 3377, 1, 4),
(9087, 29, 1373945786, 2831, 1, 5),
(9088, 49, 1373945828, 2249, 1, 5),
(9089, 52, 1373946175, 4375, 2, 12),
(9090, 47, 1373946241, 7078, 1, 7),
(9091, 20, 1373946401, 1251, 2, 0),
(9092, 35, 1373946503, 3462, 2, 6),
(9093, 41, 1373946531, 10226, 14, 42),
(9094, 29, 1373946684, 898, 2, 2),
(9095, 16, 1373947002, 1639, 2, 6),
(9096, 46, 1373947123, 10589, 9, 47),
(9097, 14, 1373947355, 2637, 1, 7),
(9098, 13, 1373948315, 3720, 1, 6),
(9099, 62, 1373948322, 6079, 1, 2),
(9100, 28, 1373948671, 3454, 2, 5),
(9101, 58, 1373948697, 6320, 1, 2),
(9102, 21, 1373948721, 1176, 2, 3),
(9103, 24, 1373948758, 4236, 2, 9),
(9104, 38, 1373948777, 11693, 1, 8),
(9105, 49, 1373948845, 979, 1, 7),
(9106, 64, 1373948888, 792, 1, 2),
(9107, 51, 1373948910, 5154, 1, 8),
(9108, 54, 1373948974, 5717, 1, 3),
(9109, 21, 1373949057, 336, 1, 1),
(9110, 20, 1373949066, 351, 1, 1),
(9111, 53, 1373949120, 5862, 2, 6),
(9112, 56, 1373949157, 6413, 1, 4),
(9113, 27, 1373949259, 1837, 2, 5),
(9114, 13, 1373949398, 562, 1, 2),
(9115, 18, 1373949598, 1250, 1, 4),
(9116, 58, 1373949701, 1004, 1, 2),
(9117, 27, 1373949798, 539, 1, 1),
(9118, 41, 1373949838, 3307, 6, 11),
(9119, 30, 1373949964, 2341, 4, 6),
(9120, 21, 1373950097, 314, 2, 4),
(9121, 23, 1373950251, 1249, 2, 4),
(9122, 53, 1373950311, 1191, 1, 2),
(9123, 51, 1373950464, 1211, 4, 2),
(9124, 18, 1373950651, 1053, 1, 7),
(9125, 27, 1373950712, 763, 1, 3),
(9126, 58, 1373950883, 443, 1, 0),
(9127, 27, 1373950988, 276, 1, 0),
(9128, 19, 1373951061, 8062, 6, 22),
(9129, 14, 1373951163, 1020, 1, 5),
(9130, 50, 1373951165, 8513, 2, 13),
(9131, 48, 1373951185, 7801, 4, 28),
(9132, 11, 1373951206, 1345, 2, 6),
(9133, 61, 1373951209, 799, 1, 1),
(9134, 24, 1373951232, 2244, 1, 11),
(9135, 15, 1373951257, 862, 1, 2),
(9136, 25, 1373951393, 7214, 9, 18),
(9137, 13, 1373951496, 1764, 2, 9),
(9138, 20, 1373951666, 1475, 1, 5),
(9139, 29, 1373951755, 5071, 3, 17),
(9140, 52, 1373951784, 4878, 1, 15),
(9141, 35, 1373951892, 5389, 6, 22),
(9142, 51, 1373952018, 1498, 1, 7),
(9143, 63, 1373952060, 3845, 3, 8),
(9144, 28, 1373952118, 3447, 4, 12),
(9145, 49, 1373952145, 3300, 1, 10),
(9146, 50, 1373952277, 1112, 1, 6),
(9147, 12, 1373952380, 6558, 2, 18),
(9148, 56, 1373952400, 3243, 2, 8),
(9149, 31, 1373952475, 8886, 10, 35),
(9150, 48, 1373952760, 1575, 2, 10),
(9151, 25, 1373953093, 989, 1, 3),
(9152, 51, 1373953166, 1148, 1, 3),
(9153, 14, 1373953403, 2239, 1, 2),
(9154, 30, 1373953497, 1964, 3, 3),
(9155, 46, 1373953590, 6467, 4, 37),
(9156, 22, 1373953647, 8642, 5, 23),
(9157, 27, 1373953660, 2095, 1, 2),
(9158, 44, 1373953755, 13244, 15, 53),
(9159, 28, 1373953847, 1729, 1, 6),
(9160, 51, 1373954095, 929, 1, 2),
(9161, 24, 1373954133, 2900, 1, 3),
(9162, 47, 1373954134, 7893, 12, 39),
(9163, 43, 1373954469, 22260, 2, 5),
(9164, 20, 1373954502, 650, 3, 1),
(9165, 52, 1373954703, 2919, 2, 2),
(9166, 11, 1373954775, 1150, 1, 1),
(9167, 55, 1373954878, 2770, 3, 7),
(9168, 15, 1373955235, 2406, 1, 4),
(9169, 23, 1373955517, 4674, 1, 11),
(9170, 28, 1373955631, 1784, 3, 6),
(9171, 11, 1373955759, 822, 1, 5),
(9172, 27, 1373955904, 920, 1, 4),
(9173, 47, 1373955913, 1779, 1, 6),
(9174, 61, 1373955951, 4742, 2, 0),
(9175, 59, 1373956093, 620, 1, 4),
(9176, 40, 1373956189, 3251, 3, 10),
(9177, 54, 1373956387, 2240, 3, 3),
(9178, 55, 1373956597, 1147, 1, 3),
(9179, 16, 1373956602, 1422, 2, 4),
(9180, 60, 1373956606, 5189, 1, 7),
(9181, 21, 1373956777, 1796, 1, 12),
(9182, 38, 1373957036, 8259, 10, 40),
(9183, 44, 1373957130, 2104, 3, 5),
(9184, 25, 1373957286, 3136, 3, 11),
(9185, 28, 1373957404, 1773, 2, 4),
(9186, 16, 1373957444, 842, 1, 1),
(9187, 31, 1373957541, 5066, 4, 18),
(9188, 29, 1373957693, 5793, 3, 28),
(9189, 53, 1373957848, 2341, 2, 10),
(9190, 48, 1373957925, 4953, 1, 15),
(9191, 46, 1373957948, 4358, 4, 14),
(9192, 51, 1373958080, 1901, 1, 4),
(9193, 49, 1373958084, 1248, 2, 6),
(9194, 15, 1373958163, 2833, 5, 14),
(9195, 55, 1373958176, 1579, 1, 0),
(9196, 51, 1373958267, 187, 1, 0),
(9197, 56, 1373958281, 5881, 1, 22),
(9198, 19, 1373958444, 4721, 1, 18),
(9199, 18, 1373958470, 4909, 3, 17),
(9200, 14, 1373958556, 2957, 1, 6),
(9201, 24, 1373958758, 2958, 3, 15),
(9202, 30, 1373958930, 3424, 6, 19),
(9203, 36, 1373959229, 27766, 20, 125),
(9204, 50, 1373959284, 1465, 1, 6),
(9205, 20, 1373959316, 1183, 2, 8),
(9206, 40, 1373959414, 3224, 3, 9),
(9207, 58, 1373959516, 435, 1, 2),
(9208, 59, 1373959527, 824, 1, 2),
(9209, 57, 1373959756, 548, 1, 2),
(9210, 13, 1373959832, 1669, 3, 6),
(9211, 14, 1373959893, 1337, 1, 4),
(9212, 11, 1373959919, 937, 2, 2),
(9213, 17, 1373959945, 4635, 4, 20),
(9214, 59, 1373960291, 220, 1, 0),
(9215, 13, 1373960366, 534, 1, 1),
(9216, 27, 1373960466, 1738, 3, 8),
(9217, 51, 1373960559, 1670, 2, 8),
(9218, 34, 1373960649, 14804, 10, 54),
(9219, 52, 1373960658, 5955, 2, 18),
(9220, 58, 1373961090, 1258, 3, 4),
(9221, 23, 1373961096, 5409, 4, 34),
(9222, 24, 1373961304, 2546, 1, 10),
(9223, 53, 1373961350, 3306, 4, 13),
(9224, 34, 1373961351, 702, 1, 3),
(9225, 55, 1373961375, 1172, 2, 2),
(9226, 28, 1373961502, 2796, 3, 10),
(9227, 30, 1373961590, 2660, 5, 19),
(9228, 17, 1373961643, 1201, 1, 6),
(9229, 35, 1373961663, 9771, 12, 42),
(9230, 49, 1373961721, 2785, 3, 18),
(9231, 21, 1373961820, 5043, 7, 22),
(9232, 18, 1373961878, 2557, 1, 7),
(9233, 61, 1373961968, 1624, 1, 4),
(9234, 57, 1373962101, 459, 1, 6),
(9235, 21, 1373962112, 292, 1, 0),
(9236, 55, 1373962116, 339, 1, 1),
(9237, 38, 1373962168, 5132, 6, 42),
(9238, 16, 1373962311, 982, 1, 6),
(9239, 12, 1373962672, 1744, 2, 4),
(9240, 29, 1373962799, 5106, 9, 27),
(9241, 40, 1373962844, 3430, 5, 17),
(9242, 50, 1373962897, 3126, 7, 15),
(9243, 51, 1373962945, 2220, 1, 12),
(9244, 14, 1373963000, 1139, 2, 5),
(9245, 28, 1373963235, 1448, 1, 8),
(9246, 34, 1373963302, 1950, 2, 10),
(9247, 48, 1373963332, 5406, 6, 19),
(9248, 31, 1373963361, 5769, 5, 35),
(9249, 49, 1373963495, 1358, 2, 1),
(9250, 24, 1373963517, 2213, 1, 16),
(9251, 30, 1373963566, 1976, 1, 8),
(9252, 21, 1373963714, 1602, 5, 4),
(9253, 46, 1373963716, 5767, 7, 35),
(9254, 18, 1373963740, 1862, 1, 8),
(9255, 15, 1373963753, 4063, 3, 22),
(9256, 35, 1373964122, 2459, 5, 13),
(9257, 56, 1373964128, 1926, 1, 3),
(9258, 43, 1373964409, 8157, 9, 31),
(9259, 52, 1373964491, 2806, 1, 10),
(9260, 54, 1373964639, 6540, 7, 23),
(9261, 38, 1373964651, 2482, 6, 9),
(9262, 58, 1373964718, 2623, 1, 4),
(9263, 42, 1373964827, 19432, 25, 83),
(9264, 47, 1373964986, 9073, 6, 37),
(9265, 28, 1373965078, 1843, 1, 3),
(9266, 47, 1373965368, 234, 1, 0),
(9267, 55, 1373965734, 600, 1, 1),
(9268, 59, 1373966049, 196, 1, 1),
(9269, 15, 1373966144, 1014, 1, 2),
(9270, 28, 1373966176, 1044, 1, 3),
(9271, 52, 1373966208, 668, 2, 0),
(9272, 18, 1373966272, 1141, 1, 9),
(9273, 20, 1373966427, 1296, 4, 3),
(9274, 32, 1373966514, 928, 1, 6),
(9275, 31, 1373966520, 1388, 2, 6),
(9276, 51, 1373966520, 1386, 2, 6),
(9277, 13, 1373966637, 1441, 2, 5),
(9278, 49, 1373966754, 880, 1, 3),
(9279, 16, 1373966861, 1730, 2, 3),
(9280, 14, 1373966918, 1788, 2, 6),
(9281, 28, 1373967085, 909, 3, 11),
(9282, 22, 1373967089, 1958, 2, 9),
(9283, 50, 1373967557, 1858, 3, 10),
(9284, 24, 1373967694, 2563, 5, 17),
(9285, 43, 1373967721, 2588, 2, 11),
(9286, 15, 1373967875, 459, 1, 3),
(9287, 51, 1373967882, 1118, 2, 3),
(9288, 23, 1373968018, 1577, 1, 8),
(9289, 58, 1373968175, 1732, 1, 3),
(9290, 34, 1373968281, 3149, 4, 15),
(9291, 41, 1373968456, 3094, 4, 31),
(9292, 52, 1373968551, 2343, 2, 11),
(9293, 23, 1373968769, 751, 1, 5),
(9294, 44, 1373968778, 3645, 2, 12),
(9295, 50, 1373969138, 1581, 2, 1),
(9296, 24, 1373969177, 1483, 1, 5),
(9297, 13, 1373969198, 279, 1, 1),
(9298, 59, 1373969264, 2229, 2, 1),
(9299, 29, 1373969390, 4112, 4, 17),
(9300, 38, 1373969404, 4271, 2, 24),
(9301, 45, 1373969604, 3670, 1, 12),
(9302, 51, 1373969605, 1723, 1, 3),
(9303, 14, 1373969696, 1883, 2, 6),
(9304, 42, 1373969759, 4217, 4, 21),
(9305, 49, 1373970162, 1149, 1, 2),
(9306, 61, 1373970418, 1701, 2, 0),
(9307, 17, 1373970446, 3527, 3, 5),
(9308, 29, 1373970457, 1067, 2, 4),
(9309, 58, 1373970461, 2286, 1, 4),
(9310, 48, 1373970519, 5385, 4, 12),
(9311, 12, 1373970636, 458, 1, 1),
(9312, 57, 1373970640, 632, 1, 2),
(9313, 47, 1373970682, 5314, 5, 27),
(9314, 44, 1373970855, 2077, 2, 5),
(9315, 41, 1373970903, 2447, 3, 23),
(9316, 60, 1373970904, 1035, 2, 1),
(9317, 38, 1373970910, 632, 5, 10),
(9318, 15, 1373971177, 1091, 1, 2),
(9319, 28, 1373971272, 4187, 7, 27),
(9320, 59, 1373971291, 758, 1, 1),
(9321, 13, 1373971459, 2261, 1, 8),
(9322, 63, 1373971497, 1238, 1, 0),
(9323, 14, 1373971566, 566, 1, 4),
(9324, 18, 1373971806, 3076, 1, 10),
(9325, 17, 1373971831, 1223, 1, 6),
(9326, 20, 1373971854, 5427, 5, 28),
(9327, 29, 1373971879, 1422, 1, 9),
(9328, 21, 1373971889, 6758, 9, 31),
(9329, 54, 1373971929, 391, 1, 1),
(9330, 55, 1373972097, 1869, 2, 6),
(9331, 43, 1373972161, 2798, 1, 18),
(9332, 22, 1373972340, 5250, 2, 19),
(9333, 52, 1373972424, 2207, 3, 4),
(9334, 31, 1373972430, 5910, 9, 29),
(9335, 37, 1373972467, 7334, 6, 48),
(9336, 40, 1373973632, 1007, 1, 0),
(9337, 28, 1373973810, 1186, 2, 7),
(9338, 25, 1373974101, 1478, 6, 9),
(9339, 23, 1373974340, 879, 1, 6),
(9340, 21, 1373974432, 1809, 2, 2),
(9341, 40, 1373974638, 974, 1, 8),
(9342, 34, 1373974639, 2015, 1, 7),
(9343, 15, 1373974924, 322, 1, 1),
(9344, 18, 1373975252, 268, 2, 0),
(9345, 17, 1373975257, 179, 1, 0),
(9346, 14, 1373975341, 194, 1, 1),
(9347, 16, 1373975464, 482, 1, 2),
(9348, 23, 1373975669, 1329, 1, 6),
(9349, 59, 1373975688, 558, 2, 1),
(9350, 14, 1373975830, 489, 1, 1),
(9351, 11, 1373975843, 1074, 1, 3),
(9352, 20, 1373976004, 2598, 1, 10),
(9353, 24, 1373976029, 3406, 5, 5),
(9354, 38, 1373976258, 3633, 8, 24),
(9355, 16, 1373976514, 1050, 1, 3),
(9356, 37, 1373976542, 3918, 4, 17),
(9357, 15, 1373976554, 885, 1, 2),
(9358, 29, 1373976561, 3937, 8, 30),
(9359, 44, 1373976574, 3949, 3, 9),
(9360, 48, 1373976596, 3970, 5, 7),
(9361, 49, 1373976734, 4108, 4, 4),
(9362, 34, 1373976877, 2238, 4, 15),
(9363, 24, 1373977053, 1024, 1, 4),
(9364, 45, 1373977061, 4436, 1, 13),
(9365, 14, 1373977068, 1238, 1, 4),
(9366, 52, 1373977184, 1020, 2, 5),
(9367, 44, 1373977200, 626, 2, 2),
(9368, 51, 1373977212, 1800, 1, 4),
(9369, 58, 1373977284, 1753, 1, 5),
(9370, 13, 1373977671, 841, 1, 4),
(9371, 52, 1373977848, 664, 1, 2),
(9372, 19, 1373977857, 4174, 1, 9),
(9373, 51, 1373977876, 664, 1, 1),
(9374, 53, 1373978026, 1298, 1, 6),
(9375, 49, 1373978200, 758, 2, 5),
(9376, 12, 1373978299, 265, 1, 5),
(9377, 27, 1373978318, 5695, 11, 30),
(9378, 13, 1373978544, 417, 1, 3),
(9379, 17, 1373978564, 337, 1, 2),
(9380, 41, 1373978738, 4210, 3, 27),
(9381, 11, 1373978750, 995, 1, 6),
(9382, 42, 1373978753, 6128, 7, 25),
(9383, 44, 1373978766, 1566, 3, 8),
(9384, 22, 1373978771, 6148, 3, 22),
(9385, 43, 1373978867, 2169, 1, 11),
(9386, 12, 1373979223, 852, 3, 1),
(9387, 55, 1373979267, 2615, 4, 8),
(9388, 28, 1373979365, 5555, 11, 37),
(9389, 58, 1373979433, 580, 1, 2),
(9390, 14, 1373979433, 245, 1, 2),
(9391, 17, 1373979453, 889, 1, 5),
(9392, 27, 1373979565, 1247, 1, 9),
(9393, 57, 1373979570, 1495, 1, 5),
(9394, 52, 1373979599, 1567, 1, 9),
(9395, 54, 1373979623, 1654, 2, 8),
(9396, 15, 1373979645, 665, 1, 3),
(9397, 23, 1373979783, 4114, 5, 18),
(9398, 13, 1373979857, 213, 1, 0),
(9399, 43, 1373980048, 1181, 2, 7),
(9400, 29, 1373980085, 3524, 5, 21),
(9401, 42, 1373980244, 1491, 2, 8),
(9402, 51, 1373980249, 354, 1, 3),
(9403, 16, 1373980263, 700, 1, 1),
(9404, 64, 1373980403, 697, 1, 3),
(9405, 11, 1373980422, 71, 1, 0),
(9406, 35, 1373980461, 7837, 8, 39),
(9407, 55, 1373980493, 1226, 2, 4),
(9408, 37, 1373980529, 3987, 2, 30),
(9409, 50, 1373980541, 3191, 3, 15),
(9410, 30, 1373980557, 7933, 17, 43),
(9411, 52, 1373980620, 802, 1, 5),
(9412, 52, 1373980733, 112, 1, 0),
(9413, 65, 1373980741, 1335, 4, 2),
(9414, 17, 1373981051, 651, 1, 2),
(9415, 57, 1373981054, 1484, 2, 4),
(9416, 53, 1373981265, 2333, 5, 10),
(9417, 14, 1373981355, 842, 2, 1),
(9418, 26, 1373981358, 8735, 7, 41),
(9419, 58, 1373981390, 1957, 1, 5),
(9420, 33, 1373981405, 8781, 17, 59),
(9421, 56, 1373981427, 2217, 3, 11),
(9422, 24, 1373981536, 4483, 4, 24),
(9423, 41, 1373981604, 2866, 7, 21),
(9424, 54, 1373981614, 1991, 1, 10),
(9425, 12, 1373981654, 741, 1, 6),
(9426, 64, 1373981711, 1308, 1, 2),
(9427, 17, 1373982173, 667, 1, 0),
(9428, 44, 1373982194, 3428, 3, 22),
(9429, 53, 1373982457, 1192, 1, 5),
(9430, 43, 1373982740, 2692, 4, 16),
(9431, 55, 1373982845, 2165, 1, 4),
(9432, 52, 1373982905, 2172, 2, 5),
(9433, 49, 1373983116, 4916, 7, 21),
(9434, 56, 1373983307, 1880, 1, 7),
(9435, 48, 1373983335, 4959, 3, 5),
(9436, 41, 1373983778, 2174, 1, 5),
(9437, 47, 1373984097, 11472, 6, 32),
(9438, 27, 1373984125, 4560, 1, 18),
(9439, 19, 1373984132, 6274, 3, 16),
(9440, 50, 1373984182, 3641, 2, 9),
(9441, 20, 1373984657, 8653, 6, 24),
(9442, 42, 1373984943, 4699, 2, 14),
(9443, 35, 1373985108, 4647, 7, 13),
(9444, 19, 1373985188, 1056, 2, 1),
(9445, 41, 1373985428, 1650, 1, 1),
(9446, 45, 1373985505, 8444, 3, 24),
(9447, 23, 1373985936, 6153, 1, 23),
(9448, 33, 1373986167, 4762, 3, 18),
(9449, 12, 1373986240, 191, 1, 0),
(9450, 31, 1373986270, 13646, 16, 81),
(9451, 50, 1373986427, 1850, 1, 2),
(9452, 51, 1373986442, 4800, 1, 1),
(9453, 45, 1373986469, 964, 2, 1),
(9454, 36, 1373986581, 13957, 22, 45),
(9455, 44, 1373986632, 1747, 1, 1),
(9456, 13, 1373986635, 601, 1, 4),
(9457, 32, 1373986767, 14143, 17, 75),
(9458, 43, 1373986774, 4034, 1, 2),
(9459, 53, 1373986976, 797, 1, 6),
(9460, 22, 1373987130, 8359, 1, 23),
(9461, 27, 1373987148, 3023, 4, 11),
(9462, 24, 1373987175, 5639, 6, 7),
(9463, 29, 1373987309, 7223, 11, 40),
(9464, 33, 1373987338, 1171, 2, 7),
(9465, 52, 1373987717, 899, 1, 4),
(9466, 45, 1373987805, 1336, 1, 1),
(9467, 44, 1373987933, 1301, 1, 8),
(9468, 60, 1373987970, 6606, 1, 0),
(9469, 18, 1373988026, 609, 1, 1),
(9470, 20, 1373988060, 2741, 2, 4),
(9471, 62, 1373988218, 273, 1, 0),
(9472, 17, 1373988297, 355, 1, 1),
(9473, 58, 1373988453, 7063, 1, 3),
(9474, 63, 1373988535, 7256, 1, 0),
(9475, 42, 1373988689, 3746, 1, 15),
(9476, 15, 1373988790, 1620, 2, 4),
(9477, 52, 1373988902, 299, 1, 2),
(9478, 54, 1373988928, 3902, 3, 4),
(9479, 62, 1373989023, 805, 1, 2),
(9480, 15, 1373989199, 408, 1, 0),
(9481, 56, 1373989256, 622, 1, 1),
(9482, 16, 1373989330, 336, 2, 2),
(9483, 55, 1373989377, 896, 1, 2),
(9484, 14, 1373989534, 1399, 1, 2),
(9485, 57, 1373989572, 893, 1, 1),
(9486, 53, 1373989753, 1364, 1, 6),
(9487, 58, 1373989823, 1370, 1, 3),
(9488, 63, 1373989856, 1321, 1, 3),
(9489, 55, 1373989909, 532, 1, 2),
(9490, 23, 1373990289, 4353, 3, 13),
(9491, 26, 1373990378, 9020, 7, 43),
(9492, 22, 1373990390, 3173, 2, 10),
(9493, 42, 1373990391, 1702, 3, 12),
(9494, 50, 1373990396, 1898, 1, 8),
(9495, 24, 1373990407, 3232, 3, 14),
(9496, 29, 1373990421, 3112, 2, 15),
(9497, 46, 1373990598, 17973, 8, 59),
(9498, 21, 1373990607, 16036, 2, 12),
(9499, 47, 1373990630, 6533, 5, 25),
(9500, 45, 1373990642, 2837, 1, 13),
(9501, 28, 1373990686, 11321, 17, 55),
(9502, 20, 1373990698, 2638, 5, 8),
(9503, 14, 1373991190, 1656, 1, 8),
(9504, 19, 1373991336, 1216, 2, 12),
(9505, 37, 1373991372, 10843, 10, 43),
(9506, 11, 1373991426, 844, 3, 5),
(9507, 59, 1373991606, 1250, 2, 1),
(9508, 43, 1373991629, 4854, 6, 29),
(9509, 53, 1373991644, 1662, 1, 4),
(9510, 52, 1373991762, 1833, 2, 3),
(9511, 28, 1373991942, 1256, 2, 11),
(9512, 23, 1373991981, 1692, 1, 9),
(9513, 15, 1373992021, 1779, 1, 11),
(9514, 36, 1373992274, 5693, 12, 34),
(9515, 13, 1373992320, 329, 1, 0),
(9516, 48, 1373992398, 4379, 2, 21),
(9517, 49, 1373992459, 6037, 2, 19),
(9518, 13, 1373992622, 302, 1, 1),
(9519, 17, 1373992771, 488, 1, 4),
(9520, 23, 1373992800, 819, 3, 6),
(9521, 27, 1373993047, 5112, 11, 25),
(9522, 46, 1373993140, 2408, 2, 7),
(9523, 55, 1373993241, 564, 1, 2),
(9524, 56, 1373993263, 563, 1, 1),
(9525, 11, 1373993268, 701, 1, 0),
(9526, 58, 1373993294, 1851, 2, 4),
(9527, 42, 1373993341, 2950, 3, 15),
(9528, 33, 1373993357, 5502, 8, 23),
(9529, 50, 1373993697, 2464, 1, 3),
(9530, 17, 1373993710, 939, 2, 9),
(9531, 20, 1373993755, 457, 1, 1),
(9532, 14, 1373993787, 1363, 3, 9),
(9533, 18, 1373993790, 2156, 5, 15),
(9534, 19, 1373993941, 2605, 2, 16),
(9535, 51, 1373993951, 863, 1, 1),
(9536, 16, 1373993992, 1186, 1, 2),
(9537, 26, 1373994219, 3840, 4, 12),
(9538, 22, 1373994265, 3104, 4, 14),
(9539, 42, 1373994346, 1005, 3, 10),
(9540, 14, 1373994439, 652, 1, 0),
(9541, 30, 1373994473, 13916, 16, 58),
(9542, 40, 1373994554, 19916, 31, 109),
(9543, 12, 1373994713, 519, 1, 2),
(9544, 37, 1373994816, 3444, 8, 24),
(9545, 44, 1373994940, 7007, 6, 38),
(9546, 39, 1373994942, 22317, 25, 122),
(9547, 15, 1373997266, 739, 1, 1),
(9548, 34, 1373997272, 743, 1, 4),
(9549, 14, 1373997301, 479, 1, 2);

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_frags`
--

CREATE TABLE IF NOT EXISTS `zotsme_frags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `kill_time` int(11) NOT NULL,
  `killed_id` int(11) NOT NULL,
  `killed_ip` int(11) NOT NULL,
  `killed_account` int(11) NOT NULL,
  `killed_level` int(11) NOT NULL,
  `killed_alive_time` int(11) NOT NULL,
  `killer_id` int(11) NOT NULL,
  `killer_ip` int(11) NOT NULL,
  `killer_level` int(11) NOT NULL,
  `killer_damage_percent` int(11) NOT NULL,
  `assistants` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `kill_time` (`kill_time`,`killed_id`,`killer_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 AUTO_INCREMENT=1 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_logins`
--

CREATE TABLE IF NOT EXISTS `zotsme_logins` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `player_id` int(11) NOT NULL,
  `login_time` int(11) NOT NULL,
  `logout_time` int(11) NOT NULL,
  `online_time` int(11) NOT NULL,
  `kills` int(11) NOT NULL DEFAULT '0',
  `deaths` int(11) NOT NULL DEFAULT '0',
  `assists` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `player_id` (`player_id`,`login_time`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=812 ;

--
-- Zrzut danych tabeli `zotsme_logins`
--

INSERT INTO `zotsme_logins` (`id`, `player_id`, `login_time`, `logout_time`, `online_time`, `kills`, `deaths`, `assists`) VALUES
(1, 3, 1373143682, 1373144548, 866, 0, 0, 0),
(2, 4, 1373143682, 1373144548, 866, 0, 0, 0),
(3, 5, 1373143682, 1373144548, 866, 0, 0, 0),
(4, 2, 1373143700, 1373144549, 849, 0, 0, 0),
(5, 8, 1373185545, 1373186450, 905, 0, 0, 0),
(6, 10, 1373186541, 1373187455, 914, 0, 0, 0),
(7, 10, 1373187456, 1373188147, 691, 0, 0, 0),
(8, 8, 1373188147, 1373188249, 102, 0, 0, 0),
(9, 9, 1373188249, 1373188469, 220, 0, 0, 0),
(10, 3, 1373188470, 1373188548, 78, 0, 0, 0),
(11, 10, 1373188549, 1373188575, 26, 0, 0, 0),
(12, 3, 1373188583, 1373188656, 73, 0, 0, 0),
(13, 9, 1373188657, 1373189319, 662, 0, 0, 0),
(14, 2, 1373185586, 1373189361, 3775, 0, 0, 0),
(15, 9, 1373189320, 1373189362, 42, 0, 0, 0),
(16, 10, 1373189588, 1373190954, 1366, 0, 0, 0),
(17, 2, 1373189588, 1373191020, 1432, 0, 0, 0),
(18, 2, 1373204317, 1373204620, 303, 0, 0, 0),
(19, 8, 1373204318, 1373204759, 441, 0, 0, 0),
(20, 3, 1373204759, 1373204777, 18, 0, 0, 0),
(21, 9, 1373204777, 1373204797, 20, 0, 0, 0),
(22, 10, 1373204798, 1373204827, 29, 0, 0, 0),
(23, 3, 1373204827, 1373205952, 1125, 0, 0, 0),
(24, 2, 1373204620, 1373221571, 16951, 0, 0, 0),
(25, 8, 1373226752, 1373226774, 22, 0, 0, 0),
(26, 10, 1373226774, 1373226814, 40, 0, 0, 0),
(27, 9, 1373226814, 1373227271, 457, 0, 0, 0),
(28, 9, 1373227283, 1373227902, 619, 0, 0, 0),
(29, 8, 1373227909, 1373228680, 771, 0, 0, 0),
(30, 3, 1373228687, 1373228772, 85, 0, 0, 0),
(31, 10, 1373228776, 1373228824, 48, 0, 0, 0),
(32, 8, 1373228841, 1373228866, 25, 0, 0, 0),
(33, 9, 1373228867, 1373228882, 15, 0, 0, 0),
(34, 10, 1373228883, 1373229149, 266, 0, 0, 0),
(35, 10, 1373229149, 1373229162, 13, 0, 0, 0),
(36, 9, 1373229163, 1373229306, 143, 0, 0, 0),
(37, 3, 1373229308, 1373229468, 160, 0, 0, 0),
(38, 9, 1373229468, 1373229483, 15, 0, 0, 0),
(39, 8, 1373229483, 1373229514, 31, 0, 0, 0),
(40, 3, 1373229514, 1373230429, 915, 0, 0, 0),
(41, 3, 1373230531, 1373231463, 932, 0, 0, 0),
(42, 8, 1373231475, 1373231680, 205, 0, 0, 0),
(43, 2, 1373226827, 1373232258, 5431, 0, 0, 0),
(44, 2, 1373271257, 1373271964, 707, 0, 0, 0),
(45, 10, 1373272581, 1373272611, 30, 0, 0, 0),
(46, 2, 1373272580, 1373296016, 23436, 0, 0, 0),
(47, 2, 1373302917, 1373302929, 12, 0, 0, 0),
(48, 8, 1373302930, 1373302944, 14, 0, 0, 0),
(49, 10, 1373302945, 1373303748, 803, 0, 0, 0),
(50, 9, 1373303793, 1373304707, 914, 0, 0, 0),
(51, 2, 1373307465, 1373307752, 287, 0, 0, 0),
(52, 10, 1373307753, 1373307770, 17, 0, 0, 0),
(53, 10, 1373307781, 1373307905, 124, 0, 0, 0),
(54, 2, 1373307906, 1373307940, 34, 0, 0, 0),
(55, 10, 1373307943, 1373308192, 249, 0, 0, 0),
(56, 10, 1373308298, 1373308354, 56, 0, 0, 0),
(57, 2, 1373308387, 1373308406, 19, 0, 0, 0),
(58, 3, 1373308407, 1373309012, 605, 0, 0, 0),
(59, 10, 1373309033, 1373310055, 1022, 0, 0, 0),
(60, 8, 1373310073, 1373310684, 611, 0, 0, 0),
(61, 2, 1373319445, 1373319479, 34, 0, 0, 0),
(62, 10, 1373319479, 1373320084, 605, 0, 0, 0),
(63, 2, 1373320087, 1373320125, 38, 0, 0, 0),
(64, 10, 1373320126, 1373320928, 802, 0, 0, 0),
(65, 2, 1373320928, 1373320943, 15, 0, 0, 0),
(66, 10, 1373320943, 1373321344, 401, 0, 0, 0),
(67, 2, 1373324088, 1373324143, 55, 0, 0, 0),
(68, 2, 1373324703, 1373324966, 263, 0, 0, 0),
(69, 10, 1373324967, 1373325606, 639, 0, 0, 0),
(70, 8, 1373325965, 1373325986, 21, 0, 0, 0),
(71, 9, 1373325995, 1373326277, 282, 0, 0, 0),
(72, 2, 1373325611, 1373326284, 673, 0, 0, 0),
(73, 2, 1373348905, 1373348987, 82, 0, 0, 0),
(74, 10, 1373348988, 1373350004, 1016, 0, 0, 0),
(75, 9, 1373354710, 1373354934, 224, 0, 0, 0),
(76, 8, 1373354934, 1373355076, 142, 0, 0, 0),
(77, 2, 1373358053, 1373358811, 758, 0, 0, 0),
(78, 2, 1373358812, 1373358877, 65, 0, 0, 0),
(79, 2, 1373358878, 1373358918, 40, 0, 0, 0),
(80, 2, 1373358919, 1373359068, 149, 0, 0, 0),
(81, 10, 1373359546, 1373359742, 196, 0, 0, 0),
(82, 2, 1373359743, 1373359796, 53, 0, 0, 0),
(83, 9, 1373359798, 1373359931, 133, 0, 0, 0),
(84, 2, 1373359932, 1373359947, 15, 0, 0, 0),
(85, 9, 1373359950, 1373360299, 349, 0, 0, 0),
(86, 9, 1373360436, 1373360656, 220, 0, 0, 0),
(87, 10, 1373360657, 1373360920, 263, 0, 0, 0),
(88, 8, 1373360938, 1373360951, 13, 0, 0, 0),
(89, 10, 1373361043, 1373361078, 35, 0, 0, 0),
(90, 9, 1373361079, 1373362132, 1053, 0, 0, 0),
(91, 2, 1373369148, 1373371767, 2619, 0, 0, 0),
(92, 11, 1373364500, 1373373086, 8586, 0, 0, 0),
(93, 12, 1373364500, 1373373086, 8586, 0, 0, 0),
(94, 13, 1373364500, 1373373086, 8586, 0, 0, 0),
(95, 14, 1373364500, 1373373086, 8586, 0, 0, 0),
(96, 15, 1373364500, 1373373086, 8586, 0, 0, 0),
(97, 16, 1373364500, 1373373087, 8587, 0, 0, 0),
(98, 17, 1373364500, 1373373087, 8587, 0, 0, 0),
(99, 18, 1373364500, 1373373087, 8587, 0, 0, 0),
(100, 19, 1373364500, 1373373088, 8588, 0, 0, 0),
(101, 20, 1373364500, 1373373088, 8588, 0, 0, 0),
(102, 21, 1373364500, 1373373088, 8588, 0, 0, 0),
(103, 22, 1373364500, 1373373088, 8588, 0, 0, 0),
(104, 23, 1373364501, 1373373088, 8587, 0, 0, 0),
(105, 24, 1373364501, 1373373088, 8587, 0, 0, 0),
(106, 25, 1373364501, 1373373089, 8588, 0, 0, 0),
(107, 26, 1373364501, 1373373089, 8588, 0, 0, 0),
(108, 27, 1373364501, 1373373089, 8588, 0, 0, 0),
(109, 28, 1373364501, 1373373089, 8588, 0, 0, 0),
(110, 29, 1373364501, 1373373089, 8588, 0, 0, 0),
(111, 30, 1373364501, 1373373090, 8589, 0, 0, 0),
(112, 31, 1373364501, 1373373090, 8589, 0, 0, 0),
(113, 32, 1373364501, 1373373090, 8589, 0, 0, 0),
(114, 33, 1373364501, 1373373090, 8589, 0, 0, 0),
(115, 34, 1373364501, 1373373090, 8589, 0, 0, 0),
(116, 35, 1373364501, 1373373091, 8590, 0, 0, 0),
(117, 36, 1373364501, 1373373091, 8590, 0, 0, 0),
(118, 37, 1373364501, 1373373091, 8590, 0, 0, 0),
(119, 38, 1373364501, 1373373091, 8590, 0, 0, 0),
(120, 39, 1373364501, 1373373091, 8590, 0, 0, 0),
(121, 40, 1373364501, 1373373092, 8591, 0, 0, 0),
(122, 41, 1373364501, 1373373092, 8591, 0, 0, 0),
(123, 42, 1373364501, 1373373092, 8591, 0, 0, 0),
(124, 43, 1373364502, 1373373092, 8590, 0, 0, 0),
(125, 44, 1373364502, 1373373092, 8590, 0, 0, 0),
(126, 45, 1373364502, 1373373093, 8591, 0, 0, 0),
(127, 46, 1373364502, 1373373093, 8591, 0, 0, 0),
(128, 47, 1373364502, 1373373093, 8591, 0, 0, 0),
(129, 48, 1373364502, 1373373093, 8591, 0, 0, 0),
(130, 49, 1373364502, 1373373093, 8591, 0, 0, 0),
(131, 50, 1373364502, 1373373094, 8592, 0, 0, 0),
(132, 51, 1373364502, 1373373094, 8592, 0, 0, 0),
(133, 52, 1373364502, 1373373094, 8592, 0, 0, 0),
(134, 53, 1373364502, 1373373094, 8592, 0, 0, 0),
(135, 54, 1373364502, 1373373094, 8592, 0, 0, 0),
(136, 55, 1373364502, 1373373094, 8592, 0, 0, 0),
(137, 56, 1373364502, 1373373095, 8593, 0, 0, 0),
(138, 57, 1373364502, 1373373095, 8593, 0, 0, 0),
(139, 58, 1373364502, 1373373095, 8593, 0, 0, 0),
(140, 59, 1373364502, 1373373095, 8593, 0, 0, 0),
(141, 60, 1373364502, 1373373095, 8593, 0, 0, 0),
(142, 61, 1373364502, 1373373095, 8593, 0, 0, 0),
(143, 62, 1373364503, 1373373096, 8593, 0, 0, 0),
(144, 63, 1373364503, 1373373096, 8593, 0, 0, 0),
(145, 64, 1373364503, 1373373096, 8593, 0, 0, 0),
(146, 65, 1373364503, 1373373096, 8593, 0, 0, 0),
(147, 66, 1373364503, 1373373096, 8593, 0, 0, 0),
(148, 67, 1373364503, 1373373096, 8593, 0, 0, 0),
(149, 68, 1373364503, 1373373097, 8594, 0, 0, 0),
(150, 69, 1373364503, 1373373097, 8594, 0, 0, 0),
(151, 70, 1373364503, 1373373097, 8594, 0, 0, 0),
(152, 71, 1373364503, 1373373097, 8594, 0, 0, 0),
(153, 72, 1373364503, 1373373097, 8594, 0, 0, 0),
(154, 73, 1373364503, 1373373098, 8595, 0, 0, 0),
(155, 74, 1373364503, 1373373098, 8595, 0, 0, 0),
(156, 75, 1373364503, 1373373098, 8595, 0, 0, 0),
(157, 76, 1373364503, 1373373098, 8595, 0, 0, 0),
(158, 77, 1373364503, 1373373098, 8595, 0, 0, 0),
(159, 78, 1373364503, 1373373099, 8596, 0, 0, 0),
(160, 79, 1373364503, 1373373099, 8596, 0, 0, 0),
(161, 80, 1373364503, 1373373099, 8596, 0, 0, 0),
(162, 81, 1373364503, 1373373099, 8596, 0, 0, 0),
(163, 82, 1373364504, 1373373099, 8595, 0, 0, 0),
(164, 83, 1373364504, 1373373099, 8595, 0, 0, 0),
(165, 84, 1373364504, 1373373100, 8596, 0, 0, 0),
(166, 85, 1373364504, 1373373100, 8596, 0, 0, 0),
(167, 86, 1373364504, 1373373100, 8596, 0, 0, 0),
(168, 87, 1373364504, 1373373100, 8596, 0, 0, 0),
(169, 88, 1373364504, 1373373100, 8596, 0, 0, 0),
(170, 89, 1373364504, 1373373100, 8596, 0, 0, 0),
(171, 90, 1373364504, 1373373101, 8597, 0, 0, 0),
(172, 91, 1373364504, 1373373101, 8597, 0, 0, 0),
(173, 92, 1373364504, 1373373101, 8597, 0, 0, 0),
(174, 93, 1373364504, 1373373101, 8597, 0, 0, 0),
(175, 94, 1373364504, 1373373101, 8597, 0, 0, 0),
(176, 95, 1373364504, 1373373102, 8598, 0, 0, 0),
(177, 96, 1373364504, 1373373102, 8598, 0, 0, 0),
(178, 97, 1373364504, 1373373102, 8598, 0, 0, 0),
(179, 98, 1373364504, 1373373102, 8598, 0, 0, 0),
(180, 99, 1373364504, 1373373102, 8598, 0, 0, 0),
(181, 100, 1373364504, 1373373102, 8598, 0, 0, 0),
(182, 101, 1373364504, 1373373102, 8598, 0, 0, 0),
(183, 102, 1373364504, 1373373103, 8599, 0, 0, 0),
(184, 103, 1373364505, 1373373103, 8598, 0, 0, 0),
(185, 104, 1373364505, 1373373103, 8598, 0, 0, 0),
(186, 105, 1373364505, 1373373103, 8598, 0, 0, 0),
(187, 106, 1373364505, 1373373103, 8598, 0, 0, 0),
(188, 107, 1373364505, 1373373104, 8599, 0, 0, 0),
(189, 108, 1373364505, 1373373104, 8599, 0, 0, 0),
(190, 109, 1373364505, 1373373104, 8599, 0, 0, 0),
(191, 110, 1373364505, 1373373104, 8599, 0, 0, 0),
(192, 111, 1373364505, 1373373104, 8599, 0, 0, 0),
(193, 112, 1373364505, 1373373104, 8599, 0, 0, 0),
(194, 113, 1373364505, 1373373105, 8600, 0, 0, 0),
(195, 114, 1373364505, 1373373105, 8600, 0, 0, 0),
(196, 115, 1373364505, 1373373105, 8600, 0, 0, 0),
(197, 116, 1373364505, 1373373105, 8600, 0, 0, 0),
(198, 117, 1373364505, 1373373105, 8600, 0, 0, 0),
(199, 118, 1373364505, 1373373105, 8600, 0, 0, 0),
(200, 119, 1373364505, 1373373106, 8601, 0, 0, 0),
(201, 120, 1373364505, 1373373106, 8601, 0, 0, 0),
(202, 121, 1373364505, 1373373106, 8601, 0, 0, 0),
(203, 122, 1373364505, 1373373106, 8601, 0, 0, 0),
(204, 123, 1373364506, 1373373106, 8600, 0, 0, 0),
(205, 124, 1373364506, 1373373107, 8601, 0, 0, 0),
(206, 125, 1373364506, 1373373107, 8601, 0, 0, 0),
(207, 126, 1373364506, 1373373107, 8601, 0, 0, 0),
(208, 127, 1373364506, 1373373107, 8601, 0, 0, 0),
(209, 128, 1373364506, 1373373107, 8601, 0, 0, 0),
(210, 129, 1373364506, 1373373108, 8602, 0, 0, 0),
(211, 130, 1373364506, 1373373108, 8602, 0, 0, 0),
(212, 131, 1373364506, 1373373108, 8602, 0, 0, 0),
(213, 132, 1373364506, 1373373108, 8602, 0, 0, 0),
(214, 133, 1373364506, 1373373108, 8602, 0, 0, 0),
(215, 134, 1373364506, 1373373109, 8603, 0, 0, 0),
(216, 135, 1373364506, 1373373109, 8603, 0, 0, 0),
(217, 136, 1373364506, 1373373109, 8603, 0, 0, 0),
(218, 137, 1373364506, 1373373109, 8603, 0, 0, 0),
(219, 138, 1373364506, 1373373110, 8604, 0, 0, 0),
(220, 139, 1373364506, 1373373110, 8604, 0, 0, 0),
(221, 140, 1373364506, 1373373110, 8604, 0, 0, 0),
(222, 141, 1373364506, 1373373110, 8604, 0, 0, 0),
(223, 142, 1373364506, 1373373111, 8605, 0, 0, 0),
(224, 143, 1373364507, 1373373111, 8604, 0, 0, 0),
(225, 144, 1373364507, 1373373111, 8604, 0, 0, 0),
(226, 145, 1373364507, 1373373111, 8604, 0, 0, 0),
(227, 146, 1373364507, 1373373112, 8605, 0, 0, 0),
(228, 147, 1373364507, 1373373113, 8606, 0, 0, 0),
(229, 148, 1373364507, 1373373113, 8606, 0, 0, 0),
(230, 149, 1373364507, 1373373113, 8606, 0, 0, 0),
(231, 150, 1373364507, 1373373113, 8606, 0, 0, 0),
(232, 151, 1373364507, 1373373113, 8606, 0, 0, 0),
(233, 152, 1373364507, 1373373113, 8606, 0, 0, 0),
(234, 153, 1373364507, 1373373114, 8607, 0, 0, 0),
(235, 154, 1373364507, 1373373114, 8607, 0, 0, 0),
(236, 155, 1373364507, 1373373114, 8607, 0, 0, 0),
(237, 156, 1373364507, 1373373114, 8607, 0, 0, 0),
(238, 157, 1373364507, 1373373114, 8607, 0, 0, 0),
(239, 158, 1373364507, 1373373115, 8608, 0, 0, 0),
(240, 159, 1373364507, 1373373115, 8608, 0, 0, 0),
(241, 160, 1373364507, 1373373115, 8608, 0, 0, 0),
(242, 161, 1373364507, 1373373115, 8608, 0, 0, 0),
(243, 162, 1373364507, 1373373115, 8608, 0, 0, 0),
(244, 163, 1373364507, 1373373116, 8609, 0, 0, 0),
(245, 164, 1373364508, 1373373116, 8608, 0, 0, 0),
(246, 165, 1373364508, 1373373116, 8608, 0, 0, 0),
(247, 166, 1373364508, 1373373116, 8608, 0, 0, 0),
(248, 167, 1373364508, 1373373117, 8609, 0, 0, 0),
(249, 168, 1373364508, 1373373117, 8609, 0, 0, 0),
(250, 169, 1373364508, 1373373117, 8609, 0, 0, 0),
(251, 170, 1373364508, 1373373117, 8609, 0, 0, 0),
(252, 171, 1373364508, 1373373117, 8609, 0, 0, 0),
(253, 172, 1373364508, 1373373117, 8609, 0, 0, 0),
(254, 173, 1373364508, 1373373118, 8610, 0, 0, 0),
(255, 174, 1373364508, 1373373118, 8610, 0, 0, 0),
(256, 175, 1373364508, 1373373118, 8610, 0, 0, 0),
(257, 176, 1373364508, 1373373118, 8610, 0, 0, 0),
(258, 177, 1373364508, 1373373118, 8610, 0, 0, 0),
(259, 178, 1373364508, 1373373119, 8611, 0, 0, 0),
(260, 179, 1373364508, 1373373119, 8611, 0, 0, 0),
(261, 180, 1373364508, 1373373119, 8611, 0, 0, 0),
(262, 181, 1373364508, 1373373119, 8611, 0, 0, 0),
(263, 182, 1373364508, 1373373119, 8611, 0, 0, 0),
(264, 183, 1373364509, 1373373120, 8611, 0, 0, 0),
(265, 184, 1373364509, 1373373120, 8611, 0, 0, 0),
(266, 185, 1373364509, 1373373121, 8612, 0, 0, 0),
(267, 186, 1373364509, 1373373121, 8612, 0, 0, 0),
(268, 187, 1373364509, 1373373121, 8612, 0, 0, 0),
(269, 188, 1373364509, 1373373121, 8612, 0, 0, 0),
(270, 189, 1373364509, 1373373122, 8613, 0, 0, 0),
(271, 190, 1373364509, 1373373122, 8613, 0, 0, 0),
(272, 191, 1373364509, 1373373122, 8613, 0, 0, 0),
(273, 192, 1373364509, 1373373122, 8613, 0, 0, 0),
(274, 193, 1373364509, 1373373122, 8613, 0, 0, 0),
(275, 194, 1373364509, 1373373122, 8613, 0, 0, 0),
(276, 195, 1373364509, 1373373122, 8613, 0, 0, 0),
(277, 196, 1373364509, 1373373122, 8613, 0, 0, 0),
(278, 197, 1373364509, 1373373123, 8614, 0, 0, 0),
(279, 198, 1373364509, 1373373123, 8614, 0, 0, 0),
(280, 199, 1373364509, 1373373123, 8614, 0, 0, 0),
(281, 200, 1373364509, 1373373123, 8614, 0, 0, 0),
(282, 201, 1373364509, 1373373124, 8615, 0, 0, 0),
(283, 202, 1373364509, 1373373124, 8615, 0, 0, 0),
(284, 203, 1373364510, 1373373124, 8614, 0, 0, 0),
(285, 204, 1373364510, 1373373125, 8615, 0, 0, 0),
(286, 205, 1373364510, 1373373125, 8615, 0, 0, 0),
(287, 206, 1373364510, 1373373125, 8615, 0, 0, 0),
(288, 207, 1373364510, 1373373125, 8615, 0, 0, 0),
(289, 208, 1373364510, 1373373125, 8615, 0, 0, 0),
(290, 209, 1373364510, 1373373125, 8615, 0, 0, 0),
(291, 210, 1373364510, 1373373126, 8616, 0, 0, 0),
(292, 2, 1373371876, 1373373126, 1250, 0, 0, 0),
(293, 2, 1373374568, 1373375136, 568, 0, 0, 0),
(294, 2, 1373375625, 1373375642, 17, 0, 0, 0),
(295, 10, 1373375789, 1373375814, 25, 0, 0, 0),
(296, 2, 1373375814, 1373375877, 63, 0, 0, 0),
(297, 10, 1373375877, 1373375958, 81, 0, 0, 0),
(298, 2, 1373375999, 1373383481, 7482, 0, 0, 0),
(299, 2, 1373477385, 1373477599, 214, 0, 0, 0),
(300, 10, 1373477600, 1373477985, 385, 0, 0, 0),
(301, 2, 1373494426, 1373494443, 17, 0, 0, 0),
(302, 10, 1373494443, 1373495911, 1468, 0, 0, 0),
(303, 2, 1373498483, 1373498796, 313, 0, 0, 0),
(304, 10, 1373498796, 1373499013, 217, 0, 0, 0),
(305, 10, 1373499016, 1373500125, 1109, 0, 0, 0),
(306, 2, 1373509623, 1373509655, 32, 0, 0, 0),
(307, 2, 1373535102, 1373538295, 3193, 0, 0, 0),
(308, 2, 1373627001, 1373627541, 540, 0, 0, 0),
(309, 212, 1373627405, 1373627667, 262, 0, 0, 0),
(310, 8, 1373627736, 1373628678, 942, 0, 0, 0),
(311, 10, 1373627541, 1373628803, 1262, 0, 0, 0),
(312, 2, 1373629289, 1373629328, 39, 0, 0, 0),
(313, 8, 1373629328, 1373629401, 73, 0, 0, 0),
(314, 3, 1373629402, 1373630984, 1582, 0, 0, 0),
(315, 2, 1373632527, 1373633218, 691, 0, 0, 0),
(316, 10, 1373633218, 1373633396, 178, 0, 0, 0),
(317, 2, 1373633396, 1373653923, 20527, 0, 0, 0),
(318, 10, 1373653923, 1373654590, 667, 0, 0, 0),
(319, 11, 1373509424, 1373654592, 145168, 0, 0, 0),
(320, 12, 1373509424, 1373654592, 145168, 0, 0, 0),
(321, 13, 1373509424, 1373654592, 145168, 0, 0, 0),
(322, 14, 1373509424, 1373654592, 145168, 0, 0, 0),
(323, 15, 1373509424, 1373654593, 145169, 0, 0, 0),
(324, 16, 1373509424, 1373654593, 145169, 0, 0, 0),
(325, 17, 1373509424, 1373654593, 145169, 0, 0, 0),
(326, 18, 1373509424, 1373654593, 145169, 0, 0, 0),
(327, 19, 1373509424, 1373654593, 145169, 0, 0, 0),
(328, 20, 1373509424, 1373654593, 145169, 0, 0, 0),
(329, 21, 1373509424, 1373654594, 145170, 0, 0, 0),
(330, 22, 1373509424, 1373654594, 145170, 0, 0, 0),
(331, 23, 1373509424, 1373654594, 145170, 0, 0, 0),
(332, 24, 1373509424, 1373654594, 145170, 0, 0, 0),
(333, 25, 1373509424, 1373654594, 145170, 0, 0, 0),
(334, 26, 1373509424, 1373654594, 145170, 0, 0, 0),
(335, 27, 1373509424, 1373654595, 145171, 0, 0, 0),
(336, 28, 1373509424, 1373654595, 145171, 0, 0, 0),
(337, 29, 1373509424, 1373654595, 145171, 0, 0, 0),
(338, 30, 1373509424, 1373654595, 145171, 0, 0, 0),
(339, 31, 1373509424, 1373654595, 145171, 0, 0, 0),
(340, 32, 1373509424, 1373654595, 145171, 0, 0, 0),
(341, 33, 1373509424, 1373654595, 145171, 0, 0, 0),
(342, 34, 1373509425, 1373654596, 145171, 0, 0, 0),
(343, 35, 1373509425, 1373654596, 145171, 0, 0, 0),
(344, 36, 1373509425, 1373654596, 145171, 0, 0, 0),
(345, 37, 1373509425, 1373654596, 145171, 0, 0, 0),
(346, 38, 1373509425, 1373654596, 145171, 0, 0, 0),
(347, 39, 1373509425, 1373654597, 145172, 0, 0, 0),
(348, 40, 1373509425, 1373654597, 145172, 0, 0, 0),
(349, 41, 1373509425, 1373654597, 145172, 0, 0, 0),
(350, 42, 1373509425, 1373654597, 145172, 0, 0, 0),
(351, 43, 1373509425, 1373654597, 145172, 0, 0, 0),
(352, 44, 1373509425, 1373654598, 145173, 0, 0, 0),
(353, 45, 1373509425, 1373654598, 145173, 0, 0, 0),
(354, 46, 1373509425, 1373654598, 145173, 0, 0, 0),
(355, 47, 1373509425, 1373654598, 145173, 0, 0, 0),
(356, 48, 1373509425, 1373654598, 145173, 0, 0, 0),
(357, 49, 1373509425, 1373654599, 145174, 0, 0, 0),
(358, 50, 1373509425, 1373654599, 145174, 0, 0, 0),
(359, 51, 1373509425, 1373654599, 145174, 0, 0, 0),
(360, 52, 1373509425, 1373654599, 145174, 0, 0, 0),
(361, 53, 1373509425, 1373654599, 145174, 0, 0, 0),
(362, 54, 1373509425, 1373654599, 145174, 0, 0, 0),
(363, 55, 1373509425, 1373654600, 145175, 0, 0, 0),
(364, 56, 1373509425, 1373654600, 145175, 0, 0, 0),
(365, 57, 1373509425, 1373654600, 145175, 0, 0, 0),
(366, 58, 1373509425, 1373654600, 145175, 0, 0, 0),
(367, 59, 1373509425, 1373654600, 145175, 0, 0, 0),
(368, 60, 1373509425, 1373654601, 145176, 0, 0, 0),
(369, 61, 1373509425, 1373654601, 145176, 0, 0, 0),
(370, 62, 1373509425, 1373654601, 145176, 0, 0, 0),
(371, 63, 1373509426, 1373654601, 145175, 0, 0, 0),
(372, 64, 1373509426, 1373654601, 145175, 0, 0, 0),
(373, 65, 1373509426, 1373654602, 145176, 0, 0, 0),
(374, 66, 1373509426, 1373654602, 145176, 0, 0, 0),
(375, 67, 1373509426, 1373654602, 145176, 0, 0, 0),
(376, 68, 1373509426, 1373654602, 145176, 0, 0, 0),
(377, 69, 1373509426, 1373654602, 145176, 0, 0, 0),
(378, 70, 1373509426, 1373654603, 145177, 0, 0, 0),
(379, 71, 1373509426, 1373654603, 145177, 0, 0, 0),
(380, 72, 1373509426, 1373654603, 145177, 0, 0, 0),
(381, 73, 1373509426, 1373654603, 145177, 0, 0, 0),
(382, 74, 1373509426, 1373654603, 145177, 0, 0, 0),
(383, 75, 1373509426, 1373654603, 145177, 0, 0, 0),
(384, 76, 1373509426, 1373654604, 145178, 0, 0, 0),
(385, 77, 1373509426, 1373654604, 145178, 0, 0, 0),
(386, 78, 1373509426, 1373654604, 145178, 0, 0, 0),
(387, 79, 1373509426, 1373654604, 145178, 0, 0, 0),
(388, 80, 1373509426, 1373654604, 145178, 0, 0, 0),
(389, 81, 1373509426, 1373654604, 145178, 0, 0, 0),
(390, 82, 1373509426, 1373654605, 145179, 0, 0, 0),
(391, 83, 1373509426, 1373654605, 145179, 0, 0, 0),
(392, 84, 1373509426, 1373654605, 145179, 0, 0, 0),
(393, 85, 1373509426, 1373654605, 145179, 0, 0, 0),
(394, 86, 1373509426, 1373654605, 145179, 0, 0, 0),
(395, 87, 1373509426, 1373654605, 145179, 0, 0, 0),
(396, 88, 1373509426, 1373654606, 145180, 0, 0, 0),
(397, 89, 1373509426, 1373654606, 145180, 0, 0, 0),
(398, 90, 1373509426, 1373654606, 145180, 0, 0, 0),
(399, 91, 1373509426, 1373654606, 145180, 0, 0, 0),
(400, 92, 1373509427, 1373654606, 145179, 0, 0, 0),
(401, 93, 1373509427, 1373654607, 145180, 0, 0, 0),
(402, 94, 1373509427, 1373654607, 145180, 0, 0, 0),
(403, 95, 1373509427, 1373654607, 145180, 0, 0, 0),
(404, 96, 1373509427, 1373654607, 145180, 0, 0, 0),
(405, 97, 1373509427, 1373654607, 145180, 0, 0, 0),
(406, 98, 1373509427, 1373654608, 145181, 0, 0, 0),
(407, 99, 1373509427, 1373654608, 145181, 0, 0, 0),
(408, 100, 1373509427, 1373654608, 145181, 0, 0, 0),
(409, 101, 1373509427, 1373654608, 145181, 0, 0, 0),
(410, 102, 1373509427, 1373654608, 145181, 0, 0, 0),
(411, 103, 1373509427, 1373654609, 145182, 0, 0, 0),
(412, 104, 1373509427, 1373654609, 145182, 0, 0, 0),
(413, 105, 1373509427, 1373654609, 145182, 0, 0, 0),
(414, 106, 1373509427, 1373654609, 145182, 0, 0, 0),
(415, 107, 1373509427, 1373654609, 145182, 0, 0, 0),
(416, 108, 1373509427, 1373654609, 145182, 0, 0, 0),
(417, 109, 1373509427, 1373654610, 145183, 0, 0, 0),
(418, 110, 1373509427, 1373654610, 145183, 0, 0, 0),
(419, 111, 1373509427, 1373654610, 145183, 0, 0, 0),
(420, 112, 1373509427, 1373654610, 145183, 0, 0, 0),
(421, 113, 1373509427, 1373654610, 145183, 0, 0, 0),
(422, 114, 1373509427, 1373654611, 145184, 0, 0, 0),
(423, 115, 1373509427, 1373654611, 145184, 0, 0, 0),
(424, 116, 1373509427, 1373654611, 145184, 0, 0, 0),
(425, 117, 1373509427, 1373654611, 145184, 0, 0, 0),
(426, 118, 1373509427, 1373654611, 145184, 0, 0, 0),
(427, 119, 1373509427, 1373654611, 145184, 0, 0, 0),
(428, 120, 1373509427, 1373654612, 145185, 0, 0, 0),
(429, 121, 1373509428, 1373654612, 145184, 0, 0, 0),
(430, 122, 1373509428, 1373654612, 145184, 0, 0, 0),
(431, 123, 1373509428, 1373654612, 145184, 0, 0, 0),
(432, 124, 1373509428, 1373654612, 145184, 0, 0, 0),
(433, 125, 1373509428, 1373654613, 145185, 0, 0, 0),
(434, 126, 1373509428, 1373654613, 145185, 0, 0, 0),
(435, 127, 1373509428, 1373654613, 145185, 0, 0, 0),
(436, 128, 1373509428, 1373654613, 145185, 0, 0, 0),
(437, 129, 1373509428, 1373654613, 145185, 0, 0, 0),
(438, 130, 1373509428, 1373654614, 145186, 0, 0, 0),
(439, 131, 1373509428, 1373654614, 145186, 0, 0, 0),
(440, 132, 1373509428, 1373654614, 145186, 0, 0, 0),
(441, 133, 1373509428, 1373654614, 145186, 0, 0, 0),
(442, 134, 1373509428, 1373654614, 145186, 0, 0, 0),
(443, 135, 1373509428, 1373654614, 145186, 0, 0, 0),
(444, 136, 1373509428, 1373654615, 145187, 0, 0, 0),
(445, 137, 1373509428, 1373654615, 145187, 0, 0, 0),
(446, 138, 1373509428, 1373654615, 145187, 0, 0, 0),
(447, 139, 1373509428, 1373654615, 145187, 0, 0, 0),
(448, 140, 1373509428, 1373654615, 145187, 0, 0, 0),
(449, 141, 1373509428, 1373654615, 145187, 0, 0, 0),
(450, 142, 1373509428, 1373654615, 145187, 0, 0, 0),
(451, 143, 1373509428, 1373654616, 145188, 0, 0, 0),
(452, 144, 1373509428, 1373654616, 145188, 0, 0, 0),
(453, 145, 1373509428, 1373654616, 145188, 0, 0, 0),
(454, 146, 1373509428, 1373654616, 145188, 0, 0, 0),
(455, 147, 1373509428, 1373654616, 145188, 0, 0, 0),
(456, 148, 1373509428, 1373654617, 145189, 0, 0, 0),
(457, 149, 1373509429, 1373654617, 145188, 0, 0, 0),
(458, 150, 1373509429, 1373654617, 145188, 0, 0, 0),
(459, 151, 1373509429, 1373654617, 145188, 0, 0, 0),
(460, 152, 1373509429, 1373654617, 145188, 0, 0, 0),
(461, 153, 1373509429, 1373654617, 145188, 0, 0, 0),
(462, 154, 1373509429, 1373654618, 145189, 0, 0, 0),
(463, 155, 1373509429, 1373654618, 145189, 0, 0, 0),
(464, 156, 1373509429, 1373654618, 145189, 0, 0, 0),
(465, 157, 1373509429, 1373654618, 145189, 0, 0, 0),
(466, 158, 1373509429, 1373654618, 145189, 0, 0, 0),
(467, 159, 1373509429, 1373654619, 145190, 0, 0, 0),
(468, 160, 1373509429, 1373654619, 145190, 0, 0, 0),
(469, 161, 1373509429, 1373654619, 145190, 0, 0, 0),
(470, 162, 1373509429, 1373654619, 145190, 0, 0, 0),
(471, 163, 1373509429, 1373654619, 145190, 0, 0, 0),
(472, 164, 1373509429, 1373654619, 145190, 0, 0, 0),
(473, 165, 1373509429, 1373654620, 145191, 0, 0, 0),
(474, 166, 1373509429, 1373654620, 145191, 0, 0, 0),
(475, 167, 1373509429, 1373654620, 145191, 0, 0, 0),
(476, 168, 1373509429, 1373654620, 145191, 0, 0, 0),
(477, 169, 1373509429, 1373654620, 145191, 0, 0, 0),
(478, 170, 1373509429, 1373654620, 145191, 0, 0, 0),
(479, 171, 1373509429, 1373654620, 145191, 0, 0, 0),
(480, 172, 1373509429, 1373654621, 145192, 0, 0, 0),
(481, 173, 1373509429, 1373654621, 145192, 0, 0, 0),
(482, 174, 1373509429, 1373654621, 145192, 0, 0, 0),
(483, 175, 1373509429, 1373654621, 145192, 0, 0, 0),
(484, 176, 1373509429, 1373654621, 145192, 0, 0, 0),
(485, 177, 1373509429, 1373654622, 145193, 0, 0, 0),
(486, 178, 1373509430, 1373654622, 145192, 0, 0, 0),
(487, 179, 1373509430, 1373654622, 145192, 0, 0, 0),
(488, 180, 1373509430, 1373654622, 145192, 0, 0, 0),
(489, 181, 1373509430, 1373654622, 145192, 0, 0, 0),
(490, 182, 1373509430, 1373654623, 145193, 0, 0, 0),
(491, 183, 1373509430, 1373654623, 145193, 0, 0, 0),
(492, 184, 1373509430, 1373654623, 145193, 0, 0, 0),
(493, 185, 1373509430, 1373654624, 145194, 0, 0, 0),
(494, 186, 1373509430, 1373654624, 145194, 0, 0, 0),
(495, 187, 1373509430, 1373654624, 145194, 0, 0, 0),
(496, 188, 1373509430, 1373654624, 145194, 0, 0, 0),
(497, 189, 1373509430, 1373654624, 145194, 0, 0, 0),
(498, 190, 1373509430, 1373654625, 145195, 0, 0, 0),
(499, 191, 1373509430, 1373654625, 145195, 0, 0, 0),
(500, 192, 1373509430, 1373654625, 145195, 0, 0, 0),
(501, 193, 1373509430, 1373654625, 145195, 0, 0, 0),
(502, 194, 1373509430, 1373654625, 145195, 0, 0, 0),
(503, 195, 1373509430, 1373654625, 145195, 0, 0, 0),
(504, 196, 1373509430, 1373654626, 145196, 0, 0, 0),
(505, 197, 1373509430, 1373654626, 145196, 0, 0, 0),
(506, 198, 1373509430, 1373654626, 145196, 0, 0, 0),
(507, 199, 1373509430, 1373654626, 145196, 0, 0, 0),
(508, 200, 1373509430, 1373654626, 145196, 0, 0, 0),
(509, 201, 1373509430, 1373654626, 145196, 0, 0, 0),
(510, 202, 1373509430, 1373654627, 145197, 0, 0, 0),
(511, 203, 1373509430, 1373654627, 145197, 0, 0, 0),
(512, 204, 1373509430, 1373654627, 145197, 0, 0, 0),
(513, 205, 1373509431, 1373654627, 145196, 0, 0, 0),
(514, 206, 1373509431, 1373654627, 145196, 0, 0, 0),
(515, 207, 1373509431, 1373654627, 145196, 0, 0, 0),
(516, 208, 1373509431, 1373654627, 145196, 0, 0, 0),
(517, 209, 1373509431, 1373654628, 145197, 0, 0, 0),
(518, 210, 1373509431, 1373654628, 145197, 0, 0, 0),
(519, 2, 1373654590, 1373654628, 38, 0, 0, 0),
(520, 10, 1373655145, 1373655681, 536, 0, 0, 0),
(521, 2, 1373656898, 1373656910, 12, 0, 0, 0),
(522, 10, 1373656910, 1373657907, 997, 0, 0, 0),
(523, 212, 1373659353, 1373659459, 106, 0, 0, 0),
(524, 10, 1373662572, 1373662939, 367, 0, 0, 0),
(525, 2, 1373662940, 1373664122, 1182, 0, 0, 0),
(526, 10, 1373664122, 1373664161, 39, 0, 0, 0),
(527, 2, 1373664161, 1373670174, 6013, 0, 0, 0),
(528, 2, 1373715390, 1373718671, 3281, 0, 0, 0),
(529, 10, 1373718671, 1373718682, 11, 0, 0, 0),
(530, 2, 1373718682, 1373722040, 3358, 0, 0, 0),
(531, 10, 1373795818, 1373795940, 122, 0, 0, 0),
(532, 2, 1373795941, 1373796029, 88, 0, 0, 0),
(533, 2, 1373796033, 1373796120, 87, 0, 0, 0),
(534, 10, 1373796121, 1373796386, 265, 0, 0, 0),
(535, 2, 1373796386, 1373796416, 30, 0, 0, 0),
(536, 2, 1373796417, 1373798163, 1746, 0, 0, 0),
(537, 2, 1373798164, 1373798420, 256, 0, 0, 0),
(538, 10, 1373798420, 1373798477, 57, 0, 0, 0),
(539, 10, 1373798484, 1373798649, 165, 0, 0, 0),
(540, 8, 1373798656, 1373798697, 41, 0, 0, 0),
(541, 8, 1373798705, 1373798780, 75, 0, 0, 0),
(542, 8, 1373798785, 1373798857, 72, 0, 0, 0),
(543, 2, 1373798858, 1373799056, 198, 0, 0, 0),
(544, 8, 1373799062, 1373799324, 262, 0, 0, 0),
(545, 2, 1373799324, 1373799338, 14, 0, 0, 0),
(546, 8, 1373799339, 1373799369, 30, 0, 0, 0),
(547, 2, 1373799369, 1373799393, 24, 0, 0, 0),
(548, 8, 1373799393, 1373799689, 296, 0, 0, 0),
(549, 8, 1373799694, 1373799893, 199, 0, 0, 0),
(550, 10, 1373799895, 1373800022, 127, 0, 0, 0),
(551, 10, 1373800027, 1373800954, 927, 0, 0, 0),
(552, 10, 1373802408, 1373802444, 36, 0, 0, 0),
(553, 2, 1373802445, 1373802551, 106, 0, 0, 0),
(554, 10, 1373802551, 1373802594, 43, 0, 0, 0),
(555, 10, 1373802600, 1373802715, 115, 0, 0, 0),
(556, 9, 1373802716, 1373802867, 151, 0, 0, 0),
(557, 2, 1373802868, 1373803209, 341, 0, 0, 0),
(558, 3, 1373803209, 1373803387, 178, 0, 0, 0),
(559, 3, 1373803669, 1373803694, 25, 0, 0, 0),
(560, 2, 1373803694, 1373803826, 132, 0, 0, 0),
(561, 3, 1373803827, 1373803899, 72, 0, 0, 0),
(562, 2, 1373803899, 1373805057, 1158, 0, 0, 0),
(563, 214, 1373803664, 1373805083, 1419, 0, 0, 0),
(564, 10, 1373805486, 1373805813, 327, 0, 0, 0),
(565, 11, 1373803648, 1373805870, 2222, 0, 0, 0),
(566, 12, 1373803648, 1373805870, 2222, 0, 0, 0),
(567, 13, 1373803648, 1373805870, 2222, 0, 0, 0),
(568, 14, 1373803648, 1373805870, 2222, 0, 0, 0),
(569, 15, 1373803648, 1373805870, 2222, 0, 0, 0),
(570, 16, 1373803648, 1373805871, 2223, 0, 0, 0),
(571, 17, 1373803648, 1373805871, 2223, 0, 0, 0),
(572, 18, 1373803648, 1373805871, 2223, 0, 0, 0),
(573, 19, 1373803648, 1373805871, 2223, 0, 0, 0),
(574, 20, 1373803649, 1373805871, 2222, 0, 0, 0),
(575, 21, 1373803649, 1373805871, 2222, 0, 0, 0),
(576, 22, 1373803649, 1373805871, 2222, 0, 0, 0),
(577, 23, 1373803649, 1373805871, 2222, 0, 0, 0),
(578, 24, 1373803649, 1373805872, 2223, 0, 0, 0),
(579, 25, 1373803649, 1373805872, 2223, 0, 0, 0),
(580, 26, 1373803649, 1373805872, 2223, 0, 0, 0),
(581, 27, 1373803649, 1373805872, 2223, 0, 0, 0),
(582, 28, 1373803649, 1373805872, 2223, 0, 0, 0),
(583, 29, 1373803649, 1373805872, 2223, 0, 0, 0),
(584, 30, 1373803649, 1373805873, 2224, 0, 0, 0),
(585, 31, 1373803649, 1373805873, 2224, 0, 0, 0),
(586, 32, 1373803649, 1373805873, 2224, 0, 0, 0),
(587, 33, 1373803649, 1373805873, 2224, 0, 0, 0),
(588, 34, 1373803649, 1373805873, 2224, 0, 0, 0),
(589, 35, 1373803649, 1373805873, 2224, 0, 0, 0),
(590, 36, 1373803649, 1373805873, 2224, 0, 0, 0),
(591, 37, 1373803649, 1373805874, 2225, 0, 0, 0),
(592, 38, 1373803649, 1373805874, 2225, 0, 0, 0),
(593, 39, 1373803649, 1373805874, 2225, 0, 0, 0),
(594, 40, 1373803649, 1373805874, 2225, 0, 0, 0),
(595, 41, 1373803649, 1373805874, 2225, 0, 0, 0),
(596, 42, 1373803649, 1373805875, 2226, 0, 0, 0),
(597, 43, 1373803649, 1373805875, 2226, 0, 0, 0),
(598, 44, 1373803649, 1373805875, 2226, 0, 0, 0),
(599, 45, 1373803649, 1373805875, 2226, 0, 0, 0),
(600, 46, 1373803649, 1373805875, 2226, 0, 0, 0),
(601, 47, 1373803649, 1373805875, 2226, 0, 0, 0),
(602, 48, 1373803649, 1373805875, 2226, 0, 0, 0),
(603, 49, 1373803650, 1373805876, 2226, 0, 0, 0),
(604, 50, 1373803650, 1373805876, 2226, 0, 0, 0),
(605, 51, 1373803650, 1373805876, 2226, 0, 0, 0),
(606, 52, 1373803650, 1373805876, 2226, 0, 0, 0),
(607, 53, 1373803650, 1373805876, 2226, 0, 0, 0),
(608, 54, 1373803650, 1373805876, 2226, 0, 0, 0),
(609, 55, 1373803650, 1373805876, 2226, 0, 0, 0),
(610, 56, 1373803650, 1373805877, 2227, 0, 0, 0),
(611, 57, 1373803650, 1373805877, 2227, 0, 0, 0),
(612, 58, 1373803650, 1373805877, 2227, 0, 0, 0),
(613, 59, 1373803650, 1373805877, 2227, 0, 0, 0),
(614, 60, 1373803650, 1373805877, 2227, 0, 0, 0),
(615, 61, 1373803650, 1373805877, 2227, 0, 0, 0),
(616, 62, 1373803650, 1373805877, 2227, 0, 0, 0),
(617, 63, 1373803650, 1373805878, 2228, 0, 0, 0),
(618, 64, 1373803650, 1373805878, 2228, 0, 0, 0),
(619, 65, 1373803650, 1373805878, 2228, 0, 0, 0),
(620, 66, 1373803650, 1373805878, 2228, 0, 0, 0),
(621, 67, 1373803650, 1373805878, 2228, 0, 0, 0),
(622, 68, 1373803650, 1373805878, 2228, 0, 0, 0),
(623, 69, 1373803650, 1373805878, 2228, 0, 0, 0),
(624, 70, 1373803650, 1373805879, 2229, 0, 0, 0),
(625, 71, 1373803650, 1373805879, 2229, 0, 0, 0),
(626, 72, 1373803650, 1373805879, 2229, 0, 0, 0),
(627, 73, 1373803650, 1373805879, 2229, 0, 0, 0),
(628, 74, 1373803650, 1373805879, 2229, 0, 0, 0),
(629, 75, 1373803650, 1373805879, 2229, 0, 0, 0),
(630, 76, 1373803650, 1373805879, 2229, 0, 0, 0),
(631, 77, 1373803651, 1373805879, 2228, 0, 0, 0),
(632, 78, 1373803651, 1373805880, 2229, 0, 0, 0),
(633, 79, 1373803651, 1373805880, 2229, 0, 0, 0),
(634, 80, 1373803651, 1373805880, 2229, 0, 0, 0),
(635, 81, 1373803651, 1373805880, 2229, 0, 0, 0),
(636, 82, 1373803651, 1373805880, 2229, 0, 0, 0),
(637, 83, 1373803651, 1373805880, 2229, 0, 0, 0),
(638, 84, 1373803651, 1373805880, 2229, 0, 0, 0),
(639, 85, 1373803651, 1373805881, 2230, 0, 0, 0),
(640, 86, 1373803651, 1373805881, 2230, 0, 0, 0),
(641, 87, 1373803651, 1373805881, 2230, 0, 0, 0),
(642, 88, 1373803651, 1373805881, 2230, 0, 0, 0),
(643, 89, 1373803651, 1373805881, 2230, 0, 0, 0),
(644, 90, 1373803651, 1373805881, 2230, 0, 0, 0),
(645, 91, 1373803651, 1373805882, 2231, 0, 0, 0),
(646, 92, 1373803651, 1373805882, 2231, 0, 0, 0),
(647, 93, 1373803651, 1373805882, 2231, 0, 0, 0),
(648, 94, 1373803651, 1373805882, 2231, 0, 0, 0),
(649, 95, 1373803651, 1373805882, 2231, 0, 0, 0),
(650, 96, 1373803651, 1373805882, 2231, 0, 0, 0),
(651, 97, 1373803651, 1373805883, 2232, 0, 0, 0),
(652, 98, 1373803651, 1373805883, 2232, 0, 0, 0),
(653, 99, 1373803651, 1373805883, 2232, 0, 0, 0),
(654, 100, 1373803651, 1373805886, 2235, 0, 0, 0),
(655, 101, 1373803651, 1373805886, 2235, 0, 0, 0),
(656, 102, 1373803651, 1373805886, 2235, 0, 0, 0),
(657, 103, 1373803651, 1373805886, 2235, 0, 0, 0),
(658, 104, 1373803651, 1373805887, 2236, 0, 0, 0),
(659, 105, 1373803651, 1373805887, 2236, 0, 0, 0),
(660, 106, 1373803652, 1373805887, 2235, 0, 0, 0),
(661, 107, 1373803652, 1373805887, 2235, 0, 0, 0),
(662, 108, 1373803652, 1373805887, 2235, 0, 0, 0),
(663, 109, 1373803652, 1373805887, 2235, 0, 0, 0),
(664, 110, 1373803652, 1373805887, 2235, 0, 0, 0),
(665, 111, 1373803652, 1373805888, 2236, 0, 0, 0),
(666, 112, 1373803652, 1373805888, 2236, 0, 0, 0),
(667, 113, 1373803652, 1373805888, 2236, 0, 0, 0),
(668, 114, 1373803652, 1373805888, 2236, 0, 0, 0),
(669, 115, 1373803652, 1373805888, 2236, 0, 0, 0),
(670, 116, 1373803652, 1373805889, 2237, 0, 0, 0),
(671, 117, 1373803652, 1373805889, 2237, 0, 0, 0),
(672, 118, 1373803652, 1373805889, 2237, 0, 0, 0),
(673, 119, 1373803652, 1373805889, 2237, 0, 0, 0),
(674, 120, 1373803652, 1373805889, 2237, 0, 0, 0),
(675, 121, 1373803652, 1373805889, 2237, 0, 0, 0),
(676, 122, 1373803652, 1373805890, 2238, 0, 0, 0),
(677, 123, 1373803652, 1373805890, 2238, 0, 0, 0),
(678, 124, 1373803652, 1373805890, 2238, 0, 0, 0),
(679, 125, 1373803652, 1373805890, 2238, 0, 0, 0),
(680, 126, 1373803652, 1373805890, 2238, 0, 0, 0),
(681, 127, 1373803652, 1373805890, 2238, 0, 0, 0),
(682, 128, 1373803652, 1373805891, 2239, 0, 0, 0),
(683, 129, 1373803652, 1373805891, 2239, 0, 0, 0),
(684, 130, 1373803652, 1373805891, 2239, 0, 0, 0),
(685, 131, 1373803652, 1373805891, 2239, 0, 0, 0),
(686, 132, 1373803652, 1373805891, 2239, 0, 0, 0),
(687, 133, 1373803652, 1373805891, 2239, 0, 0, 0),
(688, 134, 1373803652, 1373805892, 2240, 0, 0, 0),
(689, 135, 1373803652, 1373805892, 2240, 0, 0, 0),
(690, 136, 1373803653, 1373805892, 2239, 0, 0, 0),
(691, 137, 1373803653, 1373805892, 2239, 0, 0, 0),
(692, 138, 1373803653, 1373805892, 2239, 0, 0, 0),
(693, 139, 1373803653, 1373805892, 2239, 0, 0, 0),
(694, 140, 1373803653, 1373805893, 2240, 0, 0, 0),
(695, 141, 1373803653, 1373805893, 2240, 0, 0, 0),
(696, 142, 1373803653, 1373805893, 2240, 0, 0, 0),
(697, 143, 1373803653, 1373805893, 2240, 0, 0, 0),
(698, 144, 1373803653, 1373805893, 2240, 0, 0, 0),
(699, 145, 1373803653, 1373805894, 2241, 0, 0, 0),
(700, 146, 1373803653, 1373805894, 2241, 0, 0, 0),
(701, 147, 1373803653, 1373805894, 2241, 0, 0, 0),
(702, 148, 1373803653, 1373805894, 2241, 0, 0, 0),
(703, 149, 1373803653, 1373805894, 2241, 0, 0, 0),
(704, 150, 1373803653, 1373805894, 2241, 0, 0, 0),
(705, 151, 1373803653, 1373805895, 2242, 0, 0, 0),
(706, 152, 1373803653, 1373805895, 2242, 0, 0, 0),
(707, 153, 1373803653, 1373805895, 2242, 0, 0, 0),
(708, 154, 1373803653, 1373805895, 2242, 0, 0, 0),
(709, 155, 1373803653, 1373805895, 2242, 0, 0, 0),
(710, 156, 1373803653, 1373805896, 2243, 0, 0, 0),
(711, 157, 1373803653, 1373805896, 2243, 0, 0, 0),
(712, 158, 1373803653, 1373805896, 2243, 0, 0, 0),
(713, 159, 1373803653, 1373805896, 2243, 0, 0, 0),
(714, 160, 1373803653, 1373805896, 2243, 0, 0, 0),
(715, 161, 1373803653, 1373805896, 2243, 0, 0, 0),
(716, 162, 1373803653, 1373805897, 2244, 0, 0, 0),
(717, 163, 1373803653, 1373805897, 2244, 0, 0, 0),
(718, 164, 1373803653, 1373805897, 2244, 0, 0, 0),
(719, 165, 1373803654, 1373805897, 2243, 0, 0, 0),
(720, 166, 1373803654, 1373805897, 2243, 0, 0, 0),
(721, 167, 1373803654, 1373805898, 2244, 0, 0, 0),
(722, 168, 1373803654, 1373805898, 2244, 0, 0, 0),
(723, 169, 1373803654, 1373805898, 2244, 0, 0, 0),
(724, 170, 1373803654, 1373805898, 2244, 0, 0, 0),
(725, 171, 1373803654, 1373805898, 2244, 0, 0, 0),
(726, 172, 1373803654, 1373805898, 2244, 0, 0, 0),
(727, 173, 1373803654, 1373805898, 2244, 0, 0, 0),
(728, 174, 1373803654, 1373805899, 2245, 0, 0, 0),
(729, 175, 1373803654, 1373805899, 2245, 0, 0, 0),
(730, 176, 1373803654, 1373805899, 2245, 0, 0, 0),
(731, 177, 1373803654, 1373805899, 2245, 0, 0, 0),
(732, 178, 1373803654, 1373805899, 2245, 0, 0, 0),
(733, 179, 1373803654, 1373805899, 2245, 0, 0, 0),
(734, 180, 1373803654, 1373805900, 2246, 0, 0, 0),
(735, 181, 1373803654, 1373805900, 2246, 0, 0, 0),
(736, 182, 1373803654, 1373805900, 2246, 0, 0, 0),
(737, 183, 1373803654, 1373805900, 2246, 0, 0, 0),
(738, 184, 1373803654, 1373805900, 2246, 0, 0, 0),
(739, 185, 1373803654, 1373805901, 2247, 0, 0, 0),
(740, 186, 1373803654, 1373805901, 2247, 0, 0, 0),
(741, 187, 1373803654, 1373805901, 2247, 0, 0, 0),
(742, 188, 1373803654, 1373805901, 2247, 0, 0, 0),
(743, 189, 1373803654, 1373805901, 2247, 0, 0, 0),
(744, 190, 1373803654, 1373805901, 2247, 0, 0, 0),
(745, 191, 1373803654, 1373805902, 2248, 0, 0, 0),
(746, 192, 1373803654, 1373805902, 2248, 0, 0, 0),
(747, 193, 1373803654, 1373805902, 2248, 0, 0, 0),
(748, 194, 1373803654, 1373805902, 2248, 0, 0, 0),
(749, 195, 1373803655, 1373805902, 2247, 0, 0, 0),
(750, 196, 1373803655, 1373805903, 2248, 0, 0, 0),
(751, 197, 1373803655, 1373805903, 2248, 0, 0, 0),
(752, 198, 1373803655, 1373805903, 2248, 0, 0, 0),
(753, 199, 1373803655, 1373805903, 2248, 0, 0, 0),
(754, 200, 1373803655, 1373805903, 2248, 0, 0, 0),
(755, 201, 1373803655, 1373805903, 2248, 0, 0, 0),
(756, 202, 1373803655, 1373805904, 2249, 0, 0, 0),
(757, 203, 1373803655, 1373805904, 2249, 0, 0, 0),
(758, 204, 1373803655, 1373805904, 2249, 0, 0, 0),
(759, 205, 1373803655, 1373805904, 2249, 0, 0, 0),
(760, 206, 1373803655, 1373805904, 2249, 0, 0, 0),
(761, 207, 1373803655, 1373805904, 2249, 0, 0, 0),
(762, 208, 1373803655, 1373805905, 2250, 0, 0, 0),
(763, 209, 1373803655, 1373805905, 2250, 0, 0, 0),
(764, 210, 1373803655, 1373805905, 2250, 0, 0, 0),
(765, 2, 1373805284, 1373805905, 621, 0, 0, 0),
(766, 10, 1373805822, 1373805905, 83, 0, 0, 0),
(767, 2, 1373806129, 1373806629, 500, 0, 0, 0),
(768, 10, 1373806129, 1373806697, 568, 0, 0, 0),
(769, 2, 1373811009, 1373812104, 1095, 0, 0, 0),
(770, 214, 1373876801, 1373876825, 24, 0, 0, 0),
(771, 10, 1373876833, 1373876846, 13, 0, 0, 0),
(772, 9, 1373876846, 1373876861, 15, 0, 0, 0),
(773, 10, 1373876874, 1373876896, 22, 0, 0, 0),
(774, 2, 1373878113, 1373878124, 11, 0, 0, 0),
(775, 9, 1373878125, 1373879358, 1233, 0, 0, 0),
(776, 2, 1373906413, 1373906429, 16, 0, 0, 0),
(777, 10, 1373906429, 1373907430, 1001, 0, 0, 0),
(778, 2, 1373911568, 1373912091, 523, 0, 0, 0),
(779, 212, 1373924383, 1373925253, 870, 0, 0, 0),
(780, 3, 1373925929, 1373926077, 148, 0, 0, 0),
(781, 2, 1373926095, 1373926137, 42, 0, 0, 0),
(782, 3, 1373926137, 1373926160, 23, 0, 0, 0),
(783, 212, 1373926212, 1373926232, 20, 0, 0, 0),
(784, 10, 1373926160, 1373926329, 169, 0, 0, 0),
(785, 10, 1373926335, 1373926591, 256, 0, 0, 0),
(786, 2, 1373926592, 1373926631, 39, 0, 0, 0),
(787, 9, 1373965162, 1373965360, 198, 0, 0, 0),
(788, 2, 1373965162, 1373965427, 265, 0, 0, 0),
(789, 9, 1373965366, 1373965641, 275, 0, 0, 0),
(790, 9, 1373965641, 1373966569, 928, 0, 0, 0),
(791, 2, 1373965427, 1373967419, 1992, 0, 0, 0),
(792, 10, 1373967428, 1373967446, 18, 0, 0, 0),
(793, 9, 1373967446, 1373967458, 12, 0, 0, 0),
(794, 9, 1373967471, 1373968861, 1390, 0, 0, 0),
(795, 9, 1373968888, 1373969799, 911, 0, 0, 0),
(796, 2, 1373971249, 1373972388, 1139, 0, 0, 0),
(797, 2, 1373972398, 1373972436, 38, 0, 0, 0),
(798, 2, 1373972437, 1373972474, 37, 0, 0, 0),
(799, 2, 1373972474, 1373972509, 35, 0, 0, 0),
(800, 2, 1373972510, 1373972618, 108, 0, 0, 0),
(801, 2, 1373972692, 1373972704, 12, 0, 0, 0),
(802, 10, 1373972714, 1373972731, 17, 0, 0, 0),
(803, 2, 1373972731, 1373972758, 27, 0, 0, 0),
(804, 9, 1373972758, 1373972800, 42, 0, 0, 0),
(805, 2, 1373972801, 1373972817, 16, 0, 0, 0),
(806, 9, 1373972820, 1373972885, 65, 0, 0, 0),
(807, 9, 1373972892, 1373972916, 24, 0, 0, 0),
(808, 2, 1373972916, 1373973894, 978, 0, 0, 0),
(809, 214, 1373973894, 1373975012, 1118, 0, 0, 0),
(810, 2, 1373988556, 1373989131, 575, 0, 0, 0),
(811, 214, 1373992602, 1373993566, 964, 0, 0, 0);

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_news`
--

CREATE TABLE IF NOT EXISTS `zotsme_news` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `date` int(11) NOT NULL,
  `image_url` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `text` text NOT NULL,
  `author` varchar(255) NOT NULL,
  `lang` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `date` (`date`,`lang`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=2 ;

--
-- Zrzut danych tabeli `zotsme_news`
--

INSERT INTO `zotsme_news` (`id`, `date`, `image_url`, `title`, `text`, `author`, `lang`) VALUES
(1, 1373636515, '', 'Start', 'Mmmmmm\r\nMmmmmm\r\nMmmmmm', 'Admin', 'en');

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_ots_communication`
--

CREATE TABLE IF NOT EXISTS `zotsme_ots_communication` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tid` int(11) NOT NULL,
  `player_id` int(11) NOT NULL,
  `name` text NOT NULL,
  `item` int(11) NOT NULL,
  `item_count` int(11) NOT NULL,
  `item_attributes` text NOT NULL,
  `container` int(11) NOT NULL,
  `container_items_count` int(11) NOT NULL,
  `container_attributes` text NOT NULL,
  `lua_execute` text NOT NULL,
  `storages` text NOT NULL,
  `addons` text NOT NULL,
  `custom_parameters` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=11 ;

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_shop_offer`
--

CREATE TABLE IF NOT EXISTS `zotsme_shop_offer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `active` int(1) NOT NULL DEFAULT '1',
  `lp` int(11) NOT NULL,
  `type` int(11) NOT NULL DEFAULT '0',
  `category` int(11) NOT NULL DEFAULT '0',
  `points` int(11) NOT NULL DEFAULT '0',
  `offers` int(11) NOT NULL DEFAULT '1000000',
  `name` text NOT NULL,
  `description` text NOT NULL,
  `image` varchar(255) NOT NULL,
  `item` int(11) NOT NULL DEFAULT '0',
  `item_count` int(11) NOT NULL DEFAULT '0',
  `container` int(11) NOT NULL DEFAULT '0',
  `container_items_count` int(11) NOT NULL DEFAULT '0',
  `item_attributes` text NOT NULL,
  `container_attributes` text NOT NULL,
  `lua_execute` text NOT NULL,
  `storages` text NOT NULL,
  `addons` text NOT NULL,
  `custom_parameters` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `active` (`active`),
  KEY `type` (`type`),
  KEY `lp` (`lp`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=405 ;

--
-- Zrzut danych tabeli `zotsme_shop_offer`
--

INSERT INTO `zotsme_shop_offer` (`id`, `active`, `lp`, `type`, `category`, `points`, `offers`, `name`, `description`, `image`, `item`, `item_count`, `container`, `container_items_count`, `item_attributes`, `container_attributes`, `lua_execute`, `storages`, `addons`, `custom_parameters`) VALUES
(1, 1, 1, 1, 2, 40, 1000000, 'Addon Doll', '<b>Buy 1 addon to 1 outfit.</b> How to use:<br />\r\n<b>1. Choose in game outfit for which you want get addon:</b><br />\r\n<img src="http://img.thaiswar.net/static/images/addondoll1.png" alt="get addon first step" /><br />\r\n<b>2. Say <span style="color:red">!addon 1</span> or <span style="color:red">!addon 2</span></b> to get first or second addon:<br />\r\n<img src="http://img.thaiswar.net/static/images/addondoll2.png" alt="get addon first step" />', '', 8985, 1, 0, 0, '', '', '', '', '', ''),
(2, 1, 2, 1, 2, 50, 1000000, 'Demon outfit', 'You see <b>demons'' stuffed dragon</b>. Use it to get Demon outfit. Short instruction:<br /><img src="http://img.thaiswar.net/static/images/demonaddon.png" alt="how to get demon outfit"/>', '', 5791, 1, 0, 0, '', '', '', '', '', ''),
(4, 1, 4, 4, 3, 100, 1000000, 'Change Name Of Your Character', 'You can also give <b>change name</b> to your friend. Just type his name in <b>To player</b> form. Then he must login on website and type new name of his character in <b>Transactions History</b>.', 'changenick.png', 0, 0, 0, 0, '', '', '', '', '', ''),
(28, 1, 28, 1, 0, 100, 1000000, 'Thunder Hammer', 'You see a thunder hammer (Atk:50 physical + 15 fire,Def:45) that has energy for 600 minutes left. It is blessed by the gods of Tibia. [10 Hours item]', '', 2421, 0, 0, 0, '', '', '', '', '', ''),
(29, 1, 29, 1, 0, 100, 1000000, 'Great Axe', 'You see a great axe (Atk:50 physical + 15 fire,Def:45) that has energy for 600 minutes left. A masterpiece of a dwarven smith. [10 Hours item]', '', 2415, 0, 0, 0, '', '', '', '', '', ''),
(30, 1, 30, 1, 0, 100, 1000000, 'Magic Longsword', 'You see a magic longsword (Atk:50 physical + 15 fire,Def:45) that has energy for 600 minutes left. It is the magic Cyclopmania Sword. [10 Hours item]', '', 2390, 0, 0, 0, '', '', '', '', '', ''),
(31, 1, 31, 1, 0, 100, 1000000, 'Star Shoter', 'You see the star shoter that has energy for 600 minutes left. This holy wand radiates huge ammount of light. [10 Hours item]', '', 7735, 0, 0, 0, '', '', '', '', '', ''),
(32, 1, 32, 1, 0, 100, 1000000, 'Great Shield', 'You see a great shield (Def:50) that has energy for 600 minutes left. The shield is made of dragon scales. [10 Hours item]', '', 2522, 0, 0, 0, '', '', '', '', '', ''),
(33, 1, 33, 1, 0, 100, 1000000, 'Rose Shield', 'You see a rose shield (Def:80) that has energy for 600 minutes left. It can only be wielded properly by royal paladins and elite knights. [10 Hours item]', '', 2527, 0, 0, 0, '', '', '', '', '', ''),
(34, 1, 0, 1, 1, 20, 1000000, '100x Super SD rune', 'You see 100 Super SD runes. Their damage is ~15% higher then normal SD. They are good to get much exp for you when you are killing someone trapped.', '', 2263, 100, 0, 0, '', '', '', '', '', ''),
(35, 1, 0, 1, 0, 80, 1000000, '100x Viper Star', 'You see 100 viper stars (Atk:66). The best weapon for paladins. 100 viper stars should be enough for few hours of shooting (~5000 shots).', '', 7366, 100, 0, 0, '', '', '', '', '', ''),
(36, 1, 0, 1, 0, 20, 1000000, '100x Assassin Star', 'You see 100 assassin stars (Atk:55). Very good weapon for paladins. 100 assassin stars should be enough for few hours of shooting (~5000 shots).', '', 7368, 100, 0, 0, '', '', '', '', '', ''),
(38, 1, 0, 1, 0, 80, 1000000, 'Backpack (20x) of Ice Rapiers', 'You see an ice rapier (Atk:60 physical + 20 ice,Def:1) that has <b>5 charges left</b>. A deadly but fragile weapon.', '', 2396, 5, 2002, 20, '', '', '', '', '', ''),
(39, 1, 0, 1, 0, 10, 1000000, 'Experience Book', 'You see a exp book. Use it to get 5 levels. Works only if your level is lower then 90.', '', 6108, 0, 0, 0, '', '', '', '', '', ''),
(100, 1, 100, 1, 0, 100, 1000000, 'Donation Glacier Amulet', 'You see a donation glacier amulet (protection energy +5%,ice +20%) that has 5000 charge left.', '', 7888, 5000, 0, 0, '', '', '', '', '', ''),
(101, 1, 101, 1, 0, 100, 1000000, 'Donation Glacier Mask', 'You see a donation glacier mask (Arm:20,protection energy +5%,ice +10%) that has energy for 600 minutes left. [10 Hours item]', '', 7902, 0, 0, 0, '', '', '', '', '', ''),
(102, 1, 102, 1, 0, 100, 1000000, 'Donation Glacier Robe', 'You see a donation glacier robe (Arm:20,protection energy +5%,ice +10%) that has energy for 600 minutes left. [10 Hours item]', '', 7897, 0, 0, 0, '', '', '', '', '', ''),
(103, 1, 103, 1, 0, 100, 1000000, 'Donation Glacier Kilt', 'You see donation glacier kilt (Arm:20,protection energy +5%,ice +10%) that has energy for 600 minutes left. [10 Hours item]', '', 7896, 0, 0, 0, '', '', '', '', '', ''),
(104, 1, 104, 1, 0, 100, 1000000, 'Donation Glacier Shoes', 'You see donation glacier shoes (Arm:20,protection energy +5%,ice +10%,speed +30) that has energy for 600 minutes left. [10 Hours item]', '', 7892, 0, 0, 0, '', '', '', '', '', ''),
(200, 1, 200, 1, 0, 100, 1000000, 'Donation Lightning Pendant', 'You see a donation lightning pendant (protection energy +20%,earth +5%) that has 5000 charge left.', '', 7889, 5000, 0, 0, '', '', '', '', '', ''),
(201, 1, 201, 1, 0, 100, 1000000, 'Donation Lightning Headband', 'You see a donation lightning headband (Arm:20,protection energy +10%,earth +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7901, 0, 0, 0, '', '', '', '', '', ''),
(202, 1, 202, 1, 0, 100, 1000000, 'Donation Lightning Robe', 'You see a donation lightning robe (Arm:20,protection energy +10%,earth +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7898, 0, 0, 0, '', '', '', '', '', ''),
(203, 1, 203, 1, 0, 100, 1000000, 'Donation Lightning Legs', 'You see donation lightning legs (Arm:20,protection energy +10%,earth +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7895, 0, 0, 0, '', '', '', '', '', ''),
(204, 1, 204, 1, 0, 100, 1000000, 'Donation Lightning Boots', 'You see donation lightning boots (Arm:20,protection energy +10%,earth +5%,speed +30) that has energy for 600 minutes left. [10 Hours item]', '', 7893, 0, 0, 0, '', '', '', '', '', ''),
(300, 1, 300, 1, 0, 100, 1000000, 'Donation Terra Amulet', 'You see a donation terra amulet (protection earth +20%,fire +5%) that has 5000 charge left.', '', 7887, 5000, 0, 0, '', '', '', '', '', ''),
(301, 1, 301, 1, 0, 100, 1000000, 'Donation Terra Hood', 'You see a donation terra hood (Arm:20,protection earth +5%,fire +10%) that has energy for 600 minutes left. [10 Hours item]', '', 7903, 0, 0, 0, '', '', '', '', '', ''),
(302, 1, 302, 1, 0, 100, 1000000, 'Donation Terra Mantle', 'You see a donation terra mantle (Arm:20,protection earth +10%,fire +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7884, 0, 0, 0, '', '', '', '', '', ''),
(303, 1, 303, 1, 0, 100, 1000000, 'Donation Terra Legs', 'You see donation terra legs (Arm:20,protection earth +10%,fire +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7885, 0, 0, 0, '', '', '', '', '', ''),
(304, 1, 304, 1, 0, 100, 1000000, 'Donation Terra Boots', 'You see donation terra boots (Arm:20,protection earth +10%,fire +5%,speed +30) that has energy for 600 minutes left. [10 Hours item]', '', 7886, 0, 0, 0, '', '', '', '', '', ''),
(400, 1, 400, 1, 0, 100, 1000000, 'Donation Magma Amulet', 'You see a donation magma amulet (protection fire +20%,ice +5%) that has 5000 charge left.', '', 7890, 5000, 0, 0, '', '', '', '', '', ''),
(401, 1, 401, 1, 0, 100, 1000000, 'Donation Magma Monocle', 'You see a donation magma monocle (Arm:20,protection fire +10%,ice +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7900, 0, 0, 0, '', '', '', '', '', ''),
(402, 1, 402, 1, 0, 100, 1000000, 'Donation Magma Coat', 'You see a donation magma coat (Arm:20,protection fire +10%,ice +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7899, 0, 0, 0, '', '', '', '', '', ''),
(403, 1, 403, 1, 0, 100, 1000000, 'Donation Magma Legs', 'You see donation magma legs (Arm:20,protection fire +10%,ice +5%) that has energy for 600 minutes left. [10 Hours item]', '', 7894, 0, 0, 0, '', '', '', '', '', ''),
(404, 1, 404, 1, 0, 100, 1000000, 'Donation Magma Boots', 'You see donation magma boots (Arm:20,protection fire +10%,ice +5%,speed +30) that has energy for 600 minutes left. [10 Hours item]', '', 7891, 0, 0, 0, '', '', '', '', '', '');

-- --------------------------------------------------------

--
-- Struktura tabeli dla tabeli `zotsme_shop_transactions`
--

CREATE TABLE IF NOT EXISTS `zotsme_shop_transactions` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `state` int(11) NOT NULL DEFAULT '0',
  `offer_id` int(11) NOT NULL,
  `points` int(11) NOT NULL DEFAULT '0',
  `from_account` int(11) NOT NULL,
  `to_account` int(11) NOT NULL,
  `to_player` int(11) NOT NULL,
  `buyer_ip` int(11) NOT NULL,
  `receiver_ip` int(11) NOT NULL,
  `date_buy` int(11) NOT NULL,
  `date_receiver_decide` int(11) NOT NULL DEFAULT '0',
  `date_delivery` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `offer_id` (`offer_id`),
  KEY `order_ip` (`buyer_ip`),
  KEY `receiver_ip` (`receiver_ip`),
  KEY `date_buy` (`date_buy`),
  KEY `state` (`state`)
) ENGINE=InnoDB  DEFAULT CHARSET=latin1 AUTO_INCREMENT=12 ;

--
-- Zrzut danych tabeli `zotsme_shop_transactions`
--

INSERT INTO `zotsme_shop_transactions` (`id`, `state`, `offer_id`, `points`, `from_account`, `to_account`, `to_player`, `buyer_ip`, `receiver_ip`, `date_buy`, `date_receiver_decide`, `date_delivery`) VALUES
(1, 3, 104, 100, 1, 1, 2, 2147483647, 0, 1373716057, 0, 1373718643),
(2, 3, 31, 100, 1, 1, 2, 2147483647, 0, 1373718780, 0, 1373718799),
(3, 3, 100, 100, 1, 1, 2, 2147483647, 0, 1373718846, 0, 1373718909),
(4, 3, 100, 100, 1, 1, 2, 2147483647, 0, 1373718940, 0, 1373718941),
(5, 3, 100, 100, 1, 1, 2, 2147483647, 0, 1373718965, 0, 1373718981),
(6, 3, 400, 100, 1, 1, 2, 2147483647, 0, 1373719300, 0, 1373719309),
(7, 3, 30, 100, 1, 1, 2, 2147483647, 0, 1373719331, 0, 1373719333),
(8, 2, 4, 100, 1, 1, 214, 2147483647, 0, 1373908157, 0, 1373908349),
(9, 3, 34, 20, 1, 1, 2, 2147483647, 0, 1373963858, 0, 1373963863),
(10, 3, 35, 80, 1, 1, 2, 2147483647, 0, 1373964118, 0, 1373964119),
(11, 3, 38, 80, 1, 1, 2, 2147483647, 0, 1373964764, 0, 1373964775);

--
-- Ograniczenia dla zrzutów tabel
--

--
-- Ograniczenia dla tabeli `account_viplist`
--
ALTER TABLE `account_viplist`
  ADD CONSTRAINT `account_viplist_ibfk_1` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `account_viplist_ibfk_2` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `environment_killers`
--
ALTER TABLE `environment_killers`
  ADD CONSTRAINT `environment_killers_ibfk_1` FOREIGN KEY (`kill_id`) REFERENCES `killers` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `guild_invites`
--
ALTER TABLE `guild_invites`
  ADD CONSTRAINT `guild_invites_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `guild_invites_ibfk_2` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `guild_kills`
--
ALTER TABLE `guild_kills`
  ADD CONSTRAINT `guild_kills_ibfk_1` FOREIGN KEY (`war_id`) REFERENCES `guild_wars` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `guild_kills_ibfk_2` FOREIGN KEY (`death_id`) REFERENCES `player_deaths` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `guild_kills_ibfk_3` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `guild_ranks`
--
ALTER TABLE `guild_ranks`
  ADD CONSTRAINT `guild_ranks_ibfk_1` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `guild_wars`
--
ALTER TABLE `guild_wars`
  ADD CONSTRAINT `guild_wars_ibfk_1` FOREIGN KEY (`guild_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `guild_wars_ibfk_2` FOREIGN KEY (`enemy_id`) REFERENCES `guilds` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `house_auctions`
--
ALTER TABLE `house_auctions`
  ADD CONSTRAINT `house_auctions_ibfk_1` FOREIGN KEY (`house_id`, `world_id`) REFERENCES `houses` (`id`, `world_id`) ON DELETE CASCADE,
  ADD CONSTRAINT `house_auctions_ibfk_2` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `house_data`
--
ALTER TABLE `house_data`
  ADD CONSTRAINT `house_data_ibfk_1` FOREIGN KEY (`house_id`, `world_id`) REFERENCES `houses` (`id`, `world_id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `house_lists`
--
ALTER TABLE `house_lists`
  ADD CONSTRAINT `house_lists_ibfk_1` FOREIGN KEY (`house_id`, `world_id`) REFERENCES `houses` (`id`, `world_id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `killers`
--
ALTER TABLE `killers`
  ADD CONSTRAINT `killers_ibfk_1` FOREIGN KEY (`death_id`) REFERENCES `player_deaths` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `players`
--
ALTER TABLE `players`
  ADD CONSTRAINT `players_ibfk_1` FOREIGN KEY (`account_id`) REFERENCES `accounts` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_deaths`
--
ALTER TABLE `player_deaths`
  ADD CONSTRAINT `player_deaths_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_depotitems`
--
ALTER TABLE `player_depotitems`
  ADD CONSTRAINT `player_depotitems_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_items`
--
ALTER TABLE `player_items`
  ADD CONSTRAINT `player_items_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_killers`
--
ALTER TABLE `player_killers`
  ADD CONSTRAINT `player_killers_ibfk_1` FOREIGN KEY (`kill_id`) REFERENCES `killers` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `player_killers_ibfk_2` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_namelocks`
--
ALTER TABLE `player_namelocks`
  ADD CONSTRAINT `player_namelocks_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_skills`
--
ALTER TABLE `player_skills`
  ADD CONSTRAINT `player_skills_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_spells`
--
ALTER TABLE `player_spells`
  ADD CONSTRAINT `player_spells_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_storage`
--
ALTER TABLE `player_storage`
  ADD CONSTRAINT `player_storage_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `player_viplist`
--
ALTER TABLE `player_viplist`
  ADD CONSTRAINT `player_viplist_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE,
  ADD CONSTRAINT `player_viplist_ibfk_2` FOREIGN KEY (`vip_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `server_reports`
--
ALTER TABLE `server_reports`
  ADD CONSTRAINT `server_reports_ibfk_1` FOREIGN KEY (`player_id`) REFERENCES `players` (`id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `tiles`
--
ALTER TABLE `tiles`
  ADD CONSTRAINT `tiles_ibfk_1` FOREIGN KEY (`house_id`, `world_id`) REFERENCES `houses` (`id`, `world_id`) ON DELETE CASCADE;

--
-- Ograniczenia dla tabeli `tile_items`
--
ALTER TABLE `tile_items`
  ADD CONSTRAINT `tile_items_ibfk_1` FOREIGN KEY (`tile_id`) REFERENCES `tiles` (`id`) ON DELETE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
